local m_initPointX = nil;
local m_initPointY = nil;

local function AccountActivationWndClose()  
    m_initPointX = nil;
    m_initPointY = nil;
end

local function onWindowTouched(tag)
	local editAcount = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("7012-2"));
    if editAcount ~= nil and editAcount:getIsInputing() then
        editAcount:detachWithIME();
    end
	local editAcountSure = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("7012-3"));
    if editAcountSure ~= nil and editAcountSure:getIsInputing() then
        editAcountSure:detachWithIME();
    end
	local editActivationCode = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("7012-4"));
    if editActivationCode ~= nil and editActivationCode:getIsInputing() then
        editActivationCode:detachWithIME();
    end
end

local function OnClickBtnActivation(tag)
	local editAcount = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("7012-2"));
	if not editAcount then
		return
	end
	local editAcountSure = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("7012-3"));
    if not editAcountSure then
		return
    end
    local editActivationCode = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("7012-4"));
    if not editActivationCode then
        return;
    end
    if editAcount:getContentText() ~= editAcountSure:getContentText() then
        showMessage(_LTParser("str6112"));
        return;
    end
    if #editActivationCode:getContentText() == 0 then
        showMessage(_LTParser("str6114"));
        return;
    end
    LoginLogic:getSingleton():sendAccountActivation(editAcount:getContentText(), editActivationCode:getContentText());
    --[[local str1 = SCString:stringWithString(editAcount:getContentText());
    local str2 = SCString:stringWithString(editActivationCode:getContentText());
    local dataStream = SCDataTransStream:streamWithCommand(1055);
    dataStream:writeByte(5);
    dataStream:writeString(str1);
    dataStream:writeString(str2);
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();]]
end

local function onEditBeginInput(tag)
    local m_wnd = getCurentSceneWindow(7012);
    if nil == m_wnd then
        return;
    end
    local moveSize = 0;
    local pNode = SCTypeCast:castNodeToEdit(m_wnd:getChildByTag(tag));
    if pNode then
        moveSize = moveSize + pNode:getPosition().y - pNode:getAnchorPoint().y * pNode:getContentSize().height;
        m_wnd:runAction(CCMoveTo:create(0.2, CCPointMake(m_initPointX, m_initPointY + 200 * gUIScale().y - moveSize)));
    end
end

local function onEditEndInput(tag)
    local m_wnd = getCurentSceneWindow(7012);
    if nil == m_wnd then
        return;
    end
    m_wnd:runAction(CCMoveTo:create(0.2, CCPointMake(m_initPointX, m_initPointY)));
end

local function createWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7012));
    if wnd == nil then
        return nil 
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/titile..png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    wnd:luaSetSelectorOnClose(AccountActivationWndClose);    
    wnd:luaSetSelectorOnTouched(onWindowTouched);
    wnd:setFrameVisibled(false);
    -- create a test window controller
    local Btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(5, tolua.cast(wnd, "SCNode")));
    if Btn then
        local Btnpath = getRealUIResourcePath("img/titile65.png");
        if Btnpath then
            Btn:setTitle(Btnpath:getData());
        end
        Btn:luaSetSelectorOnClicked(OnClickBtnActivation);
    end
    local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("6", tolua.cast(wnd, "SCNode")));
    if pDragNode then
        pDragNode:setFrameVisibled(true);
        pDragNode:setFrameType(EnumFrameTypeRound);
    end
    local editAcount = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlistAndParent("2", tolua.cast(wnd, "SCNode")));
    if editAcount then
        editAcount:setBottomColor(color_transparent);
        editAcount:setFontColor(color_white);  
        editAcount:luaSetSelectorOnBeginInput(onEditBeginInput);
        editAcount:luaSetSelectorOnEndInput(onEditEndInput);
    end
    local editAcountSure = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
    if editAcountSure then
        editAcountSure:setBottomColor(color_transparent);
        editAcountSure:setFontColor(color_white);  
        editAcountSure:luaSetSelectorOnBeginInput(onEditBeginInput);
        editAcountSure:luaSetSelectorOnEndInput(onEditEndInput);
    end
    local editActivationCode = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(wnd, "SCNode")));
    if editActivationCode then
        editActivationCode:setBottomColor(color_transparent);
        editActivationCode:setFontColor(color_white);  
        editActivationCode:luaSetSelectorOnBeginInput(onEditBeginInput);
        editActivationCode:luaSetSelectorOnEndInput(onEditEndInput);
    end
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    
    return wndCtrl;
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then   
        local m_wnd = getCurentSceneWindow(7012);
        if m_wnd then
            m_initPointX = m_wnd:getPosition().x;
            m_initPointY = m_wnd:getPosition().y;
        else
            m_initPointX = 0;
            m_initPointY = 0;
        end
    end
end

function showAccountActivation()    
    local wndCtrl = createWnd();    
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);  
        naviCtrl:pushWindowController(wndCtrl);  
    end
end