
AchieveGuide = {}
-----------------------结构定义区------------------------

-----------------------常量定义区------------------------
local ACHIEVEMENT_ADVANCE_SKILL               = 200--,      //升级技能 
local ACHIEVEMENT_EQUIP_STRENGTHEN            = 201--,      //装备强化
local ACHIEVEMENT_SEEK_FRIENDS                = 202--,      //寻找好友
local ACHIEVEMENT_ACCUMULATE_EXP              = 203--,      //积攒经验
local ACHIEVEMENT_COMPARE_NOTES               = 204--,      //切磋(竞技场)
local ACHIEVEMENT_GOLD_MINING                 = 205--,      //挖金矿
local ACHIEVEMENT_RECRUIT                     = 206--,      //招募武将
local ACHIEVEMENT_ROUTINE_WORK                = 207--,      //日常任务
local ACHIEVEMENT_A_GOOD                      = 208--,      //日行一善
local ACHIEVEMENT_ETERNAL_AWAKENING           = 209--,      //武魂觉醒
local ACHIEVEMENT_GEM_SYNTHESIS               = 210--,      //珍宝合成

local ACHIEVE_TYPE_MAX = 11
local MAP_CHEAT_PROSON = 1080400--,			// 外挂监狱
local ACHIEVEMENT_ACTION_GUID_INFO    = 9  --       //成就引导信息 
-----------------------变量定义区------------------------
local m_nCurAchieveType  = 0
local m_nCurAchieveIndex = 0
local m_nMaxAchieveIndex = 0
-----------------------函数声明区------------------------

-----------------------逻辑功能区------------------------
--关闭窗口
function AchieveGuide:onWndClose()
    m_nCurAchieveType  = 0
    m_nCurAchieveIndex = 0
    m_nMaxAchieveIndex = 0
end
--打开窗口
function AchieveGuide:OpenAchieveWnd()
    local wndCtrl = getCurentSceneWindowController(9107)
    if not wndCtrl then
        local wnd = AchieveGuide:CreateMainWnd()
        if wnd then
            wndCtrl = SCWindowController:controllerWithWindow(wnd)
            if wndCtrl then
                PUSH_CTRL(wndCtrl)
                AchieveGuide:UpdateWindow()
            end
        end
    else
        AchieveGuide:UpdateWindow()
    end
end
--自动寻路
function AchieveGuide.onAutoFind(tag)    
    local wndCtrl = getCurentSceneWindowController(9107)
    if wndCtrl then
        REMOVE_CTRL(wndCtrl)
    end
        
    Hero:getSingleton():stopAutoMove();
    local tmp = AchieveGuide.SelectCase()
    if tmp then        
        if tmp.idFunc then
            tmp.idFunc()            
        elseif tmp.szMsg then
            showMessage(tmp.szMsg)
        end
    end
end
--刷新窗口
function AchieveGuide:UpdateWindow()
    local tmp = AchieveGuide.SelectCase()
    if not tmp.idType then return end 
    
    local nodeUp = SCFunction:getUiNodeByIdlist("9107-1")
    if nodeUp then
        local szNode = nodeUp:getContentSize()
        local title = tolua.cast(nodeUp:getChildByTag(1), "SCLabel")
        if title then
            title:setText(tmp.szName)
        else            
            title = SCLabel:labelWithStringFont(tmp.szName, getDefaultFontName(), F(15))
            if title then
                title:setAnchorPoint(CCPointMake(0, 0.5))
                title:setPosition(SX(45), szNode.height - SY(20))
                title:setTag(1)
                title:setColor(color_green)
                nodeUp:addChild(title)
            end
        end
        
        local require = nodeUp:getChildByTag(2)
        if require then
            require:removeFromParentAndCleanup(true)
        end
        
        require = getItemTextNode(tmp.szTip, 0, 15)
        if require then
            require:setAnchorPoint(CCPointMake(0, 0.5))            
            require:setPosition(SX(90), szNode.height / 2 - SY(3))
            require:setTag(2)
            nodeUp:addChild(require)
        end
        
        local reward = tolua.cast(nodeUp:getChildByTag(3), "SCLabel")
        if reward then
            reward:setText(tmp.szReward)
        else
            reward = SCLabel:labelWithStringFont(tmp.szReward, getDefaultFontName(), F(15))
            reward:setAnchorPoint(CCPointMake(0, 0.5))
            reward:setPosition(SX(92.3), SY(23))
            reward:setTag(3)
            nodeUp:addChild(reward)
        end
        
        local btn = nodeUp:getChildByTag(10)
        if not btn then
            local path = RES("img/new00056.pn")
            btn = SCButton:button(1)
            if btn then
                btn:setTitle(path)
                btn:setContentSize(AUTO_SIZE(80, 30))
                btn:setTag(10)
                btn:setAnchorPoint(CCPointMake(1, 0.5))
                btn:setPosition(szNode.width - SX(10), szNode.height / 2)
                btn:luaSetSelectorOnClicked(AchieveGuide.onAutoFind)
                nodeUp:addChild(btn)
            end
        end
    end
    
    local nodeDown = SCFunction:getUiNodeByIdlist("9107-2")
    if nodeDown then
        local parseNode = nodeDown:getChildByTag(1)
        if parseNode then
            parseNode:removeFromParentAndCleanup(true)
        end
        
        local index = tmp.idType - 1;
        if index < 0 then
            index = 0;
        end
        parseNode = getItemTextNode(L("str20062").."*3"..index .."/"..ACHIEVE_TYPE_MAX, 0, 15)
        if parseNode then
            parseNode:setAnchorPoint(CCPointMake(0.5, 0.5))
            parseNode:setPosition(nodeDown:getContentSize().width / 2, nodeDown:getContentSize().height / 2)
            parseNode:setTag(1)
            nodeDown:addChild(parseNode)
        end
    end
end

--成就任务属性
function AchieveGuide.SelectCase()
    local tmp = {__mode = "kv"}    
    tmp.szReward = 10 .. L("str0138")
    if m_nCurAchieveType == ACHIEVEMENT_ADVANCE_SKILL then--               = 200,      //升级技能 
        tmp.idType = 1
        tmp.szName = L("str20063")        
        tmp.szTip  = L("str20072").."*6("..m_nCurAchieveIndex.."/"..m_nMaxAchieveIndex..")"
		if luaIsUnlock(UNLOCK_TYPE_MAGIC_LEVELUP) then
			tmp.idFunc = SkillNode1_showMainInterfaceSkill
		else
			tmp.szMsg  = L("str0069")
		end
	elseif m_nCurAchieveType == ACHIEVEMENT_EQUIP_STRENGTHEN then--           = 201,      //装备强化
	    tmp.idType = 2
	    tmp.szName = L("str6146")
	    tmp.szTip  = L("str6146").."*6("..m_nCurAchieveIndex.."/"..m_nMaxAchieveIndex..")"
		if luaIsUnlock(UNLOCK_TYPE_EQUIP_STRENGTHEN) then
			tmp.idFunc = Equipmentstrengthen_showEquipmentstrengthenWnd
		else
			tmp.szMsg  = L("str0069")
		end
    elseif m_nCurAchieveType == ACHIEVEMENT_SEEK_FRIENDS then--               = 202,      //寻找好友
        tmp.idType = 3
        tmp.szName = L("str20064")
        tmp.szTip  = L("str20064").."*6("..m_nCurAchieveIndex.."/"..m_nMaxAchieveIndex..")"
		if luaIsUnlock(UNLOCK_TYPE_FRIEND) then
			tmp.idFunc = NewFriends_showNewFriendsWnd
		else
			tmp.szMsg  = L("str0069")
		end
	elseif m_nCurAchieveType == ACHIEVEMENT_ACCUMULATE_EXP then--              = 203,      //积攒经验
	    tmp.idType = 4
	    tmp.szName = L("str20065")
	    tmp.szTip  = L("str20074").."*6("..m_nCurAchieveIndex.."/"..m_nMaxAchieveIndex..")"
		if luaIsUnlock(UNLOCK_TYPE_SKILL) then
			tmp.idFunc = AutomaticGrinding_sendAutomaticGrindingInfo
		else
			tmp.szMsg  = L("str0069")
		end
	elseif m_nCurAchieveType == ACHIEVEMENT_COMPARE_NOTES then--               = 204,      //切磋(竞技场)
	    tmp.idType = 5
	    tmp.szName = L("str20071")--L("str0293")
	    tmp.szTip  = L("str0293").."*6("..m_nCurAchieveIndex.."/"..m_nMaxAchieveIndex..")"
	    if luaIsUnlock(UNLOCK_TYPE_AREAN) then
			if MAP_CHEAT_PROSON ~= math.floor(GameCommonMsgRecive:getSingleton():getMapID() / 100) * 100 then
				tmp.idFunc = challengeView_sendData
			else
				tmp.szMsg  = L("str20047")
			end
		else
			tmp.szMsg  = L("str0069")
		end
	elseif m_nCurAchieveType == ACHIEVEMENT_GOLD_MINING then--                = 205,      //挖金矿
	    tmp.idType = 6
	    tmp.szName = L("str20066")
	    tmp.szTip  = L("str20075").."*6("..m_nCurAchieveIndex.."/"..m_nMaxAchieveIndex..")"
		if luaIsUnlock(UNLOCK_TYPE_TYPE10) then
			tmp.idFunc = cornucopia_ClickBtn
		else
			tmp.szMsg  = L("str0069")
		end
	elseif m_nCurAchieveType == ACHIEVEMENT_RECRUIT then--                    = 206,      //招募武将
	    tmp.idType = 7
	    tmp.szName = L("str20067")
	    tmp.szTip  = L("str20067").."*6("..m_nCurAchieveIndex.."/"..m_nMaxAchieveIndex..")"
		if luaIsUnlock(UNLOCK_TYPE_RECRUITPARTNER) then
			tmp.idFunc = BlowRecruit_showBlowRecruitWnd1
		else
			tmp.szMsg  = L("str0069")
		end
	elseif m_nCurAchieveType == ACHIEVEMENT_ROUTINE_WORK then--               = 207,      //日常任务
	    tmp.idType = 8
	    tmp.szName = L("str0028")
	    tmp.szTip  = L("str20161").."*6("..m_nCurAchieveIndex.."/"..m_nMaxAchieveIndex..")"
		if luaIsUnlock(UNLOCK_TYPE_TYPE8) then
			tmp.idFunc = TaskForDay_sendEverydayTask
		else
			tmp.szMsg  = L("str0069")
		end
	elseif m_nCurAchieveType == ACHIEVEMENT_A_GOOD then--                     = 208,      //日行一善
	    tmp.idType = 9
	    tmp.szName = L("str20068")
	    tmp.szTip  = L("str20068").."*6("..m_nCurAchieveIndex.."/"..m_nMaxAchieveIndex..")"
		if luaIsUnlock(UNLOCK_TYPE_TYPE2) then
			tmp.idFunc = GoodDeed_sendData
		else
			tmp.szMsg  = L("str0069")
		end
	elseif m_nCurAchieveType == ACHIEVEMENT_ETERNAL_AWAKENING then--           = 209,      //武魂觉醒
	    tmp.idType = 10
	    tmp.szName = L("str20069")
	    tmp.szTip  = L("str20069").."*6("..m_nCurAchieveIndex.."/"..m_nMaxAchieveIndex..")"
		if luaIsUnlock(UNLOCK_TYPE_TYPE4) then
			tmp.idFunc = Hunter_showHunterWnd1
		else
			tmp.szMsg  = L("str0069")
		end
	elseif m_nCurAchieveType == ACHIEVEMENT_GEM_SYNTHESIS then--              = 210,      //珍宝合成
	    tmp.idType = 11
	    tmp.szName = L("str20070")
	    tmp.szTip  = L("str20070").."*6("..m_nCurAchieveIndex.."/"..m_nMaxAchieveIndex..")"
		if luaIsUnlock(UNLOCK_TYPE_TREASURE) then
			tmp.idFunc = treasure.showTreasureWnd
		else
			tmp.szMsg  = L("str0069")
		end
	end
	
	return tmp
end
-----------------------UI控制器区------------------------
function AchieveGuide.CreateMainWnd()
    local wnd = SCWindow:window()
    if not wnd then return end 
        
    wnd:setTag(9107)
    wnd:setContentSize(AUTO_SIZE(480, 320))
    wnd:luaSetSelectorOnClose(AchieveGuide.onWndClose)    
    
    local path = RES("img/new00792.pn")
    if path then
        wnd:setTitleWithImage(path)
    end
    
    local szWnd     = AUTO_SIZE(480, 320)
    local szUp      = CCSizeMake(szWnd.width - SX(30), SY(90))
    local szDown    = CCSizeMake(szUp.width, szWnd.height - szUp.height - SY(80))
    local height    = SY(15)
    local ptDown    = CCPointMake(szWnd.width / 2, height)
    local ptUp      = CCPointMake(ptDown.x, ptDown.y  + szDown.height + SY(5))
    
    local nodeUp = SCDragNode:node()
    if nodeUp then
        nodeUp:setTag(1)
        nodeUp:setContentSize(szUp)
        nodeUp:setPosition(ptUp)
        nodeUp:setAnchorPoint(CCPointMake(0.5, 0))
        nodeUp:setFrameVisibled(true)
        nodeUp:setFrameType(EnumFrameTypeLine)
        wnd:addChild(nodeUp)
        
        local path = RES("img/new00067.pn")
        if path then
            local img = SCImage:imageWithFile(path)
            if img then
                nodeUp:addChild(img)
                img:setAnchorPoint(CCPointMake(0, 0.5))
                img:setPosition(SX(10), szUp.height - SY(20))
            end
        end
        
        local labelRequire = getItemTextNode(L("str0276"), 0, 15)
        if labelRequire then
            labelRequire:setAnchorPoint(CCPointMake(0, 0.5))
            labelRequire:setPosition(SX(20), szUp.height / 2 - SY(3))
            nodeUp:addChild(labelRequire)
        end
        
        local labelReward = getItemTextNode(L("str0277"), 0, 15)
        if labelReward then            
            labelReward:setAnchorPoint(CCPointMake(0, 0.5))
            labelReward:setPosition(SX(20), SY(23))
            nodeUp:addChild(labelReward)
        end
    end
    
    local nodeDown = SCDragNode:node()
    if nodeDown then
        nodeDown:setTag(2)
        nodeDown:setContentSize(szDown)
        nodeDown:setPosition(ptDown)
        nodeDown:setAnchorPoint(CCPointMake(0.5, 0))
        nodeDown:setFrameVisibled(true)
        nodeDown:setFrameType(EnumFrameTypeLine)
        wnd:addChild(nodeDown)
    end
    
    return wnd
end
-----------------------消息处理区------------------------
function AchieveGuide.SendAchieve()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ACHIEVE)
    if dataStream then
        dataStream:writeShort(ACHIEVEMENT_ACTION_GUID_INFO)
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show()
    end
end

function AchieveGuide.ReadAchieveData(dt)
    m_nCurAchieveType  = dt:readInt()
    m_nCurAchieveIndex = dt:readInt()
    m_nMaxAchieveIndex = dt:readInt()
    
    if m_nCurAchieveIndex > m_nMaxAchieveIndex then
        m_nCurAchieveIndex = m_nMaxAchieveIndex
    end  
end
-----------------------消息注册区------------------------

-----------------------全局函数区------------------------
function AchieveGuide_RecvData(dt)
    if not dt then return end   
    
    SCActivityIndicator:getSingleton():close()
    
    AchieveGuide.ReadAchieveData(dt)
    AchieveGuide.OpenAchieveWnd()
end