local SYSTEMNOTICE_NOTICE_INFO = 2    --公告
local SYSTEMNOTICE_EVEVTCALENDAR_INFO = 3   --活动通知
local SYSTEMNOTICE_HISTORY_INFO = 4   --历史公告
local SYSTEMNOTICE_HISTORY_INFOEND = 5   --历史公告（最后一个包）

local Announcement = {
     __mode = "kv",
     data1 = {},
     data2 = {},
     data3 = {},
}

local tMsg_Info1 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.dwVersion = dt:readInt();
        local scStr = dt:readString()
            if scStr == nil then
                tmp.szInfo = ""
            else
                tmp.szInfo = scStr:getData()
        end
        return tmp;
    end
}

local tMsg_Info2_info = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nUnlock = dt:readInt();
        tmp.idPhoto = dt:readInt();
        tmp.szName = dt:readString();
        if tmp.szName == nil then
            tmp.szName = ""
        else
            tmp.szName = tmp.szName:getData()
        end
        tmp.szDescribe = dt:readString();
        if tmp.szDescribe == nil then
            tmp.szDescribe = ""
        else
            tmp.szDescribe = tmp.szDescribe:getData()
        end
        
        return tmp
    end
}

local tMsg_Info2 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucAmount = dt:readByte();
        tmp.stInfo = {}
        for i = 1, tmp.ucAmount do
            table.insert(tmp.stInfo, tMsg_Info2_info.initWithStream(dt));
        end
        return tmp;
    end
}

local tMsg_Info3 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.dwVersions = {};
        tmp.ucAmount = dt:readByte();
        for i = 1, tmp.ucAmount do
          table.insert(tmp.dwVersions, dt:readInt());
        end
        return tmp;
    end
}

local function setData1(tmp)
    if not Announcement.data1 then
        Announcement.data1 = {}
    end
    table.insert(Announcement.data1, tmp);
end

local function setData3(tmp)
    if not Announcement.data3 then
        Announcement.data3 = {}
    end
    table.insert(Announcement.data3, tmp);
end

local function ranAnnouncementWndClose()
    Announcement = {
        __mode = "kv",
        data1 = {},
        data2 = {},
        data3 = {},
    }
end

local function creatAnnouncement()
    local textbox = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlist("7002-6"));
    if textbox then
        textbox:setText("");
        for i = 1, #Announcement.data1 do
            textbox:addText(Announcement.data1[i].szInfo);
        end
    end
    
    local pListbox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("7002-9"));
    if pListbox then
        if Announcement.data2[1] then
            pListbox:removeAllItems();
            for i = 1, Announcement.data2[1].ucAmount do
                local pDragNode = SCDragNode:node()
                if pDragNode then
                    pDragNode:setTag(1)
                    pDragNode:setContentSize(AUTO_SIZE(200, 56))
                    pDragNode:setFrameType(EnumFrameTypeTip3);
                    pDragNode:setDragEnabled(false)
                    pDragNode:setFrameVisibled(true);
                    pListbox:addItem(pDragNode);
                end
                local imgPath1 = getRealUIResourcePath("MainInterfaceImg/"..Announcement.data2[1].stInfo[i].idPhoto..".pn")
                if imgPath1 then
                    local pLogImg = SCImage:imageWithFile(imgPath1:getData());
                    if pLogImg then
                        pLogImg:setAnchorPoint(CCPointMake(0,0.5));
                        pLogImg:setPosition(CCPointMake(SX(11), pDragNode:getContentSize().height/2));
                        pDragNode:addChild(pLogImg) 
                    end
                end
                local pDragNode1 = SCDragNode:node()
                if pDragNode1 then
                    pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pDragNode1:setPosition(AUTO_POS(46.00, 27.00))
                    pDragNode1:setContentSize(AUTO_SIZE(147, 20))
                    pDragNode1:setFrameVisibled(false)
                    pDragNode1:setDragEnabled(false)
                    pDragNode1:setFrameType(EnumFrameTypeRound)
                    pDragNode:addChild(tolua.cast(pDragNode1, "SCNode"))
                end
                local pLable1 = SCLabel:labelWithStringFont(Announcement.data2[1].stInfo[i].szName, DEFAULT_FONT_NAME, F(15))  --活动名字
                if pLable1 then
                    pLable1:setAnchorPoint(CCPointMake(0.5,0.5))
                    pLable1:setPosition(CCPointMake(pDragNode1:getContentSize().width/2, pDragNode1:getContentSize().height/2))
                    pLable1:setColor(color_green)
                    pDragNode1:addChild(tolua.cast(pLable1, "SCNode"))
                end
                local pDragNode2 = SCDragNode:node()
                if pDragNode2 then
                    pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pDragNode2:setPosition(AUTO_POS(46.00, 10.00))
                    pDragNode2:setContentSize(AUTO_SIZE(147, 15))
                    pDragNode2:setFrameVisibled(false)
                    pDragNode2:setDragEnabled(false)
                    pDragNode2:setFrameType(EnumFrameTypeRound)
                    pDragNode:addChild(tolua.cast(pDragNode2, "SCNode"))
                end
                local pLable2 = SCLabel:labelWithStringFont(Announcement.data2[1].stInfo[i].szDescribe, DEFAULT_FONT_NAME, F(12))  --活动时间
                if pLable2 then
                    pLable2:setAnchorPoint(CCPointMake(0.5,0.5))
                    pLable2:setPosition(CCPointMake(pDragNode2:getContentSize().width/2, pDragNode2:getContentSize().height/2))
                    pLable2:setColor(color_orange)
                    pDragNode2:addChild(tolua.cast(pLable2, "SCNode"))
                end
                local pButton10 = SCButton:button(EnumBtnTypeNormalImg)
                if pButton10 and Announcement.data2[1].stInfo[i].nUnlock then
                    pButton10:setTag(Announcement.data2[1].stInfo[i].nUnlock)
                    pButton10:setAnchorPoint(ANCHOR_CENTER)
                    pButton10:setPosition(CCPointMake(pDragNode:getContentSize().width/2, pDragNode:getContentSize().height/2))
                    pButton10:setContentSize(CCSizeMake(pDragNode:getContentSize().width,pDragNode:getContentSize().height))
                    pButton10:luaSetSelectorOnClicked(Announcement_onClickActive);
                    pDragNode:addChild(pButton10)
                end
            end
        end
    end
       
    --[[textbox = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlist("7002-2-7"));
    if textbox then
        textbox:setText("");
        for i = 1, #Announcement.data2 do
            textbox:addText(Announcement.data2[i].szInfo);
        end
    end--]]
end


local function setData2(tmp)
    if not Announcement.data2 then
        Announcement.data2 = {}
    end
    table.insert(Announcement.data2, tmp);
    creatAnnouncement();
end

local function joinInTeam(tag, itemTag, itemIndex)
    local list = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("7004-1-3"));
    if list == nil then
        return;
    end
    local node = SCTypeCast:castNodeToDragNode(list:getChildByTag(itemTag));
    if node then
        node:setFrameType(EnumFrameTypeListSelect)
        node:setFrameVisibled(true)
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_SYSTEM_NOTICE);
    dataStream:writeByte(SYSTEMNOTICE_NOTICE_INFO);
    dataStream:writeInt(itemTag);
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
    getCurentSceneNavigationController():removeWindowControllerByTag(7004);
    Announcement.data1 = {};
    Announcement.data2 = {};
end

local function unSelset(tag, itemTag, itemIndex)
    local list = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("7004-1-3"));
    if list == nil then
        return;
    end
    local node = SCTypeCast:castNodeToDragNode(list:getChildByTag(itemTag));
   
    if node then
        node:setFrameType(EnumFrameTypeListNormal)
        node:setFrameVisibled(true)
    end
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        getCurentSceneWindow(tag):setAutoCloseOnTouchSpace(true);
    end
end

local function creatVersionMenu(tmp)
    SCActivityIndicator:getSingleton():close();
    table.insert(Announcement.data3, tmp);
    local node = SCFunction:getUiByZipAndId(7002, 7004);  
    local wnd = SCTypeCast:castNodeToWindow(node);
    if wnd == nil then
        return nil 
    end
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    wnd:setFrameVisibled(false);
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl);
        wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);
        local dragnode = SCTypeCast:castNodeToDragNode(node:getChildByTag(1))
        if dragnode == nil then
            return;
        end
        dragnode:setFrameType(EnumFrameTypeRound);
        dragnode:setFrameVisibled(true);
        local listbox = SCTypeCast:castNodeToListBox(dragnode:getChildByTag(3));
        if listbox == nil then
            return;
        end
        listbox:luaSetSelectorOnItemSelected(joinInTeam);
        listbox:luaSetSelectorOnItemUnSelected(unSelset);
        for i = 1, #Announcement.data3 do
            for j = 1, Announcement.data3[i].ucAmount do
                dragnode = SCDragNode:node();
                if dragnode then
                    dragnode:setContentSize(CCSizeMake(SX(95), SY(20)));
                    dragnode:setFrameType(EnumFrameTypeListNormal);
                    dragnode:setFrameVisibled(true);
                    local text = getItemTextNode(Announcement.data3[i].dwVersions[j]);
                    if text then                        
                        dragnode:addChild(text);
                        text:setAnchorPoint(CCPointMake(0.5, 0.5));
                        text:setPosition(CCPointMake(SX(95 / 2),SY(10)));
                        listbox:addItem(dragnode);
                        dragnode:setTag(Announcement.data3[i].dwVersions[j]);
                    end
                end
            end        
        end
    end
end

local function onOpenHistoryAnnouncement(tag)
    if tag then
        POP_TOP_CTRL()
        MainInterface_clickMainInterfaceFun(0)
        return
    end
    Announcement.data3 = {};
    SCActivityIndicator:getSingleton():show();
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_SYSTEM_NOTICE);
    dataStream:writeByte(SYSTEMNOTICE_HISTORY_INFO);
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end

local function CloseWnd()
    POP_TOP_CTRL()
end

local function createWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7002));
    if wnd == nil then
        return nil 
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/new00685.png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    
    local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
    local imgPath = getRealUIResourcePath("img/new00011.png")
    if btn and imgPath then
        btn:luaSetSelectorOnClicked(onOpenHistoryAnnouncement);
        btn:setTitle(imgPath:getData())
    end
    local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("10", tolua.cast(wnd, "SCNode")));
    local imgPath = getRealUIResourcePath("img/new00024.png")
    if btn and imgPath then
        btn:luaSetSelectorOnClicked(CloseWnd);
        btn:setTitle(imgPath:getData())
        btn:setButtonType(EnumBtnType9Atlas);
    end
    
    --wnd:luaSetSelectorOnClose(ranAnnouncementWndClose);
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    local dragnode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    local pImageFile = getRealUIResourcePath("kernal/Tip.png");
    local pTxtFile = getRealUIResourcePath("kernal/Tip.ini");
    if dragnode then
        --dragnode:setFrameType(EnumFrameTypeListNormal);
        if pTxtFile and pImageFile then
            dragnode:setFrameWithFile(pImageFile:getData(), pTxtFile:getData())
        end
        dragnode:setFrameVisibled(true);
        local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(dragnode, "SCNode")));
        if label then
            label:setColor(colorYellow());
        end
    end
    dragnode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("2", tolua.cast(wnd, "SCNode")));
    if dragnode then
        if pTxtFile and pImageFile then
            dragnode:setFrameWithFile(pImageFile:getData(), pTxtFile:getData())
        end
        dragnode:setFrameVisibled(true);
        local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("5", tolua.cast(dragnode, "SCNode")));
        if label then
            label:setColor(colorYellow());
        end
    end
    local pImageFile = getRealUIResourcePath("kernal/Tip3.png");
    local pTxtFile = getRealUIResourcePath("kernal/Tip3.ini");
    dragnode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("8", tolua.cast(wnd, "SCNode")));
    if dragnode then
        if pTxtFile and pImageFile then
            dragnode:setFrameWithFile(pImageFile:getData(), pTxtFile:getData())
        end
        dragnode:setFrameVisibled(true);
    end
    
    
    return wndCtrl;
end

function creatAnnouncementWnd()
    FirstLoginVeiw_isFirstLogon();
    if #Announcement.data1==nil or #Announcement.data2==nil then
        return
    end
    if #Announcement.data1 == 0 and #Announcement.data2 == 0 then
        return;
    end
    
    if getCurentSceneWindowController(7002) then
        return
    end
    
    local wndCtrl = createWnd();
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl);
        creatAnnouncement();
    end
end

function Announcement_clearAnnouncementTabel()
    Announcement.data1 = {};
    Announcement.data2 = {};
    CopymapSweep_setIsSweeping(false);
    TreasureHunt3.clearDate()			--清空一次寻宝仓库数据
end

function showAnnouncementWnd()
    if isopen_AniFirst() == true then
        isopen_InitFirst()
        return;
    end
    local wndCtrl = createWnd();
    local naviCtrl =  getCurentSceneNavigationController();
        if  naviCtrl and wndCtrl then
            naviCtrl:pushWindowController(wndCtrl);
            Announcement.data1 = {};
            Announcement.data2 = {};
            local dataStream = SCDataTransStream:streamWithCommand(_MSG_SYSTEM_NOTICE);
            dataStream:writeByte(SYSTEMNOTICE_NOTICE_INFO);
            dataStream:writeInt(0);
            if SCDataTransThread:getSingleton() then
                SCDataTransThread:getSingleton():transData(dataStream);
                SCActivityIndicator:getSingleton():show();
            end
        end
    return;
end

local function recvAnnouncement()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    if dt == nil then
        return;
    end
    local action = dt:readByte()
    if action == SYSTEMNOTICE_NOTICE_INFO then
        setData1(tMsg_Info1.initWithStream(dt));
    elseif action == SYSTEMNOTICE_EVEVTCALENDAR_INFO then
        setData2(tMsg_Info2.initWithStream(dt))
        creatAnnouncementWnd();
    elseif action == SYSTEMNOTICE_HISTORY_INFO then
        setData3(tMsg_Info3.initWithStream(dt))
    elseif action == SYSTEMNOTICE_HISTORY_INFOEND then
        creatVersionMenu(tMsg_Info3.initWithStream(dt))
    end
end

function Announcement_onClickActive(tag)
    MainInterface_onClickActive(tag)
end

if SCMessageCenter:getSingleton() then
    SCMessageCenter:getSingleton():luaRegistCommand(recvAnnouncement, _MSG_SYSTEM_NOTICE, 0, nil)
end
