--定义一个与文件名相同的table
AnswerGuess = {}
------------------消息--------------------

----------------结构定义区----------------

--//答题begin//答题end(最后一个包)
local stAnswerQuiz = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.ucQuizNumber = dt:readByte()
        tmp.szQuiz = dt:readString()
        if tmp.szQuiz then
			tmp.szQuiz = tmp.szQuiz:getData()
		else
			tmp.szQuiz = " "
		end
		
		tmp.szAnswer0 = dt:readString()
        if tmp.szAnswer0 then
			tmp.szAnswer0 = tmp.szAnswer0:getData()
		else
			tmp.szAnswer0 = " "
		end
		
		tmp.szAnswer1 = dt:readString()
        if tmp.szAnswer1 then
			tmp.szAnswer1 = tmp.szAnswer1:getData()
		else
			tmp.szAnswer1 = " "
		end
		
		tmp.szAnswer2 = dt:readString()
        if tmp.szAnswer2 then
			tmp.szAnswer2 = tmp.szAnswer2:getData()
		else
			tmp.szAnswer2 = " "
		end
		
		tmp.szAnswer3 = dt:readString()
        if tmp.szAnswer3 then
			tmp.szAnswer3 = tmp.szAnswer3:getData()
		else
			tmp.szAnswer3 = " "
		end
		return tmp
	end
}

local MSG_tInfo1 = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.ucAmount = dt:readByte()
        tmp.stAnswerQuiz = {}
        if tmp.ucAmount < 1 then
            tmp.ucAmount = 1
        end
        for i = 1,tmp.ucAmount do
            --table.insert(tmp.stAnswerQuiz, stAnswerQuiz.initWithStream(dt))
            table.insert(AnswerGuess.allAnswerList, stAnswerQuiz.initWithStream(dt))
        end
        
        return tmp
    end
}
--//当前世界答题状态
local MSG_tInfo3 = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.ucStatus = dt:readByte()                 --//0: 还未开始   1: 已开始(答题中)  2:已开始(准备换题中)
        tmp.usCountDown = dt:readShort()             --//不同状态倒计时
        tmp.ucQuizNumber = dt:readByte()             --//ucStatus=0时,为随机题的编号  ucStatus=1时,为当前题目的编号
        tmp.ucAnswer = dt:readByte()                 --//已选中的答案
        return tmp
     end
}
--//答题排行榜
local stQuizRank = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.usRank = dt:readShort()
        tmp.szName = dt:readString()
        if tmp.szName then
			tmp.szName = tmp.szName:getData()
		else
			tmp.szName = " "
		end
        tmp.usScore = dt:readShort()
        
        return tmp
     end
}

local MSG_tInfo4 = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.ucAmount = dt:readByte()
        tmp.stQuizRank = {}
        if tmp.ucAmount < 1 then
            tmp.ucAmount = 1
        end
        for i = 1,tmp.ucAmount do
             table.insert(tmp.stQuizRank, stQuizRank.initWithStream(dt))
        end
        
        return tmp
     end
}

--//玩家自身排名
local MSG_tInfo5 = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.usScore = dt:readShort()
        tmp.usRank = dt:readShort()
        
        return tmp
    end
}

----------------常量定义区----------------
local MSG_QUIZ_ACTION_QUIZ  = 1  --//答题begin
local MSG_QUIZ_ACTION_QUIZ_END = 2 --//答题end(最后一个包)
local MSG_QUIZ_ACTION_ANSWER = 3  --//答案上发(用于排名显示)
local MSG_QUIZ_ACTION_CURRENT_STATUS = 4  --//当前世界答题状态
local MSG_QUIZ_ACTION_RANK_INFO = 5  --//答题排行榜
local MSG_QUIZ_ACTION_CUR_RANK = 6   --//玩家自身排名
local MSG_QUIZ_ACTION_CLOSE_QUIZ = 7 --//关闭答题窗口

local USERINFO_JION_WORLD_EVENT = 76 --//参与世界活动或改按钮

----------------变量定义区----------------
AnswerGuess.allAnswerList = {}
AnswerGuess.questionNum = 0
AnswerGuess.openAnswerGuessWnd = 0
--变量的定义
local function randomSort(wheelAwardItem)
	math.randomseed(os.time())
	local tab = {} --随机本表
	local retTab = {}
	local Rand
	local nMax = #wheelAwardItem
	for i=1, nMax do
		table.insert(tab, i)
	end
	
	for i=1, #tab do
		Rand = math.random(nMax)
		while tab[Rand] == nil do
			Rand = math.random(nMax)
		end
		tab[Rand] = nil
		table.insert(retTab, wheelAwardItem[Rand])
	end
	return retTab
end

----------------UI控制器区----------------
function AnswerGuess.initControl()
	local pWindow4001 = SCWindow:window()
	if pWindow4001 then
		pWindow4001:setTag(4001)
		pWindow4001:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow4001:setPosition(AUTO_POS(0.00, 0.00))pWindow4001:setContentSize(AUTO_SIZE(480, 320))
		pWindow4001:luaSetSelectorOnClose(AnswerGuess.releaseControl)
	end

	local imgPath = getRealUIResourcePath("img/new00285.pn")
	local pImage10001 = nil
	if imgPath then
		pImage10001 = SCImage:imageWithFile(imgPath:getData())
		if pImage10001 then
			pImage10001:setTag(10001)
			pImage10001:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10001:setPosition(AUTO_POS(17.00, 282.00))
		end
	end

	AnswerGuess.pDragNode100 = SCDragNode:node()
	if AnswerGuess.pDragNode100 then
		AnswerGuess.pDragNode100:setTag(100)
		AnswerGuess.pDragNode100:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		AnswerGuess.pDragNode100:setPosition(AUTO_POS(20.00, 190.00))
		AnswerGuess.pDragNode100:setContentSize(AUTO_SIZE(230, 80))
		AnswerGuess.pDragNode100:setFrameVisibled(true)
		AnswerGuess.pDragNode100:setDragEnabled(false)
		AnswerGuess.pDragNode100:setFrameType(EnumFrameTypeRound)
	end

	AnswerGuess.pDragNode200 = SCDragNode:node()
	if AnswerGuess.pDragNode200 then
		AnswerGuess.pDragNode200:setTag(200)
		AnswerGuess.pDragNode200:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		AnswerGuess.pDragNode200:setPosition(AUTO_POS(20.00, 40.00))
		AnswerGuess.pDragNode200:setContentSize(AUTO_SIZE(230, 150))
		AnswerGuess.pDragNode200:setFrameVisibled(true)
		AnswerGuess.pDragNode200:setDragEnabled(false)
		AnswerGuess.pDragNode200:setFrameType(EnumFrameTypeRound)
	end

	AnswerGuess.pDragNode300 = SCDragNode:node()
	if AnswerGuess.pDragNode300 then
		AnswerGuess.pDragNode300:setTag(300)
		AnswerGuess.pDragNode300:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		AnswerGuess.pDragNode300:setPosition(AUTO_POS(260.00, 210.00))
		AnswerGuess.pDragNode300:setContentSize(AUTO_SIZE(210, 60))
		AnswerGuess.pDragNode300:setFrameVisibled(true)
		AnswerGuess.pDragNode300:setDragEnabled(false)
		AnswerGuess.pDragNode300:setFrameType(EnumFrameTypeRound)
	end

	AnswerGuess.pDragNode400 = SCDragNode:node()
	if AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:setTag(400)
		AnswerGuess.pDragNode400:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		AnswerGuess.pDragNode400:setPosition(AUTO_POS(260.00, 10.00))
		AnswerGuess.pDragNode400:setContentSize(AUTO_SIZE(210, 200))
		AnswerGuess.pDragNode400:setFrameVisibled(true)
		AnswerGuess.pDragNode400:setDragEnabled(false)
		AnswerGuess.pDragNode400:setFrameType(EnumFrameTypeRound)
	end

	local pLable1 = SCLabel:labelWithStringFont(L("str3001"), DEFAULT_FONT_NAME, F(15))
	if pLable1 then
		pLable1:setTag(1)
		pLable1:setAnchorPoint(ANCHOR_CENTER)
		pLable1:setPosition(AUTO_POS(60.00, 30.00))
	end

	local pLable3 = SCLabel:labelWithStringFont(L("str3002"), DEFAULT_FONT_NAME, F(15))
	if pLable3 then
		pLable3:setTag(3)
		pLable3:setAnchorPoint(ANCHOR_CENTER)
		pLable3:setPosition(AUTO_POS(170.00, 30.00))
	end

	AnswerGuess.pLable4 = SCLabel:labelWithStringFont(L("20"), DEFAULT_FONT_NAME, F(15))
	if AnswerGuess.pLable4 then
		AnswerGuess.pLable4:setTag(4)
		AnswerGuess.pLable4:setAnchorPoint(ANCHOR_CENTER)
		AnswerGuess.pLable4:setPosition(AUTO_POS(222.00, 30.00))
		AnswerGuess.pLable4:setColor(getColorGreen())
	end

	AnswerGuess.pDragNode500 = SCDragNode:node()
	if AnswerGuess.pDragNode500 then
		AnswerGuess.pDragNode500:setTag(500)
		AnswerGuess.pDragNode500:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		AnswerGuess.pDragNode500:setPosition(AUTO_POS(90.00, 25.00))
		AnswerGuess.pDragNode500:setContentSize(AUTO_SIZE(30, 10))
		AnswerGuess.pDragNode500:setFrameVisibled(true)
		AnswerGuess.pDragNode500:setDragEnabled(false)
		AnswerGuess.pDragNode500:setFrameType(EnumFrameTypeNone)
	end

	local pLable31 = SCLabel:labelWithStringFont(L("str3003"), DEFAULT_FONT_NAME, F(15))
	if pLable31 then
		pLable31:setTag(31)
		pLable31:setAnchorPoint(ANCHOR_CENTER)
		pLable31:setPosition(AUTO_POS(95.00, 40.00))
	end

	local pLable32 = SCLabel:labelWithStringFont(L("str3004"), DEFAULT_FONT_NAME, F(15))
	if pLable32 then
		pLable32:setTag(32)
		pLable32:setAnchorPoint(ANCHOR_CENTER)
		pLable32:setPosition(AUTO_POS(95.00, 20.00))
		pLable32:setColor(getColorRed())
	end

	local pLable33 = SCLabel:labelWithStringFont(L("0"), DEFAULT_FONT_NAME, F(15))
	if pLable33 then
		pLable33:setTag(33)
		pLable33:setAnchorPoint(CCPointMake(0, 0.5))
		pLable33:setPosition(AUTO_POS(130.00, 40.00))
	end

	local pLable34 = SCLabel:labelWithStringFont(L("0"), DEFAULT_FONT_NAME, F(15))
	if pLable34 then
		pLable34:setTag(34)
		pLable34:setAnchorPoint(CCPointMake(0, 0.5))
		pLable34:setPosition(AUTO_POS(130.00, 20.00))
	end

	local pLable41 = SCLabel:labelWithStringFont(L("str3005"), DEFAULT_FONT_NAME, F(15))
	if pLable41 then
		pLable41:setTag(41)
		pLable41:setAnchorPoint(ANCHOR_CENTER)
		pLable41:setPosition(AUTO_POS(30.00, 180.00))
	end

	local pLable42 = SCLabel:labelWithStringFont(L("str3006"), DEFAULT_FONT_NAME, F(15))
	if pLable42 then
		pLable42:setTag(42)
		pLable42:setAnchorPoint(ANCHOR_CENTER)
		pLable42:setPosition(AUTO_POS(100.00, 180.00))
	end

	local pLable43 = SCLabel:labelWithStringFont(L("str3007"), DEFAULT_FONT_NAME, F(15))
	if pLable43 then
		pLable43:setTag(43)
		pLable43:setAnchorPoint(ANCHOR_CENTER)
		pLable43:setPosition(AUTO_POS(170.00, 180.00))
	end

	local pTextBox10 = SCTextBox:boxWithWidthHeightFont(AUTO_W(190), AUTO_H(60), DEFAULT_FONT_NAME, F(15))
	if pTextBox10 then
		tolua.cast(pTextBox10, "SCNode"):setTag(10)
		tolua.cast(pTextBox10, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(pTextBox10, "SCNode"):setPosition(AUTO_POS(20.00, 5.00))
		pTextBox10:setText(L(""))
	end

	local pButton21 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton21 then
		pButton21:setTag(21)
		pButton21:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton21:setPosition(AUTO_POS(20.00, 110.00))
		pButton21:setContentSize(AUTO_SIZE(20, 20))
		pButton21:setTouchRectScale(18.0,2.0)
		pButton21:setTitle(L(""), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00286.pn")
		if pBackimg then
			pButton21:setBackgroundImage(pBackimg:getData())
		end
		local pPressimg = getRealUIResourcePath("img/new00287.pn")
		if pBackimg then
			pButton21:setSelectedImage(pPressimg:getData())
		end
	end

	local pButton22 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton22 then
		pButton22:setTag(22)
		pButton22:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton22:setPosition(AUTO_POS(20.00, 80.00))
		pButton22:setContentSize(AUTO_SIZE(20, 20))
		pButton22:setTouchRectScale(18.0,2.0)
		pButton22:setTitle(L(""), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00286.pn")
		if pBackimg then
			pButton22:setBackgroundImage(pBackimg:getData())
		end
		local pPressimg = getRealUIResourcePath("img/new00287.pn")
		if pBackimg then
			pButton22:setSelectedImage(pPressimg:getData())
		end
	end

	local pButton23 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton23 then
		pButton23:setTag(23)
		pButton23:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton23:setPosition(AUTO_POS(20.00, 50.00))
		pButton23:setContentSize(AUTO_SIZE(20, 20))
		pButton23:setTouchRectScale(18.0,2.0)
		pButton23:setTitle(L(""), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00286.pn")
		if pBackimg then
			pButton23:setBackgroundImage(pBackimg:getData())
		end
		local pPressimg = getRealUIResourcePath("img/new00287.pn")
		if pBackimg then
			pButton23:setSelectedImage(pPressimg:getData())
		end
	end

	local pButton24 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton24 then
		pButton24:setTag(24)
		pButton24:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton24:setPosition(AUTO_POS(20.00, 20.00))
		pButton24:setContentSize(AUTO_SIZE(20, 20))
		pButton24:setTouchRectScale(18.0,2.0)
		pButton24:setTitle(L(""), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00286.pn")
		if pBackimg then
			pButton24:setBackgroundImage(pBackimg:getData())
		end
		local pPressimg = getRealUIResourcePath("img/new00287.pn")
		if pBackimg then
			pButton24:setSelectedImage(pPressimg:getData())
		end
	end

	local pLable210 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable210 then
		pLable210:setTag(210)
		pLable210:setAnchorPoint(CCPointMake(0, 0.5))
		pLable210:setPosition(AUTO_POS(50.00, 110.00))
	end

	local pLable220 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable220 then
		pLable220:setTag(220)
		pLable220:setAnchorPoint(CCPointMake(0, 0.5))
		pLable220:setPosition(AUTO_POS(50.00, 80.00))
	end

	local pLable230 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable230 then
		pLable230:setTag(230)
		pLable230:setAnchorPoint(CCPointMake(0, 0.5))
		pLable230:setPosition(AUTO_POS(50.00, 50.00))
	end

	local pLable240 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable240 then
		pLable240:setTag(240)
		pLable240:setAnchorPoint(CCPointMake(0, 0.5))
		pLable240:setPosition(AUTO_POS(50.00, 20.00))
	end

	local pLable401 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable401 then
		pLable401:setTag(401)
		pLable401:setAnchorPoint(CCPointMake(0.5, 0))
		pLable401:setPosition(AUTO_POS(30.00, 150.00))
		pLable401:setColor(getColorRed())
	end

	local pLable402 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable402 then
		pLable402:setTag(402)
		pLable402:setAnchorPoint(CCPointMake(0.5, 0))
		pLable402:setPosition(AUTO_POS(30.00, 135.00))
		pLable402:setColor(getColorOrange())
	end

	local pLable403 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable403 then
		pLable403:setTag(403)
		pLable403:setAnchorPoint(CCPointMake(0.5, 0))
		pLable403:setPosition(AUTO_POS(30.00, 120.00))
		pLable403:setColor(getColorBlue())
	end

	local pLable405 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable405 then
		pLable405:setTag(405)
		pLable405:setAnchorPoint(CCPointMake(0.5, 0))
		pLable405:setPosition(AUTO_POS(30.00, 90.00))
	end

	local pLable406 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable406 then
		pLable406:setTag(406)
		pLable406:setAnchorPoint(CCPointMake(0.5, 0))
		pLable406:setPosition(AUTO_POS(30.00, 75.00))
	end

	local pLable407 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable407 then
		pLable407:setTag(407)
		pLable407:setAnchorPoint(CCPointMake(0.5, 0))
		pLable407:setPosition(AUTO_POS(30.00, 60.00))
	end

	local pLable408 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable408 then
		pLable408:setTag(408)
		pLable408:setAnchorPoint(CCPointMake(0.5, 0))
		pLable408:setPosition(AUTO_POS(30.00, 45.00))
	end

	local pLable409 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable409 then
		pLable409:setTag(409)
		pLable409:setAnchorPoint(CCPointMake(0.5, 0))
		pLable409:setPosition(AUTO_POS(30.00, 30.00))
	end

	local pLable404 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable404 then
		pLable404:setTag(404)
		pLable404:setAnchorPoint(CCPointMake(0.5, 0))
		pLable404:setPosition(AUTO_POS(30.00, 105.00))
	end

	local pLable410 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable410 then
		pLable410:setTag(410)
		pLable410:setAnchorPoint(CCPointMake(0.5, 0))
		pLable410:setPosition(AUTO_POS(30.00, 15.00))
	end

	local pLable421 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable421 then
		pLable421:setTag(421)
		pLable421:setAnchorPoint(CCPointMake(0.5, 0))
		pLable421:setPosition(AUTO_POS(100.00, 150.00))
		pLable421:setColor(getColorRed())
	end

	local pLable423 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable423 then
		pLable423:setTag(423)
		pLable423:setAnchorPoint(CCPointMake(0.5, 0))
		pLable423:setPosition(AUTO_POS(100.00, 120.00))
		pLable423:setColor(getColorBlue())
	end

	local pLable425 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable425 then
		pLable425:setTag(425)
		pLable425:setAnchorPoint(CCPointMake(0.5, 0))
		pLable425:setPosition(AUTO_POS(100.00, 90.00))
	end

	local pLable426 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable426 then
		pLable426:setTag(426)
		pLable426:setAnchorPoint(CCPointMake(0.5, 0))
		pLable426:setPosition(AUTO_POS(100.00, 75.00))
	end

	local pLable428 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable428 then
		pLable428:setTag(428)
		pLable428:setAnchorPoint(CCPointMake(0.5, 0))
		pLable428:setPosition(AUTO_POS(100.00, 45.00))
	end

	local pLable430 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable430 then
		pLable430:setTag(430)
		pLable430:setAnchorPoint(CCPointMake(0.5, 0))
		pLable430:setPosition(AUTO_POS(100.00, 15.00))
	end

	local pLable429 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable429 then
		pLable429:setTag(429)
		pLable429:setAnchorPoint(CCPointMake(0.5, 0))
		pLable429:setPosition(AUTO_POS(100.00, 30.00))
	end

	local pLable427 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable427 then
		pLable427:setTag(427)
		pLable427:setAnchorPoint(CCPointMake(0.5, 0))
		pLable427:setPosition(AUTO_POS(100.00, 60.00))
	end

	local pLable424 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable424 then
		pLable424:setTag(424)
		pLable424:setAnchorPoint(CCPointMake(0.5, 0))
		pLable424:setPosition(AUTO_POS(100.00, 105.00))
	end

	local pLable422 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable422 then
		pLable422:setTag(422)
		pLable422:setAnchorPoint(CCPointMake(0.5, 0))
		pLable422:setPosition(AUTO_POS(100.00, 135.00))
		pLable422:setColor(getColorOrange())
	end

	local pLable441 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable441 then
		pLable441:setTag(441)
		pLable441:setAnchorPoint(CCPointMake(0.5, 0))
		pLable441:setPosition(AUTO_POS(170.00, 150.00))
		pLable441:setColor(getColorRed())
	end

	local pLable443 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable443 then
		pLable443:setTag(443)
		pLable443:setAnchorPoint(CCPointMake(0.5, 0))
		pLable443:setPosition(AUTO_POS(170.00, 120.00))
		pLable443:setColor(getColorBlue())
	end

	local pLable445 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable445 then
		pLable445:setTag(445)
		pLable445:setAnchorPoint(CCPointMake(0.5, 0))
		pLable445:setPosition(AUTO_POS(170.00, 90.00))
	end

	local pLable442 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable442 then
		pLable442:setTag(442)
		pLable442:setAnchorPoint(CCPointMake(0.5, 0))
		pLable442:setPosition(AUTO_POS(170.00, 135.00))
		pLable442:setColor(getColorOrange())
	end

	local pLable444 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable444 then
		pLable444:setTag(444)
		pLable444:setAnchorPoint(CCPointMake(0.5, 0))
		pLable444:setPosition(AUTO_POS(170.00, 105.00))
	end

	local pLable446 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable446 then
		pLable446:setTag(446)
		pLable446:setAnchorPoint(CCPointMake(0.5, 0))
		pLable446:setPosition(AUTO_POS(170.00, 75.00))
	end

	local pLable448 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable448 then
		pLable448:setTag(448)
		pLable448:setAnchorPoint(CCPointMake(0.5, 0))
		pLable448:setPosition(AUTO_POS(170.00, 45.00))
	end

	local pLable447 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable447 then
		pLable447:setTag(447)
		pLable447:setAnchorPoint(CCPointMake(0.5, 0))
		pLable447:setPosition(AUTO_POS(170.00, 60.00))
	end

	local pLable450 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable450 then
		pLable450:setTag(450)
		pLable450:setAnchorPoint(CCPointMake(0.5, 0))
		pLable450:setPosition(AUTO_POS(170.00, 15.00))
	end

	local pLable449 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(15))
	if pLable449 then
		pLable449:setTag(449)
		pLable449:setAnchorPoint(CCPointMake(0.5, 0))
		pLable449:setPosition(AUTO_POS(170.00, 30.00))
	end

	if pImage10001 and pWindow4001 then
		pWindow4001:addChild(tolua.cast(pImage10001, "SCNode"))
	end
	if AnswerGuess.pDragNode100 and pWindow4001 then
		pWindow4001:addChild(tolua.cast(AnswerGuess.pDragNode100, "SCNode"))
	end
	if AnswerGuess.pDragNode400 and pWindow4001 then
		pWindow4001:addChild(tolua.cast(AnswerGuess.pDragNode400, "SCNode"))
	end
	if AnswerGuess.pDragNode200 and pWindow4001 then
		pWindow4001:addChild(tolua.cast(AnswerGuess.pDragNode200, "SCNode"))
	end
	if AnswerGuess.pDragNode300 and pWindow4001 then
		pWindow4001:addChild(tolua.cast(AnswerGuess.pDragNode300, "SCNode"))
	end
	
	if pLable1 and pWindow4001 then
		pWindow4001:addChild(tolua.cast(pLable1, "SCNode"))
	end
	if pLable3 and pWindow4001 then
		pWindow4001:addChild(tolua.cast(pLable3, "SCNode"))
	end
	if AnswerGuess.pLable4 and pWindow4001 then
		pWindow4001:addChild(tolua.cast(AnswerGuess.pLable4, "SCNode"))
	end
	if AnswerGuess.pDragNode500 and pWindow4001 then
		pWindow4001:addChild(tolua.cast(AnswerGuess.pDragNode500, "SCNode"))
	end
	if pLable31 and AnswerGuess.pDragNode300 then
		AnswerGuess.pDragNode300:addChild(tolua.cast(pLable31, "SCNode"))
	end
	if pLable32 and AnswerGuess.pDragNode300 then
		AnswerGuess.pDragNode300:addChild(tolua.cast(pLable32, "SCNode"))
	end
	if pLable33 and AnswerGuess.pDragNode300 then
		AnswerGuess.pDragNode300:addChild(tolua.cast(pLable33, "SCNode"))
	end
	if pLable34 and AnswerGuess.pDragNode300 then
		AnswerGuess.pDragNode300:addChild(tolua.cast(pLable34, "SCNode"))
	end
	if pLable41 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable41, "SCNode"))
	end
	if pLable42 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable42, "SCNode"))
	end
	if pLable43 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable43, "SCNode"))
	end
	if pTextBox10 and AnswerGuess.pDragNode100 then
		AnswerGuess.pDragNode100:addChild(tolua.cast(pTextBox10, "SCNode"))
	end
	if pButton21 and AnswerGuess.pDragNode200 then
		AnswerGuess.pDragNode200:addChild(tolua.cast(pButton21, "SCNode"))
	end
	if pButton22 and AnswerGuess.pDragNode200 then
		AnswerGuess.pDragNode200:addChild(tolua.cast(pButton22, "SCNode"))
	end
	if pButton23 and AnswerGuess.pDragNode200 then
		AnswerGuess.pDragNode200:addChild(tolua.cast(pButton23, "SCNode"))
	end
	if pButton24 and AnswerGuess.pDragNode200 then
		AnswerGuess.pDragNode200:addChild(tolua.cast(pButton24, "SCNode"))
	end
	if pLable210 and AnswerGuess.pDragNode200 then
		AnswerGuess.pDragNode200:addChild(tolua.cast(pLable210, "SCNode"))
	end
	if pLable220 and AnswerGuess.pDragNode200 then
		AnswerGuess.pDragNode200:addChild(tolua.cast(pLable220, "SCNode"))
	end
	if pLable230 and AnswerGuess.pDragNode200 then
		AnswerGuess.pDragNode200:addChild(tolua.cast(pLable230, "SCNode"))
	end
	if pLable240 and AnswerGuess.pDragNode200 then
		AnswerGuess.pDragNode200:addChild(tolua.cast(pLable240, "SCNode"))
	end
	if pLable401 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable401, "SCNode"))
	end
	if pLable402 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable402, "SCNode"))
	end
	if pLable403 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable403, "SCNode"))
	end
	if pLable405 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable405, "SCNode"))
	end
	if pLable406 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable406, "SCNode"))
	end
	if pLable407 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable407, "SCNode"))
	end
	if pLable408 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable408, "SCNode"))
	end
	if pLable409 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable409, "SCNode"))
	end
	if pLable404 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable404, "SCNode"))
	end
	if pLable410 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable410, "SCNode"))
	end
	if pLable421 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable421, "SCNode"))
	end
	if pLable423 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable423, "SCNode"))
	end
	if pLable425 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable425, "SCNode"))
	end
	if pLable426 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable426, "SCNode"))
	end
	if pLable428 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable428, "SCNode"))
	end
	if pLable430 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable430, "SCNode"))
	end
	if pLable429 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable429, "SCNode"))
	end
	if pLable427 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable427, "SCNode"))
	end
	if pLable424 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable424, "SCNode"))
	end
	if pLable422 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable422, "SCNode"))
	end
	if pLable441 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable441, "SCNode"))
	end
	if pLable443 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable443, "SCNode"))
	end
	if pLable445 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable445, "SCNode"))
	end
	if pLable442 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable442, "SCNode"))
	end
	if pLable444 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable444, "SCNode"))
	end
	if pLable446 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable446, "SCNode"))
	end
	if pLable448 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable448, "SCNode"))
	end
	if pLable447 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable447, "SCNode"))
	end
	if pLable450 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable450, "SCNode"))
	end
	if pLable449 and AnswerGuess.pDragNode400 then
		AnswerGuess.pDragNode400:addChild(tolua.cast(pLable449, "SCNode"))
	end
	return pWindow4001
end
function AnswerGuess.releaseControl()
	if AnswerGuess.wndCloss then
		AnswerGuess.wndCloss()
	end
end
--函数定义
----------------逻辑功能区----------------
--//回答问题按钮回调
function AnswerGuess.questionEnter(tag)
    local wndCtrl = getCurentSceneWindowController(4001)
    local wnd = nil
    if wndCtrl then
        wnd = wndCtrl:getWindow()
        if not wnd then
            return
        end
    end
    local pDragNode200 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("200", tolua.cast(wnd, "SCNode")));
    if pDragNode200 then
        local btn2x = SCTypeCast:castNodeToButton(pDragNode200:getChildByTag(tag))
        local imgFile = getRealUIResourcePath("img/new00287.png")
        if btn2x and imgFile then
            btn2x:setBackgroundImage(imgFile:getData())
        end
        local lable2x0 = SCTypeCast:castNodeToLabel(pDragNode200:getChildByTag(tag*10))
        if lable2x0 then
            lable2x0:setColor(getColorOrange())
        end
        for i = 1,4 do
            local btn2x = SCTypeCast:castNodeToButton(pDragNode200:getChildByTag(20 + i))
            if btn2x then
                btn2x:luaSetSelectorOnClicked(AnswerGuess.notQuestionEnter)
            end
        end
    end
    local m_time = 0
    local pDragNode500 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("500", tolua.cast(wnd, "SCNode")));
    if pDragNode500 then
        local pCountDownNode = SCTypeCast:castNodeToCountDownNode(pDragNode500:getChildByTag(999))
        if pCountDownNode then
            m_time = pCountDownNode:getCurTime()
        end
    end
    
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_QUIZGAME)
    dataStream:writeShort(MSG_QUIZ_ACTION_ANSWER)
    dataStream:writeByte(AnswerGuess.questionNum )
    dataStream:writeByte(tag - 21)
    dataStream:writeByte(m_time)
    SCDataTransThread:getSingleton():transData(dataStream)
    --SCActivityIndicator:getSingleton():show()
end
--//回答问题按钮空回调
function AnswerGuess.notQuestionEnter()

end
--//答题结束
function AnswerGuess.exitQuestion()
    local naviCtrl =  getCurentSceneNavigationController()
    if not naviCtrl then
        return
    end
    naviCtrl:removeWindowControllerByTag(4001)
    AnswerGuess.allAnswerList = {}
    AnswerGuess.questionNum = nil
    AnswerGuess.openAnswerGuessWnd = 0
    
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_QUIZGAME)
    dataStream:writeShort(MSG_QUIZ_ACTION_CLOSE_QUIZ)
    SCDataTransThread:getSingleton():transData(dataStream)
    --SCActivityIndicator:getSingleton():show()
end
--//等待换题
function AnswerGuess.waitQuestion()
    local wndCtrl = getCurentSceneWindowController(4001)
    local wnd = nil
    if wndCtrl then
        wnd = wndCtrl:getWindow()
        if not wnd then
            return
        end
    end
    local pDragNode500 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("500", tolua.cast(wnd, "SCNode")));
    if pDragNode500 then
        local pCountDownNode = SCTypeCast:castNodeToCountDownNode(pDragNode500:getChildByTag(999))
        if pCountDownNode then
            pDragNode500:removeChildByTag(999,true)
        end
        AnswerGuess.questionNum = AnswerGuess.questionNum + 1
        local pCountDownNode = CountDownNode:newCountDownNode(DisplayTimeType_Second,15)
        if pCountDownNode then
                pCountDownNode:setTime(3)
                pCountDownNode:setTag(999)
                pCountDownNode:setColor(getColorRed())
                pCountDownNode:setPosition(SX(1),SY(-4))
                pDragNode500:addChild(pCountDownNode)
                pCountDownNode:luasetSelectorOnClose(AnswerGuess.notQuestionEnter)
        end
    end
    local pDragNode200 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("200", tolua.cast(wnd, "SCNode")));
    if pDragNode200 then
    	for i = 1,4 do
            local btn2x = SCTypeCast:castNodeToButton(pDragNode200:getChildByTag(20 + i))
            if btn2x then
                btn2x:luaSetSelectorOnClicked(AnswerGuess.notQuestionEnter)
            end
        end
    end
    
end
--//更换题目
function AnswerGuess.updateQuestion(dt)
    local qNum = AnswerGuess.questionNum + 1
    if AnswerGuess.allAnswerList[qNum] then
        local wndCtrl = getCurentSceneWindowController(4001)
        local wnd = nil
        if wndCtrl then
            wnd = wndCtrl:getWindow()
            
        end
        if not wnd then
            return
        end
        local pDragNode500 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("500", tolua.cast(wnd, "SCNode")));
        if pDragNode500 then
            local pCountDownNode = SCTypeCast:castNodeToCountDownNode(pDragNode500:getChildByTag(999))
            if pCountDownNode then
                pDragNode500:removeChildByTag(999,true)
            end
            local pCountDownNode = CountDownNode:newCountDownNode(DisplayTimeType_Second,15)
            if pCountDownNode then
                local m_time = 20
                if dt then
                    m_time = dt.usCountDown
                    if m_time < 0 then
                        m_time = 20
                    end
                end
                pCountDownNode:setTime(m_time)
                pCountDownNode:setTag(999)
                pCountDownNode:setColor(getColorRed())
                pCountDownNode:setPosition(SX(3),SY(-5))
                pDragNode500:addChild(pCountDownNode)
             	if qNum == 20 then
             		pCountDownNode:luasetSelectorOnClose(AnswerGuess.notQuestionEnter)
             	else
                	pCountDownNode:luasetSelectorOnClose(AnswerGuess.waitQuestion)
                end
            end
        end
        local pDragNode100 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("100", tolua.cast(wnd, "SCNode")));
        local pDragNode200 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("200", tolua.cast(wnd, "SCNode")));
        if pDragNode100 and pDragNode200 then
                local answerList = {}
                answerList = AnswerGuess.allAnswerList[qNum]
                local textbox10 = SCTypeCast:castNodeToTextBox(pDragNode100:getChildByTag(10))
                if textbox10 and answerList then
                    local message = answerList.szQuiz
                    if not message then
                        message = " "
                    end
                    local text = qNum..". "..message
                    textbox10:setText(text)
                end
                --[[
                local answerList = {}
                answerList[1] = AnswerGuess.allAnswerList[qNum].szAnswer0
                answerList[2] = AnswerGuess.allAnswerList[qNum].szAnswer1
                answerList[3] = AnswerGuess.allAnswerList[qNum].szAnswer2
                answerList[4] = AnswerGuess.allAnswerList[qNum].szAnswer3
                local answerList2 = {}
                answerList2 = randomSort(answerList)
                ]]--
                local lable210 = SCTypeCast:castNodeToLabel(pDragNode200:getChildByTag(210))
                if lable210 and answerList then
                    local message = answerList.szAnswer0
                    if not message then
                        message = " "
                    end
                    lable210:setText(message)
                    lable210:setColor(getColorWhite())
                end
                   
                local lable220 = SCTypeCast:castNodeToLabel(pDragNode200:getChildByTag(220))
                if lable220 and answerList then
                    local message = answerList.szAnswer1
                    if not message then
                        message = " "
                    end
                    lable220:setText(message)
                    lable220:setColor(getColorWhite())
                end
                local lable230 = SCTypeCast:castNodeToLabel(pDragNode200:getChildByTag(230))
                if lable230 and answerList then
                    local message = answerList.szAnswer2
                    if not message then
                        message = " "
                    end
                    lable230:setText(message)
                    lable230:setColor(getColorWhite())
                end
                local lable240 = SCTypeCast:castNodeToLabel(pDragNode200:getChildByTag(240))
                if lable240 and answerList then
                    local message = answerList.szAnswer3
                    if not message then
                        message = " "
                    end
                    lable240:setText(message)
                    lable240:setColor(getColorWhite())
                end
                for i = 1,4 do
                    local imgFile = getRealUIResourcePath("img/new00286.png")
                    local imgFile1 = getRealUIResourcePath("img/new00287.png")
	                local btn2x = SCTypeCast:castNodeToButton(pDragNode200:getChildByTag(20 + i))
	                if btn2x and imgFile and imgFile1 then
	                    btn2x:setBackgroundImage(imgFile:getData())
	                    btn2x:setSelectedImage(imgFile1:getData())
	                    btn2x:setTouchRectScale(18.0,1.0)  
	                    btn2x:luaSetSelectorOnClicked(AnswerGuess.questionEnter)
	                end
	            end
        end
        local pLable4 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(wnd, "SCNode")));
        if pLable4 then
	        local surplusNum = 20 - qNum - 1
	        if surplusNum >= 0 then 
	            pLable4:setText(surplusNum)
	        end
	    end
        
        --AnswerGuess.questionNum = AnswerGuess.questionNum + 1
        
    end    
end
--//答题begin//答题end(最后一个包)
function AnswerGuess.questionData(dt)
    if not dt then
		return
	end
end

function AnswerGuess.beginState(time)
    local bWnd =  SCFunction:getUiNodeByIdlist("4001")
    if not bWnd then
        return
    end
    local w = 160 * gUIScale().x
    local h = 80 * gUIScale().y
    local wnd = FrameWindow:frameWnd();
    if not wnd then
        return
    end
    wnd:setTag(888)
    wnd:setCloseBtnVisible(false)
    wnd:setContentSize(CCSize(w ,h))
    local pNode = SCDragNode:node()
    if pNode then
        pNode:setTag(10)
        pNode:setPosition(AUTO_POS(5.00, 5.00))
		pNode:setContentSize(AUTO_SIZE(150, 70))
        pNode:setFrameVisibled(true)
		pNode:setDragEnabled(false)
		pNode:setFrameType(EnumFrameTypeRound)
		--wnd:setContentSize(pNode:getContentSize())
		wnd:addChild(pNode)
		local nameLabel = SCLabel:labelWithStringFont(_LTParser("str3020"),getDefaultFontName(), getFontSize(15))
        if nameLabel then
            nameLabel:setAnchorPoint(CCPointMake(0.5,0.5));
            nameLabel:setPosition(CCPointMake(SX(70),SY(40)));
            nameLabel:setColor(getColorRed())
            pNode:addChild(nameLabel)
        end
        local beginCountDownNode = CountDownNode:newCountDownNode(DisplayTimeType_Second,15)
        if beginCountDownNode then
               
            if time < 0 then
                time = 20
            end
            beginCountDownNode:setTime(time)
            beginCountDownNode:setAnchorPoint(CCPointMake(0.5,0.5));
            beginCountDownNode:setTag(999)
            beginCountDownNode:setColor(getColorRed())
            beginCountDownNode:setPosition(SX(115),SY(40))
            pNode:addChild(beginCountDownNode)
            beginCountDownNode:luasetSelectorOnClose(AnswerGuess.notQuestionEnter)
                
        end
        wnd:setOutSpaceClickClose(true)
	    bWnd:addChild(wnd)
    end
    

end
function AnswerGuess.beginRemove()
    local wndCtrl = getCurentSceneWindowController(4001)
	local wnd = nil
    if wndCtrl then
        wnd = wndCtrl:getWindow()
        if not wnd then
            return
        end
    end
	local pDragNode200 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("200", tolua.cast(wnd, "SCNode")));
    if pDragNode200 then
        local nameNode = pDragNode200:getChildByTag(887)
        if nameNode then
            pDragNode200:removeChildByTag(887,true)
        end
        local pCountDownNode = SCTypeCast:castNodeToCountDownNode(pDragNode200:getChildByTag(888))
        if pCountDownNode then
            pDragNode200:removeChildByTag(888,true)
        end
    end
    --AnswerGuess.updateQuestion()
end
function AnswerGuess.beginQuestionEnter()
    local wndCtrl = getCurentSceneWindowController(4001)
	local wnd = nil
    if wndCtrl then
        wnd = wndCtrl:getWindow()
        if not wnd then
            return
        end
    end
	local pDragNode200 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("200", tolua.cast(wnd, "SCNode")));
    if pDragNode200 then
        local pCountDownNode = SCTypeCast:castNodeToCountDownNode(pDragNode200:getChildByTag(888))
        if pCountDownNode then
            pDragNode200:removeChildByTag(888,true)
        end
    end
end
--//当前世界答题状态
function AnswerGuess.answerState(dt)
    if not dt then
		return
	end
	local wndCtrl = getCurentSceneWindowController(4001)
    local wnd = nil
    if wndCtrl then
        wnd = wndCtrl:getWindow()
        
    end
    if not wnd then
        return
    end   
	AnswerGuess.questionNum = dt.ucQuizNumber
	local qNum = dt.ucQuizNumber + 1
	if AnswerGuess.allAnswerList[qNum] then
	    local pDragNode100 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("100", tolua.cast(wnd, "SCNode")));
	    local pDragNode200 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("200", tolua.cast(wnd, "SCNode")));
        if pDragNode100 and pDragNode200 then
            local answerList = {}
            answerList = AnswerGuess.allAnswerList[qNum]
            
        	local num = tostring(qNum)
		    local textbox10 = SCTypeCast:castNodeToTextBox(pDragNode100:getChildByTag(10))
		    if textbox10 and answerList then
		    	local message = num.."."..answerList.szQuiz
		    	if 0 == dt.ucStatus  then
		    	    message = _LTParser("str3009")
		    	end
		    	
                if not message then
                    message = " "
                end
		        textbox10:setText(message)
		    end
		        
		    local lable210 = SCTypeCast:castNodeToLabel(pDragNode200:getChildByTag(210))
		    if lable210 and answerList then
		        local message = answerList.szAnswer0
                if not message then
                     message = " "
                end
		        if 0 == dt.ucStatus  then
		    	    message = _LTParser("str3010")
		    	end
		        lable210:setText(message)
		    end
		       
		    local lable220 = SCTypeCast:castNodeToLabel(pDragNode200:getChildByTag(220))
		    if lable220 and answerList then
		        local message = answerList.szAnswer1
                if not message then
                     message = " "
                end
		        if 0 == dt.ucStatus  then
		    	    message = _LTParser("str3011")
		    	end
		        lable220:setText(message)
		    end
		    local lable230 = SCTypeCast:castNodeToLabel(pDragNode200:getChildByTag(230))
		    if lable230 and answerList then
		        local message = answerList.szAnswer2
                if not message then
                     message = " "
                end
		        if 0 == dt.ucStatus  then
		    	    message = _LTParser("str3012")
		    	end
		        lable230:setText(message)
		    end
		    local lable240 = SCTypeCast:castNodeToLabel(pDragNode200:getChildByTag(240))
		    if lable240 and answerList then
		        local message = answerList.szAnswer3
                if not message then
                     message = " "
                end
		        
		        if 0 == dt.ucStatus  then
		    	    message = _LTParser("str3013")
		    	end
		        lable240:setText(message)
		    end
		    
	    end
    end
    
    local pCountDownNode = nil
    local pDragNode500 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("500", tolua.cast(wnd, "SCNode")));
    if pDragNode500 then
        local pCountDownNode = SCTypeCast:castNodeToCountDownNode(pDragNode500:getChildByTag(999))
        if pCountDownNode then
            pDragNode500:removeChildByTag(999,true)
        end
        pCountDownNode = CountDownNode:newCountDownNode(DisplayTimeType_Second,15)
        if pCountDownNode then
                local m_time = dt.usCountDown
                if m_time < 0 then
                    m_time = 20
                end
                pCountDownNode:setTime(m_time)
                pCountDownNode:setTag(999)
                pCountDownNode:setColor(getColorRed())
                pCountDownNode:setPosition(SX(3),SY(-5))
                pDragNode500:addChild(pCountDownNode)
                pCountDownNode:luasetSelectorOnClose(AnswerGuess.waitQuestion)
                
        end
    end
    --//还未开始
	if 0 == dt.ucStatus  then	
	
        if pCountDownNode then
            AnswerGuess.questionNum = 1
            pCountDownNode:luasetSelectorOnClose(AnswerGuess.notQuestionEnter)
        end 
        local m_time = dt.usCountDown
        local pDragNode200 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("200", tolua.cast(wnd, "SCNode")));
        local nameLabel = SCLabel:labelWithStringFont(_LTParser("str3020"),getDefaultFontName(), getFontSize(15))
        if nameLabel and pDragNode200 then
            nameLabel:setAnchorPoint(CCPointMake(0.5,0.5));
            nameLabel:setPosition(CCPointMake(SX(195),SY(120)));
            nameLabel:setColor(getColorRed())
            nameLabel:setTag(887)
            pDragNode200:addChild(nameLabel)
        end
        local beginCountDownNode = CountDownNode:newCountDownNode(DisplayTimeType_Second,15)
        
        if beginCountDownNode and pDragNode200 then
               
            if m_time < 0 then
                m_time = 20
            end
            beginCountDownNode:setTime(m_time)
            beginCountDownNode:setAnchorPoint(CCPointMake(0.5,0.5));
            beginCountDownNode:setTag(888)
            beginCountDownNode:setColor(getColorRed())
            beginCountDownNode:setPosition(SX(245),SY(120))
            pDragNode200:addChild(beginCountDownNode)
            beginCountDownNode:luasetSelectorOnClose(AnswerGuess.beginQuestionEnter)
                
        end
        
    --//已开始(答题中)
	elseif 1 == dt.ucStatus then
	    if 0 == AnswerGuess.questionNum then
	        AnswerGuess.beginRemove()
	    end
	    AnswerGuess.updateQuestion(dt)
	    if pCountDownNode then
	        AnswerGuess.questionNum = dt.ucQuizNumber 
	        pCountDownNode:luasetSelectorOnClose(AnswerGuess.waitQuestion)
	    end
	    local pDragNode200 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("200", tolua.cast(wnd, "SCNode")));
	    if pDragNode200 then
	        for i = 1,4 do
	            local btn2x = SCTypeCast:castNodeToButton(pDragNode200:getChildByTag(20 + i))
	            if btn2x then
	                btn2x:luaSetSelectorOnClicked(AnswerGuess.questionEnter)
	            end
	        end
	    end
	    local pLable4 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(wnd, "SCNode")));
	    if pLable4 then
	        local surplusNum = 20 - dt.ucQuizNumber - 1
	        if surplusNum >= 0 then 
	            pLable4:setText(surplusNum)
	        end
	    end
	--//已开始(准备换题中)
	elseif 2 == dt.ucStatus then
	    if pCountDownNode then
	        AnswerGuess.questionNum = dt.ucQuizNumber + 1
	        pCountDownNode:luasetSelectorOnClose(AnswerGuess.updateQuestion)
	    end
	    local pLable4 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(wnd, "SCNode")));
	    if pLable4 then
	        local surplusNum = 20 - dt.ucQuizNumber - 1
	        if surplusNum >= 0 then 
	            pLable4:setText(surplusNum)
	        end
	    end
	--//已答题
	elseif 3 == dt.ucStatus then
	    if pCountDownNode then
	        AnswerGuess.questionNum = dt.ucQuizNumber
	        pCountDownNode:luasetSelectorOnClose(AnswerGuess.waitQuestion)
	    end
	    if qNum < 1 then
	        qNum = 1
	    end
	    if AnswerGuess.allAnswerList[qNum] then
	        local pDragNode100 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("100", tolua.cast(wnd, "SCNode")));
	        local pDragNode200 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("200", tolua.cast(wnd, "SCNode")));
            if pDragNode100 and pDragNode200 then
                local qNum = dt.ucQuizNumber + 1
                local answerNum = dt.ucAnswer
	            if AnswerGuess.allAnswerList[qNum] then
                    if pDragNode100 and pDragNode200 then
                        local btn2x = SCTypeCast:castNodeToButton(pDragNode200:getChildByTag(21 + answerNum))
                        local imgFile = getRealUIResourcePath("img/new00287.png")
                        if btn2x and imgFile then
                            btn2x:setBackgroundImage(imgFile:getData())
                        end
                        local lable2x0 = SCTypeCast:castNodeToLabel(pDragNode200:getChildByTag(210 + answerNum*10))
                        if lable2x0 then
                            lable2x0:setColor(getColorOrange())
                        end
                    end
                end
            end
        end
        local pLable4 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(wnd, "SCNode")));
        if pLable4 then
	        local surplusNum = 20 - dt.ucQuizNumber - 1
	        if surplusNum >= 0 then 
	            pLable4:setText(surplusNum)
	        end
	    end
    end
end

--//答题排行榜
function AnswerGuess.answerList(dt)
    if not dt then
		return
	end
	local wndCtrl = getCurentSceneWindowController(4001)
	local wnd = nil
    if wndCtrl then
        wnd = wndCtrl:getWindow()
        
    end
    if not wnd then
        return
    end
	local pDragNode400 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("400", tolua.cast(wnd, "SCNode")));
	if not pDragNode400 then
		return
	end
	for i = 1,10 do
	    local rank = " "
	    local name = " "
	    local score = " "
	    if dt.stQuizRank[i] then
	        rank = dt.stQuizRank[i].usRank
	        name = dt.stQuizRank[i].szName
	        score = dt.stQuizRank[i].usScore
	    end
	    local lable40x = SCTypeCast:castNodeToLabel(pDragNode400:getChildByTag(400 + i))
	    if lable40x then
	        if not rank then
	            rank = " "
	        end 
	        lable40x:setText(rank)
	        
	        if i == 1 then
	            lable40x:setColor(getColorRed())
	        elseif i == 2 then
	            lable40x:setColor(getColorOrange())
	        elseif i == 3 then
	            lable40x:setColor(getColorBlue())
	        end
	    end
	    
	    local lable42x = SCTypeCast:castNodeToLabel(pDragNode400:getChildByTag(420 + i))
	    if lable42x then
	        if not name then
	            name = " "
	        end
	        lable42x:setText(name)
	        if i == 1 then
	            lable42x:setColor(getColorRed())
	        elseif i == 2 then
	            lable42x:setColor(getColorOrange())
	        elseif i == 3 then
	            lable42x:setColor(getColorBlue())
	        end
	    end
	    
	    local lable44x = SCTypeCast:castNodeToLabel(pDragNode400:getChildByTag(440 + i))
	    if lable44x then
	        if not score then
	            score = " "
	        end
	        lable44x:setText(score)
	        
	        if i == 1 then
	            lable44x:setColor(getColorRed())
	        elseif i == 2 then
	            lable44x:setColor(getColorOrange())
	        elseif i == 3 then
	            lable44x:setColor(getColorBlue())
	        end
	    end
	end
end

--//玩家自身排名
function AnswerGuess.playerRanking(dt)
    if not dt then
		return
	end
	local wndCtrl = getCurentSceneWindowController(4001)
	local wnd = nil
    if wndCtrl then
        wnd = wndCtrl:getWindow()
        
    end
    if not wnd then
        return
    end
	local pDragNode300 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("300", tolua.cast(wnd, "SCNode")));
	if not pDragNode300 then
		return
	end	
	local lable33 = SCTypeCast:castNodeToLabel(pDragNode300:getChildByTag(33))
	if lable33 then
	    local score = dt.usScore
	    if not score then
	        score = 0
	    end
	    lable33:setText(score)
	end
	local lable34 = SCTypeCast:castNodeToLabel(pDragNode300:getChildByTag(34))
	if lable34 then
	    local rank = dt.usRank
	    if not rank then
	        rank = 0
	    end
	    lable34:setText(rank)
	    lable34:setColor(getColorRed())
	end
end
----------------消息处理区----------------
local function recvAnswerGuessInfo()
    --SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if not dt then
        return;
    end
    if 0 == AnswerGuess.openAnswerGuessWnd then
        
        local wndCtrl = getCurentSceneWindowController(4001)
        if wndCtrl then
            return
        end
        local wnd = AnswerGuess.initControl()
        if wnd then
            wndCtrl = SCWindowController:controllerWithWindow(wnd)
            local naviCtrl =  getCurentSceneNavigationController()
            if wndCtrl and naviCtrl then
                naviCtrl:pushWindowController(wndCtrl)
                
            end
        end
        AnswerGuess.openAnswerGuessWnd = 1
    end
    
	
    local action = dt:readShort()	

	if action == MSG_QUIZ_ACTION_QUIZ then         --//答题begin                
	    AnswerGuess.questionData(MSG_tInfo1.initWithStream(dt))
	elseif action == MSG_QUIZ_ACTION_QUIZ_END then    --//答题end(最后一个包)
        AnswerGuess.questionData(MSG_tInfo1.initWithStream(dt))
	elseif action == MSG_QUIZ_ACTION_CURRENT_STATUS then   --//当前世界答题状态
	    AnswerGuess.answerState(MSG_tInfo3.initWithStream(dt))
	elseif action == MSG_QUIZ_ACTION_RANK_INFO then     --//答题排行榜
	    AnswerGuess.answerList(MSG_tInfo4.initWithStream(dt))
	elseif action == MSG_QUIZ_ACTION_CUR_RANK then      --//玩家自身排名
	    AnswerGuess.playerRanking(MSG_tInfo5.initWithStream(dt))
	elseif action == MSG_QUIZ_ACTION_CLOSE_QUIZ then
	    AnswerGuess.exitQuestion()
	end
end

----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(recvAnswerGuessInfo, _MSG_QUIZGAME, 0, nil)

----------------全局函数区----------------
function AnswerGuess.showAnswerGuessWnd()
	AnswerGuess.openAnswerGuessWnd = 0
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_JION_WORLD_EVENT)
    dataStream:writeShort(4)
    dataStream:writeByte(1)
    SCDataTransThread:getSingleton():transData(dataStream)
    --SCActivityIndicator:getSingleton():show()
    
end

function AnswerGuess.wndCloss()
	--AnswerGuess.allAnswerList = {}
    --AnswerGuess.questionNum = nil
    AnswerGuess.pDragNode100 = nil
    AnswerGuess.pDragNode200 = nil
    AnswerGuess.pDragNode300 = nil
    AnswerGuess.pDragNode400 = nil
    AnswerGuess.pDragNode500 = nil
    AnswerGuess.pLable4 = nil
    
end

--函数调用