GUIDE_TYPE_RECEIVE_QUEST		= 1000--//接受任务
GUIDE_TYPE_INST				= 1001--//副本引导
GUIDE_TYPE_OVER_QUEST			= 1002--//完成任务引导

GUIDE_TYPE_FORMAT_1			= 1003--//布阵学天赋
GUIDE_TYPE_FORMAT_2			= 1004--//布阵拉人
GUIDE_TYPE_FORMAT_3			= 1005--//布阵换技能

GUIDE_TYPE_RECEIVE_MAINQUEST		= 1006--//接受主线任务
GUIDE_TYPE_AUTOINST				= 1007--//自动副本
GUIDE_TYPE_OVER_MAINQUEST			= 1008--//完成主线任务引导

GUIDE_TYPE_CHANGEJOB			= 90--//转职
GUIDE_TYPE_STRENGTHEN			= UNLOCK_TYPE_EQUIP_STRENGTHEN--//强化新手引导
GUIDE_TYPE_ATTR_TRAIN			= UNLOCK_TYPE_TRAIN--//属性培养
GUIDE_TYPE_BOOK				= UNLOCK_TYPE_BOOK--//修炼
GUIDE_TYPE_SKILL				= UNLOCK_TYPE_SKILL--//冥想
GUIDE_TYPE_BUY_PHYSICAL_POWER	= UNLOCK_TYPE_BUY_PHYSICAL_POWER--//购买体力
GUIDE_TYPE_MONEY_SYMBOL		= UNLOCK_TYPE_MONEY_SYMBOL--//点击神符
GUIDE_TYPE_HELPER				= UNLOCK_TYPE_HELPER--//小助手	
GUIDE_TYPE_AREAN				= UNLOCK_TYPE_AREAN--//竞技场
GUIDE_TYPE_MORECOPY			= UNLOCK_TYPE_EXTRA31 --//多人副本
GUIDE_TYPE_SEED				= UNLOCK_TYPE_SEED--//魔豆
GUIDE_TYPE_COLLECTMONEY		= UNLOCK_TYPE_COLLECTMONEY--//领取奖励
GUIDE_TYPE_PVPBATTLE			= UNLOCK_TYPE_PVPBATTLE--//大乱斗
GUIDE_TYPE_WOLRD_BOSS			= UNLOCK_TYPE_WOLRD_BOSS--//世界BOSS
GUIDE_TYPE_RANK				= UNLOCK_TYPE_RANK--//排行榜
GUIDE_TYPE_HERO_COPY			= UNLOCK_TYPE_HERO_COPY--//英雄副本
GUIDE_TYPE_HUNT				= UNLOCK_TYPE_HUNT--//占卜
GUIDE_TYPE_FLOWER				= UNLOCK_TYPE_FLOWER--//送花
GUIDE_TYPE_GUILD				= UNLOCK_TYPE_NORMAL_WORK--//公会
GUIDE_TYPE_3V3				= UNLOCK_TYPE_3V3--	//3V3功能
GUIDE_TYPE_RECRUITPARTNER		= UNLOCK_TYPE_RECRUITPARTNER--//伙伴邀请
GUIDE_TYPE_TALENT             = UNLOCK_TYPE_USER_TALENT  --天赋
GUIDE_TYPE_ELFGUARD           = UNLOCK_TYPE_ELFGUARD  --精灵守护
GUIDE_TYPE_LIBRARY			= UNLOCK_TYPE_LIBRARY  --资料馆
GUIDE_TYPE_BUDDHIST_SCRIPTURES	= UNLOCK_TYPE_BUDDHIST_SCRIPTURES  --护戒使者


local Right_Direction = 1
local Left_Direction = 2
local Top_Direction = 3
local Bottom_Direction = 4


local m_stepInfo = {}
local m_dailogs = {}
local m_inmainData = {}
local m_typeTmp = 0
local m_dailogsStepTmp = nil
local m_nowType = nil
local m_pauseFlag = false

--结束引导
local function sendEndGuideMsg(type)
	local USERINFO_GUIDE_BEGIN	 = 79
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_GUIDE_BEGIN)
    dataStream:writeInt(type)
    SCDataTransThread:getSingleton():transData(dataStream)
end

local initStep
local formation2
local formation3
local function clearGuideData(type)
	sendEndGuideMsg(type)
	m_stepInfo[type] = nil
	m_dailogs[type] = nil

	local mainNode = getMainInterface()
	if mainNode then
		local guideNode = tolua.cast(mainNode:getChildByTag(5924), "GuideMaskNode")
		if guideNode then
			guideNode:removeGuidePoint(type)
			m_inmainData = {}
			guideNode:removeChildByTag(10000, true)
		end
	end
end

local function onClickCloseDialogNode(tag)
	if m_dailogsStepTmp and m_nowType then
		m_dailogs[m_nowType][m_dailogsStepTmp] = nil
		m_dailogsStepTmp = nil
		m_nowType = nil
	end
	local mainNode = getMainInterface()
	if mainNode then
		local guideNode = tolua.cast(mainNode:getChildByTag(5924), "GuideMaskNode")
		if guideNode then
			guideNode:removeChildByTag(10000, true)
		end
	end
	local mapLayer = getMapLayer()
    if not mapLayer then
		return
    end
	local scene = tolua.cast(mapLayer:getParent(), "GameScene")
	if scene then
		local node = scene:getUINode()
		if node then
			local guideNode = tolua.cast(mainNode:getChildByTag(5919), "GuideMaskNode")
			if guideNode then
				guideNode:removeChildByTag(10000, true)
			end
		end
	end
end

local function getDialogNode(dialogInfo)
	if 1 then
		return
	end
	if not dialogInfo or dialogInfo.showFlag == 0 then
		return
	end
	local dialogNode = SCNode:node()
	if not dialogNode then
		return
	end
	setNodeContentSize(dialogNode, CCSizeMake(480, 320))
--[[	dialogNode:setContentSize(CCSizeMake(getScreenWidth(), getScreenHeight()))
	local faceNode = SCTypeCast:castNodeToButton(SCFunction:getUiById(5924))
	if not faceNode then
		return
	end
	faceNode:luaSetSelectorOnClicked(onClickCloseDialogNode)--]]
	local filePath = getRealUIResourcePath("PlotPhoto/4100011.png")
	if not filePath then
		return
	end
	local faceNode = SCButton:button()
	if not faceNode then
		return
	end
	faceNode:setTitle(filePath:getData())
	faceNode:luaSetSelectorOnClicked(onClickCloseDialogNode)
	--[[
	local faceNode = SCImage:imageWithFile(filePath:getData())
	if not faceNode then
		return
	end
	]]
	dialogNode:addChild(faceNode, 1)

	local filePath = getRealUIResourcePath("img/img5048.png")
	if not filePath then
		return
	end
	local nameNode = SCImage:imageWithFile(filePath:getData())
	if not nameNode then
		return
	end
	dialogNode:addChild(nameNode)
	local nameLabel = SCLabel:labelWithStringFont(_LTParser("str5099"), getDefaultFontName(), getFontSize(12))
	if not nameLabel then
		return
	end
	nameLabel:setColor(color_red)
	nameLabel:setAnchorPoint(CCPointMake(0.5, 0.5))
	setNodePostion(nameLabel, CCPointMake(getNodeContentSize(nameNode).width/2, getNodeContentSize(nameNode).height/2))
	nameNode:addChild(nameLabel)
	local filePath = getRealUIResourcePath("img/img5047.png")
	if not filePath then
		return
	end
	local backNode = SCImage:imageWithFile(filePath:getData())
	if not backNode then
		return
	end
	backNode:setBackgroundColor(ccc4(0,0,0,160))
	dialogNode:addChild(backNode)
	local textNode = SCTextBox:boxWithWidthHeightFont(307*gUIScale().x, 65*gUIScale().y, getDefaultFontName(), getFontSize(12))
	if not textNode then
		return
	end
	textNode:setParserDelegate(TextParser:getSingleton());
	textNode:setScrollVertical(false);
	textNode:setAnchorPoint(CCPointMake(0.5, 0.5))
	setNodePostion(textNode, CCPointMake(getNodeContentSize(backNode).width/2+20, getNodeContentSize(backNode).height/2))
	textNode:setText(dialogInfo.guideWord)
	backNode:addChild(textNode)
	if dialogInfo.pos == 0 then
		setNodePostion(faceNode, CCPointMake(0, 0))
		setNodePostion(backNode, CCPointMake(getNodeContentSize(faceNode).width-50, 0))
		setNodePostion(nameNode, CCPointMake(getNodeContentSize(faceNode).width-50, getNodeContentSize(backNode).height))
	else
		faceNode:setAnchorPoint(CCPointMake(0, 1))
		setNodePostion(faceNode, CCPointMake(0, getNodeContentSize(dialogNode).height))
		setNodePostion(backNode, CCPointMake(getNodeContentSize(faceNode).width-50, getNodeContentSize(dialogNode).height-getNodeContentSize(faceNode).height))
		setNodePostion(nameNode, CCPointMake(getNodeContentSize(faceNode).width-50, getNodeContentSize(backNode).height+getNodePostion(backNode).y))
	end
	return dialogNode
end

local function guideBefore()
	if m_pauseFlag then
		return
	end
	local inter = getMainInterface() 
	if not inter then
		return
	end
	local naviCtrl = getCurentSceneNavigationController()
	if not naviCtrl then
		return
	end
	naviCtrl:removeAllWindowControllers()
end

local function showGuideNextStep(type, step, dailogStep)
	if not m_stepInfo[type] then
		return
	end
    local mapLayer = getMapLayer()
    if not mapLayer then
		return
    end
	local scene = tolua.cast(mapLayer:getParent(), "GameScene")
	if not scene then
		return
	end
	
	--if step == 1 or (step==2 and m_stepInfo[type][1]==nil) then
	--	guideBefore()
	--end
	endGuideWnd()
	
	if step == 0 then
		return
	end
	
	m_dailogsStepTmp = dailogStep
	m_nowType = type
	if m_dailogsStepTmp and m_nowType then
		m_dailogs[m_nowType][m_dailogsStepTmp-1] = nil
	end
	if step == -1 then
		clearGuideData(type)
		return
	end
	
	if not m_stepInfo[type] or not m_stepInfo[type][step] then
		return
	end
	if m_stepInfo[type][step].sendEndFlag then
		sendEndGuideMsg(type)
	end
	local addBtnFlag = false
	local rect = {m_stepInfo[type][step].rect[1], m_stepInfo[type][step].rect[2], m_stepInfo[type][step].rect[3], m_stepInfo[type][step].rect[4]}
	if rect[1]==0 and rect[2]==0 and rect[3]==0 and rect[4]==0 then
		local node = nil
		local parNode = nil
		local idTab = Split(m_stepInfo[type][step].strlist, "-")
		node = scene:getUINode():getChildByTag(idTab[1])
		for i=2, #idTab do
			if not node then
				return
			end
			node = node:getChildByTag(idTab[i])
		end
		if not node then
			return
		end
		parNode = node:getParent()
		if not parNode then
			return
		end
		if idTab[1]+0 == 5201 then
			addBtnFlag = true
			local pAni = LookfaceParser:getSingleton():getAnimationByIndex(1102, 1143)
			if pAni then
				local pAniNode = SCAnimationNode:nodeWithAnimation(pAni);
				pAniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
				pAniNode:setPosition(CCPointMake(-pAniNode:getContentSize().width/2, node:getContentSize().height/2))
				node:addChild(pAniNode);
			end
		end
		local anchorPoint = node:getAnchorPoint()
		if anchorPoint.x==0 then
			rect[1] = parNode:convertToWorldSpace(node:getPosition()).x/gUIScale().x
		elseif anchorPoint.x==1 then
			rect[1] = parNode:convertToWorldSpace(node:getPosition()).x/gUIScale().x-getNodeContentSize(node).width
		else
			rect[1] = parNode:convertToWorldSpace(node:getPosition()).x/gUIScale().x-getNodeContentSize(node).width/2
		end
		if anchorPoint.y==0 then
			rect[2] = parNode:convertToWorldSpace(node:getPosition()).y/gUIScale().y
		elseif anchorPoint.y==1 then
			rect[2] = parNode:convertToWorldSpace(node:getPosition()).y/gUIScale().y-getNodeContentSize(node).height
		else
			rect[2] = parNode:convertToWorldSpace(node:getPosition()).y/gUIScale().y-getNodeContentSize(node).height/2
		end
		rect[3] = getNodeContentSize(node).width
		rect[4] = getNodeContentSize(node).height
	else
		rect[1] = rect[1] + (getScreenWidth()/gUIScale().x - 480) / 2
		rect[2] = rect[2] + (getScreenHeight()/gUIScale().y - 320) / 2
		if m_stepInfo[type][step].reSize then
			m_stepInfo[type][step].reSize[1] = m_stepInfo[type][step].reSize[1] + (getScreenWidth()/gUIScale().x - 480) / 2
			m_stepInfo[type][step].reSize[2] = m_stepInfo[type][step].reSize[2] + (getScreenHeight()/gUIScale().y - 320) / 2
		end
		if m_stepInfo[type][step].fromTo then
			m_stepInfo[type][step].fromTo[1] = m_stepInfo[type][step].fromTo[1] + (getScreenWidth()/gUIScale().x - 480) / 2
			m_stepInfo[type][step].fromTo[2] = m_stepInfo[type][step].fromTo[2] + (getScreenHeight()/gUIScale().y - 320) / 2
			m_stepInfo[type][step].fromTo[3] = m_stepInfo[type][step].fromTo[3] + (getScreenWidth()/gUIScale().x - 480) / 2
			m_stepInfo[type][step].fromTo[4] = m_stepInfo[type][step].fromTo[4] + (getScreenHeight()/gUIScale().y - 320) / 2
		end
	end
	if m_stepInfo[type][step].inMainFlag then
		local mainNode = getMainInterface()
		if mainNode then
			local guideNode = tolua.cast(mainNode:getChildByTag(5924), "GuideMaskNode")
			if not guideNode then
				for i=1, #m_inmainData do
					if m_inmainData[i][1] == rect[1] and m_inmainData[i][2] == rect[2] then
						return
					end
				end
				guideNode = GuideMaskNode:newGuideMaskNode(CCRectMake(rect[1], rect[2], rect[3], rect[4]), type, m_stepInfo[type][step].dir)
				guideNode:setTag(5924)
				mainNode:addChild(guideNode, 2)
				table.insert(m_inmainData, rect)
			else
				guideNode:removeGuidePoint(type)
				for i=1, #m_inmainData do
					if m_inmainData[i][1] == rect[1] and m_inmainData[i][2] == rect[2] then
						return
					end
				end
				guideNode:addGuidePoint(CCRectMake(rect[1], rect[2], rect[3], rect[4]), type, m_stepInfo[type][step].dir)
				table.insert(m_inmainData, rect)
			end
			guideNode:removeChildByTag(10000, true)
			if dailogStep and dailogStep > 0 and not m_stepInfo[type][step].notShowDialog then
				if m_dailogs[type] then
					local node = getDialogNode(m_dailogs[type][dailogStep])
					if node then
						m_dailogs[type][dailogStep] = nil
						node:setTag(10000)
						guideNode:addChild(node)
					end
				end
			end
		end
	else
		local mainNode = getMainInterface()
		if mainNode then
			local guideNode = tolua.cast(mainNode:getChildByTag(5924), "GuideMaskNode")
			if guideNode then
				guideNode:removeGuidePoint(type)
				guideNode:removeChildByTag(10000, true)
				m_inmainData = {}
			end
		end
		local guideNode = GuideMaskNode:newGuideMaskNode(CCRectMake(rect[1], rect[2], rect[3], rect[4]), type, m_stepInfo[type][step].dir)
		if guideNode then
			if addBtnFlag then
				guideNode:removeAllChildrenWithCleanup(true)
			end
			scene:getUINode():addChild(guideNode, Max_Int, 5919)
			if m_stepInfo[type][step].fromTo then
				guideNode:moveFromTo(CCPointMake(m_stepInfo[type][step].fromTo[1]*gUIScale().x, m_stepInfo[type][step].fromTo[2]*gUIScale().y), CCPointMake(m_stepInfo[type][step].fromTo[3]*gUIScale().x, m_stepInfo[type][step].fromTo[4]*gUIScale().y), m_stepInfo[type][step].fromTo[5], m_stepInfo[type][step].fromTo[6])
			elseif m_stepInfo[type][step].reSize then
				guideNode:resetArrowPosition(CCPointMake(m_stepInfo[type][step].reSize[1]*gUIScale().x, m_stepInfo[type][step].reSize[2]*gUIScale().y))
			end
			if dailogStep and dailogStep > 0 then
				if m_dailogs[type] then
					local node = getDialogNode(m_dailogs[type][dailogStep])
					if node then
						m_dailogs[type][dailogStep] = nil
						node:setTag(10000)
						guideNode:addChild(node)
					end
				end
			end
		end
	end
end

--是否要点击显示底下的按钮
local function isClickBottomHideButton(enumType)
	if getIsBottomButtonHide() then
		local tmp = {}
		tmp.strlist = "5918-5931"	--idlist
		tmp.rect = {0, 0, 0, 0}
		tmp.dir = Right_Direction
		tmp.inMainFlag = true
		tmp.notShowDialog = true
		table.insert(m_stepInfo[enumType], 1, tmp)
	end
end
--是否要点击显示上面的按钮
local function isClickTopHideButton(enumType)
	if getIsTopButtonHide() then
--[[		local tmp = {}
		tmp.strlist = "5918-5932-1001"	--idlist
		tmp.rect = {0, 0, 0, 0}
		tmp.dir = Right_Direction
		tmp.inMainFlag = true
		tmp.notShowDialog = true
		table.insert(m_stepInfo[enumType], 1, tmp)--]]
	end
end
--是否要点击隐藏上面的按钮
local function isClickTopShowButton(enumType)
	if not getIsTopButtonHide() then
		local tmp = {}
		tmp.strlist = "5918-5932-1001"	--idlist
		tmp.rect = {0, 0, 0, 0}
		tmp.dir = Right_Direction
		tmp.inMainFlag = true
		tmp.notShowDialog = true
		table.insert(m_stepInfo[enumType], 1, tmp)
	end
end

--完成任务引导
function overTask(enumType)
	--1、点击引导按钮
	local tmp = {}
	tmp.strlist = "5918-5932-1007"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Top_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
	--2、点击任务
	local tmp = {}
	tmp.strlist = "5501-200-6-5"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 2, tmp)
end

--副本引导1
function copyGuide(enumType)
	isClickBottomHideButton(enumType)
	--1、点击世界按钮
	local tmp = {}
	tmp.strlist = "5918-5934-1003"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--2、点击古树山脉
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {105, 97, 98, 112}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 3, tmp)
	--3、点击野狼深林
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {42, 55, 132, 60}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	--4、进入副本
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {15, 183, 82, 82}
	tmp.dir = Top_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
	--5、奖励
	local tmp = {}
	tmp.strlist = "2025-2025-30"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 6, tmp)
	--6、关副本窗口
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {435, 275, 40, 40}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 7, tmp)
	--7、关地图窗口
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {436, 278, 26, 26}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 8, tmp)
end

--接受任务引导
local function startTask(enumType)
	--1、点击引导按钮
	local tmp = {}
	tmp.strlist = "5918-5932-1007"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Top_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
	--2、点击任务
	local tmp = {}
	tmp.strlist = "5501-200-6-5"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 2, tmp)
end

--完成主线任务引导
function overMainTask(enumType)
	--1、点击引导按钮
	local tmp = {}
	tmp.strlist = "5918-5932-1007"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Top_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
	--2、点击任务
	local tmp = {}
	tmp.strlist = "5501-200-6-5"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 2, tmp)
end

--快速副本引导
function autoCopyGuide(enumType)
	--1、点击引导按钮
	local tmp = {}
	tmp.strlist = "5918-5932-1007"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Top_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
	--2、点击任务
	local tmp = {}
	tmp.strlist = "5917"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 2, tmp)
	
end

--接受主线任务引导
local function startMainTask(enumType)
	--1、点击引导按钮
	local tmp = {}
	tmp.strlist = "5918-5932-1007"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Top_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
	--2、点击任务
	local tmp = {}
	tmp.strlist = "5501-200-6-5"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 2, tmp)
end

--强化引导
local function strengthen(enumType)
	isClickBottomHideButton(enumType)
	--1、点击强化按钮
	local tmp = {}
	tmp.strlist = "5918-5933-1"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--2、点击确定强化
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {317, 29, 90, 32}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 3, tmp)
	--3、关窗口
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {435, 275, 40, 40}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
end

--属性培养
local function train(enumType)
	isClickBottomHideButton(enumType)
	--1、点击人物
	local tmp = {}
	tmp.strlist = "5918-5933-1001"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--2、点击培养
	local tmp = {}
	tmp.strlist = "2011-9999-5000"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 3, tmp)
	--3、开始培养
	local tmp = {}
	tmp.strlist = "2011-9999-1009-1009-25"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	--保存
	local tmp = {}
	tmp.strlist = "2011-9999-1009-1009-5"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
end

--修炼引导
local function practice(enumType)
	isClickBottomHideButton(enumType)
	--1、点击修行
	local tmp = {}
	tmp.strlist = "5918-5933-1004"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--2、点击修炼
	local tmp = {}
	tmp.strlist = "5918-5933-5914-4"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 3, tmp)
	--3、升级技能
	local tmp = {}
	tmp.strlist = "8009-800901-1-1-1-1"	--idlist
	--tmp.rect = {134, 224, 24, 24}
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	--4、关窗口
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {435, 275, 40, 40}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
end

--冥想引导
local function meditation(enumType)
	isClickBottomHideButton(enumType)
	--1、点击冥想
	local tmp = {}
	tmp.strlist = "5918-5933-5"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
end

--购买体力
local function buyPower(enumType)
	isClickTopShowButton(enumType)
	--1、点击购买体力
	local tmp = {}
	tmp.strlist = "5918-5936-1-9-1"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Left_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
end

--点金神符
local function moneySymbol(enumType)
	isClickTopShowButton(enumType)
	--1、点击点金卷轴
	local tmp = {}
	tmp.strlist = "5918-5936-1-8-1"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Left_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
end

--小助手
local function smallHelper(enumType)
	--1、点击小助手
	local tmp = {}
	tmp.strlist = "5918-5932-87"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
end

--竞技场
local function arene(enumType)
	--1、点击小助手
	local tmp = {}
	tmp.strlist = "5918-5932-87"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
	--2、点击世界活动
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {330, 275, 80, 25}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 2, tmp)
	--3、进入竞技场
	local tmp = {}
	tmp.strlist = "5201-1-3-401-1-2-2"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 3, tmp)
	--4、挑战玩家
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {120, 40, 62, 62}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	--5、开始战斗
	local tmp = {}
	tmp.strlist = "5920-1-1"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
	--6、关闭窗口
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {435, 275, 40, 40}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 6, tmp)
end

--多人副本
local function moreCopy(enumType)
	--1、点击小助手
	local tmp = {}
	tmp.strlist = "5918-5932-87"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
	--2、点击世界活动
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {330, 275, 80, 25}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 2, tmp)
	--3、进入多人副本
	local tmp = {}
	tmp.strlist = "5201-1-3-401-1-7-7"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 3, tmp)
	--4、创建副本
	local tmp = {}
	tmp.strlist = "2036-100-5"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	--5、确认创建副本
	local tmp = {}
	tmp.strlist = "2037-1-0-0"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
end

--魔豆
local function magicBean(enumType)
	isClickTopHideButton(enumType)
	--1、点击功能
	local tmp = {}
	tmp.strlist = "5918-5932-1002"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--2、点击查看魔豆
	local tmp = {}
	tmp.strlist = "5913-2-79-79"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 3, tmp)
	--3、种植魔豆
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {290, 50, 45, 75}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	--4、选择金豆
	local tmp = {}
	tmp.strlist = "1011-5921-1"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
	local tmp = {}
	tmp.strlist = ""	--idlist
	tmp.rect = {1, 1, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 6, tmp)
	--5、点击种植
	local tmp = {}
	tmp.strlist = "1011-10086-1"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 7, tmp)
	--6、关闭窗口
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {445, 290, 20, 20}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 8, tmp)
end

--领取奖励
local function collectMoney(enumType)
	isClickTopHideButton(enumType)
	--1、点击领取奖励
	local tmp = {}
	tmp.strlist = "5918-5932-66"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Top_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
end

--大乱斗
local function PVEBattle(enumType)
	--1、点击小助手
	local tmp = {}
	tmp.strlist = "5918-5932-87"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
	--2、点击世界活动
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {330, 275, 80, 25}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 2, tmp)
end

--世界boss
local function worldBoss(enumType)
	--1、点击小助手
	local tmp = {}
	tmp.strlist = "5918-5932-87"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
	--2、点击世界活动
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {330, 275, 80, 25}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 2, tmp)
end

--排行榜
local function rank(enumType)
	--1、点击排行榜
	local tmp = {}
	tmp.strlist = "5918-5932-83"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
end

local function heroCopy(enumType)
	isClickTopHideButton(enumType)
	--1、点击挑战
	local tmp = {}
	tmp.strlist = "5918-5932-1003"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--2、点击英雄副本
	local tmp = {}
	tmp.strlist = "5913-2-68-68"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 3, tmp)
	--3、进入副本
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {20, 135, 82, 82}
	tmp.dir = Top_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
end

--占卜
local function hunt(enumType)
	isClickBottomHideButton(enumType)
	--1、点击修行
	local tmp = {}
	tmp.strlist = "5918-5933-1004"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--2、点击占卜
	local tmp = {}
	tmp.strlist = "5918-5933-5914-15"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 3, tmp)
	--3、前往占卜
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {315, 20, 74, 30}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	
	local tmp = {}
	tmp.strlist = "2013-1"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Bottom_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
	
	--[[
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {5, 231, 45, 60}
	tmp.dir = Bottom_Direction
	table.insert(m_stepInfo[enumType], 6, tmp)
	]]
	
	local tmp = {}
	tmp.strlist = "2013-23"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 6, tmp)
end

--送花
local function flower(enumType)
	isClickBottomHideButton(enumType)
	--1、点击人物
	local tmp = {}
	tmp.strlist = "5918-5933-1001"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--2、点击送花
	local tmp = {}
	tmp.strlist = "2011-9999-5001"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 3, tmp)
end

--公会
local function normalWork(enumType)
	isClickBottomHideButton(enumType)
	--1、点击社交
	local tmp = {}
	tmp.strlist = "5918-5933-1005"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--2、点击公会
	local tmp = {}
	tmp.strlist = "5918-5933-5914-11"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 3, tmp)
end

--3V3
local function threeVSThree(enumType)
	--1、点击小助手
	local tmp = {}
	tmp.strlist = "5918-5932-87"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
	--2、点击世界活动
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {330, 275, 80, 25}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 2, tmp)
end

--伙伴招募
local function getPartner(enumType)
	--1、点击引导按钮，找到酒馆
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {10000, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
	--2、进入伙伴招募界面
	local tmp = {}
	tmp.strlist = "5501-200-6-6"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 2, tmp)
	local tmp = {}
	tmp.strlist = "5501-200-6-5"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 3, tmp)
	--3、招募伙伴
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {58, 33, 90, 32}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	--6、关闭窗口
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {435, 275, 40, 40}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
end
--阵型
local function formation1(enumType)
	isClickBottomHideButton(enumType)
	--1、点击修行
	local tmp = {}
	tmp.strlist = "5918-5933-1004"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--2、点击天赋
	local tmp = {}
	tmp.strlist = "5918-5933-5914-80"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Bottom_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 3, tmp)
	--3、学习天赋
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {44, 75, 66, 60}
	tmp.dir = Bottom_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	--4、关闭天赋窗口
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {435, 275, 40, 40}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
end
function formation2(enumType)
	isClickBottomHideButton(enumType)
	--5、点击布阵
	local tmp = {}
	tmp.strlist = "5918-5933-2"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--6、开始布阵
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {0, 0, 480, 270}
	tmp.dir = Right_Direction
	tmp.fromTo = {51, 212, 330, 133, 2, true}
	table.insert(m_stepInfo[enumType], 3, tmp)
	--10、关闭阵型窗口
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {435, 275, 40, 40}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
end
function formation3(enumType)
	isClickBottomHideButton()
	if not m_stepInfo then
		m_stepInfo = {}
	end
	--5、点击布阵
	local tmp = {}
	tmp.strlist = "5918-5933-2"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--7、点击切换技能按钮
	local tmp = {}
	tmp.strlist = "5601-24"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Bottom_Direction
	table.insert(m_stepInfo[enumType], 3, tmp)
	--8、选择技能
	local tmp = {}
	tmp.strlist = "7006-100-3-1-1"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	--9、切换按钮
	local tmp = {}
	tmp.strlist = "7006-100-1"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
	--10、关闭阵型窗口
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {435, 275, 40, 40}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 6, tmp)
end
--天赋
local function talent(enumType)
	isClickBottomHideButton(enumType)
	--1、点击修行
	local tmp = {}
	tmp.strlist = "5918-5933-1004"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--2、点击天赋
	local tmp = {}
	tmp.strlist = "5918-5933-5914-80"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Bottom_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 3, tmp)
	--3、学习天赋
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {106, 17, 66, 60}
	tmp.dir = Bottom_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	--4、关闭天赋窗口
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {435, 275, 40, 40}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
end

local function changeJob(enumType)
	--1、点击引导按钮，找到圣女
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {10000, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
	--2、进入转职界面
	local tmp = {}
	tmp.strlist = "5501-200-6-6"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 2, tmp)
	local tmp = {}
	tmp.strlist = "5501-200-6-5"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 3, tmp)
	--3、点转职
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {42, 57, 60, 26}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	--4、再转职
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {210, 32, 60, 26}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
	--5、确认转职
	local tmp = {}
	tmp.strlist = "5903-2"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 6, tmp)
	--4、关闭窗口
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {435, 275, 40, 40}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 7, tmp)
end

local function elfguard(enumType)
	isClickBottomHideButton(enumType)
	--1、点击修行
	local tmp = {}
	tmp.strlist = "5918-5933-1004"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--2、点击精灵
	local tmp = {}
	tmp.strlist = "5918-5933-5914-76"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Bottom_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 3, tmp)
	--3、培养
	local tmp = {}
	tmp.strlist = "5904-0"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	--4、关闭窗口
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {435, 275, 40, 40}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
end

local function helpSystem(enumType)
	isClickTopHideButton(enumType)
	--1、点击功能
	local tmp = {}
	tmp.strlist = "5918-5932-1002"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 2, tmp)
	--2、点击查看资料馆
	local tmp = {}
	tmp.strlist = "5913-2-85-85"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 3, tmp)
end

local function buddhistScriptures(enumType)
	--1、点击小助手
	local tmp = {}
	tmp.strlist = "5918-5932-87"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	tmp.inMainFlag = true
	table.insert(m_stepInfo[enumType], 1, tmp)
	--2、点击世界活动
	local tmp = {}
	tmp.strlist = " "	--idlist
	tmp.rect = {330, 275, 80, 25}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 2, tmp)
	--3、进入护戒使者
	local tmp = {}
	tmp.strlist = "5201-1-3-401-1-4-4"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 3, tmp)
	--4、护戒设置界面
	local tmp = {}
	tmp.strlist = "5702-3"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 4, tmp)
	--5、开始护送
	local tmp = {}
	tmp.strlist = "5701-5"	--idlist
	tmp.rect = {0, 0, 0, 0}
	tmp.dir = Right_Direction
	table.insert(m_stepInfo[enumType], 5, tmp)
end

local function setStepInfo(enumType)
	if enumType == GUIDE_TYPE_RECEIVE_QUEST then
		--接受任务
		startTask(enumType)
		return
	end
	if enumType == GUIDE_TYPE_INST then
		--打副本
		copyGuide(enumType)
		return
	end
	if enumType == GUIDE_TYPE_OVER_QUEST then
		--完成任务
		overTask(enumType)
		return
	end
	if enumType == GUIDE_TYPE_RECEIVE_MAINQUEST then
		startMainTask(enumType)
		return
	end
	if enumType == GUIDE_TYPE_AUTOINST then
		autoCopyGuide(enumType)
		return
	end
	if enumType == GUIDE_TYPE_OVER_MAINQUEST then
		overMainTask(enumType)
		return
	end
	if enumType == GUIDE_TYPE_STRENGTHEN then
		--强化
		strengthen(enumType)
		return
	end
	if enumType == GUIDE_TYPE_ATTR_TRAIN then
		--属性培养
		train(enumType)
		return
	end
	if enumType == GUIDE_TYPE_BOOK then
		--修炼
		practice(enumType)
		return
	end
	if enumType == GUIDE_TYPE_SKILL then
		--冥想
		meditation(enumType)
		return
	end
	if enumType == GUIDE_TYPE_BUY_PHYSICAL_POWER then
		--购买体力
		buyPower(enumType)
		return
	end
	if enumType == GUIDE_TYPE_MONEY_SYMBOL then
		--点金神符
		moneySymbol(enumType)
		return
	end
	if enumType == GUIDE_TYPE_HELPER then
		--小助手
		smallHelper(enumType)
		return
	end
	if enumType == GUIDE_TYPE_AREAN then
		--竞技场
		arene(enumType)
		return
	end
	if enumType == GUIDE_TYPE_MORECOPY then
		--多人副本
		moreCopy(enumType)
		return
	end
	if enumType == GUIDE_TYPE_SEED then
		--魔豆
		magicBean(enumType)
		return
	end
	if enumType == GUIDE_TYPE_COLLECTMONEY then
		--领取奖励
		collectMoney(enumType)
		return
	end
	if enumType == GUIDE_TYPE_PVPBATTLE then
		--大乱斗
		PVEBattle(enumType)
		return
	end
	if enumType == GUIDE_TYPE_WOLRD_BOSS then
		--世界boss
		worldBoss(enumType)
		return
	end
	if enumType == GUIDE_TYPE_RANK then
		--排行榜
		rank(enumType)
		return
	end
	if enumType == GUIDE_TYPE_HERO_COPY then
		--英雄副本
		heroCopy(enumType)
		return
	end
	if enumType == GUIDE_TYPE_HUNT then
		--占卜
		hunt(enumType)
		return
	end
	if enumType == GUIDE_TYPE_FLOWER then
		--送花
		flower(enumType)
		return
	end
	if enumType == GUIDE_TYPE_GUILD then
		--公会
		normalWork(enumType)
		return
	end
	if enumType == GUIDE_TYPE_3V3 then
		--3V3
		threeVSThree(enumType)
		return
	end
	if enumType == GUIDE_TYPE_RECRUITPARTNER then
		--伙伴招募 
		getPartner(enumType)
		return
	end
	if enumType == GUIDE_TYPE_FORMAT_1 then
		--布阵1
		formation1(enumType)
		return
	end
	if enumType == GUIDE_TYPE_FORMAT_2 then
		--布阵2
		formation2(enumType)
		return
	end
	if enumType == GUIDE_TYPE_FORMAT_3 then
		--布阵3
		formation3(enumType)
		return
	end
	if enumType == GUIDE_TYPE_TALENT then
	    --天赋
	    talent(enumType)
		return
	end
	if enumType == GUIDE_TYPE_CHANGEJOB then
		--转职
		changeJob(enumType)
		--sendEndGuideMsg(enumType)
		return
	end
	if enumType == GUIDE_TYPE_ELFGUARD then
		--精灵守护
		elfguard(enumType)
		return
	end
	if enumType == GUIDE_TYPE_LIBRARY then
		--资料馆
		helpSystem(enumType)
		return
	end
	if enumType == GUIDE_TYPE_BUDDHIST_SCRIPTURES then
		--护戒使者
		buddhistScriptures(enumType)
		return
	end
end

function initStep(enumType)
	setStepInfo(enumType)
	if not getIsShowNewFunAnimation() and getMainInterface() then
		if m_stepInfo[enumType][1] then
			showGuideStep(enumType, 1, 1)
		else
			showGuideStep(enumType, 2, 1)
		end
	end
end

local function insertDailog(dailogs, dt)
	local usAmount = dt:readShort()
	for i=1, usAmount do
		local tmp = {}
		tmp.id = dt:readShort()
		tmp.showFlag = dt:readByte()
		tmp.pos = dt:readByte()
		local scStr = dt:readString()
		if scStr then
			tmp.guideWord = scStr:getData()
		else
			tmp.guideWord = ""
		end
		
		local scStr = dt:readString()
		if scStr then
			tmp.controlText = scStr:getData()
		else
			tmp.controlText = ""
		end
		local scStr = dt:readString()
		if scStr then
			tmp.featuresText = scStr:getData()
		else
			tmp.featuresText = ""
		end
		
		table.insert(dailogs, tmp)
	end
end

local function guideBeginData()
	local dt = LuaData:getSingleton():getDataTransStream()
	if not dt then
	    return
	end
	local nData = dt:readInt()
	if nData ~= 0 then
		m_typeTmp = nData
		m_dailogs[nData] = {}
		insertDailog(m_dailogs[m_typeTmp], dt)
		if m_stepInfo[nData] then
			return
		end
		
		if nData>=1006 and nData<=1008 then
			for i=1006, 1008 do
				if i~= nData then
					showGuideStep(i, -1)
				end
			end
		end
		m_stepInfo[nData] = {}
		initStep(nData)
	end
	if m_dailogs[m_typeTmp] then
		insertDailog(m_dailogs[m_typeTmp], dt)
	end
end

local function endGuideData()
	local dt = LuaData:getSingleton():getDataTransStream()
	if not dt then
	    return
	end
	local nData = dt:readInt()
	showGuideStep(nData, -1)
end

--LuaData:getSingleton():luaSetSelectorOnRecvData(guideBeginData, LuaData_USERINFO_GUIDE_BEGIN)
--LuaData:getSingleton():luaSetSelectorOnRecvData(endGuideData, LuaData_USERINFO_GUIDE_CLOSE)

function endGuideWnd()
    local mapLayer = getMapLayer()
    if mapLayer ~= nil then
        local scene = tolua.cast(mapLayer:getParent(), "GameScene")
		if not scene then
			return
		end
		if scene:getUINode():getChildByTag(5919) then
			scene:getUINode():removeChildByTag(5919, true)
		end
	end
end

function autoShowNextGuideStep(type)
	if type == nil then
		return
	end
	if getIsShowNewFunAnimation() then
		return
	end
	--showGuideNextStep(type)
end

function startBeginnerGuide()
	if m_stepInfo[type].nowStep == 0 then
		autoShowNextGuideStep()
	end
end

function restartAllBeginnerGuide()
	if not m_stepInfo then
		return
	end
	m_pauseFlag = false
	m_inmainData = {}
	for key, value in pairs(m_stepInfo) do
		if key and m_stepInfo[key] then
			m_stepInfo[key] = {}
			initStep(key)
		end
	end
end

function restartBeginnerGuide(type)
	restartAllBeginnerGuide()
	--[[
	if type == nil and step == nil then
		type = GuideManagement:getSingleton():getGuideTypeForLua()
	end
	if not type or not m_stepInfo[type] then
		return
	end
	setRestartGuideFlag(type, true)

	if m_stepInfo[type][1] then
		showGuideStep(type, 1, 1)
	else
		showGuideStep(type, 2, 1)
	end
	]]
end

function restartGuideStep(type)
	restartBeginnerGuide(type)
end

function showGuideStep(type, guideStep, dailogStep)
	if type == nil and step == nil then
		type = GuideManagement:getSingleton():getGuideTypeForLua()
		guideStep = GuideManagement:getSingleton():getGuideStepForLua()
		dailogStep = GuideManagement:getSingleton():getDailogStepForLua()
	end
	if not type or not m_stepInfo[type] then
		return
	end
	if getIsShowNewFunAnimation() then
		if guideStep == -1 then
			showGuideNextStep(type, guideStep, dailogStep)
		end
		return
	end
	showGuideNextStep(type, guideStep, dailogStep)
end

function setRestartGuideFlag(type, flag)
	if type == nil and flag == nil then
		type = GuideManagement:getSingleton():getGuideTypeForLua()
		flag = GuideManagement:getSingleton():getRestartFlagForLua()
	end
	if not type or not m_stepInfo[type] then
		return
	end
	m_stepInfo[type].restartFlag = flag
end
function setGuideRestartFlag(type, flag)
	setRestartGuideFlag(type, flag)
end
function getRestartGuideFlag(type)
	local tf = false
	if type == nil then
		tf = true
		type = GuideManagement:getSingleton():getGuideTypeForLua()
	end
	if not type or not m_stepInfo[type] then
		return
	end
	if tf then
		GuideManagement:getSingleton():setRestartFlagForLua(m_stepInfo[type].restartFlag)
		return
	end
	return m_stepInfo[type].restartFlag
end
function getGuideRestartFlag(type)
	return getRestartGuideFlag(type)
end
function isGuideCanStart(type)
	local tf = false
	if type == nil then
		tf = true
		type = GuideManagement:getSingleton():getGuideTypeForLua()
	end
	if not type or not m_stepInfo[type] then
		if tf then
			GuideManagement:getSingleton():setRestartFlagForLua(false)
			return
		end
		return false
	end
	if tf then
		GuideManagement:getSingleton():setRestartFlagForLua(true)
		return
	end
	return true
end

function pauseAllGuide()
    local mapLayer = getMapLayer()
    if mapLayer ~= nil then
        local scene = tolua.cast(mapLayer:getParent(), "GameScene")
		if not scene then
			return
		end
		if scene:getUINode():getChildByTag(5919) then
			scene:getUINode():removeChildByTag(5919, true)
		end
	end
	local mainNode = getMainInterface()
	if mainNode then
		mainNode:removeChildByTag(5924, true)
	end
	m_pauseFlag = true
end

function clearDataWhileExitGame()
	m_stepInfo = {}
	m_dailogs = {}

	m_inmainData = {}
	m_typeTmp = 0
	m_dailogsStepTmp = nil
	m_nowType = nil
	m_pauseFlag = false
end