--定义一个与文件名相同的table
DuelTemple = {}
------------------消息--------------------

----------------结构定义区----------------
local stHeroInfoData = {    --自己信息
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		local self = {
            __mode = "kv",
        }
		
		self.idUser = dt:readInt();
		self.szName = dt:readString()
        if self.szName then
		    self.szName = self.szName:getData()
		else
		    self.szName = " "
		end
        self.nLev = dt:readInt();
        self.ucClan = dt:readByte();                     --职业  1.龙骑 2.剑舞 3.箭神 4.军师
        self.dwPoint = dt:readInt();                     --荣誉点
        self.dwTotalPoint = dt:readInt();                --最大荣誉点
        self.szMilitaryRank = dt:readString(); --军衔 
        if self.szMilitaryRank then
		    self.szMilitaryRank = self.szMilitaryRank:getData()
		else
		    self.szMilitaryRank = " "
		end
        self.nTotalTimes = dt:readInt();                 --总战斗次数
        self.nWinTimes = dt:readInt();                   --胜利次数
        self.nContinueWinTimes = dt:readInt();           --连胜次数 
        self.nSurplusTimes = dt:readInt();               --剩余可战斗次数 
        self.nFleeTimes = dt:readInt();			         --逃跑次数
        self.nPicture = dt:readInt();			         --军衔图标
		return self
	end
}

local stArenaHistory = {       --历史记录
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		local self = {
            __mode = "kv",
        }
		
        self.idBattle = dt:readInt();						--战斗ID
        self.szPastTime = dt:readString();		--战斗已过时间
        if self.szPastTime then
		    self.szPastTime = self.szPastTime:getData()
		else
		    self.szPastTime = " "
		end
        self.ucRiseFightFlag = dt:readByte();				--1:自己发起挑战
        self.idTarget = dt:readInt();						--目标ID
        self.szTargetName = dt:readString();	    --目标名字
        if self.szTargetName then
		    self.szTargetName = self.szTargetName:getData()
		else
		    self.szTargetName = " "
		end
        self.ucWinFlag = dt:readByte();						--1:胜利
        self.nOldRank = dt:readInt();						--旧排名
        self.nNewRank = dt:readInt();						--新排名
		return self
	end
}

local stPlayInfoData = {    --其它玩家信息
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		local self = {
            __mode = "kv",
        }
		
		self.idUser = dt:readInt();
		local szName = dt:readString();
		self.szName = "";
		if szName ~= nil then
		    self.szName = szName:getData();
		end
        self.nLev = dt:readInt();
        self.ucClan = dt:readByte();                     --职业
        self.dwPoint = dt:readInt();                     --荣誉点
        self.dwTotalPoint = dt:readInt();                --最大荣誉点
        self.szMilitaryRank = dt:readString();           --军衔 
        if self.szMilitaryRank then
		    self.szMilitaryRank = self.szMilitaryRank:getData()
		else
		    self.szMilitaryRank = " "
		end
        self.nTotalTimes = dt:readInt();                 --总战斗次数
        self.nWinTimes = dt:readInt();                   --胜利次数
        self.nContinueWinTimes = dt:readInt();           --连胜次数 
        self.nSurplusTimes = dt:readInt();               --剩余可战斗次数 
        self.nFleeTimes = dt:readInt();			         --逃跑次数
        self.nPicture = dt:readInt();
		return self
	end
}

----------------常量定义区----------------
local MSG_BUY_INSTANCE_TIME        = 2        --购买挑战次数
local ARENASCRITP_DUEL_USETINFO    = 48       --决斗战神殿玩家信息 
local ARENASCRITP_DUEL_LATELYINFO  = 49       --决斗战神殿最近5场战斗信息
local ARENASCRITP_DUEL_RIVALINFO   = 50       --决斗战神殿对手信息
local ARENASCRITP_DUEL_OPENPAIR    = 51       --决斗战神殿开始配对  
local ARENASCRITP_DUEL_CLOSEPAIR   = 52       --决斗战神殿取消配对 
local ARENASCRITP_DUEL_LEAVE       = 53       --离开战神殿 
local ARENASCRITP_DUEL_AWARD	   = 54       --获得奖励
local ARENASCRITP_DUEL_DAYMATCH    = 55       --刷新今日荣誉次数

----------------变量定义区----------------
local m_Value = 0;
local m_Flag = 0;
local m_HeroInfo = {};
local m_PlayInfo = {};
local m_HistoryInfo = {};

g_DuelTemple_bBuyTimes = false;
g_DuelTemple_bisOpen = false;
--变量的定义
----------------UI控制器区----------------
function DuelTemple.initControl()
	local pWindow4435 = SCWindow:window()
	if pWindow4435 then
		pWindow4435:setTag(4435)
		pWindow4435:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow4435:setPosition(AUTO_POS(0.00, 0.00))pWindow4435:setContentSize(AUTO_SIZE(480, 320))
		pWindow4435:luaSetSelectorOnClose(DuelTemple.releaseControl)
	end

	local imgPath = getRealUIResourcePath("pk/new00780.jp")
	local pImage1 = nil
	if imgPath then
		pImage1 = SCImage:imageWithFile(imgPath:getData())
		if pImage1 then
		    pImage1:setScaleX(SY(480) / pImage1:getContentSize().width)
			pImage1:setTag(1)
			pImage1:setAnchorPoint(ANCHOR_CENTER)
			pImage1:setPosition(AUTO_POS(240.00, 160.00))
		end
	end
	
	local imgPath = getRealUIResourcePath("img/img7033.pn")
	local pImage2 = nil
	if imgPath then
		pImage2 = SCImage:imageWithFile(imgPath:getData())
		if pImage2 then
			pImage2:setTag(2)
			pImage2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage2:setPosition(AUTO_POS(157.00, 147.00));
			pImage2:setScale(0.53);
		end
	end

	local imgPath = getRealUIResourcePath("img/img7032.jp")
	local pImage3 = nil
	if imgPath then
		pImage3 = SCImage:imageWithFile(imgPath:getData())
		if pImage3 then
			pImage3:setTag(3)
			pImage3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage3:setVisible(false)
			pImage3:setPosition(AUTO_POS(-66.00, 147.00))
		end
	end

	local imgPath = getRealUIResourcePath("pk/new00718.pn")
	local pImage4 = nil
	if imgPath then
		pImage4 = SCImage:imageWithFile(imgPath:getData())
		if pImage4 then
			pImage4:setTag(4)
			pImage4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage4:setPosition(AUTO_POS(190.00, 182.00))
		end
	end

	local pDragNode5 = SCDragNode:node()
	if pDragNode5 then
		pDragNode5:setTag(5)
		pDragNode5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode5:setPosition(AUTO_POS(0.00, 82.00))
		pDragNode5:setContentSize(AUTO_SIZE(191, 71))
		pDragNode5:setFrameVisibled(true)
		pDragNode5:setDragEnabled(false)
		pDragNode5:setFrameType(EnumFrameTypeLine)
	end

	local pButton6 = SCButton:button(EnumBtnType9Atlas)
	if pButton6 then
		pButton6:setTag(6)
		pButton6:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton6:setPosition(AUTO_POS(201.00, 95.00))
		pButton6:setContentSize(AUTO_SIZE(78, 44))
		pButton6:setTitle(L(" "), DEFAULT_FONT_NAME, F(15))
	end

	local pDragNode7 = SCDragNode:node()
	if pDragNode7 then
		pDragNode7:setTag(7)
		pDragNode7:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode7:setPosition(AUTO_POS(286.00, 82.00))
		pDragNode7:setContentSize(AUTO_SIZE(191, 71))
		pDragNode7:setFrameVisibled(true)
		pDragNode7:setDragEnabled(false)
		pDragNode7:setFrameType(EnumFrameTypeLine)
	end

	local pLable8 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable8 then
		pLable8:setTag(8)
		pLable8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable8:setPosition(AUTO_POS(24.00, 41.00))
		pLable8:setColor(ccc4(255,255,255,255))
	end

	local pLable9 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable9 then
		pLable9:setTag(9)
		pLable9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable9:setPosition(AUTO_POS(137.00, 41.00))
		pLable9:setColor(ccc4(255,255,255,255))
	end

	local pLable10 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable10 then
		pLable10:setTag(10)
		pLable10:setAnchorPoint(CCPointMake(0.5, 0))
		pLable10:setPosition(AUTO_POS(84.50, 18.00))
		pLable10:setColor(ccc4(255,255,255,255))
	end
	
	local pLable28 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable28 then
		pLable28:setTag(28)
		pLable28:setAnchorPoint(CCPointMake(0.5, 0))
		pLable28:setPosition(AUTO_POS(154.50, 18.00))
		pLable28:setColor(ccc4(255,255,255,255))
	end

	local pLable11 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable11 then
		pLable11:setTag(11)
		pLable11:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable11:setPosition(AUTO_POS(24.00, 41.00))
		pLable11:setColor(ccc4(255,255,255,255))
	end

	local pLable12 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable12 then
		pLable12:setTag(12)
		pLable12:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable12:setPosition(AUTO_POS(137.00, 41.00))
		pLable12:setColor(ccc4(255,255,255,255))
	end

	local pLable13 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable13 then
		pLable13:setTag(13)
		pLable13:setAnchorPoint(CCPointMake(0.5, 0))
		pLable13:setPosition(AUTO_POS(84.50, 18.00))
		pLable13:setColor(ccc4(255,255,255,255))
	end
	
	local pLable29 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable29 then
		pLable29:setTag(29)
		pLable29:setAnchorPoint(CCPointMake(0.5, 0))
		pLable29:setPosition(AUTO_POS(154.50, 18.00))
		pLable29:setColor(ccc4(255,255,255,255))
	end
	
	local pLable28 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable28 then
		pLable28:setTag(28)
		pLable28:setAnchorPoint(CCPointMake(0.5, 0))
		pLable28:setPosition(AUTO_POS(154.50, 18.00))
		pLable28:setColor(ccc4(255,255,255,255))
	end

	local pDragNode14 = SCDragNode:node()
	if pDragNode14 then
		pDragNode14:setTag(14)
		pDragNode14:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode14:setPosition(AUTO_POS(0.00, 48.00))
		pDragNode14:setContentSize(AUTO_SIZE(476, 40))
		pDragNode14:setFrameVisibled(true)
		pDragNode14:setDragEnabled(false)
		pDragNode14:setFrameType(EnumFrameTypeLine)
	end

	local pLable15 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable15 then
		pLable15:setTag(15)
		pLable15:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable15:setPosition(AUTO_POS(44.00, 14.00))
		pLable15:setColor(ccc4(255,255,255,255))
	end

	local imgPath = getRealUIResourcePath("rank/new00771.pn")
	local pImage16 = nil
	if imgPath then
		pImage16 = SCImage:imageWithFile(imgPath:getData())
		if pImage16 then
			pImage16:setTag(16)
			pImage16:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage16:setPosition(AUTO_POS(70.00, 11.00))
			pImage16:setVisible(false)
		end
	end

	local pLable17 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable17 then
		pLable17:setTag(17)
		pLable17:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable17:setPosition(AUTO_POS(87.00, 14.00))
		pLable17:setColor(ccc4(255,255,255,255))
	end

	local pLable18 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable18 then
		pLable18:setTag(18)
		pLable18:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable18:setPosition(AUTO_POS(168.00, 14.00))
		pLable18:setColor(ccc4(255,255,255,255))
	end
	
	local pLable26 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable26 then
		pLable26:setTag(26)
		pLable26:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable26:setPosition(AUTO_POS(208.00, 14.00))
		pLable26:setColor(ccc4(255,255,255,255))
	end

	local pLable19 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable19 then
		pLable19:setTag(19)
		pLable19:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable19:setPosition(AUTO_POS(313.00, 14.00))
		pLable19:setColor(ccc4(255,255,255,255))
	end
	
	local pLable27 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable27 then
		pLable27:setTag(27)
		pLable27:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable27:setPosition(AUTO_POS(397.00, 14.00))
		pLable27:setColor(ccc4(255,255,255,255))
	end

	local pDragNode20 = SCDragNode:node()
	if pDragNode20 then
		pDragNode20:setTag(20)
		pDragNode20:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode20:setPosition(AUTO_POS(1.00, 0.00))
		pDragNode20:setContentSize(AUTO_SIZE(406, 55))
		pDragNode20:setFrameVisibled(true)
		pDragNode20:setDragEnabled(false)
		pDragNode20:setFrameType(EnumFrameTypeLine)
	end

	local pButton21 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton21 then
		pButton21:setTag(21)
		pButton21:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton21:setPosition(AUTO_POS(405.00, 14.00))
		pButton21:setContentSize(AUTO_SIZE(70, 24))
		local imgPath = getRealUIResourcePath("pk/new00721.pn")
		if imgPath then
			pButton21:setTitle(imgPath:getData())
		end
	end

	local pButton22 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton22 then
		pButton22:setTag(22)
		pButton22:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton22:setPosition(AUTO_POS(13.00, 7.00))
		pButton22:setContentSize(AUTO_SIZE(46, 40))
		local imgPath = getRealUIResourcePath("MainInterfaceImg/5000.pn")
		if imgPath then
			pButton22:setTitle(imgPath:getData())
		end
	end

	local pListBox23 = SCListBox:boxWithWidthHeight(AUTO_W(313), AUTO_H(34))
	if pListBox23 then
		tolua.cast(pListBox23, "SCNode"):setTag(23)
		tolua.cast(pListBox23, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(pListBox23, "SCNode"):setPosition(AUTO_POS(73.00, 10.00))
	end

	local pButton24 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton24 then
		pButton24:setTag(24)
		pButton24:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton24:setPosition(AUTO_POS(428.00, 6.00))
		pButton24:setContentSize(AUTO_SIZE(14, 14))
		local imgPath = getRealUIResourcePath("img/new00308.pn")
		if imgPath then
			pButton24:setTitle(imgPath:getData())
		end
		pButton24:setVisible(false)
	end
	
	local pButton25 = SCButton:button()
	if pButton25 then
		pButton25:setTag(25)
		pButton25:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton25:setPosition(AUTO_POS(447.00, 289.00))
		pButton25:setContentSize(AUTO_SIZE(14, 14))
		local imgPath = getRealUIResourcePath("kernal/close-normal.pn")
		if imgPath then
			pButton25:setTitle(imgPath:getData())
		end
	end

	if pImage1 and pWindow4435 then
		pWindow4435:addChild(tolua.cast(pImage1, "SCNode"))
	end
	if pImage2 and pWindow4435 then
		pWindow4435:addChild(tolua.cast(pImage2, "SCNode"))
	end
	if pImage3 and pWindow4435 then
		pWindow4435:addChild(tolua.cast(pImage3, "SCNode"))
	end
	if pImage4 and pWindow4435 then
		pWindow4435:addChild(tolua.cast(pImage4, "SCNode"), 99)
	end
	if pDragNode5 and pWindow4435 then
		pWindow4435:addChild(tolua.cast(pDragNode5, "SCNode"))
	end
	if pButton6 and pWindow4435 then
		pWindow4435:addChild(tolua.cast(pButton6, "SCNode"))
	end
	if pDragNode7 and pWindow4435 then
		pWindow4435:addChild(tolua.cast(pDragNode7, "SCNode"), 100)
	end
	if pLable8 and pDragNode5 then
		pDragNode5:addChild(tolua.cast(pLable8, "SCNode"))
	end
	if pLable9 and pDragNode5 then
		pDragNode5:addChild(tolua.cast(pLable9, "SCNode"))
	end
	if pLable10 and pDragNode5 then
		pDragNode5:addChild(tolua.cast(pLable10, "SCNode"))
	end
	if pLable28 and pDragNode5 then
		pDragNode5:addChild(tolua.cast(pLable28, "SCNode"))
	end
	if pLable11 and pDragNode7 then
		pDragNode7:addChild(tolua.cast(pLable11, "SCNode"))
	end
	if pLable12 and pDragNode7 then
		pDragNode7:addChild(tolua.cast(pLable12, "SCNode"))
	end
	if pLable13 and pDragNode7 then
		pDragNode7:addChild(tolua.cast(pLable13, "SCNode"))
	end
	if pLable29 and pDragNode7 then
		pDragNode7:addChild(tolua.cast(pLable29, "SCNode"))
	end
	if pDragNode14 and pWindow4435 then
		pWindow4435:addChild(tolua.cast(pDragNode14, "SCNode"))
	end
	if pLable15 and pDragNode14 then
		pDragNode14:addChild(tolua.cast(pLable15, "SCNode"))
	end
	if pImage16 and pDragNode14 then
		pDragNode14:addChild(tolua.cast(pImage16, "SCNode"))
	end
	if pLable17 and pDragNode14 then
		pDragNode14:addChild(tolua.cast(pLable17, "SCNode"))
	end
	if pLable18 and pDragNode14 then
		pDragNode14:addChild(tolua.cast(pLable18, "SCNode"))
	end
	if pLable26 and pDragNode14 then
		pDragNode14:addChild(tolua.cast(pLable26, "SCNode"))
	end
	if pLable19 and pDragNode14 then
		pDragNode14:addChild(tolua.cast(pLable19, "SCNode"))
	end
	if pLable27 and pDragNode14 then
		pDragNode14:addChild(tolua.cast(pLable27, "SCNode"))
	end
	if pDragNode20 and pWindow4435 then
		pWindow4435:addChild(tolua.cast(pDragNode20, "SCNode"))
	end
	if pButton21 and pWindow4435 then
		pWindow4435:addChild(tolua.cast(pButton21, "SCNode"))
	end
	if pButton22 and pDragNode20 then
		pDragNode20:addChild(tolua.cast(pButton22, "SCNode"))
	end
	if pListBox23 and pDragNode20 then
		pDragNode20:addChild(tolua.cast(pListBox23, "SCNode"))
	end
	if pButton24 and pDragNode14 then
		pDragNode14:addChild(tolua.cast(pButton24, "SCNode"))
	end
	if pButton25 and pWindow4435 then
		pWindow4435:addChild(tolua.cast(pButton25, "SCNode"), 102)
	end
	return pWindow4435
end
function DuelTemple.releaseControl()
	if DuelTemple.wndClose then
		DuelTemple.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
local function ChatPro()
    ChatProcessor:getSingleton():pushChatController();
end

local function OkCheck(tag)
    if tag == 1 then
        DuelTemple_sendLeaveData();
        POP_TOP_CTRL();
    end
end

local function CloseWin()
    if m_Value == 1 then
        luashowConfirmationWindow(_LTParser("str0546"), WIN_YES_NO, OkCheck);
    else
        POP_TOP_CTRL();
    end
end

local function Specifications()    --玩法说明
    local wnd = SCFunction:getUiNodeByIdlist("4435");   --文本显示   可以换行
    if wnd and wnd:getChildByTag(10000) == nil then
        local pframeWnd = FrameWindow:frameWnd();
        if pframeWnd then
            pframeWnd:setTag(10000);
            pframeWnd:setContentSize(CCSizeMake(SX(360), SY(120)));
            pframeWnd:setAnchorPoint(CCPointMake(0.5, 0.5));
            pframeWnd:setPosition(CCPointMake(wnd:getContentSize().width / 2, wnd:getContentSize().height / 2 + SY(50)));
            local pParsedNode = SCTextBox:boxWithWidthHeight(SX(330), SY(80));
            if pParsedNode then
                pParsedNode:setParserDelegate(TextParser:getSingleton());
                pParsedNode:setText(L("str0513"));
                pParsedNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                pParsedNode:setPosition(CCPointMake(pframeWnd:getContentSize().width / 2, pframeWnd:getContentSize().height / 2));
                pframeWnd:addChild(pParsedNode);
            end
            wnd:addChild(pframeWnd, 101);
            pframeWnd:setCloseBtnVisible(false);
        end
    end
end

local function restart()
    local pWnd = SCFunction:getUiNodeByIdlist("4435");
    local pListBox = SCFunction:getUiNodeByIdlist("4435-50");
    if pListBox then
        pWnd:removeChild(pListBox, true); 
    end
    local imgPath = getRealUIResourcePath("img/img7033.pn")
    local imgPath1 = getRealUIResourcePath("img/img7036.pn")
    local imgPath2 = getRealUIResourcePath("img/img7035.pn")
    local imgPath3 = getRealUIResourcePath("img/img7034.pn")
	local pImage100 = nil
	local pImage200 = nil
	local pImage300 = nil
	local pImage400 = nil
	if imgPath and imgPath1 and imgPath2 and imgPath3 then
		pImage100 = SCImage:imageWithFile(imgPath:getData())
		pImage200 = SCImage:imageWithFile(imgPath1:getData())
		pImage300 = SCImage:imageWithFile(imgPath2:getData())
		pImage400 = SCImage:imageWithFile(imgPath3:getData())
		if pImage100 and pImage200 and pImage300 and pImage400 then
		    pImage100:setTag(1);
		    pImage200:setTag(2);
		    pImage300:setTag(3);
		    pImage400:setTag(4);
		    pImage100:setScale(0.53);
		    pImage200:setScale(0.53);
		    pImage300:setScale(0.53);
		    pImage400:setScale(0.53);
		    
            local pNode50 = AutoScrollNode:newAutoScrollNode(SX(382), SY(170));
            if pNode50 then
                pNode50:setTag(50);
                pNode50:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pNode50:setPosition(AUTO_POS(157.00, 147.00))
                pNode50:setScrollNode1(pImage100, pImage200, pImage300, pImage400, 1);
                pNode50:setDuratio(2);
            end
            
            if pNode50 and pWnd then
                pWnd:addChild(tolua.cast(pNode50, "SCNode"));
            end	    
		end
	end
	
    --设置对手信息
    local pLable11 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-11"));
    if pLable11 then
        pLable11:setText(L("str0529").." "..L("str0529"));
    end
    local pLable12 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-12"));
    if pLable12 then
        pLable12:setText(L("str0529"));
    end
    local pLable13 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-13"));
    if pLable13 then
        pLable13:setText(L("str0525"));
    end
    local pLable29 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-29"));
    if pLable29 then
        pLable29:setText(L("str0553"));
    end  
end

local function OnCheck()
   
end

local function StartMarry()      --开始匹配
    local pNode = SCFunction:getUiNodeByIdlist("4435-50")
    if pNode then
        restart();
    end
    local pImage = tolua.cast(SCFunction:getUiNodeByIdlist("4435-2"), "SCImage");
    if pImage then
        local pWin = SCFunction:getUiNodeByIdlist("4435");
        if pWin then
            pWin:removeChild(pImage, true);
        end
        restart();
    end
    local pNode = tolua.cast(SCFunction:getUiNodeByIdlist("4435-50"), "AutoScrollNode");
    if pNode then
        pNode:startAutoScroll(Interrupted);
    end            --匹配到某一个人物
    local pButton6 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-6"), "SCButton");
    if pButton6 then 
        pButton6:luaSetSelectorOnClicked(OnCheck);
    end
end

--[[local function freshHead()
    m_Value = m_Value - 1;
    if m_Value < 0 then
        if m_timeID then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_timeID);  --关闭定时器
            m_timeID = nil;
            return;
        end
    end
    local pButton6 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-6"), "SCButton");
    if pButton6 then
        pButton6:setTitle(m_Value, DEFAULT_FONT_NAME, F(15)); 
        pButton6:luaSetSelectorOnClicked(OnCheck);
    end
end--]]

function DuelTemple_freshPlayData()
    local ProName = nil;
    local ProImg = nil;
    local flag = 0;
    if m_PlayInfo.ucClan == 1 then
        ProName = L("str6041");     --龙将
        ProImg = 7033;
        flag = 3;
    elseif m_PlayInfo.ucClan == 2 then
        ProName = L("str6042");     --剑舞
        ProImg = 7036;
        flag = 0;
    elseif m_PlayInfo.ucClan == 3 then
        ProName = L("str6043");     --箭神
        ProImg = 7035;
        flag = 1;
    elseif m_PlayInfo.ucClan == 4 then
        ProName = L("str6044");     --军师
        ProImg = 7034;
        flag = 2;
    end
    --对方数据显示
    local pLable11 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-11"));
    if pLable11 then
        pLable11:setText(m_PlayInfo.szName.." "..L("str0530")..m_PlayInfo.nLev);
    end
    local pLable12 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-12"));
    if pLable12 then
        pLable12:setText(ProName);
    end
    local pLable13 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-13"));
    if pLable13 then
        local num = nil
        if m_PlayInfo.nTotalTimes == 0 then
            num = 0;
        else
            num = getIntPart(m_PlayInfo.nWinTimes/m_PlayInfo.nTotalTimes*100);
        end
        pLable13:setText(string.format(L("str0524"), m_PlayInfo.nTotalTimes, m_PlayInfo.nWinTimes, num)..L("str0545"));
    end
    local pLable29 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-29"));
    if pLable29 then
        pLable29:setText(string.format(L("str0552"), m_PlayInfo.nFleeTimes));
    end
end

local function setWindow()
    --restart();
    --设置自身头像
    local ProName = nil;
    local ProImg = nil;
    local flag = 0;
    if m_HeroInfo.ucClan == 1 then
        ProName = L("str6041");     --龙将
        ProImg = 7033;
        flag = 3;
    elseif m_HeroInfo.ucClan == 2 then
        ProName = L("str6042");     --剑舞
        ProImg = 7036;
        flag = 0;
    elseif m_HeroInfo.ucClan == 3 then
        ProName = L("str6043");     --箭神
        ProImg = 7035;
        flag = 1;
    elseif m_HeroInfo.ucClan == 4 then
        ProName = L("str6044");     --军师
        ProImg = 7034;
        flag = 2;
    end
    local imgPath = getRealUIResourcePath("img/img"..ProImg..".pn")
    local pImage3 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-3"), "SCImage");
    if pImage3 and imgPath then
        pImage3:setImage(imgPath:getData());
        pImage3:setScale(0.53);
        pImage3:setVisible(true)
        pImage3:setFlipX(true);
    end
    --设置自身信息
    local pLable8 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-5-8"));
    if pLable8 then
        --pLable8:setText("皇陵 Lv。146");
        pLable8:setColor(color_orange);
        pLable8:setText(m_HeroInfo.szName.." "..L("str0530")..m_HeroInfo.nLev);
    end
    local pLable9 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-5-9"));
    if pLable9 then
        --pLable9:setText("剑圣");
        pLable9:setColor(color_orange);
        pLable9:setText(ProName);
    end
    local pLable10 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-5-10"));
    if pLable10 then
        --pLable10:setText("145战 35胜 (24%)");
        local num = nil
        if m_HeroInfo.nTotalTimes == 0 then
            num = 0;
        else
            num = getIntPart(m_HeroInfo.nWinTimes/m_HeroInfo.nTotalTimes*100);
        end
        pLable10:setColor(color_green);
        pLable10:setText(string.format(L("str0524"), m_HeroInfo.nTotalTimes, m_HeroInfo.nWinTimes, num)..L("str0545"));
    end
    local pLable28 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-5-28"));
    if pLable28 then
        pLable28:setColor(color_red);
        pLable28:setText(string.format(L("str0552"), m_HeroInfo.nFleeTimes));
    end
    --设置对手信息
    local pLable11 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-11"));
    if pLable11 then
        pLable11:setColor(color_orange);
        pLable11:setText(L("str0529").." "..L("str0529"));
    end
    local pLable12 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-12"));
    if pLable12 then
        pLable12:setColor(color_orange);
        pLable12:setText(L("str0529"));
    end
    local pLable13 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-13"));
    if pLable13 then
        pLable13:setColor(color_green);
        pLable13:setText(L("str0525"));
    end
    local pLable29 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-29"));
    if pLable29 then
        pLable29:setColor(color_red);
        pLable29:setText(L("str0553"));
    end
    --设置军衔和荣誉
    local pLable14 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-14-15"));
    if pLable14 then
        pLable14:setText(L("str0547"));
    end
    --设置军衔图标
    local imgPath = getRealUIResourcePath("rank/new00"..m_HeroInfo.nPicture..".pn")
    local pImage16 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-14-16"), "SCImage");
    if pImage16 then --and imgPath then
        pImage16:setImage(imgPath:getData());
        pImage16:setVisible(true)
    end
    local pLable17 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-14-17"));
    if pLable17 then
        pLable17:setColor(color_orange);
        pLable17:setText(m_HeroInfo.szMilitaryRank);
    end
    local pLable18 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-14-18"));
    if pLable18 then
        pLable18:setText(L("str0522"))
    end
    local pLable26 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-14-26"));
    if pLable26 then
        pLable26:setColor(color_orange);
        pLable26:setText(m_HeroInfo.dwPoint.."/"..m_HeroInfo.dwTotalPoint)
    end
    local pLable19 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-14-19"));
    if pLable19 then
        pLable19:setText("");
    end
    local pLable27 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-14-27"));
    if pLable27 then
        pLable27:setColor(color_orange);
        pLable27:setText("")
    end
    local pLable19 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-14-19"));
    if pLable19 then
        pLable19:setText(string.format(L("str30187"), m_HeroInfo.nSurplusTimes))
        pLable19:setColor(color_orange);
    end
    
    --设置增加决斗次数按钮
    local pButton24 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-14-24"), "SCButton");
    if pButton24 then
        local imgPath = getRealUIResourcePath("img/new00307.png")
		if imgPath then
			pButton24:setBackgroundImage(imgPath:getData())
		end
		pButton24:setVisible(true)
        pButton24:luaSetSelectorOnClicked(DuelTemple_sendBuyData);
    end
    --设置决斗按钮
    local pButton6 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-6"), "SCButton");
    if pButton6 then
        pButton6:setTitle(L("str0548"), DEFAULT_FONT_NAME, F(15)); 
        pButton6:luaSetSelectorOnClicked(DuelTemple_sendPlayData);
    end
    --设置说明按钮
    local pButton21 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-21"), "SCButton");
    if pButton21 then
        pButton21:luaSetSelectorOnClicked(Specifications);
    end
    --设置聊天按钮
    local pButton22 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-20-22"), "SCButton");
    if pButton22 then
        pButton22:luaSetSelectorOnClicked(ChatPro);
    end
	--显示之前对战信息
    local pListBox23 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-20-23"), "SCListBox");
    if pListBox23 then
        pListBox23:removeAllItems()
        --for i = 1, 10 do
        for i = 1, #m_HistoryInfo do
            if m_HistoryInfo[i].ucWinFlag == 1 then
                isWin = L("str0532");
            else
                isWin = L("str0533");
            end
            local dragNode = SCDragNode:node();
            dragNode:setDragEnabled(false);
            dragNode:setFrameType(EnumFrameTypeListNormal);
            dragNode:setFrameVisibled(false);
            local text = m_HistoryInfo[i].szPastTime..", "..L("str0531")..L("*6")..m_HistoryInfo[i].szTargetName..L("*0")..", "..isWin;
            local parserNode = getItemTextNode(text);
            parserNode:setPosition(0, SY(4));
            dragNode:setContentSize(CCSizeMake(pListBox23:getContentSize().width - SX(60), parserNode:getContentSize().height+SY(1)));
            dragNode:addChild(parserNode);
            pListBox23:addItem(dragNode);
        end
    end
    --设置关闭窗口按钮
    local pButton25 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-25"), "SCButton");
    if pButton25 then
        pButton25:luaSetSelectorOnClicked(CloseWin);
    end
end

local function showWin(tag, type)
    if type == LuaControllerEventPushEnded then
        setWindow();
    end
end

local function SendCancleMarry()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ARENA);
    if dataStream then                   ----消息发送提示
        dataStream:writeShort(ARENASCRITP_DUEL_CLOSEPAIR);
        SCDataTransThread:getSingleton():transData(dataStream);
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1);
        SCActivityIndicator:getSingleton():show();
    end
end

local function CancleMarry()
    SendCancleMarry();
    restart();
end

local function sendExitData()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ARENA);
    if dataStream then                   ----消息发送提示
        dataStream:writeShort(ARENASCRITP_DUEL_AWARD);
        SCDataTransThread:getSingleton():transData(dataStream);
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1);
    end
end

----------------消息处理区----------------

----------------消息注册区----------------
function DuelTemple_revcHeroData(dt)
    m_HeroInfo = {}
    m_HeroInfo = stHeroInfoData.initWithStream(dt)
end

function DuelTemple_revcHistoryData(dt)
    local ucAmount = dt:readByte();
    m_HistoryInfo = {};
	for i = 1, ucAmount do
        table.insert(m_HistoryInfo, stArenaHistory.initWithStream(dt));
    end
	local wndCtrl = getCurentSceneWindowController(4435);
	if wndCtrl then 
        DuelTemple_refreshHistory();
        DuelTemple_setOkButton();
        return;  
    end
    if g_DuelTemple_bisOpen == false then
        return;
    end
    DuelTemple.Window();
end

function DuelTemple_revcPlayData(dt)
    m_Flag = 0;
    m_PlayInfo = stPlayInfoData.initWithStream(dt);
    local num = 10 + m_PlayInfo.ucClan;
	LuaReCall:getSingleton():setnID(num);
	--设置决斗按钮
    local pButton6 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-6"), "SCButton");
    if pButton6 then
        pButton6:setTitle(L("str0549"), DEFAULT_FONT_NAME, F(15)); 
        pButton6:luaSetSelectorOnClicked(OnCheck);
    end
    m_Value = 1;
	DuelTemple_freshPlayData();
end

--发送获取自己信息请求
function DuelTemple_sendHeroData()
	if CLIENT_VERSION < 331 then
		showMessage(L("str6301"))
		return
	end
    m_Flag = 1;
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ARENA);
    if dataStream then                   ----消息发送提示
        dataStream:writeShort(ARENASCRITP_DUEL_USETINFO);
        SCDataTransThread:getSingleton():transData(dataStream);
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1);
        SCActivityIndicator:getSingleton():show();
    end
    g_DuelTemple_bisOpen = true;
end

--发送获取配对信息请求
function DuelTemple_sendPlayData()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ARENA);
    if dataStream then                   ----消息发送提示
        dataStream:writeShort(ARENASCRITP_DUEL_OPENPAIR);
        SCDataTransThread:getSingleton():transData(dataStream);
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1);
        SCActivityIndicator:getSingleton():show();
    end
    StartMarry();   --开启匹配
end

--发送离开信息请求
function DuelTemple_sendLeaveData()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ARENA);
    if dataStream then                   ----消息发送提示
        dataStream:writeShort(ARENASCRITP_DUEL_LEAVE);
        SCDataTransThread:getSingleton():transData(dataStream);
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1);
    end
end

----------------全局函数区----------------
function DuelTemple_setOkButton()
    m_Value = 0;
    local pButton6 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-6"), "SCButton");
    if pButton6 then
        pButton6:setTitle(L("str0548"), DEFAULT_FONT_NAME, F(15)); 
        pButton6:luaSetSelectorOnClicked(DuelTemple_sendPlayData);
    end
    --设置对手信息
    local pLable11 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-11"));
    if pLable11 then
        pLable11:setText(L("str0529").." "..L("str0529"));
    end
    local pLable12 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-12"));
    if pLable12 then
        pLable12:setText(L("str0529"));
    end
    local pLable13 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-13"));
    if pLable13 then
        pLable13:setText(L("str0525"));
    end 
end

function DuelTemple_setCancleButton()
    m_Flag = 1;
    --取消匹配按钮设置
    local pButton6 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-6"), "SCButton");
    if pButton6 then
        pButton6:setTitle(L("str8084"), DEFAULT_FONT_NAME, F(15)); 
        pButton6:luaSetSelectorOnClicked(CancleMarry);
    end
end
--服务端说明已经进入战斗消息
function DuelTemple_isFight()
    m_Value = 0;
    --设置决斗按钮
    local pButton6 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-6"), "SCButton");
    if pButton6 then
        pButton6:setTitle(L("str0548"), DEFAULT_FONT_NAME, F(15)); 
        pButton6:luaSetSelectorOnClicked(DuelTemple_sendPlayData);
    end
    --设置对手信息
    local pLable11 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-11"));
    if pLable11 then
        pLable11:setText(L("str0529").." "..L("str0529"));
    end
    local pLable12 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-12"));
    if pLable12 then
        pLable12:setText(L("str0529"));
    end
    local pLable13 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-13"));
    if pLable13 then
        pLable13:setText(L("str0525"));
    end 
    local pLable29 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-7-29"));
    if pLable29 then
        pLable29:setText(L("str0553"));
    end 
    local MAPTYPE_SYN_CAMPAIGN_WAR = 67108864   --军团战地图ID
    if  true == GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_SYN_CAMPAIGN_WAR) then
		removeAllWindwoController();
	end
end

--刷新历史记录
function DuelTemple_refreshHistory()
    --设置自身信息
    local pLable10 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-5-10"));
    if pLable10 then
        local num = nil
        if m_HeroInfo.nTotalTimes == 0 then
            num = 0;
        else
            num = getIntPart(m_HeroInfo.nWinTimes/m_HeroInfo.nTotalTimes*100);
        end
        pLable10:setText(string.format(L("str0524"), m_HeroInfo.nTotalTimes, m_HeroInfo.nWinTimes, num)..L("str0545"));
    end
    local pLable28 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-5-28"));
    if pLable28 then
        pLable28:setText(string.format(L("str0552"), m_HeroInfo.nFleeTimes));
    end
    --设置军衔图标
    local imgPath = getRealUIResourcePath("rank/new00"..m_HeroInfo.nPicture..".pn")
    local pImage16 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-14-16"), "SCImage");
    if pImage16 then --and imgPath then
        pImage16:setImage(imgPath:getData());
        pImage16:setVisible(true)
    end
    local pLable17 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-14-17"));
    if pLable17 then
        pLable17:setText(m_HeroInfo.szMilitaryRank);
    end
    local pLable26 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-14-26"));
    if pLable26 then
        pLable26:setText(m_HeroInfo.dwPoint.."/"..m_HeroInfo.dwTotalPoint)
    end
    local pLable27 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-14-27"));
    if pLable27 then
        pLable27:setText("")
    end
    local pLable19 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-14-19"));
    if pLable19 then
        pLable19:setText(string.format(L("str30187"), m_HeroInfo.nSurplusTimes))
        pLable19:setColor(color_orange);
    end
    --显示之前对战信息
    local pListBox23 = tolua.cast(SCFunction:getUiNodeByIdlist("4435-20-23"), "SCListBox");
    if pListBox23 then
        pListBox23:removeAllItems()
        for i = 1, #m_HistoryInfo do
            if m_HistoryInfo[i].ucWinFlag == 1 then
                isWin = L("str0532");
            else
                isWin = L("str0533");
            end
            local dragNode = SCDragNode:node();
            dragNode:setDragEnabled(false);
            dragNode:setFrameType(EnumFrameTypeListNormal);
            dragNode:setFrameVisibled(false);
            local text = m_HistoryInfo[i].szPastTime..", "..L("str0531")..L("*6")..m_HistoryInfo[i].szTargetName..L("*0")..", "..isWin;
            local parserNode = getItemTextNode(text);
            parserNode:setPosition(0, SY(4));
            dragNode:setContentSize(CCSizeMake(pListBox23:getContentSize().width - SX(60), parserNode:getContentSize().height+SY(1)));
            dragNode:addChild(parserNode);
            pListBox23:addItem(dragNode);
        end
    end
    
end

--刷新挑战按钮次数
function DuelTemple_refreshFightTimes(dt)
    local dwDayMatch = dt:readInt();         --今日剩余荣誉次数
	local dwLeaveBuyTimes = dt:readInt();	 --今日还可购买荣誉次数
    local pLable19 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-14-19"));
    if pLable19 then
        pLable19:setText(string.format(L("str30187"), dwDayMatch))
        pLable19:setColor(color_orange)
    end
end

--购买决斗神殿次数
function DuelTemple_sendBuyData() --挑战购买次数数据
    challengeView_sendBuyByHufuMsg()
    g_DuelTemple_bBuyTimes = true
end

--奖励提示框
function DuelTemple_showAward(dt)
    local ucWin = dt:readByte();        --胜利标志 0失败1胜利
	local dwHonorExp = dt:readInt();    --额外获得的荣誉
	local szAwardBuf = dt:readString()  --奖励信息
	if szAwardBuf then
        szAwardBuf = szAwardBuf:getData()
    else
        szAwardBuf = " "
    end
	local text = nil
	local pNBManager = nil;
    local pMapLayer = tolua.cast(getMapLayer(), "MapLayer");
    if pMapLayer and CLIENT_VERSION > 328 then
        pNBManager = tolua.cast(pMapLayer:getNewBattleManager(), "NBManager");
    end
	if ucWin == 1 then
	    text = string.format(L("str0550"), dwHonorExp)..szAwardBuf..L("str0555");
	    if pNBManager then
	        pNBManager:showBattleWin();
	    end
	else
	    text = string.format(L("str0551"), dwHonorExp)..szAwardBuf..L("str0555");
	    if pNBManager then
	        pNBManager:showBattleLost();
	    end
	end
    luaShowBattleMessage(text, WIN_YES, sendExitData);
end

function DuelTemple.Window()
	local wnd = nil;
	local wndCtrl = getCurentSceneWindowController(4435);
	if wndCtrl then
		wnd = wndCtrl:getWindow();  
	else
		wnd = DuelTemple.initControl();
		if wnd then
			local wndCtrl = SCWindowController:controllerWithWindow(wnd);
			local naviCtrl = getCurentSceneNavigationController();
			if wndCtrl and naviCtrl then
				naviCtrl:pushWindowController(wndCtrl);
				wndCtrl:luaSetSelectorOnEvent(showWin);
				wnd:setBackButtonVisibled(false);
                wnd:setCloseButtonVisibled(false);
                wnd:setFrameVisibled(false);
			end
			local pBlackImg = SCTypeCast:castNodeToImage(wnd:getChildByTag(1))
			if pBlackImg then
			    local pImgPath = getRealUIResourcePath("pk/new00719.png")
                if pImgPath then
                    local pImg = SCImage:imageWithFile(pImgPath:getData())
                    if pImg then
                        pImg:setAnchorPoint(CCPointMake(0.5, 0.5))
                        pImg:setPosition(CCPointMake(wnd:getContentSize().width / 2,SY(300)))
                        wnd:addChild(pImg)
                        wnd:reorderChild(pImg, 1000);
                    end
                end
			end
		 end
    end
end

function DuelTemple.wndClose()
    if m_Flag == 1 then
        SendCancleMarry();
    end
    m_Value = 0;
    m_Flag = 0;
    m_HeroInfo = {};
    m_PlayInfo = {};
    m_HistoryInfo = {};
    g_DuelTemple_bBuyTimes = false;
    g_DuelTemple_bisOpen = false;
end

function refreshDuelTempleHufuTimes(times)
	local pLable19 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4435-14-19"))
    if pLable19 then
        pLable19:setText(string.format(L("str30187"), times))
        pLable19:setColor(color_orange);
    end
end


--函数调用