--8008 装备强化界面

local m_wnd = nil
local m_roleList = nil
local m_currentSelectItemId = nil--当前选中装备id
local m_currentEquiptDetail = nil

local function removeAllData()
    m_wnd = nil
    m_roleList = nil
    m_currentSelectItemId = nil
    m_currentEquiptDetail = nil
end

local function createMenuItem(menuItemBtn,width,height,icon,name,levelStr)
    
	local menuItem = nil
    if menuItemBtn then
        menuItem = menuItemBtn
    else
        menuItem = SCButton:button()
    end 
	menuItem:setContentSize(CCSizeMake(width,height)) 
    local itemBtn = SCButton:button()
    itemBtn:setTag(1)
    if icon and icon~=0 then
        local itemFile = getItemImageByIcon(icon)
        if itemFile then
             itemBtn:setTitle(itemFile:getData())
        end
    end
    itemBtn:setBackgroundImage(getRealUIResourcePath(ItemBack_Normal_ImagePath):getData())
    itemBtn:setSelectedImage(getRealUIResourcePath(ItemBack_Click_ImagePath):getData())
    itemBtn:setAnchorPoint(CCPointMake(0.5,0));
    itemBtn:setPosition(CCPointMake(width/2,height-itemBtn:getContentSize().height-SY(3)));
    menuItem:addChild(itemBtn)
    
    local tmpX = itemBtn:getContentSize().width+SX(3)
    local tmpY = menuItem:getContentSize().height
    local itemName = name
    if itemName == nil then
        itemName = ""
    end
    --物品名称
    if itemName~= nil and itemName ~= "" then--字符串已经带颜色了
	    local nameLabel = ParsedNode:getParsedNode(itemName,0,10)
	    nameLabel:setTag(2)
        nameLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        nameLabel:setPosition(CCPointMake(width/2,SY(25)));
        menuItem:addChild(nameLabel)
	end
	
	if levelStr~=nil and levelStr~="" then
	    local levelLabel = ParsedNode:getParsedNode(levelStr,0,10)
	    levelLabel:setTag(3)
        levelLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        levelLabel:setPosition(CCPointMake(width/2,SY(10)));
        menuItem:addChild(levelLabel)
	end
    
    return menuItem,itemBtn
end


--点击装备列表响应
local function menuItemButtonAction(tag)
    if m_wnd ==nil then
        return;
    end
    m_currentSelectItemId = tag

    refreshEquiptDetail_EquiptStrengthScreen()
end

--上一页
local function upPageAction()

end

--下一页
local function nextPageAction()

end

local function strengthButtonAction(tag)
    if tag and tag~=0 then
        sendEquiptStrengthOkMsg(tag)
        setRestartGuideFlag(GUIDE_TYPE_STRENGTHEN, false);
		showGuideStep(GUIDE_TYPE_STRENGTHEN, 4, 3);
    end
    
end

--[[显示处理每页装备列表
    参数：pageNodeLayer 父节点
    role = {}
    role.roleId
    role.roleName
    role.equiptList
]]
local function setEquiptPageNode(pageNodeLayer,role)
    if pageNodeLayer == nil or role == nil then
        return
    end
    local showWidth  = pageNodeLayer:getContentSize().width
    local showHeight = pageNodeLayer:getContentSize().height
    
    local startX = SX(30)+(showWidth)
    local startY = showHeight*0.9
    local roleName = role.roleName
    if roleName == nil then
        roleName = ""
    end
    --角色名称
    local titleLabel = SCLabel:labelWithStringFont(roleName,getDefaultFontName(), getFontSize(15))
    titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0.5,0));
    titleLabel:setPosition(CCPointMake(showWidth/2,startY));
    pageNodeLayer:addChild(titleLabel)
    startY = startY-titleLabel:getContentSize().height-SY(5)
    
    
    local equiptList = role.equitpList
    if equiptList == nil then
        return
    end
    
    local amount = 6
    if amount > 6 then
        amount = 6
    end
    local menuWidth  = SY(66)
    local menuHeight = SY(80)
    local rowAmount  = 3
    local tmpX = 0
    local tmpY = showHeight*0.88
    for i=1,amount do
        local row = math.ceil(i/rowAmount)--例如：1/2 = 1
        local col = math.mod(i,rowAmount)
        if row < 1 then
            row = 1
        end
        if  col == 0 then
            col = rowAmount
        end 
        tmpX = SX(8) + (menuWidth+SX(10))*(col-1)

        if equiptList[i] then
            local itemId      = equiptList[i].idItem
            local icon        = equiptList[i].nPhoto
            local name        = equiptList[i].szName
            local levelStr    = string.format(_LTParser("str8036"),equiptList[i].usStrengthLevel)

            local menuItem,itemBtn = createMenuItem(nil,menuWidth,menuHeight,icon,name,levelStr)
            menuItem:setTag(itemId)
            menuItem:setAnchorPoint(CCPointMake(0,0));
            menuItem:setPosition(CCPointMake(tmpX,tmpY-(menuHeight+SY(15))*row));
            
            local imgFile = getRealUIResourcePath("img/img0001.png");
            if imgFile then
                menuItem:setBackgroundImage(imgFile:getData())
            end
            itemBtn:setTouchEnabled(false)--不能点击
            menuItem:luaSetSelectorOnClicked(menuItemButtonAction)
            
            pageNodeLayer:addChild(menuItem)
        end
    end
end

--显示当前装备列表
local function showLeftContent(fatherLayer)
    if fatherLayer == nil then
        return;
    end
    fatherLayer:removeAllChildrenWithCleanup(true)
    
    local width = fatherLayer:getContentSize().width
    local height = fatherLayer:getContentSize().height
    
    local scrollBox = SCPageScrollBox:boxWithWidthHeight(width*0.96,height)
    scrollBox:setTag(1)
	scrollBox:setAnchorPoint(CCPointMake(0.5,0));
	scrollBox:setPosition(CCPointMake(width/2,0));
	scrollBox:setScrollHorizontal(true)
    scrollBox:setScrollVertical(false)
    scrollBox:setPageSize(CCSizeMake(width*0.96,height));
    scrollBox:luaSetSelectorOnScrollToPrevious(upPageAction)
    scrollBox:luaSetSelectorOnScrollToNext(nextPageAction)
    
    local scPageHint = SCPageHint:hintWithType(EnumPgaeHintTypeHorizontal)
    scPageHint:setAnchorPoint(CCPointMake(0.5,0.5));
	scPageHint:setPosition(CCPointMake(width/2,SY(10)));
	scPageHint:setBoundPageScrollBox(scrollBox)
	
	fatherLayer:addChild(scrollBox)
	fatherLayer:addChild(scPageHint)
	
	
    local showWidth  = scrollBox:getContentSize().width
    local showHeight = scrollBox:getContentSize().height
    
    if m_roleList == nil then
        return
    end
    local pageAmount = #m_roleList    
    local pageIndex = 1
    for i=1,pageAmount do
        --[[if m_roleList[i].roleId == 0 then--背包，equiptList里面个数可能会多于6个
            local bagPageAmount = math.ceil(m_bagEquiptAmount/6)
            for j=1,bagPageAmount do
                
                local pageNodeLayer = SCNode:node()
	            pageNodeLayer:setTag(1)
                pageNodeLayer:setAnchorPoint(CCPointMake(0,0));
	            pageNodeLayer:setPosition(CCPointMake((pageIndex-1)*showWidth,0));
	            pageNodeLayer:setContentSize(CCSizeMake(showWidth,showHeight))
	            scrollBox:setContentSize(CCSizeMake(showWidth*pageIndex,showHeight))
	            scrollBox:addChild(pageNodeLayer)
	            
	            local equitpList = {}--只读取6个
	            local statIndex = 6*(j-1)
                local endIndex = 6*j
                for k=statIndex,endIndex do
                    table.insert(equitpList,m_roleList[i].equitpList[k]);
                end
                local role = {}
	            role.roleId     = m_roleList[i].roleId
	            role.roleName   = m_roleList[i].roleName
	            role.equitpList  = equitpList
                setEquiptPageNode(pageNodeLayer,role)
                pageIndex = pageIndex+1
            end
        else--角色身上]]
            local role = {}
	        role.roleId      = m_roleList[i].roleId
	        role.roleName    = m_roleList[i].roleName
	        role.equitpList  = m_roleList[i].equitpList
	        
            local pageNodeLayer = SCDragNode:node()
	        pageNodeLayer:setTag(role.roleId)
	        pageNodeLayer:setAnchorPoint(CCPointMake(0,0));
	        pageNodeLayer:setPosition(CCPointMake((pageIndex-1)*showWidth,0));
	        pageNodeLayer:setContentSize(CCSizeMake(showWidth,showHeight))
	        scrollBox:setContentSize(CCSizeMake(showWidth*pageIndex,showHeight))
	        scrollBox:addChild(pageNodeLayer)

         
            setEquiptPageNode(pageNodeLayer,role)
            
            pageIndex = pageIndex+1
        --end
       
    end
end

--动画显示完成回调
local function removeAniNode()
    local pNode = m_wnd:getChildByTag(800801);
    if pNode then
        local pNode = pNode:getChildByTag(2);
        if pNode then
            local pNode = pNode:getChildByTag(1);
            if pNode then
                local pNode = pNode:getChildByTag(1);
                if pNode then
                    pNode:removeChildByTag(1, true);
                end
            end
        end
    end
end

--显示选中装备详细
local function showRightContent(fatherLayer, type)
    if fatherLayer == nil then
        return;
    end
    fatherLayer:removeAllChildrenWithCleanup(true)
    local showWidth = fatherLayer:getContentSize().width
    local showHeight = fatherLayer:getContentSize().height
    
    local startX = SX(30)
    local startY = showHeight*0.95
    
    local menuWidth  = SY(66)
    local menuHeight = SY(80)
    local bgImgFile = getRealUIResourcePath("img/img0001.png");

    
    local icon          = nil
    local name          = nil
    local levelStr      = nil
    local levelStr2     = nil--强化后等级
    local attrValueStr  = nil--当前属性
    local attrValueStr2 = nil--强化后属性
    local moneyStr      = nil--消耗
    local equiptId      = 0
    if m_currentEquiptDetail then
        icon          = m_currentEquiptDetail.nPhoto
        name          = m_currentEquiptDetail.szName
        levelStr      = string.format(_LTParser("str8036"),m_currentEquiptDetail.usStrengthLevel)
        levelStr2      = string.format(_LTParser("str8036"),m_currentEquiptDetail.usStrengthLevel+1)
        attrValueStr  = m_currentEquiptDetail.szOldSpe
        attrValueStr2 = m_currentEquiptDetail.szNewSpe
        
        moneyStr      = m_currentEquiptDetail.szCondition
        equiptId      = m_currentEquiptDetail.idItem
    end
    local menuItem,itemBtn = createMenuItem(nil,menuWidth,menuHeight,icon,name,levelStr)
    menuItem:setAnchorPoint(CCPointMake(0,0));
    menuItem:setPosition(CCPointMake(SX(10),startY-menuHeight));
    if bgImgFile then
        menuItem:setBackgroundImage(bgImgFile:getData())
    end
    menuItem:setTouchEnabled(false)--不能点击
    itemBtn:setTouchEnabled(false)--不能点击
    fatherLayer:addChild(menuItem)
    
    --箭头
    local imgFile = getRealUIResourcePath(Img5058_ImagePath);
	local imageLabel = nil
	if imgFile then
	    imageLabel = SCImage:imageWithFile(imgFile:getData())
	    imageLabel:setVisible(true)
        imageLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        imageLabel:setPosition(CCPointMake(showWidth*0.46,showHeight*0.8));
        fatherLayer:addChild(imageLabel)
	end
	
	--强化后图片
	local menuItem,itemBtn = createMenuItem(nil,menuWidth,menuHeight,icon,name,levelStr2)
    menuItem:setAnchorPoint(CCPointMake(0,0));
    menuItem:setPosition(CCPointMake(showWidth*0.6,startY-menuHeight));
    if bgImgFile then
        menuItem:setBackgroundImage(bgImgFile:getData())
    end
    menuItem:setTouchEnabled(false)--不能点击
    itemBtn:setTouchEnabled(false)--不能点击
    fatherLayer:addChild(menuItem)
    local pAni = LookfaceParser:getSingleton():getAnimationByIndex(1101, 1139);
    if pAni and type == 1 then
        pAni:setAutoremoveOnComplete(true);
        pAni:luaSetSelectorOnComplete(removeAniNode);
        local pAniNode = SCAnimationNode:nodeWithAnimation(pAni);
        if pAniNode then
            pAniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
            pAniNode:setPosition(CCPointMake(itemBtn:getContentSize().width / 2, itemBtn:getContentSize().height / 2));
            itemBtn:addChild(pAniNode);
            pAniNode:setTag(1);
            menuItem:setTag(1);
            itemBtn:setTag(1);
        end
    end
    
    startY = startY-  menuHeight - SY(20)   
    
    --分割线图片
    local imgFile = getRealUIResourcePath("img/img0015.png");
    if imgFile then
        local lineBgImgLabel = SCImage:imageWithFile(imgFile:getData()) 
        lineBgImgLabel:setAnchorPoint(CCPointMake(0.5,0));
        lineBgImgLabel:setPosition(CCPointMake(showWidth/2,startY));
        fatherLayer:addChild(lineBgImgLabel)
        startY = startY -  lineBgImgLabel:getContentSize().height - SY(8)   
    end
    
    
    --当前属性标题
    local titleLabel = SCLabel:labelWithStringFont(_LTParser("str8034"),getDefaultFontName(), getFontSize(11))
	titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0,0));
    titleLabel:setPosition(CCPointMake(SX(10),startY-titleLabel:getContentSize().height));
    fatherLayer:addChild(titleLabel)
    
    --强化属性标题
    titleLabel = SCLabel:labelWithStringFont(_LTParser("str8035"),getDefaultFontName(), getFontSize(11))
	titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0,0));
    titleLabel:setPosition(CCPointMake(showWidth*0.6,startY-titleLabel:getContentSize().height));
    fatherLayer:addChild(titleLabel)
    
    startY = startY-titleLabel:getContentSize().height-SY(5)
     
    --强化前属性值
    
    if attrValueStr == nil then
        attrValueStr = ""
    end
    local attrLabel = ParsedNode:getParsedNode(""..attrValueStr,0,9)
    attrLabel:setAnchorPoint(CCPointMake(0,0));
    attrLabel:setPosition(CCPointMake(SX(7),startY-attrLabel:getContentSize().height));
    fatherLayer:addChild(attrLabel)
    
    --强化后属性值
    
    if attrValueStr2 == nil then
        attrValueStr2 = ""
    end
    local attrLabel2 = ParsedNode:getParsedNode(""..attrValueStr2,0,9)
    attrLabel2:setAnchorPoint(CCPointMake(0,0));
    attrLabel2:setPosition(CCPointMake(showWidth*0.58,startY-attrLabel2:getContentSize().height));
    fatherLayer:addChild(attrLabel2)
    startY = startY -  attrLabel2:getContentSize().height - SY(10)  
    
    --分割线图片
    local imgFile = getRealUIResourcePath("img/img0015.png");
    if imgFile then
        local lineBgImgLabel = SCImage:imageWithFile(imgFile:getData()) 
        lineBgImgLabel:setAnchorPoint(CCPointMake(0.5,0));
        lineBgImgLabel:setPosition(CCPointMake(showWidth/2,startY));
        fatherLayer:addChild(lineBgImgLabel)
        startY = startY -  lineBgImgLabel:getContentSize().height - SY(10)  
    end
    
    --消耗费用
    if moneyStr == nil then
        moneyStr = ""
    end
    local costLabel = ParsedNode:getParsedNode(moneyStr,0)
    costLabel:setAnchorPoint(CCPointMake(0.5,0));
    costLabel:setPosition(CCPointMake(showWidth/2,startY-costLabel:getContentSize().height));
    fatherLayer:addChild(costLabel)
    
    --确定强化
	local strengthButton = SCButton:button(EnumBtnType9Atlas)
	if equiptId then
	    strengthButton:setTag(equiptId)
    end
    setNodeContentSize(strengthButton, BigButton_Size)
	local imgFile = getRealUIResourcePath(Img0008_ImagePath);
	strengthButton:setTitle(_LTParser("str8037"),getDefaultFontName(), getFontSize(15),getColorYellow())
    strengthButton:setAnchorPoint(CCPointMake(0.5,0));
    strengthButton:setPosition(CCPointMake(showWidth/2,SY(10)));
    strengthButton:luaSetSelectorOnClicked(strengthButtonAction)--设置回调
    strengthButton:setTouchRectScale(1.5, 2.0)
    fatherLayer:addChild(strengthButton)
    
end


local function createStrengthLayer(fatherLayer)    
   
	if fatherLayer == nil then
	    return
    end
    local showWidth   = fatherLayer:getContentSize().width
    local showHeight  = fatherLayer:getContentSize().height
    local left_width  = showWidth*0.53
	local left_height = showHeight
	local left_startX = 0
	local left_startY = 0
	
	--左边内容层
	local leftContentLayer = SCDragNode:node()
	leftContentLayer:setTag(1)
	leftContentLayer:setFrameVisibled(true)
	leftContentLayer:setFrameType(EnumFrameTypeRound)
	leftContentLayer:setAnchorPoint(CCPointMake(0,0));
	leftContentLayer:setPosition(CCPointMake(left_startX,left_startY));
	leftContentLayer:setContentSize(CCSizeMake(left_width,left_height))
	fatherLayer:addChild(leftContentLayer)
	
	
	local right_width  = showWidth*0.45
	local right_height = left_height
	local right_startX = showWidth-right_width
	local right_startY = 0
	
	--右边内容层
	local rightContentLayer = SCDragNode:node()
	rightContentLayer:setTag(2)
	rightContentLayer:setFrameType(EnumFrameTypeRound)
	rightContentLayer:setFrameVisibled(true)
	rightContentLayer:setAnchorPoint(CCPointMake(0,0));
	rightContentLayer:setPosition(CCPointMake(right_startX,right_startY));
	rightContentLayer:setContentSize(CCSizeMake(right_width,right_height))
	fatherLayer:addChild(rightContentLayer)
	
	
	showLeftContent(leftContentLayer)
	showRightContent(rightContentLayer)
end

--刷新金钱
local function refreshMoneyLabel()
    if m_wnd == nil then
        return
    end
    local moneyStr = ""
    local hero = Hero:getSingleton()  
    if hero then
        moneyStr = hero:getMoney()
    end
    local moneyLabel = SCFunction:getUiNodeByIdlistAndParent("800802-1",m_wnd)
    if moneyLabel then
        moneyLabel = SCTypeCast:castNodeToLabel(moneyLabel)
        moneyLabel:setText(moneyStr)
    end

end

local function getRoleName(roleId)
    local role = Hero:getSingleton()  
    if roleId==role:getID() then
        return role:getName():getData()
    end
    local amount = role:partnerSize()
    for i=1,amount do
        local partner = role:getPartnerWithPos(i-1)
        if partner then
            if  roleId == partner.nID then
                return partner.strName:getData()
            end
        end
    end
    return ""
end

local function isInRoleList(roleId)
    if m_roleList == nil then
        return -1
    end
    
    local amount = #m_roleList
    for i=1,amount do
        if m_roleList[i] and m_roleList[i].roleId == roleId then
            return i
        end
    end
    
    return -1
end


function processEquiptListData_EquiptStrengthScreen(dt)
    if dt == nil then
        return
    end
    if m_roleList == nil then
        m_roleList = {}
    end
    
    local roleId   = dt:readInt()
    local ucAmount = dt:readByte()
    if ucAmount < 1 then--没有装备return掉
        return
    end
    local tmpList = {}
    if roleId~= 0 then
        tmpList.roleName = getRoleName(roleId)
        tmpList.roleId = roleId
    else
        tmpList.roleId = #m_roleList+1
        tmpList.roleName = _LTParser("str8009")--背包
    end
    
    local equitpList = {}
    for i=1,ucAmount do
        local idItem           = dt:readInt()
        local nPhoto           = dt:readInt()
        local szName           = dt:readString()--//名字
        local usStrengthLevel  = dt:readShort()--//强化等级
        local szOldSpe         = dt:readString()--//当前属性
        local szNewSpe         = dt:readString()--//升级属性
        local szCondition      = dt:readString()--//升级需求
        local ucCanStrength    = dt:readByte()--//可强化标志
        local byPos            = dt:readByte()--//装备位置
        local tmpDetail = {}
        tmpDetail.idItem     = idItem
        tmpDetail.nPhoto     = nPhoto
        if szName then
            tmpDetail.szName     = szName:getData()
        end
        tmpDetail.usStrengthLevel     = usStrengthLevel
        if szOldSpe then
            tmpDetail.szOldSpe     = szOldSpe:getData()
        end
        if szNewSpe then
            tmpDetail.szNewSpe     = szNewSpe:getData()
        end
        if szCondition then
            tmpDetail.szCondition  = szCondition:getData()
        end
        tmpDetail.ucCanStrength   = ucCanStrength
        
        if byPos ~= 0 then
            equitpList[byPos] = tmpDetail
        else
            table.insert(equitpList, tmpDetail);
        end
    end
    
    tmpList.equitpList = equitpList
    table.insert(m_roleList,tmpList);
end

function processEquiptSuccess_EquiptStrengthScreen(dt)
    if dt == nil then
        return
    end
    
    local roleId   = dt:readInt()
    local ucAmount = dt:readByte()
    --因为正常就已经装备更新，所以不循环读取
    local idItem           = dt:readInt()
    local nPhoto           = dt:readInt()
    local szName           = dt:readString()--//名字
    local usStrengthLevel  = dt:readShort()--//强化等级
    local szOldSpe         = dt:readString()--//当前属性
    local szNewSpe         = dt:readString()--//升级属性
    local szCondition      = dt:readString()--//升级需求
    local ucCanStrength    = dt:readByte()--//可强化标志
    local byPos            = dt:readByte()--//装备位置
    local tmpDetail = {}
    tmpDetail.idItem     = idItem
    tmpDetail.nPhoto     = nPhoto
    if szName then
        tmpDetail.szName     = szName:getData()
    end
    tmpDetail.usStrengthLevel     = usStrengthLevel
    if szOldSpe then
        tmpDetail.szOldSpe     = szOldSpe:getData()
    end
    if szNewSpe then
        tmpDetail.szNewSpe     = szNewSpe:getData()
    end
    if szCondition then
        tmpDetail.szCondition     = szCondition:getData()
    end
    tmpDetail.ucCanStrength   = ucCanStrength    
    
    refreshMoneyLabel()
    local menuItem = nil
    local pageAmount = #m_roleList
    for i=1,pageAmount do
        if m_roleList[i] then
            local roleEquiptList = m_roleList[i].equitpList
            local equiptAmount = 6
            for j=1,equiptAmount do
                if roleEquiptList[j] and roleEquiptList[j].idItem ==  tmpDetail.idItem then
                    m_roleList[i].equitpList[j] = tmpDetail
                    menuItem = SCFunction:getUiNodeByIdlistAndParent("800801-1-1-"..m_roleList[i].roleId.."-"..tmpDetail.idItem,m_wnd)
                    break
                end
            end
        end
    end
       
    if menuItem then
        menuItem = SCTypeCast:castNodeToButton(menuItem)
        menuItem:removeAllChildrenWithCleanup(true)
        local icon        = tmpDetail.nPhoto
        local name        = tmpDetail.szName
        local levelStr    = string.format(_LTParser("str8036"),tmpDetail.usStrengthLevel)
        local menuWidth  = SY(66)
        local menuHeight = SY(80)
        local menuItem,itemBtn = createMenuItem(menuItem,menuWidth,menuHeight,icon,name,levelStr)
        menuItem:luaSetSelectorOnClicked(menuItemButtonAction)
        itemBtn:setTouchEnabled(false)--不能点击
        --itemBtn:setBackgroundImage(getRealUIResourcePath(ItemBack_Click_ImagePath):getData())
        local pAni = LookfaceParser:getSingleton():getAnimationByIndex(1101, 1139);
        if pAni then
            pAni:luaSetSelectorOnComplete(removeAniNode);
            local pAniNode = SCAnimationNode:nodeWithAnimation(pAni);
            if pAniNode then
                pAniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                pAniNode:setPosition(CCPointMake(itemBtn:getContentSize().width / 2, itemBtn:getContentSize().height / 2));
                itemBtn:addChild(pAniNode);
                pAniNode:setTag(1);
            end
        end
    end
        
        
    m_currentEquiptDetail = tmpDetail
        
    local strengthLayer = m_wnd:getChildByTag(800801);
    if strengthLayer then
        local rightLayer = strengthLayer:getChildByTag(2)
        showRightContent(rightLayer, 1)
    end
end

--初始化
function refreshEquiptList_EquiptStrengthScreen()
    if m_wnd ==nil then
        return;
    end
    if m_roleList and m_roleList[1] then
        if m_roleList[1].equitpList and  m_roleList[1].equitpList[1] then
            m_currentSelectItemId = m_roleList[1].equitpList[1].idItem
        end
    end
    
    local strengthLayer = m_wnd:getChildByTag(800801);
    if strengthLayer then
        local leftLayer = strengthLayer:getChildByTag(1)
        showLeftContent(leftLayer)
    end
    refreshEquiptDetail_EquiptStrengthScreen()
end

function refreshEquiptDetail_EquiptStrengthScreen()
    if m_wnd ==nil then
        return;
    end
    
    --设置选中效果
    local scrollBox = SCFunction:getUiNodeByIdlistAndParent("800801-1-1",m_wnd)
    if scrollBox then
        scrollBox = SCTypeCast:castNodeToPageScrollBox(scrollBox)
        if scrollBox then
            local pageAmount = #m_roleList
            local pageAmount = #m_roleList
            for i=1,pageAmount do
                if m_roleList[i] and m_roleList[i].roleId then
                    local roleEquiptList = m_roleList[i].equitpList
                    local equiptAmount = 6
                    for j=1,equiptAmount do
                        if roleEquiptList[j] and roleEquiptList[j].idItem then
                            local itemBtn = SCFunction:getUiNodeByIdlistAndParent("800801-1-1-"..m_roleList[i].roleId.."-"..roleEquiptList[j].idItem.."-1",m_wnd)
                            if itemBtn then
                                itemBtn = SCTypeCast:castNodeToButton(itemBtn)
                                if pageNum == currentPage and roleEquiptList[j].idItem == m_currentSelectItemId then
                                    m_currentEquiptDetail = roleEquiptList[j]
                                    local pAni = LookfaceParser:getSingleton():getAnimationByIndex(1101, 1139);
                                    if pAni and itemBtn:getChildByTag(1) == nil then
                                        local pAniNode = SCAnimationNode:nodeWithAnimation(pAni);
                                        if pAniNode then
                                            pAniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                            pAniNode:setPosition(CCPointMake(itemBtn:getContentSize().width / 2, itemBtn:getContentSize().height / 2));                                            
                                            itemBtn:addChild(pAniNode);
                                            pAniNode:setTag(1);
                                        end
                                    end
                                    --itemBtn:setBackgroundImage(getRealUIResourcePath(ItemBack_Click_ImagePath):getData())
                                else
                                    --itemBtn:setBackgroundImage(getRealUIResourcePath(ItemBack_Normal_ImagePath):getData())
                                    itemBtn:removeChildByTag(1, true);
                                end
                            end
                        end
                    end
                end
            end
        end
    end
    
    
    local strengthLayer = m_wnd:getChildByTag(800801);
    if strengthLayer then
        local rightLayer = strengthLayer:getChildByTag(2)
        showRightContent(rightLayer)
    end
end

--打开装备强化界面
function sendOpenMsg_EquiptStrengthScreen()
    local dt = SCDataTransStream:streamWithCommand(_MSG_MATERIALMADE);
    dt:writeShort(EQUIPMADE_EQUIPSTRENGTHEN_ALL_ROLE_ITEMS);
    dt:writeInt(0);
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

--确认强化
function sendEquiptStrengthOkMsg(equiptId)
    if equiptId then
        local dt = SCDataTransStream:streamWithCommand(_MSG_MATERIALMADE);
        dt:writeShort(EQUIPMADE_EQUIPSTRENGTHEN_OK);
        dt:writeInt(equiptId);
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

local function initShowMoney()
    if m_wnd == nil then
        return
    end
    local topLayer = m_wnd:getChildByTag(800802);
    if topLayer == nil then
        return
    end
    
    topLayer = SCTypeCast:castNodeToDragNode(topLayer)
    topLayer:removeAllChildrenWithCleanup(true)
    
    local showHeight = topLayer:getContentSize().height
     --金币图标
    local moneyImgLabel = SCButton:button()
    local imgFile = getRealUIResourcePath("img/img5041.png");
    if imgFile then
        moneyImgLabel:setTitle(imgFile:getData(),CCRectMake(SX(32), 0, SX(16), SY(16)))
    end
    moneyImgLabel:setAnchorPoint(CCPointMake(0,0.5));
    moneyImgLabel:setPosition(CCPointMake(0,showHeight/2));
    topLayer:addChild(moneyImgLabel)   

    --选中物品金钱
    local moneyStr = nil
    local hero = Hero:getSingleton()  
    if hero then
        moneyStr = hero:getMoney()
    end
    if moneyStr == nil then
        moneyStr = ""
    end
    local moneyLabel = SCLabel:labelWithStringFont(""..moneyStr,getDefaultFontName(), getFontSize(12))
    moneyLabel:setTag(1)
    moneyLabel:setAnchorPoint(CCPointMake(0,0.5));
    moneyLabel:setPosition(CCPointMake(SX(18),showHeight/2));
    topLayer:addChild(moneyLabel)
end

local function ctrlEvent(tag, eventType)
	if eventType == LuaControllerEventPushEnded then
		if isGuideCanStart(GUIDE_TYPE_STRENGTHEN) then
			setRestartGuideFlag(GUIDE_TYPE_STRENGTHEN, false);
			showGuideStep(GUIDE_TYPE_STRENGTHEN, 3, 2);
		elseif isGuideCanStart(GUIDE_TYPE_HUNT) then
			setRestartGuideFlag(GUIDE_TYPE_HUNT, true);
			showGuideStep(GUIDE_TYPE_HUNT, 3, 2);
		end
	elseif eventType == LuaControllerEventPopBegan then
		if isGuideCanStart(GUIDE_TYPE_STRENGTHEN) then
			if getRestartGuideFlag(GUIDE_TYPE_STRENGTHEN) then
				restartGuideStep(GUIDE_TYPE_STRENGTHEN);
			else
				setRestartGuideFlag(GUIDE_TYPE_STRENGTHEN, false);
				showGuideStep(GUIDE_TYPE_STRENGTHEN, -1);
			end
		elseif isGuideCanStart(GUIDE_TYPE_HUNT) then
			restartGuideStep(GUIDE_TYPE_HUNT)
		end
	end
end

function open_EquiptStrengthScreen()
     if getCurentSceneWindowController(8008) then
        return;
    end
    --获取创建窗口
    local wnd = SCWindow:window()
    wnd:setContentSize(CCSizeMake(SX(480), SY(320)))
    wnd:setTag(8008);
    wnd:luaSetSelectorOnClose(onClickClose);
    wnd:setBackgroundColor(colorWindowRedBG());
    wnd:luaSetSelectorOnClose(removeAllData);
    local imgFile = getRealUIResourcePath("img/titile04.png");
	if imgFile then
	   wnd:setTitleWithImage(imgFile:getData())
	end
	
	local wndCtrl = SCWindowController:controllerWithWindow(wnd)
	wndCtrl:luaSetSelectorOnEvent(ctrlEvent)
	local scene = SCBaseScene:getRunningScene()
	local naviCtrl =  scene:getNavigationController()
	naviCtrl:pushWindowController(wndCtrl)
	
	--m_wnd =  getCurentSceneWindowController(8008):getWindow();
	
	local width  = SX(480)--当前屏幕宽
    local height = SY(320)--当前屏幕高
    
    local showWidth  = width*0.94
    local showHeight = height*0.78
    local startX = SX(15)
    local startY = SY(15)
    
    local strengthLayer = SCDragNode:node()
    strengthLayer:setTag(800801)
    strengthLayer:setFrameVisibled(true)
    --strengthLayer:setFrameType(EnumFrameTypeRound)
    strengthLayer:setAnchorPoint(CCPointMake(0,0));
	strengthLayer:setPosition(CCPointMake(startX,startY));
	strengthLayer:setContentSize(CCSizeMake(showWidth,showHeight))
	
	createStrengthLayer(strengthLayer)
	
	--m_wnd:addChild(strengthLayer)
	
	local topLayer = SCDragNode:node()
    topLayer:setTag(800802)
    topLayer:setFrameVisibled(true)
    topLayer:setFrameType(EnumFrameTypeListNormal)
    topLayer:setAnchorPoint(CCPointMake(0,0.5));
	topLayer:setPosition(CCPointMake(width*0.32,height*0.91));
	topLayer:setContentSize(CCSizeMake(SX(120),SY(18)))
    --m_wnd:addChild(topLayer)
	
	local pMultiPage = SCMultiPage:pageWithType(EnumMultiPageTypeLarge);
	if pMultiPage then
        local pDragNode = SCDragNode:node();
        if pDragNode then
                --pDragNode:setFrameVisibled(true)
                --pDragNode:setFrameType(EnumFrameTypeListNormal)
                --pDragNode:setContentSize(CCSizeMake(450, 300));
            pDragNode:setTag(0);
            pDragNode:addChild(topLayer);
            pDragNode:addChild(strengthLayer);
            pMultiPage:addPage(pDragNode);
		    pMultiPage:setTitleAtPage(L("str0118") .. L("str0297"), DEFAULT_FONT_NAME, F(12), 0);    
            m_wnd = pDragNode; 
        end
        pDragNode = SCDragNode:node();
        if pDragNode then
            pDragNode:setTag(1);
            pMultiPage:addPage(pDragNode);
		    pMultiPage:setTitleAtPage(L("str6143"), DEFAULT_FONT_NAME, F(12), 1);            
        end
	    pMultiPage:setContentSize(SCREEN_SIZE);
	    wnd:addChild(pMultiPage);
	    pMultiPage:setTag(1);
	end
    
    initShowMoney()

end
