--新手功能提示窗口

FunctionTip = {}

local m_wndObjectTable = {}--因为可能同时开启多个界面，用来存储所有窗口

--点击按钮响应
local function openButtonAction(tag)
    if tag then
        local dt = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
        dt:writeShort(USERINFO_FUNCTION_PATHING);
        dt:writeByte(tag);--functionType
        SCDataTransThread:getSingleton():transData(dt);
        
        if m_wndObjectTable then
            local amount = #m_wndObjectTable
            for index,object in pairs(m_wndObjectTable) do 
                if object.m_functionType == tag then
                    m_pMainInterface:removeChild(object.m_frameWndNode,true)
                    object = nil
                    m_wndObjectTable[index] = nil
                end
            end
        end
    end
end

--直接点击关闭按钮
function coloseWnd_FunctionTip(tag)
    for index,object in pairs(m_wndObjectTable) do 
        if object.m_functionImageId == tag then
            object = nil
            m_wndObjectTable[index] = nil
            return
        end
    end
end

--功能提示 8003窗口
function FunctionTip:new(width,height,px,py)
    local instance = {}
	setmetatable(instance, self)
	self.__index = self
	
	local window_Width  = width
	local window_Height = height
	local frameWndNode = FrameWindow:frameWnd()
	frameWndNode:setContentSize(CCSizeMake(window_Width, window_Height))
	frameWndNode:setOutSpaceClickClose(true)
	frameWndNode:setAnchorPoint(CCPointMake(0, 0))
	frameWndNode:setPosition(CCPointMake(px,py))
	frameWndNode:luaSetReturnSelector(coloseWnd_FunctionTip)
	
	local functionName = nil
	local functionImageId = nil
	local functionDetail = nil
	local buttonName = nil
	local functionType = nil
	
	function showFunctionTip()
	    
	    local lineImg = nil
	    if functionType == 3 then--技能
	        local imgFile = getRealUIResourcePath("Skill/"..functionImageId..".png");
	        if imgFile then
	            lineImg = SCImage:imageWithFile(imgFile:getData())  
            end
        else--头像
            lineImg = getFaceImg(functionImageId)
        end
	    if lineImg then
	        lineImg:setVisible(true)
            lineImg:setAnchorPoint(CCPointMake(0,0));
            lineImg:setPosition(CCPointMake(SX(15),window_Height-lineImg:getContentSize().height-SY(15)));
            frameWndNode:addChild(lineImg)
	    end
	    
	    --名称
	    if functionName then
	        local nameLabel = SCLabel:labelWithStringFont(functionName,getDefaultFontName(), getFontSize(10))
            nameLabel:setAnchorPoint(CCPointMake(0,0));
            nameLabel:setPosition(CCPointMake(window_Width*0.38,window_Height-nameLabel:getContentSize().height-SY(15)));
            nameLabel:setColor(getColorYellow())
            frameWndNode:addChild(nameLabel)
        end
        
        --描述
        if functionDetail then
            local showTextLabel = SCText:textWithWidthFont(window_Width*0.55,getDefaultFontName(), getFontSize(10));
            showTextLabel:setAnchorPoint(CCPointMake(0,0));
            showTextLabel:setPosition(CCPointMake(window_Width*0.38,window_Height*0.7));
            showTextLabel:addNormalText(functionDetail,getColorGreen())
            frameWndNode:addChild(showTextLabel)
        end
        --按钮
        if buttonName then
            local openButton = SCButton:button(EnumBtnType9Atlas)
            openButton:setTag(functionType)
            openButton:setTitle(buttonName,getDefaultFontName(), getFontSize(12),getColorWhite())
            openButton:setContentSize(CCSizeMake(SX(80), SY(20)))
            openButton:setAnchorPoint(CCPointMake(0,0));
            openButton:setPosition(CCPointMake((window_Width-openButton:getContentSize().width)/2,SY(10)));
            openButton:luaSetSelectorOnClicked(openButtonAction)--设置回调
            frameWndNode:addChild(openButton)         
        end
    end
	
	function instance:porcessFunctionInfo(dt)
	    if dt then
	        local name        = dt:readString()--//提示 
            local detail      = dt:readString()--//提示描述
            functionImageId   = dt:readInt()--//图片id
            local btName      = dt:readString()
            functionType      = dt:readByte()--//寻路类型 ucType=1 伙伴招募 2 伙伴转职 3 技能修炼
            
            if name then
	            functionName = name:getData()
            end
            if detail then
                functionDetail = detail:getData()
            end
            if btName then
                buttonName = btName:getData()
            end
            
            frameWndNode:setTag(functionImageId)--用图片来区分不同类型
            instance.m_functionImageId = functionImageId
            instance.m_functionType = functionType
            showFunctionTip()
        end
    end

	instance.m_frameWndNode = frameWndNode
	return instance
end

--打开功能提示窗
function open_FunctionTip()
    m_pMainInterface = getMainInterface()
	if m_pMainInterface == nil then
		return
	end
	local window_Width  = SX(150)
	local window_Height = SY(100)
	local window_startX = getScreenWidth()-window_Width-SX(50)
	local window_startY = SY(50)
	
    
	local functionTip = FunctionTip:new(window_Width,window_Height,window_startX,window_startY)
	if functionTip then
	    local dt = LuaData:getSingleton():getDataTransStream();
	    functionTip:porcessFunctionInfo(dt)		
	    m_pMainInterface:addChild(functionTip.m_frameWndNode)
	    
        if m_wndObjectTable == nil then
	        m_wndObjectTable = {}
        end
	    table.insert(m_wndObjectTable,functionTip)
    end
end

LuaData:getSingleton():luaSetSelectorOnRecvData(open_FunctionTip, LuaData_USERINFO_FUNCTION_PROMPT);