--获取整数部分
function getIntPart(x)
--[[
    if x <= 0 then
       return math.ceil(x);
    end

    if math.ceil(x) == x then
       x = math.ceil(x);
    else
       x = math.ceil(x) - 1;
    end
    return x;
]]
    return math.modf(x);
end

--将数字转换为时分秒
Hour_Min_Sec = 1
Min_Sec		 = 2
function makeTime(dwTime, type)
    if dwTime == nil then
        return "0"
    end
    local timeStr = "";
    local hour = getIntPart(dwTime/3600);
    local min = getIntPart((dwTime%3600)/60);
    local sec = (dwTime%3600)%60;
    if type == Hour_Min_Sec then
		timeStr = timeStr..hour..":"
	end
	if type == Min_Sec or type == Hour_Min_Sec then
		if min < 10 then
			timeStr = timeStr.."0"
		end
		timeStr = timeStr..min..":"
		if sec < 10 then
			timeStr = timeStr.."0"
		end
		timeStr = timeStr..sec
    else
		if hour ~= 0 then
			timeStr = timeStr..hour..":";
		end
		if min < 10 and hour ~= 0 then
			timeStr = timeStr.."0"..min..":";
		elseif min ~= 0 then
			timeStr = timeStr..min..":";
		end
		if sec < 10 and min ~= 0 then
			timeStr = timeStr.."0"..sec;
		elseif sec ~= 0 then
			timeStr = timeStr..sec;
		end
	end
    return timeStr;
end

--字符串切割
function Split(str, delim, maxNb)   
    -- Eliminate bad cases...   
    if string.find(str, delim) == nil then  
        return { str }  
    end  
    if maxNb == nil or maxNb < 1 then  
        maxNb = 0    -- No limit   
    end  
    local result = {}  
    local pat = "(.-)" .. delim .. "()"   
    local nb = 0  
    local lastPos   
    for part, pos in string.gfind(str, pat) do  
        nb = nb + 1  
        result[nb] = part   
        lastPos = pos   
        if nb == maxNb then break end  
    end  
    -- Handle the last field   
    if nb ~= maxNb then  
        result[nb + 1] = string.sub(str, lastPos)   
    end  
    return result   
end

--根据长度换行
--len 按中文字数分行
function getNewLinStr(str, number)
	local strbuf = str
	local temp = "";
	local colorMarkStr = "";
	local strlen = string.len(strbuf);
	local index = 1;
	local num = 1;
	local mark = 1;
	local isdigital = 0;
	local colorMark = 0;
	local markStander = 1;
	local i = 1
	while string.char(string.byte(strbuf, i)) ~= "" do
		local ch = string.char(string.byte(strbuf, i))
		if ch == "_" then
			temp = temp..string.sub(strbuf, index, index);
			index = index+1;
			i = i+1;
			num = 1;
			isdigital = 0;
		elseif ch == '*' then
			colorMarkStr = "";
			temp = temp..string.sub(strbuf, index, index);
			colorMarkStr = colorMarkStr..string.sub(strbuf, index, index);
			index = index + 1;
			i = i+1;
			ch = string.char(string.byte(strbuf, i))
			if ch ~= "" and ch >= '0' and ch <= '9' then
				temp = temp..string.sub(strbuf, index, index);
				colorMarkStr = colorMarkStr..string.sub(strbuf, index, index);
				index = index+1;
				i = i+1;
			end
		else
			if string.byte(strbuf, i) > 128 or string.byte(strbuf, i) < 0 then
			    if CLIENT_VERSION >= 328 then
                    if CC_TARGET_PLATFORM == CC_PLATFORM_WIN32 then
                        mark = 2;
                        markStander = 2;
                    else
                        mark = 3;
                        markStander = 3;
                    end
                else
                    mark = 3;
                    markStander = 3;
                end
            else
                mark = 1;
                isdigital = isdigital + 1;
            end

            temp = temp..string.sub(strbuf, index, index+mark-1);
            index = index + mark;
            i = i+mark;
            ch = string.char(string.byte(strbuf, i))
            if num >= number or (num == number - 1 and isdigital == 1 and mark ~= 1) then
                if ch ~= "" then
                    --showMessage(string.sub(strbuf, index-mark, index-1))
                    temp = temp.."_";
                    temp = temp..colorMarkStr;
                    num = 0;
                    if mark == 1 then
                        num = num + 1;
                    end		
                    isdigital = 0;
                end
            end
            if mark == markStander or isdigital == 2 then
                num = num + 1;
                if isdigital == 2 then
                    isdigital = 0;
                end
            end
		end
	end
	return temp
end

--确认框
function luashowConfirmationWindow(messge, WinType, nHandle)
    local kTagTipWnd = 888889
    local pRunningScene = getRunningScene() --tolua.cast(getRunningScene(), "SCBaseScene")
    if pRunningScene == nil then
        return
    end
    local pWnd = MessageWindow:windowWithContentType(messge, WinType);
    if pWnd then
		if nHandle then
			pWnd:luaSetYesOrNoClicked(nHandle);
		end
        pRunningScene:getUINode():addChild(tolua.cast(pWnd, "SCNode"), 2147483647, kTagTipWnd) --4294967295
    end
end

--确认提示框
function luashowConfirmationWindowPoint(messge, pointmessge, Sure, WinType, nHandle, close, type, upBox)  --Sure确认按钮
    local kTagTipWnd = 788889
    local pRunningScene = getRunningScene() --tolua.cast(getRunningScene(), "SCBaseScene")
    if pRunningScene == nil then
        return
    end
    local pWnd = MessageWindow:windowWithContentType(messge, WinType);
    if pWnd then
		if nHandle then
			pWnd:luaSetYesOrNoClicked(nHandle);
		end
		--[[local pLable = SCLabel:labelWithStringFont(pointmessge, DEFAULT_FONT_NAME, F(11));
		if pLable then
			pLable:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pLable:setColor(color_yellow)
			pLable:setPosition(CCPointMake(SX(30), pWnd:getContentSize().height/2 - SY(5)))
			pWnd:addChild(tolua.cast(pLable, "SCNode"));
		end--]]
		
		if upBox then
			local srcollBox = SCTextBox:boxWithWidthHeightFont(AUTO_W(295), AUTO_H(65), DEFAULT_FONT_NAME, F(11));
			if srcollBox then
				srcollBox:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
				srcollBox:setParserDelegate(TextParser:getSingleton())
				srcollBox:setText(pointmessge);
				srcollBox:setPosition(CCPointMake(SX(30), SY(45)))
				pWnd:addChild(tolua.cast(srcollBox, "SCNode"));
			end
		else
			local srcollBox = SCTextBox:boxWithWidthHeightFont(AUTO_W(295), AUTO_H(30), DEFAULT_FONT_NAME, F(11));
			if srcollBox then
				srcollBox:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
				srcollBox:setParserDelegate(TextParser:getSingleton())
				srcollBox:setText(pointmessge);
				srcollBox:setPosition(CCPointMake(SX(30), pWnd:getContentSize().height/2 - SY(29)))
				pWnd:addChild(tolua.cast(srcollBox, "SCNode"));
			end
		end
		if type == 1 then
            local Button = SCButton:button(EnumBtnType9Atlas)
            if Button then
                Button:setTag(1)
                Button:setAnchorPoint(CCPointMake(0.5, 0))
                Button:setContentSize(AUTO_SIZE(60, 30))
                Button:setPosition(CCPointMake(pWnd:getContentSize().width/2 -SX(80), SY(15)))
                Button:setTitle(Sure, DEFAULT_FONT_NAME, F(13), color_yellow); 
                Button:luaSetSelectorOnClicked(nHandle)
                pWnd:addChild(tolua.cast(Button, "SCNode"));
            end
            
            local Button1 = SCButton:button(EnumBtnType9Atlas)
            if Button1 then
                Button1:setTag(0)
                Button1:setAnchorPoint(CCPointMake(0.5, 0))
                Button1:setContentSize(AUTO_SIZE(60, 30))
                Button1:setPosition(CCPointMake(pWnd:getContentSize().width/2 +SX(80), SY(15)))
                Button1:setTitle(L("str0237"), DEFAULT_FONT_NAME, F(13), color_yellow); 
                Button1:luaSetSelectorOnClicked(close)
                pWnd:addChild(tolua.cast(Button1, "SCNode"));
            end
        end
        pRunningScene:getUINode():addChild(tolua.cast(pWnd, "SCNode"), 2147483647, kTagTipWnd) --4294967295
    end
end

function luaShowTip(message, szBtnName, nCount, nHandle, title, perLineSize)
    local kTagTipWnd = 888888
    local pRunningScene = getRunningScene() --tolua.cast(getRunningScene(), "SCBaseScene")
    if pRunningScene == nil then
        return
    end
    if pRunningScene:getUINode():getChildByTag(kTagTipWnd) then
        pRunningScene:getUINode():removeChildByTag(kTagTipWnd, true)
    end
    
    local pWnd = TipWindow:newWindow()
	if perLineSize then
		--tolua.cast(pWnd, "SCDragNode"):setContentSize(CCSizeMake(perLineSize*2*13+SX(30), 0))
		pWnd:setContent(message, perLineSize)
	else
		pWnd:setContent(message)
	end
    if szBtnName and nCount then
        pWnd:setBtnList(szBtnName, nCount)
    end
    if nHandle then
        pWnd:luaSetReturnSelector(nHandle)
    end
    if title then
		pWnd:setTitle(title)
    end
    pRunningScene:getUINode():addChild(tolua.cast(pWnd, "SCNode"), 2147483647, kTagTipWnd) --4294967295
    return pWnd
end

function luaShowTipHaveIcon(message, title, iconPath, szBtnName, nCount, nHandle, fScaleValue)
	local kTagTipWnd = 888888
    local pRunningScene = getRunningScene() --tolua.cast(getRunningScene(), "SCBaseScene")
    if pRunningScene == nil then
        return
    end
    if pRunningScene:getUINode():getChildByTag(kTagTipWnd) then
        pRunningScene:getUINode():removeChildByTag(kTagTipWnd, true)
    end
    
    local pWnd = TipWindow:newWindow()
	if not pWnd then
		return
	end
	
	local pImgBg = nil
	local pImg = nil
	
	if iconPath then
		pImg = SCImage:imageWithFile(iconPath:getData())
		if pImg then
			local strPath = getRealUIResourcePath("img/new00002.png")
			if strPath then
				pImgBg = SCImage:imageWithFile(strPath:getData())
				if pImgBg then
					pImgBg:setAnchorPoint(CCPointMake(1, 1));
					if fScaleValue then
						pImgBg:setScale(fScaleValue);
				    else
				        pImgBg:setScale(0.7);
					end
					pImg:setAnchorPoint(CCPointMake(0.5, 0.5));
					local size = pImgBg:getContentSize();
					pImg:setPosition(CCPointMake(size.width / 2, size.height / 2));
					tolua.cast(pWnd, "SCNode"):addChild(pImgBg);
					pImgBg:addChild(pImg);
					if getNodeContentSize(pWnd).height < getNodeContentSize(pImgBg).height+20 then
                        pWnd:setContentSize(CCSizeMake(pWnd:getContentSize().width + SX(40), pImg:getContentSize().height + SY(40)));
                    else
                        pWnd:setContentSize(CCSizeMake(pWnd:getContentSize().width + SX(40), pWnd:getContentSize().height));
                    end
				end
				tolua.cast(pWnd, "SCNode"):setContentSize(CCSizeMake(tolua.cast(pWnd, "SCNode"):getContentSize().width + SX(40), tolua.cast(pWnd, "SCNode"):getContentSize().height));
			end
		end
	end
	
	pWnd:setContent(message, 18)
	
    if szBtnName and nCount then
        if 1 == nCount then
            pWnd:setBtnList(szBtnName, nCount)
            local pBtn = tolua.cast(pWnd:getChildByTag(0), "SCButton")
            if pBtn then
                pBtn:setAnchorPoint(CCPointMake(0.5, 1))
                pBtn:setPosition(CCPointMake(pWnd:getContentSize().width/2, pBtn:getPosition().y))
            end
            --pWnd:setContentSize(CCSizeMake(pWnd:getContentSize().width, pWnd:getContentSize().height+SY(10)))
        else
            pWnd:setBtnList(szBtnName, nCount)
        end
    end
    if nHandle then
        pWnd:luaSetReturnSelector(nHandle)
    end
    
	if title then
		pWnd:setTitle(title, false)
    end
    
	if pImgBg then
		pImgBg:setPosition(CCPointMake(tolua.cast(pWnd, "SCNode"):getContentSize().width - SX(15), tolua.cast(pWnd, "SCNode"):getContentSize().height - SY(12)))
	end

    pRunningScene:getUINode():addChild(tolua.cast(pWnd, "SCNode"), 2147483647, kTagTipWnd) --4294967295
    return pWnd
end

function GlobalFunction_luaShowTip(message, szBtnName, btnNameSize, nHandle, WinType, closeBtnVisible, bRemoveWin, kTagTipWnd)
    if kTagTipWnd == nil then
        return
    end
    
    local pRunningScene = getRunningScene() --tolua.cast(getRunningScene(), "SCBaseScene")
    if pRunningScene == nil then
        return
    end
    if pRunningScene:getUINode():getChildByTag(kTagTipWnd) then
        pRunningScene:getUINode():removeChildByTag(kTagTipWnd, true)
    end
    
    local pWnd = MessageWindow:windowWithContentType(message, WinType);
    if pWnd then
		if nHandle then
			pWnd:luaSetYesOrNoClicked(nHandle);
		end
		
		if szBtnName then
		    pWnd:setOneButtonName(szBtnName, btnNameSize);
		end
		
		if closeBtnVisible then
		    pWnd:setCloseBtnVisible(closeBtnVisible);
		end
		
		if bRemoveWin ~= nil then
		    pWnd:setIsRemoveWindow(bRemoveWin);
		end
    end
    
    pRunningScene:getUINode():addChild(tolua.cast(pWnd, "SCNode"), 2147483647) --4294967295
    return pWnd
end

function GlobalFunction_luaRemoveTip(kTagTipWnd)
    if kTagTipWnd == nil then
        return
    end

    local pRunningScene = getRunningScene()
    if pRunningScene == nil then
        return
    end
    
    pRunningScene:getUINode():removeChildByTag(kTagTipWnd, true)
end

function GlobalFunction_luaUpdataTip(message, kTagTipWnd)
    if kTagTipWnd == nil then
        return
    end
    
    local pRunningScene = getRunningScene()
    if pRunningScene == nil or message == nil then
        return
    end
    
    local pWnd = pRunningScene:getUINode():getChildByTag(kTagTipWnd)
    if pWnd == nil then
        return
    end
   
   local messageWindow = tolua.cast(pWnd, "MessageWindow")
   messageWindow:setContent(message);
end

function luaShowBattleMessage(message, winType, nHandle)
    local messageWindow = luaShowMessage(message, winType);
    if messageWindow and nHandle then
        messageWindow:luaSetYesOrNoClicked(nHandle);
    end
end

function NULL()

end
--获取头像的SCPath
function getFaceImagePath(faceId)
	if not faceId then
		return nil;
	end
	
	if faceId < 10000 then
	    return nil;
	end
	
    local filePath = getRealUIResourcePath("faceicon/"..faceId..".jpg")
    return filePath
end
--获取职业
function getProfession()
	local id = Hero:getSingleton():getProfessionID();
	local str = "str604";
	str = str .. id;
	return _LTParser(str);
end

--获取总个数
function getNumberCount(number)
    local num = 1;
    if number >= 1000000000 then
        num = 10;
    elseif number < 1000000000 and number >= 100000000 then 
        num = 9;
    elseif number < 100000000 and number >= 10000000 then
        num = 8;
    elseif number < 10000000 and number >= 1000000 then
        num = 7;
    elseif number < 1000000 and number >= 100000 then
        num = 6;
    elseif number < 100000 and number >= 10000 then
        num = 5;
    elseif number < 10000 and number >= 1000 then
        num = 4;
    elseif number < 1000 and number >= 100 then
        num = 3;
    elseif number < 100 and number >= 10 then
        num = 2;
    elseif number < 10 and number >= 0 then
        num = 1;
    end
    
    return num;
end

--切割数字图片  参数：1.值，2.图片路径
function getImageNumber(number, imagePath, width, height, gap)
	if number == nil or imagePath == nil or width == nil or height == nil then
		return
	end

	local filePath = getRealUIResourcePath(imagePath);
	if filePath == nil then
		return;
	end
	
	if number < 0 then
	    return;
	end
	
	local count = getNumberCount(number)
	if count <= 0 then
	    return
	end
	local bgNode = SCNode:node();
	if bgNode then
	    bgNode:setContentSize(CCSizeMake(count * width, height));
        local tmpNum = number;
        if tmpNum == 0 then
            local image = SCImage:imageWithFile(filePath:getData(), CCRectMake(0, 0, width, height));
            if image then
                image:setAnchorPoint(CCPointMake(0, 0));
                image:setPosition(CCPointMake(0, 0));
                bgNode:addChild(image);
            end
        else
            while tmpNum ~= 0 do
                local index = math.floor(math.mod(tmpNum, 10));
                if index >= 0 and index <= 9 then
                    count = count - 1;
                    local image = SCImage:imageWithFile(filePath:getData(), CCRectMake(index * width, 0, width, height));
                    if image then
                        image:setAnchorPoint(CCPointMake(0, 0));
                        if gap then
                            image:setPosition(CCPointMake(count * gap, 0));
                            bgNode:setContentSize(CCSizeMake(bgNode:getContentSize().width + gap, image:getContentSize().height));
                        else
                            image:setPosition(CCPointMake(count * image:getContentSize().width, 0));
                            bgNode:setContentSize(CCSizeMake(bgNode:getContentSize().width + image:getContentSize().width, image:getContentSize().height));
                        end
                        bgNode:addChild(image);
                        
                        tmpNum = tmpNum / 10;
                        if tmpNum < 1 then
                            tmpNum = 0;
                        end
                    end
                end
            end
        end
    end
	
	return bgNode;
end

--自动寻路结束回调
function GlobalFunction_onFindRoadEnd()
	local Lev = Hero:getSingleton():getLeval()
    if Lev <= 27 then
		local pNode = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-1007-2-1"), "SCNode")
		if pNode then
		    pNode:setVisible(true);
		end
	end
end

function getPlatFormFlag()  -- 0 官网  1 平台 2 宝软
        local platFormType = getPlatFormType():getData();  -- "_CMP" "_CMP_" "_KDSG"
        if string.match(platFormType, "_CMP_") ~= nil then  --表示宝软
              return 2;
        elseif string.match(platFormType, "IMPORT_KDSG") ~= nil then  --表示官网
              return 0;
        else  --表示平台
              return 1;
        end
        
end

function getColorString(itemType)
    local colorId = itemType%10
    local col = "*";
	if colorId == 9 then
		col = col.."5"; --// "橙色"
	elseif colorId == 8 then
		col = col.."6"; --// "紫色"
	elseif colorId == 7 then
		col = col.."7"; --// "蓝色"
	elseif colorId == 6 then
		col = col.."4"; --// "绿色"
	elseif colorId == 5 then
		col = col.."3"; --// "绿色"
	elseif colorId == 4 then
		col = col.."0";
	else 
		col = col.."0"; --// 白色
	end
	return col
end

function luaCheckCharIsLegitimacy(text)
     if checkCharIsLegitimacy(text)==false then
         return false;
     end
    local value = string.byte(text);
    if value==34 or value==39 or value == 96 then  --后面加的
        return false;
    end
    return true;
end

function luaIntToUInt(intValue)
	if type(intValue) ~= "number" then
		return 0
	end
	return string.format("%u", intValue) + 0
end
--创建图片倒计时node
function newImgCountDownNodeWithTime(nTime, nHandle)
    if nTime <= 0 then
        return nil
    end
    local m_nTime = nTime
    local m_nHandle = nHandle
    local m_nEntryID = nil
    local m_node = nil
    
    local function getCountDownImage( totalSeconds )
        local imgPath = getRealUIResourcePath("img/img7099.png");
        if nil == imgPath then
            return nil
        end
        local seconds = totalSeconds % 60;
        local minute = math.modf(totalSeconds/60) % 60;
        local first = 0;
        local second = 0;
        local width = SX(15.9)
        local height = SY(20)
        local node = SCNode:node();
        if nil == node then
            return nil
        end
        node:setContentSize(CCSizeMake(5 * width, height));
        if minute >= 10 then
            first = math.modf(minute/10)
            if first >= 10 then
                first = 9
            end
            second = minute%10;
            local pImageFirst = SCImage:imageWithFile(imgPath:getData(), CCRectMake(first * width, 0, width, height));
            local pImageSecond = SCImage:imageWithFile(imgPath:getData(), CCRectMake(second * width, 0, width, height));
            if pImageFirst and pImageSecond then
                pImageFirst:setPosition(CCPointMake(0, 0));
                pImageFirst:setTag(0);
                node:addChild(pImageFirst);
                pImageSecond:setPosition(CCPointMake(width, 0));
                pImageSecond:setTag(1);
                node:addChild(pImageSecond);
            end
        else
            local pImageFirst = SCImage:imageWithFile(imgPath:getData(), CCRectMake(0, 0, width, height));
            local pImageSecond = SCImage:imageWithFile(imgPath:getData(), CCRectMake(minute * width, 0, width, height));
            if pImageFirst and pImageSecond then
                pImageFirst:setPosition(CCPointMake(0, 0));
                pImageFirst:setTag(0);
                node:addChild(pImageFirst);
                pImageSecond:setPosition(CCPointMake(width, 0));
                pImageSecond:setTag(1);
                node:addChild(pImageSecond);
            end
        end

        if seconds >= 10 then
            first = math.modf(seconds/10);
            if first >= 10 then
                first = 9
            end
            second = seconds%10;
            local pImageFirst = SCImage:imageWithFile(imgPath:getData(), CCRectMake(first * width, 0, width, height));
            local pImageSecond = SCImage:imageWithFile(imgPath:getData(), CCRectMake(second * width, 0, width, height));
            if pImageFirst and pImageSecond then
                pImageFirst:setPosition(CCPointMake(3 * width, 0));
                pImageFirst:setTag(3);
                node:addChild(pImageFirst);
                pImageSecond:setPosition(CCPointMake(4 * width, 0));
                pImageSecond:setTag(4);
                node:addChild(pImageSecond);
            end
        else
            local pImageFirst = SCImage:imageWithFile(imgPath:getData(), CCRectMake(0, 0, width, height));
            local pImageSecond = SCImage:imageWithFile(imgPath:getData(), CCRectMake(seconds * width, 0, width, height));
            if pImageFirst and pImageSecond then
                pImageFirst:setPosition(CCPointMake(3 * width, 0));
                pImageFirst:setTag(3);
                node:addChild(pImageFirst);
                pImageSecond:setPosition(CCPointMake(4 * width, 0));
                pImageSecond:setTag(4);
                node:addChild(pImageSecond);
            end
        end

        local res = getRealUIResourcePath("img/new00595.png");
        if res then
            local pImg = SCImage:imageWithFile(res:getData());
            if pImg then
                pImg:setPosition(CCPointMake(2 * width + SX(5), SY(3)));
                node:addChild(pImg);
            end
        end

        return node;
    end
    local function enterExitEvent(eventType)
        if eventType == kCCNodeOnEnter then
            
        elseif eventType == kCCNodeOnExit then
            if nil ~= m_nEntryID then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_nEntryID);
                m_nEntryID = nil;
            end
        end
    end
    local function upDateTime(nTime)
        if m_nTime <= 0 then
            if nil ~= m_nEntryID then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_nEntryID);
                m_nEntryID = nil;
                if m_nHandle then
                    m_nHandle(m_node:getTag())
                end
            end
            return
        end
        m_nTime = m_nTime - 1
        local childNode = getCountDownImage(m_nTime)
        if nil == childNode then
            return nil
        end
        m_node:removeChildByTag(12000, true)
        childNode:setTag(12000)
        m_node:addChild(childNode)
    end
    
    local childNode = getCountDownImage(m_nTime)
    if nil == childNode then
        return nil
    end
    m_node = SCNode:node()
    m_node:setContentSize(childNode:getContentSize())
    childNode:setTag(12000)
    m_node:registerScriptHandler(enterExitEvent)
    m_node:addChild(childNode)
    m_nEntryID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(upDateTime, 1.0, false)
    
    return m_node
end

function G_Min(a, b)
	if a > b then
		return b
	end
	return a
end

function G_Max(a, b)
	if a > b then
		return a
	end
	return b
end

function GlobalFunction_getPhotoByPrfession(profession)
	local file = getRealUIResourcePath("img/new00627.png")
	if profession == nil then
		return file
	end
	
	if 1 == profession then
	elseif 2 == profession then
		file = getRealUIResourcePath("img/new00630.png")
	elseif 3 == profession then
		file = getRealUIResourcePath("img/new00629.png")
	elseif 4 == profession then
		file = getRealUIResourcePath("img/new00628.png")
	end
	
	return file
end

function GlobalFunction_getIsSpeciaItem(index)
	local CUSTOM_AWARD_MONEY = 1--, //金钱
	local CUSTOM_AWARD_REPUTATION = 5--, //声望
	local CUSTOM_AWRAD_EMONEY = 7--,	//仙晶
	local CUSTOM_AWARD_LIFE_CRYSTAL = 8--, //生命水晶
	local CUSTOM_AWARD_TIRED = 9--,	//体力
	local CUSTOM_AWARD_CURRENCY1 = 101--,	//战功
	local CUSTOM_AWARD_CURRENCY2 = 102--,	//复活币 
	local CUSTOM_AWARD_CURRENCY3 = 103--,	//灵石
	local CUSTOM_AWARD_CURRENCY4 = 104--,	//荣誉
	local CUSTOM_AWARD_CURRENCY5 = 105--,	//神玉
	local icon = nil
	local bSpeciaItem = true;
	local strName = nil
	if index == CUSTOM_AWARD_MONEY then
		icon = 2001001
		strName = L("str5167")
	elseif index == CUSTOM_AWARD_REPUTATION then
		icon = 2001003
		strName = L("str5168")
	elseif index == CUSTOM_AWRAD_EMONEY then
		icon = 2001008
		strName = L("str5169")
	elseif index == CUSTOM_AWARD_LIFE_CRYSTAL then
		icon = 2001004
		strName = L("str8161")
	elseif index == CUSTOM_AWARD_TIRED then
		icon = 2001005
		strName = L("str5170")
	elseif index == CUSTOM_AWARD_CURRENCY1 then
		icon = 2001006
		strName = L("str5171")
	elseif index == CUSTOM_AWARD_CURRENCY2 then
	elseif index == CUSTOM_AWARD_CURRENCY3 then
		icon = 2005003;
	elseif index == CUSTOM_AWARD_CURRENCY4 then
		icon = 2005002
	elseif index == CUSTOM_AWARD_CURRENCY5 then
		icon = 2001017
	else
		bSpeciaItem = false
	end
	
	return bSpeciaItem,icon,strName
end

--用于处理托管按钮是否显示
function GlobalFunction_IsShowAutoFightBtn()
	local ret = 0
	local level = Hero:getSingleton():getLeval()
	if level >= 30 then
		ret = 1
	end
	
	return ret;
end

--获取技能阶数及等级颜色
function GlobalFunction_getSkillLevelMsg(pLevel)
	local ani = nil;
	local level = pLevel
	local levelIndex = 1;
	local color = color_white;
	if pLevel > 140 then
		level = level - 140;
		levelIndex = 8;
		color = colorLightYellow();
		ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1030, 1030);
	elseif pLevel > 120 then
		level = level - 120;
		levelIndex = 7;
		color = colorLightYellow();
		ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1030, 1030);
	elseif pLevel > 100 then
		level = level - 100;
		levelIndex = 6;
		color = colorLightYellow();
		ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1030, 1030);
	elseif pLevel > 80 then
		level = level - 80;
		levelIndex = 5;
		color = colorYellow();
		ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1015, 1015);
	elseif pLevel > 60 then
		level = level - 60;
		levelIndex = 4;
		color = colorPurple();
		ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1014, 1014);
	elseif pLevel > 40 then
		level = level - 40;
		levelIndex = 3;
		color = colorSkyBlue();
		ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1013, 1013);
	elseif pLevel > 20 then
		level = level - 20;
		levelIndex = 2;
		color = colorGreen();
		ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1012, 1012);
	end
	return ani,level,levelIndex,color
end

--获取属性类型名称两个字
function GlobalFunction_getAttributeNameByTypeId(typeId)
	local str = nil 
	if 4923 == typeId then --暴击
		str = _LTParser("str8131")
	elseif 4211 == typeId then --物理防御
		str = _LTParser("str9145")
	elseif 4571 == typeId then --技能攻击
		str = _LTParser("str9144")
	elseif 4581 == typeId then --技能防御
		str = _LTParser("str9146")
	elseif 4111 == typeId then --物理攻击
		str = _LTParser("str9143")
	elseif 4963 == typeId then --暴击抵抗
		str = _LTParser("str8125")
	elseif 2021 == typeId then --智力
		str = _LTParser("str8128")
	elseif 2011 == typeId then --武力
		str = _LTParser("str8127")
	elseif 4981 == typeId then --破甲伤害
		str = _LTParser("str3343")
	elseif 4811 == typeId then --减免伤害
		str = _LTParser("str3342")
	elseif 4551 == typeId then --生命
		str = _LTParser("str5069")
	end
	return str
end

--获取属性类型名称四字
function GlobalFunction_getAttributeNameByTypeIdOfHunter(typeId)
	local str = "" 
	if 4923 == typeId then --暴击
		str = _LTParser("str3354")
	elseif 4211 == typeId then --物理防御
		str = _LTParser("str0389")
	elseif 4571 == typeId then --技能攻击
		str = _LTParser("str0390")
	elseif 4581 == typeId then --技能防御
		str = _LTParser("str0391")
	elseif 4111 == typeId then --物理攻击
		str = _LTParser("str0388")
	elseif 4963 == typeId then --暴击抵抗
		str = _LTParser("str0405")
	elseif 2021 == typeId then --智力
		str = _LTParser("str8128")
	elseif 2011 == typeId then --武力
		str = _LTParser("str8127")
	elseif 4981 == typeId then --破甲伤害
		str = _LTParser("str0402")
	elseif 4811 == typeId then --减免伤害
		str = _LTParser("str0403")
	elseif 4551 == typeId then --生命
		str = _LTParser("str3353")
	elseif 4971 == typeId then --暴击伤害
		str = _LTParser("str0406")
	elseif 4961 == typeId then --暴击抵抗
		str = _LTParser("str0405")
	elseif 4921 == typeId then --暴击
		str = _LTParser("str3354")
	end
	return str
end

function GlobalFunction_getPlotDailogHeroPhoto()
    local profession = Hero:getSingleton():getProfessionID();
    if 1 == profession then
        return 5000020;
    elseif 2 == profession then
        return 5000017;
    elseif 3 == profession then
        return 5000018;
    elseif 4 == profession then
        return 5000019;
    elseif 5 == profession then
        return 5000021;
    end
end

