--资料馆
local m_titleList = nil

local m_leftContent_startX = nil
local m_leftContent_startY = nil
local m_leftContent_width  = nil
local m_leftContent_height = nil

local m_rightContent_startX = nil
local m_rightContent_startY = nil
local m_rightContent_width  = nil
local m_rightContent_height = nil

local m_currentTitleDetail = nil--当前选择的详细信息

--列表点击
local function titleButtonAction(tag)
    if m_titleList[tag] then
        sendQueryHelpDetail_HelpSystem( m_titleList[tag].titleId)
    end
end

--详细按钮点击
local function showAllDetailAction(tag)
    if m_currentTitleDetail then
        if m_currentTitleDetail.titleId ~=0 then
            sendQueryHelpAllDetail_HelpSystem(m_currentTitleDetail.titleId)
        end 
    end
end

--显示右半边详细信息
local function showDetailContent()
	local wnd = nil
	if getCurentSceneWindowController(8002) then
		wnd =  getCurentSceneWindowController(8002):getWindow();
		if wnd == nil then
			return
		end
	else
		return
	end
    
    local backDragNodeLayer = wnd:getChildByTag(800202);
    backDragNodeLayer = SCTypeCast:castNodeToDragNode(backDragNodeLayer)
    if backDragNodeLayer == nil then
        return
    end
    backDragNodeLayer:removeAllChildrenWithCleanup(true)
    
    if m_currentTitleDetail == nil then
        return
    end
    
    --标题
    local titleName = m_currentTitleDetail.titleName
    if titleName == nil then
        titleName = ""
    end
    local nameLabel = SCLabel:labelWithStringFont(titleName,getDefaultFontName(), getFontSize(20))
    nameLabel:setAnchorPoint(CCPointMake(0.5,0));
    nameLabel:setPosition(CCPointMake(m_rightContent_width/2-SX(3),m_rightContent_height-nameLabel:getContentSize().height-SY(20)));
    backDragNodeLayer:addChild(nameLabel)
    
    if m_currentTitleDetail.titleId ~= 0 then--0的话不显示详细按钮
        --详细按钮
        local showAllDetailButton = SCButton:button(EnumBtnType9Atlas)
        showAllDetailButton:setContentSize(SmallButton_Size)
        showAllDetailButton:setTitle(_LTParser("str8013"),getDefaultFontName(), getFontSize(12),Button_Normal_Color)
    
        showAllDetailButton:setAnchorPoint(CCPointMake(0,0));
        showAllDetailButton:setPosition(CCPointMake(m_rightContent_width-showAllDetailButton:getContentSize().width-SX(10),nameLabel:getPosition().y));
        showAllDetailButton:luaSetSelectorOnClicked(showAllDetailAction)--设置回调
        backDragNodeLayer:addChild(showAllDetailButton)
    end
    
    
    --横线
    local imgFile = getRealUIResourcePath("img/img0015.png");
	local lineImg = nil
	if imgFile then
	    lineImg = SCImage:imageWithFile(imgFile:getData())
	    lineImg:setVisible(true)
        lineImg:setAnchorPoint(CCPointMake(0.5,0));
        lineImg:setPosition(CCPointMake(m_rightContent_width/2,nameLabel:getPosition().y-SY(5)));
        backDragNodeLayer:addChild(lineImg)
	end
	
    --详细信息
	local detailStr = m_currentTitleDetail.detail
	if detailStr then
	    local showTextLabel = SCTextBox:boxWithWidthHeight(m_rightContent_width*0.9,m_rightContent_height*0.74);
	    showTextLabel:setParserDelegate(TextParser:getSingleton())
	    showTextLabel:setAnchorPoint(CCPointMake(0,0));
	    showTextLabel:setPosition(CCPointMake((m_rightContent_width-showTextLabel:getContentSize().width)/2,SY(15)));
	    showTextLabel:setText(detailStr)
        backDragNodeLayer:addChild(showTextLabel)
    end
	
end

--显示左半边内容
local function showTitleList()
    local wnd = nil
	if getCurentSceneWindowController(8002) then
		wnd =  getCurentSceneWindowController(8002):getWindow();
		if wnd == nil then
			return
		end
	else
		return
	end
    local backDragNodeLayer = wnd:getChildByTag(800201);
    backDragNodeLayer = SCTypeCast:castNodeToDragNode(backDragNodeLayer)
    if backDragNodeLayer == nil then
        return
    end
    backDragNodeLayer:removeAllChildrenWithCleanup(true)
    
    
    local titleListBox = SCListBox:boxWithWidthHeight(m_leftContent_width*0.9,m_leftContent_height*0.9)
	titleListBox:setPosition(CCPointMake((m_leftContent_width-titleListBox:getContentSize().width)/2,(m_leftContent_height-titleListBox:getContentSize().height)/2));
	backDragNodeLayer:addChild(titleListBox)
	
    if m_titleList == nil then
        return
    end
    
    local showWidth  = titleListBox:getContentSize().width
	local showHeight = 40
	local total = #m_titleList
	local amount = math.floor(total/2)
	if total>0 and math.mod(total,2) ~=0 then
	    amount = amount+1
    end
	
	local index = 1
	for i =1 , amount do 
        local content = SCNode:node()
        content:setAnchorPoint(CCPointMake(0,0));
	    content:setContentSize(CCSizeMake(showWidth,showHeight * gUIScale().y))
	    
	    local changeButton = SCButton:button(EnumBtnType9Atlas)
        changeButton:setContentSize(CCSizeMake(80 * gUIScale().x, 32 * gUIScale().y))
        changeButton:setTitle(m_titleList[index].titleName,getDefaultFontName(), getFontSize(12),Button_Normal_Color)
	    changeButton:setTag(index)
	    changeButton:setAnchorPoint(CCPointMake(0.5,0));
	    changeButton:setPosition(showWidth*0.23,5 * gUIScale().y)
        changeButton:luaSetSelectorOnClicked(titleButtonAction)--设置回调
        content:addChild(changeButton)
        index = index + 1 
        
        if index <= total then
            local changeButton = SCButton:button(EnumBtnType9Atlas)
            changeButton:setContentSize(CCSizeMake(80 * gUIScale().x, 32 * gUIScale().y))
	        changeButton:setTag(index)
	        changeButton:setAnchorPoint(CCPointMake(0.5,0));
	        changeButton:setPosition(showWidth*0.75,5 * gUIScale().y)
	        changeButton:setTitle(m_titleList[index].titleName,getDefaultFontName(), getFontSize(12),Button_Normal_Color)
            changeButton:luaSetSelectorOnClicked(titleButtonAction)--设置回调
            content:addChild(changeButton)
            index = index + 1 
        end
        titleListBox:addItem(content)
    end
end

--界面打开入口
local function open_HelpSystem()
    if getCurentSceneWindowController(8002) then--如果已经创建返回
        local wnd =  getCurentSceneWindowController(8002):getWindow();
        if wnd then
            return
        end
    end
    
    --获取创建窗口
    local wnd = SCWindow:window()
    wnd:setContentSize(CCSizeMake(SX(480), SY(320)))
    wnd:setTag(8002);
    wnd:luaSetSelectorOnClose(onClickClose_HelpSystem);--关闭
    wnd:setBackgroundColor(colorWindowRedBG());--设置背景颜色
    local titlefile = getRealUIResourcePath("img/titile18.png")
    if titlefile then
		wnd:setTitleWithImage(titlefile:getData())
    end
	--wnd:setTitle(_LTParser("str8012"), getDefaultFontName(), gDefaultFontSize);--资料馆
	local wndCtrl = SCWindowController:controllerWithWindow(wnd)
	
	local scene = SCBaseScene:getRunningScene()
	local naviCtrl =  scene:getNavigationController()
	naviCtrl:pushWindowController(wndCtrl)
	
	
	
	m_leftContent_startX = SX(10)
	m_leftContent_startY = SY(10)
	m_leftContent_width  = wnd:getContentSize().width*0.39
	m_leftContent_height = wnd:getContentSize().height*0.8
	
	
    m_rightContent_startY = SY(10)
    m_rightContent_width  = wnd:getContentSize().width*0.56
    m_rightContent_startX = wnd:getContentSize().width - m_rightContent_width-SX(10)
    m_rightContent_height = wnd:getContentSize().height*0.8
    
    local leftBackLayer = SCDragNode:node()
	leftBackLayer:setTag(800201)--左半边大背景层
	leftBackLayer:setFrameType(EnumFrameTypeRound)
	leftBackLayer:setFrameVisibled(true)
	leftBackLayer:setAnchorPoint(CCPointMake(0,0));
	leftBackLayer:setPosition(CCPointMake(m_leftContent_startX,m_leftContent_startY));
	leftBackLayer:setContentSize(CCSizeMake(m_leftContent_width,m_leftContent_height))
	wnd:addChild(leftBackLayer)
	
	 
	 ----右半边
    local rightBackLayer = SCDragNode:node()
	rightBackLayer:setTag(800202)--左半边大背景层
	rightBackLayer:setFrameType(EnumFrameTypeRound)
	rightBackLayer:setFrameVisibled(true)
	rightBackLayer:setAnchorPoint(CCPointMake(0,0));
	rightBackLayer:setPosition(CCPointMake(m_rightContent_startX,m_rightContent_startY));
	rightBackLayer:setContentSize(CCSizeMake(m_rightContent_width,m_rightContent_height))
	wnd:addChild(rightBackLayer)
        
	showTitleList()
	showDetailContent()
	showGuideStep(GUIDE_TYPE_LIBRARY, -1)
end

--判断是否重复添加
local function isAdd(id)
    if m_titleList == nil then
        return true
    end
    
    local amount = #m_titleList
    for i=1,amount do
        if m_titleList then
            if m_titleList[i].titleId == id then
                return false
            end
        end
    end
    return true
end

--处理服务端下发左边标题数据
local function processTitleListData(dt)
    if dt == nil then
        return
    end
    if m_titleList == nil then
        m_titleList = {}
    end
    local ucAmount = dt:readByte()
    for i=1,ucAmount do
        local id   = dt:readInt()
        local name = dt:readString()
        if name then
            if isAdd(id) == true then
                tmpTitle= {}
                tmpTitle.titleId = id
                tmpTitle.titleName = name:getData()
                table.insert(m_titleList, tmpTitle);
            end
        end
    end
end

--处理服务端下发详细信息
local function processTitleDetailData(dt)
    if dt == nil then
        return
    end
    local id        = dt:readInt()
    local titleName = dt:readString()
    local detail    = dt:readString()
    m_currentTitleDetail = {}
    m_currentTitleDetail.titleId = id
    if titleName then
        m_currentTitleDetail.titleName = titleName:getData()
    else
        m_currentTitleDetail.titleName = ""
    end
    if detail then
        m_currentTitleDetail.detail = detail:getData()
    else
        m_currentTitleDetail.detail = ""
    end
    SCActivityIndicator:getSingleton():close()
end

--MSG_HELP_MANUAL消息入口
local function processMSG_HELP_MANUAL()
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    local ucAction = dt:readByte()
    if ucAction == HELP_OPEN_DATA_LIBRARY then--//打开资料馆界面
        open_HelpSystem()
        processTitleListData(dt)
        showTitleList()
    elseif ucAction == HELP_CLICK_DATA_LIBRARY then--//点击查看资料
        processTitleDetailData(dt)
        showDetailContent()
    elseif ucAction == HELP_DETAILS_DATA_LIBRARY then--//点击资料馆详细信息
        processTitleDetailData(dt)
        showDetailContent()
	elseif ucAction == HELP_FIGHT_GUIDE then
		BattleStrengthen_process(dt);
		BattleStrengthen_show();
    end
end

--打开资料馆入口
function sendOpenHelpSystemMsg()
    local dt = SCDataTransStream:streamWithCommand(_MSG_HELP_MANUAL);
    dt:writeByte(HELP_OPEN_DATA_LIBRARY);
    SCDataTransThread:getSingleton():transData(dt);
end

----//点击查看资料
function sendQueryHelpDetail_HelpSystem(titleId)
    local dt = SCDataTransStream:streamWithCommand(_MSG_HELP_MANUAL);
    dt:writeByte(HELP_CLICK_DATA_LIBRARY);
    dt:writeInt(titleId);
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

--//点击资料馆详细信息
function sendQueryHelpAllDetail_HelpSystem(titleId)
    local dt = SCDataTransStream:streamWithCommand(_MSG_HELP_MANUAL);
    dt:writeByte(HELP_DETAILS_DATA_LIBRARY);
    dt:writeInt(titleId);
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

--点击关闭
function onClickClose_HelpSystem()
    m_titleList = nil

    m_leftContent_startX = nil
    m_leftContent_startY = nil
    m_leftContent_width  = nil
    m_leftContent_height = nil

    m_rightContent_startX = nil
    m_rightContent_startY = nil
    m_rightContent_width  = nil
    m_rightContent_height = nil

    m_currentTitleDetail = nil--当前选择的详细信息
end

SCMessageCenter:getSingleton():luaRegistCommand(processMSG_HELP_MANUAL, _MSG_HELP_MANUAL, 0, nil);

