--定义一个与文件名相同的table
Hunter6 = {}
------------------消息--------------------

----------------变量定义------------------
local m_EatBagInfo = {}		--背包信息
local m_EatBagStatus = {}	--选中状态
local m_EatBagChoice = {}	--选中道具信息
local m_Item = nil

----------------结构定义区----------------
----------------常量定义区----------------
local HUNT_GRID_BEGINPLACE = 400		--命格背包起始位置
local HUNT_GRID_ENDPLACE = 499			--命格背包结束位置
local ACTION_HUNT_BATCH_SWALLOW = 10	--批量吞噬
local GOD_HUNTER_DRAGON = 1811010010 --青龙魂
local GOD_HUNTER_TIGER = 1812010010  --白虎魂
local GOD_HUNTER_BRID = 1813010010   --朱雀魂
local GOD_HUNTER_TURTLE = 1814010010 --玄武魂
----------------函数回调------------------
---窗口关闭回调---
function Hunter6.onClickEatWndClose()
	local naviCtrl = getCurentSceneNavigationController()
    if naviCtrl then
        naviCtrl:removeWindowControllerByTag(11006)
    end
end

---点击背包格---
function Hunter6.onClickBagNode(tag)
	local index = tag - 30
	if not m_EatBagInfo[index] or not m_Item then return end		--无武魂信息，返回
	
	if not Hunter6.levCheck(m_Item, m_EatBagInfo[index]) then
		showMessage(L("str30164"))
		return
	end
	
	local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("11006-1-2-"..tag))
	if not pBtn then return end
	
	local isAdd = false				--是否增加
	
	if m_EatBagStatus[index] then	--选中
		m_EatBagStatus[index] = false
		imgPath = getRealUIResourcePath("img/new00002.png")
		if imgPath then
			pBtn:setBackgroundImage(imgPath:getData())
		end
		isAdd = false
	else							--未选中
		m_EatBagStatus[index] = true
		imgPath = getRealUIResourcePath("img/new00003.png")
		if imgPath then
			pBtn:setBackgroundImage(imgPath:getData())
		end
		isAdd = true
	end
	
	--插入选中的道具信息
	if isAdd then
		local isFind = false
		for i = 1, #m_EatBagChoice do
			if m_EatBagInfo[index] then
				local eatChoiceInfo = ItemProcessor:getSingleton():getItem(m_EatBagChoice[i])
				local bagInfo = ItemProcessor:getSingleton():getItem(m_EatBagInfo[index])
				
				if not eatChoiceInfo or not bagInfo then return end
				if eatChoiceInfo:getID() == bagInfo:getID() then
					isFind = true 
					break
				end
			end
		end
		
		if not isFind then
			table.insert(m_EatBagChoice, m_EatBagInfo[index])
		end
	--删除选中道具
	else
		for i = 1, #m_EatBagChoice do
			if m_EatBagInfo[index] then
				local eatChoiceInfo = ItemProcessor:getSingleton():getItem(m_EatBagChoice[i])
				local bagInfo = ItemProcessor:getSingleton():getItem(m_EatBagInfo[index])
				
				if not eatChoiceInfo or not bagInfo then return end
				if eatChoiceInfo:getID() == bagInfo:getID() then
					table.remove(m_EatBagChoice, i)
					break
				end
			end
		end
	end
end

---点击吞噬---
function Hunter6.onClickEatBtn()
	if not m_Item or #m_EatBagChoice <= 0 then return end
	local item = ItemProcessor:getSingleton():getItem(m_Item)
	if not item then return end
	local flg = nil
	for i = 1, #m_EatBagChoice do
		local pItem = ItemProcessor:getSingleton():getItem(m_EatBagChoice[i])
		if pItem then
			local pItemID = pItem:getIdType()
			if GOD_HUNTER_DRAGON <= pItemID and GOD_HUNTER_TURTLE >= pItemID then
				flg = true
			end
		end 
	end
	local msg = nil
	if flg then
		msg = string.format(L("str3317"), item:getName())
	else
		msg = string.format(L("str30165"), item:getName())
	end
	luashowConfirmationWindow(msg, WIN_YES_NO, Hunter6.onClickEatChoice)
end

---吞噬确定取消选择---
function Hunter6.onClickEatChoice(tag)
	if tag == 1 then
		Hunter6.sendEatBtnMsg()
	end
end

----------------UI控制器区----------------
function Hunter6.initControl()
	local pWindow11006 = getCurentSceneWindow(11006)
	if pWindow11006 then return end
	
	pWindow11006 = SCWindow:window()
	if not pWindow11006 then return end
	if pWindow11006 then
		pWindow11006:setTag(11006)
		pWindow11006:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow11006:setPosition(AUTO_POS(0.00, 0.00))
		pWindow11006:setContentSize(AUTO_SIZE(250, 315))
		pWindow11006:luaSetSelectorOnClose(Hunter6.releaseControl)
	end
	
	pWindow11006:removeAllChildrenWithCleanup(true)
	
	--底框
	local pDragNode = SCDragNode:node()
	if not pDragNode then return end
		
	pDragNode:setTag(1)
	pDragNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
	pDragNode:setPosition(AUTO_POS(0, 0))
	pDragNode:setContentSize(AUTO_SIZE(250.00, 315.00))
	pDragNode:setFrameVisibled(true)
	pDragNode:setDragEnabled(false)
	pDragNode:setFrameType(EnumFrameTypeRound)

	pWindow11006:addChild(pDragNode)
	
	--关闭按钮
	local pButtonClose = SCButton:button(EnumBtnTypeNormalImg)
	if pButtonClose then
	    pButtonClose:setMusicPath("closeWindow.mp3")
        pButtonClose:luaSetSelectorOnClicked(Hunter6.onClickEatWndClose)
		pButtonClose:setTag(10)
		pButtonClose:setAnchorPoint(CCPointMake(0, 0))
		pButtonClose:setPosition(AUTO_POS(216.00, 279.00))
		local imgPath = getRealUIResourcePath("kernal/close-normal.png")
		if imgPath then
			pButtonClose:setTitle(imgPath:getData())
		end
		pDragNode:addChild(pButtonClose)
	end
	
	--标题
	local pLable = SCLabel:labelWithStringFont(L("str30162"), getDefaultFontName(), getFontSize(15))
	pLable:setAnchorPoint(CCPointMake(0.5, 0))
	pLable:setPosition(CCPointMake(pDragNode:getContentSize().width / 2, SY(278)))
	pLable:setColor(color_orange)
	pDragNode:addChild(pLable)

	--按钮底框
	local pDragNodeBack = SCDragNode:node()
	if not pDragNodeBack then return end
		
	pDragNodeBack:setTag(2)
	pDragNodeBack:setAnchorPoint(CCPointMake(0.5, 0))
	pDragNodeBack:setPosition(CCPointMake(pDragNode:getContentSize().width / 2, SY(65)))
	pDragNodeBack:setContentSize(AUTO_SIZE(225, 210))
	pDragNodeBack:setFrameVisibled(false)
	pDragNodeBack:setDragEnabled(false)
	pDragNodeBack:setFrameType(EnumFrameTypeRound)
	pDragNode:addChild(pDragNodeBack)
	
	--武魂背包单格按钮
    for i = 1, 16 do			
		local pButton = SCButton:button(EnumBtnTypeNormalImg)
		if pButton then
			pButton:setPosition(AUTO_POS(15 + ((i - 1) % 4) * 50, 158 - math.floor((i - 1) / 4 ) * 55))
			pButton:setTag(30 + i)
			local imgPath = getRealUIResourcePath("img/new00002.png")
			if imgPath then
				pButton:setBackgroundImage(imgPath:getData())
			end
			pButton:luaSetSelectorOnClicked(Hunter6.onClickBagNode)
			pDragNodeBack:addChild(pButton)
		end
    end
    
    --下方说明文字
	local pLable = SCLabel:labelWithStringFont(L("str30163"), getDefaultFontName(), getFontSize(12))
	pLable:setPosition(AUTO_POS(30, 22))
	pLable:setColor(color_orange)
	pDragNode:addChild(pLable)
	
    --吞噬按钮
	local pButton = SCButton:button(EnumBtnType9Atlas)
	if pButton then
		pButton:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton:setPosition(AUTO_POS(167.00, 13.00))
		pButton:setContentSize(AUTO_SIZE(55, 30))
		pButton:setTitle(L("str30161"), getDefaultFontName(), getFontSize(13), color_white)
		pButton:luaSetSelectorOnClicked(Hunter6.onClickEatBtn)
		pDragNode:addChild(pButton)
	end
    
	if pWindow11006 then
        local wndCtrl = SCWindowController:controllerWithWindow(pWindow11006)
        local naviCtrl =  getCurentSceneNavigationController()
        if pWindow11006 and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
            pWindow11006:setFrameVisibled(false);
            pWindow11006:setCloseButtonVisibled(false)
        end
    end
end

function Hunter6.releaseControl()
	m_EatBagInfo = {}
	m_EatBagStatus = {}
	m_EatBagChoice = {}
	m_Item = nil
end

---武魂背包信息显示---
function Hunter6.refreshWnd(item)
	local pNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("11006-1-2"))
	if not pNode then return end
	
	--选中的武魂
	if item then
		m_Item = item
	end
	
	local choiceItem = ItemProcessor:getSingleton():getItem(m_Item)
	if not choiceItem then return end
	
	--武魂选中状态清除
	Hunter6.statusInit()
	
	--获取保存武魂信息
	m_EatBagInfo = {}
	local iteminfoSize = ItemProcessor:getSingleton():ItemSize()
    for i = 1, iteminfoSize do
		local item = ItemProcessor:getSingleton():getItemInfo(i - 1)	--获取身上物品
		if item then
			if item:getPlace() >= HUNT_GRID_BEGINPLACE and item:getPlace() <= HUNT_GRID_ENDPLACE then	--武魂道具
				if item:getID() ~= choiceItem:getID() then				--排除吞噬的物品本身
					table.insert(m_EatBagInfo, item:getID())			--保存武魂道具信息
				end
			end
		end
	end
	
	--显示武魂信息
	for i = 1, 16 do
		local pBtn = SCTypeCast:castNodeToButton(pNode:getChildByTag(30 + i))
		if m_EatBagInfo[i] and pBtn then
			pBtn:removeAllChildrenWithCleanup(true)
			local itemObj = ItemProcessor:getSingleton():getItem(m_EatBagInfo[i])
			if itemObj then
				--设置图片
				local imgPath = getRealUIResourcePath("item/"..itemObj:getIconID()..".jpg");
				if not imgPath then
					imgPath = getRealUIResourcePath("img/ItemTemp.png");
				end
				pBtn:setTitle(imgPath:getData())
				
				--设置等级
				local itemInfo = itemObj:getData()
				local pLv = "lv."..itemInfo.dwData2
				local plabel = SCLabel:labelWithStringFont(pLv, DEFAULT_FONT_NAME, F(9))
				if plabel then
					plabel:setAnchorPoint(ANCHOR_CENTER)
					plabel:setPosition(pBtn:getContentSize().width - SX(14), SY(10))
					pBtn:addChild(plabel)
				end
				
				--设置名字
				local pLabelName = SCLabel:labelWithStringFont(itemObj:getName(), DEFAULT_FONT_NAME, F(10))
				if pLabelName then
					pLabelName:setAnchorPoint(ANCHOR_CENTER)
					pLabelName:setPosition(pBtn:getContentSize().width / 2, -SY(4))
					
					--设置颜色
					local idType = itemObj:getIdType()
					if 4 == idType % 10 then
						
					elseif 5 == idType % 10 then
						pLabelName:setColor(color_green)
					elseif 6 == idType % 10 then
						pLabelName:setColor(color_skyBlue)
					elseif 7 == idType % 10 then
						pLabelName:setColor(color_purple)
					elseif 8 == idType % 10 then
						pLabelName:setColor(color_yellow)
					elseif 9 == idType % 10 then
						pLabelName:setColor(color_orange)
					elseif 0 == idType % 10 then
						pLabelName:setColor(color_orange)
					end
					pBtn:addChild(pLabelName)
				end
			end
		elseif not m_EatBagInfo[i] and pBtn then 	--无武魂信息，清空格子内容
			pBtn:removeAllChildrenWithCleanup(true)
			imgPath = getRealUIResourcePath("img/new00002.png")
			if imgPath then
				pBtn:setTitle(imgPath:getData())
			end
		end
	end
end

----------------逻辑处理区----------------
---初始化武魂选中状态---
function Hunter6.statusInit()
	local pNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("11006-1-2"))
	if not pNode then return end
	
	--按钮选中效果初始化
	for i = 31, 46 do
		pBtn = SCTypeCast:castNodeToButton(pNode:getChildByTag(i))
		if pBtn then
			imgPath = getRealUIResourcePath("img/new00002.png")
			if imgPath then
				pBtn:setTitle(imgPath:getData())
				pBtn:setBackgroundImage(imgPath:getData())
			end
		end
		
		m_EatBagStatus[i] = false
		m_EatBagChoice = {}
	end
end

---吞噬等级判断---
function Hunter6.levCheck(itemOne, itemTwo)
	local itemInfoOne = ItemProcessor:getSingleton():getItem(itemOne)
	local itemInfoTwo = ItemProcessor:getSingleton():getItem(itemTwo)
	
	if not itemInfoOne or not itemInfoTwo then return false end
	
	local idTypeOne = itemInfoOne:getIdType() % 10
	local idTypeTwo = itemInfoTwo:getIdType() % 10
	if idTypeTwo == 0 and idTypeOne ~= 0 then
		return false
	end
	
	if idTypeOne >= idTypeTwo or idTypeTwo <= 4 or idTypeOne == 0 then
		return true
	end
	
	return false
end

----------------消息处理区----------------
---批量吞噬消息发送---
function Hunter6.sendEatBtnMsg()
	if not m_Item or #m_EatBagChoice <= 0 then return end
	local item = ItemProcessor:getSingleton():getItem(m_Item)
	if not item then return end
	
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_HUNTER)
    if not dataStream then return end
    
	dataStream:writeShort(ACTION_HUNT_BATCH_SWALLOW)
    dataStream:writeInt(item:getID())
    dataStream:writeInt(#m_EatBagChoice)
    for i = 1, #m_EatBagChoice do
		local item = ItemProcessor:getSingleton():getItem(m_EatBagChoice[i])
		if item then
			dataStream:writeInt(item:getID())
			dataStream:writeInt(item:getPostion())
		end
    end
    
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end
----------------消息注册区----------------
----------------全局函数区----------------
