----------------------------消息-----------------------------
--[[
const unsigned short _MSG_USER_GUID			=_MSG_GENERAL+90;

GUID_OPEN_LEVELUP = 3,	//升级引导窗口
下发：
typedef struct
{
	USHORT usFlag;
	char szName[_MAX_NAMESIZE];
	DWORD dwPhoto;
	char szDescribe[_MAX_WORDSSIZE];
}stGuideByLev;

typedef struct  
{
	USHORT			usNum;
	stGuideByLev	stInfo[12];
}tMsg_Info3;

上发：
{
	USHORT usFlag;	//点击进入
}

GUID_OPEN_HELP_WINDOW = 4,	//打开对应窗口
{
	int nData1;
	int nData2;
	int nData3;
}
]]
----------------结构定义区------------------------------------
local stGuideByLev = {
	initWithStream = function(dt)
		local tmp = {}
		if dt == nil then
			return tmp
		end
		tmp.usFlag = dt:readShort()
		tmp.szName = dt:readString()
		if tmp.szName then
			tmp.szName = tmp.szName:getData()
		else
			tmp.szName = ""
		end
		tmp.nPhoto = dt:readInt()
		tmp.szDescribe = dt:readString()
		if tmp.szDescribe then
			tmp.szDescribe = tmp.szDescribe:getData()
		else
			tmp.szDescribe = ""
		end
		
		return tmp
	end
}
local stLevelUpGuide = {
	initWithStream = function(dt)
		local tmp = {}
		if dt == nil then
			return tmp
		end
		tmp.usAmount = dt:readShort()
		tmp.guideByLev = {}
		for i=1, tmp.usAmount do
			table.insert(tmp.guideByLev, stGuideByLev.initWithStream(dt))
		end
		
		return tmp
	end
}
local stOpenHelpWnd = {
	initWithStream = function(dt)
		local tmp = {}
		if dt == nil then
			return tmp
		end
		tmp.usIndex = dt:readShort()
		tmp.nData1 = dt:readInt()
		tmp.nData2 = dt:readInt()
		
		return tmp
	end
}
----------------常量定义区------------------------------------
local USERGUIDLEV_SWEEPING_COPY	= 1--	//扫荡副本
local USERGUIDLEV_MEDITATION		= 2--	//冥想
local USERGUIDLEV_TASK_BRANCH		= 3--	//支线任务

----------------变量定义区------------------------------------

----------------函数声明区-------------------------------------
local createWindowWithData
local createFunNode
local onFunClicked
----------------UI控制器区-------------------------------------
--创建一个功能节点
function createFunNode(info)
	local nodeWidth = SX(83)
	local nodeHeight = SY(125)
	local tmpHeight = nodeHeight
	local pDragNode = SCDragNode:node()
	pDragNode:setContentSize(CCSizeMake(nodeWidth, nodeHeight))
	pDragNode:setFrameType(EnumFrameTypeListNormal)
	pDragNode:setFrameVisibled(true)
	
	local pBtn = SCButton:button()
	pBtn:setTag(info.usFlag)
	pBtn:luaSetSelectorOnClicked(onFunClicked)
	pDragNode:addChild(pBtn)
	pBtn:setContentSize(CCSizeMake(nodeWidth, nodeHeight))
	
	local pImgFile = getRealUIResourcePath("MainInterfaceImg/"..info.nPhoto..".png")
	if pImgFile then
		local pImg = SCImage:imageWithFile(pImgFile:getData())
		pImg:setAnchorPoint(CCPointMake(0.5, 0.5))
		pImg:setPosition(CCPointMake(nodeWidth/2, tmpHeight-pImg:getContentSize().height/2-SY(10)))
		pDragNode:addChild(pImg)
		tmpHeight = tmpHeight-pImg:getContentSize().height-SY(10)
	end
	
	local pNameLabel = SCLabel:labelWithStringFont("-"..info.szName.."-", getDefaultFontName(), getFontSize(12))
	if pNameLabel then
		pNameLabel:setColor(color_yellow)
		pNameLabel:setAnchorPoint(CCPointMake(0.5, 0.5))
		pNameLabel:setPosition(CCPointMake(nodeWidth/2, tmpHeight-pNameLabel:getContentSize().height/2-SY(5)))
		pDragNode:addChild(pNameLabel)
		tmpHeight = tmpHeight-pNameLabel:getContentSize().height-SY(5)
	end
	
	local pParsedNode = ParsedNode:getParsedNode(getStringLine(info.szDescribe, 7), 0, 11)
	if pParsedNode then
		pParsedNode:setAnchorPoint(CCPointMake(0.5, 0.5))
		pParsedNode:setPosition(CCPointMake(nodeWidth/2, tmpHeight-pParsedNode:getContentSize().height/2-SY(5)))
		pDragNode:addChild(pParsedNode)
		tmpHeight = tmpHeight-pParsedNode:getContentSize().height-SY(5)
	end
	
	return pDragNode
end
--创建窗口
function createWindowWithData(upInfo)
	local wndWidth = SX(300)
	local wndHeight = SY(240)
	local pageWidth = SX(260)
	local pageHeight = SY(150)
	local pWnd = SCWindow:window()
	pWnd:setTag(5945)
	pWnd:setContentSize(CCSizeMake(wndWidth, wndHeight))
	pWnd:setAnchorPoint(CCPointMake(0.5, 0.5))
	pWnd:setPosition(CCPointMake(WIN_SIZE.width/2, WIN_SIZE.height/2))
	local file = getRealUIResourcePath("img/new00093.png")
	if file then
		pWnd:setTitleWithImage(file:getData())
	end
	
	local topImgFile = getRealUIResourcePath("img/new00092.png")
	if topImgFile then
		local topImg = SCImage:imageWithFile(topImgFile:getData())
		if topImg then
			topImg:setAnchorPoint(CCPointMake(0.5, 1))
			topImg:setPosition(CCPointMake(wndWidth/2, wndHeight-SY(55)))
			pWnd:addChild(topImg)
		end
	end
	
	local pDragNode = SCDragNode:node()
	pDragNode:setContentSize(CCSizeMake(pageWidth, pageHeight))
	pDragNode:setFrameType(EnumFrameTypeRound)
	pDragNode:setFrameVisibled(true)
	pDragNode:setPosition(CCPointMake((wndWidth-pageWidth)/2, SY(13)))
	pWnd:addChild(pDragNode)
	
	pageScrollBox = SCPageScrollBox:boxWithWidthHeight(pageWidth, pageHeight);
    pageScrollBox:setPageSize(CCSizeMake(pageWidth, pageHeight));
    pageScrollBox:setAnchorPoint(CCPointMake(0.5, 0.5));
    pageScrollBox:setPosition(CCPointMake(pageWidth/2, pageHeight/2))
    pageScrollBox:setScrollVertical(false);
    pDragNode:addChild(pageScrollBox);
    local pageHint = SCPageHint:hintWithType(EnumPgaeHintTypeHorizontal)
    pageHint:setAnchorPoint(CCPointMake(0.5, 0.5))
    pageHint:setPosition(CCPointMake(pageWidth/2, SY(10)))
    pageHint:setBoundPageScrollBox(pageScrollBox)
    pDragNode:addChild(pageHint)
	
	local pageNode = nil
	local pageNodeTag = 1
	
	for i=1, upInfo.usAmount-upInfo.usAmount%3 do
		if (i-1)%3 == 0 then
			pageNode = SCNode:node()
			pageNode:setTag(pageNodeTag)
			pageNode:setContentSize(CCSizeMake(pageWidth, pageHeight))
			pageNode:setPosition(CCPointMake(pageWidth*(i-1), 0))
			pageScrollBox:setContentSize(CCSizeMake(pageNodeTag*pageWidth, pageHeight))
			pageScrollBox:addChild(pageNode)
			pageNodeTag = pageNodeTag + 1
		end
		local dragNode = createFunNode(upInfo.guideByLev[i])
		--dragNode:setAnchorPoint(CCPointMake(0.5, 0.5))
		dragNode:setPosition(CCPointMake((i-1)%3*dragNode:getContentSize().width+SX(5), SY(20)))
		pageNode:addChild(dragNode)
	end
	for i=1, upInfo.usAmount%3 do
		if (i-1)%3 == 0 then
			pageNode = SCNode:node()
			pageNode:setTag(pageNodeTag)
			pageNode:setContentSize(CCSizeMake(pageWidth, pageHeight))
			pageNode:setPosition(CCPointMake(pageWidth*(i-1), 0))
			pageScrollBox:setContentSize(CCSizeMake(pageNodeTag*pageWidth, pageHeight))
			pageScrollBox:addChild(pageNode)
			pageNodeTag = pageNodeTag + 1
		end
		local dragNode = createFunNode(upInfo.guideByLev[i])
		--dragNode:setAnchorPoint(CCPointMake(0.5, 0.5))
		if upInfo.usAmount%3 == 1 then
			dragNode:setAnchorPoint(CCPointMake(0.5, 0.5))
			dragNode:setPosition(CCPointMake(pageNode:getContentSize().width/2, pageNode:getContentSize().height/2))
		else
			dragNode:setPosition(CCPointMake((i-1)%2*dragNode:getContentSize().width+SX(50), SY(20)))
		end
		pageNode:addChild(dragNode)
	end
	
	return pWnd
end
----------------逻辑功能区-------------------------------------
function onFunClicked(tag)
	local GUID_OPEN_LEVELUP = 4
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USER_GUID)
	dataStream:writeShort(GUID_OPEN_LEVELUP)
	dataStream:writeShort(tag)
	SCDataTransThread:getSingleton():transData(dataStream)
end
----------------消息处理区-------------------------------------

----------------消息注册区-------------------------------------

----------------全局函数区-------------------------------------
--收到升级引导消息，给收到消息处调用
function LevelFunGuide_ProcessorLevelUpGuideMsg(dt)
	local pWnd = createWindowWithData(stLevelUpGuide.initWithStream(dt))
	local pWndCtrl = SCWindowController:controllerWithWindow(pWnd)
	local naviCtrl = getCurentSceneNavigationController()
	if naviCtrl and pWndCtrl then
		naviCtrl:pushWindowController(pWndCtrl)
	end
end
--打开相应窗口
function LevelFunGuide_ProcessorLevelUpOpenWndMsg(dt)
	local naviCtrl = getCurentSceneNavigationController()
	if naviCtrl then
		naviCtrl:removeWindowControllerByTag(5945)
	end
	local openInfo = stOpenHelpWnd.initWithStream(dt)
	if openInfo.usIndex == USERGUIDLEV_SWEEPING_COPY then
		return
	end
	if openInfo.usIndex == USERGUIDLEV_MEDITATION then
		return
	end
	if openInfo.usIndex == USERGUIDLEV_TASK_BRANCH then
		createTaskWnd(1)
		return
	end
end