--action
local OTHERPLAYDATA_CLICK             =10    --//点击人物
local OTHERPLAYDATA_CHECK             =11    --//点击查看
local OTHERPLAYDATA_MYCRIB            =12    --//查看人物的具体信息
local OTHERPLAYDATA_LIVE              =13    --//点击生活信息
local OTHERPLAYDATA_DIVINE_CHECK      =14    --//点击生活信息
local OTHERPLAYDATA_UPDATA_EUD        =15    --//跟新列表信息
local OTHERPLAYDATA_CHECK_END         =16	 --//查看下发结束
--struct
local stPlayerSimpleInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {};
        end
        local tmp = {
            __mode = "kv",
            --[[
            nLev,        --//人物等级
            idUser,        --//人物id
            nPhoto,        --//人物头像id
            szName,        --//人物名
            ]]
        }
        tmp.nLev = dt:readInt()
        tmp.idUser = dt:readInt()
        tmp.nPhoto = dt:readInt()
        local scStr = dt:readString();
        if scStr == nil then
            tmp.szName = ""                --人物名字
        else
            tmp.szName = scStr:getData();
        end
        return tmp;
    end
}
local stPlayerBaseInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {};
        end
        local tmp = {
            __mode = "kv",
            --[[
            idUser,        --//玩家id
            idEudemon,    --//宠物id
            szName,        --//名字  (szName)
            nLev,        --//人物等级
            dwFlower,    --//鲜花
            szProfession,--//职业
            dwLowLookFace,--//玩家图片索引
            stEquip={},--//装备信息
            dwPhysicalAttack,--//武力
            dwVitality,    --//生命
            dwUniqueSkill, --//绝技
            szMethod,    --//战法
            dwMagic,    --//法术
            nDemonLev,    --//精灵等级 等级为0 没有精灵
            ucOffline,     --//1:不在线  0:在线
            ]]
        }
        tmp.idUser = dt:readInt()
        tmp.idEudemon = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szName = ""
        else
            tmp.szName = scStr:getData()
        end
        tmp.nLev = dt:readInt()
        tmp.dwFlower = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szProfession = ""
        else
            tmp.szProfession = scStr:getData()
        end
        tmp.dwLowLookFace = dt:readInt()
        tmp.dwPhysicalAttack = dt:readInt()
        tmp.dwVitality = dt:readInt()
        tmp.dwUniqueSkill = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szMethod = ""
        else
            tmp.szMethod = scStr:getData()
        end
        tmp.dwMagic = dt:readInt()
        
        tmp.ucAmount = dt:readByte()
        tmp.stEquip = {}
        for i=1, tmp.ucAmount do
            tmp.stEquip[i] = {}
            tmp.stEquip[i].ucPos = dt:readByte()
            tmp.stEquip[i].idEquip = dt:readInt()        --装备id
            tmp.stEquip[i].nEquipPhoto = dt:readInt()    --图片索引
        end
        tmp.nDemonLev = dt:readInt()
        tmp.ucOffline = dt:readByte()
        tmp.ucType = dt:readByte()
        return tmp
    end
}
local stPlayerDetailedInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {};
        end
        local tmp = {__mode = "kv"}
        tmp.dwLookFace = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.sz4ToEInfo = ""
        else
            tmp.sz4ToEInfo = scStr:getData()
        end
        local scStr = dt:readString()
        if scStr == nil then
            tmp.sz1To3Info = ""
        else
            tmp.sz1To3Info = scStr:getData()
        end
        return tmp;
    end
}
local stPlayerLifeInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {};
        end
        local tmp = {__mode = "kv"}
        tmp.dwLookFace = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.sz4ToEInfo = ""
        else
            tmp.sz4ToEInfo = scStr:getData()
        end
        local scStr = dt:readString()
        if scStr == nil then
            tmp.sz1To3Info = ""
        else
            tmp.sz1To3Info = scStr:getData()
        end
        return tmp;
    end
}
local stPlayerTarotInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {};
        end
        local tmp = {__mode = "kv"}
        local ucAmount = dt:readByte()
        for i = 1, ucAmount do
            tmp[i] = {}
            tmp[i].idItem = dt:readInt()
            tmp[i].nPhoto = dt:readInt()
            local scStr = dt:readString()
            if scStr == nil then
                tmp[i].DivineInfo = ""
            else
                tmp[i].DivineInfo = scStr:getData()
            end
        end
        tmp.zhanbu = dt:readInt()
        return tmp;
    end
}
--data
local m_simplePlayerInfo = nil
local m_playerBaseInfo = {__mode = "kv"}
local m_playerDetailedInfo = {__mode = "kv"}
local m_playerLifeInfo = nil
local m_playerTarotInfo = {__mode = "kv"}

local m_sendPlayerId = nil
local m_sendPlayerName = nil

local m_multiPage = nil
local m_scrollBox = nil

--send message function
local function sendLookPlayerInfoMsg(playerId, playerName)
	local naviCtrl = getCurentSceneNavigationController()
	if naviCtrl then
		naviCtrl:removeWindowControllerByTag(5908)
	end
    SCActivityIndicator:getSingleton():show()
	local dt = SCDataTransStream:streamWithCommand(_MSG_PLAYERINFO)
	dt:writeByte(OTHERPLAYDATA_CHECK)
	dt:writeByte(0)
	dt:writeInt(playerId)
	dt:writeInt(0)
	dt:writeString(SCString:stringWithString(playerName))
	SCDataTransThread:getSingleton():transData(dt)
end

local function sendShowPlayerDetailedInfoMsg(playerId, eudemonId)
    SCActivityIndicator:getSingleton():show()
	local dt = SCDataTransStream:streamWithCommand(_MSG_PLAYERINFO)
	dt:writeByte(OTHERPLAYDATA_MYCRIB)
	dt:writeByte(0)
	dt:writeInt(playerId)
	dt:writeInt(eudemonId)
	SCDataTransThread:getSingleton():transData(dt)
end

local function sendShowPlayerLifeInfoMsg(playerId, eudemonId)
    SCActivityIndicator:getSingleton():show()
	local dt = SCDataTransStream:streamWithCommand(_MSG_PLAYERINFO)
	dt:writeByte(OTHERPLAYDATA_LIVE)
	dt:writeByte(0)
	dt:writeInt(playerId)
	dt:writeInt(eudemonId)
	SCDataTransThread:getSingleton():transData(dt)
end

local function sendShowPlayerTarotInfoMsg(playerId, eudemonId)
    SCActivityIndicator:getSingleton():show()
	local dt = SCDataTransStream:streamWithCommand(_MSG_PLAYERINFO)
	dt:writeByte(OTHERPLAYDATA_DIVINE_CHECK)
	dt:writeByte(0)
	dt:writeInt(playerId)
	dt:writeInt(eudemonId)
	SCDataTransThread:getSingleton():transData(dt)
end

--查看塔罗界面
local function onClickTarot(tag)
	local index = m_scrollBox:getPageIndex()
	if m_playerTarotInfo[index+1][tag] ~= nil then
		luaLookItemInfo(m_playerTarotInfo[index+1][tag].idItem)
	end
end

local function showPlayerTarotInfo(playerTarotInfo)
	local wndCtrl = getCurentSceneWindowController(5908)
	if not wndCtrl then
		return
	end
	local wnd = wndCtrl:getWindow()
	if not wnd then
		return
	end
	local fileNor = getRealUIResourcePath("img/new00002.png")
	local fileSel = getRealUIResourcePath("img/new00003.png")
	local node = SCFunction:getUiNodeByIdlist("5908-1-103-1004")
	if node then
		local MAX_Tarot = 8
		local index = m_scrollBox:getPageIndex()
		local EquiptCount = getIntPart(m_playerBaseInfo[index+1].nLev/10)
		if EquiptCount > MAX_Tarot then
			EquiptCount = MAX_Tarot
		end
		for i=1, 8 do
			local dragNode = node:getChildByTag(i)
			if dragNode then
				local btn = tolua.cast(dragNode:getChildByTag(i), "SCButton")
				if not btn then
					btn = SCButton:button()
					btn:setBackgroundImage(fileNor:getData())
					btn:setSelectedImage(fileSel:getData())
					btn:luaSetSelectorOnClicked(onClickTarot)
					btn:setTag(i)
					dragNode:addChild(btn)
				end
				if i > EquiptCount then
					local file = getRealUIResourcePath("img/img5030.png")
					btn:setTitle(file:getData())
				else
					btn:setTitle(" ", getDefaultFontName(), getFontSize(15))
				end
			end
		end
		for i=1, #playerTarotInfo do
			local dragNode = node:getChildByTag(i)
			if dragNode then
				local btn = tolua.cast(dragNode:getChildByTag(i), "SCButton")
				if btn then
					local file, rect = getItemImageByIcon(playerTarotInfo[i].nPhoto)
					btn:setTitle(file:getData(), rect)
				end
			end
			
		end
		local dragNode = tolua.cast(node:getChildByTag(11), "SCDragNode")
		if dragNode then
			dragNode:setFrameType(EnumFrameTypeRound)
			dragNode:setFrameVisibled(true)
		end
		local label =  tolua.cast(node:getChildByTag(12), "SCLabel")
		if label then
			label:setText(playerTarotInfo.zhanbu)
		end
	end
end

--查看生活界面
local function showPlayerLifeInfo(playerLifeInfo)
	local wndCtrl = getCurentSceneWindowController(5908)
	if not wndCtrl then
		return
	end
	local wnd = wndCtrl:getWindow()
	if not wnd then
		return
	end
	local node = SCFunction:getUiNodeByIdlist("5908-1-102-1003")
	if node then
		
		local img = tolua.cast(node:getChildByTag(3), "SCImage")
		if img then
			local file = getFaceImagePath(playerLifeInfo.dwLookFace)
			if file then
				img:setImage(file:getData())
			end
		end
		
		if node:getChildByTag(1) then
			node:removeChildByTag(1, true)
		end
		if node:getChildByTag(2) then
			node:removeChildByTag(2, true)
		end
		local parNode = getItemTextNode(playerLifeInfo.sz1To3Info, 1)
		parNode:setTag(1)
		parNode:setPerWidthAndHeight(120, 20)
		parNode:setPosition(CCPointMake(99 * gUIScale().x, 208 * gUIScale().y))
		node:addChild(parNode)
		
		local parNode = getItemTextNode(playerLifeInfo.sz4ToEInfo, 1)
		parNode:setTag(2)
		parNode:setColumns(2)
		parNode:setPerWidthAndHeight(120, 25)
		parNode:setAnchorPoint(CCPointMake(0, 1))
		parNode:setPosition(CCPointMake(10 * gUIScale().x, 195 * gUIScale().y))
		node:addChild(parNode)
	end
end

--查看详细信息界面
local function showPlayerDetailedInfo(playerDetailedInfo)
	local wndCtrl = getCurentSceneWindowController(5908)
	if not wndCtrl then
		return
	end
	local wnd = wndCtrl:getWindow()
	if not wnd then
		return
	end
	local node = SCFunction:getUiNodeByIdlist("5908-1-101-1002")
	if node then
		
		local img = tolua.cast(node:getChildByTag(3), "SCImage")
		if img then
			local file = getFaceImagePath(playerDetailedInfo.dwLookFace)
			if file then
				img:setImage(file:getData())
			end
		end
		
		if node:getChildByTag(1) then
			node:removeChildByTag(1, true)
		end
		if node:getChildByTag(2) then
			node:removeChildByTag(2, true)
		end
		local parNode = getItemTextNode(playerDetailedInfo.sz1To3Info, 1)
		parNode:setTag(1)
		parNode:setPerWidthAndHeight(118, 20)
		parNode:setPosition(CCPointMake(99 * gUIScale().x, 208 * gUIScale().y))
		node:addChild(parNode)
		
		local parNode = getItemTextNode(playerDetailedInfo.sz4ToEInfo, 1)
		parNode:setTag(2)
		parNode:setColumns(2)
		parNode:setPerWidthAndHeight(118, 23)
		parNode:setAnchorPoint(CCPointMake(0, 1))
		parNode:setPosition(CCPointMake(10 * gUIScale().x, 195 * gUIScale().y))
		node:addChild(parNode)
	end
end
--点击查看后的界面
local function onClosePlayerBaseInfoWnd()
	m_playerBaseInfo = {__mode = "kv"}
	m_playerDetailedInfo = {__mode = "kv"}
	m_playerLifeInfo = nil
	m_playerTarotInfo = {__mode = "kv"}
	m_multiPage = nil
	m_scrollBox = nil
	m_sendPlayerName = nil
end

local function onClickBaseAddFriend(tag)
	gAddFriend(m_playerBaseInfo[1].idUser, m_playerBaseInfo[1].szName)
end

local function onClickBaseSendFlower(tag)
	SendFlowersProcessor:getSingleton():SendOpenFlowerMsg(m_playerBaseInfo[1].idUser)
end

local function onClickEquip(tag)
	local index = m_scrollBox:getPageIndex()
	for i=1, #m_playerBaseInfo[index+1].stEquip do
		if m_playerBaseInfo[index+1].stEquip[i].ucPos == tag then
			luaLookItemInfo(m_playerBaseInfo[index+1].stEquip[i].idEquip)
		end
	end
end

local function onClickRole(tag)
	--sendShowPlayerDetailedInfoMsg(m_playerBaseInfo[1].idUser, m_playerBaseInfo[1].idEudemon)
end

local function scrollPrevious(tag)
	if not m_scrollBox then
		return
	end
	if not m_multiPage then
		return
	end
	local index = m_scrollBox:getPageIndex()
	local dex = m_multiPage:selectedPageIndex()
	if dex ==0 then
		if m_playerDetailedInfo[index+1] ~= nil then
			local dex = m_multiPage:selectedPageIndex()
			showPlayerDetailedInfo(m_playerDetailedInfo[index+1])
		else
			sendShowPlayerDetailedInfoMsg(m_playerBaseInfo[index+1].idUser, m_playerBaseInfo[index+1].idEudemon)
		end
	elseif dex == 2 then
		if m_playerTarotInfo[index+1] ~= nil then
			local dex = m_multiPage:selectedPageIndex()
			showPlayerTarotInfo(m_playerTarotInfo[index+1])
		else
			sendShowPlayerTarotInfoMsg(m_playerBaseInfo[index+1].idUser, m_playerBaseInfo[index+1].idEudemon)
		end
	end
end

local function scrollNext(tag)
	if not m_scrollBox then
		return
	end
	if not m_multiPage then
		return
	end
	local index = m_scrollBox:getPageIndex()
	local dex = m_multiPage:selectedPageIndex()
	if dex ==0 then
		if m_playerDetailedInfo[index+1] ~= nil then
			local dex = m_multiPage:selectedPageIndex()
			showPlayerDetailedInfo(m_playerDetailedInfo[index+1])
		else
			sendShowPlayerDetailedInfoMsg(m_playerBaseInfo[index+1].idUser, m_playerBaseInfo[index+1].idEudemon)
		end
	elseif dex == 2 then
		if m_playerTarotInfo[index+1] ~= nil then
			local dex = m_multiPage:selectedPageIndex()
			showPlayerTarotInfo(m_playerTarotInfo[index+1])
		else
			sendShowPlayerTarotInfoMsg(m_playerBaseInfo[index+1].idUser, m_playerBaseInfo[index+1].idEudemon)
		end
	end
end

local function multiPageChange(tag, dex)
	if not m_multiPage then
		return
	end
	if dex == 1 then
		if not m_playerLifeInfo then
			sendShowPlayerLifeInfoMsg(m_playerBaseInfo[1].idUser, m_playerBaseInfo[1].idEudemon)
		end
	elseif dex == 0 then
		if not m_scrollBox then
			return
		end
		local index = m_scrollBox:getPageIndex()
		if m_playerDetailedInfo[index+1] ~= nil then
			local dex = m_multiPage:selectedPageIndex()
			showPlayerDetailedInfo(m_playerDetailedInfo[index+1])
		else
			sendShowPlayerDetailedInfoMsg(m_playerBaseInfo[index+1].idUser, m_playerBaseInfo[index+1].idEudemon)
		end
	elseif dex == 2 then
		if not m_scrollBox then
			return
		end
		local index = m_scrollBox:getPageIndex()
		if m_playerTarotInfo[index+1] ~= nil then
			local dex = m_multiPage:selectedPageIndex()
			showPlayerTarotInfo(m_playerTarotInfo[index+1])
		else
			sendShowPlayerTarotInfoMsg(m_playerBaseInfo[index+1].idUser, m_playerBaseInfo[index+1].idEudemon)
		end
	end
end

local function ctrlEvent(tag, eventType)
	if eventType == LuaControllerEventAddEnded or eventType == LuaControllerEventPushEnded then
	end
end

local function cteatPlayerBaseInfoWnd()
	local wnd = nil
	local naviCtrl = getCurentSceneNavigationController()
	local wndCtrl = naviCtrl:getWindowControllerByTag(5908)
	if wndCtrl == nil then
		wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5908))
		wnd:setBackgroundColor(color_window_red_bg)
		wnd:setAnchorPoint(CCPointMake(0.5, 0.5))
		wnd:setPosition(CCPointMake(240 * gUIScale().x, 160 * gUIScale().y))
		local imgPath = getRealUIResourcePath("img/titile54.png")
        if imgPath then
            wnd:setTitleWithImage(imgPath:getData());
        end
		wndCtrl = SCWindowController:controllerWithWindow(wnd)
		wndCtrl:luaSetSelectorOnEvent(ctrlEvent)
		wnd:luaSetSelectorOnClose(onClosePlayerBaseInfoWnd)
		m_multiPage = tolua.cast(wnd:getChildByTag(1), "SCMultiPage")
		if not m_multiPage then
			return		
		end
		naviCtrl:pushWindowController(wndCtrl)
	else
		wnd = wndCtrl:getWindow()
	end
	return wnd
end

local function showPlayerBaseInfo()
	local wnd = getCurentSceneWindow(5908)
	if not wnd then
		return
	end
	m_multiPage:setTitleAtPage(_LTParser("str5018"), getDefaultFontName(), getFontSize(15), 0)
	m_multiPage:setTitleAtPage(_LTParser("str5083"), getDefaultFontName(), getFontSize(15), 1)
	--m_multiPage:setTitleAtPage(_LTParser("str5081"), getDefaultFontName(), getFontSize(15), 2)
	m_multiPage:luaSetSelectorOnPageSelected(multiPageChange)
	if m_playerBaseInfo[1].ucOffline==0 then
		local node = SCFunction:getUiByZipAndId(5908, 103)
		if node then
			m_multiPage:addPage(node)
			m_multiPage:setTitleAtPage(_LTParser("str5081"), getDefaultFontName(), getFontSize(15), 2)
		end
	end
	local btn = tolua.cast(wnd:getChildByTag(4), "SCButton")
	if btn then
		btn:setTitle(_LTParser("str0061"), getDefaultFontName(), getFontSize(15), color_yellow)
		btn:luaSetSelectorOnClicked(onClickBaseAddFriend)
	end
	local btn = tolua.cast(wnd:getChildByTag(5), "SCButton")
	if btn then
		btn:setTitle(_LTParser("str0128"), getDefaultFontName(), getFontSize(15), color_yellow)
		btn:luaSetSelectorOnClicked(onClickBaseSendFlower)
	end
	local scrollBoxWidth = 208
	local scrollBoxHeight = 236
	m_scrollBox = tolua.cast(wnd:getChildByTag(3), "SCPageScrollBox")
	if m_scrollBox then
		m_scrollBox:setPageSize(CCSizeMake(scrollBoxWidth * gUIScale().x, scrollBoxHeight * gUIScale().y))
		m_scrollBox:luaSetSelectorOnScrollToPrevious(scrollPrevious)
		m_scrollBox:luaSetSelectorOnScrollToNext(scrollNext)
		for i=1, #m_playerBaseInfo do
			local node = m_scrollBox:getChildByTag(m_playerBaseInfo[i].idEudemon)
			if not node then
				node = SCFunction:getUiByZipAndId(5908, 1001)
				local fileNor = getRealUIResourcePath("img/new00002.png")
				local fileSel = getRealUIResourcePath("img/new00003.png")
				for j=1, 6 do
					local dragNode = node:getChildByTag(j)
					if dragNode then
						local btn = SCButton:button()
						if fileNor then
							btn:setBackgroundImage(fileNor:getData())
						end
						if fileSel then
							btn:setSelectedImage(fileSel:getData())
						end
						btn:setTag(j)
						dragNode:addChild(btn)
					end
				end
				for j=1, m_playerBaseInfo[i].ucAmount do
					local dragNode = node:getChildByTag(m_playerBaseInfo[i].stEquip[j].ucPos)
					if dragNode then
						local btn = tolua.cast(dragNode:getChildByTag(m_playerBaseInfo[i].stEquip[j].ucPos), "SCButton")
						if btn then
							local imgFile, rect = getItemImageByIcon(m_playerBaseInfo[i].stEquip[j].nEquipPhoto)
							--rect.size.width = rect.size.width * gUIScale().x;
							--rect.size.height = rect.size.height * gUIScale().y;
							--rect.origin.x = rect.origin.x * gUIScale().x
							--rect.origin.y = rect.origin.y * gUIScale().y
							if imgFile then
								btn:setTitle(imgFile:getData(), rect)
							end
							btn:luaSetSelectorOnClicked(onClickEquip)
						end
					end
				end
				local label = tolua.cast(node:getChildByTag(8), "SCLabel")
				if label then
					label:setColor(color_yellow)
					label:setText(_LTParser("str5071").." "..m_playerBaseInfo[i].dwFlower)
				end
				local label = tolua.cast(node:getChildByTag(40), "SCLabel")
				if label then
					label:setText(_LTParser("str5056")..": "..m_playerBaseInfo[i].szProfession)
				end
				local label = tolua.cast(node:getChildByTag(41), "SCLabel")
				if label then
					label:setText(_LTParser("str5020")..": "..m_playerBaseInfo[i].dwPhysicalAttack)
				end
				local label = tolua.cast(node:getChildByTag(42), "SCLabel")
				if label then
					label:setText(_LTParser("str5069")..": "..m_playerBaseInfo[i].dwVitality)
				end
				local label = tolua.cast(node:getChildByTag(43), "SCLabel")
				if label then
					label:setText(_LTParser("str5021")..": "..m_playerBaseInfo[i].dwUniqueSkill)
				end
				local label = tolua.cast(node:getChildByTag(44), "SCLabel")
				if label then
					label:setText(_LTParser("str0144").." "..m_playerBaseInfo[i].szMethod)
				end
				local label = tolua.cast(node:getChildByTag(45), "SCLabel")
				if label then
					label:setText(_LTParser("str5022")..": "..m_playerBaseInfo[i].dwMagic)
				end
				local imgpath = getRealUIResourcePath("img/img2548.png")
				local ani = LookfaceParser:getSingleton():getAnimationByLookFaceAndIndex(m_playerBaseInfo[i].dwLowLookFace)
				if ani and imgpath then
					local lookBGimg = SCImage:imageWithFile(imgpath:getData())
					local aniNode = SCAnimationNode:nodeWithAnimation(ani)
					aniNode:setAnchorPoint(CCPointMake(0.5, 0.5))
					aniNode:setPosition(CCPointMake(lookBGimg:getContentSize().width/2, lookBGimg:getContentSize().height/2+aniNode:getContentSize().height/2))
					lookBGimg:addChild(aniNode)
					lookBGimg:setAnchorPoint(CCPointMake(0.5, 0.5))
					lookBGimg:setPosition(CCPointMake(node:getContentSize().width/2, 85 * gUIScale().y+lookBGimg:getContentSize().height/2))
					node:addChild(lookBGimg)
				end
				

				for i=30, 35 do
					local dragNode = tolua.cast(node:getChildByTag(i), "SCDragNode")
					if dragNode then
						dragNode:setFrameType(EnumFrameTypeListNormal)
						dragNode:setFrameVisibled(true)
					end
				end
				node:setPosition(CCPointMake((i-1)*scrollBoxWidth * gUIScale().x, 0))
				m_scrollBox:addChild(node)
			end
		end
		m_scrollBox:setContentSize(CCSizeMake(scrollBoxWidth*#m_playerBaseInfo * gUIScale().x, scrollBoxHeight * gUIScale().y))
	end
end

--点击人物后显示的界面
local function closePlayerSimpleInfoWnd()
	m_simplePlayerInfo = nil
end

local function onClickLookInfo(tag)
    sendLookPlayerInfoMsg(m_simplePlayerInfo.idUser, "")
end

local function onClickAddFriend(tag)
	gAddFriend(m_simplePlayerInfo.idUser, m_simplePlayerInfo.szName)
end

local function onClickSendFlower(tag)
	SendFlowersProcessor:getSingleton():SendOpenFlowerMsg(m_simplePlayerInfo.idUser)
end

local function onClickTalkTo(tag)
	gTalkTo(m_simplePlayerInfo.szName)
end

local function showPlayerSimpleInfo(dt)
    local wnd = nil
    local naviCtrl = getCurentSceneNavigationController()
    local wndCtrl = naviCtrl:getWindowControllerByTag(5907)
    if wndCtrl == nil then
        wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5907))
        wnd:setAnchorPoint(CCPointMake(0.5, 0.5))
        wnd:setPosition(CCPointMake(getScreenWidth()/2, getScreenHeight()-wnd:getContentSize().height/2-SY(5)))
        wnd:setBackgroundColor(color_window_red_transparent_bg)
        wndCtrl = SCWindowController:controllerWithWindow(wnd)
        wnd:luaSetSelectorOnClose(closePlayerSimpleInfoWnd)
        naviCtrl:addWindowController(wndCtrl)
        wnd:setFrameVisibled(false)
        wnd:setAutoCloseOnTouchSpace(true)
        
        local dragNode = tolua.cast(wnd:getChildByTag(100), "SCDragNode")
        if dragNode then
            dragNode:setFrameType(EnumFrameTypeLine);
            dragNode:setFrameVisibled(true);
        end
        
        local button = tolua.cast(wnd:getChildByTag(3), "SCButton")
        if button then
            button:setTitle(_LTParser("str0022"), getDefaultFontName(), getFontSize(15), color_yellow)
            button:luaSetSelectorOnClicked(onClickLookInfo)
        end
        local button = tolua.cast(wnd:getChildByTag(4), "SCButton")
        if button then
            button:setTitle(_LTParser("str0061"), getDefaultFontName(), getFontSize(15), color_yellow)
            button:luaSetSelectorOnClicked(onClickAddFriend)
        end
        local button = tolua.cast(wnd:getChildByTag(5), "SCButton")
        if button then
            button:setTitle(_LTParser("str0128"), getDefaultFontName(), getFontSize(15), color_yellow)
            button:luaSetSelectorOnClicked(onClickSendFlower)
        end
        local button = tolua.cast(wnd:getChildByTag(6), "SCButton")
        if button then
            button:setTitle(_LTParser("str0053"), getDefaultFontName(), getFontSize(15), color_yellow)
            button:luaSetSelectorOnClicked(onClickTalkTo)
        end
    else
        wnd = wndCtrl:getWindow()
    end
    m_simplePlayerInfo = stPlayerSimpleInfo.initWithStream(dt)
    local faceNode = tolua.cast(wnd:getChildByTag(1), "SCImage")
    if faceNode then
        local imgNode = getFaceImg(m_simplePlayerInfo.nPhoto)
        if imgNode and not faceNode:getChildByTag(1) then
            imgNode:setAnchorPoint(CCPointMake(0.5, 0.5))
            imgNode:setPosition(CCPointMake(faceNode:getContentSize().width/2, faceNode:getContentSize().height/2))
            imgNode:setTag(1)
            faceNode:addChild(imgNode)
        end
    end
    local dragNode = tolua.cast(wnd:getChildByTag(2), "SCDragNode")
    if dragNode then
        local text = m_simplePlayerInfo.szName.." "..m_simplePlayerInfo.nLev.._LTParser("str0266")
        local label = tolua.cast(dragNode:getChildByTag(1), "SCLabel")
        if label then
            label:setText(text)
        else
            label = SCLabel:labelWithStringFont(text, getDefaultFontName(), getFontSize(12))
            label:setAnchorPoint(CCPointMake(0.5, 0.5))
            label:setPosition(CCPointMake(dragNode:getContentSize().width/2, dragNode:getContentSize().height/2))
            dragNode:addChild(label)
        end
    end
end

local function DisplayPlayer(tmp)
    local pRunningScene = tolua.cast(CCDirector:sharedDirector():getRunningScene(), "SCBaseScene");
	if pRunningScene == nil then
	    return
	end
	
	local framewindow = FrameWindow:frameWnd()
	framewindow:setContentSize(CCSizeMake(232 * gUIScale().x, 285 * gUIScale().y))
	if framewindow == nil then
	    return
	end
	framewindow:setCloseBtnVisible(false)
		
    local file = getFaceImagePath(tmp.dwLookFace)
	if file then
	    local img = SCImage:imageWithFile(file:getData());
        setNodePostion(img, CCPointMake(30, 205))
        framewindow:addChild(img)
	end
		
    local parNode = getItemTextNode(tmp.sz4ToEInfo, 1)
    parNode:setTag(1)
    parNode:setPerWidthAndHeight(105, 20)
    parNode:setPosition(CCPointMake(99 * gUIScale().x, 208 * gUIScale().y))
    framewindow:addChild(parNode)
    
    local parNode = getItemTextNode(tmp.sz1To3Info, 1)
    parNode:setTag(2)
    parNode:setColumns(2)
    parNode:setPerWidthAndHeight(105, 23)
    parNode:setAnchorPoint(CCPointMake(0, 1))
    parNode:setPosition(CCPointMake(10 * gUIScale().x, 195 * gUIScale().y))
    framewindow:addChild(parNode)
    
    pRunningScene:getUINode():addChild(framewindow, Max_Int);   
end

--接收消息
local function recPlayerSimpleInfo()
	local dt = SCMessageCenter:getSingleton():getDataTransStream()
    local action = dt:readShort()
    if action == OTHERPLAYDATA_CLICK then
		SCActivityIndicator:getSingleton():close()
        showPlayerSimpleInfo(dt)
    elseif action == OTHERPLAYDATA_CHECK then
        ViewPlayInfo_recvData(dt, false)
	elseif action ==OTHERPLAYDATA_CHECK_END then
		ViewPlayInfo_recvData(dt, true)
    elseif action == OTHERPLAYDATA_MYCRIB then
		SCActivityIndicator:getSingleton():close()
        if not m_scrollBox then
            return
        end
        local index = m_scrollBox:getPageIndex()
        local tmp = stPlayerDetailedInfo.initWithStream(dt)
        table.insert(m_playerDetailedInfo, index+1, tmp)
        showPlayerDetailedInfo(tmp)
    elseif action == OTHERPLAYDATA_LIVE then
        SCActivityIndicator:getSingleton():close()
        if not m_scrollBox then
            return
        end
        local index = m_scrollBox:getPageIndex()
        local m_playerLifeInfo = stPlayerLifeInfo.initWithStream(dt)
        showPlayerLifeInfo(m_playerLifeInfo)
    elseif action == OTHERPLAYDATA_DIVINE_CHECK then
        SCActivityIndicator:getSingleton():close()
        if not m_scrollBox then
            return
        end
        local index = m_scrollBox:getPageIndex()
        local tmp = stPlayerTarotInfo.initWithStream(dt)
        table.insert(m_playerTarotInfo, index+1, tmp)
        showPlayerTarotInfo(tmp)
    elseif action == OTHERPLAYDATA_UPDATA_EUD then
        DisplayPlayer(stPlayerDetailedInfo.initWithStream(dt));
    end
end

SCMessageCenter:getSingleton():luaRegistCommand(recPlayerSimpleInfo, _MSG_PLAYERINFO, 0, nil)

--查看玩家信息
function luaLookPlayerInfo(playerId, playerName)
    sendLookPlayerInfoMsg(playerId, playerName)
end
