----------------------结构定义区------------------------
local FunctionInfo = {
    initWithStream = function(dt)
		local tmp = {} 
		if not dt then
			return tmp
		end
		tmp.ucType = dt:readByte()      --1开启 0未开启 
		tmp.lockType = dt:readInt()     --解锁类型
		tmp.IDPhoto = dt:readInt()      --图片ID
		local str = dt:readString()     
		if str == nil then
			tmp.szDescribe = ""         --文字秒描述
		else
			tmp.szDescribe = str:getData()
		end
		return tmp
    end
}
local stLoseGuidance = {
    initWithStream = function(dt)
		local tmp = {}
		if not dt then
			return tmp
		end
		tmp.stFunctionInfo = FunctionInfo.initWithStream(dt)      --//推荐功能
		--CCMessageBox(tmp.stFunctionInfo.szDescribe)
		tmp.ucAmount = dt:readByte()
		tmp.stFunctionInfo1  = {}
		for i = 1, tmp.ucAmount do 
			table.insert(tmp.stFunctionInfo1,FunctionInfo.initWithStream(dt)) --//功能
		end     
		return tmp
    end
}


---------------------常量定义区-------------------------
local SHOW_OPTIONAL_SUM     = 4                 --显示可选择按钮的数量
----------------------变量定义区------------------------

local m_stFunctionInfo = nil                --//推荐功能
local m_stFunctionInfoLogo = nil            --//推荐功能LOGO
local m_stFunctionInfo1 = nil               --//功能
local m_BtnRange = nil                      --按钮间距
local m_Logo = {}                           --按钮小插图
local m_PageNode = {}                       --滑动选择窗口
local m_PageTotal =  nil                    --可滑动窗口的总页数
local m_Page = 1                            --初始化当前所在窗口 
----------------------函数声明区------------------------
local InitLoseGuidance              --初始化失败引导
local setLogo                       --设置小logo的文件名
local setwndChild                   --设置窗口
local getButton                     --给予按钮
local onClickObject                 --点击按钮事件
local TableLeftMove                 --点击左边按钮执行事件    
local TableRightMove                --点击右边按钮执行事件
local upPageAction                  --上一页
local nextPageAction                --下一页
local OnClose                       --析构
local removeAllWithStream           --移除当前节点  
local sendUnlockBtnHitMsg                  

-----------------------逻辑功能区-----------------------

function getButton(BackgroundFile,SelectedFile)
    local pBtn = SCButton:button()
    local file = getRealUIResourcePath(BackgroundFile)
    if not file then
        return nil
    end
    pBtn:setBackgroundImage(file:getData())
    file = getRealUIResourcePath(SelectedFile)
    if not file then
        return nil
    end
    pBtn:setSelectedImage(file:getData())
    return pBtn
end

function setwndChild(wnd)
    local WndNode = SCDragNode:node()
    WndNode:setDragEnabled(false)
    WndNode:setFrameType(1)
    WndNode:setContentSize(CCSizeMake(SX(300), SY(200)))
	WndNode:setAnchorPoint(CCPointMake(0.5, 1))
    WndNode:setPosition(CCPointMake(wnd:getContentSize().width/2, wnd:getContentSize().height))
    WndNode:setFrameVisibled(true)
    wnd:addChild(WndNode)           --wnd = "2401"
    WndNode:setTag(2401)
    --失败引导LOGO-----------------------------------------
    local file = getRealUIResourcePath("img/new00075.pn")
    local Image = nil
    if file then
        Image = SCImage:imageWithFile(file:getData())
        Image:setPosition(CCPointMake((WndNode:getContentSize().width - Image:getContentSize().width)/2, WndNode:getContentSize().height - Image:getContentSize().height*0.75))
        WndNode:addChild(Image)
    end
    --失败引导文字贴图---------------------------------------
    file = getRealUIResourcePath("img/new00074.pn")
    if file then
        Image = SCImage:imageWithFile(file:getData())
        Image:setPosition(CCPointMake((WndNode:getContentSize().width - Image:getContentSize().width)/2 , WndNode:getContentSize().height - Image:getContentSize().height*2.8))
        WndNode:addChild(Image)
    end
    --失败引导套图---------------------------------------------
    file = getRealUIResourcePath("img/new00071.pn")
    if  file then
        Image = SCImage:imageWithFile(file:getData())
        Image:setPosition(CCPointMake((WndNode:getContentSize().width - Image:getContentSize().width)/2 , (WndNode:getContentSize().height - Image:getContentSize().height)/2))
        WndNode:addChild(Image)
    end
    local RecommendBtn = SCButton:button()                                          --推荐功能进入按钮
    local strPhoto                                                                  --按钮图片地址
    if m_stFunctionInfo.ucType == 1 then 
         strPhoto = tostring(m_stFunctionInfo.IDPhoto)
         RecommendBtn:luaSetSelectorOnClicked(onClickObject)
    else
         strPhoto = tostring(m_stFunctionInfo.IDPhoto + 100 )
    end
    file = getRealUIResourcePath("MainInterfaceImg/"..strPhoto..".pn")
    if file then
        RecommendBtn:setTitle(file:getData())
        RecommendBtn:setPosition(CCPointMake((WndNode:getContentSize().width - RecommendBtn:getContentSize().width)/2 , (WndNode:getContentSize().height - RecommendBtn:getContentSize().height)/2))
        WndNode:addChild(RecommendBtn)
        RecommendBtn:setTag(m_stFunctionInfo.lockType)                  --推荐功能按钮对应UNLOCK_TYPE枚举
    end
    file = getRealUIResourcePath(m_stFunctionInfoLogo)
    if file then
        Image = SCImage:imageWithFile(file:getData())
        Image:setPosition(CCPointMake(WndNode:getContentSize().width/1.92  , WndNode:getContentSize().height/2 - Image:getContentSize().height))
        WndNode:addChild(Image)
    end
    --显示文字简要-----------------------------------------
    local IntoNode = SCDragNode:node()
    IntoNode:setDragEnabled(false)
    IntoNode:setFrameType(0)
    IntoNode:setFrameVisibled(true)
    IntoNode:setContentSize(CCSizeMake(WndNode:getContentSize().width*0.7,wnd:getContentSize().height*0.1))
    IntoNode:setPosition(CCPointMake((WndNode:getContentSize().width - IntoNode:getContentSize().width)/2 , WndNode:getContentSize().height*0.1))
    local label = SCLabel:labelWithStringFont(m_stFunctionInfo.szDescribe, getDefaultFontName(), getFontSize(13))
    label:setPosition(CCPointMake((IntoNode:getContentSize().width - label:getContentSize().width)/2 , (IntoNode:getContentSize().height - label:getContentSize().height)/2 ))
    IntoNode:addChild(label)
    WndNode:addChild(IntoNode)
    ------------------------------------选择需要进入的界面----------------------------
    local ChoiceNode = SCDragNode:node()
    ChoiceNode:setPosition(CCPointMake(0 ,WndNode:getContentSize().height/2 - WndNode:getContentSize().height*0.75))
    ChoiceNode:setContentSize(CCSizeMake(WndNode:getContentSize().width,WndNode:getContentSize().height/4.5))
    --左右按钮-------------------
    local LeftBtn = getButton("kernal/close-selected.png","img/new00065.png")
    local RightBtn = getButton("kernal/close-selected.png","img/new00065.png")
    LeftBtn:setPosition(CCPointMake(0,(ChoiceNode:getContentSize().height + LeftBtn:getContentSize().height)/2))
    RightBtn:setPosition(CCPointMake(ChoiceNode:getContentSize().width ,(ChoiceNode:getContentSize().height - RightBtn:getContentSize().height)/2 ))
    LeftBtn:luaSetSelectorOnClicked(TableLeftMove)
    LeftBtn:setRotation(90)
    RightBtn:setRotation(-90)
    RightBtn:luaSetSelectorOnClicked(TableRightMove)
    ChoiceNode:addChild(LeftBtn)
    ChoiceNode:addChild(RightBtn)
    --选择表格-------------------
    local TableBoxNode = SCPageScrollBox:boxWithWidthHeight(ChoiceNode:getContentSize().width - LeftBtn:getContentSize().width*2,ChoiceNode:getContentSize().height)
    TableBoxNode:setPosition(ChoiceNode:getPosition().x + LeftBtn:getContentSize().width,ChoiceNode:getPosition().y+SY(50))
    TableBoxNode:setPageSize(CCSizeMake(ChoiceNode:getContentSize().width - LeftBtn:getContentSize().width*2,ChoiceNode:getContentSize().height))
    TableBoxNode:setScrollHorizontal(false)
    TableBoxNode:setScrollVertical(false)
    local showWidth  = TableBoxNode:getContentSize().width
    local showHeight = TableBoxNode:getContentSize().height
    TableBoxNode:luaSetSelectorOnScrollToPrevious(upPageAction)
    TableBoxNode:luaSetSelectorOnScrollToNext(nextPageAction)
    m_BtnRange = TableBoxNode:getContentSize().width/SHOW_OPTIONAL_SUM        --按钮间隔距离
    local itemId = 0                                                          --按钮的排序ID
    for j = 1, m_PageTotal do
		local TmpNode = SCNode:node()
		TmpNode:setPosition(CCPointMake((j-1)*showWidth,0))
		TmpNode:setContentSize(CCSizeMake(showWidth,showHeight))
		for i =1, SHOW_OPTIONAL_SUM do
			if not m_stFunctionInfo1[i+itemId] then
				break
			end
			local btn = SCButton:button()
			if m_stFunctionInfo1[i+itemId].ucType == 1 then 
				strPhoto = tostring(m_stFunctionInfo1[i+itemId].IDPhoto)
				btn:luaSetSelectorOnClicked(onClickObject)
			else
				strPhoto = tostring(m_stFunctionInfo1[i+itemId].IDPhoto +100 )
			end
			file = getRealUIResourcePath("MainInterfaceImg/"..strPhoto..".pn")       
			if file then    
				btn:setTitle(file:getData()) 
				btn:setPosition(CCPointMake(m_BtnRange*i - btn:getContentSize().width*1.2 , (showHeight - btn:getContentSize().height)/2))
				TmpNode:addChild(btn)
				btn:setTag(m_stFunctionInfo1[i+itemId].lockType)
				file = getRealUIResourcePath(m_Logo[i + itemId])
				if file then 
					Image = SCImage:imageWithFile(file:getData())
					Image:setPosition(CCPointMake(m_BtnRange*i - Image:getContentSize().width*1.1, (showHeight - btn:getContentSize().height)/2))
					TmpNode:addChild(Image)
				end
				file = getRealUIResourcePath("img/new00073.pn")
				if file then
					Image = SCImage:imageWithFile(file:getData())
					Image:setPosition(CCPointMake(m_BtnRange*i - Image:getContentSize().width*3.3, (showHeight - Image:getContentSize().height)/2))
					TmpNode:addChild(Image)
				end
				local label = SCLabel:labelWithStringFont(i+itemId, getDefaultFontName(), getFontSize(16))
				label:setPosition(CCPointMake((Image:getContentSize().width - label:getContentSize().width)/2 , (Image:getContentSize().height - label:getContentSize().height)/2))
				Image:addChild(label)
			end
		end
		TableBoxNode:setContentSize(CCSizeMake(showWidth*j,showHeight))
		TableBoxNode:addChild(TmpNode)
		table.insert(m_PageNode,TmpNode)
		itemId = itemId +SHOW_OPTIONAL_SUM
    end
    file = getRealUIResourcePath("img/new00087.pn")                --底部
    if file then 
        Image = SCImage:imageWithFile(file:getData())
        Image:setPosition(CCPointMake((showWidth - Image:getContentSize().width)/2+SX(25),SY(-22)))
        ChoiceNode:addChild(Image);
    end
    ChoiceNode:addChild(TableBoxNode)           --TableBoxNode"2401-2401-2401-11"
    TableBoxNode:setTag(11)
    WndNode:addChild(ChoiceNode)                --ChoiceNode"2401-2401"
    ChoiceNode:setTag(2401)
end

function setLogo(ucAmount)
    local FileName
    if m_stFunctionInfo.lockType == UNLOCK_TYPE_EQUIP_STRENGTHEN then             --强化
        FileName = "img/new00070.pn"
    elseif m_stFunctionInfo.lockType == UNLOCK_TYPE_USER_TALENT then          --天赋
        FileName = "img/new00072.pn"
    elseif m_stFunctionInfo.lockType == UNLOCK_TYPE_TRAIN  or tag == UNLOCK_TYPE_IMMORTALITY then     --人物界面 培养 魔果
        FileName = "img/new00070.pn"
    else
        FileName = " "
    end
    m_stFunctionInfoLogo = FileName
    for i = 1, ucAmount do
        if m_stFunctionInfo1[i].lockType == UNLOCK_TYPE_EQUIP_STRENGTHEN then             --强化
            FileName = "img/new00070.pn"
        elseif m_stFunctionInfo1[i].lockType == UNLOCK_TYPE_USER_TALENT then              --天赋
            FileName = "img/new00072.pn"
        elseif m_stFunctionInfo1[i].lockType == UNLOCK_TYPE_TRAIN  or tag == UNLOCK_TYPE_IMMORTALITY then     --人物界面 培养 魔果
            FileName = "img/new00070.pn"
        else
            FileName = " "
        end
        table.insert(m_Logo,FileName)
    end
    
end
function InitLoseGuidance(LoseGuidanceInfo)
    if not LoseGuidanceInfo then
        return
    end
    m_stFunctionInfo = LoseGuidanceInfo.stFunctionInfo      --//推荐功能
    m_stFunctionInfo1 = LoseGuidanceInfo.stFunctionInfo1    --//功能
    local ucAmount = LoseGuidanceInfo.ucAmount              --功能数量
    m_PageTotal = ucAmount%SHOW_OPTIONAL_SUM
    if m_PageTotal ~= 0 then
        m_PageTotal = getIntPart(ucAmount/SHOW_OPTIONAL_SUM)+1
    else
        m_PageTotal = getIntPart(ucAmount/SHOW_OPTIONAL_SUM)
    end
    setLogo(ucAmount)                  --设置小logo的文件名

end
-----------------------UI控制器区-----------------------
function sendUnlockBtnHitMsg(usType)
    SCActivityIndicator:getSingleton():show()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_PUSH_UNLOCK)
    dataStream:writeShort(usType)
    SCDataTransThread:getSingleton():transData(dataStream)
end

function onClickObject (tag)
	removeAllWithStream(); 
    if tag == UNLOCK_TYPE_EQUIP_STRENGTHEN then             --强化
        sendOpenMsg_EquiptStrengthScreen()
		return
	end
    if tag == UNLOCK_TYPE_USER_TALENT then              --天赋
        sendUnlockBtnHitMsg(tag)
		return
	end
    if tag == UNLOCK_TYPE_ELFGUARD then                 --精灵
        sendUnlockBtnHitMsg(tag)
		return
	end
    if tag == UNLOCK_TYPE_BOOK then                     --奇书
        sendOpenMsg_SkillStudyScreen()
		return
	end
    if tag == UNLOCK_TYPE_IMMORTALITY then     --人物界面魔果
        local pMainInterface = getMainInterface()
        if pMainInterface ~= nil then
            pMainInterface:onClickHero(1)
        end
		return
	end
	if tag == UNLOCK_TYPE_TRAIN then     --人物界面培养
        local pMainInterface = getMainInterface()
        if pMainInterface ~= nil then
            pMainInterface:onClickHero(2)
        end
		return
	end
    if tag == UNLOCK_TYPE_HUNT then                     --塔罗  
        local pMainInterface = getMainInterface()
        if pMainInterface ~= nil then
            pMainInterface:onClickTarot(tag)
        end
		return
	end
    if tag == UNLOCK_TYPE_RECRUITPARTNER then
        local USERINFO_FUNCTION_PATHING = 80
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
        if dataStream then        
            dataStream:writeShort(USERINFO_FUNCTION_PATHING);
            dataStream:writeByte(1)
            SCDataTransThread:getSingleton():transData(dataStream);
        end
		return
    end
end

function TableLeftMove()
    local GuideTable = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlist("2401-2401-2401-11"))
    if not GuideTable then
        return
    end 
    m_Page = m_Page - 1
    if m_Page >= 1 then
        GuideTable:setOffset(CCPointMake(m_PageNode[m_Page]:getPosition().x,m_PageNode[m_Page]:getPosition().y))
    elseif m_Page < 1 then 
        m_Page = 1
    end
end

function TableRightMove()
    local GuideTable = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlist("2401-2401-2401-11"))
    if not GuideTable then
        return
    end
    m_Page = m_Page + 1
    if m_Page <= m_PageTotal then
       GuideTable:setOffset(CCPointMake(m_PageNode[m_Page]:getPosition().x,m_PageNode[m_Page]:getPosition().y))
    elseif m_Page > m_PageTotal then 
        m_Page = m_PageTotal
    end
end

function upPageAction()             --上一页
    local GuideTable = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlist("2401-2401-2401-11"))
    if not GuideTable then
        return
    end 
    GuideTable:setOffset(CCPointMake(m_PageNode[m_Page]:getPosition().x,m_PageNode[m_Page]:getPosition().y))
end

function nextPageAction()           --下一页
    local GuideTable = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlist("2401-2401-2401-11"))
    if not GuideTable then
        return
    end 
    GuideTable:setOffset(CCPointMake(m_PageNode[m_Page]:getPosition().x,m_PageNode[m_Page]:getPosition().y))
end

function OnClose()                        --析数据构
    m_stFunctionInfo = nil                --//推荐功能
    m_stFunctionInfoLogo = nil
    m_stFunctionInfo1 = nil               --//功能
    m_BtnRange = nil                      --按钮间?
    m_Logo = {}                           --按钮小插图?
    m_PageNode = {}                       --滑动选择窗口
    m_PageTotal =  nil                    --可滑动窗口的总页数
    m_Page = 1                            --初始化当前所在窗口
    BattleProcessor:getSingleton():removeBattle();
end

function removeAllWithStream()
    local GuideWnd = SCTypeCast:castNodeToWindow(SCFunction:getUiNodeByIdlist("2401"))
    if not GuideWnd then
        return
    end 
    GuideWnd:removeFromParentAndCleanup(true)
end

-----------------------消息处理区-----------------------
function LoseGuidance_recvLoseStrengthenGuide(dt)
    InitLoseGuidance(stLoseGuidance.initWithStream(dt))
end

function LoseGuidance_IsVisible()
    if  m_stFunctionInfo and  m_stFunctionInfo1 then
        local wnd = SCWindow:window()
        wnd:setContentSize(CCSizeMake(SX(300), SY(250)))
        wnd:setTag(2401)
        wnd:setFrameVisibled(false)
        wnd:luaSetSelectorOnClose(OnClose)
        setwndChild(wnd)
        local wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        naviCtrl:pushWindowController(wndCtrl)
		return true
    end
	return false
end

function LoseGuidance_SendFailMsg()
    local GUID_COPY_FAILE = 2
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USER_GUID)
    dataStream:writeShort(GUID_COPY_FAILE)
    SCDataTransThread:getSingleton():transData(dataStream)
end