--定义一个与文件名相同的table
LotteryBoat = {}
------------------消息--------------------

----------------结构定义区----------------
local stLotteryInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv", 
        }
        
        tmp.idUser = dt:readInt()
        tmp.curArrowsNum = dt:readInt()     --当前箭只数量
        tmp.leftCounts = dt:readInt()       --免费借箭次数
        
        tmp.lev1BorrowCost = dt:readInt()   --1船借箭所需元宝	
		tmp.lev2BorrowCost = dt:readInt()   --2船借箭所需元宝	
		tmp.lev3BorrowCost = dt:readInt()   --3船借箭所需元宝
		tmp.lev1ArrowsGet = dt:readInt()    --1船借箭数	
		tmp.lev2ArrowsGet = dt:readInt()    --2船借借箭数	
		tmp.lev3ArrowsGet = dt:readInt()    --3船借借箭数
	    tmp.itemtype1 = dt:readInt() 		--兑换物品
	    tmp.itemtype2 = dt:readInt()
	    tmp.itemtype3 = dt:readInt()
	    tmp.itemtype4 = dt:readInt()
		tmp.needExchangeNum1 = dt:readInt() --兑换需要箭只数
		tmp.needExchangeNum2 = dt:readInt()
		tmp.needExchangeNum3 = dt:readInt()
		tmp.needExchangeNum4 = dt:readInt()
        
        return tmp
    end
}

local stLotteryUpDataInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv", 
        }
        
        tmp.idUser = dt:readInt()
        tmp.curArrowsNum = dt:readInt()     --当前箭只数量
        tmp.leftCounts = dt:readInt()       --免费借箭次数
        
        return tmp;
    end
}

----------------常量定义区----------------
ACTION_BORROW_ARROWS_QUERY_SELF	= 1     --查询草船借箭自身信息
ACTION_BORROW_ARROWS_QUERY_DATA = 2 	--查询基本配置信息	
ACTION_BORROW_ARROWS_BORROW = 3 		--借箭
ACTION_BORROW_ARROWS_GET_BOX = 4 		--兑换 
ACTION_BORROW_ARROWS_BAG_FULL = 5       --满背包

local EXCHANGE_PER_COST = {50, 200, 1000, 4000}         --兑换消耗
local BORROW_PER_COST = {5, 10, 20}                     --借箭消耗


----------------变量定义区----------------
local mLotteryInfo = {}
local mCurBorrow = 0
local mCurExchange = 0

---------------回调函数------------------
---空回调---
function LotteryBoat.funNil()
end

---点击关闭按钮---
function LotteryBoat.onCloseBtnClick(tag)
	local wndCtrl = getCurentSceneWindowController(11000)
	if wndCtrl then
		removeWindowCtrl(wndCtrl)
	end
end

---关闭提示窗---
local function close(tag)               --提示关闭
    local pRunningScene = getRunningScene()
    if pRunningScene == nil then
        return
    end
    pRunningScene:getUINode():removeChildByTag(788889 ,true)
end

---点击船只---
function LotteryBoat.onClickBoatBtn(tag)
    if tag == 9 then
        luashowConfirmationWindow(L("str30105"), WIN_YES, nil) 
    elseif tag == 10 then
        luashowConfirmationWindow(L("str30106"), WIN_YES, nil) 
    elseif tag == 11 then
        luashowConfirmationWindow(L("str30107"), WIN_YES, nil) 
    end
end

---点击奖励---
function LotteryBoat.onClickPirceBtn(tag)	
	if tag == 5 then
		if mLotteryInfo.itemtype1 then
			showTip(mLotteryInfo.itemtype1)
		end
	elseif tag == 6 then
		if mLotteryInfo.itemtype2 then
			showTip(mLotteryInfo.itemtype2)
		end
	elseif tag == 7 then
		if mLotteryInfo.itemtype3 then
			showTip(mLotteryInfo.itemtype3)
		end
	elseif tag == 8 then
		if mLotteryInfo.itemtype4 then
			if mLotteryInfo.itemtype4 == 1999000014 then
				local itemInfo = TableParser:getSingleton():getItemInfoByKey(mLotteryInfo.itemtype4)
				if not itemInfo then return end
				local pWnd = showTipEx(L("str30075"), L("str30118"), itemInfo.name:getData(), itemInfo.icon, itemInfo.id)            
				if pWnd then
					local pWnd = tolua.cast(pWnd, "TipWindow")
					pWnd:luaSetReturnSelector(LotteryBoat.wingsTipReturn)
				end
			else
				showTip(mLotteryInfo.itemtype4)
			end
		end
	end
end

---羽翼tip点击回调---
function LotteryBoat.wingsTipReturn()
	local pWnd = SCFunction:getUiNodeByIdlist("888888")
    if pWnd then
        pWnd:removeFromParentAndCleanup(true)
    end
end

---点击借箭---
function LotteryBoat.onClickBorrowBtn(tag)
    if not mLotteryInfo.leftCounts then return end
    local freeTime = mLotteryInfo.leftCounts

    local eMoney = Hero:getSingleton():getEmoney()
    
    if tag == 12 then
        if freeTime > 0 then        --免费
            mCurBorrow = 1
            LotteryBoat.sendBorrowMsg()
        else
			if not mLotteryInfo.lev1BorrowCost or mLotteryInfo.lev1BorrowCost <= 0 then return end
            if eMoney >= mLotteryInfo.lev1BorrowCost then     --判断元宝
                local msg = string.format(L("str30100"), BORROW_PER_COST[1])
                msg = msg..L("str30134")
                mCurBorrow = 1
                luashowConfirmationWindowPoint(msg, nil, L("str30075"), WIN_NULL, LotteryBoat.sendBorrowMsg, close, 1)
            else
                GuidePoint_shoprechangeByClose()
            end
        end
    elseif tag == 13 then
		if not mLotteryInfo.lev2BorrowCost or mLotteryInfo.lev2BorrowCost <= 0 then return end
        if eMoney >= mLotteryInfo.lev2BorrowCost then     		--判断元宝
            local msg = string.format(L("str30100"), BORROW_PER_COST[2])
            msg = msg..L("str30135")
            mCurBorrow = 2
            luashowConfirmationWindowPoint(msg, nil, L("str30075"), WIN_NULL, LotteryBoat.sendBorrowMsg, close, 1)
        else
            GuidePoint_shoprechangeByClose()
        end
    elseif tag == 14 then
		if not mLotteryInfo.lev3BorrowCost or mLotteryInfo.lev3BorrowCost <= 0 then return end
        if eMoney >= mLotteryInfo.lev3BorrowCost then     		--判断元宝
            local msg = string.format(L("str30100"), BORROW_PER_COST[3])
            msg = msg..L("str30136")
            mCurBorrow = 3
            luashowConfirmationWindowPoint(msg, nil, L("str30075"), WIN_NULL, LotteryBoat.sendBorrowMsg, close, 1)
        else
            GuidePoint_shoprechangeByClose()
        end
	elseif tag == 35 then
		if not mLotteryInfo.lev3BorrowCost or mLotteryInfo.lev3BorrowCost <= 0 then return end
        if eMoney >= mLotteryInfo.lev3BorrowCost * 10 then     	--判断元宝
            local msg = string.format(L("str30100"), BORROW_PER_COST[4])
            msg = msg..L("str30137")
            mCurBorrow = 4
            luashowConfirmationWindowPoint(msg, nil, L("str30075"), WIN_NULL, LotteryBoat.sendBorrowMsg, close, 1)
        else
            GuidePoint_shoprechangeByClose()
        end
	elseif tag == 60 then
		if not mLotteryInfo.nNeedMoney then return end
		local money = Hero:getSingleton():getMoney()
		if money < mLotteryInfo.nNeedMoney then
			GuidePoint_shopBuyTip()
		else
			LotteryBoat.sendMoneyBorrowMsg()
		end
    end
end

---点击说明---
function LotteryBoat.onClickInfoBtn()
	local wnd = getCurentSceneWindow(11000)
    if not wnd then return end
    
	local pframeWnd = FrameWindow:frameWnd()
	if pframeWnd then
		pframeWnd:setContentSize(CCSizeMake(SX(280), SY(120)))
		pframeWnd:setPosition(CCPointMake(wnd:getContentSize().width / 2, wnd:getContentSize().height / 2))
		local pParsedNode = getItemTextNode(L("str30103"));
		if pParsedNode then
			pParsedNode:setAnchorPoint(CCPointMake(0.5, 0.5));
			pParsedNode:setPosition(CCPointMake(pframeWnd:getContentSize().width / 2, pframeWnd:getContentSize().height / 2));
			pframeWnd:addChild(pParsedNode)
			wnd:addChild(pframeWnd)
		end
	end
end

---兑换按钮---
function LotteryBoat.onClickExchangeBtn(tag)
    if not mLotteryInfo.curArrowsNum then return end
    if CLIENT_VERSION < 335 and tag == 32 then
		showMessage(L("str30183"))
		return
    end

    local exchangeNeed = 0                          --兑换需要箭只
    local exchangeCur = mLotteryInfo.curArrowsNum   --当前箭只数
    
	local itemType = 0	
		
    if tag == 29 then
        exchangeNeed = EXCHANGE_PER_COST[1]
        mCurExchange = 1
        if mLotteryInfo.itemtype1 then
			itemType = mLotteryInfo.itemtype1
		end
    elseif tag == 30 then
        exchangeNeed = EXCHANGE_PER_COST[2]
        mCurExchange = 2
        if mLotteryInfo.itemtype2 then
			itemType = mLotteryInfo.itemtype2
		end
    elseif tag == 31 then
        exchangeNeed = EXCHANGE_PER_COST[3]
        mCurExchange = 3 
        if mLotteryInfo.itemtype3 then
			itemType = mLotteryInfo.itemtype3
		end
    elseif tag == 32 then
        exchangeNeed = EXCHANGE_PER_COST[4]
        mCurExchange = 4
        if mLotteryInfo.itemtyp4 then
			itemType = mLotteryInfo.itemtyp4
		end
    end
    
    if exchangeNeed == 0 then 
        mCurExchange = 0
        return
    end
    
    if exchangeCur >= exchangeNeed then
		local strName = " "
		local pItem = TableParser:getSingleton():getItemInfoByKey(itemType)
		if pItem then
			strName = pItem.name:getData()
		end
		
		local str = string.format(L("str30191"), exchangeNeed, strName)			
		luashowConfirmationWindow(str, WIN_YES_NO, LotteryBoat.sendExchangeMsg)
    else
        mCurExchange = 0
        luashowConfirmationWindow(L("str30097"), WIN_YES, nil)
    end
end

----------------UI控制器区----------------
function LotteryBoat.initControl()
	local pWindow11000 = SCWindow:window()
	if pWindow11000 then
		pWindow11000:setTag(11000)
		pWindow11000:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow11000:setPosition(AUTO_POS(0.00, 0.00))pWindow11000:setContentSize(AUTO_SIZE(480, 320))
		pWindow11000:luaSetSelectorOnClose(LotteryBoat.releaseControl)
	end

	local pDragNode2 = SCDragNode:node()
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM) 
		pDragNode2:setPosition(AUTO_POS(0.00, 0.00))
		pDragNode2:setContentSize(AUTO_SIZE(480, 320))
		pDragNode2:setFrameVisibled(true)
		pDragNode2:setDragEnabled(false)
		pDragNode2:setFrameType(EnumFrameTyperedwindowstip)
	end
	
	local pDragNode36 = SCDragNode:node()                               --左底框
	if pDragNode36 then
		pDragNode36:setTag(36)
		pDragNode36:setAnchorPoint(ANCHOR_LEFT_BOTTOM) 
		pDragNode36:setPosition(AUTO_POS(6.00, 30.00))
		pDragNode36:setContentSize(AUTO_SIZE(213, 265))
		pDragNode36:setFrameVisibled(true)
		pDragNode36:setDragEnabled(false)
		pDragNode36:setFrameType(EnumFrameTypeRound)
	end
	
	local pDragNode37 = SCDragNode:node()                               --右底框
	if pDragNode37 then
		pDragNode37:setTag(36)
		pDragNode37:setAnchorPoint(ANCHOR_LEFT_BOTTOM) 
		pDragNode37:setPosition(AUTO_POS(212.00, 30.00))
		pDragNode37:setContentSize(AUTO_SIZE(265, 265))
		pDragNode37:setFrameVisibled(true)
		pDragNode37:setDragEnabled(false)
		pDragNode37:setFrameType(EnumFrameTypeRound)
	end
	
	local imgPath = getRealUIResourcePath("1.6/lottery/new00877.png")
	local pImage35 = nil
	if imgPath then
		pImage35 = SCImage:imageWithFile(imgPath:getData())
		if pImage35 then
			pImage35:setTag(35)
			pImage35:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage35:setPosition(AUTO_POS(8.00, 7.00))
		end
    end
	
	local pButton1 = SCButton:button(EnumBtnTypeNormalImg)          --关闭
	if pButton1 then
		pButton1:setTag(1)
		pButton1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton1:setPosition(AUTO_POS(458.00, 299.00))
		pButton1:setContentSize(AUTO_SIZE(20, 20))
		local imgPath = getRealUIResourcePath("img/new00123.png")
		if imgPath then
			pButton1:setTitle(imgPath:getData())
		end
	end

	local imgPath = getRealUIResourcePath("kernal/redtop.png")      
	local pImage3 = nil
	if imgPath then
		pImage3 = SCImage:imageWithFile(imgPath:getData())
		if pImage3 then
			pImage3:setTag(3)
			pImage3:setAnchorPoint(CCPointMake(0.5, 0))
			pImage3:setPosition(AUTO_POS(240.00, 296.00))
		end
	end

	local pButton4 = SCButton:button(EnumBtnTypeNormalImg)             --说明
	if pButton4 then
		pButton4:setTag(4)
		pButton4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton4:setPosition(AUTO_POS(398.00, 262.00))
		pButton4:setContentSize(AUTO_SIZE(60, 27))
		local imgPath = getRealUIResourcePath("pk/new00721.png")
		if imgPath then
			pButton4:setTitle(imgPath:getData())
		end
	end

	local pButton5 = SCButton:button(EnumBtnTypeNormalImg)          --奖励1
	if pButton5 then
		pButton5:setTag(5)
		pButton5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton5:setPosition(AUTO_POS(20.00, 226.00))
		pButton5:setContentSize(AUTO_SIZE(36, 36))
		local imgPathBack = getRealUIResourcePath("img/new00002.png")
		if imgPathBack then
		    pButton5:setBackgroundImage(imgPathBack:getData())
		end
	end

	local pButton6 = SCButton:button(EnumBtnTypeNormalImg)          --奖励2
	if pButton6 then
		pButton6:setTag(6)
		pButton6:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton6:setPosition(AUTO_POS(20.00, 167.00))
		pButton6:setContentSize(AUTO_SIZE(36, 36))
		local imgPathBack = getRealUIResourcePath("img/new00002.png")
		if imgPathBack then
		    pButton6:setBackgroundImage(imgPathBack:getData())
		end
	end

	local pButton7 = SCButton:button(EnumBtnTypeNormalImg)         	--奖励3
	if pButton7 then
		pButton7:setTag(7)
		pButton7:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton7:setPosition(AUTO_POS(20.00, 109.00))
		pButton7:setContentSize(AUTO_SIZE(36, 36))
		local imgPathBack = getRealUIResourcePath("img/new00002.png")
		if imgPathBack then
		    pButton7:setBackgroundImage(imgPathBack:getData())
		end
	end

	local pButton8 = SCButton:button(EnumBtnTypeNormalImg)          --奖励4
	if pButton8 then
		pButton8:setTag(8)
		pButton8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton8:setPosition(AUTO_POS(20.00, 51.00))
		pButton8:setContentSize(AUTO_SIZE(36, 26))
		local imgPathBack = getRealUIResourcePath("img/new00002.png")
		if imgPathBack then
		    pButton8:setBackgroundImage(imgPathBack:getData())
		end
		local ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1030, 1030)
		if ani then
			ani:setFPS(10.0)
			local aniNode = SCAnimationNode:nodeWithAnimation(ani)
			if aniNode then
				aniNode:setAnchorPoint(CCPointMake(0.5, 0.5))
				aniNode:setPosition(CCPointMake(pButton8:getContentSize().width / 2, pButton8:getContentSize().height / 2))
				pButton8:addChild(aniNode)
			end
		end
	end

	local pButton9 = SCButton:button(EnumBtnTypeNormalImg)          --船只
	if pButton9 then
		pButton9:setTag(9)
		pButton9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton9:setPosition(AUTO_POS(218.00, 189.00))
		pButton9:setContentSize(AUTO_SIZE(36, 36))
		local imgPath = getRealUIResourcePath("1.6/lottery/new00880.png")
		if imgPath then
			pButton9:setTitle(imgPath:getData())
		end
	end
    
    local pButton10 = SCButton:button(EnumBtnTypeNormalImg)         --船只
	if pButton10 then
		pButton10:setTag(10)
		pButton10:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10:setPosition(AUTO_POS(220.00, 127.00))
		pButton10:setContentSize(AUTO_SIZE(36, 36))
		local imgPath = getRealUIResourcePath("1.6/lottery/new00879.png")
		if imgPath then
			pButton10:setTitle(imgPath:getData())
		end
	end
	
	local pButton11 = SCButton:button(EnumBtnTypeNormalImg)         --船只
	if pButton11 then
		pButton11:setTag(11)
		pButton11:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton11:setPosition(AUTO_POS(220.00, 44.00))
		pButton11:setContentSize(AUTO_SIZE(36, 36))
		local imgPath = getRealUIResourcePath("1.6/lottery/new00878.png")
		if imgPath then
			pButton11:setTitle(imgPath:getData())
		end
	end
	
	local pButton12 = SCButton:button(EnumBtnType9Atlas)            --借箭按钮
	if pButton12 then
		pButton12:setTag(12)
		pButton12:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton12:setPosition(AUTO_POS(335.00, 207.00))
		pButton12:setContentSize(AUTO_SIZE(75, 30))
		pButton12:setTitle(L("str30084"), DEFAULT_FONT_NAME, F(15))
	end

	local pButton13 = SCButton:button(EnumBtnType9Atlas)
	if pButton13 then
		pButton13:setTag(13)
		pButton13:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton13:setPosition(AUTO_POS(335.00, 142.00))
		pButton13:setContentSize(AUTO_SIZE(75, 30))
		pButton13:setTitle(L("str30084"), DEFAULT_FONT_NAME, F(15))
	end

	local pButton14 = SCButton:button(EnumBtnType9Atlas)
	if pButton14 then
		pButton14:setTag(14)
		pButton14:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton14:setPosition(AUTO_POS(335.00, 78.00))
		pButton14:setContentSize(AUTO_SIZE(75, 30))
		pButton14:setTitle(L("str30084"), DEFAULT_FONT_NAME, F(15))
	end
	
	local pButton35 = SCButton:button(EnumBtnType9Atlas)
	if pButton35 then
		pButton35:setTag(35)
		pButton35:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton35:setPosition(AUTO_POS(335.00, 48.00))
		pButton35:setContentSize(AUTO_SIZE(75, 30))
		pButton35:setTitle(L("str30116"), DEFAULT_FONT_NAME, F(15))
	end

	local pLable15 = SCLabel:labelWithStringFont(L("str30085"), DEFAULT_FONT_NAME, F(15))       --宝箱名
	if pLable15 then
		pLable15:setTag(15)
		pLable15:setColor(color_yellow)
		pLable15:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable15:setPosition(AUTO_POS(76.00, 251.00))
	end

	local pLable16 = SCLabel:labelWithStringFont(L("str30086"), DEFAULT_FONT_NAME, F(15))
	if pLable16 then
		pLable16:setTag(16)
		pLable16:setColor(color_yellow)
		pLable16:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable16:setPosition(AUTO_POS(76.00, 193.00))
	end

	local pLable17 = SCLabel:labelWithStringFont(L("str30087"), DEFAULT_FONT_NAME, F(15))
	if pLable17 then
		pLable17:setTag(17)
		pLable17:setColor(color_yellow)
		pLable17:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable17:setPosition(AUTO_POS(76.00, 134.00))
	end

	local pLable18 = SCLabel:labelWithStringFont(L("str30088"), DEFAULT_FONT_NAME, F(15))
	if pLable18 then
		pLable18:setTag(18)
		pLable18:setColor(color_yellow)
		pLable18:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable18:setPosition(AUTO_POS(76.00, 77.00))
	end

	local pLable19 = SCLabel:labelWithStringFont(L("str30089"), DEFAULT_FONT_NAME, F(15))       --箭只数
	if pLable19 then
		pLable19:setTag(19)
		pLable19:setColor(color_yellow)
		pLable19:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable19:setPosition(AUTO_POS(76.00, 231.00))
	end

	local pLable20 = SCLabel:labelWithStringFont(L("str30089"), DEFAULT_FONT_NAME, F(15))
	if pLable20 then
		pLable20:setTag(20)
		pLable20:setColor(color_yellow)
		pLable20:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable20:setPosition(AUTO_POS(76.00, 173.00))
	end

	local pLable21 = SCLabel:labelWithStringFont(L("str30089"), DEFAULT_FONT_NAME, F(15))
	if pLable21 then
		pLable21:setTag(21)
		pLable21:setColor(color_yellow)
		pLable21:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable21:setPosition(AUTO_POS(76.00, 115.00))
	end

	local pLable22 = SCLabel:labelWithStringFont(L("str30089"), DEFAULT_FONT_NAME, F(15))
	if pLable22 then
		pLable22:setTag(22)
		pLable22:setColor(color_yellow)
		pLable22:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable22:setPosition(AUTO_POS(76.00, 58.00))
	end

	local pLable23 = SCLabel:labelWithStringFont(L("str30092"), DEFAULT_FONT_NAME, F(15))       --借箭消耗
	if pLable23 then
		pLable23:setTag(23)
		pLable23:setColor(color_yellow)
		pLable23:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable23:setPosition(AUTO_POS(411.00, 214.00))
	end

	local pLable24 = SCLabel:labelWithStringFont(L("str30092"), DEFAULT_FONT_NAME, F(15))
	if pLable24 then
		pLable24:setTag(24)
		pLable24:setColor(color_yellow)
		pLable24:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable24:setPosition(AUTO_POS(411.00, 148.00))
	end

	local pLable25 = SCLabel:labelWithStringFont(L("str30092"), DEFAULT_FONT_NAME, F(15))
	if pLable25 then
		pLable25:setTag(25)
		pLable25:setColor(color_yellow)
		pLable25:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable25:setPosition(AUTO_POS(411, 86.00))
	end
	local pLable50 = SCLabel:labelWithStringFont(L("str30092"), DEFAULT_FONT_NAME, F(15))
	if pLable50 then
		pLable50:setTag(50)
		pLable50:setColor(color_yellow)
		pLable50:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable50:setPosition(AUTO_POS(411.00, 56.00))
	end

	local pLable26 = SCLabel:labelWithStringFont(L("str30090"), DEFAULT_FONT_NAME, F(15))       --当前箭只数
	if pLable26 then
		pLable26:setTag(26)
		pLable26:setColor(color_yellow)
		pLable26:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable26:setPosition(AUTO_POS(39.00, 12.00))
	end

	local pLable27 = SCLabel:labelWithStringFont(L("str30091"), DEFAULT_FONT_NAME, F(15))       --当前元宝数
	if pLable27 then
		pLable27:setTag(27)
		pLable27:setColor(color_yellow)
		pLable27:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable27:setPosition(AUTO_POS(329.00, 12.00))
	end
    
    local imgPath = getRealUIResourcePath("1.6/lottery/new00876.png")
	local pImage28 = nil
	if imgPath then
		pImage28 = SCImage:imageWithFile(imgPath:getData())
		if pImage28 then
			pImage28:setTag(28)
			pImage28:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage28:setPosition(AUTO_POS(211.00, 299.20))
		end
    end
	
    local pButton29 = SCButton:button(EnumBtnType9Atlas)                                        --兑换按钮
	if pButton29 then
		pButton29:setTag(29)
		pButton29:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton29:setPosition(AUTO_POS(143.00, 223.00))
		pButton29:setContentSize(AUTO_SIZE(60, 26))
		pButton29:setTitle(L("str30104"), DEFAULT_FONT_NAME, F(15))
	end
	
	local pButton30 = SCButton:button(EnumBtnType9Atlas)                                
	if pButton30 then
		pButton30:setTag(30)
		pButton30:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton30:setPosition(AUTO_POS(143.00, 163.00))
		pButton30:setContentSize(AUTO_SIZE(60, 26))
		pButton30:setTitle(L("str30104"), DEFAULT_FONT_NAME, F(15))
	end
	
	local pButton31 = SCButton:button(EnumBtnType9Atlas)                                  
	if pButton31 then
		pButton31:setTag(31)
		pButton31:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton31:setPosition(AUTO_POS(143.00, 108.00))
		pButton31:setContentSize(AUTO_SIZE(60, 25))
		pButton31:setTitle(L("str30104"), DEFAULT_FONT_NAME, F(15))
	end
	
	local pButton32 = SCButton:button(EnumBtnType9Atlas)                                
	if pButton32 then
		pButton32:setTag(32)
		pButton32:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton32:setPosition(AUTO_POS(143.00, 52.00))
		pButton32:setContentSize(AUTO_SIZE(60, 26))
		pButton32:setTitle(L("str30104"), DEFAULT_FONT_NAME, F(15))
	end
	
	local pLable40 = SCLabel:labelWithStringFont(L("str30117"), DEFAULT_FONT_NAME, F(13))       --点击查看提示文字
	if pLable40 then
		pLable40:setTag(40)
		pLable40:setColor(color_yellow)
		pLable40:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable40:setPosition(AUTO_POS(224.00, 267.00))
	end

	if pDragNode2 and pWindow11000 then
		pWindow11000:addChild(tolua.cast(pDragNode2, "SCNode"))
	end
    if pDragNode37 and pDragNode2 then
        pDragNode2:addChild(tolua.cast(pDragNode37, "SCNode"))
    end
    if pDragNode36 and pDragNode2 then
        pDragNode2:addChild(tolua.cast(pDragNode36, "SCNode"))
    end
    if pImage35 and pDragNode37 then
        pDragNode37:addChild(tolua.cast(pImage35, "SCNode"))
    end
	if pButton1 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton1, "SCNode"))
	end
	if pImage3 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage3, "SCNode"))
	end
	if pButton4 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton4, "SCNode"))
	end
	if pButton5 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton5, "SCNode"))
	end
	if pButton6 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton6, "SCNode"))
	end
	if pButton7 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton7, "SCNode"))
	end
	if pButton8 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton8, "SCNode"))
	end
	if pButton9 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton9, "SCNode"))
	end
	if pButton11 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton11, "SCNode"))
	end
	if pButton10 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton10, "SCNode"))
	end
	if pButton12 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton12, "SCNode"))
	end
	if pButton13 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton13, "SCNode"))
	end
	if pButton14 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton14, "SCNode"))
	end
	if pButton35 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton35, "SCNode"))
	end
	if pLable15 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable15, "SCNode"))
	end
	if pLable16 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable16, "SCNode"))
	end
	if pLable17 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable17, "SCNode"))
	end
	if pLable18 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable18, "SCNode"))
	end
	if pLable19 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable19, "SCNode"))
	end
	if pLable20 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable20, "SCNode"))
	end
	if pLable21 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable21, "SCNode"))
	end
	if pLable22 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable22, "SCNode"))
	end
	if pLable23 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable23, "SCNode"))
	end
	if pLable24 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable24, "SCNode"))
	end
	if pLable25 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable25, "SCNode"))
	end
	if pLable50 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable50, "SCNode"))
	end
	if pLable26 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable26, "SCNode"))
	end
	if pLable27 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable27, "SCNode"))
	end
	if pImage28 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage28, "SCNode"))
	end
	if pButton29 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton29, "SCNode"))
	end
	if pButton30 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton30, "SCNode"))
	end
	if pButton31 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton31, "SCNode"))
	end
	if pButton32 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton32, "SCNode"))
	end
	if pLable40 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable40, "SCNode"))
	end
    
	return pWindow11000
end

function LotteryBoat.releaseControl()
	if LotteryBoat.wndClose then
		LotteryBoat.wndClose()
	end
end

function LotteryBoat.wndClose()
    mLotteryInfo = {}
    mCurBorrow = 0
    mCurExchange = 0
end

--界面功能初始化
function LotteryBoat.init()
    local wnd = getCurentSceneWindow(11000)
    if not wnd then return end
    
    --设置兑换花费值
    if mLotteryInfo.needExchangeNum1 then
        EXCHANGE_PER_COST[1] = mLotteryInfo.needExchangeNum1
    end
    
    if mLotteryInfo.needExchangeNum2 then
        EXCHANGE_PER_COST[2] = mLotteryInfo.needExchangeNum2
    end
    
    if mLotteryInfo.needExchangeNum3 then
        EXCHANGE_PER_COST[3] = mLotteryInfo.needExchangeNum3
    end
    
    if mLotteryInfo.needExchangeNum4 then
        EXCHANGE_PER_COST[4] = mLotteryInfo.needExchangeNum4
    end
    
    --设置借箭花费值
    if mLotteryInfo.lev1BorrowCost then
        BORROW_PER_COST[1] = mLotteryInfo.lev1BorrowCost
    end
    
    if mLotteryInfo.lev2BorrowCost then
        BORROW_PER_COST[2] = mLotteryInfo.lev2BorrowCost
    end
    
    if mLotteryInfo.lev3BorrowCost then
        BORROW_PER_COST[3] = mLotteryInfo.lev3BorrowCost
        BORROW_PER_COST[4] = mLotteryInfo.lev3BorrowCost * 10
    end
    
    --关闭按钮
    local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-1", wnd))         
    if pBtn then
        pBtn:luaSetSelectorOnClicked(LotteryBoat.onCloseBtnClick)
    end
    
    --船只点击
    for i = 1, 3 do
        local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-"..i + 8, wnd))     
        if pBtn then
            pBtn:luaSetSelectorOnClicked(LotteryBoat.onClickBoatBtn)
        end
    end
    
    --兑换道具点击
    for i = 1, 4 do
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-"..i + 4, wnd))     
        if pBtn then
            pBtn:luaSetSelectorOnClicked(LotteryBoat.onClickPirceBtn)
        end
    end
    
    --借箭点击
    for i = 1, 3 do
        local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-"..i + 11, wnd))     
        if pBtn then
            pBtn:luaSetSelectorOnClicked(LotteryBoat.onClickBorrowBtn)
        end
    end
    
    local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-35", wnd))     
	if pBtn then
		pBtn:luaSetSelectorOnClicked(LotteryBoat.onClickBorrowBtn)
	end
	
	local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-60", wnd))     
	if pBtn then
		pBtn:luaSetSelectorOnClicked(LotteryBoat.onClickBorrowBtn)
	end
    
    --说明点击
    local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-4", wnd))     
    if pBtn then
        pBtn:luaSetSelectorOnClicked(LotteryBoat.onClickInfoBtn)
    end
    
    --设置奖励图标
    LotteryBoat.setPricePic()
    
    --更新奖励名字
    LotteryBoat.updataPriceName()
    
    --兑换按钮
    LotteryBoat.updataExchangeBtn()
    
    --借箭消耗
    LotteryBoat.updataBorrowCost()
    
    --兑换更新
    LotteryBoat.updataExchangeCost()
    
    --更新当前箭只
    LotteryBoat.updataExchangeCur()
    
    --更新元宝数
    LotteryBoat.updataEmoney()
    
    --更新借箭按钮
    LotteryBoat.updataBorrowBtn()
end

---更新借箭按钮---
function  LotteryBoat.updataBorrowBtn()
	local wnd = getCurentSceneWindow(11000)
    if not wnd then return end
    
    local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-60", wnd))     
	if pBtn then
		if mLotteryInfo.nMoneyCounts and mLotteryInfo.nMoneyCounts == 0 then
			pBtn:setButtonType(EnumBtnTypeAsh)
			pBtn:luaSetSelectorOnClicked(LotteryBoat.funNil)
		end
	end
end

---设置奖励图标---
function LotteryBoat.setPricePic()
	local wnd = getCurentSceneWindow(11000)
    if not wnd then return end
    
    --四个奖励物品类型
	local itemtype = {}
    itemtype[1] = mLotteryInfo.itemtype1
    itemtype[2] = mLotteryInfo.itemtype2
    itemtype[3] = mLotteryInfo.itemtype3
    itemtype[4] = mLotteryInfo.itemtype4
    
    --四个奖励对应图标
    local pic = {}
    for i = 1, 4 do
		if itemtype[i] then
			local item = TableParser:getSingleton():getItemInfoByKey(itemtype[i])
			if item then
				pic[i] = item.icon
			end
		end
    end
    
    for i = 1, 4 do
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-"..i + 4, wnd))
		if pBtn and pic[i] then
			local imgPath = getRealUIResourcePath("item/"..pic[i]..".jpg")
			if imgPath then
				pBtn:setTitle(imgPath:getData())
			end
		end
    end
end

---更新奖励名---
function LotteryBoat.updataPriceName()
	local wnd = getCurentSceneWindow(11000)
    if not wnd then return end
    
    local itemtype = {mLotteryInfo.itemtype1, mLotteryInfo.itemtype2, mLotteryInfo.itemtype3, mLotteryInfo.itemtype4}
    
    for i = 1, 4 do
        local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-"..14 + i, wnd))
        if pLabel then
			if itemtype[i] and itemtype[i] > 0 then
				local stProduction = TableParser:getSingleton():getItemInfoByKey(itemtype[i])
				if stProduction and stProduction.name then
					pLabel:setText(stProduction.name:getData())
				end
            end
        end
    end
end

---兑换消耗更新---
function LotteryBoat.updataExchangeCost()
    local wnd = getCurentSceneWindow(11000)
    if not wnd then return end
    
    for i = 1, 4 do
        local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-"..18 + i, wnd))
        if pLabel then
            pLabel:setText(EXCHANGE_PER_COST[i]..L("str30089"))
        end
    end
end 

---借箭消耗更新---
function LotteryBoat.updataBorrowCost()
    if not mLotteryInfo.leftCounts then return end
    local freeTime = mLotteryInfo.leftCounts

    local wnd = getCurentSceneWindow(11000)
    if not wnd then return end
    
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-23", wnd)) 
    if pLabel then
        if freeTime > 0 then
            local text = string.format(L("str30102"), freeTime)
            pLabel:setText(text)
        else
            pLabel:setText(BORROW_PER_COST[1]..L("str30101"))
        end
    end
    
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-24", wnd)) 
    if pLabel then
        pLabel:setText(BORROW_PER_COST[2]..L("str30101"))
    end
    
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-25", wnd)) 
    if pLabel then
        pLabel:setText(BORROW_PER_COST[3]..L("str30101"))
    end
    
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-50", wnd)) 
    if pLabel then
        pLabel:setText(BORROW_PER_COST[4]..L("str30101"))
    end
    
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-70", wnd)) 
    if pLabel and mLotteryInfo.nMoneyCounts and mLotteryInfo.nNeedMoney then
		local str = ""
		if mLotteryInfo.nMoneyCounts == 100000 then
			str = string.format(L("str30186"), math.floor(mLotteryInfo.nNeedMoney / 10000))
		else 
			str = string.format(L("str30184"), math.floor(mLotteryInfo.nNeedMoney / 10000), mLotteryInfo.nMoneyCounts)
		end
		pLabel:setText(str)
		pLabel:setColor(color_yellow)
    end
end

---箭只数更新---
function LotteryBoat.updataExchangeCur()
    local wnd = getCurentSceneWindow(11000)
    if not wnd then return end
    
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-26", wnd)) 
    if pLabel and mLotteryInfo.curArrowsNum then
        pLabel:setText(L("str30090")..mLotteryInfo.curArrowsNum)
    end
end

---元宝数更新---
function LotteryBoat.updataEmoney()
    local wnd = getCurentSceneWindow(11000)
    if not wnd then return end
    
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-27", wnd)) 
    if pLabel then
        pLabel:setText(L("str30091")..Hero:getSingleton():getEmoney())
    end
end

---兑换按钮颜色状态显示---
function LotteryBoat.updataExchangeBtn()
    local wnd = getCurentSceneWindow(11000)
    if not wnd then return end

    if not mLotteryInfo.curArrowsNum then return end
    local curNum = mLotteryInfo.curArrowsNum
    
    --兑换按钮
    for i = 1, 4 do
        local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-"..i + 28, wnd))     
        if pBtn then
            if curNum >= EXCHANGE_PER_COST[i] then
                pBtn:setButtonType(1)
                pBtn:luaSetSelectorOnClicked(LotteryBoat.onClickExchangeBtn)
            else
                pBtn:setButtonType(3)
                pBtn:luaSetSelectorOnClicked(LotteryBoat.showBorrowErrorMsg)
            end
        end
    end
end

---箭只不足兑换提示---
function LotteryBoat.showBorrowErrorMsg(tag)
	if CLIENT_VERSION < 335 and tag == 32 then
		showMessage(L("str30183"))
		return
    end
	showMessage(L("str30138"))
end

----------------消息处理区----------------
---借箭信息接收---
function LotteryBoat.recLotteryMsg()
    SCActivityIndicator:getSingleton():close()
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    local action = dt:readShort()
    
    if action ==  ACTION_BORROW_ARROWS_QUERY_DATA then          --总信息
        mLotteryInfo = stLotteryInfo.initWithStream(dt)
        LotteryBoat.showLotteryBoatWnd()
    elseif action == ACTION_BORROW_ARROWS_QUERY_SELF then       --更新信息
        tmp = stLotteryUpDataInfo.initWithStream(dt)
        if mLotteryInfo.curArrowsNum then 
            mLotteryInfo.curArrowsNum = tmp.curArrowsNum 
        end
        if mLotteryInfo.leftCounts then 
            mLotteryInfo.leftCounts = tmp.leftCounts 
        end
        if mLotteryInfo.nMoneyCounts then
			mLotteryInfo.nMoneyCounts = tmp.nMoneyCounts 
        end
        
        LotteryBoat.updataBorrowCost()
        LotteryBoat.updataExchangeCur()
        LotteryBoat.updataEmoney()
        LotteryBoat.updataExchangeBtn()
        LotteryBoat.updataBorrowBtn()
    elseif action == ACTION_BORROW_ARROWS_BAG_FULL then         --背包空间满
        GuidePoint_shoprechangeTipWithInfo(L("str30098"))
    end
end

---界面请求---
function LotteryBoat.sendReqWndMsg()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_BORROW_ARROWS);
    if not dataStream then return end
    
    dataStream:writeShort(ACTION_BORROW_ARROWS_QUERY_DATA)
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show()
    end
end

---借箭发送---
function LotteryBoat.sendBorrowMsg()
    local pRunningScene = getRunningScene()
    if not pRunningScene then return end
    pRunningScene:getUINode():removeChildByTag(788889 ,true)

    if mCurBorrow == 0 then return end
    
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_BORROW_ARROWS);
    if not dataStream then return end
    
    dataStream:writeShort(ACTION_BORROW_ARROWS_BORROW)
    dataStream:writeInt(mCurBorrow)
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show()
    end
end

---金币借箭发送---
function LotteryBoat.sendMoneyBorrowMsg()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_BORROW_ARROWS)
    if not dataStream then return end
    
    dataStream:writeShort(ACTION_BORROW_ARROWS_BORROW)
    dataStream:writeInt(0)
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show()
    end
end

---兑换发送---
function LotteryBoat.sendExchangeMsg(tag)
	local pRunningScene = getRunningScene()
    if pRunningScene == nil then
        return
    end
    pRunningScene:getUINode():removeChildByTag(788889 ,true)
    
	if tag == 1 then
		if mCurExchange == 0 then return end

		local dataStream = SCDataTransStream:streamWithCommand(_MSG_BORROW_ARROWS);
		if not dataStream then return end
		
		dataStream:writeShort(ACTION_BORROW_ARROWS_GET_BOX)
		dataStream:writeInt(mCurExchange)
		if SCDataTransThread:getSingleton() then
			SCDataTransThread:getSingleton():transData(dataStream)
			SCActivityIndicator:getSingleton():show()
		end
	end
end

----------------全局函数区----------------
function LotteryBoat.showLotteryBoatWnd()
    local wnd = getCurentSceneWindow(11000)
    if wnd then return end
    
    local wnd = LotteryBoat.initControl()
    if wnd == nil then
        return
    end
    if wnd then
        local wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
            wnd:setFrameVisibled(true)
            wnd:setCloseButtonVisibled(false)
        end
        LotteryBoat.init()
    end
end

SCMessageCenter:getSingleton():luaRegistCommand(LotteryBoat.recLotteryMsg, _MSG_BORROW_ARROWS, 0, nil)

