SCTRANS_NONE			= 0
SCTRANS_MIRROR			= 2
SCTRANS_ROT90			= 5
SCTRANS_MIRROR_ROT90	= 7
SCTRANS_ROT180			= 3
SCTRANS_MIRROR_ROT180	= 1
SCTRANS_ROT270			= 6
SCTRANS_MIRROR_ROT270	= 4

--随机排序
local function randomSort(wheelAwardItem)
	math.randomseed(os.time())
	local tab = {} --随机本表
	local retTab = {}
	local Rand
	local nMax = #wheelAwardItem
	for i=1, nMax do
		table.insert(tab, i)
	end
	
	for i=1, #tab do
		Rand = math.random(nMax)
		while tab[Rand] == nil do
			Rand = math.random(nMax)
		end
		tab[Rand] = nil
		table.insert(retTab, wheelAwardItem[Rand])
	end
	return retTab
end

stWheelAwardItem = {
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		local tmp = {}
		tmp.nId = dt:readInt()
		tmp.szName = " "
		local str = dt:readString()
		if str then
			tmp.szName = str:getData()
		end
		tmp.nNum = dt:readInt()
		tmp.nItemType = dt:readInt() --	//1 = 金钱2 = 储备金3 = 修为（阅历）4 = 经验 5 =声望， 其他 = 物品类型
		tmp.nPhoto = dt:readInt()
		tmp.nOdd = dt:readInt()
		tmp.szDescribe = nil
		local str = dt:readString()
		if str then
			tmp.szDescribe = str:getData()
		end
		
		return tmp
	end
}
stWheelInfo = {
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		local tmp = {}
		tmp.usTimes = dt:readShort()
		tmp.nContribution = dt:readInt()
		tmp.nCost = dt:readInt()
		tmp.ucAmount = dt:readByte()
		tmp.awardItems = {}
		for i=1, tmp.ucAmount do
			table.insert(tmp.awardItems, stWheelAwardItem.initWithStream(dt))
		end
		tmp.awardItems = randomSort(tmp.awardItems)
		return tmp
	end
}

stStartWheelInfo = {
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		local tmp = {}
		tmp.nId = dt:readInt()
		tmp.usTimes = dt:readShort()
		tmp.nContribution = dt:readInt()
		tmp.nCost = dt:readInt()
		tmp.szAward = nil
		local str = dt:readString()
		if str then
			tmp.szAward = str:getData()
		end
			
		return tmp
	end
}

local TIMER_TIME = 0.1
local FAST_ROUND_TIME = 4
local START_SPIN_TIME	= 0.1
local END_SPIN_TIME		= 0.3

local m_wheelItemInfo = nil
local m_startWheelInfo = nil
local m_spinTurn = nil
local m_spinGapTime = nil
local m_spinNowTime = nil
local m_spinLastTime = nil
local m_entryId = nil

--转动结束发送消息
local function sendWheelEndMsg()
	local MSG_LUCKY_WHEEL_END = 5
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_COPYAWARD)
	dataStream:writeShort(MSG_LUCKY_WHEEL_END)
	SCDataTransThread:getSingleton():transData(dataStream)
end

--关闭按钮响应
local function onCloseBtn()
	local naviCtrl = getCurentSceneNavigationController()
	if naviCtrl then
		naviCtrl:removeWindowControllerByTag(5940)
	end
end

--窗口关闭时
local function onWndClose5940(tag)
	m_wheelItemInfo = nil
	m_startWheelInfo = nil
	m_spinTurn = nil
	m_spinGapTime = nil
	m_spinNowTime = nil
	m_spinLastTime = nil
	if m_entryId then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
		m_entryId = nil
	end
end

--开始游戏
local function onClickStartPlay(tag)
	local MSG_LUCKY_WHEEL_AWARD = 4
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_COPYAWARD)
	dataStream:writeShort(MSG_LUCKY_WHEEL_AWARD)
	if m_wheelItemInfo.usTimes == 1000 then
		dataStream:writeByte(0)
	else
		dataStream:writeByte(1)
	end
	SCDataTransThread:getSingleton():transData(dataStream)
end

--点击物品回调
local function onClickAwardItem(tag)
	if m_wheelItemInfo.awardItems[tag] and m_wheelItemInfo.awardItems[tag].szDescribe then
		luaShowTip(m_wheelItemInfo.awardItems[tag].szDescribe, nil, nil, nil, m_wheelItemInfo.awardItems[tag].szName)
	end
end

--填充物品图片
local function fillItem(pWnd, wheelItemInfo)
	if not pWnd then
		return
	end
	local backImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1", pWnd))
	if not backImg then
		return
	end
	for i=11, 18 do
		local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-"..i, pWnd))
		if img then
			if wheelItemInfo.awardItems[i-10] then
				local btn = SCButton:button()
				btn:setTag(i-10)
				--btn:setContentSize(CCSizeMake(SX(36), SY(36)))
				btn:setAnchorPoint(CCPointMake(0.5, 0.5))
				btn:setPosition(img:getPosition())
				btn:luaSetSelectorOnClicked(onClickAwardItem)
				if wheelItemInfo.awardItems[i-10].nItemType == 1 then
					local file = getRealUIResourcePath("img/new00052.png")
					if file then
						btn:setTitle(file:getData())
						--btn:setScale(1.2)
					end
				elseif wheelItemInfo.awardItems[i-10].nItemType == 3 then
					local file = getRealUIResourcePath("img/new00051.png")
					if file then
						btn:setTitle(file:getData())
						--btn:setScale(1.3)
					end
				else
					local file,rect = getItemImageByIcon(wheelItemInfo.awardItems[i-10].nPhoto)
					if file then
						btn:setTitle(file:getData(), rect)
					end
				end
				if i==11 then
					btn:setPosition(CCPointMake(img:getPosition().x, img:getPosition().y-SY(8)))
				elseif i==12 then
					btn:setPosition(CCPointMake(img:getPosition().x+SX(4), img:getPosition().y))
				elseif i==13 then
					btn:setPosition(CCPointMake(img:getPosition().x-SX(2), img:getPosition().y))
				elseif i==14 then
					btn:setPosition(CCPointMake(img:getPosition().x, img:getPosition().y-SY(8)))
				elseif i==15 then
					btn:setPosition(CCPointMake(img:getPosition().x, img:getPosition().y+SY(5)))
				elseif i==16 then
					btn:setPosition(CCPointMake(img:getPosition().x-SX(5), img:getPosition().y))
				elseif i==17 then
					btn:setPosition(CCPointMake(img:getPosition().x+SX(5), img:getPosition().y))
				elseif i==18 then
					btn:setPosition(CCPointMake(img:getPosition().x, img:getPosition().y+SY(5)))
				end
				backImg:addChild(btn)
			end
		end
	end
end

--创建窗口
local function cteateWheelWindow()
	local pWnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5940))
	if not pWnd then
		return nil
	end
	local pWndCtrl = SCWindowController:controllerWithWindow(pWnd)
	if not pWndCtrl then
		return nil
	end
	pWnd:luaSetSelectorOnClose(onWndClose5940)
	pWnd:setFrameVisibled(false)
	local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2", pWnd))
	if btn then
		btn:luaSetSelectorOnClicked(onCloseBtn)
	end
	local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-20", pWnd))
	if btn then
		--btn:setContentSize(CCSizeMake(SX(32), SY(32)))
		btn:setTitle(_LTParser("str5092"), getDefaultFontName(), getFontSize(14), color_orange)
		btn:luaSetSelectorOnClicked(onClickStartPlay)
	end
	local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-11", pWnd))
	if img then
		img:setVisible(false)
	end
	local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-12", pWnd))
	if img then
		img:setVisible(false)
	end
	local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-13", pWnd))
	if img then
		img:setTransform(SCTRANS_ROT90)
		img:setVisible(false)
	end
	local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-14", pWnd))
	if img then
		img:setTransform(SCTRANS_ROT90)
		img:setVisible(false)
	end
	local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-15", pWnd))
	if img then
		img:setTransform(SCTRANS_ROT180)
		img:setVisible(false)
	end
	local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-16", pWnd))
	if img then
		img:setTransform(SCTRANS_ROT180)
		img:setVisible(false)
	end
	local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-17", pWnd))
	if img then
		img:setTransform(SCTRANS_ROT270)
		img:setVisible(false)
	end
	local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-18", pWnd))
	if img then
		img:setTransform(SCTRANS_ROT270)
		img:setVisible(false)
	end
	fillItem(pWnd, m_wheelItemInfo)
	return pWndCtrl
end

--显示转轮窗口
function LuckyWheel_showLuckyWheelWindow(dataStream)
	m_wheelItemInfo = stWheelInfo.initWithStream(dataStream)
	if isWindControllerExistence(5940) then
		return
	end
	local pWndCtrl = cteateWheelWindow()
	if not pWndCtrl then
		return
	end
	local naviCtrl = getCurentSceneNavigationController()
	if naviCtrl then
		naviCtrl:pushWindowController(pWndCtrl)
	end
	pWndCtrl:getWindow():setCloseButtonVisibled(false)
		if isWindControllerExistence(5201) then
		local naviCtrl = getCurentSceneNavigationController()
		if naviCtrl then
			naviCtrl:removeWindowControllerByTag(5201)
		end
	end
	if isWindControllerExistence(8012) then
		local naviCtrl = getCurentSceneNavigationController()
		if naviCtrl then
			naviCtrl:removeWindowControllerByTag(8012)
		end
	end
end

--转动定时器
local function spinTimer(float)
	m_spinNowTime = m_spinNowTime + TIMER_TIME
	if m_spinNowTime-m_spinLastTime >= m_spinGapTime then
		if m_spinTurn > 8 then
			m_spinTurn = 1
		end
		local previousTurn = m_spinTurn - 1
		if previousTurn < 1 then
			previousTurn = 8
		end
		local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("5940-1-"..(10+previousTurn)))
		if img then
			img:setVisible(false)
		end
		local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("5940-1-"..(10+m_spinTurn)))
		if img then
			img:setVisible(true)
		end
		
		if m_spinGapTime >= END_SPIN_TIME then
			if m_wheelItemInfo.awardItems[m_spinTurn].nId == m_startWheelInfo.nId then
				sendWheelEndMsg()
				if m_entryId then
					CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
					m_entryId = nil
				end
				if m_startWheelInfo.szAward then
					luashowConfirmationWindow(m_startWheelInfo.szAward, WIN_YES)
				end
			end
			local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("5940-1-20"))
			if btn then
				btn:setTouchEnabled(true)
			end
		end
		
		m_spinTurn = m_spinTurn + 1
		m_spinLastTime = m_spinNowTime
		if m_spinNowTime >= FAST_ROUND_TIME then
			m_spinGapTime = END_SPIN_TIME
		end
	end
end

--转轮开始
function LuckyWheel_startPlay(dataStream)
	local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("5940-1-20"))
	if btn then
		btn:setTouchEnabled(false)
	end
	for i=11, 18 do
		local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("5940-1-"..i))
		if img then
			img:setVisible(false)
		end
	end
	m_startWheelInfo = stStartWheelInfo.initWithStream(dataStream)
	m_spinTurn = 1
	m_spinGapTime = START_SPIN_TIME
	m_spinNowTime = TIMER_TIME
	m_spinLastTime = 0
	if m_entryId == nil then
		m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(spinTimer, TIMER_TIME, false)
	end
	playEffectMusic("rotary.mp3")
end