--struct-------------------------------------------------------------------------------
local stShowStatus = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            nStatus,    --状态id
            ucDelFlag,    --/*删除标志：0添加，1删除*/
            nPhoto,    
            ucPosition, --/*位置*/
            szName,    --/*名字*/
            szDescribe, --/*描述*/
            szParam,    --/*额外说明*/
            nRemainSec,    --/*剩余时间*/
        }
        tmp.nStatus = dt:readInt()
        tmp.ucDelFlag = dt:readByte()
        tmp.nPhoto = dt:readInt()
        tmp.ucPosition = dt:readByte()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szName = ""
        else
            tmp.szName = scStr:getData()
        end
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szDescribe = ""
        else
            tmp.szDescribe = scStr:getData()
        end
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szParam = ""
        else
            tmp.szParam = scStr:getData()
        end
        tmp.nRemainSec = dt:readInt()
        return tmp
    end
}

--end struct------------------------------------------------------------------------

--data------------------------------------------------------------------------------
--边距
local leftOffset = 4 * gUIScale().x
local bottonOffset = 20 * gUIScale().y
local rightOffset = (getScreenWidth() - 4 * gUIScale().x)
local topOffset = (getScreenHeight() - 4 * gUIScale().y)
local perHeight = 5 * gUIScale().x
local perWidth = 5 * gUIScale().y
local totalBarWidth = getScreenWidth()
local HpBarWidth = 50
local MpBarWidth = 50
local windowWidth = getScreenWidth()
local windowHeight = getScreenHeight()

--[[
--需要显示的按钮
local m_bottomMainBtnType = {UNLOCK_TYPE_FORMAT, UNLOCK_TYPE_EQUIP_STRENGTHEN, UNLOCK_TYPE_BOOK,
    UNLOCK_TYPE_HUNT, UNLOCK_TYPE_SPIRIT_IN_EQUIP, UNLOCK_TYPE_NORMAL_WORK, UNLOCK_TYPE_SEED,UNLOCK_TYPE_SKILL}
local m_topMainBtnType = {UNLOCK_TYPE_GET_AWARD, UNLOCK_TYPE_ADDUP_ONLINE_GIFT,
    UNLOCK_TYPE_NEWBIE_EMONEY , UNLOCK_TYPE_MAIL, UNLOCK_TYPE_USER_TALENT, UNLOCK_TYPE_ELFGUARD,
    UNLOCK_TYPE_FRIEND, UNLOCK_TYPE_HERO_COPY, UNLOCK_TYPE_PVPBATTLE}
--local m_rightMainBtnType = {UNLOCK_TYPE_SKILL}
]]

--需要显示的按钮
--上面的上排按钮
local m_topBtnType = {UNLOCK_TYPE_TYPE8, UNLOCK_TYPE_EVERYDAYE_TASK, UNLOCK_TYPE_KITS, UNLOCK_TYPE_WOLRD_BOSS, UNLOCK_TYPE_TYPE12, UNLOCK_TYPE_TYPE13, UNLOCK_TYPE_AREAN, UNLOCK_TYPE_DEVIL_COPY, UNLOCK_TYPE_HERO_COPY,UNLOCK_TYPE_TYPE9, UNLOCK_TYPE_TYPE10, UNLOCK_TYPE_TYPE7};
--上面的下排按钮
local m_topBtnType1 = {};
--下面的下排按钮
local m_bottomBtnType1 = {UNLOCK_TYPE_WING, UNLOCK_TYPE_ITEM_SOUL,UNLOCK_TYPE_TYPE4, UNLOCK_TYPE_TREASURE, UNLOCK_TYPE_RECRUITPARTNER};
--下面的上排按钮
local m_bottomBtnType2 = {UNLOCK_TYPE_RANK, UNLOCK_TYPE_TRIBE, UNLOCK_TYPE_TEAM, UNLOCK_TYPE_SKILL, UNLOCK_TYPE_FRIEND, UNLOCK_TYPE_MAIL};
--左侧的按钮
local m_liftBtnType = {UNLOCK_TYPE_EQUIP_STRENGTHEN, UNLOCK_TYPE_MAGIC_LEVELUP};
--奖励内按钮
local m_topBtnChildType = {}
if CLIENT_VERSION > 328 then
m_topBtnChildType = {UNLOCK_TYPE_MOODS_GIFT,UNLOCK_TYPE_FRIENDS_GIFT,UNLOCK_TYPE_TIRNED_AWARD, UNLOCK_TYPE_TYPE1,UNLOCK_TYPE_VIP_GIFT,
                            UNLOCK_TYPE_ARENA_GIFT, UNLOCK_TYPE_ADDUP_ONLINE_GIFT, UNLOCK_TYPE_RECHARGE_GIFT, UNLOCK_TYPE_TYPE2, 
                            UNLOCK_TYPE_SEVEN_GIFT, UNLOCK_TYPE_SIGN_IN, UNLOCK_TYPE_ACHIEVE_AWARD, UNLOCK_TYPE_TRIBE_GIFT, UNLOCK_TYPE_SOCIATY_WAR_AWARD,
							UNLOCK_TYPE_SOCIATY_WAR_AWARD}
else
m_topBtnChildType = {UNLOCK_TYPE_MOODS_GIFT,UNLOCK_TYPE_FRIENDS_GIFT,UNLOCK_TYPE_TIRNED_AWARD, UNLOCK_TYPE_TYPE1,UNLOCK_TYPE_VIP_GIFT,UNLOCK_TYPE_ARENA_GIFT, UNLOCK_TYPE_ADDUP_ONLINE_GIFT, UNLOCK_TYPE_RECHARGE_GIFT, UNLOCK_TYPE_TYPE2, UNLOCK_TYPE_SEVEN_GIFT, UNLOCK_TYPE_SIGN_IN, UNLOCK_TYPE_ACHIEVE_AWARD, UNLOCK_TYPE_TRIBE_GIFT, UNLOCK_TYPE_SOCIATY_WAR_AWARD}
end
--活动内按钮
local m_topBtnChildByActivity = {}
if CLIENT_TYPE == 2 then
	m_topBtnChildByActivity = {--[[UNLOCK_TYPE_PRIVATE_ACTIVITY,]] UNLOCK_TYPE_TYPE56,UNLOCK_TYPE_TYPE57,UNLOCK_TYPE_TYPE58,UNLOCK_TYPE_TYPE59,UNLOCK_TYPE_TYPE60,
									UNLOCK_TYPE_TYPE61, UNLOCK_TYPE_LOTTERY_DRAW, UNLOCK_TYPE_RUSH_TO_PURCHASE, --[[UNLOCK_TYPE_GRAND_TOTAL_RECHARGE,]]
									UNLOCK_TYPE_PRODUCE_MAGIC_DRUG, UNLOCK_TYPE_MEET_FAIRY, UNLOCK_TYPE_CELADON, --[[UNLOCK_TYPE_LOGIN_AWARD, ]]
									UNLOCK_TYPE_24HOURS_GIVE_WING, UNLOCK_TYPE_VIP_PERFERENCE_SHOP, UNLOCK_TYPE_WING_SHOP, UNLOCK_TYPE_CHIBI_TREASURE}
else
	m_topBtnChildByActivity = {--[[UNLOCK_TYPE_PRIVATE_ACTIVITY,]] UNLOCK_TYPE_TYPE56,UNLOCK_TYPE_TYPE57,UNLOCK_TYPE_TYPE58,UNLOCK_TYPE_TYPE59,UNLOCK_TYPE_TYPE60,
									UNLOCK_TYPE_TYPE61, UNLOCK_TYPE_LOTTERY_DRAW, UNLOCK_TYPE_RUSH_TO_PURCHASE, UNLOCK_TYPE_GRAND_TOTAL_RECHARGE,
									UNLOCK_TYPE_PRODUCE_MAGIC_DRUG, UNLOCK_TYPE_MEET_FAIRY, UNLOCK_TYPE_CELADON, UNLOCK_TYPE_LOGIN_AWARD, 
									UNLOCK_TYPE_24HOURS_GIVE_WING, UNLOCK_TYPE_VIP_PERFERENCE_SHOP, UNLOCK_TYPE_WING_SHOP, UNLOCK_TYPE_CHIBI_TREASURE}
end

--功能按钮type
local m_gongNengType = {UNLOCK_TYPE_GOOD_LUCK, UNLOCK_TYPE_SEED, UNLOCK_TYPE_ACHIEVE, UNLOCK_TYPE_LIBRARY}
--挑战按钮type
local m_tiaoZhanType = {UNLOCK_TYPE_HERO_COPY,  UNLOCK_TYPE_TWELVE_ANIMALS} --UNLOCK_TYPE_TOWER,
--修行按钮type
local m_xiuXingType = {UNLOCK_TYPE_USER_TALENT, UNLOCK_TYPE_BOOK, UNLOCK_TYPE_ELFGUARD, UNLOCK_TYPE_HUNT}
--社交按钮type
local m_sheJiaoType = {UNLOCK_TYPE_MAIL, UNLOCK_TYPE_NORMAL_WORK}

--按钮node
local m_pLeftBarNode = nil

--人物状态数据
local m_showStatus = {}
--小图标
local m_showIconStatus = {}

--解锁按钮数据
--[[
local m_unlockBottomMainBtn = nil
local m_unlockTopMainBtn = nil
local m_unlockRightMainBtn = nil
local m_unlockLeftMainBtn = nil
local m_otherUnlockBtn = nil
]]
local m_gongNengBtn = nil
local m_tiaoZhanBtn = nil
local m_xiuXingBtn = nil
local m_sheJiaoBtn = nil
local m_rightBtn = nil
local m_topBtn = nil
local m_topBtn1 = nil
local m_bottomBtn1 = nil
local m_bottomBtn2 = nil
local m_liftBtn = nil
    
--标记
local m_isHide = false
local m_isHideTop = true
local m_isHideRight = false

local m_entryId = nil
--经验条滚动效果
local m_entryIdExp = nil
local m_tmpExp = nil;
local m_tmpMaxExp = nil;
local m_upgradeMark = nil;
local m_moveValue = nil;

local m_functionTipType = -5000
local ACTION_COPY_MONSTOR_NAME = 17
local USERINFO_EVERYAWARD_UPDATA_GIFT = 105
local USERINFO_SCALE_AWARD = 114    --分级礼包
local GIFT_GROUP_SCALE_USERLEV = 9  --礼包类型
local downloadInfoFlg = -1 --下载礼包
local ACHIEVEMENT_ACTION_GET_INFO =8    --成就信息 
local MAP_CHEAT_PROSON	= 1080400--,			// 外挂监狱
local USERINFO_GET_ARMY_GIFT = 124      --//领取军团礼包

--end data-------------------------------------------------------------------------

--single function----------------------------------------------------------------------
local showExperienceBar

local function sendUnlockBtnHitMsg(usType)
    local unInfo = luaGetUnlockInfoWithType(usType)
    if unInfo then
        if unInfo.byFlag == 2 then
            showTip(unInfo.idItemType);
            return;
        end
    end
	SCActivityIndicator:getSingleton():show()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_PUSH_UNLOCK)
    dataStream:writeShort(usType)
    SCDataTransThread:getSingleton():transData(dataStream)
end

local function sendUnlockBtnHitMsg1(usType)
	SCActivityIndicator:getSingleton():show()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_PUSH_UNLOCK)
    dataStream:writeShort(usType)
    SCDataTransThread:getSingleton():transData(dataStream)
end

local function sendUnlockBtnHitMsg2(usType)
    local unInfo = luaGetUnlockInfoWithType(usType)
    if unInfo then
        if unInfo.byFlag == 3 then
            showMessage(L("str0487"))
            return;
        end
        if unInfo.usData == 1 then   --弹出提示框
            --showTip(unInfo.idItemType);
            if usType == UNLOCK_TYPE_MOODS_GIFT then         --加好友
                luashowConfirmationWindow(_LTParser("str0485"), WIN_YES, NewFriends_showNewFriendsWnd)
                SCActivityIndicator:getSingleton():show()
                local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
                dataStream:writeShort(USERINFO_PUSH_UNLOCK)
                dataStream:writeShort(usType)
                SCDataTransThread:getSingleton():transData(dataStream)
            elseif usType == UNLOCK_TYPE_FRIENDS_GIFT then   --好友对酒
                luashowConfirmationWindow(_LTParser("str0486"), WIN_YES, OnTheWine.showWnd)
                SCActivityIndicator:getSingleton():show()
                local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
                dataStream:writeShort(USERINFO_PUSH_UNLOCK)
                dataStream:writeShort(usType)
                SCDataTransThread:getSingleton():transData(dataStream)
            end
            return;
        end
    
        if unInfo.byFlag == 1 then
            if usType == UNLOCK_TYPE_MOODS_GIFT then         --加人气
                OnTheWine.onClickReward(1)
            elseif usType == UNLOCK_TYPE_FRIENDS_GIFT then   --好友度
                OnTheWine.onClickReward(2)
            end
        elseif unInfo.byFlag == 2 then
            if usType == UNLOCK_TYPE_MOODS_GIFT then         --加好友
                NewFriends_showNewFriendsWnd()
            elseif usType == UNLOCK_TYPE_FRIENDS_GIFT then   --好友对酒
                OnTheWine.showWnd()
            end
        end
    end
end

--获取节点，parent为nil时默认父节点为主界面
local function getNodeByIdlistAndParent(list, parent)
	if parent == nil then
		parent = getMainInterface()
		if parent == nil then
			return nil
		end
	end
	return SCFunction:getUiNodeByIdlistAndParent(list, parent)
end
--end single function-----------------------------------------------------------------

--call back function------------------------------------------------------------------
--显示隐藏功能按钮
local function onClickHideMainBtn(tag)
	showOrHideBottomButton(m_isHide)
	restartAllBeginnerGuide()
end

function MainInterface_hideBtnOnCutMap()
    MainInterface_hideBtn(true)
end

--隐藏按钮
function MainInterface_hideBtn(mark)
    if Hero:getSingleton():getLeval() < 30 and mark == nil then
        return;
    end
    m_isHide = false;
    onClickHideMainBtn();
end

function MainInterface_ShowBtn()
    m_isHide = true;
    onClickHideMainBtn();
end

--显示隐藏上面按钮
local function onClickHideTopBtn(tag)
	showOrHideTopButton(m_isHideTop)
	restartAllBeginnerGuide()
end

--设置是否显示右侧按钮
function setIsHideRightButton(isHide)
	m_isHideRight = not isHide
	local pRightBarNode = getNodeByIdlistAndParent("5934", nil)
	if pRightBarNode then
		pRightBarNode:setVisible(isHide)
	end
	showOrHideBottomButton(not m_isHide)
end
--显示隐藏底部菜单，全局其他脚本有调用
function getIsBottomButtonHide()
	return m_isHide
end
function showOrHideBottomButton(isHide)
	local pBottomBarNode = getNodeByIdlistAndParent("5933", nil)
    if pBottomBarNode == nil then
		return
	end
	m_isHide = not isHide
    local imgPath = nil
    if m_isHide == true then
        imgPath = getRealUIResourcePath("img/img5010.png")
    else
        imgPath = getRealUIResourcePath("img/img5011.png")
    end
    local pBtnHide = tolua.cast(getNodeByIdlistAndParent("5931", nil), "BtnMainInterface")
    if pBtnHide then
		pBtnHide:setTitle(imgPath:getData())
	end
    pBottomBarNode:setVisible(not m_isHide)
    
    if m_isHide == true then
        ChatProcessor:getSingleton():setChatTextVisible(true);
    elseif m_isHide == false then
        ChatProcessor:getSingleton():setChatTextVisible(false);
    end
end


--显示隐藏头部菜单，全局函数其他脚本有调用
function getIsTopButtonHide()
	return m_isHideTop
end
function showOrHideTopButton(isHide)
	local pTopBarNode = tolua.cast(getNodeByIdlistAndParent("5932", nil), "BtnMainInterface")
    if pTopBarNode == nil then
		return
	end
	m_isHideTop = not isHide
    local imgPath = nil
    if m_isHideTop == true then
        imgPath = getRealUIResourcePath("img/img5010.png")
    else
        imgPath = getRealUIResourcePath("img/img5011.png")
    end
    local pBtnHideTop = tolua.cast(getNodeByIdlistAndParent("5932-1001", nil), "BtnMainInterface")
    if pBtnHideTop then
		pBtnHideTop:setTitle(imgPath:getData())
	end
--[[    local pCurrencyInfoNode = getNodeByIdlistAndParent("5936", nil)
    if m_isHideTop and pCurrencyInfoNode then
        pCurrencyInfoNode:setVisible(true)
    elseif pCurrencyInfoNode then
        pCurrencyInfoNode:setVisible(false)
    end--]]
    showTopMainBtn()
end
--竞技场
local function onClickDoujingChang(tag)
	local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickDoujingChang(tag)
    end
end
--招财
local function onClickLucky(tag)
	local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickLucky(tag)
    end
end
--聊天窗口
local function onClickChat(tag)
	local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickChat(tag)
        Hero:getSingleton():stopAutoMove();
    end
	--createBag()
end
--修炼技能
local function onClickSkills(tag)
    sendOpenMsg_SkillStudyScreen()
	--[[local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickSkills(tag)
    end]]
end
--背包
local function onClickBag(tag)
	local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickBag(tag)
    end
end
--幻兽
local function onClickPhantom(tag)
	local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickPhantom(tag)
    end
end
--人物
local function onClickHero(tag)
    local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickHero(tag)
    end
end
--系统设置
local function onClickSystem(tag)
    showAccountWnd();
	--[[local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickSystem(tag)
    end]]
end
--邮件
local function onClickMail(tag)
    open_MailScreen()
	--[[local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickMail(tag)
    end ]]
end
--任务
local function onClickMission(tag)
	createTaskWnd()
end
--世界地图
local function onClickWoldMap(tag)
    showWorldMapController();
    --sendQueryWolrdMap();
	--local pMainInterface = getMainInterface()
    --if pMainInterface ~= nil then
    --    pMainInterface:onClickWoldMap(tag)
    --end
end
--冥想
local function onPractice(tag)
--[[	local pMainInterface = getMainInterface()
--	if pMainInterface ~= nil then
	--	pMainInterface:onPractice(tag)
		sendOnlineLevMeg(getAutonline_type());
--	end
	showGuideStep(GUIDE_TYPE_SKILL, -1)]]
    --AnswerGuess.initControl()
	sendAutomaticGrindingInfo();
end
--周围玩家
local function onClickSroundPalyer(tag)
	local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickSroundPalyer(tag)
    end
end
--隐藏主界面
local function onClickMainSceneCtrl(tag)
	local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickMainSceneCtrl(tag)
    end
end
--布阵系统
local function onClickFormation(tag)  
	--showFormationWnd()
	AnswerGuess.initControl()
end
--公会
local function onClickSociety(tag)
    open_SocietyScreen()
	--[[local pMainInterface = getMainInterface()
	if pMainInterface ~= nil then
		pMainInterface:onClickSociety(tag)
	end]]
end
--魔豆
local function onClickNormalWork(tag)
	local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickNormalWork(tag)
    end
end
--塔罗
local function onClickTarot(tag)
	local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickTarot(tag)
    end
end
--购买体力
local function onClickVipBuyPower(tag)
    Hero:getSingleton():stopAutoMove();
    GuidePoint_LuaAddCount(7, 0)  --体力增加引导计数    
	showGuideStep(GUIDE_TYPE_BUY_PHYSICAL_POWER, -1)
	local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickVipBuyPower(tag)
    end
end
--好友
local function onClickFriend(tag)
    showFriendWnd()
    --initStep(UNLOCK_TYPE_EQUIP_STRENGTHEN)
end
--排行榜
local function onClickRankingList(tag)
    showRankingListWnd()
    showGuideStep(GUIDE_TYPE_RANK, -1)
end
--成就
local function onClickAchieve(tag)
    showAchieveWnd()
end
--称号
local function onClickPlayerTitle(tag)
    showPlayerTitleWnd();
end
--护戒使者
local function onClickEscortRing(tag)
	SCActivityIndicator:getSingleton():show()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_OPEN_CONVOYRING)
    SCDataTransThread:getSingleton():transData(dataStream)
end
--vip基础
local function onClickVipBase(tag)
    local theStr = getAppName():getData()
	if string.find(theStr, "APPstore") then--string.find(theStr, "HERO_IOS4") then
		itunesPayWindow.showItunesWindow()
		return
	end
	SCActivityIndicator:getSingleton():show()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_VIP_INFO)
    SCDataTransThread:getSingleton():transData(dataStream)
end
--小助手
local function onClickAssistant(tag)
--[[
openAssistant_Wnd();
]]--
	newOutPutStream(_MSG_USERINFO);
	writeShort(USERINFO_OPEN_EVERYDAY);
	sendData(true);
	--[[
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
	dataStream:writeShort(USERINFO_OPEN_EVERYDAY)
	SCDataTransThread:getSingleton():transData(dataStream)
	]]--
end
--点金卷轴
local function onClickMoneyReel(tag)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_PUSH_UNLOCK)
    dataStream:writeShort(UNLOCK_TYPE_MONEY_SYMBOL)
    SCDataTransThread:getSingleton():transData(dataStream)
    showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
end
--人物天赋
local function onClickTalent(tag)

    sendUnlockBtnHitMsg(UNLOCK_TYPE_USER_TALENT)
end
--精灵守护
local function onClickWizardGuardian()
	sendUnlockBtnHitMsg(UNLOCK_TYPE_ELFGUARD)
end
--主界面解锁按钮回调
local function onBtnClick(tag)
	if tag == m_functionTipType then
		setLightEfficiency(m_functionTipType, false)
	end
    if tag == UNLOCK_TYPE_PVPBATTLE then
        sendUnlockBtnHitMsg(tag)
        return
    end
    if tag == UNLOCK_TYPE_BOOK then
        onClickSkills(tag)
        return
    end
    if tag == UNLOCK_TYPE_HUNT then
        onClickTarot(tag)
        return
    end
    if tag == UNLOCK_TYPE_SPIRIT_IN_EQUIP then
        return
    end    
    if tag == UNLOCK_TYPE_MAIL then
        onClickMail(tag)
        return
    end
    if tag == UNLOCK_TYPE_HERO_COPY then
        onClickPhantom(tag)
        return
    end
    if tag == UNLOCK_TYPE_FRIEND then
        showFriendWnd()
        return
    end
    if tag == UNLOCK_TYPE_USER_TALENT then
        onClickTalent(tag)
        return
    end
    if tag == UNLOCK_TYPE_ELFGUARD then
        onClickWizardGuardian(tag)
        return
    end
    if tag == UNLOCK_TYPE_ACHIEVE then
        createAchieveWnd()
        return
    end
    if tag == UNLOCK_TYPE_LIBRARY then
        sendOpenHelpSystemMsg()
        return
    end
    if tag == UNLOCK_TYPE_NORMAL_WORK then
        onClickSociety(tag)
        return
    end
    if tag == UNLOCK_TYPE_SEED then
        onClickNormalWork(tag)
        return
    end
end

--点击功能和挑战中的按钮
local function onClickGTS(tag)
    local navi = getCurentSceneNavigationController()
    if navi:getWindowControllerByTag(5913) then
        navi:removeWindowControllerByTag(5913)
    end
    onBtnClick(tag)
end

--点击修行和社交中的按钮
local function onClickXSS(tag)
	local pBottomBarNode = getNodeByIdlistAndParent("5933", nil)
    if not pBottomBarNode then
        return
    end
    if pBottomBarNode:getChildByTag(5914) then
        pBottomBarNode:removeChildByTag(5914, true)
    end
    onBtnClick(tag)
end

local function initLineData(type)
    local tLock = nil
    local btnName = ""
    local ulock = {}
    if type==1 then
        tLock = m_gongNengBtn
        btnName = _LTParser("str0022")
    else
        tLock = m_tiaoZhanBtn
        btnName = _LTParser("str5085")
    end
    for i=1, #tLock do
        local tmp = {}
        if tLock[i].szName:getData() then
            tmp.name = tLock[i].szName:getData()
        else
            tmp.name = ""
        end
        tmp.type = tLock[i].usType
        tmp.photo = tLock[i].nPhoto
        if tLock[i].szTip:getData() then
            tmp.data = tLock[i].szTip:getData()
        else
            tmp.data = ""
        end
        tmp.btnName = btnName
        table.insert(ulock, tmp)
    end
    return ulock
end

local function ctrlEvent(tag, event)
	if event == LuaControllerEventAddEnded then
		if isGuideCanStart(GUIDE_TYPE_SEED) then
			setRestartGuideFlag(GUIDE_TYPE_SEED, true)
			showGuideStep(GUIDE_TYPE_SEED, 3, 2)
		elseif isGuideCanStart(GUIDE_TYPE_HERO_COPY) then
			setRestartGuideFlag(GUIDE_TYPE_HERO_COPY, true)
			showGuideStep(GUIDE_TYPE_HERO_COPY, 3, 2)
		elseif isGuideCanStart(GUIDE_TYPE_LIBRARY) then
			setRestartGuideFlag(GUIDE_TYPE_LIBRARY, true)
			showGuideStep(GUIDE_TYPE_LIBRARY, 3, 2)
		end
		setLightEfficiency(m_functionTipType, true)
	elseif event == LuaControllerEventRemoveBegan then
		setLightEfficiency(m_functionTipType, false)
		if isGuideCanStart(GUIDE_TYPE_SEED) then
			restartBeginnerGuide(GUIDE_TYPE_SEED)
		elseif isGuideCanStart(GUIDE_TYPE_HERO_COPY) then
			restartBeginnerGuide(GUIDE_TYPE_HERO_COPY)
		elseif isGuideCanStart(GUIDE_TYPE_LIBRARY) then
			showGuideStep(GUIDE_TYPE_LIBRARY, -1)
		end
	end
end

--功能和挑战按钮
local function onClickedBtnMuster(tag)
	local addFlag = false
    local naviCtrl = getCurentSceneNavigationController()
    local wndCtrl = naviCtrl:getWindowControllerByTag(5913)
    if not wndCtrl then
        local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5913))
        wnd:setAnchorPoint(CCPointMake(0.5, 0.5))
        wnd:setPosition(CCPointMake(windowWidth/2, windowHeight/2))
        --wnd:setBackgroundColor(color_window_red_bg)
        wndCtrl = SCWindowController:controllerWithWindow(wnd)
        wndCtrl:luaSetSelectorOnEvent(ctrlEvent)
        addFlag = true
    end
    local wnd = wndCtrl:getWindow()
    local dragNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(1))
    local listBox = SCTypeCast:castNodeToListBox(wnd:getChildByTag(2))
    if not dragNode or not listBox then
        return
    end
    dragNode:setFrameType(EnumFrameTypeRound)
    dragNode:setFrameVisibled(true)    
    local unlock = nil
    local btnName = nil
    if tag == 1002 then
        wnd:setTitle(_LTParser("str5084"), getDefaultFontName(), getFontSize(15))
        unlock = initLineData(1)
        local titlefile = getRealUIResourcePath("img/titile16.png")
        if titlefile then
            wnd:setTitleWithImage(titlefile:getData())
        end
    elseif tag == 1003 then
        wnd:setTitle(_LTParser("str5085"), getDefaultFontName(), getFontSize(15))
        unlock = initLineData(2)
        local titlefile = getRealUIResourcePath("img/titile19.png")
        if titlefile then
            wnd:setTitleWithImage(titlefile:getData())
        end
    end
    for i=1, #unlock do
        local node = SCDragNode:node()
        node:setContentSize(CCSizeMake(412 * gUIScale().x, 45 * gUIScale().y))
        node:setDragEnabled(false)
        node:setFrameType(EnumFrameTypeListNormal)
        node:setFrameVisibled(true)    
        local posX = 5 * gUIScale().x
        local img = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/"..unlock[i].photo..".png", nil)
        img:setAnchorPoint(CCPointMake(0.5, 0.5))
        img:setTag(1)
        posX = posX + img:getContentSize().width/2 + 5
        img:setPosition(CCPointMake(posX, node:getContentSize().height/2))
        posX = posX + img:getContentSize().width/2 + 5
        node:addChild(img)
        local name = unlock[i].name
        if name == "" then
            name = " "
        end
        local label = SCLabel:labelWithStringFont(name, getDefaultFontName(), getFontSize(15))
        label:setColor(color_orange)
        label:setAnchorPoint(CCPointMake(0, 1))
        --posX = posX + label:getContentSize().width/2 + 5
        label:setPosition(CCPointMake(posX, node:getContentSize().height-5))
        node:addChild(label)
        local data = unlock[i].data
        if data == "" then
            name = " "
        end
        local label = SCLabel:labelWithStringFont(data, getDefaultFontName(), getFontSize(12))
        --label:setAnchorPoint(CCPointMake(0.5, 0.5))
        --posX = posX + label:getContentSize().width/2 + 5
        label:setPosition(CCPointMake(posX, 5))
        node:addChild(label)
        local btn = SCButton:button(EnumBtnType9Atlas)
        btn:setTag(unlock[i].type)
        btn:luaSetSelectorOnClicked(onClickGTS)
        btn:setContentSize(CCSizeMake(78 * gUIScale().x, 30 * gUIScale().y))
        btn:setTitle(unlock[i].btnName, getDefaultFontName(), getFontSize(15))
        btn:setAnchorPoint(CCPointMake(0.5, 0.5))
        btn:setPosition(CCPointMake(node:getContentSize().width-5-btn:getContentSize().width/2, node:getContentSize().height/2))
        node:addChild(btn)
        listBox:addItem(node)
        node:setTag(unlock[i].type)
    end
    if addFlag then
		naviCtrl:addWindowController(wndCtrl)
    end
end
--进入和移除时的回调
local function enterExitEvent(eventType)
	if eventType == kCCNodeOnEnter then
		if isGuideCanStart(GUIDE_TYPE_TALENT) then
			setRestartGuideFlag(GUIDE_TYPE_TALENT, true)
			showGuideStep(GUIDE_TYPE_TALENT, 3, 2)
            return
        end
		if isGuideCanStart(GUIDE_TYPE_FORMAT_1) then
			setRestartGuideFlag(GUIDE_TYPE_FORMAT_1, true)
			showGuideStep(GUIDE_TYPE_FORMAT_1, 3, 2)
            return
        end
		if isGuideCanStart(GUIDE_TYPE_BOOK) then
			setRestartGuideFlag(GUIDE_TYPE_BOOK, true)
			showGuideStep(GUIDE_TYPE_BOOK, 3, 2)
            return
        end
		if isGuideCanStart(GUIDE_TYPE_ELFGUARD) then
			setRestartGuideFlag(GUIDE_TYPE_ELFGUARD, true)
			showGuideStep(GUIDE_TYPE_ELFGUARD, 3, 2)
            return
        end
		if isGuideCanStart(GUIDE_TYPE_HUNT) then
			setRestartGuideFlag(GUIDE_TYPE_HUNT, true)
			showGuideStep(GUIDE_TYPE_HUNT, 3, 2)
            return
		end
		if isGuideCanStart(GUIDE_TYPE_GUILD) then
			setRestartGuideFlag(GUIDE_TYPE_GUILD, true)
			showGuideStep(GUIDE_TYPE_GUILD, 3, 2)
		end
		setLightEfficiency(m_functionTipType, true)
	elseif tag == kCCNodeOnExit then
		if isGuideCanStart(GUIDE_TYPE_TALENT) then
			restartBeginnerGuide(GUIDE_TYPE_TALENT)
            return
        end
		if isGuideCanStart(GUIDE_TYPE_FORMAT_1) then
			restartBeginnerGuide(GUIDE_TYPE_FORMAT_1)
            return
        end
		if isGuideCanStart(GUIDE_TYPE_BOOK) then
			restartBeginnerGuide(GUIDE_TYPE_BOOK)
            return
        end
		if isGuideCanStart(GUIDE_TYPE_ELFGUARD) then
			restartBeginnerGuide(GUIDE_TYPE_ELFGUARD)
            return
        end
		if isGuideCanStart(GUIDE_TYPE_HUNT) then
			restartBeginnerGuide(GUIDE_TYPE_HUNT)
            return
		end
		if isGuideCanStart(GUIDE_TYPE_GUILD) then
			restartBeginnerGuide(GUIDE_TYPE_GUILD)
		end
		setLightEfficiency(m_functionTipType, false)
	end
end
--修行和社交按钮
local function onClickedXS(tag)
	local pBottomBarNode = getNodeByIdlistAndParent("5933", nil)
	if not pBottomBarNode then
		return
	end
	if pBottomBarNode:getChildByTag(5914) then
		pBottomBarNode:removeChildByTag(5914, true)
	end
	local btn = tolua.cast(pBottomBarNode:getChildByTag(tag), "BtnMainInterface")
	if not btn then
		return
	end
	local unlock = nil
	if tag == 1004 then
		unlock = m_xiuXingBtn
	elseif tag == 1005 then
		unlock = m_sheJiaoBtn
	end
	if #unlock <= 0 then
		return
	end
	local framWnd = FrameWindow:frameWnd()
	framWnd:registerScriptHandler(enterExitEvent)
	framWnd:setCloseBtnVisible(false)
	framWnd:setTag(5914)
	local startX = 10*gUIScale().x
	for i=1, #unlock do
		local btn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/"..unlock[i].nPhoto..".png", nil)
		if btn then
			btn:setTag(unlock[i].usType)
			btn:luaSetSelectorOnClicked(onClickXSS)
			btn:setPosition(startX, 10*gUIScale().y)
			framWnd:addChild(btn)
			startX = startX + btn:getContentSize().width + 5
		end
	end
	framWnd:setContentSize(CCSizeMake(startX+5*gUIScale().x, 62*gUIScale().y))
	framWnd:setAnchorPoint(CCPointMake(0.5, 0.5))
	framWnd:setPosition(CCPointMake(btn:getContentSize().width/2+btn:getPosition().x, btn:getPosition().y+framWnd:getContentSize().height/2 + 5*gUIScale().y + btn:getContentSize().height))
	pBottomBarNode:addChild(framWnd)
end

--点击状态按钮
local function onStatuBtnClick(tag)
    for i=1, #m_showStatus do
        if tag == m_showStatus[i].nStatus then
            --luaShowTip(m_showStatus[i].szName.." "..m_showStatus[i].szDescribe)
            showMessage(m_showStatus[i].szName.." "..m_showStatus[i].szDescribe)
        end
    end
end
--空操作回调
local function nilCallBack(tag)
    
end

--end call back function------------------------------------------------------------

--show mainInterface function-------------------------------------------------------
local function onClickRightBtn(tag)
	if tag == m_functionTipType then
		setLightEfficiency(m_functionTipType, false)
	end
	if tag == 1001 then
		onClickSystem(tag)
	elseif tag == 1002 then
		onClickMission(tag)
	elseif tag == 1003 then
		onClickWoldMap(tag)
	end
end
--显示右侧按钮
local function showRightMainBtn()
    if 1 then
        return;
    end
	local pMainInterface = getMainInterface()
    if pMainInterface == nil then
        return
    end
    
    local nWidth = 0
    local nHeight = 0
    local nStartY = 0
    local isCreate = true
    local pRightBarNode = getNodeByIdlistAndParent("5934", nil)
    if pRightBarNode == nil then
        isCreate = false
        pRightBarNode = SCNode:node()
        pRightBarNode:setTag(5934)
    end
    
     m_rightBtn = {}
    local tmp = {}
    tmp.tag = 1001
    tmp.photo = 5012
	table.insert(m_rightBtn, tmp)
	local tmp = {}
    tmp.tag = 1002
    tmp.photo = 5011
	table.insert(m_rightBtn, tmp)
	local tmp = {}
    tmp.tag = 1003
    tmp.photo = 5010
	table.insert(m_rightBtn, tmp)
	
	for i=1, #m_rightBtn do
		local pBtn = tolua.cast(pRightBarNode:getChildByTag(m_rightBtn[i].tag), "BtnMainInterface")
		if pBtn == nil then
			pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/"..m_rightBtn[i].photo..".png", nil)
			if pBtn ~=nil then
				pBtn:luaSetSelectorOnClicked(onClickRightBtn)
				pBtn:setTag(m_rightBtn[i].tag)
				pRightBarNode:addChild(pBtn)
			end
		end
		
		pBtn:setPosition(CCPointMake(0, nStartY))
		nWidth = pBtn:getContentSize().width
		nHeight = pBtn:getContentSize().height
		nStartY = nStartY + nHeight + perHeight
	end
    
    pRightBarNode:setContentSize(CCSizeMake(nWidth, nStartY))
    
    if not isCreate then
        pRightBarNode:setAnchorPoint(CCPointMake(1, 0));
        pRightBarNode:setPosition(CCPointMake(rightOffset, bottonOffset + nHeight));

        pMainInterface:addChild(pRightBarNode);
    end
end

--显示左侧按钮
local function showLeftMainBtn1()
	local pMainInterface = getMainInterface()
    if pMainInterface == nil then
        return
    end
    if m_pLeftBarNode ~= nil then
        return
    end
    local nWidth = 0;
    local nHeight = 0;
    local nStartY  = 0;    
    m_pLeftBarNode = SCNode:node()
    m_pLeftBarNode:setTag(5935)
    
    local pbtn = nil
    pbtn = BtnMainInterface:getMainInterfaceButton("img/channelSetClose.png", "护戒使者")
    if pbtn ~= nil then
        pbtn:luaSetSelectorOnClicked(onClickEscortRing)
        pbtn:setPosition(CCPointMake(0, nStartY))
        nWidth = pbtn:getContentSize().width
        nHeight = pbtn:getContentSize().height
        nStartY = nStartY + nHeight + perHeight
        m_pLeftBarNode:addChild(pbtn)
    end
    
    pbtn = BtnMainInterface:getMainInterfaceButton("img/channelSetClose.png", "好友")
    if pbtn ~= nil then
        pbtn:luaSetSelectorOnClicked(onClickFriend)
        pbtn:setPosition(CCPointMake(0, nStartY))
        nWidth = pbtn:getContentSize().width
        nHeight = pbtn:getContentSize().height
        nStartY = nStartY + nHeight + perHeight
        m_pLeftBarNode:addChild(pbtn)
    end
    
    pbtn = BtnMainInterface:getMainInterfaceButton("img/channelSetClose.png", "排行版")
    if pbtn ~= nil then
        pbtn:luaSetSelectorOnClicked(onClickRankingList)
        pbtn:setPosition(CCPointMake(0, nStartY))
        nWidth = pbtn:getContentSize().width
        nHeight = pbtn:getContentSize().height
        nStartY = nStartY + nHeight + perHeight
        m_pLeftBarNode:addChild(pbtn)
    end
    --[[
    pbtn = BtnMainInterface:getMainInterfaceButton("img/channelSetClose.png", "公告")
    if pbtn ~= nil then
        pbtn:luaSetSelectorOnClicked(creatAnnouncementWnd)
        pbtn:setPosition(CCPointMake(0, nStartY))
        nWidth = pbtn:getContentSize().width
        nHeight = pbtn:getContentSize().height
        nStartY = nStartY + nHeight + perHeight
        m_pLeftBarNode:addChild(pbtn)
    end
    ]]
    
    pbtn = BtnMainInterface:getMainInterfaceButton("img/channelSetClose.png", "成就")
    if pbtn ~= nil then
        pbtn:luaSetSelectorOnClicked(onClickAchieve)
        pbtn:setPosition(CCPointMake(0, nStartY))
        nWidth = pbtn:getContentSize().width
        nHeight = pbtn:getContentSize().height
        nStartY = nStartY + nHeight + perHeight
        m_pLeftBarNode:addChild(pbtn)
    end
    
    pbtn = BtnMainInterface:getMainInterfaceButton("img/channelSetClose.png", "称号")
    if pbtn ~= nil then
        pbtn:luaSetSelectorOnClicked(onClickPlayerTitle)
        pbtn:setPosition(CCPointMake(0, nStartY))
        nWidth = pbtn:getContentSize().width
        nHeight = pbtn:getContentSize().height
        nStartY = nStartY + nHeight + perHeight
        m_pLeftBarNode:addChild(pbtn)
    end
    
    pbtn = BtnMainInterface:getMainInterfaceButton("img/channelSetClose.png", "布阵")
    if pbtn ~= nil then
        pbtn:luaSetSelectorOnClicked(onClickFormation)
        pbtn:setPosition(CCPointMake(0, nStartY))
        nWidth = pbtn:getContentSize().width
        nHeight = pbtn:getContentSize().height
        nStartY = nStartY + nHeight + perHeight
        m_pLeftBarNode:addChild(pbtn)
    end
    
    pbtn = BtnMainInterface:getMainInterfaceButton("img/channelSetClose.png", "小助手")
    if pbtn ~= nil then
        pbtn:luaSetSelectorOnClicked(onClickAssistant)
        pbtn:setPosition(CCPointMake(0, nStartY))
        nWidth = pbtn:getContentSize().width
        nHeight = pbtn:getContentSize().height
        nStartY = nStartY + nHeight + perHeight
        m_pLeftBarNode:addChild(pbtn)
    end
    
    m_pLeftBarNode:setContentSize(CCSizeMake(nWidth, nStartY))
    m_pLeftBarNode:setAnchorPoint(CCPointMake(0, 0))
    m_pLeftBarNode:setPosition(CCPointMake(leftOffset, bottonOffset + 42))

    pMainInterface:addChild(m_pLeftBarNode)
    
end

local function onshowRankingList(tag)
    --showRankingListWnd();
    showGuideStep(GUIDE_TYPE_RANK, -1)
end

--修改引导按钮
function alterTopMainTaskBtn()
    local taskBtn = SCTypeCast:castNodeToButton(getNodeByIdlistAndParent("5932-1007", nil))
    if taskBtn then
        taskBtn:removeAllChildrenWithCleanup(true)
        local imgpath = getbtnBackgroundImg()
        if imgpath then
            taskBtn:setBackgroundImage(imgpath)
        end
        imgpath = getbtnProspectImg()
        if imgpath then
            local mark = getbtnProspectImgMark();
            if mark == 0 then
                if imgpath ~= "" then
                    local pNode = SCImage:imageWithFile(imgpath)
                    if pNode then
                        taskBtn:removeAllChildrenWithCleanup(true)
                        taskBtn:addChild(pNode)
                    end   
                end              
            else
                local length = 52
                local file = getRealUIResourcePath("img/img2036.png")
                if file then
                    local pNode = SCImage:imageWithFile(file:getData(), setRealRect(CCRectMake((mark - 1) * length, 0, length, 32)))
                    if pNode then
                        taskBtn:addChild(pNode)
                        pNode:setAnchorPoint(CCPointMake(0.5, 0))
                        setNodePostion(pNode, CCPointMake(getNodeContentSize(taskBtn).width / 2, 35))
                    end 
                end
                if imgpath ~= "" then
                    local pNode = SCImage:imageWithFile(imgpath)
                    if pNode then
                        taskBtn:removeAllChildrenWithCleanup(true)
                        taskBtn:addChild(pNode)
                    end   
                end
            end
        end
        imgpath = getRealUIResourcePath("img/img7084.png");
        if imgpath then
            local pNode = SCImage:imageWithFile(imgpath:getData())
            if pNode then
                pNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                pNode:setPosition(CCPointMake(taskBtn:getContentSize().width / 2, taskBtn:getContentSize().height / 2));
                taskBtn:addChild(pNode)
            end   
        end
        freeBtntmp();
        --taskBtn:setTitle(name, getDefaultFontName(), getFontSize(12))
        --taskBtn:setBackgroundImage(imgpath:getData())
    end
end

--local onMainBtnClick
local function onActivityBtnClick(tag)
    if tag >= 10000 then            --显示界面
        ActivityAll_ShowActivityDetailWndWithUnlockType(tag)
    elseif  tag == UNLOCK_TYPE_MEET_FAIRY then   --//巧遇仙女
        --fairy_Click()
        NewFairy_OpenNewFairyWnd()--新洛神殿
        return
    elseif tag == UNLOCK_TYPE_CELADON then   --//敲青瓷
        knock_Click()
        return
    elseif tag == UNLOCK_TYPE_PRODUCE_MAGIC_DRUG then  --//炼丹
        furnace_Click()
        return
    elseif tag == UNLOCK_TYPE_TYPE56 then        --//新手特权
        newPlayerPriv_SendPrivData()
        return
    elseif tag == UNLOCK_TYPE_TYPE57 then        --//单笔充值送礼  
        showMessage(_LTParser("str6194"))
    elseif tag == UNLOCK_TYPE_TYPE58 then        --//充值积分兑换
        if luaIsUnlock(UNLOCK_TYPE_TYPE58) then
            IntegralReward_SendMsg(UNLOCK_TYPE_TYPE58)
        end
    elseif tag == UNLOCK_TYPE_TYPE59 then        --//充值积分抽奖
        showMessage(_LTParser("str6194"))
    elseif tag == UNLOCK_TYPE_TYPE60 then        --//消费积分兑换
        if luaIsUnlock(UNLOCK_TYPE_TYPE60) then
            IntegralReward_SendMsg(UNLOCK_TYPE_TYPE60)
        end
    elseif tag == UNLOCK_TYPE_TYPE61 then        --//消费积分抽奖
        showMessage(_LTParser("str6194"))
    elseif tag == UNLOCK_TYPE_PRIVATE_ACTIVITY then --//封测活动
        --ShowWndActivityAll()
        rechargeActivit_queryData()
        return
    elseif tag == UNLOCK_TYPE_RECHARGE_RETURN then  --//充值返礼
        ActivityAll_showReturnGiftWnd();
        return
    elseif tag == UNLOCK_TYPE_LOGIN_AWARD then --送香香
        MarryXiang_ShowMarryXiangWnd()
        return
    elseif tag == UNLOCK_TYPE_LOTTERY_DRAW then --狂欢抽奖
        WingAndRevel_Open30RevelDayWnd()
        return
    elseif tag == UNLOCK_TYPE_24HOURS_GIVE_WING then --送翅膀
        WingAndRevel_Open24HourToGiveWingWnd()
        return
    elseif tag == UNLOCK_TYPE_RUSH_TO_PURCHASE then --限时抢购
        GiftActivity_ShowDayByMoneyWnd()
        return
    elseif tag == UNLOCK_TYPE_GRAND_TOTAL_RECHARGE then--送土豪金活动
        GiftActivity_ShowGoldenEggWnd()
        return
    elseif tag == UNLOCK_TYPE_VIP_PERFERENCE_SHOP then --特惠商城
        VIPShop_ShowVIPShop()
        return
    elseif tag == UNLOCK_TYPE_THANKSGIVINGDAY then --感恩节活动    活动过后请手动删除
        ActivityAll_ShowShanksWnd()
        return
	elseif tag == UNLOCK_TYPE_WING_SHOP then		--羽翼商店
		WingsShop.showTreasureHuntWnd()
		return 
	elseif tag == UNLOCK_TYPE_CHIBI_TREASURE then	--赤壁寻宝
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
		dataStream:writeShort(USERINFO_PUSH_UNLOCK)
		dataStream:writeShort(UNLOCK_TYPE_CHIBI_TREASURE)
		SCDataTransThread:getSingleton():transData(dataStream)
		
		if CLIENT_VERSION < 335 then
			showMessage(L("str9236"))
			return 
		end
		TreasureHunt.sendHuntWndReq()
		return 
    end    
    onMainBtnClick(tag)
end
--活动内按钮
local function showTopBtnByActivity()        
    local pFrameWindow = FrameWindow:frameWnd()
    --local tag = MainInterface_getMainBtn()
    local pNode = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-10111"), "SCNode")
    local nWidth = SX(10)
    local fWidth = SX(10)
    local nHeight = SY(25);
    if pFrameWindow and pNode then
        pNode:addChild(pFrameWindow, 1000, 5999);
        local partent = pNode:getParent();
        if partent == nil then
            return;
        end
        partent:reorderChild(pNode, 1000);
	    pFrameWindow:setCloseBtnVisible(false)

	    local nCount = 0;
	    local nSum = 0
	    local updateTip = ActivityAll_getUpdateTipData()
	    local haveFlag = false
	    for key, value in pairs(updateTip) do
	        local findFlag = false
	        for i = 1, #m_topBtnChildByActivity do
	            if m_topBtnChildByActivity[i] == key then
	                findFlag = true
	                break
	            end
	        end
	        if findFlag == false then
				if key ~= WONDERFULEVENT_TYPE_EXPLAIN then
					table.insert(m_topBtnChildByActivity, key)
				end
	        end
	        haveFlag = true
	    end
	    if false == haveFlag then
	        local findFlag = false
	        for i = 1, #m_topBtnChildByActivity do
	            if m_topBtnChildByActivity[i] == UNLOCK_TYPE_PRIVATE_ACTIVITY then
	                findFlag = true
	                break
	            end
	        end
	        if findFlag == true then
	            table.remove(m_topBtnChildByActivity, 1)
	        end
	    else
	        local findFlag = false
	        for i = 1, #m_topBtnChildByActivity do
	            if m_topBtnChildByActivity[i] == UNLOCK_TYPE_PRIVATE_ACTIVITY then
	                findFlag = true
	                break
	            end
	        end
	        if findFlag == false then
				if key ~= WONDERFULEVENT_TYPE_EXPLAIN then
					--table.insert(m_topBtnChildByActivity, 1, UNLOCK_TYPE_PRIVATE_ACTIVITY)
				end
	        end
	    end
	    for i = 1, #m_topBtnChildByActivity do
	        if luaIsUnlock(m_topBtnChildByActivity[i]) or (m_topBtnChildByActivity[i]>=10000 and updateTip[m_topBtnChildByActivity[i]]) then
                local unInfo
                if m_topBtnChildByActivity[i]>=10000 then
                    unInfo = updateTip[m_topBtnChildByActivity[i]]
                else
                    unInfo = luaGetUnlockInfoWithType(m_topBtnChildByActivity[i])
                end
                if unInfo.nPhoto ~= 0 then
                    nSum = nSum + 1
                end
            end
	    end
	    local sizeWidth = 0
	    local sizeHeight = 0
	    if nSum > 5 then
	        sizeWidth = SX(55)*5
	        sizeHeight = SX(50)*(math.floor((nSum-1)/5)+1)+SX(45)
	    else
	        sizeWidth = SX(55)*nSum + SX(15)
	        sizeHeight = SX(50)*(math.floor((nSum-1)/5)+1)+SX(45)
	    end
	    pFrameWindow:setContentSize(CCSizeMake(sizeWidth, sizeHeight))
        for i = 1, #m_topBtnChildByActivity do
            if luaIsUnlock(m_topBtnChildByActivity[i]) or (m_topBtnChildByActivity[i]>=10000 and updateTip[m_topBtnChildByActivity[i]]) then
                local unInfo
                if m_topBtnChildByActivity[i]>=10000 then
                    unInfo = updateTip[m_topBtnChildByActivity[i]]
                else
                    unInfo = luaGetUnlockInfoWithType(m_topBtnChildByActivity[i])
                end
                if unInfo.nPhoto ~= 0 then     
                    local pBtn = nil;
                    local time = unInfo.dwTimeCountDown;
                    if unInfo.byFlag == 2 and 5004 ~= unInfo.nPhoto then
                        pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/"..unInfo.nPhoto.."1.png", nil, time);
                    else
	                    pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/"..unInfo.nPhoto..".png", nil, time);
                    end            
	                if pBtn then
	                    if unInfo.byFlag == 2 then
                            local pLabel = nil;
                            local str = nil;
                            if unInfo.nPhoto == 5001 then
                                --str = L("str6210");
                            elseif unInfo.nPhoto == 5013 then
                                --str = L("str6208");
                            elseif unInfo.nPhoto == 5022 then
                                str = L("str6208");
                            elseif unInfo.nPhoto == 5029 then
                                str = L("str6209");
                            elseif unInfo.nPhoto == 5010 then
                                str = L("str6208");
                            elseif unInfo.nPhoto == 5004 then
                                --str = L("str3070");
                            elseif unInfo.nPhoto == 5028 then
                                str = NewFairy_GetMainInterfaceTitle()
                            end
                            
                            if m_topBtnChildByActivity[i] == UNLOCK_TYPE_RECHARGE_RETURN then
                                str = "";
                            end
                                                    
                            if str then
                                pLabel = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(8));
                            end
                            if pLabel then
                                pLabel:setAnchorPoint(CCPointMake(0.5, 1));
                                pLabel:setPosition(CCPointMake(pBtn:getContentSize().width / 2, 0));
                                pBtn:addChild(pLabel);
                            end
	                    end
	                    local str = nil;
	                    if unInfo.nPhoto == 5004 then
                            --str = L("str3070");
                            str = L("str20037")
                        end
                        if unInfo.nPhoto == 5027 then
                            str = L("str3131")
                        elseif unInfo.nPhoto == 5037 then
                            str = L("str3169")
                        end
                        if m_topBtnChildByActivity[i] == UNLOCK_TYPE_RECHARGE_RETURN then
                            str = L("str9198");
                        end
                        if m_topBtnChildByActivity[i] == UNLOCK_TYPE_LOGIN_AWARD then
                            str = L("str20011")
                        elseif m_topBtnChildByActivity[i] == UNLOCK_TYPE_LOTTERY_DRAW then
                            str = L("str20016")
                        elseif m_topBtnChildByActivity[i] == UNLOCK_TYPE_24HOURS_GIVE_WING then
                            str = L("str20020")
                        elseif m_topBtnChildByActivity[i] == UNLOCK_TYPE_MEET_FAIRY then
                            str = NewFairy_GetMainInterfaceTitle()
                        elseif m_topBtnChildByActivity[i] == UNLOCK_TYPE_RUSH_TO_PURCHASE then
                            str = GiftActivity_GetDayByMoneyString()
                        elseif m_topBtnChildByActivity[i] == UNLOCK_TYPE_GRAND_TOTAL_RECHARGE then
                            str = L("str20049")
                        elseif m_topBtnChildByActivity[i] == UNLOCK_TYPE_THANKSGIVINGDAY then
                            str = L("str20078")
                        elseif m_topBtnChildByActivity[i] == UNLOCK_TYPE_VIP_PERFERENCE_SHOP then
                            str = L("str20099")
						elseif m_topBtnChildByActivity[i] == UNLOCK_TYPE_WING_SHOP then
							str = L("str30119")
						elseif m_topBtnChildByActivity[i] == UNLOCK_TYPE_CHIBI_TREASURE then
							str = L("str30147")
                        end
                        if 10000 <=  unInfo.usType then
                            if ActivityAll_getActivetyType(unInfo.usType) then
                                local tmpTxt = Split(L("str6290"), "_")
                                if tmpTxt[ActivityAll_getActivetyType(unInfo.usType)] then
                                    str = tmpTxt[ActivityAll_getActivetyType(unInfo.usType)]
                                end
                            end
                        end
                        local label5004 = nil
                        if str then
                            label5004 = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(8));
                        end
                        if label5004 then
                            label5004:setAnchorPoint(CCPointMake(0.5, 1));
                            label5004:setPosition(CCPointMake(pBtn:getContentSize().width / 2, 0));
                            pBtn:addChild(label5004);
                        end
                        pFrameWindow:addChild(pBtn);
                        pBtn:setTag(m_topBtnChildByActivity[i]);
                        if unInfo.byFlag == 1 then
                            setLightEfficiency(m_topBtnChildByActivity[i], true)
                        end
                        if 5013 == unInfo.nPhoto and unInfo.usType ~= UNLOCK_TYPE_RUSH_TO_PURCHASE then
                            setLightEfficiency(m_topBtnChildByActivity[i], true)
                        end
                        if 10000 <=  unInfo.usType then
                            setLightEfficiency(m_topBtnChildByActivity[i], true)
                        end
                        
                        if m_topBtnChildByActivity[i] == UNLOCK_TYPE_MEET_FAIRY and NewFairy_GetJewlAmount() > 0 then
                            setLightEfficiency(m_topBtnChildByActivity[i], true)
                        end
                        pBtn:setAnchorPoint(CCPointMake(0, 1))
                        nCount = nCount + 1;
                        pBtn:setPosition(CCPointMake(nWidth + SX(10), sizeHeight-nHeight))
                        nWidth = nWidth + pBtn:getContentSize().width + SX(15); 
                        if nCount%5 == 0 then
                            nHeight = nHeight + pBtn:getContentSize().height + SY(10);
                            nWidth = SX(10)
                        end
                        if fWidth < nWidth then
                            fWidth = nWidth
                        end
				        pBtn:luaSetSelectorOnClicked(onActivityBtnClick);
                    end
                end
            end
        end   
        
        if nSum > 5 then
            nHeight = nHeight + SY(20)
        end
        --local size = CCSizeMake(fWidth + SX(17), nHeight + SY(30));
        --pFrameWindow:setContentSize(size);
        local imgPath = getRealUIResourcePath("img/new00586.png")
        if imgPath then
            local pImage = SCImage:imageWithFile(imgPath:getData());
            if pImage then
                pImage:setAnchorPoint(CCPointMake(0.5, 0));
                pImage:setPosition(CCPointMake(sizeWidth / 2, sizeHeight - SY(9)));
                pFrameWindow:addChild(pImage);
            end
        end
        pFrameWindow:setAnchorPoint(CCPointMake(0.5, 1));
        pFrameWindow:setPosition(CCPointMake(pNode:getContentSize().width / 2, 0));
    end
end

local function showTopBtnRespond(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    if dataStream then                   ----消息发送提示
        dataStream:writeShort(USERINFO_EVERYAWARD_UPDATA_GIFT)
        dataStream:writeByte(tag);
        SCDataTransThread:getSingleton():transData(dataStream)
        --showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show();
    end
end

local function sendDownloadAward(tag)
    
    local pNode = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-1010"), "SCNode")
    if pNode then
        pNode:removeChildByTag(5914,true);
    end
    if tag == 19001 or tag == 29001 then
        
        local num = nil
        if tag == 19001 then
            num = 1
        else
            num = 2
        end
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
        if dataStream then                   ----消息发送提示
            dataStream:writeShort(USERINFO_SCALE_AWARD)
            dataStream:writeByte(num);
            dataStream:writeInt(GIFT_GROUP_SCALE_USERLEV);
            SCDataTransThread:getSingleton():transData(dataStream)
            SCActivityIndicator:getSingleton():show();
        end
    end
    if tag == 19000 then
		if string.find(getAppName():getData(), "IOS") then
			showMessage(_LTParser("str9215"))
		else
			showMessage(_LTParser("str3079"))
		end
    elseif tag == 29000 then
		if string.find(getAppName():getData(), "IOS") then
			showMessage(_LTParser("str9216"))
		else
			showMessage(_LTParser("str3080"))
		end
    end
end

local function showTopBtn()
	if CLIENT_VERSION > 328 then
		GetPrice.showGetPriceWnd()
		GetPrice.init()
		return
	end
	
    local pFrameWindow = FrameWindow:frameWnd()
    local pNode = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-1010"), "SCNode")
    local nWidth = SX(10)
    local fWidth = SX(10)
    local sWidth = SX(10)
    local nHeight = nil;
    if pFrameWindow and pNode then
        pNode:addChild(pFrameWindow, 1000, 5914);
        local partent = pNode:getParent();
        if partent == nil then
            return;
        end
        partent:reorderChild(pNode, 1000);
	    pFrameWindow:setCloseBtnVisible(false)
	    pFrameWindow:setOutSpaceClickClose(true)
	    pFrameWindow:luaSetReturnSelector(GuidePoint_topGuide);
	    local nCount = 0;
	    local nCount = 0;
	    local nSum = 0
	    local playerLevel = Hero:getSingleton():getLeval();
	    local downloadTag = 0
	    local extraSum = 1
	    local bDownPath
	    nSum = nSum + extraSum
	    for i = 1, #m_topBtnChildType do
	        if luaIsUnlock(m_topBtnChildType[i]) then
	            nSum = nSum + 1
	        end
	        
	    end
	    --[[
	    if downloadInfoFlg == 0 and playerLevel >= 19 then
            nSum = nSum + 1
	    end
	    ]]
	    if downloadInfoFlg == 0 and playerLevel >= 29 then
	        nSum = nSum + 1
	        extraSum = extraSum + 1
	        bDownPath = true
	    end
        for i = 1, (#m_topBtnChildType + extraSum) do
            if i >= (#m_topBtnChildType + 1)  or i <= (#m_topBtnChildType + extraSum) or luaIsUnlock(m_topBtnChildType[i]) then
                local unInfo = nil
                if i < (#m_topBtnChildType + 1) then
                    unInfo = luaGetUnlockInfoWithType(m_topBtnChildType[i])
                else
                    if i == #m_topBtnChildType + 2 and bDownPath then
                        unInfo = {}
                        if playerLevel < 19 or downloadInfoFlg > 2 then
                            unInfo.nPhoto = 0
                            unInfo.byFlag = 2
                            unInfo.dwTimeCountDown = 0
                        --[[
                        elseif downloadInfoFlg == 0 and playerLevel == 19 then
                            unInfo.nPhoto = 5010
                            unInfo.byFlag = 2
                            unInfo.dwTimeCountDown = 0
                            downloadTag = 19000
                        elseif downloadInfoFlg == 0 and playerLevel > 19 then
                            unInfo.nPhoto = 5010
                            unInfo.byFlag = 1
                            unInfo.dwTimeCountDown = 0
                            downloadTag = 19001
                            ]]
                        elseif downloadInfoFlg == 0 and playerLevel == 29 then 
                            unInfo.nPhoto = 5010
                            unInfo.byFlag = 2
                            unInfo.dwTimeCountDown = 0
                            downloadTag = 29000
                        elseif downloadInfoFlg == 0 and playerLevel > 29 then 
                            unInfo.nPhoto = 5010
                            unInfo.byFlag = 1
                            unInfo.dwTimeCountDown = 0
                            downloadTag = 29001
                        else
                            unInfo.nPhoto = 0
                        end
                    elseif i == #m_topBtnChildType + 1 then
                        unInfo = {}
                         unInfo.nPhoto = 5061
                         unInfo.byFlag = 0
                         unInfo.dwTimeCountDown = 0
                    end
                    
                end
                local mark = nil;
                if unInfo and unInfo.nPhoto ~= 0 then     
                    local pBtn = nil;
                    local time = unInfo.dwTimeCountDown;
                    if unInfo.byFlag == 2 or unInfo.byFlag == 3 then
                        pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/"..unInfo.nPhoto.."1.png", nil, time);
                    else
	                    pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/"..unInfo.nPhoto..".png", nil, time);
                    end
                    local bFlg = false
                    if 5032 == unInfo.nPhoto or 5001 == unInfo.nPhoto then
                        bFlg = true
                    end         
	                if pBtn then
	                    if unInfo.byFlag == 1 or bFlg then
	                        local str = nil;
	                        if 5052 == unInfo.nPhoto then
                                str = L("str0482")
                            elseif 5001 == unInfo.nPhoto then
                                str = L("str3044")
                            elseif unInfo.nPhoto == 5013 then
                                str = L("str3075")
                            elseif unInfo.nPhoto == 5022 then
                                str = L("str3073")
                            elseif unInfo.nPhoto == 5029 then
                                str = L("str3074")
                            elseif unInfo.nPhoto == 5036 then
                                str = L("str3075")
                            elseif 5043 == unInfo.nPhoto then
                                str = L("str3077")
                            elseif 5044 == unInfo.nPhoto then
                                str = L("str3075")
                            elseif m_topBtnChildType[i] == UNLOCK_TYPE_SOCIATY_WAR_AWARD then
                                str = L("str3284")
                            elseif 5045 == unInfo.nPhoto then
                                str = L("str3075")
                            elseif 5032 == unInfo.nPhoto then
                                str = L("str3044")
                            elseif 5054 == unInfo.nPhoto then
                                str = L("str3076")
                            elseif 5055 == unInfo.nPhoto then
                                str = L("str3076")
                            elseif 5010 == unInfo.nPhoto then
                                str = L("str3083")
                            elseif 5059 == unInfo.nPhoto then
                                str = L("str3125")
                            elseif m_topBtnChildType[i] == UNLOCK_TYPE_ACHIEVE_AWARD then
                                str = L("str20076")
                            elseif 5046 == unInfo.nPhoto then
                                str = L("str30096")
                            end
                            
                            local tmpLabel = nil
                            if str then
                                tmpLabel = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(8));
                            end
                            if tmpLabel then
                                tmpLabel:setAnchorPoint(CCPointMake(0.5, 1));
                                tmpLabel:setPosition(CCPointMake(pBtn:getContentSize().width / 2, 0));
                                pBtn:addChild(tmpLabel);
                            end
	                    end
	                    if unInfo.nPhoto == 5054 then
	                        local num = unInfo.idItemType;
	                        local num1 = unInfo.byFlag;
	                        local nn = num
	                    elseif unInfo.nPhoto == 5055 then
	                        local num = unInfo.idItemType;
	                        local num1 = unInfo.byFlag;
	                        local nn = num
	                    end
	                    if unInfo.byFlag == 2 or bFlg then
                            local pLabel = nil;
                            local str = nil;
                            if unInfo.nPhoto == 5001 then
                                --str = L("str6210");
                            elseif unInfo.nPhoto == 5013 then
                                --str = L("str6208");
                            elseif unInfo.nPhoto == 5022 then
                                str = L("str6208");
                            elseif unInfo.nPhoto == 5029 then
                                str = L("str6209");
                            elseif unInfo.nPhoto == 5036 then
                                --str = L("str6208");
                            elseif 5043 == unInfo.nPhoto then
                                str = L("str3040");
                            elseif 5044 == unInfo.nPhoto then
                                --str = L("str6208");
                            elseif 5045 == unInfo.nPhoto then
                                str = L("str6208");
                            elseif 5001 == unInfo.nPhoto then
                                --str = L("str3044")
                            elseif 5032 == unInfo.nPhoto then
                                --str = L("str3044")
                            elseif 5054 == unInfo.nPhoto then
                                str = unInfo.idItemType.."/30"
                            elseif 5055 == unInfo.nPhoto then
                                str = unInfo.idItemType.."/30"
                            elseif 5059 == unInfo.nPhoto then
                                str = L("str3124");
                            elseif m_topBtnChildType[i] == UNLOCK_TYPE_ACHIEVE_AWARD then
                                str = L("str3129")
                            end
                            if i == (#m_topBtnChildType + 2) then
                                str = L("str3081");
                            end
                            
                            if str then
                                pLabel = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(8));
                            end
                            if pLabel then
                                pLabel:setAnchorPoint(CCPointMake(0.5, 1));
                                pLabel:setPosition(CCPointMake(pBtn:getContentSize().width / 2, 0));
                                pBtn:addChild(pLabel);
                            end
                        elseif unInfo.byFlag == 3 then
                            if 5054 == unInfo.nPhoto then
                                str = L("str6208");
                            elseif 5055 == unInfo.nPhoto then
                                str = L("str6208");
                            end
                            if str then
                                pLabel = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(8));
                            end
                            if pLabel then
                                pLabel:setAnchorPoint(CCPointMake(0.5, 1));
                                pLabel:setPosition(CCPointMake(pBtn:getContentSize().width / 2, 0));
                                pBtn:addChild(pLabel);
                            end
                        elseif 0 == unInfo.byFlag then
                            if 5059 == unInfo.nPhoto then
                                str = L("str3130");
                            elseif 5057 == unInfo.nPhoto then
                                str = L("str3129");
                            elseif 5061 == unInfo.nPhoto then
                                str = L("str20101")    
                            elseif 5046 == unInfo.nPhoto then
                                str = L("str30096")  
                            elseif m_topBtnChildType[i] == UNLOCK_TYPE_SOCIATY_WAR_AWARD then
                                str = L("str3284")                  
                            end
                            if str then
                                pLabel = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(8));
                            end
                            if pLabel then
                                pLabel:setAnchorPoint(CCPointMake(0.5, 1));
                                pLabel:setPosition(CCPointMake(pBtn:getContentSize().width / 2, 0));
                                pBtn:addChild(pLabel);
                            end
	                    end
	                    
	                    pFrameWindow:addChild(pBtn);
	                    pBtn:luaSetSelectorOnClicked(onMainBtnClick);
	                    if i == (#m_topBtnChildType + 2) and bDownPath then
	                        pBtn:setTag(downloadTag)
	                        if unInfo.byFlag == 1 then
                                setLightEfficiency(downloadTag, true)
                            end
                            pBtn:luaSetSelectorOnClicked(sendDownloadAward)  
                        elseif 5061 == unInfo.nPhoto then
                            pBtn:luaSetSelectorOnClicked(CdkeyWnd_Window)                                                  
                        else
                            pBtn:setTag(m_topBtnChildType[i]);
                        end
                        
                        if unInfo.byFlag == 1 and i<(#m_topBtnChildType + 1) then
                            setLightEfficiency(m_topBtnChildType[i], true)
                            if m_topBtnChildType[i] == UNLOCK_TYPE_TRIBE_GIFT then
								pBtn:luaSetSelectorOnClicked(sendTribeGift)
							end
                        end
                        if unInfo.byFlag == 0 and 5059 == unInfo.nPhoto and i<(#m_topBtnChildType + 1) then
                            setLightEfficiency(m_topBtnChildType[i], true)
                        end                        
                        if nSum < 6 then
                            nCount = nCount + 1;  
                             pBtn:setPosition(CCPointMake(nWidth + SX(10), SY(25)))
                            nWidth = nWidth + pBtn:getContentSize().width + SX(15); 
                            if nHeight == nil then
                                nHeight = pBtn:getContentSize().height + SX(10);
                            end
                            fWidth = nWidth
                        elseif nSum > 10 then
                            if nCount < 5 then
                                nCount = nCount + 1;  
                                pBtn:setPosition(CCPointMake(fWidth + SX(10), SY(50) + pBtn:getContentSize().height * 2))
                                 fWidth = fWidth + pBtn:getContentSize().width + SX(15); 
                                if not nHeight  then
                                    nHeight = pBtn:getContentSize().height * 2 + SY(60);
                                end
                            elseif nCount > 9 then         
                                nCount = nCount + 1;  
                                pBtn:setPosition(CCPointMake(nWidth + SX(10), SY(20)))
                                nWidth = nWidth + pBtn:getContentSize().width + SX(15); 
                            else
                                nCount = nCount + 1;  
                                pBtn:setPosition(CCPointMake(sWidth + SX(10), SY(35) + pBtn:getContentSize().height))
                                sWidth = sWidth + pBtn:getContentSize().width + SX(15); 
                            end 
                        else
                            if nCount < 5 then
                                nCount = nCount + 1;  
                                pBtn:setPosition(CCPointMake(fWidth + SX(10), SY(35) + pBtn:getContentSize().height))
                                fWidth = fWidth + pBtn:getContentSize().width + SX(15); 
                                if not nHeight  then
                                    nHeight = pBtn:getContentSize().height + SY(40);
                                end
                            else          
                                nCount = nCount + 1;  
                                pBtn:setPosition(CCPointMake(nWidth + SX(10), SY(20)))
                                nWidth = nWidth + pBtn:getContentSize().width + SX(15); 
                                
                            end                           
                        end
                        --[[
                        nCount = nCount + 1;      
                        pBtn:setPosition(CCPointMake(nWidth + SX(10), SY(20)))
                        nWidth = nWidth + pBtn:getContentSize().width + SX(3); 
                        if nHeight == nil then
                            nHeight = pBtn:getContentSize().height;
                        end
				        ]] 
                    end
                end
            end
        end
        
        if nSum > 5 then
            nHeight = nHeight + SY(20)
        elseif nSum > 10 then
            nHeight = nHeight + SY(20)
        end
        
        if nHeight == nil then
            return
        end
        
        local size = CCSizeMake(fWidth + SX(20), nHeight + SY(30));
        pFrameWindow:setContentSize(size);
        local imgPath = getRealUIResourcePath("img/new00586.png")
        if imgPath then
            local pImage = SCImage:imageWithFile(imgPath:getData());
            if pImage then
                pImage:setAnchorPoint(CCPointMake(0.5, 0));
                pImage:setPosition(CCPointMake(size.width / 2, size.height - SY(9)));
                pFrameWindow:addChild(pImage);
            end
        end
        pFrameWindow:setAnchorPoint(CCPointMake(0.5, 1));
        pFrameWindow:setPosition(CCPointMake(pNode:getContentSize().width / 2, 0));
    end
end

local function SendAchievements()   --发送成就礼包
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ACHIEVE);
    if dataStream then                   ----消息发送提示
		dataStream:writeShort(ACHIEVEMENT_ACTION_GET_INFO)
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show()
    end
end

--主界面按钮响应
function onMainBtnClick(tag)
	if CLIENT_VERSION <= 328 then
		for i = 1, #m_topBtnChildType do
			if tag == m_topBtnChildType[i] then
				local pNode = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-1010"), "SCNode")
				if pNode then
					pNode:removeChildByTag(5914, true);
					break;
				end
			end
		end
	end
	if tag == m_functionTipType then
		setLightEfficiency(m_functionTipType, false)
	end
    if 1001 == tag then
        --Hero:getSingleton():stopAutoMove()
		GuidePoint_AddGoods()
        GuidePoint_removeGoods()
        GuidePoint_LuaAddCount(1, 0)
        GuidePoint_LuaAddCount(18, 0)
        GuidePoint_LuaAddCount(19, 0)
        Hero:getSingleton():setOpenBagType(0);
        onClickHero(tag)
        Hero:getSingleton():stopAutoMove();
    elseif 1002 == tag then
        onClickSystem();
        Hero:getSingleton():stopAutoMove();
    elseif 6001 == tag then
		armyGroupFight3_showArmyGroupFight3Wnd()
		local dataStream = SCDataTransStream:streamWithCommand(1176);
		dataStream:writeShort(15)
		SCDataTransThread:getSingleton():transData(dataStream); 
		SCActivityIndicator:getSingleton():show();
    elseif UNLOCK_TYPE_KITS == tag then --每日锦囊
        if MAP_CHEAT_PROSON ~= math.floor(GameCommonMsgRecive:getSingleton():getMapID() / 100) * 100 then
            DayKit_sendData(tag)
            Hero:getSingleton():stopAutoMove();
        else
            showMessage(L("str20047"))
		end
    elseif 1004 == tag then
        onClickWoldMap(tag);
        Hero:getSingleton():stopAutoMove();
    elseif 1007 == tag then --主线引导
        Task_onMainInterfaceBtnClick(tag);
    elseif 1009 == tag then
		onClickMission(tag);
		Hero:getSingleton():stopAutoMove();
    elseif 1010 == tag then
        GuidePoint_LuaAddCount(9, 0)
        GuidePoint_LuaAddCount(4, 0)
        GuidePoint_LuaAddCount(10, 0)
        GuidePoint_LuaAddCount(17, 0)
        showTopBtn();
    elseif 10111 == tag then
        showTopBtnByActivity()
    elseif tag == UNLOCK_TYPE_EQUIP_STRENGTHEN then--装备强化
	    Equipmentstrengthen_showEquipmentstrengthenWnd()--打开强化界面
	    Hero:getSingleton():stopAutoMove();
    elseif tag == UNLOCK_TYPE_SEVEN_GIFT then
        GuidePoint_LuaAddCount(4, 1)
        SevenLoginGift_showWnd() --打开七日登陆礼包
    elseif tag == UNLOCK_TYPE_TYPE9 then --聚宝盆
        GuidePoint_LuaAddCount(16, 0)
        cornucopia_ClickBtn();
        Hero:getSingleton():stopAutoMove();
    elseif tag == UNLOCK_TYPE_TYPE10 then --点金
        cornucopia_ClickBtn();
    elseif tag == UNLOCK_TYPE_TYPE7 then --推倒摇钱树
        cornucopia_ClickBtn();
    elseif tag == UNLOCK_TYPE_RECRUITPARTNER then--招募
        BlowRecruit_showBlowRecruitWnd();
        GuidePoint_AddBlowRecruit();
        Hero:getSingleton():stopAutoMove();
	elseif tag == UNLOCK_TYPE_TYPE4 then--武魂
		Hunter_showHunterWnd();
		Hero:getSingleton():stopAutoMove();
	elseif tag == UNLOCK_TYPE_SKILL then--自动练功
		AutomaticGrinding_sendAutomaticGrindingInfo();
	elseif tag == UNLOCK_TYPE_FRIEND then --好友系统
	    NewFriends_showNewFriendsWnd()
        --showFriendWnd()
        Hero:getSingleton():stopAutoMove();
    elseif tag == UNLOCK_TYPE_MAIL then   --邮件系统
        open_MailScreen()
        Hero:getSingleton():stopAutoMove();
    elseif tag == UNLOCK_TYPE_ADDUP_ONLINE_GIFT then --新手礼包
        GuidePoint_topGuide();
        GuidePoint_LuaAddCount(9, 1)
        sendUnlockBtnHitMsg(tag)
    elseif tag == UNLOCK_TYPE_DEVIL_COPY then --魔王副本
        GuidePoint_LuaAddCount(8, 0)
        challengeView_sendData()
    elseif tag == UNLOCK_TYPE_HERO_COPY then --精英副本
        GuidePoint_LuaAddCount(8, 0)
        challengeView_sendData()
	elseif tag == UNLOCK_TYPE_EVERYDAYE_TASK or tag == UNLOCK_TYPE_TYPE8 then --日常活动
		TaskForDay_sendEverydayTask();
		Hero:getSingleton():stopAutoMove();
    elseif tag == UNLOCK_TYPE_TYPE2 then   --日行一善
		GoodDeed_sendData();
	elseif tag == UNLOCK_TYPE_RANK then   --排行榜
		RankInt_sendData()
		Hero:getSingleton():stopAutoMove();
    elseif tag == UNLOCK_TYPE_AREAN then --竞技场
        if MAP_CHEAT_PROSON ~= math.floor(GameCommonMsgRecive:getSingleton():getMapID() / 100) * 100 then
            GuidePoint_LuaAddCount(8, 0)
            local MAPTYPE_SYN_CAMPAIGN_WAR = 67108864
            if true == GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_SYN_CAMPAIGN_WAR) then
                showMessage(L("str3266"))
            else
                challengeView_sendData()
            end
            Hero:getSingleton():stopAutoMove();
        else
            showMessage(L("str20047"))
        end
    elseif tag ==  UNLOCK_TYPE_MEET_FAIRY  then  --巧遇仙女
        showTopBtnByActivity()
        --sanlogin_qql();     
	elseif tag == UNLOCK_TYPE_WOLRD_BOSS or tag == UNLOCK_TYPE_TYPE12 then --世界活动
	    if MAP_CHEAT_PROSON ~= math.floor(GameCommonMsgRecive:getSingleton():getMapID() / 100) * 100 then
            PopularActivities_sendOpenWorldEvent();
            Hero:getSingleton():stopAutoMove();
        else
            showMessage(L("str20047"))
		end
    elseif tag == UNLOCK_TYPE_TREASURE then --珍宝阁
        treasure.showTreasureWnd();
        Hero:getSingleton():stopAutoMove();
    elseif tag == UNLOCK_TYPE_FIRST_RECHARGE_GIFT then  --首次充值礼包
        GuidePoint_LuaAddCount(12, 1)
        ChargeFirst.showWnd();
    elseif tag == UNLOCK_TYPE_RECHARGE_GIFT then --充值奖励
        recharge_sendData()
	elseif tag == UNLOCK_TYPE_TRIBE then	--军团系统
		onClickSociety(tag);
		Hero:getSingleton():stopAutoMove();
	elseif tag == UNLOCK_TYPE_TEAM then --组队
	    if MAP_CHEAT_PROSON ~= math.floor(GameCommonMsgRecive:getSingleton():getMapID() / 100) * 100 then	    
            BattleTeam.openBattleTeamWnd();
            Hero:getSingleton():stopAutoMove();
        else
            showMessage(L("str20047"))
        end
    elseif tag == UNLOCK_TYPE_TYPE1  then --每日俸禄
        showTopBtnRespond(1)
        --salary_Click();   
    elseif tag == UNLOCK_TYPE_ITEM_SOUL then --魂玉
        SoulJade_ShowWndSoulJade()
	elseif tag == UNLOCK_TYPE_WING then
		Wings_showWnd()
    elseif tag == UNLOCK_TYPE_VIP_GIFT then
         onClickVipBase()
    elseif tag == UNLOCK_TYPE_ARENA_GIFT then
         GuidePoint_topGuide();
         showTopBtnRespond(2)
    elseif tag == UNLOCK_TYPE_MAGIC_LEVELUP then --技能升级UNLOCK_TYPE_PRODUCE_MAGIC_DRUG, UNLOCK_TYPE_CELADON
        SkillNode1_showMainInterfaceSkill();
        Hero:getSingleton():stopAutoMove();
    elseif  tag == UNLOCK_TYPE_COLLECTMONEY  then
           salary_Click(); 
    elseif tag ==  UNLOCK_TYPE_PRODUCE_MAGIC_DRUG  then
           sanlogin_qql();      
    elseif tag ==  UNLOCK_TYPE_CELADON  then
           --sanlogin_qql();  
           showTopBtnByActivity()
    elseif tag ==  UNLOCK_TYPE_TIRNED_AWARD  then
           local unInfo = luaGetUnlockInfoWithType(UNLOCK_TYPE_TIRNED_AWARD)
           if unInfo.nPhoto ~= 0 then
               if unInfo.byFlag == 1 then
                    local power = Hero:getSingleton():getHeroInfo().nTiredness
					local viplev = Hero:getSingleton():getHeroInfo().ucVipLevel
                    if viplev > 0 then
						if power >= 250 then
	                        luashowConfirmationWindowPoint(L("str0511"), L("str0512"), nil, WIN_AUTO_CLOSE, nil, nil, nil);
	                        return;
						end
					else 
						if power >= 200 then
                         	luashowConfirmationWindowPoint(L("str0511"), L("str0512"), nil, WIN_AUTO_CLOSE, nil, nil, nil);
	                        return;
						end
                    end
               end
           end
           sendUnlockBtnHitMsg1(tag)
    elseif tag ==  UNLOCK_TYPE_MOODS_GIFT  then
		sendUnlockBtnHitMsg2(tag)
    elseif tag ==  UNLOCK_TYPE_FRIENDS_GIFT  then
		sendUnlockBtnHitMsg2(tag)
    elseif tag ==  UNLOCK_TYPE_SIGN_IN  then
		DailyAttend_sendData();
    elseif tag ==  UNLOCK_TYPE_ACHIEVE_AWARD then
		SendAchievements();    
    elseif tag == UNLOCK_TYPE_TRIBE_GIFT then 
		showTipForTribe()
	elseif tag == UNLOCK_TYPE_SOCIATY_WAR_AWARD then
		--军团俸禄
		local MSG_SOCIATY_WAR_AWARD = 83
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
		dataStream:writeShort(MSG_SOCIATY_WAR_AWARD)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show()
    end
end

local function SmallshowBtn(pBtn, num)
    if num > 0 then
        if pBtn then
            pBtn:removeChildByTag(3300,true);
        end
        local imgPath = getRealUIResourcePath("img/new00544.png")
        local pImage = nil
        if imgPath and pBtn then
            pImage = SCImage:imageWithFile(imgPath:getData())
            if pImage then
                pImage:setTag(3300);
                pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImage:setPosition(AUTO_POS(-3.00, 20.00))
                pImage:setContentSize(AUTO_SIZE(14.00, 14.00))
                pBtn:addChild(pImage);
            end
        end
        local pLabel = SCLabel:labelWithStringFont(num.."", DEFAULT_FONT_NAME, F(10))
        if pLabel and pImage then
            pLabel:setAnchorPoint(CCPointMake(0.5, 0))
            pLabel:setPosition(CCPointMake(pImage:getContentSize().width/2, SY(6)))
            pImage:addChild(pLabel);
        end
    elseif num == 0 then
        if pBtn then
            pBtn:removeAllChildrenWithCleanup(true);   --可能有问题
        end
    end
end

--显示上面按钮
function showTopMainBtn()
	local pMainInterface = getMainInterface()
	if pMainInterface == nil then
		return
	end
	
	local tmpCount = 0
	local nStartX = 0
	local nWidth = 0
	local nHeight = 0
	local isCreate = true
	local playerLevel = Hero:getSingleton():getLeval();
	local pTopBarNode = getNodeByIdlistAndParent("5932", nil)
	if pTopBarNode == nil then
		isCreate = false
		pTopBarNode = SCNode:node()
		pTopBarNode:setTag(5932)
		pTopBarNode:setAnchorPoint(CCPointMake(1, 1))
		pTopBarNode:setContentSize(CCSizeMake(SX(32), SY(44)))
		pTopBarNode:setPosition(CCPointMake(windowWidth - SX(7), windowHeight))
		pMainInterface:addChild(pTopBarNode, 100)
	--	pTopBarNode:setBackgroundColor(color_red)
    --else
    --    pTopBarNode:removeChildByTag(1000,true)
	end
	
	if pTopBarNode == nil then
	    return;
	end
	pTopBarNode:removeAllChildrenWithCleanup(true);
	
	m_topBtn = {}
	
	--[[local tmp = {};
	tmp.tag = 1003;
	tmp.photo = 5006;
	tmp.canHidFlag = false;
	tmp.byFlag = false;
	table.insert(m_topBtn, tmp);]]
	
	
	for i = 1, #m_topBtnType do
	    
        if luaIsUnlock(m_topBtnType[i]) then
            local unInfo = luaGetUnlockInfoWithType(m_topBtnType[i])
            local mark = nil;
            if unInfo.nPhoto ~= 0 then
                for j = 1, #m_topBtn do
                    if unInfo.nPhoto == m_topBtn[j].photo then
                        mark = 1;
                        break;
                    end
                end
                if mark == nil then
                    local tmp = {}
                    tmp.tag = m_topBtnType[i]
                    tmp.photo = unInfo.nPhoto
                    tmp.canHidFlag = false
                    if unInfo.byFlag == 1 then
	                    tmp.byFlag = true;
	                else
	                    tmp.byFlag = false;
	                end
                    table.insert(m_topBtn, tmp)
                end
            end
        end
	end
	--[[for i = 1,#m_topBtnChildByActivity do 
	    if luaIsUnlock(m_topBtnChildByActivity[i]) then
	        local tmp = {}
            tmp.tag = 10111
            tmp.photo = 5004
            tmp.canHidFlag = false
            tmp.byFlag = false
            table.insert(m_topBtn, tmp)
	    end
	end]]
	
    if pTopBarNode then
        nWidth = SX(32);
        nHeight = SY(44);
        local firPayFiftTopFlag = false
        if currentDeviceType()==SC_DEVICE_TYPE_1280x800 or currentDeviceType()==SC_DEVICE_TYPE_1280x720
            or currentDeviceType()==SC_DEVICE_TYPE_960x540 or currentDeviceType()==SC_DEVICE_TYPE_800x480 
            or (currentDeviceType()==SC_DEVICE_TYPE_HD and windowWidth>=1024) then
            firPayFiftTopFlag = true
            if luaIsUnlock(UNLOCK_TYPE_FIRST_RECHARGE_GIFT) then
                local unInfo = luaGetUnlockInfoWithType(UNLOCK_TYPE_FIRST_RECHARGE_GIFT)
                local pBtn = pTopBarNode:getChildByTag(UNLOCK_TYPE_FIRST_RECHARGE_GIFT)
                local time = 0
                if pBtn == nil then
                    pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/5032.png", nil)
                    if pBtn then
                        pBtn:setTag(UNLOCK_TYPE_FIRST_RECHARGE_GIFT);
                        pBtn:setAnchorPoint(CCPointMake(0.5, 0.5))
                        pBtn:setPosition(CCPointMake(-SX(249), nHeight / 2))
                        pBtn:luaSetSelectorOnClicked(onMainBtnClick)
                        pTopBarNode:addChild(pBtn);
                        if unInfo.byFlag == 1 then                    
                            setLightEfficiency(UNLOCK_TYPE_FIRST_RECHARGE_GIFT, true);
                        else    
                            setLightEfficiency(UNLOCK_TYPE_FIRST_RECHARGE_GIFT, false);
                        end
                    end
                end
            end
        end
        if false == firPayFiftTopFlag then
            table.insert(m_topBtnType1, UNLOCK_TYPE_FIRST_RECHARGE_GIFT)
        end
        
        local mark = nil;
        local mark1 = nil;
        local pRewardBnt = pTopBarNode:getChildByTag(1010);
        if pRewardBnt == nil then
            for i = 1, (#m_topBtnChildType + 1) do
                if i < (#m_topBtnChildType + 1) and i ~= 1 then
                    if luaIsUnlock(m_topBtnChildType[i]) then
                        local unInfo = luaGetUnlockInfoWithType(m_topBtnChildType[i])
                        if unInfo.nPhoto ~= 0 then
                            if unInfo.byFlag == 1 then
                                mark = true;
                                break;
                            elseif unInfo.byFlag == 0 and 5059 == unInfo.nPhoto then
                                mark = true;
                                break;
                            else
                                mark = false;
                            end
                        end
                    end
                else
                    if downloadInfoFlg == 0 and playerLevel > 19 then
                        mark = true;
                        break;
                    elseif downloadInfoFlg == 1 and playerLevel > 29 then
                        mark = true;
                        break;
                    else
                        mark = false;
                    end
                end
            end
            --//奖励图标
            if mark ~= nil then
                local pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/5046.png", nil);
                if pBtn then
                    pBtn:setTag(1010);
                    pBtn:setAnchorPoint(CCPointMake(0.5, 0.5))
                    pBtn:setPosition(CCPointMake(-SX(204), nHeight / 2))
				    pBtn:luaSetSelectorOnClicked(onMainBtnClick)
                    pTopBarNode:addChild(pBtn);
                    if mark == true then                    
                        setLightEfficiency(1010, true);
                    else
                        setLightEfficiency(1010, false);
                    end
                    local times = nil;
                    times = getIconTimes(4);
                    if times then
                        SmallshowBtn(pBtn, times);  --其它显示小图标
                    end
                    --SmallshowBtn(pBtn, 5)    --领奖显示小图标
                end
            end
        end
        
        local pBnt = pTopBarNode:getChildByTag(10111);
        if pBnt == nil then
            for i = 1, #m_topBtnChildByActivity do
                if luaIsUnlock(m_topBtnChildByActivity[i]) then
                    local unInfo = luaGetUnlockInfoWithType(m_topBtnChildByActivity[i])
                    if unInfo.nPhoto ~= 0 then
                        if unInfo.byFlag == 1 then
                            mark1 = true;
                            break;
                        else
                            mark1 = false;
                        end
                    end
                end
            end
            --//活动图标
            if mark1 ~= nil then
                local pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/5004.png", nil);
                if pBtn then
                    pBtn:setTag(10111);
                    pBtn:setAnchorPoint(CCPointMake(0.5, 0.5))
                    pBtn:setPosition(CCPointMake(-SX(159), nHeight / 2))
				    pBtn:luaSetSelectorOnClicked(onMainBtnClick)
                    pTopBarNode:addChild(pBtn);
                    if mark1 == true then                    
                        setLightEfficiency(10111, true);
                    else
                        setLightEfficiency(10111, false);
                    end
                    --SmallshowBtn(pBtn, 7)     --活动显示小图标
                end
            end
        end
	
        for i = 1, #m_topBtn do
	        local pBtn = pTopBarNode:getChildByTag(m_topBtn[i].tag)
            local time = 0
            if pBtn == nil then
                if m_topBtn[i].tag == UNLOCK_TYPE_ADDUP_ONLINE_GIFT then
                    local unInfo = luaGetUnlockInfoWithType(UNLOCK_TYPE_ADDUP_ONLINE_GIFT)
                    if unInfo.dwTimeCountDown > 0 then
                        m_topBtn[i].photo = m_topBtn[i].photo.."0"+0;
                        time = unInfo.dwTimeCountDown
                    end
                end
                pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/"..m_topBtn[i].photo..".png", nil, time)
                if m_topBtn[i].photo == 5035 then
                    local num = 1
                end
	            if pBtn then
	                pBtn:setTag(m_topBtn[i].tag);
	                pBtn:setAnchorPoint(CCPointMake(0, 0.5))
	                pBtn:setPosition(CCPointMake(-(nWidth + SX(3)) * (i - 1) , nHeight / 2))
				    pBtn:luaSetSelectorOnClicked(onMainBtnClick)
	                pTopBarNode:addChild(pBtn);
                    if m_topBtn[i].byFlag == true then                    
                        setLightEfficiency(m_topBtn[i].tag, true);
                    else    
                        setLightEfficiency(m_topBtn[i].tag, false);
                    end
                    local times = nil;
                    if m_topBtn[i].photo == 5015 then   --日常
                        times = getIconTimes(1);
                    elseif m_topBtn[i].photo == 5017 then  --挑战
                        times = getIconTimes(2);
                    elseif m_topBtn[i].photo == 5031 then    --赚钱
                        times = getIconTimes(3);
                    end
                    if times then
                        SmallshowBtn(pBtn, times);  --其它显示小图标
                    end
	            end
	        end	        
            if m_topBtn[i].tag == UNLOCK_TYPE_ADDUP_ONLINE_GIFT and time == 0 then
                setLightEfficiency(UNLOCK_TYPE_ADDUP_ONLINE_GIFT, true)
            end
            if m_topBtn[i].tag == UNLOCK_TYPE_COLLECTMONEY and time == 0 then
                setLightEfficiency(UNLOCK_TYPE_COLLECTMONEY, true)
            end
	    end
	end	
	
	--军团战按钮
	if IsActivityVisible(WORLDEVENT_TYPE_SYNWAR) then
		local pBtn = pMainInterface:getChildByTag(6001)
		if pBtn == nil then
			pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/5064.png", nil)
			if pBtn then
				pBtn:setTag(6001);
				pBtn:setAnchorPoint(CCPointMake(1, 1))
				pBtn:setPosition(CCPointMake(windowWidth - SX(145), windowHeight - SY(45)))
				pBtn:luaSetSelectorOnClicked(onMainBtnClick)
				pMainInterface:addChild(pBtn);
				pBtn:setApertureVisible(true)
			end
		end
	else
		pTopBarNode:removeChildByTag(6001, true)
	end
	
	local pTopBarNode1 = getNodeByIdlistAndParent("5900", nil)
	if pTopBarNode1 == nil then
		pTopBarNode1 = SCNode:node()
		pTopBarNode1:setTag(5900)
		pTopBarNode1:setAnchorPoint(CCPointMake(1, 1))
		pTopBarNode1:setContentSize(CCSizeMake(SX(32), SY(44)))
		pTopBarNode1:setPosition(CCPointMake(windowWidth - SX(185), windowHeight - SY(45)))
		pMainInterface:addChild(pTopBarNode1, 1)
		--pTopBarNode1:setBackgroundColor(color_red)
	--	pTopBarNode:setBackgroundColor(color_red)
    --else
    --    pTopBarNode:removeChildByTag(1000,true)
	end
	
	m_topBtn1 = {}
	--UNLOCK_TYPE_FIRST_RECHARGE_GIFT
	for i = 1, #m_topBtnType1 do
	    
        if luaIsUnlock(m_topBtnType1[i]) then
            local unInfo = luaGetUnlockInfoWithType(m_topBtnType1[i])
            local mark = nil;
            if unInfo.nPhoto ~= 0 then
                for j = 1, #m_topBtn1 do
                    if unInfo.nPhoto == m_topBtn1[j].photo then
                        mark = 1;
                        break;
                    end
                end
                if mark == nil then
                    local tmp = {}
                    tmp.tag = m_topBtnType1[i]
                    tmp.photo = unInfo.nPhoto
                    tmp.canHidFlag = false
                    if unInfo.byFlag == 1 then
	                    tmp.byFlag = true;
	                else
	                    tmp.byFlag = false;
	                end
                    table.insert(m_topBtn1, tmp)
                end
            end
        end       
	end
	
        
	
	if pTopBarNode1 then
	    pTopBarNode1:removeAllChildrenWithCleanup(true);
        nWidth = pTopBarNode1:getContentSize().width;
        nHeight = pTopBarNode1:getContentSize().height;
        for i = 1, #m_topBtn1 do
	        local pBtn = pTopBarNode1:getChildByTag(m_topBtn1[i].tag)
            local time = 0
            if pBtn == nil then
                pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/"..m_topBtn1[i].photo..".png", nil)
	            if pBtn then
	                pBtn:setTag(m_topBtn1[i].tag);
	                pBtn:setAnchorPoint(CCPointMake(0, 0.5))
	                pBtn:setPosition(CCPointMake(-(nWidth + SX(3)) * (i - 1) , nHeight / 2))
				    pBtn:luaSetSelectorOnClicked(onMainBtnClick)
	                pTopBarNode1:addChild(pBtn);
                    if m_topBtn1[i].byFlag == true then                    
                        setLightEfficiency(m_topBtn1[i].tag, true);
                    else    
                        setLightEfficiency(m_topBtn1[i].tag, false);
                    end
	            end
	            
	            if m_topBtn1[i].tag == UNLOCK_TYPE_SEVEN_GIFT and SevenLoginGift.CheckSevenGiftAward()==true then
                    setLightEfficiency(UNLOCK_TYPE_SEVEN_GIFT, true)
                end
	        end
	    end
	end	
	
	--主线引导
	local pBtnTask = tolua.cast(pTopBarNode:getChildByTag(1007), "BtnMainInterface")
	if pBtnTask == nil then
		pBtnTask = BtnMainInterface:getMainInterfaceButton("img/new00584.png", nil)
		pBtnTask:luaSetSelectorOnClicked(onMainBtnClick)
        pBtnTask:setTag(1007)
        pTopBarNode:addChild(pBtnTask)
        pBtnTask:setAnchorPoint(CCPointMake(1, 1));
		pBtnTask:setPosition(CCPointMake(SX(40), -SY(5)))
        --alterTopMainTaskBtn()
        --local pNode = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-1007"), "SCNode")
        GuidePoint_topGuide();
	end
	
	--快速任务按钮
	local pBtnTask1 = pTopBarNode:getChildByTag(1005);
	if pBtnTask1 == nil then    
	    pBtnTask1 = SCButton:button();
	    local file = getRealUIResourcePath("img/new00585.png");
	    if pBtnTask1 and file then
	        pBtnTask1:setBackgroundImage(file:getData());
	        pBtnTask1:setTag(1005);
            pBtnTask1:setAnchorPoint(CCPointMake(1, 1));
            pBtnTask1:setPosition(CCPointMake(SX(40), -SY(55)))
			pBtnTask1:setVisible(false);
			pBtnTask1:luaSetSelectorOnClicked(Task_onMainInterfaceBtnClick);
	        pTopBarNode:addChild(pBtnTask1);
	    end
	end
	
	local pBtnTask2 = pTopBarNode:getChildByTag(1006);
	if pBtnTask2 == nil then    
	    pBtnTask2 = SCButton:button();
	    local file = getRealUIResourcePath("img/new00585.png");
	    if pBtnTask2 and file then
	        pBtnTask2:setBackgroundImage(file:getData());
	        pBtnTask2:setTag(1006);
            pBtnTask2:setAnchorPoint(CCPointMake(1, 1));
            pBtnTask2:setPosition(CCPointMake(SX(40), -SY(77)))
			pBtnTask2:setVisible(false);
			pBtnTask2:luaSetSelectorOnClicked(Task_onMainInterfaceBtnClick);
	        pTopBarNode:addChild(pBtnTask2);
	    end
	end
	
	local pBtnTask3 = pTopBarNode:getChildByTag(1008);
	if pBtnTask3 == nil then    
	    pBtnTask3 = SCButton:button();
	    local file = getRealUIResourcePath("img/new00585.png");
	    if pBtnTask3 and file then
	        pBtnTask3:setBackgroundImage(file:getData());
	        pBtnTask3:setTag(1008);
            pBtnTask3:setAnchorPoint(CCPointMake(1, 1));
            pBtnTask3:setPosition(CCPointMake(SX(40), -SY(99)))
			pBtnTask3:setVisible(false);
			pBtnTask3:luaSetSelectorOnClicked(Task_onMainInterfaceBtnClick);
	        pTopBarNode:addChild(pBtnTask3);
	    end
	end
	
	showMainInterfaceTaskList();
end

local function onClickBottomBtn(tag)
	if tag == m_functionTipType then
		setLightEfficiency(m_functionTipType, false)
	end
	if tag == 1001 then
		onClickHero(tag)
        return
    end
	if tag == UNLOCK_TYPE_EQUIP_STRENGTHEN then--装备强化
	    sendOpenMsg_EquiptStrengthScreen()--打开强化界面
		--onClickBag(tag)
        return
    end
	if tag == UNLOCK_TYPE_FORMAT then
		onClickFormation(tag)
        return
    end
	if tag == 1004 then
		onClickedXS(tag)
        return
    end
	if tag == 1005 then
		onClickedXS(tag)
        return
    end
	if tag == UNLOCK_TYPE_SKILL then
		onPractice(tag)
        return
	end
end
--显示下面按钮
local function showBottomMainBtn()
	local pMainInterface = getMainInterface()
	if pMainInterface == nil then
		return
	end
	
	local nStartX = 0
	local nWidth = 0
	local nHeight = 0
	local isCreate = true
	local pBottomBarNode = getNodeByIdlistAndParent("5933", nil)
	if pBottomBarNode == nil then
		isCreate = false;
		pBottomBarNode = SCNode:node()
		if pBottomBarNode then
            pBottomBarNode:setTag(5933)
            pBottomBarNode:setAnchorPoint(CCPointMake(1, 0));
            pBottomBarNode:setPosition(CCPointMake(windowWidth - SX(5), SY(25)));
            pBottomBarNode:setContentSize(CCSizeMake(SX(32), SY(24)))
            --pBottomBarNode:setBackgroundColor(color_red)
            pMainInterface:addChild(pBottomBarNode);
            MainInterface_hideBtn();
		end
    --else
        --pBottomBarNode:removeAllChildrenWithCleanup(true)
	end
	
	local interval = 10;
	
	m_bottomBtn1 = {}
	local tmp = {}
	tmp.tag = 1002
	tmp.photo = 5002
	table.insert(m_bottomBtn1, tmp)
	
	for i = 1, #m_bottomBtnType1 do
        if luaIsUnlock(m_bottomBtnType1[i]) then
            local unInfo = luaGetUnlockInfoWithType(m_bottomBtnType1[i])
            local mark = nil;
            if unInfo.nPhoto ~= 0 then
                for j = 1, #m_bottomBtn1 do
                    if unInfo.nPhoto == m_bottomBtn1[j].photo then
                        mark = 1;
                        break;
                    end
                end
                if mark == nil then
                    local tmp = {}
                    tmp.tag = m_bottomBtnType1[i]
                    tmp.photo = unInfo.nPhoto
                    tmp.canHidFlag = false
                    if unInfo.byFlag == 1 then
	                    tmp.byFlag = true;
	                else
	                    tmp.byFlag = false;
	                end
                    table.insert(m_bottomBtn1, tmp)
                end
            end
        end
	end
	
	local tmp = {}
	tmp.tag = 1001
	tmp.photo = 5003
	table.insert(m_bottomBtn1, tmp)
	
	if pBottomBarNode then
        local size = pBottomBarNode:getContentSize();
        nWidth = SX(32);
        nHeight = SY(24);
	    local pNode = pBottomBarNode:getChildByTag(1);
	    if pNode == nil then
            pNode = SCNode:node();
            pNode:setContentSize(size);
            pBottomBarNode:addChild(pNode);
            pNode:setTag(1);
	    end
	    if pNode == nil then
	        return;
	    end
	    pNode:removeAllChildrenWithCleanup(true);
	    --pBottomBarNode:removeChildByTag(1, true);
        for i = 1, #m_bottomBtn1 do
            local pBtn = pNode:getChildByTag(m_bottomBtn1[i].tag);
            if pBtn == nil then
                pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/" .. m_bottomBtn1[i].photo .. ".png", nil)           
                if pBtn then              
                    pBtn:setTag(m_bottomBtn1[i].tag);
                    pBtn:setAnchorPoint(CCPointMake(0, 0.5))
                    pBtn:setPosition(CCPointMake(-(nWidth + SX(interval)) * i - SX(10), nHeight / 2))
                    pBtn:luaSetSelectorOnClicked(onMainBtnClick)
                    pNode:addChild(pBtn);
                    if m_bottomBtn1[i].tag == 1001 then
						if isDelGuide1() == true then
				        	GuidePoint_AddGiftsGuide(); --添加新手成长礼包引导
						end
                    end
                    if m_bottomBtn1[i].byFlag == true then                    
                        setLightEfficiency(m_bottomBtn1[i].tag, true);
                    else    
                        setLightEfficiency(m_bottomBtn1[i].tag, false);
                    end
                end
            end
        end
	end
	
	m_bottomBtn2 = {}
	
	local tmp = {}
	tmp.tag = 1004
	tmp.photo = 5005
	table.insert(m_bottomBtn2, tmp)
	for i = 1, #m_bottomBtnType2 do
        if luaIsUnlock(m_bottomBtnType2[i]) then
            local unInfo = luaGetUnlockInfoWithType(m_bottomBtnType2[i])
            local mark = nil;
            if unInfo.nPhoto ~= 0 then
                for j = 1, #m_bottomBtn2 do
                    if unInfo.nPhoto == m_bottomBtn2[j].photo then
                        mark = 1;
                        break;
                    end
                end
                if mark == nil then
                    local tmp = {}
                    tmp.tag = m_bottomBtnType2[i]
                    tmp.photo = unInfo.nPhoto
                    tmp.canHidFlag = false
                    if unInfo.byFlag == 1 then
	                    tmp.byFlag = true;
	                else
	                    tmp.byFlag = false;
	                end
                    table.insert(m_bottomBtn2, tmp)
                end
            end
        end
	end
	
	local tmp = {}
	tmp.tag = 1009
	tmp.photo = 5033
	table.insert(m_bottomBtn2, tmp)
	
	if pBottomBarNode then
        local size = pBottomBarNode:getContentSize();
        nWidth = SX(32);
        nHeight = SY(24);
	    local pNode = pBottomBarNode:getChildByTag(2);
	    if pNode == nil then
            pNode = SCNode:node();
            pNode:setContentSize(size);
            pBottomBarNode:addChild(pNode);
            pNode:setTag(2);
	    end
	    if pNode == nil then
	        return;
	    end
	    pNode:removeAllChildrenWithCleanup(true);
	    --pBottomBarNode:removeChildByTag(2, true);
        for i = 1, #m_bottomBtn2 do
            local pBtn = pNode:getChildByTag(m_bottomBtn2[i].tag);
            if pBtn == nil then
                pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/" .. m_bottomBtn2[i].photo .. ".png", nil)
                if pBtn then
                    pBtn:setTag(m_bottomBtn2[i].tag);
                    pBtn:setAnchorPoint(CCPointMake(0, 0.5))
                    pBtn:setPosition(CCPointMake(-(nWidth + SX(interval)) * (i - 1) - SX(10), nHeight / 2 + nHeight * 2))
                    pBtn:luaSetSelectorOnClicked(onMainBtnClick)
                    pNode:addChild(pBtn);
                    if m_bottomBtn2[i].tag == UNLOCK_TYPE_TRIBE then 
                        if getBrightFlagForTribe() == true then
                            setLightEfficiency(m_bottomBtn2[i].tag, true)
                        else
                            setLightEfficiency(m_bottomBtn2[i].tag, false)
                        end
                    else
                        if m_bottomBtn2[i].byFlag == true then                    
                        setLightEfficiency(m_bottomBtn2[i].tag, true);
                        else    
                            setLightEfficiency(m_bottomBtn2[i].tag, false);
                        end
                        if UNLOCK_TYPE_SKILL == m_bottomBtn2[i].tag then                        
                            AutomaticGrinding_Mark(pBtn);
                        end
                    end
                end
            end
        end
	end
end
--
local function getHeroPhoto()
	local lookface = Hero:getSingleton():getLookFace()
	local sex = getIntPart(lookface/100000)%10
	local clan = getIntPart(lookface/100)%10
	if clan == 1 and sex == 1  then --男战士
		return 300630
    end
	if clan == 1 and sex == 2 then --女战士
		return 400640
    end
	if clan == 2 and sex == 1 then --男法师
		return 300830
    end
	if clan == 2 and sex == 2 then --女法师
		return 400840
    end
    if clan == 3 and sex == 1 then --男射手
		return 300730
    end
	if clan == 3 and sex == 2 then --女射手
		return 400740
    end
	--elseif clan == 4 and sex == 1 then --男刺客
	
	--elseif clan == 4 and sex == 2 then --女刺客
	
	--elseif clan == 5 and sex == 1 then --男骑士
	
	--elseif clan == 5 and sex == 2 then --女骑士
	
	
	return 0
end

--战斗力按钮点击
local function onBattleStrengthenBtnClick(tag)
    Hero:getSingleton():stopAutoMove();
    SCActivityIndicator:getSingleton():show()
	BattleStrengthen_show();
end

local function getHeroFaceImg()
    local faceID = Hero:getSingleton():getLookFace()
    local faceName = nil;
	if faceID == 111010 then
        faceName = "new00627.png";
	elseif faceID == 131010 then
        faceName = "new00628.png";
	elseif faceID == 121010 then
        faceName = "new00629.png";
	elseif faceID == 141010 then
        faceName = "new00630.png";
	end
	local path = "faceicon/" .. faceName;
	return getRealUIResourcePath(path);
end

local function showLeftMainBtn()
    local pCurrencyInfoNode = getNodeByIdlistAndParent("5936", nil);
    if pCurrencyInfoNode == nil then
        return;
    end
    local pBtn = pCurrencyInfoNode:getChildByTag(12);
    if pBtn == nil then
        return;
    end
    m_liftBtn = {}
	for i = 1, #m_liftBtnType do
        if luaIsUnlock(m_liftBtnType[i]) then
            local unInfo = luaGetUnlockInfoWithType(m_liftBtnType[i])
            local mark = nil;
            if unInfo.nPhoto ~= 0 then
                for j = 1, #m_liftBtn do
                    if unInfo.nPhoto == m_liftBtn[j].photo then
                        mark = 1;
                        break;
                    end
                end
                if mark == nil then
                    local tmp = {}
                    tmp.tag = m_liftBtnType[i]
                    tmp.photo = unInfo.nPhoto
                    tmp.canHidFlag = false
                    if unInfo.byFlag == 1 then
	                    tmp.byFlag = true;
	                else
	                    tmp.byFlag = false;
	                end
                    table.insert(m_liftBtn, tmp)
                end
            end
        end
	end
    
    local pNode = pBtn:getChildByTag(1);
    if pNode then
        pNode:removeAllChildrenWithCleanup(true);
    else
        pNode = SCNode:node();
        pNode:setTag(1);
        pBtn:addChild(pNode);
    end
    for i = 1, #m_liftBtn do    
        local pButton = pBtn:getChildByTag(m_liftBtn[i].tag);
        if pButton == nil and pBtn then
            pButton = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/" .. m_liftBtn[i].photo .. ".png", nil)
            if pButton then
                pButton:setTag(m_liftBtn[i].tag);
                pButton:setAnchorPoint(CCPointMake(0.5, 0));
                pButton:setPosition(CCPointMake(pBtn:getContentSize().width / 2, -SY(51) * i - SY(3)))
                pButton:luaSetSelectorOnClicked(onMainBtnClick)
                pNode:addChild(pButton);
                if m_liftBtn[i].byFlag == true then                    
                    setLightEfficiency(m_liftBtn[i].tag, true);
                else    
                    setLightEfficiency(m_liftBtn[i].tag, false);
                end
            end
        end
    end
end

--副本扫荡倒计时点击响应
local function onClickCopySweep()
    --local idTemplate = Hero:getSingleton():getSweepTeamplateID();
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE)
	dataStream:writeShort(ACTION_COPY_MONSTOR_NAME)
	dataStream:writeInt(0)
	SCDataTransThread:getSingleton():transData(dataStream)
	SCActivityIndicator:getSingleton():show()
end

--副本扫荡时间截止
function MainInterface_endCopySweep()
    local pCopyMapSweep = getNodeByIdlistAndParent("5940", nil)
    if pCopyMapSweep then
        pCopyMapSweep:removeAllChildrenWithCleanup(true);
        Hero:getSingleton():setSweepTeamplateID(0);
        Hero:getSingleton():setSweepLeaveTime(0);
    end
end

--副本扫荡倒计时
function MainInterface_AddCopySweepTime()
    local pCopyMapSweep = getNodeByIdlistAndParent("5940", nil)
    if pCopyMapSweep == nil then
        return
    end
    
    local nAddWaitTime = Hero:getSingleton():getSweepLeaveTime();
    if nAddWaitTime>0 then
        local pBtnTime = SCTypeCast:castNodeToButton(pCopyMapSweep:getChildByTag(1));
        if pBtnTime==nil then
            pBtnTime = SCButton:button(1)
            pBtnTime:setTag(1)
            pBtnTime:setContentSize(CCSizeMake(pCopyMapSweep:getContentSize().width + SX(37), pCopyMapSweep:getContentSize().height))
			pBtnTime:setAnchorPoint(CCPointMake(0.5, 0.5))
            pBtnTime:setPosition(CCPointMake(pCopyMapSweep:getContentSize().width/2, pCopyMapSweep:getContentSize().height/2))
            pBtnTime:luaSetSelectorOnClicked(onClickCopySweep)
            pCopyMapSweep:addChild(pBtnTime)
            --pCopyMapSweep:setPosition(pCopyMapSweep:getPosition().x, pCopyMapSweep:getPosition().y - SY(10))
        end
        
        if pBtnTime then
            local pBtnLabel = SCLabel:labelWithStringFont(_LTParser("str8172"), getDefaultFontName(), getFontSize(11))
            if pBtnLabel then
                pBtnLabel:setTag(2)
                pBtnLabel:setAnchorPoint(CCPointMake(0, 0.5))
                pBtnLabel:setPosition(CCPointMake(SX(7), pBtnTime:getContentSize().height/2))
                pBtnTime:addChild(pBtnLabel)
            end
            
            local pCountDownNode = CountDownNode:newCountDownNode(DisplayTimeType_Hour_Minute_Second,12)
            if pCountDownNode and pBtnLabel then
                pCountDownNode:setTime(nAddWaitTime);
                pCountDownNode:setTag(999);
                --pCountDownNode:setColor(getColorRed());
                pCountDownNode:setAnchorPoint(CCPointMake(0, 0.5))
                pCountDownNode:setPosition(CCPointMake(pBtnLabel:getContentSize().width + SX(10),pBtnTime:getContentSize().height/2));
                pBtnTime:addChild(pCountDownNode);
                pCountDownNode:luasetSelectorOnClose(MainInterface_endCopySweep);
            end
        end
    end
end

--显示基本信息
local function showCurrencyInfo()
	local pMainInterface = getMainInterface()
    if pMainInterface == nil then
        return
    end
    local heroInfo = Hero:getSingleton():getHeroInfo()
    if heroInfo == nil then
        return
    end

    local vipLevel = Hero:getSingleton():getVipLevel()
    local roleLevel = Hero:getSingleton():getLeval()
    local emoney = Hero:getSingleton():getEmoney()
    local money = Hero:getSingleton():getMoney()
    local tiredness = Hero:getSingleton():getTiredness()
    local tiredNessAdd = Hero:getSingleton():getTirednessAdd()
    local tierdNum = tiredness + tiredNessAdd
	local facePhoto = getHeroPhoto()
	local profession = Hero:getSingleton():getProfessionID()
	
	if roleLevel > 27 then   --当角色大于27级别
	    GuidePoint_DeltopGuide()
	end
	    
   	local pCopyMapSweep = getNodeByIdlistAndParent("5940", nil)
    if pCopyMapSweep == nil then
        pCopyMapSweep = SCNode:node();
        pCopyMapSweep:setTag(5940);
        pCopyMapSweep:setContentSize(CCSizeMake(SX(98), SY(24)));
        pCopyMapSweep:setAnchorPoint(CCPointMake(0.5, 0.5));
        pCopyMapSweep:setPosition(CCPointMake(pMainInterface:getContentSize().width/2, pMainInterface:getContentSize().height-SY(100)));
        pMainInterface:addChild(pCopyMapSweep);

        MainInterface_AddCopySweepTime();
    end
    
	local pCurrencyInfoNode = getNodeByIdlistAndParent("5936", nil)
    if pCurrencyInfoNode == nil then
        pCurrencyInfoNode = SCNode:node()
        pCurrencyInfoNode:setTag(5936)
        pCurrencyInfoNode:setContentSize(CCSizeMake(SX(50), SY(50)))
        pCurrencyInfoNode:setAnchorPoint(CCPointMake(0, 1))
        pCurrencyInfoNode:setPosition(CCPointMake(0, windowHeight))
        pMainInterface:addChild(pCurrencyInfoNode)
        pMainInterface:reorderChild(pCurrencyInfoNode, 10);
    end
    
    local pInfoImg = SCTypeCast:castNodeToImage(pCurrencyInfoNode:getChildByTag(5));
    if pInfoImg == nil then
		local file = getRealUIResourcePath("img/new00684.png")
		if file and pCurrencyInfoNode then
		    pInfoImg = SCImage:imageWithFile(file:getData());
		    if pInfoImg then
		        pInfoImg:setTag(5);
				pInfoImg:setScaleX(0.55)
                pInfoImg:setPosition(CCPointMake(SX(0), SY(7)));
		        pCurrencyInfoNode:addChild(pInfoImg);
		    end
		end
    end
    
    local pIconImg = SCTypeCast:castNodeToImage(pCurrencyInfoNode:getChildByTag(10));
    if pIconImg == nil then
        local imgFile = getRealUIResourcePath("img/new00682.png")
        if imgFile and pCurrencyInfoNode then
            pIconImg = SCImage:imageWithFile(imgFile:getData());
            if pIconImg then
                pIconImg:setTag(10);
                pIconImg:setAnchorPoint(CCPointMake(0, 0.5))
                pIconImg:setPosition(CCPointMake(SX(42),SY(40)))
                pCurrencyInfoNode:addChild(pIconImg);
            end
        end
    end
    local pImg = SCTypeCast:castNodeToImage(pIconImg:getChildByTag(10));
    if not pImg then
        local file = getRealUIResourcePath("img/2001001.png")
        if file and pIconImg then
            local pImg = SCImage:imageWithFile(file:getData());
            if pImg then
                pImg:setTag(10)
                pImg:setScale(0.4,0.4)
                pImg:setAnchorPoint(CCPointMake(0, 0.5))
                pImg:setPosition(CCPointMake(SX(3), pIconImg:getContentSize().height/2));
                pIconImg:addChild(pImg);
            end
        end
    end
    pImg = SCTypeCast:castNodeToImage(pIconImg:getChildByTag(11));
    if pImg == nil then
		local file = getRealUIResourcePath("img/2001008.png")
		if file and pCurrencyInfoNode then
		    pImg = SCImage:imageWithFile(file:getData());
		    if pImg then
		        pImg:setScale(0.4,0.4)
		        pImg:setTag(11);
			    pImg:setAnchorPoint(CCPointMake(0, 0.5))
                pImg:setPosition(CCPointMake(SX(58), pIconImg:getContentSize().height/2));
		        pIconImg:addChild(pImg);
		    end
		end
    end
    
    local emoneyStr = ""
    if emoney < 100000 then
        emoneyStr = emoneyStr..emoney
    elseif emoney >= 100000000 then
        --emoneyStr = emoneyStr..getIntPart(emoney/100000000).._LTParser("str0284")
        emoneyStr = emoneyStr..getIntPart(emoney/100000000).."..."
        emoney = emoney % 100000000
    else 
        --emoneyStr = emoneyStr..getIntPart(emoney/10000).._LTParser("str0285")
        emoneyStr = emoneyStr..getIntPart(emoney/10000).."..."
    end
    
    local emoneyLabel = SCTypeCast:castNodeToLabel(pIconImg:getChildByTag(7))
    if not emoneyLabel then
		emoneyLabel = SCLabel:labelWithStringFont(emoneyStr, getDefaultFontName(), getFontSize(11))
		if emoneyLabel and pIconImg then
			emoneyLabel:setTag(7)
			emoneyLabel:setAnchorPoint(CCPointMake(0, 0.5))
			emoneyLabel:setPosition(CCPointMake(SX(77), pIconImg:getContentSize().height/2))
			pIconImg:addChild(emoneyLabel)
		end
	else
		emoneyLabel:setText(emoneyStr)
	end
 
    moneyStr = ""
    if money < 100000 then
        moneyStr = moneyStr..money
    elseif money >= 100000000 then
        moneyStr = moneyStr..getIntPart(money/100000000).."..."
    else
        moneyStr = moneyStr..getIntPart(money/10000).."..."
    end
   
    local moneyLabel = SCTypeCast:castNodeToLabel(pIconImg:getChildByTag(8))
    if not moneyLabel then
		moneyLabel = SCLabel:labelWithStringFont(moneyStr, getDefaultFontName(), getFontSize(11))
		if moneyLabel and pIconImg then
			moneyLabel:setTag(8)
			moneyLabel:setAnchorPoint(CCPointMake(0, 0.5))
			moneyLabel:setPosition(CCPointMake(SX(20), pIconImg:getContentSize().height/2))
			pIconImg:addChild(moneyLabel)
		end
	else
		moneyLabel:setText(moneyStr)
	end
	
    local pInfoImg = SCTypeCast:castNodeToImage(pCurrencyInfoNode:getChildByTag(20));
    if pInfoImg == nil then
        local imgFile = getRealUIResourcePath("img/new00682.png")
        if imgFile and pCurrencyInfoNode then
            pInfoImg = SCImage:imageWithFile(imgFile:getData());
            if pInfoImg then
                pInfoImg:setTag(20);
                pInfoImg:setAnchorPoint(CCPointMake(0, 0.5))
                pInfoImg:setPosition(CCPointMake(SX(42),SY(20)))
                pCurrencyInfoNode:addChild(pInfoImg);
            end
        end
    end
	local tLabel = SCTypeCast:castNodeToLabel(pInfoImg:getChildByTag(12))
    if tLabel == nil and pInfoImg then
        
        local nMaxTierdNum = 200;
        if vipLevel>=1 then
            nMaxTierdNum = 250;
        end
		tLabel = SCLabel:labelWithStringFont(tierdNum.."/"..nMaxTierdNum, getDefaultFontName(), getFontSize(11))
		if tLabel  then
			tLabel:setTag(12)
			tLabel:setAnchorPoint(CCPointMake(0, 0.5))
			tLabel:setPosition(CCPointMake(SX(22), pInfoImg:getContentSize().height/2))
			--tiredLabel:setColor(color_green);
			pInfoImg:addChild(tLabel)
		end
	    local imgPath = SCTypeCast:castNodeToImage(pInfoImg:getChildByTag(13))
	    if not imgPath then
	         local pImg1 = getRealUIResourcePath("img/new00590.png")
	         if pImg1 then
                imgPath = SCImage:imageWithFile(pImg1:getData())
                 if imgPath then
                    imgPath:setTag(13)
                    imgPath:setAnchorPoint(CCPointMake(0, 0.5))
                    imgPath:setPosition(CCPointMake(SX(75), pInfoImg:getContentSize().height/2));
                    pInfoImg:addChild(imgPath);
                 end
	         end
	     end
		local imgPath1 = SCTypeCast:castNodeToImage(pInfoImg:getChildByTag(14))
		if not imgPath1 then
		    local pImg1 = getRealUIResourcePath("img/2001005.png") --体力小图标
            if pImg1 then
                imgPath1 = SCImage:imageWithFile(pImg1:getData());
                if imgPath1 then
                    imgPath1:setTag(14)
                    imgPath1:setScale(0.4,0.4) --//缩小
                    imgPath1:setAnchorPoint(CCPointMake(0,0.5));
                    imgPath1:setPosition(CCPointMake(SX(3),pInfoImg:getContentSize().height/2));
                    pInfoImg:addChild(imgPath1);
                end
            end
        end
		
		local pBtn = SCTypeCast:castNodeToButton(pInfoImg:getChildByTag(15))
		if not pBtn then
			pBtn = SCButton:button()
			if pBtn then
                pBtn:setTag(15)
                pBtn:setAnchorPoint(CCPointMake(0.5,0))
                pBtn:setContentSize(CCSizeMake(pInfoImg:getContentSize().width, pInfoImg:getContentSize().height*3));
                pBtn:setPosition(CCPointMake(pInfoImg:getContentSize().width/2, SY(-5)))
                pBtn:luaSetSelectorOnClicked(onClickVipBuyPower)
                pInfoImg:addChild(pBtn)
            end
		end
	else
	    local nMaxTierdNum = 200;
        if vipLevel>=1 then
            nMaxTierdNum = 250;
        end
		tLabel:setText(tierdNum.."/"..nMaxTierdNum)
	end
	
--战斗力系统  
    
    pInfoImg = SCTypeCast:castNodeToImage(pCurrencyInfoNode:getChildByTag(6));
    if pInfoImg == nil then
		local file = getRealUIResourcePath("img/new00683.png")
		if file and pCurrencyInfoNode then
		    pInfoImg = SCImage:imageWithFile(file:getData());
		    if pInfoImg then
		        pInfoImg:setTag(6);
                pInfoImg:setPosition(CCPointMake(SX(0), SY(-6)));
		        pCurrencyInfoNode:addChild(pInfoImg);
		    end
		end
    end
	
	--战斗力系统  
	if pInfoImg ~= nil then
		local pBattleImage = SCTypeCast:castNodeToImage(pInfoImg:getChildByTag(20));
		if pBattleImage == nil then
			local file = getRealUIResourcePath("img/new00114.png");
			if file then
				pBattleImage = SCImage:imageWithFile(file:getData());
				if pBattleImage then
				    pBattleImage:setAnchorPoint(CCPointMake(0,0.5))
					pBattleImage:setTag(20);
					pBattleImage:setPosition(CCPointMake(SX(5), pInfoImg:getContentSize().height/2));
					pInfoImg:addChild(pBattleImage);
				end
			end
		end
		
		pInfoImg:removeChildByTag(16, true);
		local pBattleNumber = pInfoImg:getChildByTag(16);
		if pBattleNumber == nil then
			pBattleNumber = getImageNumber(heroInfo.nPrestige, "img/new00530.png", SX(12.2), SY(18), SX(8));
			--pBattleNumber = getImageNumber(heroInfo.nPrestige, "img/new00115.png", SX(6), SY(8));
			if pBattleNumber then
				pBattleNumber:setTag(16);
				pBattleNumber:setAnchorPoint(CCPointMake(0,0.5))
				pBattleNumber:setPosition(CCPointMake(SX(35), pInfoImg:getContentSize().height/2));
				pInfoImg:addChild(pBattleNumber);
			end
		end
		
		local pBattleBtn = SCTypeCast:castNodeToButton(pInfoImg:getChildByTag(17));
		if pBattleBtn == nil then
			pBtn = SCButton:button()
			if pBtn then
                pBtn:setTag(17)
                pBtn:setAnchorPoint(CCPointMake(0.5,0.5))
                pBtn:setContentSize(CCSizeMake(pInfoImg:getContentSize().width, pInfoImg:getContentSize().height));
                pBtn:setPosition(CCPointMake(pInfoImg:getContentSize().width/2, pInfoImg:getContentSize().height/2))
                pBtn:luaSetSelectorOnClicked(onBattleStrengthenBtnClick)
                pInfoImg:addChild(pBtn)
            end
		end
	end
    
    --主界面人物头像
    local pImgFace = SCTypeCast:castNodeToImage(pCurrencyInfoNode:getChildByTag(2));
    if pImgFace == nil then
		--local file = getHeroFaceImg();
		local file = nil
		if 1 == profession then
		    file = getRealUIResourcePath("img/new00627.png")
		elseif 2 == profession then
		    file = getRealUIResourcePath("img/new00630.png")
		elseif 3 == profession then
		    file = getRealUIResourcePath("img/new00629.png")
		elseif 4 == profession then
		    file = getRealUIResourcePath("img/new00628.png")
		end
		if file then
		    pImgFace = SCImage:imageWithFile(file:getData());
		    if pImgFace then
		        pImgFace:setTag(2);
                pImgFace:setAnchorPoint(CCPointMake(0, 1));
                pImgFace:setPosition(CCPointMake(SX(1), SY(52)));
		        pCurrencyInfoNode:addChild(pImgFace);
		        local pBtn = SCButton:button();
		        if pBtn then
		            local size = pImgFace:getContentSize();
		            pBtn:setContentSize(CCSizeMake(size.width,size.height));
		            pBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
		            pBtn:setPosition(CCPointMake(size.width / 2, size.height / 2));
		            pBtn:setTag(1001);
		            pBtn:luaSetSelectorOnClicked(onMainBtnClick);
		            pImgFace:addChild(pBtn);
		        end
		    end
		end
    end
	
    local strName = Hero:getSingleton():getName():getData();
    
    local heroMapObject = tolua.cast(Hero:getSingleton(), "MapObject");
	local plabel = SCLabel:labelWithStringFont(strName, getDefaultFontName(), getFontSize(12));
	if plabel and heroMapObject then
	    plabel:setColor(Hero:getSingleton():getNameColor(roleLevel));
	    plabel:setDoubleRenderWithColor(color_black);
        heroMapObject:setTitle(plabel, 1);
	end
	
    local pExpNode = getNodeByIdlistAndParent("5941-2", nil)
    if not pExpNode then
        showExperienceBar();
        pExpNode = getNodeByIdlistAndParent("5941-2", nil);
    end
    
    if pExpNode then
        local pLevelNode = pExpNode:getChildByTag(40);
        if pLevelNode  == nil then
            pLevelNode = SCNode:node()
            pLevelNode:setAnchorPoint(CCPointMake(0, 0.5))
            --pLevelNode:setBackgroundColor(color_red);
            --tolua.cast(pLevelNode, "SCNode"):setContentSize(CCSizeMake(SX(13), pExpNode:getContentSize().height/2));
            pLevelNode:setContentSize(CCSizeMake(SX(30),SY(16)))
            pLevelNode:setPosition(CCPointMake(SX(3), pExpNode:getContentSize().height/2))
            pLevelNode:setTag(40)
            pExpNode:addChild(pLevelNode)
        end
        if pLevelNode then        
            pLevelNode:removeAllChildrenWithCleanup(true)
            local pLevNode = SCNode:node();
            local pChildNode = SCNode:node();
            local file = getRealUIResourcePath("img/new00074.png")
            if file and pLevNode and pChildNode then
                local pImg = getImageNumber(roleLevel, "img/new00074.png", SX(10), SY(12), SX(7))
                if pImg then
                    pImg:setTag(30);
                    pImg:setAnchorPoint(CCPointMake(0,0.5))
                    if roleLevel < 10 then
                        pImg:setPosition(CCPointMake(SX(12), pLevelNode:getContentSize().height/2));
                    elseif roleLevel > 99 then
                        pImg:setPosition(CCPointMake(SX(2), pLevelNode:getContentSize().height/2));
                    else
                        pImg:setPosition(CCPointMake(SX(8), pLevelNode:getContentSize().height/2));
                    end
                    pLevelNode:addChild(pImg);
                end
            end
        end
    end    
    --
    --充值按钮
    local pBtn = SCTypeCast:castNodeToButton(pCurrencyInfoNode:getChildByTag(1));
    if pBtn == nil then
        pBtn = SCButton:button()
        local file = getRealUIResourcePath("img/img7078.png")
        if pBtn and file then
            pBtn:setTitle(file:getData());
            pBtn:setTag(1)
            pBtn:setAnchorPoint(CCPointMake(0, 1));
            pBtn:setPosition(CCPointMake(SX(165), SY(49)));
            pBtn:luaSetSelectorOnClicked(onClickVipBase);

            pCurrencyInfoNode:addChild(pBtn, 50);
                       
        end
    end
    
	--vip图标
	local vipBtn = SCTypeCast:castNodeToButton(pBtn:getChildByTag(12));
	local pFile = nil;
	if vipLevel == 0 then
	    pFile = getRealUIResourcePath("img/new00626.png");
	else
	    pFile = getRealUIResourcePath("img/new00" .. (608 + vipLevel) .. ".png");
	end
	if pFile then
	    if vipBtn == nil then
			vipBtn = SCButton:button();
			if vipBtn then
                vipBtn:setTitle(pFile:getData());
                vipBtn:setScale(0.5);
                vipBtn:setTag(12)
                vipBtn:luaSetSelectorOnClicked(onClickVipBase);
                vipBtn:setAnchorPoint(CCPointMake(0.5, 0.5))
                local size = pBtn:getContentSize();
                vipBtn:setPosition(CCPointMake(size.width / 2, size.height / 3))
                pBtn:addChild(vipBtn)
            end
            local pAi = SCLookfaceParser:getSingleton():getAnimationByIndex(1024, 1024);--光圈
            if pAi then
                local pAnimationNode =  SCAnimationNode:nodeWithAnimation(pAi);
                if pAnimationNode then
                    pAnimationNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                    local size = pBtn:getContentSize();
                    pAnimationNode:setPosition(CCPointMake(size.width / 2, size.height / 2));
                    pBtn:addChild(pAnimationNode);
                end
            end
	    else
	        vipBtn:setTitle(pFile:getData());
	    end
	end
	
    local pBtn = pCurrencyInfoNode:getChildByTag(12);
    if pBtn == nil then
        pBtn = SCButton:button();
        local file = getRealUIResourcePath("img/new00542.png");
        if pBtn and file then
            pBtn:setTag(12);
            pBtn:setContentSize(CCSizeMake(SX(45),SY(18)));          
            pBtn:setPosition(CCPointMake(SX(0), -SY(40)));
            pBtn:luaSetSelectorOnClicked(AccountController_ShowOrHide)
            pCurrencyInfoNode:addChild(pBtn);
        end
    end
    
    local tImg = pCurrencyInfoNode:getChildByTag(18)
    if not tImg then
        local file = getRealUIResourcePath("img/new00542.png")
        if file then
            tImg = SCImage:imageWithFile(file:getData());
            if tImg then
                tImg:setTag(18);
                tImg:setPosition(CCPointMake(SX(8), -SY(42)));
                pCurrencyInfoNode:addChild(tImg);
            end
        end
    end
end

--显状态信息
local function showHeroStatus()
    if true then
        return
    end
    
	local pMainInterface = getMainInterface()
    if pMainInterface == nil then
        return
    end
    local isCreate = true
    local pHeroStatusNode = getNodeByIdlistAndParent("5937", nil)
    if pHeroStatusNode == nil then
        isCreate = false
    end
    local nwidth = 0;
    local nheight = 0;
    local spacing = 10 * gUIScale().x;
    local nStartX = 0;
    local nStartY = 0;
    
    local file = nil
    local pbtn = nil
    
    if not isCreate then
        pHeroStatusNode = SCNode:node()
        pHeroStatusNode:setTag(5937)
    end
    
    for i=1, #m_showStatus do
        pbtn = SCTypeCast:castNodeToButton(pHeroStatusNode:getChildByTag(m_showStatus[i].nStatus))
        if pbtn == nil then
            pbtn = SCButton:button()
            pbtn:setTouchRectScale(2,1.5)
            if pbtn ~= nil then
                pbtn:luaSetSelectorOnClicked(onStatuBtnClick)
                pbtn:setTag(m_showStatus[i].nStatus)
                pbtn:setTouchRectScale(1, 2)
                file = getRealUIResourcePath("statusex/"..m_showStatus[i].nPhoto..".png")
                --local nImgHeight = m_showStatus[i].nPhoto%100;
                --local nImgWidth = getIntPart(m_showStatus[i].nPhoto%10000/100)
                --pbtn:setTitle(file:getData(), CCRectMake(m_showStatus[i].ucPosition*nImgWidth * gUIScale().x,0,nImgWidth * gUIScale().x,nImgHeight * gUIScale().y))
				pbtn:setTitle(file:getData(), CCRectMake(m_showStatus[i].ucPosition*20 * gUIScale().x,0,20 * gUIScale().x,20 * gUIScale().y))
                pHeroStatusNode:addChild(pbtn)
            end
        end
        pbtn:setPosition(CCPointMake(nStartX, nStartY))
        nwidth = pbtn:getContentSize().width
        nheight = pbtn:getContentSize().height
        nStartX = nStartX + nwidth + spacing
    end
    --赠送体力图标
    pHeroStatusNode:setContentSize(CCSizeMake(nStartX, nheight))
    if not isCreate then
        pHeroStatusNode:setAnchorPoint(CCPointMake(0, 0))
        pHeroStatusNode:setPosition(CCPointMake(SX(75), getScreenHeight() - SY(100)))
    
        pMainInterface:addChild(pHeroStatusNode)
    end
end

--显示经验条
function showExperienceBar()
	local pMainInterface = getMainInterface()
    if pMainInterface == nil then
        return
    end
    local heroInfo = Hero:getSingleton():getHeroInfo()
    if heroInfo == nil then
        return
    end
    local pExpBarNode = getNodeByIdlistAndParent("5941", nil)
    if pExpBarNode == nil then
        pExpBarNode = SCNode:node()
        pExpBarNode:setTag(5941)
        pExpBarNode:setContentSize(CCSizeMake(windowWidth, SY(12)))
        pExpBarNode:setAnchorPoint(CCPointMake(0.5, 0.5))
        pExpBarNode:setPosition(CCPointMake(windowWidth/2, SY(5)))
        pMainInterface:addChild(pExpBarNode)
    end
    local barRealMaxWidth = SX(464)
    local curExp = heroInfo.dwExp
    local maxExp = heroInfo.dwMaxExp
    if maxExp == 0 then
        maxExp = 1
    end
    
    local bl = curExp/maxExp
    if bl > 1 then
		bl = 1
    end
    local expWidth = bl*barRealMaxWidth
    local bBackImg = SCTypeCast:castNodeToImage(pExpBarNode:getChildByTag(3))
    if not bBackImg then
		local file = getRealUIResourcePath("img/new00072.png")
		if file then
			bBackImg = SCImage:imageWithFile(file:getData())
			if bBackImg then
                bBackImg:setTag(3)
                bBackImg:setAnchorPoint(CCPointMake(0.5, 0.5))
                bBackImg:setPosition(CCPointMake(pExpBarNode:getContentSize().width/2, pExpBarNode:getContentSize().height/2))
                pExpBarNode:addChild(bBackImg)
            end
		end
    end
	local frontImg = SCTypeCast:castNodeToImage(pExpBarNode:getChildByTag(2))
    if not frontImg then
		local file = getRealUIResourcePath("img/new00688.png")
		if file then
			frontImg = SCImage:imageWithFile(file:getData())
			if frontImg then
                frontImg:setTag(2)
                frontImg:setAnchorPoint(CCPointMake(0.5, 0.5))
                frontImg:setPosition(CCPointMake(pExpBarNode:getContentSize().width/2, pExpBarNode:getContentSize().height/2 + SY(5)))
                pExpBarNode:addChild(frontImg)
                
                --等级文字
                local file1 = getRealUIResourcePath("img/img7079.png")
                if file1 then
                    local pImg = SCImage:imageWithFile(file1:getData())
                    if pImg then
                        pImg:setAnchorPoint(CCPointMake(0, 0.5))
                        pImg:setPosition(CCPointMake(SX(26),SY(31/4)))
                        frontImg:addChild(pImg)
                    end
                end 
            end
		end
    end
    local backImg = SCTypeCast:castNodeToImage(frontImg:getChildByTag(1))
    if not backImg then
		local file = getRealUIResourcePath("img/new00687.png")
		if file then
			backImg = SCImage:imageWithFile(file:getData())
			backImg:setTag(1)
			--backImg:setAnchorPoint(CCPointMake(0.5, 0.5))
			--backImg:setScaleX(windowWidth/frontImg:getContentSize().width)
			local pSize = backImg:getContentSize();
			backImg:setImage(file:getData(), CCRectMake(0, 0, (pSize.width-SX(42)) * bl + SX(42), SY(27)));
			backImg:setAnchorPoint(CCPointMake(0, 0.5))
			backImg:setPosition(CCPointMake(SX(0), SY(24/5)))
			frontImg:addChild(backImg)
		end
	else
		local file = getRealUIResourcePath("img/new00687.png")
		if file then
			backImg:setImage(file:getData())
			--backImg:setScaleX(windowWidth/frontImg:getContentSize().width)
			local pSize = backImg:getContentSize();
			backImg:setImage(file:getData(), CCRectMake(0, 0, (pSize.width-SX(42)) * bl + SX(42),  SY(27)));
			--backImg:setPosition(CCPointMake(SX(10), SY(5)))
		end
    end
    open_RewardsFunctionTip()
end

--经验条动态效果
local function runExperienceBarAction(float)
	local pMainInterface = getMainInterface()
    if pMainInterface == nil then
        return
    end
    local heroInfo = Hero:getSingleton():getHeroInfo()
    if heroInfo == nil then
        return
    end
	
	local pExpBarNode = getNodeByIdlistAndParent("5941", nil)
    if pExpBarNode == nil then
		return
	end
	
	if m_tmpMaxExp == nil then
	    return;
	end
	
    local curExp = heroInfo.dwExp
    local maxExp = heroInfo.dwMaxExp
	if m_tmpMaxExp < maxExp and m_upgradeMark ~= 1 then	    
        if m_tmpExp >= m_tmpMaxExp then
            m_upgradeMark = 1;
            m_tmpExp = 0;
        end
	else
        if m_tmpExp >= curExp then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryIdExp)
            m_entryIdExp = nil;
            showExperienceBar();
            m_upgradeMark = nil;
            m_tmpExp = nil;
            m_tmpMaxExp = nil;
            m_moveValue = nil;
            local pNode = getNodeByIdlistAndParent("2-1", pExpBarNode);
            if pNode then
                pNode:removeChildByTag(1, true);
            end
            return;
        end
	end	
    
    local tmpB = nil;
    if m_tmpMaxExp < maxExp and m_upgradeMark ~= 1 then
        tmpB = m_tmpExp / m_tmpMaxExp;
    else    
        tmpB = m_tmpExp/maxExp;
    end
    if tmpB > 1 then
		tmpB = 1
    end
	
	local backImg = SCTypeCast:castNodeToImage(getNodeByIdlistAndParent("2-1", pExpBarNode))
	if backImg == nil then
		return
	end
	
	local file = getRealUIResourcePath("img/new00687.png")
	if file then
		backImg:setImage(file:getData())
		local pSize = backImg:getContentSize();
		backImg:setImage(file:getData(), CCRectMake(0, 0, (pSize.width - SX(42)) * tmpB + SX(42), SY(27)));
		if m_moveValue then
		    m_tmpExp = m_tmpExp + m_moveValue;
		end
		local pImg = backImg:getChildByTag(1);
		if pImg == nil then
            local imgPath = getRealUIResourcePath("img/new00508.png");
            if imgPath then
                pImg = SCImage:imageWithFile(imgPath:getData());
                if pImg then
                    pImg:setAnchorPoint(CCPointMake(0, 0.5))
                    pImg:setPosition(CCPointMake(pSize.width - SX(3), SY(5)));
                    pImg:setTag(1);
                    backImg:addChild(pImg);
                end
            end
		else
            pImg:setPosition(CCPointMake(pSize.width - SX(3), SY(5)));
		end
	end
end

--系统时间更新
local function updateTime(float)
	 local timeLabel = SCTypeCast:castNodeToLabel(getNodeByIdlistAndParent("5942-1", nil))
	 if timeLabel then
		timeLabel:setText(os.date("%H:%M", os.time()))
	 end
end

--------------------------------斩将令-----------------------------------
function MainInterface_onDelCutWillBtnClick()
    local timeNode = getNodeByIdlistAndParent("5942", nil)
    if not timeNode then
		local file = getRealUIResourcePath("img/new00539.png")
		if file then
			timeNode = SCImage:imageWithFile(file:getData())
			timeNode:setTag(5942)
			timeNode:setAnchorPoint(CCPointMake(0, 1))
			timeNode:setPosition(CCPointMake(0, windowHeight-SY(56)))
			pMainInterface:addChild(timeNode)
			pMainInterface:reorderChild(timeNode, 9);
			local label = SCLabel:labelWithStringFont(os.date("%H:%M", os.time()), getDefaultFontName(), getFontSize(10))
			if label then
				label:setTag(1)
				label:setAnchorPoint(CCPointMake(0.5, 0.5));
				label:setPosition(CCPointMake(timeNode:getContentSize().width / 2 + SX(5), timeNode:getContentSize().height *3/ 4))
				timeNode:addChild(label)
			end
			
			--斩将令
            local cutWillRes = getRealUIResourcePath("challenge/new00883.png");
            if cutWillRes then
                local button = SCButton:button();
                if button then
                    button:setTitle(cutWillRes:getData());
                    button:setTag(2014);
                    button:setAnchorPoint(CCPointMake(0, 0));
                    button:setPosition(CCPointMake(timeNode:getContentSize().width, SX(-3)));
                    button:luaSetSelectorOnClicked(onCutWillBtnClick)
                    timeNode:addChild(button);
                end
            end
           
			m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(updateTime, 20.0, false)
		end
    else
        local button = SCTypeCast:castNodeToButton(timeNode:getChildByTag(2014));
        if button then
            local cutWillRes = getRealUIResourcePath("challenge/new00883.png");
            if cutWillRes then
                button:setTitle(cutWillRes:getData());
            end
        end
    end 
end

function MainInterface_updataStatus()
    local cutWillInfo = ItemProcessor:getSingleton():getCutWillInfo();
    if cutWillInfo == nil then
        return
    end
    
    local timeNode = getNodeByIdlistAndParent("5942", nil)
    if not timeNode then
		local file = getRealUIResourcePath("img/new00539.png")
		if file then
			timeNode = SCImage:imageWithFile(file:getData())
			timeNode:setTag(5942)
			timeNode:setAnchorPoint(CCPointMake(0, 1))
			timeNode:setPosition(CCPointMake(0, windowHeight-SY(56)))
			pMainInterface:addChild(timeNode)
			pMainInterface:reorderChild(timeNode, 9);
			local label = SCLabel:labelWithStringFont(os.date("%H:%M", os.time()), getDefaultFontName(), getFontSize(10))
			if label then
				label:setTag(1)
				label:setAnchorPoint(CCPointMake(0.5, 0.5));
				label:setPosition(CCPointMake(timeNode:getContentSize().width / 2 + SX(5), timeNode:getContentSize().height *3/ 4))
				timeNode:addChild(label)
			end
			
			--斩将令
            local cutWillRes = getRealUIResourcePath("challenge/new00883.png");
            if cutWillInfo.nTimes > 0 then
                cutWillRes = getRealUIResourcePath("challenge/new00881.png");
            end
            if cutWillRes then
                local button = SCButton:button();
                if button then
                    button:setTitle(cutWillRes:getData());
                    button:setTag(2014);
                    button:setAnchorPoint(CCPointMake(0, 0));
                    button:setPosition(CCPointMake(timeNode:getContentSize().width, SY(-3)));
                    button:luaSetSelectorOnClicked(onCutWillBtnClick)
                    timeNode:addChild(button);
                end
            end
           
			m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(updateTime, 20.0, false)
		end
    else
        local button = SCTypeCast:castNodeToButton(timeNode:getChildByTag(2014));
        if button then
            local cutWillRes = getRealUIResourcePath("challenge/new00883.png");
            if cutWillInfo.nTimes > 0 then
                cutWillRes = getRealUIResourcePath("challenge/new00881.png");
            end
            if cutWillRes then
                button:setTitle(cutWillRes:getData());
            end
        end
    end
    
    local tipStr = "*3"..cutWillInfo:getName().."*0"..L("str8117").."*3"..cutWillInfo.nTimes;
    tipStr = tipStr.."_"..L("str9248").."*3"..math.floor(cutWillInfo.nAddExp/10).."%*0,";
    tipStr = tipStr..L("str9249").."*3"..math.floor(cutWillInfo.nAddMoney/10).."%";
    tipStr = tipStr.."_"..L("str9247")
    
    GlobalFunction_luaUpdataTip(tipStr, 1)
end

local function onCutWillAddTimeBtnClick(tag)
    if tag == 0 then
        GlobalFunction_luaRemoveTip(0);
        return
    end
    local USERINFO_USE_CUTWILL = 122
    local dt = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dt:writeShort(USERINFO_USE_CUTWILL)
    dt:writeByte(0);
    dt:writeInt(1);
    dt:writeInt(0);
    SCDataTransThread:getSingleton():transData(dt)
    SCActivityIndicator:getSingleton():show()   
end

local function onCutWillBtnClick(tag)
    if CLIENT_VERSION < 329 then
        showMessage(L("str9236"));
        return
    end
    local cutWillInfo = ItemProcessor:getSingleton():getCutWillInfo();
    if cutWillInfo == nil then
        return
    end
    
    local tipStr = "*3"..cutWillInfo:getName().."*0"..L("str8117").."*3"..cutWillInfo.nTimes;
    tipStr = tipStr.."_"..L("str9248").."*3"..math.floor(cutWillInfo.nAddExp/10).."%*0,";
    tipStr = tipStr..L("str9249").."*3"..math.floor(cutWillInfo.nAddMoney/10).."%";
    tipStr = tipStr.."_"..L("str9247")
    
    GlobalFunction_luaShowTip(tipStr, L("str9250"), 4, onCutWillAddTimeBtnClick, 1, true, false, 1);
end
---------斩将令 end

--显示主界面
function showUnlockMainBtn()
    local pMainInterface = getMainInterface()
    if pMainInterface == nil then
        return
    end
    local pBtnHide = getNodeByIdlistAndParent("5931", nil)
    if pBtnHide == nil then
        pBtnHide = BtnMainInterface:getMainInterfaceButton("img/img5011.png", nil)
        if pBtnHide ~= nil then
            pBtnHide:setTag(5931)
            pBtnHide:luaSetSelectorOnClicked(onClickHideMainBtn)
            pBtnHide:setAnchorPoint(CCPointMake(1, 0))
            pBtnHide:setPosition(CCPointMake(rightOffset+SX(2), bottonOffset-SY(2)))
			pBtnHide:setTouchRectScale(2, 2)
            pMainInterface:addChild(pBtnHide)
        end
        
        local pBtnChat = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/5000.png", nil)
        if pBtnChat ~= nil then
            pBtnChat:setTag(5938)
            --pBtnChat:setVisible(false)
            pBtnChat:luaSetSelectorOnClicked(onClickChat)
            pBtnChat:setAnchorPoint(CCPointMake(0, 0))
            pBtnChat:setPosition(CCPointMake(leftOffset, bottonOffset+5))
            pMainInterface:addChild(pBtnChat)
        end
    end
    local timeNode = getNodeByIdlistAndParent("5942", nil)
    if not timeNode then
		local file = getRealUIResourcePath("img/new00539.png")
		if file then
			timeNode = SCImage:imageWithFile(file:getData())
			timeNode:setTag(5942)
			timeNode:setAnchorPoint(CCPointMake(0, 1))
			timeNode:setPosition(CCPointMake(0, windowHeight-SY(56)))
			pMainInterface:addChild(timeNode)
			pMainInterface:reorderChild(timeNode, 9);
			local label = SCLabel:labelWithStringFont(os.date("%H:%M", os.time()), getDefaultFontName(), getFontSize(10))
			if label then
				label:setTag(1)
				label:setAnchorPoint(CCPointMake(0.5, 0.5));
				label:setPosition(CCPointMake(timeNode:getContentSize().width / 2 + SX(5), timeNode:getContentSize().height *3/ 4))
				timeNode:addChild(label)
			end
			
			--斩将令
			if CLIENT_VERSION > 328 then
				local cutWillInfo = ItemProcessor:getSingleton():getCutWillInfo();
				if cutWillInfo ~= nil then
					local cutWillRes = getRealUIResourcePath("challenge/new00883.png");
					if cutWillInfo.nTimes > 0 then
						cutWillRes = getRealUIResourcePath("challenge/new00881.png");
					end
					if cutWillRes then
						local button = SCButton:button();
						if button then
							button:setTitle(cutWillRes:getData());
							button:setTag(2014);
							button:setAnchorPoint(CCPointMake(0, 0));
							button:setPosition(CCPointMake(timeNode:getContentSize().width, SY(-3)));
							button:luaSetSelectorOnClicked(onCutWillBtnClick)
							timeNode:addChild(button);
						end
					end
				end
			end
           
			m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(updateTime, 20.0, false)
		end
    end
    showRightMainBtn()
    --[[if _DEBUG == true then
        showLeftMainBtn()
    end]]
    showTopMainBtn()
    showBottomMainBtn()
    showCurrencyInfo()
    showExperienceBar()
    activityVisibleAnimation();
    showLeftMainBtn();
end
--end shwo mainInterface function---------------------------------------------------

--global Interface---------------------------------------------------------------
--功能解锁数据处理
function updateUnlockBtns()

    m_gongNengBtn ={__mode = "kv"}
    m_tiaoZhanBtn = {__mode = "kv"}
    m_xiuXingBtn = {__mode = "kv"}
    m_sheJiaoBtn = {__mode = "kv"}
    
    for j=1, #m_gongNengType do
		if  luaIsUnlock(m_gongNengType[j]) then
            table.insert(m_gongNengBtn, luaGetUnlockInfoWithType(m_gongNengType[j]))
        end
	end
    for j=1, #m_tiaoZhanType do
		if  luaIsUnlock(m_tiaoZhanType[j]) then
            table.insert(m_tiaoZhanBtn, luaGetUnlockInfoWithType(m_tiaoZhanType[j]))
        end
	end
    for j=1, #m_xiuXingType do
		if  luaIsUnlock(m_xiuXingType[j]) then
            table.insert(m_xiuXingBtn, luaGetUnlockInfoWithType(m_xiuXingType[j]))
        end
	end
    for j=1, #m_sheJiaoType do
		if  luaIsUnlock(m_sheJiaoType[j]) then
            table.insert(m_sheJiaoBtn, luaGetUnlockInfoWithType(m_sheJiaoType[j]))
        end
	end
	showUnlockMainBtn()
	restartAllBeginnerGuide()
	ActivityAll_updateTipData()
end

function delUnlockBtn()
    local mapLayer = getMapLayer()
    if mapLayer ~= nil then
        local delType = mapLayer:getDelType()
        local pTopBarNode = getNodeByIdlistAndParent("5932", nil)
		if pTopBarNode then
			local node = pTopBarNode:getChildByTag(delType)
			if node ~= nil then
				pTopBarNode:removeChildByTag(delType, true)
			end
		end
		
        local pBottomBarNode = getNodeByIdlistAndParent("5933", nil)
		if pBottomBarNode then
			local node = pBottomBarNode:getChildByTag(delType)
			if node ~= nil then
				pBottomBarNode:removeChildByTag(delType, true)
			end
		end
		
        local pRightBarNode = getNodeByIdlistAndParent("5934", nil)
		if pRightBarNode then
			local node = pRightBarNode:getChildByTag(delType)
			if node ~= nil then
				pRightBarNode:removeChildByTag(delType, true)
			end
		end
		
        if delType == UNLOCK_TYPE_MONEY_SYMBOL then
            m_bMoneyRell = false
        end
        updateUnlockBtns()
		ActivityAll_delUpdateTipDataWithType(delType)
    end
    
    GetPriceRefreshForC()
end

function freeMainInterfaceData()
    m_pLeftBarNode = nil
    
    m_showStatus = {}
    
    m_gongNengBtn = nil
    m_tiaoZhanBtn = nil
    m_xiuXingBtn = nil
    m_sheJiaoBtn = nil
	m_rightBtn = nil
	m_topBtn = nil
	m_bottomBtn1 = nil
    
    m_isHide = false
    m_isHideTop = true
    m_isHideRight = false
    m_functionTipType = -5000

	if m_entryId then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
		m_entryId = nil
	end
	
	m_tmpExp = nil;
	m_tmpMaxExp = nil;
	m_upgradeMark = nil;
	m_moveValue = nil;
	if m_entryIdExp then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryIdExp)
		m_entryIdExp = nil
	end
	
    freeActivitiesPromptedData()
    clearDataWhileExitGame()
	levelTenSpree_ClearData()
	friend_clearData()
	NewFriends_clearData()
	ActivityAll_clearData()
	GameCopyController_clearData()
end

function refreshCurrencyInfo()
    showCurrencyInfo()
--    WingAndRevel_ResetWingsData()
end
--刷新经验条
function refreshExperienceBar()
	CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryIdExp)
	m_entryIdExp = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(runExperienceBarAction, 0.01, false)
	--showExperienceBar()
    local heroInfo = Hero:getSingleton():getHeroInfo()
    if heroInfo == nil then
        return
    end
    local dwExp = heroInfo.dwExp
    if m_tmpMaxExp == heroInfo.dwMaxExp and dwExp > m_tmpExp then
        m_moveValue = m_tmpMaxExp / SX(460)--(dwExp - m_tmpExp) / 25;
    end
end
--获取当前经验
function MainInterface_DirExperienceBar()
    local heroInfo = Hero:getSingleton():getHeroInfo()
    if heroInfo == nil then
        return
    end
    if m_tmpExp == nil then
        m_tmpExp = heroInfo.dwExp
    end
    if m_tmpMaxExp == nil then
        m_tmpMaxExp = heroInfo.dwMaxExp
    end
end

function MainInterface_DirMaxExperienceBar()
    local heroInfo = Hero:getSingleton():getHeroInfo()
    if heroInfo == nil then
        return
    end
    
    local dwExp = heroInfo.dwExp
   -- m_moveValue = (m_tmpMaxExp + dwExp - m_tmpExp) / 2.5;
    --m_tmpMaxExp = heroInfo.dwMaxExp
    --m_moveValue = 3000
end

function luaIsUnlock(unloclType)
    local mapLayer = getMapLayer()
    if mapLayer and unloclType then
        return mapLayer:isUnlock(unloclType)
    end
    return false
end

function luaGetUnlockInfoWithType(unloclType)
    local mapLayer = getMapLayer()
    if mapLayer and unloclType then
        return mapLayer:getUnlockInfoWithType(unloclType)
    end
    return false
end

function setMainTopNodeIsVisible(bFlag, mark)
	local pTopBarNode = nil;
    if mark == nil or mark == 1 then
        pTopBarNode = getNodeByIdlistAndParent("5932", nil)
    elseif 2 == mark then    
        pTopBarNode = getNodeByIdlistAndParent("5933-1", nil)
    elseif mark == 3 then    
        pTopBarNode = getNodeByIdlistAndParent("5933-2", nil)
    elseif 4 == mark then
        pTopBarNode = getNodeByIdlistAndParent("5936-12-1", nil)
    elseif 5 == mark then
        pTopBarNode = getNodeByIdlistAndParent("5900", nil)    
    end
    if pTopBarNode then
        pTopBarNode:setVisible(bFlag)
    end
end

function setMainCurrencyInfoNodeIsVisible(bFlag)
	local pCurrencyInfoNode = getNodeByIdlistAndParent("5936", nil)
    if pCurrencyInfoNode then
        pCurrencyInfoNode:setVisible(bFlag)
    end
	local pHeroStatusNode = getNodeByIdlistAndParent("5937", nil)
    if pHeroStatusNode then
        pHeroStatusNode:setVisible(bFlag)
    end
end

--获取主界面node
function getMainInterface()
    local mapLayer = getMapLayer()
    if mapLayer ~= nil then
        local scene = tolua.cast(mapLayer:getParent(), "GameScene")
        if scene ~= nil then
            return scene:getMainInterface()
        end
    end
    return nil;
end

--global Interface---------------------------------------------------------------

--人物状态
local function processShowStatusMsg()
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    local idUser = dt:readInt();
    local ucAmount = dt:readByte();
    for i=1, ucAmount do
        local tmpStatus = stShowStatus.initWithStream(dt);
        if tmpStatus.ucDelFlag == 0 then
            local count = 0
            for j=1, #m_showStatus do
                if tmpStatus.nStatus == m_showStatus[j].nStatus then
                    table.remove(m_showStatus, j)
                    table.insert(m_showStatus, j, tmpStatus)
                    break;
                end
                count = count + 1
            end
            if count == #m_showStatus then
                table.insert(m_showStatus, tmpStatus)
            end
        else
            for j=1, #m_showStatus do
                if tmpStatus.nStatus == m_showStatus[j].nStatus then
					local pHeroStatusNode = getNodeByIdlistAndParent("5937", nil)
					if pHeroStatusNode then
						pHeroStatusNode:removeChildByTag(m_showStatus[j].nStatus, true)
					end
                    table.remove(m_showStatus, j)
                    break;
                end
            end
        end
    end
    showHeroStatus()
end

function setNewFunctionType(type,flg)
	m_functionTipType = type
    setLightEfficiency(m_functionTipType, flg)
end

--判断是在功能、挑战、修行、社交中
local function getInWhichSite(lockType)
    for j=1, #m_gongNengType do
		if  m_gongNengType[j] == lockType then
            return 1  --功能
        end
	end
    for j=1, #m_tiaoZhanType do
		if  m_tiaoZhanType[j] == lockType then
             return 2  --挑战
        end
	end
    for j=1, #m_xiuXingType do
		if  m_xiuXingType[j] == lockType then
             return 3  --修行
        end
	end
    for j=1, #m_sheJiaoType do
		if  m_sheJiaoType[j] == lockType then
             return 4  --社交
        end
	end
	return 0
end

function setFeatCountDown(tt)
	local time = tt
	local mainNode = getMainInterface()
	if not mainNode then
		return
	end
	if time == 0 then
		mainNode:removeChildByTag(5925, true)
	else
		local countNode = mainNode:getChildByTag(5925)
		if not countNode then
			countNode = CountDownNode:newCountDownNode(DisplayTimeType_Hour_Minute_Second)
			if not countNode then
				return
			end
			countNode:setAnchorPoint(CCPointMake(0.5, 0.5))
			countNode:setPosition(getScreenWidth()/2, getScreenHeight()/2 + 100*gUIScale().y)
			countNode:setColor(color_green)
			countNode:setTag(5925)
			mainNode:addChild(countNode)
		end
		countNode:setTime(time)
	end
end

function MainInterface_getMainBtn(lockType)
    if lockType == nil then
        return nil
    end
    
    if lockType == UNLOCK_TYPE_THROUGH then
        lockType = UNLOCK_TYPE_TYPE6;
    end
    
	local node = tolua.cast(getNodeByIdlistAndParent("5933-1-"..lockType, nil), "BtnMainInterface")
	if node then
		return node;
	end
	node = tolua.cast(getNodeByIdlistAndParent("5933-2-"..lockType, nil), "BtnMainInterface")
	if node then
		return node;
	end
	node = tolua.cast(getNodeByIdlistAndParent("5932-"..lockType, nil), "BtnMainInterface")
	if node then
		return node;
	end
	node = tolua.cast(getNodeByIdlistAndParent("5936-12-1-"..lockType, nil), "BtnMainInterface")
	if node then
		return node;
	end
	node = tolua.cast(getNodeByIdlistAndParent("5900-"..lockType, nil), "BtnMainInterface")
	if node then
		return node;
	end
	node = tolua.cast(getNodeByIdlistAndParent("5932-1010-5914-"..lockType, nil), "BtnMainInterface")
	if node then
		return node;
	end
end

function setAniEfficiency(pNode, plistid, isShow)
    if pNode then
		if plistid then
        	pNode:removeAllChildrenWithCleanup(true);
		end
        if isShow == true  then
            local pAni = SCLookfaceParser:getSingleton():getAnimationByIndex(plistid, plistid);
            if pAni then
	            local pAnimation =  SCAnimationNode:nodeWithAnimation(pAni);
	            if pAnimation then
                    pAnimation:setAnchorPoint(CCPointMake(0.5, 0.5));
                    local size = pNode:getContentSize();
                    if plistid == 1043 then
                        pAnimation:setPosition(CCPointMake(size.width / 2, size.height / 2 -SY(10)));
                    else
                        pAnimation:setPosition(CCPointMake(size.width / 2, size.height / 2));
                    end
                    pNode:addChild(pAnimation);
	            end
            end
        end
    end
end

--设置主界面中的按钮上显示光效
function setLightEfficiency(lockType, isShow)
    if lockType == nil then
        return;
    end
    if UNLOCK_TYPE_FRIEND == lockType then  --好友系统添加邮件判断
        local mailScreenNum = NewFriend_getMailScreenNum()
        if mailScreenNum and 0 < mailScreenNum then
            isShow = true
        end
    end
	local node = tolua.cast(getNodeByIdlistAndParent("5933-1-"..lockType, nil), "BtnMainInterface")
	if node then
		node:setApertureVisible(isShow)
		if not isShow then
			m_functionTipType = -5000
		end
		return
	end
	node = tolua.cast(getNodeByIdlistAndParent("5933-2-"..lockType, nil), "BtnMainInterface")
	if node then
		node:setApertureVisible(isShow)
		if not isShow then
			m_functionTipType = -5000
		end
		return
	end
	node = tolua.cast(getNodeByIdlistAndParent("5932-"..lockType, nil), "BtnMainInterface")
	if node then
	    if lockType == 19 then
	        setAniEfficiency(node, 1044, isShow)
	        node:setApertureVisible(false)
	    elseif lockType == 1010 then
	        setAniEfficiency(node, 1043, isShow)
	        node:setApertureVisible(false)
	    else 
		    node:setApertureVisible(isShow)
		end
		if not isShow then
			m_functionTipType = -5000
		end
		return
	end
	node = tolua.cast(getNodeByIdlistAndParent("5936-12-1-"..lockType, nil), "BtnMainInterface")
	if node then
		node:setApertureVisible(isShow)
		if not isShow then
			m_functionTipType = -5000
		end
		return
	end
	node = tolua.cast(getNodeByIdlistAndParent("5900-"..lockType, nil), "BtnMainInterface")
	if node then
		node:setApertureVisible(isShow)
		if not isShow then
			m_functionTipType = -5000
		end
		return
	end
	node = tolua.cast(getNodeByIdlistAndParent("5932-1010-5914-"..lockType, nil), "BtnMainInterface")
	if node then
		node:setApertureVisible(isShow)
		if not isShow then
			m_functionTipType = -5000
		end
		return
	end	
	node = tolua.cast(getNodeByIdlistAndParent("5932-10111-5999-"..lockType, nil), "BtnMainInterface")
	if node then
		node:setApertureVisible(isShow)
		if not isShow then
			m_functionTipType = -5000
		end
		return
	end	
	local list = nil
	local realList = nil
	local flag = getInWhichSite(lockType)
	local parNode = nil
	if flag == 1 or flag == 2 then
		list = "5932-"..(1001+flag)
		realList = "5913-2-"..lockType.."-1"
	elseif flag == 3 or flag == 4 then
		list = "5933-"..(1001+flag)
		realList = "5933-5914-"..lockType
	end
	if list then
		node = tolua.cast(getNodeByIdlistAndParent(list, nil), "BtnMainInterface")
		if node then
			node:setApertureVisible(isShow)
			if not isShow then
				m_functionTipType = -5000
			end
			local nodeX = nil
			if flag == 4 or flag == 3 then
				nodeX = tolua.cast(getNodeByIdlistAndParent(realList, nil), "BtnMainInterface")
			else
				nodeX = tolua.cast(SCFunction:getUiNodeByIdlist(realList), "BtnMainInterface")
			end
			if nodeX then
				nodeX:setApertureVisible(isShow)
				if not isShow then
					m_functionTipType = -5000
				end
			end
			return
		end
	end
end

function getXiuXingBtn()
    return m_sheJiaoBtn;
end

function getSheJiaoBtn()
    return m_sheJiaoBtn;
end

function getTiaoZhanBtn()
    return m_tiaoZhanBtn;
end

function getGongNengBtn()
    return m_gongNengBtn;
end

--获取按钮位置
function MainInterface_getPos(UNLOCK_TYPE)
    if UNLOCK_TYPE == nil then
        return
    end
    
    if UNLOCK_TYPE == UNLOCK_TYPE_RUNE_STONE then
        UNLOCK_TYPE = UNLOCK_TYPE_EQUIP_STRENGTHEN
    elseif UNLOCK_TYPE == UNLOCK_TYPE_THROUGH then
        UNLOCK_TYPE = UNLOCK_TYPE_AREAN
    end
    for i = 1, #m_topBtn do
        if UNLOCK_TYPE == m_topBtn[i].tag then
            return 1;
        end
    end
    for i = 1, #m_bottomBtn1 do
        if UNLOCK_TYPE == m_bottomBtn1[i].tag then
            return 2;
        end
    end
    for i = 1, #m_bottomBtn2 do
        if UNLOCK_TYPE == m_bottomBtn2[i].tag then
            return 3;
        end
    end
    for i = 1, #m_liftBtn do
        if UNLOCK_TYPE == m_liftBtn[i].tag then
            return 4;
        end
    end
    for i = 1, #m_topBtn1 do
        if UNLOCK_TYPE == m_topBtn1[i].tag then
            return 5;
        end
    end
    for i = 1, #m_topBtnChildType do
        if UNLOCK_TYPE == m_topBtnChildType[i] then
            return 6;
        end
    end
    for i = 1,#m_topBtnChildByActivity do 
        if UNLOCK_TYPE == m_topBtnChildByActivity[i] then
            return 7;
        end
    end
    return nil;
end

function MainInterface_getBtnList(index)
    if 1 == index then
        return m_topBtn;
    elseif 2 == index then
        return m_bottomBtn1;
    elseif 3 == index then
        return m_bottomBtn2;
    elseif 4 == index then
        return m_liftBtn;
    elseif 5 == index then
        return m_topBtn1;
    end
end

function openVIPBase()
    onClickVipBase(0);
end

function MainInterface_teamPlay()
    local pNode = SCFunction:getUiNodeByIdlist("5918-5936-12");
    if pNode then
        local size = pNode:getContentSize();
        local pTeamNode = pNode:getChildByTag(2);
        if pTeamNode == nil then
            pTeamNode = SCNode:node();
            pNode:addChild(pTeamNode);
            pTeamNode:setContentSize(size);
            pTeamNode:setTag(2);
        end
        pTeamNode:removeAllChildrenWithCleanup(true);
        local teamPlay = BattleTeam3.getteamPlayInfo();
        local id = Hero:getSingleton():getID();
        local posX = size.width;
        for i = 1, 4 do
            if teamPlay[i] and teamPlay[i].playId ~= id then
                local pImg = getFaceImg(teamPlay[i].photo);
                if pImg then
                    pImg:setAnchorPoint(CCPointMake(0, 0.5));
                    posX = posX + SX(3);
                    pImg:setPosition(CCPointMake(posX, size.height / 2));
                    pTeamNode:addChild(pImg);
                    pImg:setScale(0.3);
                    local pLabel = SCLabel:labelWithStringFont(teamPlay[i].strName, DEFAULT_FONT_NAME, F(10));
                    if pLabel then
                        pLabel:setAnchorPoint(CCPointMake(0, 0.5));
                        posX = posX + pImg:getContentSize().width * 0.3 + SX(1);
                        pLabel:setPosition(CCPointMake(posX, size.height / 2));
                        pTeamNode:addChild(pLabel);
                        posX = posX + pLabel:getContentSize().width;
                    end
                end
            end
        end
    end
end

--快速任务按钮
function MainInterface_setQuickTaskBtn(index, title, color)	
    local pTopBarNode = getNodeByIdlistAndParent("5932", nil);
    if pTopBarNode == nil then
        return;
    end
    local pBtnQuickTask = nil;
    if 1 == index then    
        pBtnQuickTask = SCTypeCast:castNodeToButton(pTopBarNode:getChildByTag(1005));
    elseif 2 == index then
        pBtnQuickTask = SCTypeCast:castNodeToButton(pTopBarNode:getChildByTag(1006));
    elseif 3 == index then
        pBtnQuickTask = SCTypeCast:castNodeToButton(pTopBarNode:getChildByTag(1008));
    end
    if pBtnQuickTask == nil then    
        return;
    end
	
	if title == nil then
        pBtnQuickTask:setVisible(false);
		return;
	else
		pBtnQuickTask:setVisible(true);
		if color then
		    pBtnQuickTask:setTitle(title, getDefaultFontName(), getFontSize(9),color);
		else
		    pBtnQuickTask:setTitle(title, getDefaultFontName(), getFontSize(9),getColorWhite());
		end
    end
end

function MainInterface_seTaskBtn(title, icon, color)
    local pTopBarNode = getNodeByIdlistAndParent("5932", nil);
    if pTopBarNode == nil then
        return;
    end
    MainInterface_setBtnTaskImg(icon);
    local pNode = SCTypeCast:castNodeToButton(pTopBarNode:getChildByTag(1007));
    if pNode then
        local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(99));
        if pLabel == nil then
            pLabel = SCLabel:labelWithStringFont(title, getDefaultFontName(), getFontSize(9));
            if pLabel then
                pLabel:setTag(99)
                pLabel:setAnchorPoint(CCPointMake(0.5, 0));
                local size = pNode:getContentSize();
                pLabel:setPosition(CCPointMake(size.width / 2 - SX(4), SY(5)));
                local pBackNode = SCNode:node();
                if pBackNode then
                    pBackNode:setContentSize(CCSizeMake(size.width - SX(4), SY(13)));
                    pBackNode:setAnchorPoint(CCPointMake(0.5, 0))
                    pBackNode:setPosition(CCPointMake(size.width / 2, SY(3)));
                    pBackNode:setBackgroundColor(ccc4(0, 0, 07, 100));
                    pNode:addChild(pBackNode);
                end   
                pNode:addChild(pLabel);
            end
        end
        if pLabel then
            if color then
                pLabel:setColor(color);
            end
            pLabel:setText(title);
        end    
    end
   
end
--快速任务按钮大图标
function MainInterface_setBtnTaskImg(filePath)
    local pImgPath = getRealUIResourcePath("instance/"..filePath..".png")
    if pImgPath then
        local taskBtn = SCTypeCast:castNodeToButton(getNodeByIdlistAndParent("5932-1007", nil));
        local pImg = nil;
        if taskBtn then
            pImg = SCTypeCast:castNodeToImage(taskBtn:getChildByTag(1));
            if pImg == nil then
                pImg = SCImage:imageWithFile(pImgPath:getData());
                pImg:setTag(1);
                local size = taskBtn:getContentSize();
                pImg:setAnchorPoint(CCPointMake(0.5, 0.5))
                pImg:setPosition(CCPointMake(size.width / 2 , size.height / 2- SY(9)));
                taskBtn:addChild(pImg);
            else
                pImg:setImage(pImgPath:getData());
            end
        end
    end
end

function getIconTimes(Type)
    for i = 1, #m_showIconStatus do
        if m_showIconStatus[i] then
            if m_showIconStatus[i].nType == Type then
                return m_showIconStatus[i].nAmount
            end
        end
    end
    return nil
end

function InitshowIconStatus()
    m_showIconStatus = {}
end

local function IconTimes_recvData()
    local dt = LuaData:getSingleton():getDataTransStream();  ---获取当前的数据对象
	if dt == nil then
	    return
	end
    local tmp = {}
    local flag = nil;
    local flag1 = nil;
    tmp.nType = dt:readInt();
    tmp.nAmount = dt:readInt();
    if #m_showIconStatus == 0 then
        table.insert(m_showIconStatus, tmp);
    end
    for j = 1, 4 do
        if m_showIconStatus[j] then
            if m_showIconStatus[j].nType == tmp.nType then
                m_showIconStatus[j].nAmount = tmp.nAmount;
                flag = 1;
            end
        end
    end
    
    if flag == nil then
        table.insert(m_showIconStatus, tmp);
    end
    

                
                local button = MainInterface_getMainBtn(8)
                if button then
                    for i = 1, 4 do
                        if m_showIconStatus[i] then
                            if m_showIconStatus[i].nType == 1 then
                                SmallshowBtn(button, m_showIconStatus[i].nAmount);
                            end
                        end
                    end
                    
                end
                local button = MainInterface_getMainBtn(6)
                if button then
                    for i = 1, 4 do
                        if m_showIconStatus[i] then
                            if m_showIconStatus[i].nType == 2 then
                                SmallshowBtn(button, m_showIconStatus[i].nAmount);
                            end
                        end
                    end
                    
                end
                local button = MainInterface_getMainBtn(9)
                if button then
                    for i = 1, 4 do
                        if m_showIconStatus[i] then
                            if m_showIconStatus[i].nType == 3 then
                                SmallshowBtn(button, m_showIconStatus[i].nAmount);
                            end
                        end
                    end
                    
                end
                
                local button = MainInterface_getMainBtn(1010)
                if button then
                    for i = 1, 4 do
                        if m_showIconStatus[i] then
                            if m_showIconStatus[i].nType == 4 then
                                SmallshowBtn(button, m_showIconStatus[i].nAmount);
                            end
                        end
                    end
                    
                end


end
local function DownloadInfo()
    SCActivityIndicator:getSingleton():close();   ----关闭等待转圈图标
	local dt = LuaData:getSingleton():getDataTransStream();  ---获取当前的数据对象
	if dt == nil then
	    return
	end
	downloadInfoFlg = dt:readByte();
	
	GetPrice.refreshWnd()
end
function MainInterface_clickMainInterfaceFun(usType)
    if 0 == usType then
        showTopBtnByActivity()
    elseif 1 == usType then
        onClickVipBase(12)
    else
        sendUnlockBtnHitMsg2(usType)
    end 
end
function MainInterface_onClickActive(tag)
    onActivityBtnClick(tag) 
end

--军团礼包领奖发送--
function sendTribeGift()
    local dt = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dt:writeShort(USERINFO_GET_ARMY_GIFT)
    SCDataTransThread:getSingleton():transData(dt)
    SCActivityIndicator:getSingleton():show()
end

--军团礼包TIP回调--
function onClickTribeTip()
    local pRunningScene = getRunningScene() --tolua.cast(getRunningScene(), "SCBaseScene")
    if pRunningScene == nil then
        return
    end
    pRunningScene:getUINode():removeChildByTag(888810, true)
    onMainBtnClick(UNLOCK_TYPE_TRIBE)
end

--军团礼包TIP--
function showTipForTribe()
    local pRunningScene = getRunningScene() --tolua.cast(getRunningScene(), "SCBaseScene")
    if pRunningScene == nil then
        return
    end
    
    pRunningScene:getUINode():removeChildByTag(888810, true)
    
    local pTip = TipWindow:newWindow()
    if pTip then
        pTip:setContentSize(AUTO_SIZE(320, 170))
        
        pTextBox = SCTextBox:boxWithWidthHeightFont(SX(280), SY(100), getDefaultFontName(), getFontSize(15))
        pTextBox:setParserDelegate(TextParser:getSingleton())
        pTextBox:setText(L("str30080"))
        
        pTextBox:setPosition(AUTO_POS(20, 40))
        pTip:addChild(pTextBox)
        
        local pBtn = SCButton:button(EnumBtnType9Atlas)
        pBtn:setContentSize(AUTO_SIZE(95, 35))
        pBtn:setTitle(L("str30081"), getDefaultFontName(), getFontSize(15), color_white)
        pBtn:setAnchorPoint(ANCHOR_CENTER)
        pBtn:setPosition(CCPointMake(pTip:getContentSize().width / 2, SY(40)))
        pBtn:luaSetSelectorOnClicked(onClickTribeTip)
        pTip:addChild(pBtn)
        
        pRunningScene:getUINode():addChild(tolua.cast(pTip, "SCNode"), 20000, 888810) --4294967295
    end
end

function getDownLoadFlgForGetPriceWnd()
    return downloadInfoFlg
end

function getDownLoadInfoForGetPriceWnd()
    return m_downloadInfo
end

--registCommand 注册人物状态消息
SCMessageCenter:getSingleton():luaRegistCommand(processShowStatusMsg, _MSG_SHOWSTATUS, 0, nil);
----------------消息注册区----------------
LuaData:getSingleton():luaSetSelectorOnRecvData(IconTimes_recvData, LuaData_USERINFO_ICON_TIMES)
LuaData:getSingleton():luaSetSelectorOnRecvData(DownloadInfo, LuaData_USERINFO_SCALE_AWARD)