--定义一个与文件名相同的table
NewFriends = {}
------------------消息--------------------

----------------结构定义区----------------
local m_blackFriendFlg = nil      --拉黑标志
local m_newAddBlackFriendId = nil --新拉黑ID

local tMSG_AROUND_USER_DATA = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            idUser,                --//玩家ID
            nLev,		    --//等级
            idPhoto,        --//职业头像
            szName,            --//名字
            usVipLev,        --//Vip等级
            nRank,           --竞技场排名
            szTribeName,     --军团名
        }
        tmp.idUser = dt:readInt()
        tmp.nLev = dt:readInt();
        tmp.idPhoto = dt:readInt();
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szName = " "
        else
            tmp.szName = scStr:getData()
        end
        tmp.usVipLev = 0
        tmp.usVipLev = dt:readShort();
        tmp.nRank = 0
        tmp.nRank = dt:readInt();
        
        tmp.szTribeName = 0
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTribeName = " "
        else
            tmp.szTribeName = scStr:getData()
        end
        return tmp
    end;
}

local stFriendOrEnemyInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            idUser,                --//玩家ID
            szName,            --//名字
            ucOnlineFlag,		    --// 在线的标志位
            dwData1,        --//存放等级
            dwData2,		--// 好友-好友度/仇人-复仇次数
            szLabourUnion,        --//公会名
            szPro,           --职业名
            dwReputation,     --声望
            dwRanking,        --竞技场排名
            dwPhoto,          --头像
            usVipLev,         --VIP等级
        }
        tmp.idUser = dt:readInt()
        if m_blackFriendFlg then
            m_newAddBlackFriendId = tmp.idUser
        end
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szName = ""
        else
            tmp.szName = scStr:getData()
        end
        tmp.ucOnlineFlag = dt:readByte()
        tmp.dwData1 = dt:readInt()
        tmp.dwData2 = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szLabourUnion = ""
        else
            tmp.szLabourUnion = scStr:getData()
        end
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szPro = ""
        else
            tmp.szPro = scStr:getData()
        end
        tmp.dwReputation = dt:readInt()
        tmp.dwRanking = dt:readInt()
        tmp.dwPhoto = dt:readInt()
        tmp.usVipLev = 0
        tmp.usVipLev = dt:readShort();
        return tmp
    end
}

----------------常量定义区----------------
local _MSG_FRIEND                    =1019;
local MSG_FRIEND_APPLY                = 10;            -- 申请好友
local MSG_FRIEND_ADD_BLACKNAME        = 29;            --- 将玩家加入黑名单
local MSG_FRIEND_GETINFO            = 13;            -- 获取好友列表


local MSG_FRIEND_UPDATE_INFO        = 14;            -- 更新好友信息
local MSG_TEMP_FRIEND_GETINFO        = 34;            -- 获取临时好友列表
local MSG_TEMP_FRIEND_UPDATE_INFO    = 35;            -- 更新临时好友信息
local MSG_BLACKNAME_GETINFO            = 32;            -- 获取黑名列表

local MSG_FRIEND_DEL_BLACKNAME        = 30;            -- 删除黑名单里的玩家
local MSG_FRIEND_DEL                = 21;            -- 删除好友
local MSG_TEMP_FRIEND_DEL            = 36;            -- 删除临时好友
local MSG_AROUND_USER		        = 43;           --//周围玩家
local MSG_ONEKEY_ADD_AROUND_USER	= 44           --一键添加


local TMPE_FRIEND_TYPE          = 1 
local TMPE_TMPE_FRIEND_TYPE          = 2
local TMPE_BLACK_FRIEND_TYPE          = 3 
local TMPE_AROUND_FRIEND_TYPE          = 4 
----------------变量定义区----------------
--变量的定义
local m_aroundUserDataList = nil
local m_aroundUserNumber = nil
local m_myFriendDataList = nil 
local m_myTempFriendDataList = nil 
local m_myBlackFriendDataList = nil
local m_nowOpenPageType = nil
local m_MailOpenFriendFlg = nil
local m_MailScreenNum = nil
----------------UI控制器区----------------
function NewFriends.initControl()
	local pWindow4301 = SCWindow:window()
	if pWindow4301 then
		pWindow4301:setTag(4301)
		pWindow4301:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow4301:setPosition(AUTO_POS(0.00, 0.00))pWindow4301:setContentSize(AUTO_SIZE(480, 320))
		pWindow4301:luaSetSelectorOnClose(NewFriends.releaseControl)
	end

	local pMultiPage1 = SCMultiPage:pageWithType(EnumMultiPageTypeLarge)
	if pMultiPage1 then
		pMultiPage1:setTag(1)
		pMultiPage1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pMultiPage1:setPosition(AUTO_POS(0.00, 0.00))
		pMultiPage1:setContentSize(AUTO_SIZE(480, 320))
		local pageImg = {"new00804.pn", "new00805.pn", "new00806.pn"}
		for i = 1, 3 do
			local pNode = SCNode:node()
			if pNode then
				pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)				   
				pNode:setPosition(ANCHOR_LEFT_BOTTOM)
				pMultiPage1:addPage(pNode)
				local imgPath = getRealUIResourcePath("friends/" .. pageImg[i])				   
				if imgPath then
					pMultiPage1:setTitleAtPage(imgPath:getData(), i - 1)
				end
			end
		end
	end

	local imgPath = getRealUIResourcePath("img/new00544.png")
	local pImage2 = nil
	if imgPath then
		pImage2 = SCImage:imageWithFile(imgPath:getData())
		if pImage2 then
			pImage2:setTag(2)
			pImage2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage2:setPosition(AUTO_POS(345.00, 295.00))
		end
	end

	local pLable3 = SCLabel:labelWithStringFont(L("  "), DEFAULT_FONT_NAME, F(10))
	if pLable3 then
		pLable3:setTag(3)
		pLable3:setAnchorPoint(ANCHOR_CENTER)
		pLable3:setPosition(AUTO_POS(7.00, 12.50))
		pLable3:setColor(ccc4(255,255,255,255))
	end

	if pMultiPage1 and pWindow4301 then
		pWindow4301:addChild(tolua.cast(pMultiPage1, "SCNode"))
	end
	if pImage2 and pWindow4301 then
		pWindow4301:addChild(tolua.cast(pImage2, "SCNode"))
	end
	if pLable3 and pImage2 then
		pImage2:addChild(tolua.cast(pLable3, "SCNode"))
	end
	return pWindow4301
end
function NewFriends.releaseControl()
	if NewFriends.wndClose then
		NewFriends.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
local function NewFriends_multiTabAction(tag, pageIndex)
    local wndCtrl = getCurentSceneWindowController(4301)
    if not wndCtrl then
        return
    end
    local wnd = wndCtrl:getWindow()
    if not wnd then
        return
    end
    local multiTabLayer = SCTypeCast:castNodeToMultiPage(wnd:getChildByTag(1))
    if multiTabLayer then
        local index = multiTabLayer:selectedPageIndex()
        if index == 0 then
        elseif index == 1 then
            showMessage(L("str6194"))
            multiTabLayer:selectPageWithIndex(0)
        elseif index == 2 then
            open_MailScreen()
            local wndCtrl = getCurentSceneWindowController(4301);
            if wndCtrl then
                removeWindowCtrl(wndCtrl);
            end
        end
    end
end
local function creatTabel(tabelBox)
    local tabel = SCTable:table();
    if tabel == nil then
        return;
    end
    
    tabel:setNumberOfRows(2);
    tabel:setNumberOfColumns(5);
    tabelBox:addTable(tabel);
    
    for i=0,5 do
        tabel:setWidthForColumn(AUTO_W(90), i);
    end
    
    for i=0,2 do
        tabel:setHeightForRow(AUTO_W(120), i);
    end
    
    tabel:reflashData();
    for i=0, 2 do
		for j=0, 5 do
			local tableCell = tabel:cellForRowAndColumn(i, j);
			if tableCell then
			    local dragNode = SCDragNode:node()
				if dragNode then
				    dragNode:setTag(1);
					dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
					dragNode:setPosition(CCPointMake(tableCell:getContentSize().width/2, tableCell:getContentSize().height/2 - SY(3)));
					dragNode:setContentSize(AUTO_SIZE(80, 110))
					dragNode:setDragEnabled(false)
		            dragNode:setFrameType(EnumFrameTypeNone)
					tableCell:addChild(dragNode);
				end
			end 
	    end
	end
end

--添加好友显示周围玩家
local function onFindFriendBtnClick()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_FRIEND)
    if dataStream then
        dataStream:writeShort(MSG_AROUND_USER)
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show();
    end
end
--一键添加
local function onOneKeyFindFriendBtnClick()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_FRIEND)
    if dataStream then
        dataStream:writeShort(MSG_ONEKEY_ADD_AROUND_USER)
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show();
    end
end

--对酒
local function onBtnSendToast()
    OnTheWine.showWnd();
end

--返回
local function onBackBtnClick()
    NewFriends_setDataToNewFriendsWnd()
end
--
local function onLookUserMenu(data,type)
    
end

--好友列表排序
local function friendSequence(secTab, insTab)
    for i = 1, #secTab do
        if secTab[i].idUser == insTab.idUser then
            table.remove(secTab, i);
            break
        end
    end
    if insTab.ucOnlineFlag == 1 then
        local count = 0
        for i = 1, #secTab do
            if secTab[i].dwData1 <= insTab.dwData1 or secTab[i].ucOnlineFlag == 0 then
                table.insert(secTab, i, insTab);
                break;
            end
            count = count + 1
        end
        if count == #secTab then
            table.insert(secTab, insTab);
        end
    else
        local count = 0
        for i = #secTab, 1, -1 do
            if secTab[i].dwData1 >= insTab.dwData1 or secTab[i].ucOnlineFlag == 1 then
                table.insert(secTab, i + 1, insTab);
                break;
            end
            count = count + 1
        end
        if count == #secTab then
            table.insert(secTab, 1, insTab);
        end
    end
end


--点击周围玩家
local function onAroundUserBtnClick(tag)
    local data = {}
    if m_aroundUserDataList[tag] then
        data.idUser = m_aroundUserDataList[tag].idUser
        data.nLev = m_aroundUserDataList[tag].nLev
        data.idPhoto = m_aroundUserDataList[tag].idPhoto
        data.szName = m_aroundUserDataList[tag].szName
        data.usVipLev =m_aroundUserDataList[tag].usVipLev
        data.dwRanking = m_aroundUserDataList[tag].nRank
        data.szLabourUnion = m_aroundUserDataList[tag].szTribeName
    end
    if m_MailOpenFriendFlg then
        local name = data.szName
        if getCurentSceneWindowController(8006) then
            openSendMailWnd(name)
            local hadeNode = SCFunction:getUiNodeByIdlist("4301");
            if hadeNode then
                hadeNode:removeFromParentAndCleanup(true);
            end
            return
        end
    end
    NewFriends4_showNewFriends4Wnd(data,4)
end

--点击显示好友
local function onLookFriendBtnClick(tag)
    local data = {}
    if m_myFriendDataList[tag] then
        data.idUser = m_myFriendDataList[tag].idUser
        data.nLev = m_myFriendDataList[tag].dwData1
        data.idPhoto = m_myFriendDataList[tag].dwPhoto
        data.szName = m_myFriendDataList[tag].szName
        data.usVipLev = m_myFriendDataList[tag].usVipLev
        data.dwRanking = m_myFriendDataList[tag].dwRanking
        data.szLabourUnion = m_myFriendDataList[tag].szLabourUnion
    end
    if m_MailOpenFriendFlg then
        local name = data.szName
        if getCurentSceneWindowController(8006) then
            openSendMailWnd(name)
            local hadeNode = SCFunction:getUiNodeByIdlist("4301");
            if hadeNode then
                hadeNode:removeFromParentAndCleanup(true);
            end
            return
        end
    end
    NewFriends5_showNewFriends5Wnd(data,1)
end
--点击显示临时好友
local function onLookTempFriendBtnClick(tag)
    local data = {}
    if m_myTempFriendDataList[tag] then
        data.idUser = m_myTempFriendDataList[tag].idUser
        data.nLev = m_myTempFriendDataList[tag].dwData1
        data.idPhoto = m_myTempFriendDataList[tag].dwPhoto
        data.szName = m_myTempFriendDataList[tag].szName
        data.usVipLev =m_myTempFriendDataList[tag].usVipLev
        data.dwRanking = m_myTempFriendDataList[tag].dwRanking
        data.szLabourUnion = m_myTempFriendDataList[tag].szLabourUnion
    end
    if m_MailOpenFriendFlg then
        local name = data.szName
        if getCurentSceneWindowController(8006) then
            openSendMailWnd(name)
            local hadeNode = SCFunction:getUiNodeByIdlist("4301");
            if hadeNode then
                hadeNode:removeFromParentAndCleanup(true);
            end
            return
        end
    end
    NewFriends4_showNewFriends4Wnd(data,2)
end
--点击显示黑名单
local function onLookBlackFriendBtnClick(tag)
    local data = {}
    if m_myBlackFriendDataList[tag] then
        data.idUser = m_myBlackFriendDataList[tag].idUser
        data.nLev = m_myBlackFriendDataList[tag].dwData1
        data.idPhoto = m_myBlackFriendDataList[tag].dwPhoto
        data.szName = m_myBlackFriendDataList[tag].szName
        data.usVipLev = m_myBlackFriendDataList[tag].usVipLev
        data.dwRanking = m_myBlackFriendDataList[tag].dwRanking
        data.szLabourUnion = m_myBlackFriendDataList[tag].szLabourUnion
    end
    if m_MailOpenFriendFlg then
        local name = data.szName
        if getCurentSceneWindowController(8006) then
            openSendMailWnd(name)
            local hadeNode = SCFunction:getUiNodeByIdlist("4301");
            if hadeNode then
                hadeNode:removeFromParentAndCleanup(true);
            end
            return
        end
    end
    NewFriends4_showNewFriends4Wnd(data,3)
end
--添加好友
local function onEditWndEnd(tag)
    local edit = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("5927-5"))
    if not edit then
        return
    end
    local strText = edit:getContentText();
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_FRIEND);
      dataStream:writeShort(MSG_FRIEND_APPLY);
      dataStream:writeInt(0);
    
      if string.len(strText) == 0 then
         showMessage(_LTParser("str2001"));
         return ;
      end
      dataStream:writeData(string.format(strText), string.len(strText));
      SCDataTransThread:getSingleton():transData(dataStream);
      
    local naviCtrl = getCurentSceneNavigationController()
    if not naviCtrl then
        return
    end
    naviCtrl:removeWindowControllerByTag(5927)
end 
--搜索好友
local function createAddFriWnd()
    if isWindControllerExistence(5927) then
        return
    end
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5927))
    if not wnd then
        return
    end
    wnd:setFrameVisibled(false)
    local framNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(1))
    if framNode then
        framNode:setFrameType(EnumFrameTypeLine)
        --framNode:setFrameWithFile()
        framNode:setFrameVisibled(true)
    end
    
    local dragNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(3))
    if dragNode then
        
        dragNode:setFrameType(EnumFrameTypeRound)
        dragNode:setFrameVisibled(true)
    end
    local btn = SCTypeCast:castNodeToButton(wnd:getChildByTag(4))
    if btn then
        
        local titlefile = getRealUIResourcePath("img/new00024.png")
        if titlefile then
            btn:setTitle(titlefile:getData())
        end
        btn:setButtonType(EnumBtnType9Atlas)
        btn:setContentSize(AUTO_SIZE(61, 30))
        btn:luaSetSelectorOnClicked(onEditWndEnd)
    end
    local edit = SCTypeCast:castNodeToEdit(wnd:getChildByTag(5))
    if edit then
        edit:setPlaceHolder(_LTParser("str5110"));
        edit:setMaxCharCount(1024);
        edit:setMinCharCount(0);
        edit:setBottomColor(color_transparent);
        edit:setFontColor(color_white);
    end
    local wndCtrl = SCWindowController:controllerWithWindow(wnd)
    if not wndCtrl then
        return
    end
    local naviCtrl = getCurentSceneNavigationController()
    if not naviCtrl then
        return
    end
    naviCtrl:pushWindowController(wndCtrl)
end

--设置人物单项
local function newTheFriendsNode(friendType,Tag)
    local data = nil
    if TMPE_AROUND_FRIEND_TYPE == friendType and m_aroundUserDataList[Tag] then
        data = {}
        data.idUser = m_aroundUserDataList[Tag].idUser
        data.nLev = m_aroundUserDataList[Tag].nLev
        data.idPhoto = m_aroundUserDataList[Tag].idPhoto
        data.szName = m_aroundUserDataList[Tag].szName
        data.usVipLev =m_aroundUserDataList[Tag].usVipLev
    elseif TMPE_FRIEND_TYPE == friendType and m_myFriendDataList and m_myFriendDataList[Tag] then
        data = {}
        data.idUser = m_myFriendDataList[Tag].idUser
        data.nLev = m_myFriendDataList[Tag].dwData1
        data.idPhoto = m_myFriendDataList[Tag].dwPhoto
        data.szName = m_myFriendDataList[Tag].szName
        data.usVipLev = m_myFriendDataList[Tag].usVipLev
        data.ucOnlineFlag = m_myFriendDataList[Tag].ucOnlineFlag
    elseif TMPE_TMPE_FRIEND_TYPE == friendType and m_myTempFriendDataList and m_myTempFriendDataList[Tag] then
        data = {}
        data.idUser = m_myTempFriendDataList[Tag].idUser
        data.nLev = m_myTempFriendDataList[Tag].dwData1
        data.idPhoto = m_myTempFriendDataList[Tag].dwPhoto
        data.szName = m_myTempFriendDataList[Tag].szName
        data.usVipLev = m_myTempFriendDataList[Tag].usVipLev
        data.ucOnlineFlag = m_myTempFriendDataList[Tag].ucOnlineFlag
    elseif TMPE_BLACK_FRIEND_TYPE == friendType and m_myBlackFriendDataList and m_myBlackFriendDataList[Tag] then
        data = {}
        data.idUser = m_myBlackFriendDataList[Tag].idUser
        data.nLev = m_myBlackFriendDataList[Tag].dwData1
        data.idPhoto = m_myBlackFriendDataList[Tag].dwPhoto
        data.szName = m_myBlackFriendDataList[Tag].szName
        data.usVipLev = m_myBlackFriendDataList[Tag].usVipLev
        data.ucOnlineFlag = m_myBlackFriendDataList[Tag].ucOnlineFlag
    end
    if not data then
        return
    end
    local dragNode = NewFriends3.initControl()
    local pLabel = SCTypeCast:castNodeToLabel(dragNode:getChildByTag(2));
    if pLabel and data.nLev then
        local str = L("str3257")..data.nLev
        pLabel:setText(str)
        if TMPE_AROUND_FRIEND_TYPE ~= friendType and 0 == data.ucOnlineFlag then
            pLabel:setColor(color_gray)
        end
    end
    local pImg = SCTypeCast:castNodeToImage(dragNode:getChildByTag(3));
    if pImg and data.idPhoto then
        local imgPath = nil
        if 1 == data.idPhoto then   
            imgPath = getRealUIResourcePath("faceicon/311004.jp")
        elseif 2 == data.idPhoto then
            imgPath = getRealUIResourcePath("faceicon/311003.jp")
        elseif 3 == data.idPhoto then
            imgPath = getRealUIResourcePath("faceicon/311001.jp")
        elseif 4 == data.idPhoto then
            imgPath = getRealUIResourcePath("faceicon/311002.jp")
        end
        if imgPath then
	        pImg:setImage(imgPath:getData())
	        --只处理点击事件
            local eventBtn = SCButton:button();
            if eventBtn then
                eventBtn:setContentSize(pImg:getContentSize());
                eventBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
                eventBtn:setPosition(CCPointMake(pImg:getContentSize().width/2, pImg:getContentSize().height/2));
                eventBtn:setTag(Tag);
                if TMPE_AROUND_FRIEND_TYPE == friendType then
                    eventBtn:luaSetSelectorOnClicked(onAroundUserBtnClick);
                elseif TMPE_FRIEND_TYPE == friendType then
                    eventBtn:luaSetSelectorOnClicked(onLookFriendBtnClick);
                elseif TMPE_TMPE_FRIEND_TYPE == friendType then
                    eventBtn:luaSetSelectorOnClicked(onLookTempFriendBtnClick);
                elseif TMPE_BLACK_FRIEND_TYPE == friendType then
                    eventBtn:luaSetSelectorOnClicked(onLookBlackFriendBtnClick);
                end
                pImg:addChild(eventBtn);
            end
	    end
    end
    local pImg4 = SCTypeCast:castNodeToImage(dragNode:getChildByTag(4));
    local flg = false
    if not data.usVipLev or 1 > data.usVipLev then
        pImg4:setVisible(false)
        flg = true
    else
        local vipNum = 608 + data.usVipLev
        local vipImg = "img/new00"..vipNum..".png"
        local imgPath = getRealUIResourcePath(vipImg)
        if imgPath then
	        pImg4:setImage(imgPath:getData())
	    end
        pImg4:setScale(0.5)
    end
    local pLabel5 = SCTypeCast:castNodeToLabel(dragNode:getChildByTag(5));
    if pLabel5 and data.szName then
        local str = data.szName
        pLabel5:setText(str)
        if flg then
            pLabel5:setPosition(CCPointMake(SX(42),SY(15)))
        end
        if TMPE_AROUND_FRIEND_TYPE ~= friendType and 0 == data.ucOnlineFlag then
            pLabel5:setColor(color_gray)
        end
    end
    return dragNode
end

--临时好友
local function onTempFriendBtnClick()
    NewFriends_setDataToNewTempFriendsWnd()
end
--设置单项
local function newOneFriendsMenuNode(friendType,nodeTag)
    local dragNode = NewFriends2.initControl()
    local pBtn = SCTypeCast:castNodeToButton(dragNode:getChildByTag(2));
    if pBtn then
        local str = L("str3255") 
        pBtn:luaSetSelectorOnClicked(onBackBtnClick)
        if TMPE_FRIEND_TYPE == friendType then
            if 0 == nodeTag then
                str = L("str3252")
                pBtn:luaSetSelectorOnClicked(onFindFriendBtnClick)
            elseif 1 == nodeTag then
                str = L("str3253")
                pBtn:luaSetSelectorOnClicked(onBtnSendToast);
            elseif 2 == nodeTag then
                str = L("str3254")
                pBtn:luaSetSelectorOnClicked(onTempFriendBtnClick);
            end
        elseif TMPE_TMPE_FRIEND_TYPE == friendType or TMPE_BLACK_FRIEND_TYPE == friendType then
        elseif TMPE_AROUND_FRIEND_TYPE == friendType then   
            if 1 == nodeTag then
                str = L("str3256")
                pBtn:luaSetSelectorOnClicked(createAddFriWnd);
            end
        end
        
        if str then
            pBtn:setTitle(str, DEFAULT_FONT_NAME, F(14))
        end
    end
    local pImg = SCTypeCast:castNodeToImage(dragNode:getChildByTag(3));
    if pImg and 0 == nodeTag then
        local imgPath = nil
        if TMPE_FRIEND_TYPE == friendType then
            imgPath = getRealUIResourcePath("friends/new00807.jpg")
        else
            imgPath = getRealUIResourcePath("img/img5010.png")
        end
	    if imgPath then
	        pImg:setImage(imgPath:getData())
	    end
    end
    return dragNode
end

local function setDataToNewFriendWnd(friendType,allItemNum)
    local pDragNode = nil
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("4301-1"));
    if pMultiPage then
        local pNode = pMultiPage:getPageWithIndex(0);
        if pNode then
            pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1))
            
        end
    end
    if not pDragNode then
        return
    end
    local pBtn = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(5));
    
    if pBtn then
        if TMPE_BLACK_FRIEND_TYPE == friendType then
            pBtn:setVisible(false)
        elseif TMPE_AROUND_FRIEND_TYPE == friendType then
            pBtn:setTitle(L("str3278"), DEFAULT_FONT_NAME, F(15))
            pBtn:luaSetSelectorOnClicked(onOneKeyFindFriendBtnClick)
        else
            pBtn:setVisible(true)
            pBtn:setTitle(L("str3251"), DEFAULT_FONT_NAME, F(15))
            pBtn:luaSetSelectorOnClicked(NewFriends_onBlackFriendBtnClick)
        end
    end
    
    local pLabel3 = SCTypeCast:castNodeToLabel(pDragNode:getChildByTag(3));
    if pLabel3 then
        if TMPE_FRIEND_TYPE == friendType and m_myFriendDataList then
            local count = 0
            for i = 1,#m_myFriendDataList do
                if m_myFriendDataList[i] and 1 == m_myFriendDataList[i].ucOnlineFlag then
                    count = count + 1
                end
            end
            local str = L("str3279")..count.."/"..#m_myFriendDataList
            pLabel3:setText(str)
            pLabel3:setVisible(true)
        else
            pLabel3:setVisible(false)
        end
    end
    local pTableBox = SCTypeCast:castNodeToTableBox(pDragNode:getChildByTag(2))
    if pTableBox then
        pTableBox:removeAllChildrenWithCleanup(true);
        local allNum = math.modf(allItemNum/10)
        if allItemNum%10 ~= 0 then
            allNum = allNum + 1
        end
        for i = 1,allNum do
            creatTabel(pTableBox)
        end
        
        local pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("0", pTableBox))
        local itemTag = nil
        local pageNum = 0
        
        for i = 0,(allItemNum-1) do
            if i%10 == 0 and 9 < i then
                pageNum = i/10
                pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent(pageNum, pTableBox))
            end
            itemTag = i - pageNum * 10
            local tableCell = nil
            if pTable then
                tableCell = pTable:getChildByTag(itemTag)
            end
            if tableCell then
                local childNode = SCTypeCast:castNodeToDragNode(tableCell:getChildByTag(1));
                if childNode then
                    local menuMaxTag = 0
                    if TMPE_FRIEND_TYPE == friendType then
                        menuMaxTag = 2
                    elseif TMPE_AROUND_FRIEND_TYPE == friendType then
                        menuMaxTag = 1
                    elseif TMPE_BLACK_FRIEND_TYPE == friendType and TMPE_TMPE_FRIEND_TYPE == friendType then
                        menuMaxTag = 0
                    end
                    if i > menuMaxTag then
                        dragNode = newTheFriendsNode(friendType,i-menuMaxTag)
                    else
                        dragNode = newOneFriendsMenuNode(friendType,i)
                    end
				    if dragNode then
                        dragNode:setTag(1);
                        dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        dragNode:setPosition(CCPointMake(childNode:getContentSize().width/2, childNode:getContentSize().height/2));
                        childNode:addChild(dragNode);
                    end
                end 
            end
        end
    end
end

function NewFriends_setDataToNewFriendsWnd()
    
    local allItemNum = 3
    if m_myFriendDataList then
        allItemNum = #m_myFriendDataList + 3
    end
    m_nowOpenPageType = 1
    setDataToNewFriendWnd(1,allItemNum)
end

function NewFriends_setDataToNewTempFriendsWnd()
    local allItemNum = 1
    if m_myTempFriendDataList then
        allItemNum = #m_myTempFriendDataList + 1
    end
    m_nowOpenPageType = 2
    setDataToNewFriendWnd(2,allItemNum)
end

local function setDataToNewFriendsFindFriendsWnd()
    local allItemNum = 2
    if m_aroundUserDataList then
        allItemNum = #m_aroundUserDataList + 2
    end
    m_nowOpenPageType = 4
    setDataToNewFriendWnd(4,allItemNum)
end

function NewFriends_onBlackFriendBtnClick()
    local allItemNum = 1
    if m_myBlackFriendDataList then
        allItemNum = #m_myBlackFriendDataList + 1
    end
    m_nowOpenPageType = 3
    setDataToNewFriendWnd(3,allItemNum)
end

local function updateFriendDataToWnd(tag)
    local pDragNode = nil
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("4301-1"));
    if pMultiPage then
        local pNode = pMultiPage:getPageWithIndex(0);
        if pNode then
            pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1))
        end
    end
    if not pDragNode then
        return
    end
    local pTableBox = SCTypeCast:castNodeToTableBox(pDragNode:getChildByTag(2))
    if pTableBox then
        local nodeTag = tag+2
        local pageNum = math.modf(nodeTag/10)
        local pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent(pageNum, pTableBox))
        for i = nodeTag,(#m_myFriendDataList + 3) do
            if i%10 == 0 and 9 < i then
                pageNum = i/10
                pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent(pageNum, pTableBox))
            end
            itemTag = i - pageNum * 10
            local tableCell = nil
            if pTable then
                tableCell = pTable:getChildByTag(itemTag)
            end
            if tableCell then
                local childNode = SCTypeCast:castNodeToDragNode(tableCell:getChildByTag(1));
                if childNode then
                    local dragNode = SCTypeCast:castNodeToDragNode(childNode:getChildByTag(1));
                    if dragNode then
                        childNode:removeChildByTag(1,true)
                    end
                    dragNode = SCTypeCast:castNodeToDragNode(childNode:getChildByTag(1));
                    if not dragNode then
                        dragNode = newTheFriendsNode(1,i-2)
                        if dragNode then
                            dragNode:setTag(1);
                            dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                            dragNode:setPosition(CCPointMake(childNode:getContentSize().width/2, childNode:getContentSize().height/2));
                            childNode:addChild(dragNode);
                        end
                    end
                end 
            end
        end
    end
end
----------------消息处理区----------------
local function recNewFriendData()
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    if not dt then
        return
    end
    local action = dt:readShort();
    if action == MSG_FRIEND_GETINFO then
        local ucAmount = dt:readByte();
        if not m_myFriendDataList then
            m_myFriendDataList = {}
        end
        for i = 1,ucAmount do
            friendSequence(m_myFriendDataList,stFriendOrEnemyInfo.initWithStream(dt))
        end
    elseif action == MSG_TEMP_FRIEND_GETINFO or action == MSG_TEMP_FRIEND_UPDATE_INFO then
        local ucAmount = dt:readByte();
        if not m_myTempFriendDataList then
            m_myTempFriendDataList = {}
        end
        for i = 1,ucAmount do
            friendSequence(m_myTempFriendDataList,stFriendOrEnemyInfo.initWithStream(dt))
        end
    elseif action == MSG_BLACKNAME_GETINFO then
        local ucAmount = dt:readByte();
        if not m_myBlackFriendDataList then
            m_myBlackFriendDataList = {}
        end
        if 1 == ucAmount then
            m_blackFriendFlg = true
        end
        for i = 1,ucAmount do
            friendSequence(m_myBlackFriendDataList,stFriendOrEnemyInfo.initWithStream(dt))
        end
        m_blackFriendFlg = false
        if m_nowOpenPageType then
            if 4 == m_nowOpenPageType and m_aroundUserDataList then
                for i = 1, #m_aroundUserDataList do
                    if  m_aroundUserDataList[i] and m_newAddBlackFriendId and m_newAddBlackFriendId ==  m_aroundUserDataList[i].idUser then 
                        table.remove(m_aroundUserDataList, i)
                        setDataToNewFriendsFindFriendsWnd()
                        break
                    end
                end 
            elseif 2 == m_nowOpenPageType and m_myTempFriendDataList then
                for i = 1, #m_myTempFriendDataList do
                    if  m_myTempFriendDataList[i] and m_newAddBlackFriendId and m_newAddBlackFriendId ==  m_myTempFriendDataList[i].idUser then 
                        table.remove(m_myTempFriendDataList, i)
                        NewFriends_setDataToNewTempFriendsWnd()
                        break
                    end
                end 
            end
        end
    elseif action == MSG_FRIEND_UPDATE_INFO then
        local ucAmount = dt:readByte();
        if not m_myFriendDataList then
            m_myFriendDataList = {}
        end
        for i = 1,ucAmount do
            friendSequence(m_myFriendDataList,stFriendOrEnemyInfo.initWithStream(dt))
        end
    elseif action == MSG_FRIEND_DEL then
        local count =  table.getn(m_myFriendDataList);
        local id = dt:readInt();
        local name = dt:readString();
        for i = 1, count do
            if  m_myFriendDataList[i] and id ==  m_myFriendDataList[i].idUser then 
                table.remove(m_myFriendDataList, i)
                if m_nowOpenPageType then
                    if 1 == m_nowOpenPageType and m_myFriendDataList then
                        updateFriendDataToWnd(i)
                    end
                end
            end
        end 
    elseif action == MSG_TEMP_FRIEND_DEL then
        local count =  table.getn(m_myTempFriendDataList);
        local id = dt:readInt();
        local name = dt:readString();
        for i = 1, count do
            if m_myTempFriendDataList[i] and id ==  m_myTempFriendDataList[i].idUser then 
                table.remove(m_myTempFriendDataList, i)
                if 2 == m_nowOpenPageType then
                    NewFriends_setDataToNewTempFriendsWnd()
                end
            end
        end 
    elseif action == MSG_FRIEND_DEL_BLACKNAME then
        local count =  table.getn(m_myBlackFriendDataList);
        local id = dt:readInt();
        local name = dt:readString();
        for i = 1, count do
            if  m_myBlackFriendDataList[i] and id ==  m_myBlackFriendDataList[i].idUser then 
                table.remove(m_myBlackFriendDataList, i)
                if 3 == m_nowOpenPageType then
                    NewFriends_onBlackFriendBtnClick()
                end
                break
            end
        end 
        
    elseif action == MSG_AROUND_USER then
        NewFriends_setFindFriendsData(dt)
    end
end

local function onClickTalkFriend(tag)
    local pDragNode = SCFunction:getUiNodeByIdlist("9000-13");
    if pDragNode then
        setNodeContentSize(pDragNode, CCSizeMake(246, 47));
        for i = 1, 3 do
            local pNode = pDragNode:getChildByTag(i);
            if pNode then
                pNode:setVisible(false);
            end
        end
    end
end
local function joinInTeam(tag, itemTag, itemIndex)
    local pWnd = SCFunction:getUiNodeByIdlist("9000");
    if pWnd then
        LuaReCall:getSingleton():setText(m_myFriendDataList[itemIndex + 1].szName);
        local lookFace = 311004;
        if 1 == m_myFriendDataList[itemIndex + 1].dwLookFace then
            lookFace = 311004;
        elseif 3 == m_myFriendDataList[itemIndex + 1].dwLookFace then
            lookFace = 311001;
        elseif 2 == m_myFriendDataList[itemIndex + 1].dwLookFace then
            lookFace = 311003;
        elseif 4 == m_myFriendDataList[itemIndex + 1].dwLookFace then
            lookFace = 311002;
        end
        ChatProcessor:getSingleton():addHearInfo(lookFace, m_myFriendDataList[itemIndex + 1].szName, m_myFriendDataList[itemIndex + 1].dwData1, 2);
        pWnd:removeChildByTag(1000, true);
    end
    local pEdit = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("9000-13-15-17"));
    if pEdit then
        pEdit:setContentText(m_myFriendDataList[itemIndex + 1].szName);
        onClickTalkFriend(0);
    end
end
----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(recNewFriendData, _MSG_FRIEND, 0, nil)
----------------全局函数区----------------
function NewFriends_showNewFriendsWnd()
    local wndCtrl = getCurentSceneWindowController(4301)
    if wndCtrl then
        return
    end
    local wnd = NewFriends.initControl()
    if wnd then
        wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
        end
        local titlefile = getRealUIResourcePath("img/new00334.png")
        if titlefile then
            wnd:setTitleWithImage(titlefile:getData())
        end
        local pMultiPage = SCTypeCast:castNodeToMultiPage(wnd:getChildByTag(1))
        if pMultiPage then
            pMultiPage:luaSetSelectorOnPageSelected(NewFriends_multiTabAction)
            local pNode = pMultiPage:getPageWithIndex(0);
            if pNode then
                local pDragNode = NewFriends1.initControl();
                if pDragNode then
                    pNode:addChild(pDragNode)
                    NewFriends_setDataToNewFriendsWnd()
                    local pBtn = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(5))
                    if pBtn then
                        pBtn:luaSetSelectorOnClicked(NewFriends_onBlackFriendBtnClick)
                    end
                end     
            end
        end
        local pImg = SCTypeCast:castNodeToImage(wnd:getChildByTag(2))
        if pImg then
            pImg:setVisible(false)
            if m_MailScreenNum and 0 < m_MailScreenNum then
                local pLabel = SCTypeCast:castNodeToLabel(pImg:getChildByTag(3))
                if pLabel then
                    pLabel:setText(m_MailScreenNum)
                    pImg:setVisible(true)
                end
            end
        end
    end
end

--聊天好友列表
function chatTalkToFriend()
    local pFrameWindow = FrameWindow:frameWnd();
    local size = CCSizeMake(0, 0)
    local pWnd = SCFunction:getUiNodeByIdlist("9000");
    if pFrameWindow and pWnd then
        size = pWnd:getContentSize();
        pFrameWindow:setAnchorPoint(CCPointMake(0.5, 0.5));
        pFrameWindow:setPosition(CCPointMake(size.width / 2, size.height / 2 - 10 * gUIScale().y));
        --wnd:luaSetReturnSelector(onWndEnd);
        pFrameWindow:setTag(1000);
        pWnd:addChild(pFrameWindow);
    end
    --local pDragNode = SCFunction:getUiNodeByIdlist("9000-13");
    local pDragNode = pFrameWindow;
    if pDragNode then
        setNodeContentSize(pDragNode, CCSizeMake(226, 222));
        pDragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
        pDragNode:setPosition(CCPointMake(size.width / 2 + 20* gUIScale().x, size.height / 2 - 10 * gUIScale().y));
        local pLabel = SCTypeCast:castNodeToLabel(pDragNode:getChildByTag(1));
        if pLabel == nil then
            pLabel = SCLabel:labelWithStringFont(_LTParser("str0081"), getDefaultFontName(), getFontSize(15));
            if pLabel then
                pLabel:setAnchorPoint(CCPointMake(0.5, 1));
                pLabel:setPosition(CCPointMake(pDragNode:getContentSize().width / 2 - 10 * gUIScale().x, pDragNode:getContentSize().height - 20 * gUIScale().y));
                pDragNode:addChild(pLabel);
                pLabel:setTag(1);
            end
        else
            pLabel:setVisible(true);
        end
        --[[local pBtn = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(2));
        if nil == pBtn then
            pBtn = SCButton:button();
            if pBtn then
                local strPath = getRealUIResourcePath("img/Btn2110.png");
                if strPath then
                    pBtn:setBackgroundImage(strPath:getData());
                end
                strPath = getRealUIResourcePath("img/Btn2111.png");
                if strPath then
                    pBtn:setSelectedImage(strPath:getData());
                end
                pBtn:luaSetSelectorOnClicked(onClickTalkFriend);
                pBtn:setAnchorPoint(CCPointMake(1, 1));
                pBtn:setPosition(CCPointMake(pDragNode:getContentSize().width - 20 * gUIScale().x, pDragNode:getContentSize().height - 20 * gUIScale().y));
                pDragNode:addChild(pBtn);
                pBtn:setTag(2);
            end
        else
            pBtn:setVisible(true);
        end]]
        local pListBox = SCTypeCast:castNodeToListBox(pDragNode:getChildByTag(3));
        if nil == pListBox then
            pListBox = SCListBox:boxWithWidthHeight(210 * gUIScale().x, 167 * gUIScale().y);
            if pListBox then
                pListBox:setPosition(CCPointMake(10 * gUIScale().x, 15 * gUIScale().y));
                pDragNode:addChild(pListBox);
                --pListBox:setBackgroundColor(colorRed())
                pListBox:setTag(3);
                pListBox:luaSetSelectorOnItemSelected(joinInTeam)
             else
                return;
            end
        else
            pListBox:setVisible(true);
        end
        pListBox:removeAllItems();
        for i = 1, #m_myFriendDataList do
            local pNode = SCDragNode:node();
            if pNode then
                setNodeContentSize(pNode, CCSizeMake(206, 27));
                pNode:setFrameVisibled(true);
                pNode:setFrameType(EnumFrameTypeListNormal);
                pLabel = SCLabel:labelWithStringFont(m_myFriendDataList[i].szName, getDefaultFontName(), getFontSize(12));
                if pLabel then
                    setNodePostion(pLabel, CCPointMake(5, 5));
                    pNode:addChild(pLabel);
                end
                pLabel = SCLabel:labelWithStringFont(m_myFriendDataList[i].dwData1 .. _LTParser("str0266"), getDefaultFontName(), getFontSize(12));
                if pLabel then
                    setNodePostion(pLabel, CCPointMake(120, 5));
                    pNode:addChild(pLabel);
                end
                pLabel = SCLabel:labelWithStringFont(m_myFriendDataList[i].szPro, getDefaultFontName(), getFontSize(12));
                if pLabel then
                    setNodePostion(pLabel, CCPointMake(170, 5));
                    pNode:addChild(pLabel);
                end
                pListBox:addItem(pNode);
            end
        end
    end
end

--
function NewFriend_InviteList(pListBox)
    if pListBox then        
        for i = 1, #m_myFriendDataList do   
            if 1 == m_myFriendDataList[i].ucOnlineFlag then          
                local pChildNode = BattleTeam6.initControl();
                if pChildNode then
                    local pLabel = SCTypeCast:castNodeToLabel(pChildNode:getChildByTag(2));
                    if pLabel then  
                        pLabel:setText(m_myFriendDataList[i].szName);
                    end
                    pLabel = SCTypeCast:castNodeToLabel(pChildNode:getChildByTag(3));
                    if pLabel then
                        pLabel:setText(m_myFriendDataList[i].dwData1);
                    end
                    local pBtn = SCTypeCast:castNodeToButton(pChildNode:getChildByTag(4));
                    if pBtn then
                        pBtn:setTag(m_myFriendDataList[i].idUser);
                        pBtn:luaSetSelectorOnClicked(BattleTeam5.onBtnInvite);
                    end
                    pListBox:addItem(pChildNode);
                end
            end
        end
    end
end

--邮件打开好友标记
function NewFriends_MailOpenNewFriendsWnd()
    m_MailOpenFriendFlg = true
    NewFriends_showNewFriendsWnd()
end
--周围玩家数据
function NewFriends_setFindFriendsData(dt)
    SCActivityIndicator:getSingleton():close();
    if not dt then
        return
    end
    
    m_aroundUserDataList = {}

    local ucAmount = dt:readByte()
    m_aroundUserNumber = ucAmount
    for i=1,ucAmount do
        table.insert(m_aroundUserDataList,tMSG_AROUND_USER_DATA.initWithStream(dt))
    end
    local wndCtrl = getCurentSceneWindowController(4301)
    if not wndCtrl then
        --BattleTeam5.showInviteFriendsWnd()
        return
    end
    setDataToNewFriendsFindFriendsWnd()
end
function NewFriends_onFindFriendBtnClick()
    onFindFriendBtnClick()
end

--获取黑名单
function NewFriends_getBlackUserDataList()
    return m_myBlackFriendDataList
end

--获取好友列表数据
function NewFriend_getFriendData()
	return m_myFriendDataList
end
--设置未读邮件数量
function NewFriend_setMailScreenNum(data)
    m_MailScreenNum = data
    if m_MailScreenNum > 0 then
		setLightEfficiency(UNLOCK_TYPE_MAIL, true)
	else
		setLightEfficiency(UNLOCK_TYPE_MAIL, false)
    end
end 
--获取未读邮件数量
function NewFriend_getMailScreenNum()
    return m_MailScreenNum
end

function NewFriends.wndClose()
    m_aroundUserDataList = nil
    m_aroundUserNumber = nil
    m_nowOpenPageType = nil
    m_blackFriendFlg = nil
    m_newAddBlackFriendId = nil
    m_MailOpenFriendFlg = nil
end

function NewFriends_clearData()
    m_myFriendDataList = nil 
    m_myTempFriendDataList = nil 
    m_myBlackFriendDataList = nil
    m_MailScreenNum = nil
end
--函数调用