--成就与称号，地图开启提示8006窗口
local m_titleImageId = nil
local m_titleNameStr = nil
local m_titleDetailStr = nil
local m_titleType = nil

local m_entryId = nil

local m_isShow = nil--显示缓存用

local function remove_NewMapOpenTip()
    m_titleImageId = nil
    m_titleNameStr = nil
    m_titleDetailStr = nil
    m_isShow = nil
    m_titleType = nil
    if m_entryId then--关闭定时器
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
        m_entryId = nil
    end
end

--时间到关闭
local function updateTime()
    remove_NewMapOpenTip()--清除数据
    
    local scene = SCBaseScene:getRunningScene()
    if scene then
        local frameWndNode = scene:getUINode():getChildByTag(8006)
        if frameWndNode then
            scene:getUINode():removeChildByTag(8006,true)--窗口移除
        end
    end
end

--倒计时
local function startScheduler()
     m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(updateTime, 1.7, false)--启动定时器
end

--初始化界面
local function init_NewMapOpenTip()
    local imgFile = getRealUIResourcePath("img/img2067.png");
    if imgFile == nil then
        return
    end
    local backImg = SCImage:imageWithFile(imgFile:getData())--背景图片
    if backImg == nil then
        return
    end
    local window_Width  = getScreenWidth()--当前屏幕宽
    local window_Height = getScreenHeight()--当前屏幕高
    
    local show_Width  = backImg:getContentSize().width
	local show_Height = backImg:getContentSize().height
	local startX = (window_Width-show_Width)/2
	local startY = SY(50)
	
    local frameWndNode = FrameWindow:frameWnd()
    frameWndNode:setTag(8006)
    frameWndNode:setOutSpaceClickClose(false)--设置点击空白不响应
	frameWndNode:setContentSize(CCSizeMake(show_Width, show_Height))
	frameWndNode:setAnchorPoint(CCPointMake(0, 0))
	frameWndNode:setPosition(CCPointMake(startX,startY))
	frameWndNode:setFrameVisibled(false)--去除边框
    frameWndNode:setCloseBtnVisible(false)--去除按钮
	
	local pnode = ActionNode:newActionNode();
	if pnode == nil then
	    return
    end
    pnode:setContentSize(backImg:getContentSize());
    pnode:setAnchorPoint(CCPointMake(0.5, 0.5))
    pnode:setPosition(CCPointMake(show_Width/2,show_Height/2))
     ---先缩小
    pnode:setScaleX(0.1);
    pnode:setScaleY(0.1);
    ---放大
    pnode:scale(10, 10, 0.3, true);--0.3秒后还原
    pnode:luaSetSelectorOnScaleEnd(startScheduler);--设置回调
    
    pnode:addChild(backImg)
    frameWndNode:addChild(pnode)
    
	local spaceH = SY(20)--头部间隔
	local titleImg = nil
	local faDir = "img/"
	if m_titleType == 2 then
		faDir = "Skill/"
	end
	if m_titleImageId == nil then
	    m_titleImageId = 0
    end
    local imgFile = getRealUIResourcePath(faDir..m_titleImageId..".png");
    if imgFile then
        titleImg = SCImage:imageWithFile(imgFile:getData())  
    end
    if titleImg then--标题图片
        titleImg:setVisible(true)
        titleImg:setAnchorPoint(CCPointMake(0,0));
        titleImg:setPosition(CCPointMake(SX(10),show_Height-titleImg:getContentSize().height-spaceH));
        pnode:addChild(titleImg)
    end
    
    if m_titleNameStr then--标题
        local titleNameLabel = SCLabel:labelWithStringFont(m_titleNameStr,getDefaultFontName(), getFontSize(12))
        titleNameLabel:setAnchorPoint(CCPointMake(0,0));
        titleNameLabel:setPosition(CCPointMake(show_Width*0.3,show_Height-titleNameLabel:getContentSize().height-spaceH));
        titleNameLabel:setColor(getColorBrown())
        pnode:addChild(titleNameLabel)
    end
    
    if m_titleDetailStr then--描述
        local titleDetailLabel = SCText:textWithWidthFont(show_Width*0.63,getDefaultFontName(), getFontSize(10));
        titleDetailLabel:setAnchorPoint(CCPointMake(0,0));
        titleDetailLabel:setPosition(CCPointMake(show_Width*0.3,show_Height/2-SY(5)));
        titleDetailLabel:addNormalText(m_titleDetailStr,getColorBrown())
        pnode:addChild(titleDetailLabel)
    end
    

    local scene = SCBaseScene:getRunningScene()
    if scene then
        scene:getUINode():addChild(frameWndNode, Max_Int)
    end
end

--界面打开入口，获取数据
function open_NewMapOpenTip()
    local dt = LuaData:getSingleton():getDataTransStream();
    if dt then
        local imageId     = dt:readInt()--//图片id
        local titleName   = dt:readString()--//提示  
        local titleDetail = dt:readString()--//提示描述
        m_titleType		  = dt:readByte()
        
        m_titleImageId = imageId
        if titleName then
            m_titleNameStr = titleName:getData()
        else
            m_titleNameStr = nil
        end
        
        if titleDetail then
            m_titleDetailStr = titleDetail:getData()
        else
            m_titleDetailStr = nil
        end
        
    else
        return
    end
    
    local scene = SCBaseScene:getRunningScene()
    if scene == nil then
        return
    end
    local frameWndNode = scene:getUINode():getChildByTag(8006)
    if frameWndNode then
        return
    end  
    --if BattleProcessor:getSingleton():getIsInBattle() then--战斗中
    --    m_isShow = true--做缓存处理
    --else
    --    m_isShow = false
    --    init_NewMapOpenTip()
   -- end  
end

--外部调用，
function show_NewMapOpenTip()
    if m_isShow == true then--显示缓存
        init_NewMapOpenTip()
    end
end
function getNewMapOpenType()
	return m_titleType
end
LuaData:getSingleton():luaSetSelectorOnRecvData(open_NewMapOpenTip, LuaData_USERINFO_MAP_OPEN);