local EUDEMONSHOW_EUDEMONINFO_LIST        = 61;
local EUDEMONSHOW_CHANGEJOB_LIST        = 62;
local EUDEMONSHOW_CHANGEJOB_INFO        = 63;
local EUDEMONSHOW_CHANGEJOB                = 64;

local canChangeEudemonId = nil;
local changeJobList = nil;
local needReputation = nil;
local changeJobInfo = nil;
local m_nowChangId = nil

local function ctrlEvent(tag, eventType)
    if eventType == LuaControllerEventPushEnded then
		if m_nowChangId == Hero:getSingleton():getID() then
			setRestartGuideFlag(GUIDE_TYPE_CHANGEJOB, true)
			showGuideStep(GUIDE_TYPE_CHANGEJOB, 5, 4)
		else
			endGuideWnd()
		end
	elseif eventType == LuaControllerEventPopBegan then
		setRestartGuideFlag(GUIDE_TYPE_CHANGEJOB, true)
		showGuideStep(GUIDE_TYPE_CHANGEJOB, 4, 3)
    end
end

local function ctrlEvent1(tag, eventType)
    if eventType == LuaControllerEventPushEnded then
		setRestartGuideFlag(GUIDE_TYPE_CHANGEJOB, true)
		showGuideStep(GUIDE_TYPE_CHANGEJOB, 4, 3)
	elseif eventType == LuaControllerEventPopBegan then
		if getRestartGuideFlag(GUIDE_TYPE_CHANGEJOB) then
			restartBeginnerGuide(GUIDE_TYPE_CHANGEJOB)
		else
			showGuideStep(GUIDE_TYPE_CHANGEJOB, -1)
		end
    end
end

local function ctrlEvent2(tag, eventType)
    if eventType == LuaControllerEventPushEnded then
		setRestartGuideFlag(GUIDE_TYPE_CHANGEJOB, false)
        endGuideWnd()
    end
end

local function ctrlEvent3(tag, eventType)
    if eventType == LuaControllerEventPushEnded then
		if m_nowChangId == Hero:getSingleton():getID() then
			setRestartGuideFlag(GUIDE_TYPE_CHANGEJOB, true)
			showGuideStep(GUIDE_TYPE_CHANGEJOB, 6, 5)
		else
			endGuideWnd()
		end
	elseif eventType == LuaControllerEventPopBegan then
		setRestartGuideFlag(GUIDE_TYPE_CHANGEJOB, true)
		showGuideStep(GUIDE_TYPE_CHANGEJOB, 4, 3)
    end
end

local function onClickClose()
    canChangeEudemonId = nil;
    changeJobList = nil;
    changeJobInfo = nil;
    m_nowChangId = nil
end

local function onClickChangeJob(tag)
    SCActivityIndicator:getSingleton():show()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_EUDEMONINFO);
    dataStream:writeShort(EUDEMONSHOW_CHANGEJOB_LIST);
    dataStream:writeInt(tag);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function makeEndemonNode(roleId, name, level, lookFace, canChange)
    local dragNode = SCDragNode:node();
    setNodeContentSize(dragNode, CCSizeMake(100, 210))
    --dragNode:setContentSize(CCSizeMake(100, 210));
    dragNode:setFrameType(EnumFrameTypeRound);
    dragNode:setFrameVisibled(true);
    dragNode:setDragEnabled(false);
    
    local bigBtn = SCButton:button();
    bigBtn:setTag(roleId);
    setNodeContentSize(bigBtn, getNodeContentSize(dragNode))
    --bigBtn:setContentSize(dragNode:getContentSize());
    bigBtn:luaSetSelectorOnClicked(onClickChangeJob);
    dragNode:addChild(bigBtn);
    
    local nameLabel = SCLabel:labelWithStringFont(name:getData(), getDefaultFontName(), getFontSize(12));
    nameLabel:setAnchorPoint(CCPointMake(0.5, 0.5));
    setNodePostion(nameLabel, CCPointMake(getNodeContentSize(bigBtn).width/2, 195-getNodeContentSize(nameLabel).height/2))
    --nameLabel:setPosition(CCPointMake(bigBtn:getContentSize().width/2, 195-nameLabel:getContentSize().height/2));
    bigBtn:addChild(nameLabel);
    
    local levelLabel = SCLabel:labelWithStringFont(level.._LTParser("level"), getDefaultFontName(), getFontSize(12));
    levelLabel:setAnchorPoint(CCPointMake(0.5, 0.5));
    setNodePostion(levelLabel, CCPointMake(getNodeContentSize(bigBtn).width/2, 185-getNodeContentSize(nameLabel).height/2-getNodeContentSize(levelLabel).height/2))
    --levelLabel:setPosition(CCPointMake(bigBtn:getContentSize().width/2, 185-nameLabel:getContentSize().height/2-levelLabel:getContentSize().height/2));
    bigBtn:addChild(levelLabel);
    
    local height = 200-getNodeContentSize(nameLabel).height/2-getNodeContentSize(levelLabel).height/2;
    
    local imgpath = getRealUIResourcePath("img/img2548.png")
    local ani = LookfaceParser:getSingleton():getAnimationByLookFaceAndIndex(lookFace)
    if ani and imgpath then
		ani:setFrameAnchor(EnumFrameAnchorCenter)
        local lookBGimg = SCImage:imageWithFile(imgpath:getData())
        local aniNode = SCAnimationNode:nodeWithAnimation(ani)
        aniNode:setAnchorPoint(CCPointMake(0.5, 0.5))
        setNodePostion(aniNode, CCPointMake(getNodeContentSize(lookBGimg).width/2, getNodeContentSize(lookBGimg).height/2+getNodeContentSize(aniNode).height/2-65))
        --aniNode:setPosition(CCPointMake(lookBGimg:getContentSize().width/2, lookBGimg:getContentSize().height/2+aniNode:getContentSize().height/2-5))
        lookBGimg:addChild(aniNode)
        lookBGimg:setAnchorPoint(CCPointMake(0.5, 0.5))
        setNodePostion(lookBGimg, CCPointMake(getNodeContentSize(bigBtn).width/2, height-120))
        --lookBGimg:setPosition(CCPointMake(bigBtn:getContentSize().width/2, height-120))
        bigBtn:addChild(lookBGimg)
    end
    
    if canChange==true then
        local btn = SCButton:button(EnumBtnType9Atlas);
        setNodeContentSize(btn, SmallButton_Size)
        --btn:setContentSize(SmallButton_Size)
        btn:setTag(roleId);
        btn:luaSetSelectorOnClicked(onClickChangeJob);
        btn:setTitle(_LTParser("change job"), getDefaultFontName(), gDefaultFontSize);
        btn:setAnchorPoint(CCPointMake(0.5, 0.5));
        setNodePostion(btn, CCPointMake(getNodeContentSize(bigBtn).width/2, 10+getNodeContentSize(btn).height/2))
        --btn:setPosition(CCPointMake(bigBtn:getContentSize().width/2, 10+btn:getContentSize().height/2));
        bigBtn:addChild(btn);
    end
    
    return dragNode;
end

local function canChange(id)
    for i=1, table.getn(canChangeEudemonId) do
        if id == canChangeEudemonId[i] then
            return true;
        end
    end
    return false;
end

local function showEndemonList()
    local wnd = nil
    local wndCtrl = getCurentSceneWindowController(5901);
    if wndCtrl == nil then
        wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5901))
        wnd:luaSetSelectorOnClose(onClickClose);
        wnd:setBackgroundColor(colorWindowRedBG());
        --wnd:setTitle(_LTParser("partner change job"), getDefaultFontName(), gDefaultFontSize);
        local imgPath = getRealUIResourcePath("img/titile34.png")
        if imgPath then
            wnd:setTitleWithImage(imgPath:getData());
        end
        local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
        dragNode:setFrameType(EnumFrameTypeListNormal);
        dragNode:setFrameVisibled(true);
        dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(wnd, "SCNode")));
        dragNode:setFrameType(EnumFrameTypeListNormal);
        dragNode:setFrameVisibled(true);
        local naviCtrl =  getCurentSceneNavigationController();
        wndCtrl = SCWindowController:controllerWithWindow(wnd);
        wndCtrl:luaSetSelectorOnEvent(ctrlEvent1)
        naviCtrl:pushWindowController(wndCtrl);
    else
        wnd = wndCtrl:getWindow()
    end    
    local prestige = Hero:getSingleton():getHeroInfo().nReputation;
    local money = Hero:getSingleton():getHeroInfo().dwMoney;
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
    label:setText(_LTParser("prestige")..prestige);
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("6", tolua.cast(wnd, "SCNode")));
    label:setText(_LTParser("money")..money);
    
    local pageScrollBox = tolua.cast(wnd:getChildByTag(10), "SCPageScrollBox")
    if not pageScrollBox then
        pageScrollBox = SCPageScrollBox:boxWithWidthHeight(460*gUIScale().x, 250*gUIScale().y);
        tolua.cast(pageScrollBox, "SCNode"):setTag(10)
        pageScrollBox:setPageSize(CCSizeMake(460*gUIScale().x, 250*gUIScale().y));
        setNodeContentSize(pageScrollBox, CCSizeMake(460, 250))
        --pageScrollBox:setContentSize(CCSizeMake(460, 250));
        pageScrollBox:setAnchorPoint(CCPointMake(0.5, 0.5));
        setNodePostion(pageScrollBox, CCPointMake(240, 130))
        --tolua.cast(pageScrollBox, "SCNode"):setPosition(CCPointMake(240, 130));
        pageScrollBox:setScrollVertical(false);
        wnd:addChild(tolua.cast(pageScrollBox, "SCNode"));
        local pageHint = SCPageHint:hintWithType(EnumPgaeHintTypeHorizontal)
        pageHint:setAnchorPoint(CCPointMake(0.5, 0.5))
        setNodePostion(pageHint, CCPointMake(240, 30))
        --pageHint:setPosition(CCPointMake(240, 30))
        pageHint:setBoundPageScrollBox(pageScrollBox)
        wnd:addChild(pageHint)
    end
    
    pageScrollBox:removeAllChildrenWithCleanup(true)
    
    local pageNode = pageScrollBox:getChildByTag(11)
    if not pageNode then
        pageNode = SCNode:node()
        pageNode:setTag(11)
        setNodeContentSize(pageNode, CCSizeMake(460, 250))
        --pageNode:setContentSize(CCSizeMake(460, 250))
        pageScrollBox:addChild(pageNode)
    end

    local nPx = 10;
    local pageCount = 0;
    local page = 1;
    local nodeTag = 1
    local heroInfo = Hero:getSingleton():getHeroInfo();
    if heroInfo ~= nil then
        local node = pageNode:getChildByTag(nodeTag)
        if not node then
            node = makeEndemonNode(heroInfo.nID, heroInfo.strName, heroInfo.ucLevel, heroInfo.dwLookFace, canChange(heroInfo.nID));
            --node:setPosition(CCPointMake(nPx, 40));
            setNodePostion(node, CCPointMake(nPx, 40))
            node:setTag(nodeTag)
            pageNode:addChild(node);
        else
            if m_nowChangId ~= nil then
                if m_nowChangId == heroInfo.nID then
                    pageNode:removeChildByTag(nodeTag, true)
                    node = makeEndemonNode(heroInfo.nID, heroInfo.strName, heroInfo.ucLevel, heroInfo.dwLookFace, canChange(heroInfo.nID));
                    setNodePostion(node, CCPointMake(nPx, 40))
                    node:setTag(nodeTag)
                    pageNode:addChild(node);
                end
            end
        end
        nodeTag = nodeTag + 1
        nPx = nPx + 112;
        pageCount = pageCount + 1;
    end
    
    local subTmp = 1
    local pSize = Hero:getSingleton():partnerSize();
    for i=1, pSize do
        local pInfo = Hero:getSingleton():getPartnerWithPos(i-subTmp);
        if pInfo ~= nil then
            if pageCount == 4 then
                page = page + 1;
                pageScrollBox:setContentSize(CCSizeMake(SX(460)*page, SY(250)));
                pageNode = pageScrollBox:getChildByTag(10+page)
                if not pageNode then
                    pageNode = SCNode:node();
                    pageNode:setTag(10+page)
                    setNodeContentSize(pageNode, CCSizeMake(460, 250))
                    setNodePostion(pageNode, CCPointMake(460*(page-1), 0))
                    --pageNode:setContentSize(CCSizeMake(460, 250));
                    --pageNode:setPosition(CCPointMake(460*(page-1), 0));
                    pageScrollBox:addChild(pageNode);    
                end
                nPx = 10;
                pageCount = 0;
            end
            local node = pageNode:getChildByTag(nodeTag)
            if not node then
                node = makeEndemonNode(pInfo.nID, pInfo.strName, pInfo.usLevel, pInfo.dwLookFace, canChange(pInfo.nID));
                setNodePostion(node, CCPointMake(nPx, 40))
                node:setTag(nodeTag)
                pageNode:addChild(node);
            else
                if m_nowChangId ~= nil then
                    if getIntPart(m_nowChangId/100) == getIntPart(pInfo.nID/100) then
                        pageNode:removeChildByTag(nodeTag, true)
                        node = makeEndemonNode(pInfo.nID, pInfo.strName, pInfo.usLevel, pInfo.dwLookFace, canChange(pInfo.nID));
                        setNodePostion(node, CCPointMake(nPx, 40))
                        node:setTag(nodeTag)
                        pageNode:addChild(node);
                        --subTmp = 2
                    end
                end
            end
            nodeTag = nodeTag + 1
            nPx = nPx + 112;
            pageCount = pageCount + 1;
        end
    end
end

local function recvEudemonListData()
    local dt = LuaData:getSingleton():getDataTransStream();
    canChangeEudemonId = {__mode="kv"};
    local ucEudNum = dt:readByte();
    for i=1, ucEudNum do
        canChangeEudemonId[i] = dt:readInt();
    end
    showEndemonList();
end

local function sendChangeJobMsg(id, type, idType)
    SCActivityIndicator:getSingleton():show()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_EUDEMONINFO);
    dataStream:writeShort(EUDEMONSHOW_CHANGEJOB_INFO);
    dataStream:writeInt(id);
    dataStream:writeByte(type);
    dataStream:writeInt(idType);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function onClickChangeJob1(tag)
    sendChangeJobMsg(m_nowChangId, 0, tag);
end

local function makeChangeJobListNode(oneChangeJobList, oldChangeJobList, endflag)
    local dragNode = SCDragNode:node();
    setNodeContentSize(dragNode, CCSizeMake(145, 240))
    --dragNode:setContentSize(CCSizeMake(145, 240));
    dragNode:setFrameType(EnumFrameTypeRound);
    dragNode:setFrameVisibled(true);
    dragNode:setDragEnabled(false);
    --local file = getFaceImagePath(oneChangeJobList["lookFace"])
    --local img = SCImage:imageWithFile(file:getData());
    local file = getRealUIResourcePath("img/new00002.png");
    local img = SCImage:imageWithFile(file:getData());
    img:setAnchorPoint(CCPointMake(0, 1));
    setNodePostion(img, CCPointMake(10, getNodeContentSize(dragNode).height-15))
    --img:setPosition(CCPointMake(10, dragNode:getContentSize().height-15));
    dragNode:addChild(img);
    
    local imgNode = getFaceImg(oneChangeJobList["facePhoto"])
    if imgNode then
        imgNode:setAnchorPoint(CCPointMake(0.5, 0.5))
        setNodePostion(imgNode, CCPointMake(getNodeContentSize(img).width/2, getNodeContentSize(img).height/2))
        img:addChild(imgNode)
    end
    
    local text = "*9"..oneChangeJobList["name"].."_"
    text = text.."*9"..oneChangeJobList["profession"].."_";
    text = text.."*9"..oneChangeJobList["skillName"].."_";
    local parserNode = ParsedNode:getParsedNode(text, 0);
    setNodePostion(parserNode, CCPointMake(15+getNodeContentSize(img).width, getNodeContentSize(dragNode).height-15-getNodeContentSize(img).height))
    dragNode:addChild(parserNode);

    
    local text = ""
    if oldChangeJobList ~= nil and oneChangeJobList["canChange"] ~= 2 then
        text = text.."*9".._LTParser("hp").."*0"..oldChangeJobList["hp"].." *3";
        if oneChangeJobList["hp"]-oldChangeJobList["hp"] > 0 then 
            text = text.."+";
        end
        if oneChangeJobList["hp"]-oldChangeJobList["hp"] ~= 0 then 
            text = text..oneChangeJobList["hp"]-oldChangeJobList["hp"];
        end
        text = text.."_"
        text = text.."*9".._LTParser("force").."*0"..oldChangeJobList["atk"].." *3";
        if oneChangeJobList["atk"]-oldChangeJobList["atk"] > 0 then
            text = text.."+";
        end
        if oneChangeJobList["atk"]-oldChangeJobList["atk"] ~= 0 then
            text = text..oneChangeJobList["atk"]-oldChangeJobList["atk"];
        end
        text = text.."_"
        text = text.."*9".._LTParser("stunt").."*0"..oldChangeJobList["skillAtk"].." *3";
        if oneChangeJobList["skillAtk"]-oldChangeJobList["skillAtk"] > 0 then
            text = text.."+";
        end
        if oneChangeJobList["skillAtk"]-oldChangeJobList["skillAtk"] ~= 0 then
            text = text..oneChangeJobList["skillAtk"]-oldChangeJobList["skillAtk"];
        end
        text = text.."_"
        text = text.."*9".._LTParser("spell").."*0"..oldChangeJobList["magAtk"].." *3";
        if oneChangeJobList["magAtk"]-oldChangeJobList["magAtk"] > 0 then
            text = text.."+";
        end
        if oneChangeJobList["magAtk"]-oldChangeJobList["magAtk"] ~= 0 then
            text = text..oneChangeJobList["magAtk"]-oldChangeJobList["magAtk"];
        end
        text = text.."_"
    else
        text = text.."*9".._LTParser("hp").."*0"..oneChangeJobList["hp"].."_";
        text = text.."*9".._LTParser("force").."*0"..oneChangeJobList["atk"].."_";
        text = text.."*9".._LTParser("stunt").."*0"..oneChangeJobList["skillAtk"].."_";
        text = text.."*9".._LTParser("spell").."*0"..oneChangeJobList["magAtk"].."_";
    end
    local height = getNodeContentSize(dragNode).height-10-getNodeContentSize(img).height-10;
    local parserNode = ParsedNode:getParsedNode(text, 0);
    height = height-10-getNodeContentSize(parserNode).height;
    setNodePostion(parserNode, CCPointMake(10, height))
    --parserNode:setPosition(CCPointMake(10, height));
    dragNode:addChild(parserNode);
    
    file = getRealUIResourcePath("img/img0015.png");
    img = SCImage:imageWithFile(file:getData());
    height = height -5-getNodeContentSize(img).height;
    img:setScaleX(0.7);
    setNodePostion(img, CCPointMake(10, height))
    --img:setPosition(CCPointMake(10, height));
    dragNode:addChild(img);
    
    local prestige = Hero:getSingleton():getHeroInfo().nReputation;
    local money = Hero:getSingleton():getHeroInfo().dwMoney;
    local level = 0
    if m_nowChangId == Hero:getSingleton():getHeroInfo().nID then
        level = Hero:getSingleton():getHeroInfo().ucLevel
    else
        level = Hero:getSingleton():getPartner(m_nowChangId).usLevel
    end
    text = _LTParser("transfer conditions").."_";
    if oneChangeJobList["needMoney"] > money then
        text = text.."*2";
    else
        text = text.."*6";
    end
    if oneChangeJobList["needMoney"] > 0 then
        text = text.._LTParser("money")..oneChangeJobList["needMoney"].."_";
    elseif oneChangeJobList["needMoney"] <= 0 then
        text = text.._LTParser("money").._LTParser("str5001").."_";
    end
    if oneChangeJobList["needReputation"] > prestige then
        text = text.."*2";
    else
        text = text.."*6";
    end
    if oneChangeJobList["needReputation"] > 0 then
        text = text.._LTParser("prestige")..oneChangeJobList["needReputation"].."(LV"..oneChangeJobList["reputationLev"]..")_";
    elseif oneChangeJobList["needReputation"] <= 0 then
        text = text.._LTParser("prestige").._LTParser("str5001").."_";
    end
    if oneChangeJobList["needlev"] > level then
        text = text.."*2";
    else
        text = text.."*6";
    end
    if oneChangeJobList["needlev"] <= 0 then
        text = text.._LTParser("str2041").." ".._LTParser("str5001").."_";
    else
        text = text.._LTParser("str2041").." "..oneChangeJobList["needlev"]
    end
    parserNode = ParsedNode:getParsedNode(text, 0);
    height = height-5-getNodeContentSize(parserNode).height;
    setNodePostion(parserNode, CCPointMake(10, height))
    --parserNode:setPosition(CCPointMake(10, height));
    dragNode:addChild(parserNode);
    
    if oneChangeJobList["canChange"] == 1 then
        local btn = SCButton:button(EnumBtnType9Atlas);
        setNodeContentSize(btn, SmallButton_Size)
        --btn:setContentSize(SmallButton_Size)
        btn:setTag(oneChangeJobList["IdType"]);
        btn:setAnchorPoint(CCPointMake(0.5, 0.5));
        setNodePostion(btn, CCPointMake(getNodeContentSize(dragNode).width/2, 10+getNodeContentSize(btn).height/2))
        --btn:setPosition(CCPointMake(dragNode:getContentSize().width/2, 10+btn:getContentSize().height/2));
        if oneChangeJobList["needMoney"] <= money and oneChangeJobList["needReputation"] <= prestige then
            btn:setTitle(_LTParser("change job"), getDefaultFontName(), gDefaultFontSize, colorYellow());
            btn:luaSetSelectorOnClicked(onClickChangeJob1);
        else
            btn:setTitle(_LTParser("change job"), getDefaultFontName(), gDefaultFontSize, colorRed());
        end
        dragNode:addChild(btn);
    elseif oneChangeJobList["canChange"] == 2 then
        local lb = nil;
        if endflag == 1 then
            lb = SCLabel:labelWithStringFont(_LTParser("str5027"), getDefaultFontName(), getFontSize(15));
        else
            lb = SCLabel:labelWithStringFont(_LTParser("str5026"), getDefaultFontName(), getFontSize(15));
        end
        lb:setColor(colorGreen());
        lb:setAnchorPoint(CCPointMake(0.5, 0.5));
        setNodePostion(lb, CCPointMake(getNodeContentSize(dragNode).width/2, 17+getNodeContentSize(lb).height/2))
        --lb:setPosition(CCPointMake(dragNode:getContentSize().width/2, 20+lb:getContentSize().height/2));
        dragNode:addChild(lb);
    end
    
    return dragNode;
end

local function AnimationEnd()
    local wnd = getCurentSceneWindow(5899)
    if not wnd then
        return
    end
    local dragNode = wnd:getChildByTag(2)
    wnd:reorderChild(dragNode, 1)
    dragNode:setVisible(true)
    wnd:removeChildByTag(2001, true)
    local imgpath = getRealUIResourcePath("img/img2547.png")
    local ani = LookfaceParser:getSingleton():getAnimationByLookFaceAndIndex(changeJobInfo[2].lookFace)
    if ani and imgpath then
		ani:setFrameAnchor(EnumFrameAnchorCenter)
		local aniNode = SCAnimationNode:nodeWithAnimation(ani)
		local lookBGimg = SCImage:imageWithFile(imgpath:getData())
		lookBGimg:setAnchorPoint(CCPointMake(0.5, 0.5))
        setNodePostion(lookBGimg, CCPointMake(getNodeContentSize(aniNode).width/2, getNodeContentSize(lookBGimg).height/2+52))
        aniNode:addChild(lookBGimg)
        aniNode:setTag(2001)
		aniNode:setAnchorPoint(CCPointMake(0.5, 0.5))
        setNodePostion(aniNode, CCPointMake(245, 50+getNodeContentSize(aniNode).height/2))
        --aniNode:setPosition(240, 145)
        wnd:addChild(aniNode)
	end
	--[[
    local aniNode = tolua.cast(wnd:getChildByTag(2001), "SCAnimationNode")
    local ani = LookfaceParser:getSingleton():getAnimationByLookFaceAndIndex(changeJobInfo[2].lookFace)
    if ani and aniNode then
        aniNode:setAnimation(ani)
        setNodePostion(aniNode, CCPointMake(245, 55+getNodeContentSize(aniNode).height/2))
        local img = tolua.cast(wnd:getChildByTag(2501), "SCImage")
        if img then
        
        end
    end
    ]]
	if m_nowChangId == Hero:getSingleton():getID() then
		setRestartGuideFlag(GUIDE_TYPE_CHANGEJOB, false)
		showGuideStep(GUIDE_TYPE_CHANGEJOB, 7, 6)
	else
		endGuideWnd()
	end
end

local function onCloseAniWnd()
    local naviCtrl = getCurentSceneNavigationController()
    if naviCtrl:getWindowControllerByTag(5899) then
        naviCtrl:removeWindowControllerByTag(5899)
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_EUDEMONINFO);
    dataStream:writeShort(EUDEMONSHOW_EUDEMONINFO_LIST);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function showChangJobAnimation()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5899));
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    if wndCtrl == nil then
        return nil;
    end
    wndCtrl:luaSetSelectorOnEvent(ctrlEvent2)
    wnd:setFrameVisibled(false)
    wnd:luaSetSelectorOnClose(onCloseAniWnd)
    local naviCtrl =  getCurentSceneNavigationController()
    naviCtrl:pushWindowController(wndCtrl)
    
    local dragNode = tolua.cast(wnd:getChildByTag(2), "SCDragNode")
    dragNode:setVisible(false)
    dragNode:setFrameType(EnumFrameTypeLine)
    dragNode:setFrameVisibled(true)
    
    local faceNode = tolua.cast(dragNode:getChildByTag(23), "SCImage")
    if faceNode then
        local file = getRealUIResourcePath("faceicon/"..changeJobInfo[2].facePhoto..".png")
        if file then
            local img = SCImage:imageWithFile(file:getData())
            if img then
                img:setAnchorPoint(CCPointMake(0.5, 0.5))
                setNodePostion(img, CCPointMake(getNodeContentSize(faceNode).width/2, getNodeContentSize(faceNode).height/2))
                faceNode:addChild(img)
            end
        end
    end
    
    local label = tolua.cast(dragNode:getChildByTag(21), "SCLabel")
    label:setColor(colorPurple())
    label:setText(changeJobInfo[2].name)
    local label = tolua.cast(dragNode:getChildByTag(22), "SCLabel")
    label:setColor(colorPurple())
    label:setText("LV "..changeJobInfo[2].level)
    
    local text = "*9".._LTParser("str5069")..": ".."*6"..changeJobInfo[1].hp.." *3"
    if changeJobInfo[2].hp-changeJobInfo[1].hp > 0 then
        text = text.."+"
    end
    if changeJobInfo[2].hp-changeJobInfo[1].hp ~= 0 then
        text = text..changeJobInfo[2].hp-changeJobInfo[1].hp
    end
    local textBox = tolua.cast(dragNode:getChildByTag(24), "SCTextBox")
    textBox:setScrollVertical(false)
    textBox:setText(text)
    
    local text = "*9".._LTParser("str5020")..": ".."*6"..changeJobInfo[1].baseAtk.." *3"
    if changeJobInfo[2].baseAtk-changeJobInfo[1].baseAtk > 0 then
        text = text.."+"
    end
    if changeJobInfo[2].baseAtk-changeJobInfo[1].baseAtk ~= 0 then
        text = text..changeJobInfo[2].baseAtk-changeJobInfo[1].baseAtk
    end
    local textBox = tolua.cast(dragNode:getChildByTag(25), "SCTextBox")
    textBox:setScrollVertical(false)
    textBox:setText(text)
    
    local text = "*9".._LTParser("str5021")..": ".."*6"..changeJobInfo[1].baseSkillAtk.." *3"
    if changeJobInfo[2].baseSkillAtk-changeJobInfo[1].baseSkillAtk > 0 then
        text = text.."+"
    end
    if changeJobInfo[2].baseSkillAtk-changeJobInfo[1].baseSkillAtk ~= 0 then
        text = text..changeJobInfo[2].baseSkillAtk-changeJobInfo[1].baseSkillAtk
    end
    local textBox = tolua.cast(dragNode:getChildByTag(26), "SCTextBox")
    textBox:setScrollVertical(false)
    textBox:setText(text)
    
    local text = "*9".._LTParser("str5022")..": ".."*6"..changeJobInfo[1].baseMagAtk.." *3"
    if changeJobInfo[2].baseMagAtk-changeJobInfo[1].baseMagAtk > 0 then
        text = text.."+"
    end
    if changeJobInfo[2].baseMagAtk-changeJobInfo[1].baseMagAtk ~= 0 then
        text = text..changeJobInfo[2].baseMagAtk-changeJobInfo[1].baseMagAtk
    end
    local textBox = tolua.cast(dragNode:getChildByTag(27), "SCTextBox")
    textBox:setScrollVertical(false)
    textBox:setText(text)
    --[[
    local lookFace = nil
    if m_nowChangId == Hero:getSingleton():getID() then
        loolFace = Hero:getSingleton():getLookFace()
    else
        local changPlayer = Hero:getSingleton():getPartner(m_nowChangId)
        lookFace = changPlayer.dwLookFace
    end

    local imgpath = getRealUIResourcePath("img/img2548.png")
    local ani = LookfaceParser:getSingleton():getAnimationByLookFaceAndIndex(lookFace)
    if ani and imgpath then
        local lookBGimg = SCImage:imageWithFile(imgpath:getData())
        local aniNode = SCAnimationNode:nodeWithAnimation(ani)
        aniNode:setAnchorPoint(CCPointMake(0.5, 0.5))
        aniNode:setPosition(CCPointMake(lookBGimg:getContentSize().width/2, lookBGimg:getContentSize().height/2+aniNode:getContentSize().height/2))
        lookBGimg:addChild(aniNode)
        lookBGimg:setAnchorPoint(CCPointMake(0.5, 0.5))
        lookBGimg:setPosition(240, 145)
        wnd:addChild(lookBGimg)
    end
    ]]
    local imgpath = getRealUIResourcePath("img/img2547.png")
    local ani = LookfaceParser:getSingleton():getAnimationByLookFaceAndIndex(changeJobInfo[1].lookFace)
    if ani and imgpath then
		ani:setFrameAnchor(EnumFrameAnchorCenter)
		local aniNode = SCAnimationNode:nodeWithAnimation(ani)
		local lookBGimg = SCImage:imageWithFile(imgpath:getData())
		lookBGimg:setAnchorPoint(CCPointMake(0.5, 0.5))
        setNodePostion(lookBGimg, CCPointMake(getNodeContentSize(aniNode).width/2, getNodeContentSize(lookBGimg).height/2+52))
        aniNode:addChild(lookBGimg)
        aniNode:setTag(2001)
		aniNode:setAnchorPoint(CCPointMake(0.5, 0.5))
        setNodePostion(aniNode, CCPointMake(245, 50+getNodeContentSize(aniNode).height/2))
        --aniNode:setPosition(240, 145)
        wnd:addChild(aniNode)
        
		local id = 1103 * 10000 + 1119
		local fps = LookfaceParser:getSingleton():getEffectFPS(id)
		local pAi = LookfaceParser:getSingleton():getAnimationWithFPS(1103, 1119, fps)
		if pAi then
			pAi:luaSetSelectorOnComplete(AnimationEnd)
			pAi:setAutoremoveOnComplete(true)
			local pNode = SCAnimationNode:nodeWithAnimation(pAi)
			pNode:setAnchorPoint(CCPointMake(0.5, 0.5))
			if LookfaceParser:getSingleton():isNeedScale(id) then
				--pt =  LookfaceParser:getSingleton():getOffSetPoint(id);
				pNode:setScaleX(LookfaceParser:getSingleton():getEffectScaleValue(id).x);
				pNode:setScaleY(LookfaceParser:getSingleton():getEffectScaleValue(id).y);
			end
			setNodePostion(pNode,CCPointMake(getNodeContentSize(aniNode).width/2, getNodeContentSize(pNode).height/2 + 40))
			aniNode:addChild(pNode)
		end
    end
end

local function showChangeJobList()
    local wndCtrl = getCurentSceneWindowController(5902);
    if wndCtrl ~= nil then
        return;
    end
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiByZipAndId(5901, 5902));
    wnd:setBackgroundColor(colorWindowRedBG());
    --wnd:setTitle(_LTParser("partner change job"), getDefaultFontName(), gDefaultFontSize);
    local imgPath = getRealUIResourcePath("img/titile34.png")
	if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    dragNode:setFrameType(EnumFrameTypeListNormal);
    dragNode:setFrameVisibled(true);
    dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(wnd, "SCNode")));
    dragNode:setFrameType(EnumFrameTypeListNormal);
    dragNode:setFrameVisibled(true);
    local prestige = Hero:getSingleton():getHeroInfo().nReputation;
    local money = Hero:getSingleton():getHeroInfo().dwMoney;
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
    label:setText(_LTParser("prestige")..prestige);
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("6", tolua.cast(wnd, "SCNode")));
    label:setText(_LTParser("money")..money);
    
    local nPointX = 12;
    local nPointY = 20;
    for i=1, table.getn(changeJobList) do
        local node = nil;
        if i==1 then
            node = makeChangeJobListNode(changeJobList[i], nil, 0);
        else
            node = makeChangeJobListNode(changeJobList[i], changeJobList[1], 1);
        end
        setNodePostion(node, CCPointMake(nPointX, nPointY))
        --node:setPosition(CCPointMake(nPointX, nPointY));
        wnd:addChild(node);
        nPointX = nPointX+10+getNodeContentSize(node).width;
    end
    
    local naviCtrl =  getCurentSceneNavigationController();
    wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wndCtrl:luaSetSelectorOnEvent(ctrlEvent)
    naviCtrl:pushWindowController(wndCtrl);
end

local function recvchangeJobListData()
    local dt = LuaData:getSingleton():getDataTransStream();
    local id = dt:readInt();
    local num = dt:readByte();
    changeJobList = nil;
    changeJobList = {};
    changeJobList["id"] = id;
    m_nowChangId = id
    for i=1, num do
        local tmp = {};
        local scStr = dt:readString();
        if scStr == nil then
            tmp["name"] = "";
        else
            tmp["name"] = scStr:getData();
        end
        local scStr = dt:readString();
        if scStr == nil then
            tmp["profession"] = "";
        else
            tmp["profession"] = scStr:getData();
        end
        tmp["facePhoto"] = dt:readInt();
        local scStr = dt:readString();
        if scStr == nil then
            tmp["skillName"] = "";
        else
            tmp["skillName"] = scStr:getData();
        end
        tmp["hp"] = dt:readShort();
        tmp["atk"] = dt:readInt();
        tmp["skillAtk"] = dt:readInt();
        tmp["magAtk"] = dt:readInt();
        tmp["needMoney"] = dt:readInt();
        tmp["needReputation"] = dt:readInt();
        tmp["canChange"] = dt:readByte();
        tmp["reputationLev"] = dt:readByte();
        tmp["IdType"] = dt:readInt()
        tmp["needlev"] = dt:readShort()
        table.insert(changeJobList, tmp);
    end
    showChangeJobList();
end

local function onClickChangeJob2(tag)
    SCActivityIndicator:getSingleton():show()
    local wndCtrl = getCurentSceneWindowController(5903);
    if wndCtrl == nil then
        return;
    end    
    local wnd = wndCtrl:getWindow();
    local checkBox = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
    local select = checkBox:isSelect();
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_EUDEMONINFO);
    dataStream:writeShort(EUDEMONSHOW_CHANGEJOB);
    dataStream:writeByte(0);
    dataStream:writeInt(changeJobInfo["id"]);
    if select==true then
        dataStream:writeInt(1);
    else
        dataStream:writeInt(0);
    end
    dataStream:writeInt(changeJobInfo[2]["IdType"]);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function makeChangeJobInfoNode(oneChangeJobInfo, oldChangeJobInfo)
    local dragNode = SCDragNode:node();
    setNodeContentSize(dragNode, CCSizeMake(217, 190))
    --dragNode:setContentSize(CCSizeMake(217, 190));
    dragNode:setFrameType(EnumFrameTypeLine);
    dragNode:setFrameVisibled(true);
    dragNode:setDragEnabled(false);

    local file = getRealUIResourcePath("img/new00002.png");
    local img = SCImage:imageWithFile(file:getData());
    img:setAnchorPoint(CCPointMake(0, 1));
    setNodePostion(img, CCPointMake(27, getNodeContentSize(dragNode).height-15))
    --img:setPosition(CCPointMake(27, dragNode:getContentSize().height-10));
    dragNode:addChild(img);
    
    local imgNode = getFaceImg(oneChangeJobInfo["facePhoto"])
    if imgNode then
        imgNode:setAnchorPoint(CCPointMake(0.5, 0.5))
        setNodePostion(imgNode, CCPointMake(getNodeContentSize(img).width/2, getNodeContentSize(img).height/2))
        img:addChild(imgNode)
    end
    
    local nameLabel = SCLabel:labelWithStringFont(oneChangeJobInfo["name"], getDefaultFontName(), getFontSize(12));
    nameLabel:setAnchorPoint(CCPointMake(0.5, 0.5));
    setNodePostion(nameLabel, CCPointMake(getNodeContentSize(img).width/2, -5-getNodeContentSize(nameLabel).height/2))
    --nameLabel:setPosition(CCPointMake(img:getContentSize().width/2, -5-nameLabel:getContentSize().height/2));
    img:addChild(nameLabel);
    
    local levelTxt= oneChangeJobInfo["level"].._LTParser("level").." "..oneChangeJobInfo["profession"];
    local levelLabel = SCLabel:labelWithStringFont(levelTxt, getDefaultFontName(), getFontSize(12));
    levelLabel:setAnchorPoint(CCPointMake(0.5, 0.5));
    setNodePostion(levelLabel, CCPointMake(getNodeContentSize(img).width/2, -10-getNodeContentSize(nameLabel).height-getNodeContentSize(levelLabel).height/2))
    --levelLabel:setPosition(CCPointMake(img:getContentSize().width/2, -10-nameLabel:getContentSize().height-levelLabel:getContentSize().height/2));
    img:addChild(levelLabel);
    
    local text = "*6".._LTParser("unique skill").."*7"..oneChangeJobInfo["skillName"].."_";
    if oldChangeJobInfo ~= nil then
        text = text.."*6".._LTParser("hp")..oldChangeJobInfo["hp"].." *7";
        if oneChangeJobInfo["hp"]-oldChangeJobInfo["hp"] > 0 then
            text = text.."+";
        end
        if oneChangeJobInfo["hp"]-oldChangeJobInfo["hp"] ~= 0 then
            text = text..oneChangeJobInfo["hp"]-oldChangeJobInfo["hp"];
        end
        text = text.."_"
        text = text.."*6".._LTParser("force")..oldChangeJobInfo["baseAtk"].." *7";
        if oneChangeJobInfo["baseAtk"]-oldChangeJobInfo["baseAtk"] > 0 then
            text = text.."+";
        end
        if oneChangeJobInfo["baseAtk"]-oldChangeJobInfo["baseAtk"] ~= 0 then
            text = text..oneChangeJobInfo["baseAtk"]-oldChangeJobInfo["baseAtk"];
        end
        text = text.."_"
        text = text.."*6".._LTParser("stunt")..oldChangeJobInfo["baseSkillAtk"].." *7";
        if oneChangeJobInfo["baseSkillAtk"]-oldChangeJobInfo["baseSkillAtk"] > 0 then
            text = text.."+";
        end
        if oneChangeJobInfo["baseSkillAtk"]-oldChangeJobInfo["baseSkillAtk"] ~= 0 then
            text = text..oneChangeJobInfo["baseSkillAtk"]-oldChangeJobInfo["baseSkillAtk"];
        end
        text = text.."_"
        text = text.."*6".._LTParser("spell")..oldChangeJobInfo["baseMagAtk"].." *7";
        if oneChangeJobInfo["baseMagAtk"]-oldChangeJobInfo["baseMagAtk"] > 0 then
            text = text.."+";
        end
        if oneChangeJobInfo["baseMagAtk"]-oldChangeJobInfo["baseMagAtk"] ~= 0 then
            text = text..oneChangeJobInfo["baseMagAtk"]-oldChangeJobInfo["baseMagAtk"];
        end
        text = text.."_"
    else
        
        text = text.."*6".._LTParser("hp")..oneChangeJobInfo["hp"].."_";
        text = text.."*6".._LTParser("force")..oneChangeJobInfo["baseAtk"].."_";
        text = text.."*6".._LTParser("stunt")..oneChangeJobInfo["baseSkillAtk"].."_";
        text = text.."*6".._LTParser("spell")..oneChangeJobInfo["baseMagAtk"].."_";
    end
    local parserNode = ParsedNode:getParsedNode(text, 0);
    parserNode:setAnchorPoint(CCPointMake(0, 1));
    setNodePostion(parserNode, CCPointMake(90, getNodeContentSize(dragNode).height-15))
    --parserNode:setPosition(CCPointMake(90, dragNode:getContentSize().height-10));
    dragNode:addChild(parserNode);
    
    local form = SCForm:formWithRowAndCol(4, 5, 35, 15);
    form:setTag(1006);
    form:setCellFontSize(getFontSize(12));
    form:setText(_LTParser("str5018"), 0, 1);
    form:setText("*9".._LTParser("str0137"), 0, 2);
    form:setText("*9".._LTParser("str0127"), 0, 3);
    form:setText("*9".._LTParser("str5019"), 0, 4);
    form:setText("*9".._LTParser("str5020"), 1, 0);
    form:setText("*9".._LTParser("str5021"), 2, 0);
    form:setText("*9".._LTParser("str5022"), 3, 0);
    form:setText("*0"..oneChangeJobInfo["baseAtk"], 1, 1);
    form:setText("*0"..oneChangeJobInfo["baseSkillAtk"], 2, 1);
    form:setText("*0"..oneChangeJobInfo["baseMagAtk"], 3, 1);
    form:setText("*0"..oneChangeJobInfo["traomAtk"], 1, 2);
    form:setText("*0"..oneChangeJobInfo["traomSkillAtk"], 2, 2);
    form:setText("*0"..oneChangeJobInfo["traomMagAtk"], 3, 2);
    form:setText("*0"..oneChangeJobInfo["medicineAtk"], 1, 3);
    form:setText("*0"..oneChangeJobInfo["medicineSkillAtk"], 2, 3);
    form:setText("*0"..oneChangeJobInfo["medicineMagAtk"], 3, 3);
    form:setText("*6"..oneChangeJobInfo["baseAtk"]+oneChangeJobInfo["traomAtk"]+oneChangeJobInfo["medicineAtk"], 1, 4);
    form:setText("*6"..oneChangeJobInfo["baseSkillAtk"]+oneChangeJobInfo["traomSkillAtk"]+oneChangeJobInfo["medicineSkillAtk"], 2, 4);
    form:setText("*6"..oneChangeJobInfo["baseMagAtk"]+oneChangeJobInfo["traomMagAtk"]+oneChangeJobInfo["medicineMagAtk"], 3, 4);
    form:setAnchorPoint(CCPointMake(0.5, 0.5));
    setNodePostion(form, CCPointMake(getNodeContentSize(dragNode).width/2, 10 + getNodeContentSize(form).height/2))
    --form:setPosition(CCPointMake(dragNode:getContentSize().width/2, 10 + form:getContentSize().height/2));
    dragNode:addChild(form);
    
    return dragNode;
end

local function onClickCheckBoxBtn(tag)
    local wndCtrl = getCurentSceneWindowController(5903);
    if wndCtrl == nil then
        return;
    end    
    local wnd = wndCtrl:getWindow();
    local checkBox = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
    local select = checkBox:isSelect();
    if select == true then
        sendChangeJobMsg(changeJobInfo["id"], 1, changeJobInfo[2]["IdType"]);
    else
        sendChangeJobMsg(changeJobInfo["id"], 0, changeJobInfo[2]["IdType"]);
    end
end

local function refreshChangeJobInfo(oneChangeJobInfo)
    local wndCtrl = getCurentSceneWindowController(5903);
    local wnd = wndCtrl:getWindow();
    if wnd == nil then
        return;
    end
    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    local node = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("2", dragNode));
    local form = SCTypeCast:castNodeToForm(SCFunction:getUiNodeByIdlistAndParent("1006", node));
    form:setText("*0"..oneChangeJobInfo["baseAtk"], 1, 1);
    form:setText("*0"..oneChangeJobInfo["baseSkillAtk"], 2, 1);
    form:setText("*0"..oneChangeJobInfo["baseMagAtk"], 3, 1);
    form:setText("*0"..oneChangeJobInfo["traomAtk"], 1, 2);
    form:setText("*0"..oneChangeJobInfo["traomSkillAtk"], 2, 2);
    form:setText("*0"..oneChangeJobInfo["traomMagAtk"], 3, 2);
    form:setText("*0"..oneChangeJobInfo["medicineAtk"], 1, 3);
    form:setText("*0"..oneChangeJobInfo["medicineSkillAtk"], 2, 3);
    form:setText("*0"..oneChangeJobInfo["medicineMagAtk"], 3, 3);
    form:setText("*6"..oneChangeJobInfo["baseAtk"]+oneChangeJobInfo["traomAtk"]+oneChangeJobInfo["medicineAtk"], 1, 4);
    form:setText("*6"..oneChangeJobInfo["baseSkillAtk"]+oneChangeJobInfo["traomSkillAtk"]+oneChangeJobInfo["medicineSkillAtk"], 2, 4);
    form:setText("*6"..oneChangeJobInfo["baseMagAtk"]+oneChangeJobInfo["traomMagAtk"]+oneChangeJobInfo["medicineMagAtk"], 3, 4);
end

local function showChangeJobInfo()
    local wndCtrl = getCurentSceneWindowController(5903);
    if wndCtrl ~= nil then
        refreshChangeJobInfo(changeJobInfo[2]);
        return;
    end
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiByZipAndId(5901, 5903));
    wnd:setBackgroundColor(colorWindowRedBG());
    --wnd:setTitle(_LTParser("partner change job"), getDefaultFontName(), gDefaultFontSize);
    local imgPath = getRealUIResourcePath("img/titile34.png")
	if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
	end
    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    dragNode:setFrameType(EnumFrameTypeRound);
    dragNode:setFrameVisibled(true);
    local checkBox = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
    checkBox:setDescribe(string.format(_LTParser("cost 1000 emoney keep some attri"), needReputation), getDefaultFontName(), getFontSize(12), colorGreen());
    --local cBgImg = getRealUIResourcePath("img/img2523.png");
    --if cBgImg then
    --    checkBox:setBackgroundImage(cBgImg:getData());
    --end
    --local cSlImg = getRealUIResourcePath("img/img2522.png");
    --if cSlImg then
    --    checkBox:setSelectedImage(cSlImg:getData());
    --end
    --checkBox:setSelect(true);
    checkBox:luaSetSelectorOnButtonClicked(onClickCheckBoxBtn);

    local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2", tolua.cast(wnd, "SCNode")));
    button:luaSetSelectorOnClicked(onClickChangeJob2);
    
    local nPointX = 5;
    local nPointY = 10;
    for i=1, table.getn(changeJobInfo) do
        local node = makeChangeJobInfoNode(changeJobInfo[i], changeJobInfo[i-1]);
        setNodePostion(node, CCPointMake(nPointX, nPointY))
        --node:setPosition(CCPointMake(nPointX, nPointY));
        node:setTag(i);
        dragNode:addChild(node);
        nPointX = nPointX+5+getNodeContentSize(node).width;
    end

    local imgFile = getRealUIResourcePath("img/img5058.png");
    local img = SCImage:imageWithFile(imgFile:getData());
    img:setAnchorPoint(CCPointMake(0.5, 0.5));
    setNodePostion(img, CCPointMake(getNodeContentSize(dragNode).width/2, getNodeContentSize(dragNode).height-getNodeContentSize(img).height/2-20))
    --img:setPosition(CCPointMake(dragNode:getContentSize().width/2, dragNode:getContentSize().height-img:getContentSize().height/2-20));
    dragNode:addChild(img);
    
    if not luaIsUnlock(UNLOCK_TYPE_PARTNER_CHANGE_JOB) or Hero:getSingleton():getID()==m_nowChangId then
        checkBox:setVisible(false)
        setNodePostion(button, CCPointMake(240, 33))
    end
    
    local naviCtrl =  getCurentSceneNavigationController();
    wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wndCtrl:luaSetSelectorOnEvent(ctrlEvent3)
    naviCtrl:pushWindowController(wndCtrl);
    
    if getCurentSceneWindowController(5902) ~= nil then
        naviCtrl:removeWindowControllerByTag(5902);
    end
end

local function recvchangeJobInfoData()
    local dt = LuaData:getSingleton():getDataTransStream();
    local id = dt:readInt();
    local cost = dt:readInt();
    local rCost = dt:readShort();
    needReputation = rCost;
    local type = dt:readByte();
    local num = dt:readByte();
    changeJobInfo = {__mode="kv"};
    changeJobInfo["id"] = id;
    for i=1, num do
        local tmp = {};
        local scStr = dt:readString();
        if scStr == nil then
            tmp["name"] = "";
        else
            tmp["name"] = scStr:getData();
        end
        local scStr = dt:readString();
        if scStr == nil then
            tmp["profession"] = "";
        else
            tmp["profession"] = scStr:getData();
        end
        tmp["facePhoto"] = dt:readInt();
        local scStr = dt:readString();
        if scStr == nil then
            tmp["skillName"] = "";
        else
            tmp["skillName"] = scStr:getData();
        end
        tmp["level"] = dt:readShort();
        tmp["hp"] = dt:readShort();
        tmp["baseAtk"] = dt:readInt();
        tmp["baseSkillAtk"] = dt:readInt();
        tmp["baseMagAtk"] = dt:readInt();
        tmp["traomAtk"] = dt:readInt();
        tmp["traomSkillAtk"] = dt:readInt();
        tmp["traomMagAtk"] = dt:readInt();
        tmp["medicineAtk"] = dt:readInt();
        tmp["medicineSkillAtk"] = dt:readInt();
        tmp["medicineMagAtk"] = dt:readInt();
        tmp["IdType"] = dt:readInt();
        tmp["lookFace"] = dt:readInt()
        table.insert(changeJobInfo, tmp);
    end
    showChangeJobInfo();
end

local function recvEndemonShowChangeJob()
    local naviCtrl =  getCurentSceneNavigationController();
    --if getCurentSceneWindowController(5901) ~= nil then
    --    naviCtrl:removeWindowControllerByTag(5901);
    --end
    showChangJobAnimation()
    
    if getCurentSceneWindowController(5903) ~= nil then
        naviCtrl:removeWindowControllerByTag(5903);
    end    
end

--set callBackFunction when recive _MSG_EUDEMONINFO, action = EUDEMONSHOW_EUDEMONINFO_LIST
LuaData:getSingleton():luaSetSelectorOnRecvData(recvEudemonListData, LuaData_EUDEMONSHOW_EUDEMONINFO_LIST);

--set callBackFunction when recive _MSG_EUDEMONINFO, action = EUDEMONSHOW_CHANGEJOB_LIST
LuaData:getSingleton():luaSetSelectorOnRecvData(recvchangeJobListData, LuaData_EUDEMONSHOW_CHANGEJOB_LIST);

--set callBackFunction when recive _MSG_EUDEMONINFO, action = EUDEMONSHOW_CHANGEJOB_INFO
LuaData:getSingleton():luaSetSelectorOnRecvData(recvchangeJobInfoData, LuaData_EUDEMONSHOW_CHANGEJOB_INFO);

--set callBackFunction when recive _MSG_EUDEMONINFO, action = EUDEMONSHOW_CHANGEJOB
LuaData:getSingleton():luaSetSelectorOnRecvData(recvEndemonShowChangeJob, LuaData_EUDEMONSHOW_CHANGEJOB);