PeopleTalenSystem = {};

function PeopleTalenSystem:new(o)
    local class = o or {};
    --成员变量
    class.CompletionTalent = {__mode="kv"}; --窗口顶上的绝技信息
    class.UnfinishedTalent = {__mode="kv"}; --天赋信息
    class.nowPosSkill = nil
    class.canLenTalentType = nil;--可学天赋
    class.m_entryID = nil --定时器
    class.nCount = 0 --定时器计数
    class.bAniPlayer = true
    
    --成员函数
    --初始化
    class.init = function ()
        --set callBackFunction when recive _MSG_MAGICINFO, action = MSG_MAGICS_OPEN_USERTALENT
        LuaData:getSingleton():luaSetSelectorOnRecvData(class.processOpenUserTalent, LuaData_MSG_MAGICS_OPEN_USERTALENT);

        --set callBackFunction when recive _MSG_MAGICINFO, action = MSG_MAGICS_SEND_TALENTINFO
        LuaData:getSingleton():luaSetSelectorOnRecvData(class.processSendTalentInfo, LuaData_MSG_MAGICS_SEND_TALENTINFO);
    end
    --打开窗口
    class.processOpenUserTalent = function ()
        local dt = LuaData:getSingleton():getDataTransStream();
        class.readOpenUserTalentData(dt);
        class.showTalentWindow();
    end
    --接收技能信息
    class.processSendTalentInfo = function ()
        local dt = LuaData:getSingleton():getDataTransStream();
        class.readTalentInfoData(dt);
        class.refreshTalentInfo();
    end
    --读取打开窗口时收到的数据
    class.readOpenUserTalentData = function (dt)
        class.CompletionTalent = {__mode="kv"}
        local num = dt:readByte();
        for i=1, num do
            local tmp = {};
            local scStr = dt:readString();
            if scStr == nil then
                tmp.name = "";
            else
                tmp.name = scStr:getData();
            end
            tmp.photo = dt:readInt();
            local scStr = dt:readString();
            if scStr == nil then
                tmp.description = "";
            else
                tmp.description = scStr:getData();
            end
            tmp.type = dt:readShort();
            for i=1, table.getn(class.CompletionTalent) do
                if tmp.type == class.CompletionTalent[i].type then
                    table.remove(class.CompletionTalent, i);
                    table.insert(class.CompletionTalent, i, tmp);
                    break;
                end
            end
            table.insert(class.CompletionTalent, tmp);
        end
        if class.nowPosSkill == nil then
            class.nowPosSkill = #class.CompletionTalent
        end
    end
    --读取技能数据
    class.readTalentInfoData = function(dt)
        class.UnfinishedTalent = {__mode="kv"}
        local scStr = dt:readString();
        if scStr == nil then
            class.UnfinishedTalent.stuntName = "";
        else
            class.UnfinishedTalent.stuntName = scStr:getData();
        end
        class.UnfinishedTalent.stuntPhoto = dt:readInt();
        local scStr = dt:readString();
        if scStr == nil then
            class.UnfinishedTalent.stuntDescription = "";
        else
            class.UnfinishedTalent.stuntDescription = scStr:getData();
        end
        class.UnfinishedTalent.soul = dt:readInt();
        local num = dt:readByte();
        class.UnfinishedTalent.num = num;
        for i=1, num do
            local tmp = {};
            local scStr = dt:readString();
            if scStr == nil then
                tmp.name = "";
            else
                tmp.name = scStr:getData();
            end
            tmp.photo = dt:readInt();
            tmp.isLearn = dt:readByte();
            local scStr = dt:readString();
            if scStr == nil then
                tmp.description = "";
            else
                tmp.description = scStr:getData();
            end
            tmp.needSoul = dt:readInt();
            tmp.type = dt:readShort();
            if tmp.isLearn==1 and class.canLenTalentType==nil then
                class.canLenTalentType = tmp.type;
            end
            table.insert(class.UnfinishedTalent, i, tmp);
        end
    end
    --窗口关闭时清除资源
    class.onCloseWnd = function()
        class.CompletionTalent = {__mode = "kv"};
        class.UnfinishedTalent = {__mode = "kv"};
        class.nowPosSkill = nil
        class.canLenTalentType = nil;--可学天赋
        if class.m_entryID ~= nil then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(class.m_entryID)
            class.m_entryID = nil
        end
        class.nCount = 0
        class.bAniPlayer = true
    end
    --查看修过的绝技
    class.sendLookStuntInfo = function(usType)
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_MAGICINFO);
        dataStream:writeShort(MSG_MAGICS_SEND_TALENTINFO);
        dataStream:writeShort(usType);
        SCDataTransThread:getSingleton():transData(dataStream);
    end    
    --切换绝技
    class.onClickStuntBtn = function (tag)
        if tag == class.nowPosSkill then
            return
        end
        local wnd = getCurentSceneWindow(5906)
        if not wnd then
            return
        end
        local node = wnd:getChildByTag(5)
        if not node then
            return
        end
        local filePathN = getRealUIResourcePath("img/img8002.png")
        local filePathS = getRealUIResourcePath("img/img8003.png")
        if not filePathN or not filePathS then
            return
        end
        local skillBtn = SCTypeCast:castNodeToButton(node:getChildByTag(class.nowPosSkill))
        if skillBtn then
            skillBtn:setBackgroundImage(filePathN:getData())
        end
        class.nowPosSkill = tag
        local skillBtn = SCTypeCast:castNodeToButton(node:getChildByTag(class.nowPosSkill))
        if skillBtn then
            skillBtn:setBackgroundImage(filePathS:getData())
        end
        if class.m_entryID ~= nil then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(class.m_entryID)
            class.m_entryID = nil
        end
        class.nCount = 0
        class.bAniPlayer = true
        class.sendLookStuntInfo(tag)
    end
    --天赋按钮被点击
    class.onClickTalentBtn = function(tag)
        if tag == 31 then
            luaShowTip(_LTParser("str5024"), nil, nil, nil, nil, 15);
            return;
        end
        if class.UnfinishedTalent[tag-10].isLearn == 2 then
            luaShowTip(class.UnfinishedTalent[tag-10].description, nil, nil, nil, "*6--"..class.UnfinishedTalent[tag-10].name.."--", 15);
            return;
        end
        if class.UnfinishedTalent[tag-10].isLearn == 1 then
            class.sendLearnTalent(class.UnfinishedTalent[tag-10].type);
            class.learnFlag = true
			if isGuideCanStart(GUIDE_TYPE_TALENT) then
				setRestartGuideFlag(GUIDE_TYPE_TALENT, false)
				showGuideStep(GUIDE_TYPE_TALENT, 5, 4)
			elseif isGuideCanStart(GUIDE_TYPE_FORMAT_1) then
				setRestartGuideFlag(GUIDE_TYPE_FORMAT_1, false)
				showGuideStep(GUIDE_TYPE_FORMAT_1, 5, 4)
			end
            return;
        end
    end
    --中间的绝技按钮被点击
    class.onClickStntBtn = function(tag)
        if class.UnfinishedTalent.stuntDescription then
            luaShowTip(class.UnfinishedTalent.stuntDescription);
        end
    end
    --窗口push回调
    class.ctrlEvent = function(tag, eventType)
        if eventType == LuaControllerEventPushEnded then
			if isGuideCanStart(GUIDE_TYPE_TALENT) then
				setRestartGuideFlag(GUIDE_TYPE_TALENT, true)
				showGuideStep(GUIDE_TYPE_TALENT, 4, 3)
			elseif isGuideCanStart(GUIDE_TYPE_FORMAT_1) then
				setRestartGuideFlag(GUIDE_TYPE_FORMAT_1, true)
				showGuideStep(GUIDE_TYPE_FORMAT_1, 4, 3)
			end
		elseif eventType == LuaControllerEventPopBegan or eventType == LuaControllerEventRemoveBegan then
			if isGuideCanStart(GUIDE_TYPE_TALENT) then
				if getRestartGuideFlag(GUIDE_TYPE_TALENT) then
					restartBeginnerGuide(GUIDE_TYPE_TALENT)
				else
					showGuideStep(GUIDE_TYPE_TALENT, -1)
				end
			elseif isGuideCanStart(GUIDE_TYPE_FORMAT_1) then
				if getRestartGuideFlag(GUIDE_TYPE_FORMAT_1) then
					restartBeginnerGuide(GUIDE_TYPE_FORMAT_1)
				else
					showGuideStep(GUIDE_TYPE_FORMAT_1, -1)
				end
			end
        end
    end
    --显示天赋窗口
    class.showTalentWindow = function ()
        local wnd = nil;
        local wndCtrl = getCurentSceneWindowController(5906);
        if wndCtrl == nil then
            wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5906));
            wnd:luaSetSelectorOnClose(class.onCloseWnd);
            wndCtrl = SCWindowController:controllerWithWindow(wnd);
            wndCtrl:luaSetSelectorOnEvent(class.ctrlEvent)
            naviCtrl = getCurentSceneNavigationController();
            naviCtrl:pushWindowController(wndCtrl);
            wnd:setFrameVisibled(false);
            wnd:setBackButtonVisibled(false);
        else
            wnd = wndCtrl:getWindow();
        end
        
        local dragNode = tolua.cast(wnd:getChildByTag(3), "SCDragNode")
        if dragNode then
            dragNode:setFrameType(EnumFrameTypeListNormal)
            dragNode:setFrameVisibled(true)
            local soulBtn = tolua.cast(dragNode:getChildByTag(31), "SCButton")
            if soulBtn then
                soulBtn:luaSetSelectorOnClicked(class.onClickTalentBtn)
            end
        end
        
        --创建绝技按钮
        local node = wnd:getChildByTag(5)
        if node then
            local nStartY = node:getContentSize().height;
            local filePathN = getRealUIResourcePath("img/img8002.png")
            local filePathS = getRealUIResourcePath("img/img8003.png")
            for i=1, #class.CompletionTalent do
                local skillBtn = SCTypeCast:castNodeToButton(node:getChildByTag(class.CompletionTalent[i].type));
                if skillBtn == nil then
                    skillBtn = SCButton:button();
                    if filePathN and filePathS then
                        skillBtn:setBackgroundImage(filePathN:getData())
                        skillBtn:setSelectedImage(filePathS:getData())
                    end
                    skillBtn:setTitle(class.CompletionTalent[i].name, getDefaultFontName(), getFontSize(15))
                    --skillBtn:setContentSize(CCSizeMake(60, 20))
                    skillBtn:luaSetSelectorOnClicked(class.onClickStuntBtn);
                    skillBtn:setTag(class.CompletionTalent[i].type);
                    skillBtn:setAnchorPoint(CCPointMake(0, 1))
                    node:addChild(skillBtn);
                end
                skillBtn:setPosition(0, nStartY);
                nStartY = nStartY - skillBtn:getContentSize().height - 5
                if i==class.nowPosSkill and filePathS then
                    skillBtn:setBackgroundImage(filePathS:getData())
                end
            end
        end

    end
    --发送学习天赋消息
    class.sendLearnTalent = function(type)
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_MAGICINFO);
        dataStream:writeShort(MSG_MAGICS_STUDY_USERTALENT);
        dataStream:writeShort(type);
        SCDataTransThread:getSingleton():transData(dataStream);
    end
    --定时器回调
    class.onTimmer = function (time)
        local wnd = getCurentSceneWindow(5906)
        if not wnd then
            return
        end
        class.nCount = class.nCount + 1
        local filePathT = getRealUIResourcePath("img/img"..(5111+class.CompletionTalent[class.nowPosSkill].type-1)..".png");
        --local filePathF = getRealUIResourcePath("img/img5083.png");
        if class.nCount <= class.UnfinishedTalent.num then
            local talentBtn = SCTypeCast:castNodeToButton(wnd:getChildByTag(class.nCount+10))
            if class.UnfinishedTalent[class.nCount].isLearn == 2 then
                talentBtn:setTitle(filePathT:getData())
                local pNode = talentBtn:getChildByTag(1001)
                if not pNode then
                    local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1101, 1120)
                    --pAi:setAutoremoveOnComplete(true)
                    --pAi:luaSetSelectorOnComplete(class.aniEnd)
                    if pAi then
							pNode =  SCAnimationNode:nodeWithAnimation(pAi)
							pNode:setTag(1001)
							pNode:setAnchorPoint(CCPointMake(0.5,0.5))
							pNode:setPosition(CCPointMake(talentBtn:getContentSize().width/2, talentBtn:getContentSize().height/2))
							talentBtn:addChild(pNode)
					  end
                end
            end
        else
            if class.m_entryID ~= nil then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(class.m_entryID)
                class.m_entryID = nil
            end
            class.nCount = 0
        end
    end
    --开启绝技动画结束
    class.stuntUpAnimationEnd = function(tag)
        local wnd = getCurentSceneWindow(5906)
        if not wnd then
            return
        end
        local midBtn = tolua.cast(wnd:getChildByTag(4), "SCButton")
        if midBtn then
            midBtn:setVisible(true)
        end
        wnd:removeChildByTag(6001, true)
        local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1109, 1147)
        if pAi then
			local pNode = SCAnimationNode:nodeWithAnimation(pAi)
			pNode:setAnchorPoint(CCPointMake(0.5, 0.5))
			pNode:setTag(6001)
			pNode:setPosition(CCPointMake(SX(190), SY(160)))
			wnd:addChild(pNode)
        end
    end
    --更新天赋数据
    class.refreshTalentInfo = function()
        local wndCtrl = getCurentSceneWindowController(5906);
        if wndCtrl == nil then
            return;
        end
        wnd = wndCtrl:getWindow();
        if wnd == nil then
            return;
        end
        local midBtn = tolua.cast(wnd:getChildByTag(4), "SCButton")
        if midBtn then
			midBtn:setContentSize(CCSizeMake(122, 120))
            --midBtn:luaSetSelectorOnClicked(class.onClickStntBtn)
            midBtn:setVisible(false)
        end
        wnd:removeChildByTag(6001, true)
        if  class.UnfinishedTalent[class.UnfinishedTalent.num] and class.UnfinishedTalent[class.UnfinishedTalent.num].isLearn == 2 then
            local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1108, 1146);
            if pAi then
				pAi:luaSetSelectorOnComplete(class.stuntUpAnimationEnd);
				pAi:setAutoremoveOnComplete(true);
				local pNode =  SCAnimationNode:nodeWithAnimation(pAi);
				pNode:setAnchorPoint(CCPointMake(0.5, 0.5))
				pNode:setTag(6001)
				pNode:setPosition(CCPointMake(SX(190), SY(160)))
				wnd:addChild(pNode)
			end
		end
        if class.m_entryID ~= nil then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(class.m_entryID)
            class.m_entryID = nil
        end
        for i=1, class.UnfinishedTalent.num do
			local filePathF = getRealUIResourcePath("img/img5083.png");
            local talentBtn = SCTypeCast:castNodeToButton(wnd:getChildByTag(i+10))
            if talentBtn then
                talentBtn:luaSetSelectorOnClicked(class.onClickTalentBtn)
                talentBtn:setTitle(filePathF:getData());
                if talentBtn:getChildByTag(1001) then
                    talentBtn:removeChildByTag(1001, true)
                end
            end
        end
        if class.bAniPlayer then
            class.nCount = 0
            class.bAniPlayer = false
            class.m_entryID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(class.onTimmer, 0.2, false)
        else
            for i=1, class.UnfinishedTalent.num do
				local filePathT = getRealUIResourcePath("img/img"..(5111+class.CompletionTalent[class.nowPosSkill].type-1)..".png");
                local talentBtn = SCTypeCast:castNodeToButton(wnd:getChildByTag(i+10))
                if talentBtn then
                    if class.UnfinishedTalent[i].isLearn == 2 then
                        talentBtn:setTitle(filePathT:getData())
                        local pNode = talentBtn:getChildByTag(1001)
                        if not pNode then
                            local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1101, 1120)
                            --pAi:setAutoremoveOnComplete(true)
                            --pAi:luaSetSelectorOnComplete(class.aniEnd)
                            if pAi then
								   pNode =  SCAnimationNode:nodeWithAnimation(pAi)
								   pNode:setTag(1001)
								   pNode:setAnchorPoint(CCPointMake(0.5,0.5))
								   pNode:setPosition(CCPointMake(talentBtn:getContentSize().width/2, talentBtn:getContentSize().height/2))
								   talentBtn:addChild(pNode)
							   end
                        end
                    end
                end
            end
        end
        local dragNode = SCTypeCast:castNodeToLabel(wnd:getChildByTag(3))
        if dragNode then
            local pLabel = SCTypeCast:castNodeToLabel(dragNode:getChildByTag(32))
            if pLabel then
                pLabel:setText(_LTParser("str5025").." "..class.UnfinishedTalent.soul)
            end
        end
    end
    
    class.__mode = "kv"; --弱表
    --下面两句相当于new出一个新的实例
    setmetatable(class, self);
    self.__index = self;
    return class;    --返回一个实例
end

local newPeopleTalenSystem =  PeopleTalenSystem:new();
newPeopleTalenSystem.init();