-----------------------------消息-----------------------------
--[[

const unsigned short _MSG_TRIBE=_MSG_GENERAL+613;	//家族系统

MSG_SOCIATY_SAINT_CALLED_OUT			= 31,	//召唤散仙
上发消息：
typedef struct
{
	BYTE sure;		//0为请求
}tMSG_Info14;


MSG_SOCIATY_RAPPELZ_JION			= 32,	//六芒封魔
上发：无参

MSG_SOCIATY_MEMBER_CALLED			= 33,	//召集成员
MSG_SOCIATY_RAPPELZ_OPEN			= 34,	//查看封魔信息
下发消息：
struct stJoininfo
{
	BYTE	byType;				//0为首次，1为协助
	int	nFaceLook;
	char	szName[_MAX_NAMESIZE];
};

struct stRapplezinfo
{
	USHORT		usNum;
	BYTE		byIsIn;					//1为在队伍中，0为不在
	stJoininfo	stJoin[6];
	char		szLackMan[64];	
	char		szDescribe[_MAX_WORDSSIZE];//tip
};

MSG_SOCIATY_RAPPELZ_SUCCEED			= 38,	//封魔成功
下发：char szBug[256];
MSG_SOCIATY_RAPPELZ_CLOSE			= 39,	//客户端关窗口
上发无参
--]]
----------------结构定义区------------------------------------
local stJoinInfo = {
	initWithStream = function(dt)
		local tmp = {} 
		if not dt then
			return tmp
		end
		tmp.byType = dt:readByte() --	/*0为首次，1为协助*/
		tmp.nFaceLook = dt:readInt()
		tmp.szName = dt:readString()
		if tmp.szName then
			tmp.szName = tmp.szName:getData()
		else
			tmp.szName = " "
		end
		return tmp
	end
}
local stRapplezinfo = {
	initWithStream = function(dt)
		local tmp = {} 
		if not dt then
			return tmp
		end
		tmp.usNum = dt:readShort()
		tmp.byIsIn = dt:readByte() --/*1为在队伍中，0为不在*/
		tmp.vecJoinInfo = {}
		for i=1, tmp.usNum do
			table.insert(tmp.vecJoinInfo, stJoinInfo.initWithStream(dt))
		end
		tmp.szLackMan = dt:readString()
		if tmp.szLackMan then
			tmp.szLackMan = tmp.szLackMan:getData()
		else
			tmp.szLackMan = " "
		end
		tmp.szDescribe = dt:readString()
		if tmp.szDescribe then
			tmp.szDescribe = tmp.szDescribe:getData()
		else
			tmp.szDescribe = " "
		end
		return tmp
	end
}
----------------常量定义区------------------------------------

----------------变量定义区------------------------------------
local m_successMsg = nil
----------------函数声明区-------------------------------------
local createRappelzWindow
local fillRappelzInfo
local refreshRoleInfo
local onClickCallSaintBtn
local onClickRappelzJoinBtn
local onClickCallMemberBtn
local onSocietyAnimationEnd
local sendRappelzWndClose
----------------UI控制器区-------------------------------------
--封魔成功动画结束回调
function onSocietyAnimationEnd(tag)
	local pNavCtrl = getCurentSceneNavigationController()
	if not pNavCtrl then
		return
	end
	pNavCtrl:removeWindowControllerByTag(1013);
	sendRappelzWndClose()
	if m_successMsg then
		showMessage(m_successMsg)
		m_successMsg = nil
	end
end
--/*召唤散仙*/
function onClickCallSaintBtn()
	SCActivityIndicator:getSingleton():show()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE)
    dataStream:writeShort(MSG_SOCIATY_SAINT_CALLED_OUT)
	dataStream:writeByte(0)
    SCDataTransThread:getSingleton():transData(dataStream)
end

--/*六芒封魔*/
function onClickRappelzJoinBtn()
	SCActivityIndicator:getSingleton():show()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE)
    dataStream:writeShort(MSG_SOCIATY_RAPPELZ_JION)
    SCDataTransThread:getSingleton():transData(dataStream)
end

--/*召集成员*/
function onClickCallMemberBtn()
	SCActivityIndicator:getSingleton():show()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE)
    dataStream:writeShort(MSG_SOCIATY_MEMBER_CALLED)
    SCDataTransThread:getSingleton():transData(dataStream)
end

--创建窗口
function createRappelzWindow()
	local pWnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(1013))
	local pWndCtrl = SCWindowController:controllerWithWindow(pWnd)
	if not pWndCtrl then
		return nil
	end
	pWnd:setBackgroundColor(color_window_red_bg);
	local imgPath = getRealUIResourcePath("img/titile11.png");
	if imgPath and pWnd then
		pWnd:setTitleWithImage(imgPath:getData());
	end
	local pCallSaintBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-2-25", pWnd))
	local pCallMemberBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-2-24", pWnd))
	local pDragBg = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", pWnd))
	local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-2", pWnd))
	if not pCallSaintBtn or not pCallMemberBtn or not pDragBg or not pDragNode then
		return nil
	end
	pCallSaintBtn:luaSetSelectorOnClicked(onClickCallSaintBtn)
	pCallMemberBtn:luaSetSelectorOnClicked(onClickCallMemberBtn)
	pDragBg:setFrameVisibled(true);
	pDragBg:setFrameType(EnumFrameTypeRound);
	pDragNode:setFrameVisibled(true);
	pDragNode:setFrameType(EnumFrameTypeLine);
	local pTextBox = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlistAndParent("1-2-23", pWnd))
	if not pTextBox then
		return nil
	end
	pTextBox:setScrollVertical(false);
	pTextBox:setScrollHorizontal(false);
	local pNode = SCFunction:getUiNodeByIdlistAndParent("1-3", pWnd)
	if not pNode then
		return nil
	end
	for i=1, 6 do
		local pRole = SCFunction:getUiByZipAndId(1013, 101)
		if not pRole then
			return nil
		end
		pRole:setTag(i);
		pRole:setAnchorPoint(CCPointMake(0, 0));
		setNodePostion(pRole, CCPointMake((i-1)*(getNodeContentSize(pRole).width + 4), 0));
		pNode:addChild(pRole);
		
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("10", pRole))
		if not pBtn then
			return nil
		end
		pBtn:luaSetSelectorOnClicked(onClickRappelzJoinBtn)
		
		local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1", pRole))
		if pImg then
			pImg:setVisible(false);
		end
	end
	return pWndCtrl
end
----------------逻辑功能区-------------------------------------
--封魔动画结束后通知服务端
function sendRappelzWndClose()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE)
    dataStream:writeShort(MSG_SOCIATY_RAPPELZ_CLOSE)
    SCDataTransThread:getSingleton():transData(dataStream)
end
--刷新人物信息
function refreshRoleInfo()
	for i=1, 6 do
		local pRoleBg = SCFunction:getUiNodeByIdlist("1013-1-2-23")
		if not pRoleBg then
			return
		end
		local pRole = pRoleBg:getChildByTag(i)
		if not pRole then
			return
		end
		local pSZRoleImg = getRealUIResourcePath("img/Btn0060.png");
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("10", pRole))
		local pRoleImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1", pRole))
		local pNameLab = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2", pRole))
		local pLab = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("3", pRole))
		if not pBtn or not pRoleImg or not pSZRoleImg or not pNameLab or not pLab then
			return
		end
		pBtn:setVisible(true);
		pRoleImg:setImage(pSZRoleImg:getData());
		pNameLab:setText("");
		pLab:setText("");
	end
end
--填充数据
function fillRappelzInfo(wnd, dt)
	if not wnd then
		return
	end

	local data = stRapplezinfo.initWithStream(dt)
	if #data.vecJoinInfo == 0 then
		refreshRoleInfo()
	end

	local pTextBox = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlistAndParent("1-2-23", wnd))
	local pLab = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-2-27", wnd))
	local pRoleBg = SCFunction:getUiNodeByIdlistAndParent("1-3", wnd)
	if not pTextBox or not pLab or not pRoleBg then
		return
	end

	pLab:setText(data.szLackMan)
	pTextBox:setText(data.szDescribe)
	
	for i=1, #data.vecJoinInfo do
		local pRole = pRoleBg:getChildByTag(i)
		if not pRole then
			return
		end
		pRole:setVisible(true)
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("10", pRole))
		if not pBtn then
			return
		end
		pBtn:setVisible(false)

		local pNameLab = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2", pRole))
		local pLab = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("3", pRole))
		local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("20", pRole))
		if not pNameLab or not pLab or not pImg then
			return
		end
		local imgFace = getFaceImg(data.vecJoinInfo[i].nFaceLook)
		if imgFace then
			imgFace:setAnchorPoint(CCPointMake(0.5, 0.5))
			imgFace:setPosition(CCPointMake(pImg:getContentSize().width / 2, pImg:getContentSize().height / 2))

			pImg:addChild(imgFace);
		end

		pNameLab:setText(data.vecJoinInfo[i].szName)
		if data.vecJoinInfo[i].byType == 1 then
			pLab:setText(_LTParser("str0271"))
		end
	end
end
----------------消息处理区-------------------------------------

----------------消息注册区-------------------------------------

----------------全局函数区-------------------------------------
--收到打开消息时
function Rappalz_processRappelzOpen(dt)
	local pWnd = getCurentSceneWindow(1013)
	if not pWnd then
		local pWndCtrl = createRappelzWindow()
		local pNavCtrl = getCurentSceneNavigationController()
		if pNavCtrl and pWndCtrl then
			pNavCtrl:pushWindowController(pWndCtrl)
			pWnd = pWndCtrl:getWindow()
		end
	end
	if pWnd then
		fillRappelzInfo(pWnd, dt)
	end
end
--
function Rappalz_processRappelzSuceed(dt)
	local msg = dt:readString()
	if msg then
		m_successMsg = msg:getData()
	end
	local pNavCtrl = getCurentSceneNavigationController()
	if not pNavCtrl then
		return
	end

	local wndCtrl = pNavCtrl:getWindowControllerByTag(1013)
	if wndCtrl and wndCtrl:getWindow() then
		local ani = LookfaceParser:getSingleton():getAnimationByIndex(1160, 1160)
		if ani then
			local pnode = SCAnimationNode:nodeWithAnimation(ani)
			ani:luaSetSelectorOnComplete(onSocietyAnimationEnd)
			ani:setAutoremoveOnComplete(true);
			pnode:setAnchorPoint(CCPointMake(0.5, 0.5));
			pnode:setPosition(CCPointMake(wndCtrl:getWindow():getContentSize().width / 2, wndCtrl:getWindow():getContentSize().height / 2))
			pnode:setScaleX(LookfaceParser:getSingleton():getEffectScaleValue(1160 * 10000 + 1160).x)
			pnode:setScaleY(LookfaceParser:getSingleton():getEffectScaleValue(1160 * 10000 + 1160).y)
			wndCtrl:getWindow():addChild(pnode)
		end
	end
end