SendFlowersProcessor = {singleton = nil};

function SendFlowersProcessor:getSingleton()
	if self.singleton ~= nil then
		return self.singleton;
	end
	self.singleton = {};
	
	self.singleton.m_sendEndFlag = true;
	self.singleton.m_id = 0;
	
	function self.singleton:init()
		SCMessageCenter:getSingleton():luaRegistCommand(self.singleton.processSendFlower, _MSG_FLOWER, 0, nil);
	end
	
	function self.singleton.processSendFlower()
		local dt = SCMessageCenter:getSingleton():getDataTransStream();
		local action = dt:readShort();
		if action == MSG_FLOWER_SEND_CONDITION then
			local flowCtrl = SendFlowersController:new();
			if flowCtrl:init(getCurentSceneWindowController(5905)) then
				flowCtrl:refreshCondition(dt);
			end
		elseif action == MSG_FLOWER_SEND_RECORD then
			local flowCtrl = SendFlowersController:new();
			if flowCtrl:init(getCurentSceneWindowController(5905)) then
				flowCtrl:refreshRecord(dt);
			end
		elseif action == MSG_FLOWER_SEND_GET_MAX then
			local flowCtrl = SendFlowersController:new();
			if flowCtrl:init(getCurentSceneWindowController(5905)) then
				flowCtrl:refreshGetMax(dt);
			end
		elseif action == MSG_FLOWER_OPEN_END then
			self.singleton:setSendTimeFlag(true);
			local flowCtrl = SendFlowersController:new();
			if flowCtrl:init(getCurentSceneWindowController(5905)) then
				flowCtrl:refreshRecord();
			end
		elseif action == MSG_FLOWER_SEND_FLOWER then
			self.singleton:showSendFlowSucAni()
		elseif action == MSG_FLOWER_SEND_SHOW_99 then
			self.singleton:show99FlowAni()
		end
	end
	
	function self.singleton.Animation99End()
		local pRunningScene = getRunningScene()
		if pRunningScene then
			if pRunningScene:getUINode():getChildByTag(5704) then
				pRunningScene:getUINode():removeChildByTag(5704, true)
			end
			if pRunningScene:getUINode():getChildByTag(5705) then
				pRunningScene:getUINode():removeChildByTag(5705, true)
			end
		end
	end
	
	function self.singleton:show99FlowAni()
		local id = 9001 * 10000 + 9001
		local fps = LookfaceParser:getSingleton():getEffectFPS(id)
		local pAi = LookfaceParser:getSingleton():getAnimationWithFPS(9001, 9001, fps)
		if pAi then
			pAi:luaSetSelectorOnComplete(self.singleton.Animation99End)
			pAi:setAutoremoveOnComplete(true)
			local pNode = SCAnimationNode:nodeWithAnimation(pAi)
			pNode:setAnchorPoint(CCPointMake(0.5, 0.5))
			if LookfaceParser:getSingleton():isNeedScale(id) then
				pNode:setScaleX(LookfaceParser:getSingleton():getEffectScaleValue(id).x);
				pNode:setScaleY(LookfaceParser:getSingleton():getEffectScaleValue(id).y);
			end
			--pNode:setBackgroundColor(color_black)
			pNode:setPosition(getScreenWidth()/2, getScreenHeight()/2)
			local pNode1 = SCAnimationNode:nodeWithAnimation(pAi)
			pNode1:setAnchorPoint(CCPointMake(0.5, 0.5))
			if LookfaceParser:getSingleton():isNeedScale(id) then
				pNode1:setScaleX(LookfaceParser:getSingleton():getEffectScaleValue(id).x);
				pNode1:setScaleY(LookfaceParser:getSingleton():getEffectScaleValue(id).y);
			end
			--pNode1:setBackgroundColor(color_black)
			pNode1:setPosition(getScreenWidth()/2, 0)
			local pRunningScene = getRunningScene()
			if pRunningScene then
				if pRunningScene:getUINode():getChildByTag(5704) then
					pRunningScene:getUINode():removeChildByTag(5704, true)
				end
				if pRunningScene:getUINode():getChildByTag(5705) then
					pRunningScene:getUINode():removeChildByTag(5705, true)
				end
				pRunningScene:getUINode():addChild(tolua.cast(pNode, "SCNode"), 2147483647, 5704)
				pRunningScene:getUINode():addChild(tolua.cast(pNode1, "SCNode"), 2147483647, 5705)
			end
		end
	end
	
	function self.singleton.AnimationEnd()
		local pRunningScene = getRunningScene()
		if pRunningScene then
			if pRunningScene:getUINode():getChildByTag(5703) then
				pRunningScene:getUINode():removeChildByTag(5703, true)
			end
		end
		local naviCtrl = getCurentSceneNavigationController()
		if naviCtrl then
			if naviCtrl:getWindowControllerByTag(5905) then
				naviCtrl:removeWindowControllerByTag(5905)
			end
		end
	end
	
	function self.singleton:showSendFlowSucAni()
		local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1102, 1116)
		if pAi then
			pAi:luaSetSelectorOnComplete(self.singleton.AnimationEnd)
			pAi:setAutoremoveOnComplete(true)
			local pNode =  SCAnimationNode:nodeWithAnimation(pAi)
			pNode:setAnchorPoint(CCPointMake(0.5, 0.5))
			pNode:setPosition(getScreenWidth()/2, getScreenHeight()/2)
			local pRunningScene = getRunningScene()
			if pRunningScene then
				if pRunningScene:getUINode():getChildByTag(5703) then
					pRunningScene:getUINode():removeChildByTag(5703, true)
				end
				pRunningScene:getUINode():addChild(tolua.cast(pNode, "SCNode"), 2147483647, 5703)
			end
	   end
	end
	
	function self.singleton:setSendTimeFlag(flag)
		self.m_sendEndFlag = flag;
	end

	function self.singleton:getSendTimeFlag()
		return self.m_sendEndFlag;
	end
	
	function self.singleton:setPlayerId(id)
		self.m_id = id;
	end

	function self.singleton:getPlayerId()
		return self.m_id;
	end
	
	function self.singleton:SendOpenFlowerMsg(id)
		local naviCtrl = getCurentSceneNavigationController()
		if naviCtrl then
			naviCtrl:removeWindowControllerByTag(5905)
		end
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_FLOWER);
		dataStream:writeShort(MSG_FLOWER_OPEN_SENDFLOWER);
		dataStream:writeInt(id);
		SCDataTransThread:getSingleton():transData(dataStream);
	end
	
	function self.singleton:SendFlowerTo(id, flowerNum)
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_FLOWER);
		dataStream:writeShort(MSG_FLOWER_SEND_FLOWER);
		dataStream:writeByte(0);
		dataStream:writeInt(id);
		dataStream:writeInt(flowerNum);
		SCDataTransThread:getSingleton():transData(dataStream);
	end
	
	self.singleton.__mode = "kv"; --弱表
	--下面两句相当于new出一个新的实例
	setmetatable(self.singleton, self);
	self.__index = self;
	
	self.singleton:init();
	return self.singleton;
end

SendFlowersController = {};

function SendFlowersController:new(o)
	local class = o or {};
	--定义变量
	class.m_wndCtrl = nil;
	class.m_selectPlayerId = 0;
	class.flowerCond = nil;
	class.flowerList = nil;
	class.getMaxInfo = nil;
	class.m_selectPlayerName = ""
	
	--定义方法
	function class.onClickClose()
		class.m_wndCtrl = nil;
		class.m_selectPlayerId = 0;
		class.flowerCond = nil;
		class.flowerList = nil;
		class.getMaxInfo = nil;
		class.m_selectPlayerName = ""
	end
	
	function class.ctrlEvent(tag, event)
		if event == LuaControllerEventPushEnded then
			showGuideStep(GUIDE_TYPE_FLOWER, -1)
		end
	end
	
	function class:init(wndCtrl)
		if wndCtrl ~= nil then
			if wndCtrl:getWindow()~=nil then
				self.m_wndCtrl = wndCtrl;
				return true;
			end
			return false;
		end
		local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5905));
		wnd:luaSetSelectorOnClose(class.onClickClose);
		wnd:setBackgroundColor(colorWindowRedBG());
		local imgPath = getRealUIResourcePath("img/titile55.png")
        if imgPath then
            wnd:setTitleWithImage(imgPath:getData());
        end
		self.m_wndCtrl = SCWindowController:controllerWithWindow(wnd);
		if self.m_wndCtrl == nil then
			return false;
		end
		self.m_wndCtrl:luaSetSelectorOnEvent(class.ctrlEvent)
		getCurentSceneNavigationController():pushWindowController(self.m_wndCtrl);
		return true;
	end
	
	function class.onClickSendFlowerBtn(tag)
		local flowerNum = 0;
		if tag == 1 then
			flowerNum = 1;
		elseif tag == 2 then
			flowerNum = 9;
		else 
			flowerNum = 99;
		end
		local id = SendFlowersProcessor:getSingleton():getPlayerId();
		SendFlowersProcessor:getSingleton():SendFlowerTo(id, flowerNum);
	end
	
	function class.menuCallBack(tag)
		if tag == 0 then
			gTalkTo(class.m_selectPlayerName);
		elseif tag == 1 then
			luaLookPlayerInfo(class.m_selectPlayerId, "")
			--showMessage("查看功能暂未实现");
		elseif tag == 2 then
			--MailProcessor:getSingleton():showSendMailToPlayer(class.m_selectPlayerName);
			openSendMailWnd(class.m_selectPlayerName)
		elseif tag == 3 then
			SendFlowersProcessor:getSingleton():SendOpenFlowerMsg(class.m_selectPlayerId);
		end
	end
	
	function class.onClickPlayerName(tag)
		class.m_selectPlayerId = tag;
		for i=1, #class.flowerList.stSendFlowers do
			if class.flowerList.stSendFlowers[i].idPlayer==class.m_selectPlayerId then
				class.m_selectPlayerName = class.flowerList.stSendFlowers[i].szName
				break
			end
		end
		
		local strList = menuList:newStringList()
		strList:createMenu(class.m_selectPlayerName,2, _LTParser("str5037"))
		strList:luasetSelector(class.menuCallBack)
	end
	
	function class:refreshCondition(dt)
		if SendFlowersProcessor:getSingleton():getPlayerId() == Hero:getSingleton():getID() then
			return
		end
		local wnd = self.m_wndCtrl:getWindow();
		local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
		
		self.flowerCond  = stFlowerCondition.initWithStream(dt);
		
		for i=1, self.flowerCond.ucAmount do
			local pForamNode = dragNode:getChildByTag(i);
			if pForamNode == nil then
				pForamNode = SCDragNode:node();
				pForamNode:setTag(i);
				pForamNode:setContentSize(CCSizeMake(145 * gUIScale().x, 65 * gUIScale().y));
				pForamNode:setFrameType(EnumFrameTypeRound);
				pForamNode:setFrameVisibled(true);
				dragNode:addChild(pForamNode);
				local pBtn = SCButton:button();
				pBtn:setContentSize(pForamNode:getContentSize());
				pBtn:setTag(i);
				if self.flowerCond.stFlowerTypes[i].ucOpenType == 1 then
					pBtn:luaSetSelectorOnClicked(class.onClickSendFlowerBtn);
				end
				pForamNode:addChild(pBtn);
			end
			local filePath = getRealUIResourcePath(--[["img/"..self.flowerCond.stFlowerTypes[i].nFlowerPhoto..".png"]]"img/img"..5059+i..".png");
			local pFlowerImg = pForamNode:getChildByTag(101);
			if pFlowerImg == nil then
				pFlowerImg = SCImage:imageWithFile(filePath:getData());
				pFlowerImg:setTag(101);
				pForamNode:addChild(pFlowerImg)
			else
				pFlowerImg:setImage(filePath:getData());
			end
			if self.flowerCond.stFlowerTypes[i].ucOpenType == 0 then
				local greyNode = SCNode:node()
				greyNode:setTag(1)
				greyNode:setContentSize(pFlowerImg:getContentSize())
				greyNode:setBackgroundColor(getColorBlackTransparent())
				pFlowerImg:addChild(greyNode)
			else
				if pFlowerImg:getChildByTag(1) ~= nil then
					pFlowerImg:removeChildByTag(1, true)
				end
			end
			pFlowerImg:setAnchorPoint(CCPointMake(0.5, 0.5));
			pFlowerImg:setPosition(CCPointMake(10 * gUIScale().x+pFlowerImg:getContentSize().width/2 ,pForamNode:getContentSize().height/2));
			
			local text = self.flowerCond.stFlowerTypes[i].szFlower.."_*0"..self.flowerCond.stFlowerTypes[i].szAward.."_*5"..self.flowerCond.stFlowerTypes[i].szCondition;
			if self.flowerCond.stFlowerTypes[i].usFlowerNum == 1 then
				text = "*0"..text;
			elseif self.flowerCond.stFlowerTypes[i].usFlowerNum == 9 then
				text = "*4"..text;
			elseif self.flowerCond.stFlowerTypes[i].usFlowerNum == 99 then
				text = "*6"..text;
			end
			local parserNode = pForamNode:getChildByTag(102);
			if parserNode ~= nil then
				pForamNode:removeChildByTag(102, true);
			end
			local parserNode = getItemTextNode(text, 0);
			parserNode:setTag(102);
			parserNode:setAnchorPoint(CCPointMake(0.5, 0.5));
			parserNode:setPosition(pFlowerImg:getContentSize().width+15 * gUIScale().x+parserNode:getContentSize().width/2, pForamNode:getContentSize().height/2);
			pForamNode:addChild(parserNode);
			
			pForamNode:setPosition(5 * gUIScale().x+(5 * gUIScale().x+pForamNode:getContentSize().width)*(i-1), (dragNode:getContentSize().height-pForamNode:getContentSize().height)/2);
		end
	end
	
	--查看鲜花榜
	function class.onClickRankingList(tag)
	    SeeflowerRanking()
	end
	
	function class.onClickConfirmationWindow(tag)
		if tag == 1 then
			local naviCtrl = getCurentSceneNavigationController()
			if not naviCtrl then
				return
			end
			naviCtrl:removeWindowControllerByTag(5905)
			showFriendWnd()
		end
	end
	
	function class:refreshRecord(dt)
		local wnd = self.m_wndCtrl:getWindow();
		local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("2", tolua.cast(wnd, "SCNode")));
		dragNode:setFrameType(EnumFrameTypeRound);
		dragNode:setFrameVisibled(true);
		local pListBox1 = SCTypeCast:castNodeToListBox(dragNode:getChildByTag(21));
		local pListBox2 = SCTypeCast:castNodeToListBox(dragNode:getChildByTag(22));
		local pListBox = nil;
		
		if SendFlowersProcessor:getSingleton():getPlayerId() == Hero:getSingleton():getID() then
			dragNode:setPosition(CCPointMake(166 * gUIScale().x, 39 * gUIScale().x));
			dragNode:setContentSize(CCSizeMake(301 * gUIScale().x, 201 * gUIScale().y));
			pListBox = pListBox2;
			tolua.cast(pListBox1, "SCNode"):setVisible(false);
			tolua.cast(pListBox2, "SCNode"):setVisible(true);
		else
			dragNode:setPosition(CCPointMake(166 * gUIScale().x, 89 * gUIScale().x));
			dragNode:setContentSize(CCSizeMake(301 * gUIScale().x, 151 * gUIScale().x));
			pListBox = pListBox1;
			tolua.cast(pListBox2, "SCNode"):setVisible(false);
			tolua.cast(pListBox1, "SCNode"):setVisible(true);
			local pBtn = SCButton:button();
			pBtn:setTitle(_LTParser("str5038"), getDefaultFontName(), getFontSize(12), colorBlue());
			pBtn:setUnderlineVisibled(true);
			pBtn:luaSetSelectorOnClicked(class.onClickRankingList);
			pBtn:setAnchorPoint(CCPointMake(0.5,0.5));
			pBtn:setPosition(CCPointMake(dragNode:getContentSize().width/2, dragNode:getContentSize().height+pBtn:getContentSize().height/2+5 * gUIScale().y));
			dragNode:addChild(pBtn);
		end
		
		if dt == nil then
			if pListBox:itemCount() == 0 then
				local dragNode = SCNode:node()
				dragNode:setContentSize(CCSizeMake(pListBox:getContentSize().width, 12 * gUIScale().y))
				local label = SCLabel:labelWithStringFont(_LTParser("str5036"), getDefaultFontName(), getFontSize(12));
				label:setColor(colorLightYellow());
				label:setAnchorPoint(CCPointMake(0.5, 0.5))
				label:setPosition(CCPointMake(dragNode:getContentSize().width/2, dragNode:getContentSize().height/2));
				dragNode:addChild(label)
				pListBox:addItem(dragNode)
				if SendFlowersProcessor:getSingleton():getPlayerId() == Hero:getSingleton():getID() then
					luashowConfirmationWindow(_LTParser("str5114"), WIN_YES_NO, class.onClickConfirmationWindow)
				end
			end
			return;
		end
		if SendFlowersProcessor:getSingleton():getSendTimeFlag() then
			pListBox:removeAllItems();
			SendFlowersProcessor:getSingleton():setSendTimeFlag(false);
		end
		
		self.flowerList = stSendFlowerList.initWithStream(dt);
		for i=1, self.flowerList.ucAmount do
			local pNode = SCNode:node();
			
			local nWidthX = 0;
			local filePath = getRealUIResourcePath(--[["img/"..self.flowerList.stSendFlowers[i].nFacePhoto..".png"]]"img/img5043.png");
			local pImg = SCImage:imageWithFile(filePath:getData());
			pImg:setPosition(CCPointMake(nWidthX * gUIScale().x, 0));
			pNode:addChild(pImg);
			
			nWidthX = nWidthX + pImg:getContentSize().width / gUIScale().x +SX(5);
			--local form = SCForm:initWithRowAndCol(1, 1, pImg.getContentSize().width, pImg:getContentSize().height);
			local pDNode = SCDragNode:node();
			pDNode:setDragEnabled(false);
			pDNode:setContentSize(CCSizeMake(200 * gUIScale().x, pImg:getContentSize().height));
			pDNode:setFrameType(EnumFrameTypeRound);
			pDNode:setFrameVisibled(true);
			local pBtn = SCButton:button();
			pBtn:setTitle("["..self.flowerList.stSendFlowers[i].szName.."]", getDefaultFontName(), getFontSize(12), colorLightYellow());
			pBtn:setUnderlineVisibled(true);
			pBtn:setTag(self.flowerList.stSendFlowers[i].idPlayer);
			pBtn:luaSetSelectorOnClicked(class.onClickPlayerName);
			local nStartX = pBtn:getContentSize().width/2 / gUIScale().x+SX(5);
			pBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
			pBtn:setPosition(CCPointMake(nStartX * gUIScale().x, pDNode:getContentSize().height/2));
			pDNode:addChild(pBtn);
			local text= ":"..self.flowerList.stSendFlowers[i].szWords;
			local parserNode = getItemTextNode(text, 0);
			nStartX = nStartX+pBtn:getContentSize().width/2 / gUIScale().x + parserNode:getContentSize().width/2 / gUIScale().x;
			parserNode:setAnchorPoint(CCPointMake(0.5,0.5));
			parserNode:setPosition(CCPointMake(nStartX * gUIScale().x, pDNode:getContentSize().height/2));
			pDNode:addChild(parserNode);
			pDNode:setPosition(nWidthX * gUIScale().x, 0);
			pNode:addChild(pDNode);
			
			nWidthX = nWidthX + pDNode:getContentSize().width / gUIScale().x +SX(2);
			local pLabel = SCLabel:labelWithStringFont(self.flowerList.stSendFlowers[i].szTime, getDefaultFontName(), getFontSize(12));
			pLabel:setColor(colorLightYellow());
			pLabel:setPosition(CCPointMake(nWidthX * gUIScale().x ,(pImg:getContentSize().height-pLabel:getContentSize().height)/2));
			pNode:addChild(pLabel);
			
			pNode:setContentSize(CCSizeMake(pListBox:getContentSize().width, pImg:getContentSize().height+5 * gUIScale().y));
			pListBox:addItem(pNode);
			pNode:setTag(self.flowerList.stSendFlowers[i].idPlayer);
		end
	end
	
	function class:refreshGetMax(dt)
		local wnd = self.m_wndCtrl:getWindow();
		local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
		if not dragNode then
			return
		end
		dragNode:setFrameType(EnumFrameTypeRound);
		dragNode:setFrameVisibled(true);
		self.getMaxInfo = stFlowerSum.initWithStream(dt);
		SendFlowersProcessor:getSingleton():setPlayerId(self.getMaxInfo.idPlayer);
		
		local nHeight = dragNode:getContentSize().height;
		
		if SendFlowersProcessor:getSingleton():getPlayerId() == Hero:getSingleton():getID() then
			dragNode:setPosition(CCPointMake(13 * gUIScale().x, 50 * gUIScale().y))
		else
			dragNode:setPosition(CCPointMake(13 * gUIScale().x, 90 * gUIScale().y))
		end
		
		local filePath = getRealUIResourcePath("img/new00002.png");
		local pImg = SCTypeCast:castNodeToImage(dragNode:getChildByTag(1));
		if pImg == nil then
			pImg = SCImage:imageWithFile(filePath:getData());
			pImg:setTag(1);
			dragNode:addChild(pImg);
			local imgNode = getFaceImg(self.getMaxInfo.nFacePhoto)
			if imgNode and not pImg:getChildByTag(1) then
                imgNode:setAnchorPoint(CCPointMake(0.5, 0.5))
                imgNode:setTag(1)
                setNodePostion(imgNode, CCPointMake(getNodeContentSize(pImg).width/2, getNodeContentSize(pImg).height/2))
                pImg:addChild(imgNode)
             end
		else
			pImg:removeChildByTag(1, true)
			local imgNode = getFaceImg(self.getMaxInfo.nFacePhoto)
			if imgNode and not pImg:getChildByTag(1) then
                imgNode:setAnchorPoint(CCPointMake(0.5, 0.5))
                imgNode:setTag(1)
                setNodePostion(imgNode, CCPointMake(getNodeContentSize(pImg).width/2, getNodeContentSize(pImg).height/2))
                pImg:addChild(imgNode)
             end
		end
		nHeight = nHeight-pImg:getContentSize().height/2-5*gUIScale().y;
		pImg:setAnchorPoint(CCPointMake(0.5,0.5));
		pImg:setPosition(CCPointMake(dragNode:getContentSize().width/2, nHeight));
		
		
		local pNameLabel = SCTypeCast:castNodeToLabel(dragNode:getChildByTag(2));
		if pNameLabel == nil then
			pNameLabel = SCLabel:labelWithStringFont(self.getMaxInfo.szName, getDefaultFontName(), getFontSize(12));
			pNameLabel:setTag(2);
			dragNode:addChild(pNameLabel);
		else
			pNameLabel:setText(self.getMaxInfo.szName);
		end
		nHeight = nHeight-pImg:getContentSize().height/2-pNameLabel:getContentSize().height/2-5*gUIScale().y;
		pNameLabel:setAnchorPoint(CCPointMake(0.5,0.5));
		pNameLabel:setPosition(CCPointMake(dragNode:getContentSize().width/2, nHeight));
		
		local node = tolua.cast(dragNode:getChildByTag(3), "SCDragNode");
		if node == nil then
			node = SCNode:node();
			node:setTag(3);
			dragNode:addChild(node);
		end
		local nNodeX = 0;
		local pXhzsLabel = SCTypeCast:castNodeToLabel(node:getChildByTag(1));
		if pXhzsLabel == nil then
			pXhzsLabel = SCLabel:labelWithStringFont(_LTParser("str5030"), getDefaultFontName(), getFontSize(12));
			pXhzsLabel:setTag(1);
			node:addChild(pXhzsLabel);
		else
			pXhzsLabel:setText(_LTParser("str5030"));
		end
		pXhzsLabel:setPosition(CCPointMake(nNodeX, 0));
		
		nNodeX = nNodeX + pXhzsLabel:getContentSize().width + 3*gUIScale().x;
		local filePath = getRealUIResourcePath(--[["img/"..self.getMaxInfo.nFlowerPhoto..".png"]]"img/img5059.png");
		local pFlowImg = SCTypeCast:castNodeToImage(node:getChildByTag(2));
		if pFlowImg == nil then
			pFlowImg = SCImage:imageWithFile(filePath:getData());
			pFlowImg:setTag(2);
			node:addChild(pFlowImg);
		else
			pFlowImg:setImage(filePath:getData());
		end
		pFlowImg:setPosition(CCPointMake(nNodeX, 0));
		
		nNodeX = nNodeX + pFlowImg:getContentSize().width + 3*gUIScale().x;
		local flowSumLabel = SCTypeCast:castNodeToLabel(node:getChildByTag(3));
		if flowSumLabel == nil then
			flowSumLabel = SCLabel:labelWithStringFont(self.getMaxInfo.nFlowerSum.."", getDefaultFontName(), getFontSize(12));
			flowSumLabel:setColor(colorOrange());
			flowSumLabel:setTag(3);
			node:addChild(flowSumLabel);
		else
			flowSumLabel:setText(self.getMaxInfo.nFlowerSum.."");
		end
		flowSumLabel:setPosition(CCPointMake(nNodeX, 0));
		nNodeX = nNodeX + flowSumLabel:getContentSize().width;
		node:setContentSize(CCSizeMake(nNodeX, pFlowImg:getContentSize().height));
		nHeight = nHeight-pNameLabel:getContentSize().height/2-node:getContentSize().height/2-5*gUIScale().y;
		node:setAnchorPoint(CCPointMake(0.5,0.5));
		node:setPosition(CCPointMake(dragNode:getContentSize().width/2, nHeight));
		
		local parserNode = dragNode:getChildByTag(4);
		if parserNode ~= nil then
			dragNode:removeChildByTag(4, true);
		end
		local parserText = string.format(_LTParser("str5031"), self.getMaxInfo.szPlayerSendMax, self.getMaxInfo.nSendMaxNum, self.getMaxInfo.szPlayerGetMax, self.getMaxInfo.nGetMaxNum);
		local parserNode = getItemTextNode(parserText, 0);
		parserNode:setTag(4);
		nHeight = nHeight-node:getContentSize().height/2-parserNode:getContentSize().height/2-5*gUIScale().y;
		parserNode:setAnchorPoint(CCPointMake(0.5,0.5));
		parserNode:setPosition(CCPointMake(dragNode:getContentSize().width/2, nHeight));
		dragNode:addChild(parserNode);
		
		local pBtn = tolua.cast(dragNode:getChildByTag(5), "SCButton")
		if SendFlowersProcessor:getSingleton():getPlayerId() == Hero:getSingleton():getID() then
			if pBtn == nil then
				pBtn = SCButton:button();
				pBtn:setTag(5)
				pBtn:setTitle(_LTParser("str5038"), getDefaultFontName(), getFontSize(12), colorBlue());
				pBtn:setUnderlineVisibled(true);
			    pBtn:luaSetSelectorOnClicked(class.onClickRankingList);
				pBtn:setAnchorPoint(CCPointMake(0.5,0.5));
				dragNode:addChild(pBtn);
			end
			nHeight = nHeight-parserNode:getContentSize().height/2-pBtn:getContentSize().height/2-5*gUIScale().y;
			pBtn:setPosition(CCPointMake(dragNode:getContentSize().width/2, nHeight));
			pBtn:setVisible(true)
		else
			if pBtn ~= nil then
				pBtn:setVisible(false)
			end
		end
		
		--self:refreshRecord();
	end
	
	function class:getCtrl()
		return self.wndCtrl;
	end
	
	class.__mode = "kv"; --弱表
	--下面两句相当于new出一个新的实例
	setmetatable(class, self);
	self.__index = self;
	return class;	--返回一个实例
end

--查看自己的送花信息
function LookSelfFlowersInfo()
	SendFlowersProcessor:getSingleton():SendOpenFlowerMsg(Hero:getSingleton():getID())
end

--送别人花
function luaSendFlowersTo(sendToId)
    SendFlowersProcessor:getSingleton():SendOpenFlowerMsg(sendToId)
end

--显示送花动画
function showSendFlowSuccessAnimation()
	SendFlowersProcessor:getSingleton():showSendFlowSucAni()
end