--8009 修炼技能学习升级

local _MSG_SKILLSTUDY			=_MSG_GENERAL+161;

local MSG_PRACTICE_MAGIC_QUERY = 3--//修炼技能查看
local MSG_PRACTICE_MAGIC_QUERY_END = 4--//修炼技能查看下发结束消息
local SCRIPT_MAGICS_STUDY=1--//学习技能（原来有）
local SCRIPT_MAGICS_STUDY_SUC=2--//学习技能成功下发（原来有）


local m_wnd = nil

local m_skillList = nil

local function removeAllData()
    m_wnd = nil
    m_skillList = nil
end

local function createMenuItem(width,height,nPhoto,name,level,isTag)
    
	local menuItem = SCButton:button(EnumBtnTypeNormalImg)
	menuItem:setContentSize(CCSizeMake(width,height)) 
    
    local itemBtn = SCButton:button()
    if nPhoto and nPhoto~=0 then
        local itemFile = getRealUIResourcePath("Skill/"..nPhoto..".png");
        if itemFile then
             itemBtn:setTitle(itemFile:getData())
        end
    end
    itemBtn:setBackgroundImage(getRealUIResourcePath(ItemBack_Normal_ImagePath):getData())
    itemBtn:setSelectedImage(getRealUIResourcePath(ItemBack_Click_ImagePath):getData())
    itemBtn:setAnchorPoint(CCPointMake(0,0.5));
    itemBtn:setPosition(CCPointMake(SX(2),height/2));
    itemBtn:setTouchEnabled(false)--不能点击
    menuItem:addChild(itemBtn)
    
    local tmpX = itemBtn:getContentSize().width+SX(3)
    local tmpY = height
    local itemName = name
    if itemName == nil then
        itemName = ""
    end
    --物品名称
    local titleLabel = ParsedNode:getParsedNode(itemName,0,10)
    titleLabel:setAnchorPoint(CCPointMake(0,0));
    titleLabel:setPosition(CCPointMake(tmpX,tmpY-titleLabel:getContentSize().height-SY(5)));
    menuItem:addChild(titleLabel)
    tmpY = titleLabel:getPosition().y
    
    if level then
        --等级
        local levlLabel = ParsedNode:getParsedNode(level,0,10)
        levlLabel:setAnchorPoint(CCPointMake(0,0));
        levlLabel:setPosition(CCPointMake(tmpX,tmpY-levlLabel:getContentSize().height-SY(5)));
        menuItem:addChild(levlLabel)
    end
    
    
    local upBtn = SCButton:button(EnumBtnTypeNormalImg)
    local path = "img/skillarrowgray.png"
    if isTag == 1 then
        path = "img/skillarrow.png"
        upBtn:setTouchEnabled(true)
    else
        upBtn:setTouchEnabled(false)--不能点击
    end
    upBtn:setBackgroundImage(getRealUIResourcePath(path):getData())
    upBtn:setAnchorPoint(CCPointMake(0.5,0.5));
    upBtn:setPosition(CCPointMake(width*0.88,height/2));
    menuItem:addChild(upBtn)
    
    return menuItem,upBtn
end


local function menuItemButtonAction(tag)
    if m_wnd == nil then
        return
    end
    local listIndex = tag
    if m_skillList and listIndex and m_skillList[listIndex] then
        local detail = m_skillList[listIndex].szDescribe
        if detail == nil then
            return
        end
        local showWidth  = SX(150)
	    local showHeight = SY(100)
	    local width  = getScreenWidth()--当前屏幕宽
        local height = getScreenHeight()--当前屏幕高
        local frameWndNode = FrameWindow:frameWnd()
	    frameWndNode:setContentSize(CCSizeMake(showWidth, showHeight))
	    frameWndNode:setOutSpaceClickClose(true)
	    frameWndNode:setCloseBtnVisible(true)--是否显示关闭按钮
	    frameWndNode:setAnchorPoint(CCPointMake(0.5, 0.5))
	    frameWndNode:setPosition(CCPointMake(width/2,height/2))
	    
	    local detailLabel = ParsedNode:getParsedNode(detail,0,10)
        detailLabel:setAnchorPoint(CCPointMake(0,0));
        detailLabel:setPosition(CCPointMake(SX(10),showHeight-detailLabel:getContentSize().height-SY(10)));
        frameWndNode:addChild(detailLabel)
        m_wnd:addChild(frameWndNode)
    end
end

--点击升级
local function upBtnButtonAction(tag)
    local listIndex = tag
    
    if m_skillList and tag and m_skillList[listIndex] then
        sendStudySkill_SkillStudyScreen(m_skillList[listIndex].idType,m_skillList[listIndex].ucLevel)
        setRestartGuideFlag(GUIDE_TYPE_BOOK, false);
		showGuideStep(GUIDE_TYPE_BOOK, 5, 4);
    end
end

--刷新阅历
local function refreshExperience()
     if m_wnd == nil then
        return
    end
    local expLabel = SCFunction:getUiNodeByIdlistAndParent("800902-1",m_wnd)
    if expLabel then
        expLabel = SCTypeCast:castNodeToLabel(expLabel)
        local hero = Hero:getSingleton() 
	    local experienceValue = hero:getExperience()
	    if experienceValue == nil then
	        experienceValue = 0
        end
        expLabel:setText(_LTParser("str8040")..":"..experienceValue)
    end
end
--学习技能成功刷新当前界面
local function refreshSkillList()
    if m_wnd== nil then
        return
    end
    local fatherLayer = m_wnd:getChildByTag(800901);
    if fatherLayer == nil then
        return
    end

    local scrollBox = fatherLayer:getChildByTag(1);
    if scrollBox then
        scrollBox = SCTypeCast:castNodeToPageScrollBox(scrollBox)
    else
        return
    end
    if m_skillList == nil then
	    return
    end
    local total = #m_skillList
    if total < 1 then
        return
    end
    
    local showWidth  = fatherLayer:getContentSize().width*0.98
    local showHeight = fatherLayer:getContentSize().height
    
    local pageAmount = 12
	--local pageSize = scrollBox:getPageCount()
	local pageIndex = scrollBox:getPageIndex()+1--索引从0开始，因为设置的页面标签从1开始所以要加1
	local menuBgImgPath  = getRealUIResourcePath("img/skillframe.png"):getData()
    local menuBgImgClickPath = getRealUIResourcePath("img/skillframeselect.png"):getData()
    local menuWidth  = 0
    local menuHeight = 0

    local menuBgImg = SCImage:imageWithFile(menuBgImgPath)
    if menuBgImg then
        menuWidth  = menuBgImg:getContentSize().width
        menuHeight = menuBgImg:getContentSize().height
    end
    
    local rowAmount  = 3        
    local tmpX = 0
    local tmpY = showHeight
    local spaceW = (showWidth-menuWidth*3)/4
    local spaceH = (showHeight-menuHeight*3)/10
	--for i=1,pageSize do
	    local pageNodeLayer = scrollBox:getChildByTag(pageIndex)
        if pageNodeLayer then
            pageNodeLayer:removeAllChildrenWithCleanup(true)
        else
            return
        end
        local startIndex = pageAmount*(pageIndex-1)
        local endIndex = pageAmount*pageIndex-1
        local index = 1
        for j=1,pageAmount do
            local listIndex = startIndex+j
            if listIndex > total then
                break
            end
            local row = math.ceil(index/rowAmount)--向上取整例如：1/2 = 1
            local col = math.mod(index,rowAmount)
            if row < 1 then
                row = 1
            end
            if  col == 0 then
                col = rowAmount
            end
            tmpX = spaceW+(menuWidth+spaceW)*(col-1)
            local icon  = m_skillList[listIndex].nPhoto
            local name  = m_skillList[listIndex].szName
            local level = string.format(_LTParser("str8038"),m_skillList[listIndex].ucLevel)
            local isTag = m_skillList[listIndex].ucCanStudy--是否可学习
            local menuItem,upBtn = createMenuItem(menuWidth,menuHeight,icon,name,level,isTag)
            menuItem:setTag(listIndex)
            menuItem:setAnchorPoint(CCPointMake(0,0));
            menuItem:setPosition(CCPointMake(tmpX,tmpY-(menuHeight+spaceH )*row+SY(3)));
            menuItem:setBackgroundImage(menuBgImgPath)
            menuItem:setSelectedImage(menuBgImgClickPath)
            menuItem:luaSetSelectorOnClicked(menuItemButtonAction)
            upBtn:luaSetSelectorOnClicked(upBtnButtonAction)
            upBtn:setTag(listIndex)
            pageNodeLayer:addChild(menuItem)
            menuItem:setTouchRectScale(0.65,1)
            upBtn:setTouchRectScale(1.5,1.5)
            index = index + 1
        end
     --   pageIndex = pageIndex + 1
   -- end
end

--上一页
local function upPageAction()
    refreshSkillList()
end

--下一页
local function nextPageAction()
    refreshSkillList()
end


--显示技能列表
local function showSkillListContent()
    if m_wnd == nil then
        return
    end
    local fatherLayer = m_wnd:getChildByTag(800901);
    if fatherLayer == nil then
        return
    end
    
    local width = fatherLayer:getContentSize().width
    local height = fatherLayer:getContentSize().height
    
    local showWidth  = width*0.98
    local showHeight = height
    local scrollBox = SCPageScrollBox:boxWithWidthHeight(showWidth,showHeight)
    scrollBox:setTag(1)
	scrollBox:setAnchorPoint(CCPointMake(0.5,0));
	scrollBox:setPosition(CCPointMake(width/2,0));
	scrollBox:setScrollHorizontal(true)
    scrollBox:setScrollVertical(false)
    scrollBox:setPageSize(CCSizeMake(showWidth,showHeight));
    scrollBox:luaSetSelectorOnScrollToPrevious(upPageAction)
    scrollBox:luaSetSelectorOnScrollToNext(nextPageAction)
    
    local scPageHint = SCPageHint:hintWithType(EnumPgaeHintTypeHorizontal)
    scPageHint:setAnchorPoint(CCPointMake(0.5,0.5));
	scPageHint:setPosition(CCPointMake(width/2,SY(10)));
	scPageHint:setBoundPageScrollBox(scrollBox)
	
	fatherLayer:addChild(scrollBox)
	fatherLayer:addChild(scPageHint)
	
	
	if m_skillList == nil then
	    return
    end
    local total = #m_skillList
    if total < 1 then
        return
    end
    local pageAmount = 12
	local pageSize = math.ceil(total/pageAmount)
	local pageIndex = 1
	local menuBgImgPath  = getRealUIResourcePath("img/skillframe.png"):getData()
    local menuBgImgClickPath = getRealUIResourcePath("img/skillframeselect.png"):getData()
    local menuWidth  = 0
    local menuHeight = 0

    local menuBgImg = SCImage:imageWithFile(menuBgImgPath)
    if menuBgImg then
        menuWidth  = menuBgImg:getContentSize().width
        menuHeight = menuBgImg:getContentSize().height
    end
    
    local rowAmount  = 3        
    local tmpX = 0
    local tmpY = showHeight
    local spaceW = (showWidth-menuWidth*3)/4
    local spaceH = (showHeight-menuHeight*3)/10
	for i=1,pageSize do
	    local pageNodeLayer = SCDragNode:node()
        pageNodeLayer:setTag(pageIndex)
        pageNodeLayer:setAnchorPoint(CCPointMake(0,0));
        pageNodeLayer:setPosition(CCPointMake((pageIndex-1)*showWidth,0));
        pageNodeLayer:setContentSize(CCSizeMake(showWidth,showHeight))
        scrollBox:setContentSize(CCSizeMake(showWidth*pageIndex,showHeight))
        scrollBox:addChild(pageNodeLayer)
        
        local startIndex = pageAmount*(i-1)
        local endIndex = pageAmount*i-1
        local index = 1
        for j=1,pageAmount do
            local listIndex = startIndex+j
            if listIndex > total then
                break
            end
            local row = math.ceil(index/rowAmount)--向上取整例如：1/2 = 1
            local col = math.mod(index,rowAmount)
            if row < 1 then
                row = 1
            end
            if  col == 0 then
                col = rowAmount
            end
            tmpX = spaceW+(menuWidth+spaceW)*(col-1)
            local icon  = m_skillList[listIndex].nPhoto
            local name  = m_skillList[listIndex].szName
            local level = string.format(_LTParser("str8038"),m_skillList[listIndex].ucLevel)
            local isTag = m_skillList[listIndex].ucCanStudy--是否可学习
            local menuItem,upBtn = createMenuItem(menuWidth,menuHeight,icon,name,level,isTag)
            menuItem:setTag(listIndex)
            menuItem:setAnchorPoint(CCPointMake(0,0));
            menuItem:setPosition(CCPointMake(tmpX,tmpY-(menuHeight+spaceH )*row+SY(3)));
            menuItem:setBackgroundImage(menuBgImgPath)
            menuItem:setSelectedImage(menuBgImgClickPath)
            menuItem:luaSetSelectorOnClicked(menuItemButtonAction)
            upBtn:luaSetSelectorOnClicked(upBtnButtonAction)
            upBtn:setTag(listIndex)
            pageNodeLayer:addChild(menuItem)
            
            index = index + 1
        end
        pageIndex = pageIndex + 1
    end
end




--获取技能列表数据
local function processSkillListData(dt)
    if dt == nil then
        return
    end
    if m_skillList == nil then
        m_skillList = {}
    end
    local roleId = dt:readInt()
    local ucAmount = dt:readByte()
    for i=1,ucAmount do
        local nPhoto     = dt:readInt()
        local idType     = dt:readInt()
        local szName     = dt:readString()
        local ucLevel    = dt:readByte()--//当前等级
        local ucLastlev  = dt:readByte()--//最大等级
        local ucCanStudy = dt:readByte()--//是否能学习
        local szDescribe = dt:readString()--tip
        local tmpDetail = {}
        tmpDetail.nPhoto = nPhoto
        tmpDetail.idType = idType
        if szName then
            tmpDetail.szName = szName:getData()
        end
        tmpDetail.ucLevel = ucLevel
        tmpDetail.ucLastlev = ucLastlev
        tmpDetail.ucCanStudy = ucCanStudy
        if szDescribe then
            tmpDetail.szDescribe = szDescribe:getData()
        end
        
        table.insert(m_skillList,tmpDetail);
    end
    
end

--升级成功数据下发
local function processUpSuccessData(dt)
    local szName         = dt:readString()
    
    local idOldMagicType = dt:readInt()
    local idNewMagicType = dt:readInt()
    local ucLevel        = dt:readByte()
    local usCanStudy     = dt:readShort()
    local nPhoto         = dt:readInt()
    local szDescribe     = dt:readString()
   
    local size = #m_skillList
    for i=1,size do
        if m_skillList[i] and m_skillList[i].idType == idOldMagicType then
            m_skillList[i].idType = idNewMagicType
            if szName then
                m_skillList[i].szName = szName:getData()
            end
            m_skillList[i].ucLevel = ucLevel
            m_skillList[i].ucCanStudy = usCanStudy
            m_skillList[i].nPhoto = nPhoto
            if szDescribe then
                m_skillList[i].szDescribe = szDescribe:getData()
            end
        end
    end
    local amount = dt:readByte()
    for i=1,amount do
        local idMagicType = dt:readInt()
        local usCanStudy  = dt:readShort()
        for j=1,size do
            if m_skillList[j] and m_skillList[j].idType == idMagicType then
                m_skillList[j].ucCanStudy = usCanStudy
            end
        end
    end
    refreshExperience()
end

local function initShowExperience()
    if m_wnd == nil then
        return
    end
    local topLayer = m_wnd:getChildByTag(800902);
    if topLayer == nil then
        return
    end
    
    topLayer = SCTypeCast:castNodeToDragNode(topLayer)
    topLayer:removeAllChildrenWithCleanup(true)
    
    local showHeight = topLayer:getContentSize().height
    
    --图标
    local imgFile = getRealUIResourcePath("img/img5032.png");
	if imgFile then
        local imageLabel = SCImage:imageWithFile(imgFile:getData()) 
        imageLabel:setAnchorPoint(CCPointMake(0,0.5));
        imageLabel:setPosition(CCPointMake(0,showHeight/2));
        topLayer:addChild(imageLabel)
	end
	--阅历
	local hero = Hero:getSingleton() 
	local experienceValue = hero:getExperience()
	if experienceValue == nil then
	    experienceValue = 0
    end
    local experienceLabel = SCLabel:labelWithStringFont(_LTParser("str8040")..":"..experienceValue,getDefaultFontName(), getFontSize(12))
    experienceLabel:setTag(1)
    experienceLabel:setAnchorPoint(CCPointMake(0,0.5));
    experienceLabel:setPosition(CCPointMake(SX(18),showHeight/2));
    topLayer:addChild(experienceLabel)
end
--ctrl回调
local function ctrlEvent(tag, eventType)
    if eventType == LuaControllerEventPushEnded then
		setRestartGuideFlag(GUIDE_TYPE_BOOK, false);
		showGuideStep(GUIDE_TYPE_BOOK, 4, 3);
    elseif eventType == LuaControllerEventPopBegan or eventType == LuaControllerEventRemoveBegan then
		if getRestartGuideFlag(GUIDE_TYPE_BOOK) then
			restartGuideStep(GUIDE_TYPE_BOOK);
		else
			showGuideStep(GUIDE_TYPE_BOOK, -1);
		end
    end
end
--打开界面
local function open_SkilStudyScreen()
    if getCurentSceneWindowController(8009) then
        return;
    end
    --获取创建窗口
    local wnd = SCWindow:window()
    wnd:setContentSize(CCSizeMake(SX(480), SY(320)))
    wnd:setTag(8009);
    wnd:luaSetSelectorOnClose(onClickClose);
    wnd:setBackgroundColor(colorWindowRedBG());
    wnd:luaSetSelectorOnClose(removeAllData);
    local imgFile = getRealUIResourcePath("img/titile45.png");
	if imgFile then
	   wnd:setTitleWithImage(imgFile:getData())
	end
	
	local wndCtrl = SCWindowController:controllerWithWindow(wnd)
	wndCtrl:luaSetSelectorOnEvent(ctrlEvent)
	local scene = SCBaseScene:getRunningScene()
	local naviCtrl =  scene:getNavigationController()
	naviCtrl:pushWindowController(wndCtrl)
	
	m_wnd =  getCurentSceneWindowController(8009):getWindow();
	
	local width  = SX(480)--当前屏幕宽
    local height = SY(320)--当前屏幕高
	
    local showWidth  = width*0.94
    local showHeight = height*0.78
    local startX = SX(15)
    local startY = SY(15)
    
    local contentLayer = SCDragNode:node()
    contentLayer:setTag(800901)
    contentLayer:setFrameVisibled(true)
    contentLayer:setFrameType(EnumFrameTypeRound)
    contentLayer:setAnchorPoint(CCPointMake(0,0));
	contentLayer:setPosition(CCPointMake(startX,startY));
	contentLayer:setContentSize(CCSizeMake(showWidth,showHeight))
    m_wnd:addChild(contentLayer)
    
    --显示头部阅历值
    local topLayer = SCDragNode:node()
    topLayer:setTag(800902)
    topLayer:setFrameVisibled(true)
    topLayer:setFrameType(EnumFrameTypeListNormal)
    topLayer:setAnchorPoint(CCPointMake(0,0.5));
	topLayer:setPosition(CCPointMake(width*0.32,height*0.91));
	topLayer:setContentSize(CCSizeMake(SX(120),SY(18)))
    m_wnd:addChild(topLayer)
    
    initShowExperience()
    
  
end

local function receiveMagicinfoMsg()
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    if dt == nil then
        return;
    end
    local action = dt:readShort()
    if action == MSG_PRACTICE_MAGIC_QUERY then--//修炼技能列表
        open_SkilStudyScreen()
        processSkillListData(dt)
    elseif action == MSG_PRACTICE_MAGIC_QUERY_END then--//修炼技能查看下发结束消息
        open_SkilStudyScreen()
        processSkillListData(dt)
        showSkillListContent()
        SCActivityIndicator:getSingleton():close()
    elseif action == SCRIPT_MAGICS_STUDY_SUC then--学习技能成功
        processUpSuccessData(dt)
        refreshSkillList()
    end
end

--发送请求打开技能学习升级界面
function sendOpenMsg_SkillStudyScreen()
    local hero = Hero:getSingleton()  
    
    local dt = SCDataTransStream:streamWithCommand(_MSG_SKILLSTUDY);
    dt:writeShort(MSG_PRACTICE_MAGIC_QUERY);
    dt:writeInt(hero:getID());
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

--发送学习技能消息
function sendStudySkill_SkillStudyScreen(idSkillType,skillLev)
    if idSkillType and skillLev then
        local dt = SCDataTransStream:streamWithCommand(_MSG_SKILLSTUDY);
        dt:writeShort(SCRIPT_MAGICS_STUDY);
        dt:writeInt(idSkillType);
        dt:writeInt(skillLev);
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end



SCMessageCenter:getSingleton():luaRegistCommand(receiveMagicinfoMsg,_MSG_SKILLSTUDY, 0, nil);