local _MSG_SYNWAR                           = _MSG_GENERAL + 176; --//公会战头消息
local MSG_SOCIATY_SIGN_GAME_LIST            = 56;    --//已报名参加公会战的公会列表
local ACTION_TRIBEWAR_CLOSE_WINDOW            = 17;     --//关闭公会战配对界面
local ACTION_TRIBEWAR_SIGN_AFFIRM           = 16;    --//公会战报名
local ACTION_TRIBEWAR_PAIR_INFO             = 15;    --//公会配对界面
local ACTION_TRIBEWAR_PAIR_READY_INFO       = 14;    --//公会配对界面的准备时间,当前几强赛
local ACTION_TRIBEWAR_REPORT                = 13;    --//公会战报告
local ACTION_TRIBEWAR_LEAVE_MAP             = 12;    --//离开公会战地图
local ACTION_TRIBEWAR_ENTER_MAP             = 11;    --//进入公会战地图
local MSG_TRIBE_WAR_TIME_LEAVE              = 30;    --//公会战准备时间(地图内)
local MSG_TRIBE_WAR_FIGHT_INFO              = 31;    --//公会战基本信息(地图内)
local MSG_TRIBE_WAR_UPDATE_USERNUM          = 32;    --//公会战更新剩余人数(地图内)
local ARENASCRIPT_TRIBEWAR_GIFT_LIST        = 43;    --//分配战利品列表
local ARENASCRIPT_TRIBEWAR_GIFT_MEMBER      = 44;    --//分配战利品下发参与玩家
local ARENASCRIPT_TRIBEWAR_GIFT_MEMBER_OK   = 45;    --//确定分配



local MatchingInterfaceInfo = {__mode = "kv",};
local BattleReportInfo = {__mode = "kv",};
local TrophieInfo = {__mode = "kv"};
local JoinPlayerInfo = {__mode = "kv"};

local idAwardItem1 = nil;
local idAwardItem2 = nil;

local stSignGameInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            usSignNum, --//报名公会个数
            ucFlag,    --//0:可报名;  1:已报名
        }
        tmp.usSignNum = dt:readShort()
        tmp.ucFlag = dt:readByte();
        tmp.idAwardItem1 = dt:readInt();        --//冠军奖励物品类型
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szItemName1 = ""
        else
            tmp.szItemName1 = scStr:getData()
        end                                     --//冠军奖励物品名字
        tmp.idAwardItem2 = dt:readInt();        --//亚军奖励
        scStr = dt:readString()
        if scStr == nil then
            tmp.szItemName2 = ""
        else
            tmp.szItemName2 = scStr:getData()
        end
        idAwardItem1 = tmp.idAwardItem1;
        idAwardItem2 = tmp.idAwardItem1;
        return tmp
    end;
}

local stSignGameSociaty = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            usNo,                --//编号
            szTribeName,        --//公会名称
            usLevel,            --//公会等级
            nReputation,        --//公会贡献
        }
        tmp.usNo = dt:readShort()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTribeName = ""
        else
            tmp.szTribeName = scStr:getData()
        end
        tmp.usLevel = dt:readShort();
        tmp.nReputation = dt:readInt();
        return tmp
    end;
}


local tMSG_Info19 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            ucAmount,
        }
        tmp.stfill = {};
        tmp.ucAmount = dt:readByte();
        for i = 1, tmp.ucAmount do
            table.insert(tmp.stfill, stSignGameSociaty.initWithStream(dt))
        end
        return tmp
    end
}

local stTribePair = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idTribe1 = dt:readInt();            --//公会id1
        tmp.idTribe2 = dt:readInt();            --//公会id2
        tmp.idWinTribe = dt:readInt();            --//胜利公会id
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTribe1 = "" --公会名字
        else
            tmp.szTribe1 = scStr:getData()
        end
        scStr = dt:readString()
        if scStr == nil then
            tmp.szTribe2 = ""
        else
            tmp.szTribe2 = scStr:getData()
        end
        tmp.ucGameStatus = dt:readByte();        --//0: 等待中  1:已开始  2:查看
        return tmp
    end;
}

local stTribeWarPairInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }                
        tmp.ucWarPair = dt:readByte();        --//几强赛
        tmp.ucPairAmount = dt:readByte();    --//配对个数
        tmp.stPairFill = {};
        for i = 1, tmp.ucPairAmount do
            table.insert(tmp.stPairFill, stTribePair.initWithStream(dt))
        end
        return tmp;
    end
}

local tMsg_Info3 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }        
        tmp.ucAmount = dt:readByte();
        tmp.stfill = {};
        for i = 1, tmp.ucAmount do
            table.insert(tmp.stfill, stTribeWarPairInfo.initWithStream(dt))
        end
        return tmp;
    end
}

local stTribeWarReadyInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucWarFlag = dt:readByte();    --//0:准备(可以进入战场) 1:已开始  2:已结束
        tmp.ucWarPair = dt:readByte();    --//几强赛
        tmp.nLeaveTime = dt:readInt();    --//准备时间
        return tmp;
    end
}

local struTribeWarInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucWarNum = dt:readByte();        --//几强赛
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTribe1 = "" --公会名称1
        else
            tmp.szTribe1 = scStr:getData()
        end
        tmp.ucTribeLev1 = dt:readByte();                --//公会等级1
        tmp.usLeaveNum1 = dt:readShort();                --//公会剩余人数1
        scStr = dt:readString()
        if scStr == nil then
            tmp.szTribe2 = "" --公会名称2
        else
            tmp.szTribe2 = scStr:getData()
        end
        tmp.ucTribeLev2 = dt:readByte();                --//公会等级2
        tmp.usLeaveNum2 = dt:readShort();                --//公会剩余人数2
        return tmp;
    end
}

local stTribeWarReport = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTribeName = ""
        else
            tmp.szTribeName = scStr:getData()
        end
        scStr = dt:readString()
        if scStr == nil then
            tmp.szUserName = ""
        else
            tmp.szUserName = scStr:getData()
        end
        tmp.usKillNum = dt:readShort();        --//击杀人数
        tmp.nReputation = dt:readInt();    --//声望奖励
        tmp.nMoney = dt:readInt();            --//金钱奖励
        tmp.ucWinFlag = dt:readByte();        --//1:胜方
        return tmp;
    end
}

local tMsg_Info2 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucAmount = dt:readByte();
        tmp.stfill = {};
        for i = 1, tmp.ucAmount do
            table.insert(tmp.stfill, stTribeWarReport.initWithStream(dt))
        end
        return tmp;
    end
}

local stTribeWarGiftMember = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idMember = dt:readInt();                --//成员id
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szName = ""
        else
            tmp.szName = scStr:getData()  --//名字
        end
        return tmp;
    end
}

local tMsg_Info8 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucAmount = dt:readByte();
        tmp.stfill = {};
        for i = 1, tmp.ucAmount do
            table.insert(tmp.stfill, stTribeWarGiftMember.initWithStream(dt))
        end
        JoinPlayerInfo = tmp;
        return tmp;
    end
}

local stTribeWarGift = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szItemName = ""
        else
            tmp.szItemName = scStr:getData()    --//物品名字
        end
        return tmp;
    end
}

local tMsg_Info10 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucAmount = dt:readByte();
        tmp.stfill = {};
        for i = 1, tmp.ucAmount do
            table.insert(tmp.stfill, stTribeWarGift.initWithStream(dt))
        end
        TrophieInfo = tmp;
        return tmp;
    end
}

local function SocietyBattleApplyWndClose()
    idAwardItem1 = nil;
    idAwardItem2 = nil;
end

local function onClickSocietyBattleType(tag)
    if 3 == tag then   
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_SOCIATY_SIGN_GAME_LIST);
        SCDataTransThread:getSingleton():transData(dt);
        local navige = getCurentSceneNavigationController();
        if navige then
            navige:removeWindowControllerByTag(7010);
        end
    elseif 4 == tag then
        local dt = SCDataTransStream:streamWithCommand(_MSG_SYNWAR);
        dt:writeShort(ACTION_TRIBEWAR_SIGN_AFFIRM);
        dt:writeByte(0);
        SCDataTransThread:getSingleton():transData(dt);
    end
    SCActivityIndicator:getSingleton():show();
end

local function createWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7010));
    if wnd == nil then
        return nil;
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/titile67.png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    wnd:luaSetSelectorOnClose(SocietyBattleApplyWndClose);    
    wnd:setBackgroundColor(colorWindowRedBG());        
    local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    if pDragNode then
        pDragNode:setFrameVisibled(true);
        pDragNode:setFrameType(EnumFrameTypeRound);
    end
    local pTextBox = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlistAndParent("1-2", tolua.cast(wnd, "SCNode")));
    if pTextBox then
        for i = 1, 5 do
            pTextBox:addLine(_LTParser("str606" .. i)); 
        end      
        pTextBox:setScrollVertical(false);
    end
    local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-3", tolua.cast(wnd, "SCNode")));
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onClickSocietyBattleType);
    end
    pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-4", tolua.cast(wnd, "SCNode")));
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onClickSocietyBattleType);
    end
    return SCWindowController:controllerWithWindow(wnd);
end

local function OnClickTrophies(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEMTYPEINFO);
    if dataStream == nil then
        return;
    end
    dataStream:writeByte(MSG_ITEMTYPEINFO_QUERY);
    if 8 == tag then
        dataStream:writeInt(idAwardItem1);
    else
        dataStream:writeInt(idAwardItem2);
    end
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show()
    end
end

local function setSocietyBattleApplyData(tmp)
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7010-1-6"));
    if pLabel then
        local str = tmp.usSignNum .. _LTParser("str2008") .. "(";
        if 0 == tmp.ucFlag then
            str = str .. _LTParser("str6066");
        elseif 1 == tmp.ucFlag then
            str = str .. _LTParser("str6067");
            local pBtn3 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("7010-1-3"));               
            local pBtn4 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("7010-1-4")); 
            if pBtn4 and pBtn3 then
                pBtn4:setVisible(false);
                local pNode = SCFunction:getUiNodeByIdlist("7010-1");
                if pNode then
                    pBtn3:setAnchorPoint(CCPointMake(0.5, 0));
                    pBtn3:setPosition(CCPointMake(pNode:getContentSize().width / 2, pBtn3:getPosition().y));
                end
            end 
        end
        pLabel:setText(str .. ")");
    end    
    local Btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("7010-1-8"));
    if Btn then
        Btn:setTitle(tmp.szItemName1, getDefaultFontName(), getFontSize(10));
        Btn:luaSetSelectorOnClicked(OnClickTrophies);
    end
    Btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("7010-1-9"));
    if Btn then
        Btn:setTitle(tmp.szItemName2, getDefaultFontName(), getFontSize(10));
        Btn:luaSetSelectorOnClicked(OnClickTrophies);
    end
end

local function setWindowBattleApplyAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
    end
end

local function showSocietyBattleApplyWnd(tmp)
    local wndCtrl = createWnd();
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl, NavigateStyleBottomToTop);
        wndCtrl:luaSetSelectorOnEvent(setWindowBattleApplyAttribute);
        setSocietyBattleApplyData(tmp);
    end
end

local function SocietyBattleViewWndClose()
end

local function joinInTeam(tag, itemTag, itemIndex)
    local node = tolua.cast(SCFunction:getUiNodeByIdlist("7011-1-3-"..itemTag), "SCDragNode");
    --[[if node then
        node:setFrameType(EnumFrameTypeListSelect)
        node:setFrameVisibled(true)
    end]]
end

local function unSelset(tag, itemTag, itemIndex)
    local node = tolua.cast(SCFunction:getUiNodeByIdlist("7011-1-3-"..itemTag), "SCDragNode");   
    --[[if node then
        node:setFrameType(EnumFrameTypeListNormal)
        node:setFrameVisibled(true)
    end]]
end

local function createWndView()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7011));
    if wnd == nil then
        return nil;
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/titile73.png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    wnd:luaSetSelectorOnClose(SocietyBattleViewWndClose);    
    wnd:setBackgroundColor(colorWindowRedBG());        
    local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    if pDragNode then
        pDragNode:setFrameVisibled(true);
        pDragNode:setFrameType(EnumFrameTypeRound);
    end
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("7", tolua.cast(wnd, "SCNode")));
    if pLabel then
        pLabel:setText(_LTParser("str6068"));
    end
    pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("8", tolua.cast(wnd, "SCNode")));
    if pLabel then
        pLabel:setText(_LTParser("str6069"));
    end
    local pListBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlistAndParent("1-3", tolua.cast(wnd, "SCNode")));
    if pListBox then        
        pListBox:luaSetSelectorOnItemSelected(joinInTeam)
        pListBox:luaSetSelectorOnItemUnSelected(unSelset)   
    end
    return SCWindowController:controllerWithWindow(wnd);
end

local function setSocietyBattleViewData(tmp)
    local listBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("7011-1-3"));
    if listBox == nil then
        return;
    end
    for i = 1, tmp.ucAmount do        
        local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(7011, 100));
        if pDragNode then
            pDragNode:setFrameType(EnumFrameTypeListNormal)
            pDragNode:setFrameVisibled(true)
            local pLabel = SCTypeCast:castNodeToLabel(pDragNode:getChildByTag(1));
            if pLabel then
                pLabel:setText(tmp.stfill[i].usNo);
            end
            pLabel = SCTypeCast:castNodeToLabel(pDragNode:getChildByTag(2));
            if pLabel then
                pLabel:setText(tmp.stfill[i].szTribeName);
            end
            pLabel = SCTypeCast:castNodeToLabel(pDragNode:getChildByTag(3));
            if pLabel then
                pLabel:setText(tmp.stfill[i].usLevel);
            end
            pLabel = SCTypeCast:castNodeToLabel(pDragNode:getChildByTag(4));
            if pLabel then
                pLabel:setText(tmp.stfill[i].nReputation);
            end
            listBox:addItem(pDragNode);
        end
    end
end

local function setWindowAttributeView(tag, type)    
    if type == LuaControllerEventPushEnded then
    end
end

local function showSocietyBattleViewWnd(tmp)
    local wndCtrl = createWndView();
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl, NavigateStyleLeftToRight);
        wndCtrl:luaSetSelectorOnEvent(setWindowAttributeView);
        setSocietyBattleViewData(tmp);
    end
end

local function recSocietyBattleApply()
    SCActivityIndicator:getSingleton():close();
    local dt = LuaData:getSingleton():getDataTransStream();
    if dt then
        showSocietyBattleApplyWnd(stSignGameInfo.initWithStream(dt));
    end
end

local function recSocietyBattleView()    
    SCActivityIndicator:getSingleton():close();
    local dt = LuaData:getSingleton():getDataTransStream();
    if dt then
        showSocietyBattleViewWnd(tMSG_Info19.initWithStream(dt));
    end
end

local function MatchingInterfaceWndClose()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_SYNWAR);
    dataStream:writeShort(ACTION_TRIBEWAR_CLOSE_WINDOW);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
    end
end

local function OnClickEntersThe(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_SYNWAR);
    dataStream:writeShort(ACTION_TRIBEWAR_ENTER_MAP);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        --SCActivityIndicator:getSingleton():show();
    end
end

local function OnClickLookUp(tag)
    tag = tag - 20;
    local tmp = {__mode = "kv"};
    for i = 1, #MatchingInterfaceInfo.stfill do
        for j = 1, #MatchingInterfaceInfo.stfill[i].stPairFill do
            table.insert(tmp, MatchingInterfaceInfo.stfill[i].stPairFill[j])
        end
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_SYNWAR);
    dataStream:writeShort(ACTION_TRIBEWAR_REPORT);
    dataStream:writeInt(tmp[tag].idTribe1);
    dataStream:writeInt(tmp[tag].idTribe2);
    if tag < 9 then
        dataStream:writeByte(8);
    elseif tag < 13 then
        dataStream:writeByte(4);
    elseif tag < 15 then
        dataStream:writeByte(2);
    elseif tag < 15 then
        dataStream:writeByte(1);
    end
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
    tmp = {__mode = "kv"};
end

local function createMatchingInterfaceWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7013));
    if wnd == nil then
        return nil 
    end
    local imgPath = nil;
    --[[if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/titile..png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end]]
    wnd:luaSetSelectorOnClose(MatchingInterfaceWndClose);
    -- create a test window controller
    local Btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
    if Btn then
        Btn:luaSetSelectorOnClicked(OnClickEntersThe);
    end
    for i = 21, 35 do
        Btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-" .. i, tolua.cast(wnd, "SCNode")));
        if Btn then
            --Btn:luaSetSelectorOnClicked(OnClickLookUp);
            Btn:setVisible(false);
        end
    end
    for i = 40, 43 do
        local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-" .. i, tolua.cast(wnd, "SCNode")));
        if pImg then
            pImg:setFlipX(true);
        end
    end
    for i = 46, 47 do
        local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-" .. i, tolua.cast(wnd, "SCNode")));
        if pImg then
            pImg:setFlipX(true);
        end
    end    
    local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-49", tolua.cast(wnd, "SCNode")));
    if pImg then
        pImg:setFlipX(true);
    end
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    return wndCtrl;
end

local function showMatchingInterfaceInfo(tmp)
    if nil == tmp.ucAmount then
        return;
    end
    MatchingInterfaceInfo = tmp;
    local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("7013-1"));
    if pDragNode then
        for i = 1, tmp.ucAmount do
            for j = 1, tmp.stfill[i].ucPairAmount do
                local n = (j - 1) * 2;
                for k = 1, i - 1 do
                    n = n + tmp.stfill[k].ucPairAmount;
                end 
                if 8 == tmp.stfill[i].ucWarPair then
                    local Btn1 = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(5 + n));
                    local Btn2 = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(6 + n));
                    if Btn1 and Btn2 then
                        --Btn1:setTag(tmp.stfill[i].stPairFill[j].idTribe1);
                        --Btn2:setTag(tmp.stfill[i].stPairFill[j].idTribe2);
                        Btn1:setTitle(tmp.stfill[i].stPairFill[j].szTribe1, getDefaultFontName(), getFontSize(14))
                        Btn2:setTitle(tmp.stfill[i].stPairFill[j].szTribe2, getDefaultFontName(), getFontSize(14))
                    end
                end
                local Btn = nil;
                local pImg = nil;
                if 1 == tmp.stfill[i].ucWarPair then
                    n = n - 14;
                    Btn = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(35 + n / 2));
                    pImg = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(50 + n / 2));
                elseif 2 == tmp.stfill[i].ucWarPair then
                    n = n - 12;
                    Btn = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(33 + n / 2));
                    pImg = SCTypeCast:castNodeToImage(pDragNode:getChildByTag(48 + n / 2));
                elseif 4 == tmp.stfill[i].ucWarPair then
                    n = n - 8;
                    Btn = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(29 + n / 2));
                    pImg = SCTypeCast:castNodeToImage(pDragNode:getChildByTag(44 + n / 2));
                elseif 8 == tmp.stfill[i].ucWarPair then
                    Btn = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(21 + n / 2));
                    pImg = SCTypeCast:castNodeToImage(pDragNode:getChildByTag(36 + n / 2));
                end
                if Btn then
                    Btn:setTitle(_LTParser("str" .. (6094 + tmp.stfill[i].stPairFill[j].ucGameStatus)), getDefaultFontName(), getFontSize(15));
                    Btn:setVisible(true);
                    if 2 == tmp.stfill[i].stPairFill[j].ucGameStatus then
                        Btn:luaSetSelectorOnClicked(OnClickLookUp);      
                    end
                end     
                if pImg and 2 == tmp.stfill[i].stPairFill[j].ucGameStatus then
                    local imgPath = nil;
                    if 8 == tmp.stfill[i].ucWarPair then
                        if tmp.stfill[i].stPairFill[j].idTribe1 == tmp.stfill[i].stPairFill[j].idWinTribe then
                            imgPath = getRealUIResourcePath("img/new00038.png");
                        else
                            imgPath = getRealUIResourcePath("img/new00039.png");
                        end
                    elseif 4 == tmp.stfill[i].ucWarPair then
                        if tmp.stfill[i].stPairFill[j].idTribe1 == tmp.stfill[i].stPairFill[j].idWinTribe then
                            imgPath = getRealUIResourcePath("img/new00041.png");
                        else
                            imgPath = getRealUIResourcePath("img/new00042.png");
                        end
                    elseif 2 == tmp.stfill[i].ucWarPair then
                        if tmp.stfill[i].stPairFill[j].idTribe1 == tmp.stfill[i].stPairFill[j].idWinTribe then
                            imgPath = getRealUIResourcePath("img/new00035.png");
                        else
                            imgPath = getRealUIResourcePath("img/new00036.png");
                        end
                    elseif 1 == tmp.stfill[i].ucWarPair then    
                        imgPath = getRealUIResourcePath("img/new00048.png");
                    end                  
                    if imgPath then
                        pImg:setImage(imgPath:getData());
                        if 1 == tmp.stfill[i].ucWarPair and tmp.stfill[i].stPairFill[j].idTribe2 == tmp.stfill[i].stPairFill[j].idWinTribe then
                            pImg:setFlipX(true);
                        elseif 2 == tmp.stfill[i].ucWarPair and (48 + n / 2) == 49 then
                            pImg:setFlipX(true);
                        elseif 4 == tmp.stfill[i].ucWarPair and ((44 + n / 2) == 47 or (44 + n / 2) == 46) then
                            pImg:setFlipX(true);
                        elseif 8 == tmp.stfill[i].ucWarPair and (36 + n / 2) > 39 and (36 + n / 2) < 44 then
                            pImg:setFlipX(true);
                        end
                    end
                end      
            end
        end
    end
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        showMatchingInterfaceInfo(MatchingInterfaceInfo);
    end
end

local function showMatchingInterface(tmp)
    local wndCtrl = createMatchingInterfaceWnd();    
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);
        naviCtrl:pushWindowController(wndCtrl);
        local pImage = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("7013-4"));
        if pImage then
            local imgPath = nil;
            if 1 == tmp.ucWarPair then
                imgPath = getRealUIResourcePath("img/titile71.png");
            elseif 2 == tmp.ucWarPair then
                imgPath = getRealUIResourcePath("img/titile70.png");
            elseif 4 == tmp.ucWarPair then
                imgPath = getRealUIResourcePath("img/titile72.png");
            elseif 8 == tmp.ucWarPair then
                imgPath = getRealUIResourcePath("img/titile68.png");
            end
            if imgPath then
                pImage:setImage(imgPath:getData());
            end
        end
        if 1 == tmp.ucWarPair then
            local Btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("7013-1-35"));
            if Btn then
                if 0 == tmp.ucWarFlag then
                    Btn:setTitle(_LTParser("str6094"), getDefaultFontName(), getFontSize(15));
                elseif 1 == tmp.ucWarFlag then
                    Btn:setTitle(_LTParser("str6095"), getDefaultFontName(), getFontSize(15));
                elseif 2 == tmp.ucWarFlag then
                    Btn:setTitle(_LTParser("str6096"), getDefaultFontName(), getFontSize(15));
                end
            end
        elseif 2 == tmp.ucWarPair then
            for i = 33, 34 do
                local Btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("7013-1-" .. i));
                if Btn then
                    if 0 == tmp.ucWarFlag then
                        Btn:setTitle(_LTParser("str6094"), getDefaultFontName(), getFontSize(15));
                    elseif 1 == tmp.ucWarFlag then
                        Btn:setTitle(_LTParser("str6095"), getDefaultFontName(), getFontSize(15));
                    elseif 2 == tmp.ucWarFlag then
                        Btn:setTitle(_LTParser("str6096"), getDefaultFontName(), getFontSize(15));
                    end
                end
            end
        elseif 4 == tmp.ucWarPair then
            for i = 29, 32 do
                local Btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("7013-1-" .. i));
                if Btn then
                    if 0 == tmp.ucWarFlag then
                        Btn:setTitle(_LTParser("str6094"), getDefaultFontName(), getFontSize(15));
                    elseif 1 == tmp.ucWarFlag then
                        Btn:setTitle(_LTParser("str6095"), getDefaultFontName(), getFontSize(15));
                    elseif 2 == tmp.ucWarFlag then
                        Btn:setTitle(_LTParser("str6096"), getDefaultFontName(), getFontSize(15));
                    end
                end
            end
        elseif 8 == tmp.ucWarPair then
            for i = 21, 28 do
                local Btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("7013-1-" .. i));
                if Btn then
                    if 0 == tmp.ucWarFlag then
                        Btn:setTitle(_LTParser("str6094"), getDefaultFontName(), getFontSize(15));
                    elseif 1 == tmp.ucWarFlag then
                        Btn:setTitle(_LTParser("str6095"), getDefaultFontName(), getFontSize(15));
                    elseif 2 == tmp.ucWarFlag then
                        Btn:setTitle(_LTParser("str6096"), getDefaultFontName(), getFontSize(15));
                    end
                end
            end
        end
        if tmp.nLeaveTime > 0 then
            local pNode = SCFunction:getUiNodeByIdlist("7013");
            if pNode then
                local pCountDownNode = SCTypeCast:castNodeToCountDownNode(pNode:getChildByTag(70131));
                if pCountDownNode == nil then
                    pCountDownNode = CountDownNode:newCountDownNode();
                    if pCountDownNode then
                        setNodePostion(pCountDownNode, CCPointMake(200, 286));
                        pCountDownNode:setTime(tmp.nLeaveTime);
                        pNode:addChild(pCountDownNode);
                        pCountDownNode:setTag(70131);
                    end
                else
                    pCountDownNode:setTime(tmp.nLeaveTime);
                end
            end       
        end 
    end    
end

local function BattleReportWndClose()
    BattleReportInfo = {__mode = "kv",};
end

local function OnClickSure(tag)    
    local naviCtrl =  getCurentSceneNavigationController();
    if naviCtrl then
        naviCtrl:removeWindowControllerByTag(7015);
    end
end

local function createBattleReportWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7015));
    if wnd == nil then
        return nil 
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/titile69.png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    wnd:luaSetSelectorOnClose(BattleReportWndClose);
    -- create a test window controller
    local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    if pDragNode then
        pDragNode:setFrameVisibled(true);
        pDragNode:setFrameType(EnumFrameTypeRound);
    end
    local Btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2", tolua.cast(wnd, "SCNode")));
    if Btn then
        Btn:luaSetSelectorOnClicked(OnClickSure);
    end
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    return wndCtrl;
end

local function setWindowBattleReportAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        local listbox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("7015-1-3"));
        if listbox then
            listbox:removeAllItems();
            for i = 1, BattleReportInfo.ucAmount do
                local pNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(7015, 101));
                if pNode then                    
                    pNode:setFrameType(EnumFrameTypeListNormal)
                    pNode:setFrameVisibled(true)
                    local pLabel1 = SCTypeCast:castNodeToLabel(pNode:getChildByTag(1));
                    local pLabel2 = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
                    local pLabel3 = SCTypeCast:castNodeToLabel(pNode:getChildByTag(3));
                    local pLabel4 = SCTypeCast:castNodeToLabel(pNode:getChildByTag(4));
                    local pLabel5 = SCTypeCast:castNodeToLabel(pNode:getChildByTag(5));
                    if pLabel1 and pLabel2 and pLabel3 and pLabel4 and pLabel5 then
                        pLabel1:setText(BattleReportInfo.stfill[i].szTribeName);
                        pLabel2:setText(BattleReportInfo.stfill[i].szUserName);
                        pLabel3:setText(BattleReportInfo.stfill[i].usKillNum);
                        pLabel4:setText(BattleReportInfo.stfill[i].nReputation);
                        pLabel5:setText(BattleReportInfo.stfill[i].nMoney);
                        if 1 ~= BattleReportInfo.stfill[i].ucWinFlag then
                            pLabel1:setColor(color_red);
                            pLabel2:setColor(color_red);
                            pLabel3:setColor(color_red);
                            pLabel4:setColor(color_red);
                            pLabel5:setColor(color_red);
                        end
                    end                    
                    listbox:addItem(pNode);
                end
            end
        end
    end
end

local function showBattleReport(tmp)
    BattleReportInfo = tmp;
    if BattleProcessor:getSingleton():getIsInBattle() then
        return;
    end
    local wndCtrl = createBattleReportWnd();
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl, NavigateStyleBottomToTop);
        wndCtrl:luaSetSelectorOnEvent(setWindowBattleReportAttribute);
    end
end

function AfterBattleReport()
    if #BattleReportInfo > 0 then        
        local wndCtrl = createBattleReportWnd();
        local naviCtrl =  getCurentSceneNavigationController();
        if  naviCtrl and wndCtrl then
            naviCtrl:pushWindowController(wndCtrl, NavigateStyleBottomToTop);
            wndCtrl:luaSetSelectorOnEvent(setWindowBattleReportAttribute);
        end
    end
end

local function recSocietyBattleInfo()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    if dt == nil then
        return;
    end
    local action = dt:readShort();
    if action == ACTION_TRIBEWAR_PAIR_INFO then
        showMatchingInterfaceInfo(tMsg_Info3.initWithStream(dt));
    elseif action == ACTION_TRIBEWAR_PAIR_READY_INFO then
        showMatchingInterface(stTribeWarReadyInfo.initWithStream(dt));
    elseif action == ACTION_TRIBEWAR_REPORT then
        showBattleReport(tMsg_Info2.initWithStream(dt));
    end
end

local function onClickQuitOrPair(tag)
    if tag == 1 then
        local wndCtrl = createMatchingInterfaceWnd();    
        local naviCtrl =  getCurentSceneNavigationController();
        if  naviCtrl and wndCtrl then
            wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);
            naviCtrl:pushWindowController(wndCtrl);
            local pNode1 = SCFunction:getUiNodeByIdlist("7013-2");
            local pNode2 = SCFunction:getUiNodeByIdlist("7013-3");
            if pNode1 and pNode2 then
                pNode1:setVisible(false);
                pNode2:setVisible(false);
            end
        end
        return;
    end    
    MatchingInterfaceInfo = {__mode = "kv",};
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_SYNWAR);
    dataStream:writeShort(ACTION_TRIBEWAR_LEAVE_MAP);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        --SCActivityIndicator:getSingleton():show();
    end      
end

local function getSocietyBattleNode()    
    local scene = getRunningScene();
    if scene~= nil then
        if scene:getUINode() then
            local pNode = scene:getUINode():getChildByTag(7014);
            if nil == pNode then
                pNode = SCFunction:getUiById(7014);
                if pNode then                    
                    pNode:setAnchorPoint(CCPointMake(0.5, 1));
                    pNode:setPosition(CCPointMake(getScreenWidth() / 2, getScreenHeight()));
                    scene:getUINode():addChild(pNode);
                    local Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(2));
                    if Btn then
                        Btn:luaSetSelectorOnClicked(onClickQuitOrPair);                        
                        Btn:setPosition(CCPointMake(pNode:getContentSize().width / 2 + getScreenWidth() / 2 - 60 * gUIScale().x, Btn:getPosition().y));
                    end   
                    Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(1));
                    if Btn then
                        Btn:luaSetSelectorOnClicked(onClickQuitOrPair);
                        Btn:setPosition(CCPointMake(pNode:getContentSize().width / 2 + getScreenWidth() / 2 - 120 * gUIScale().x, Btn:getPosition().y));
                    end                 
                    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-10"));
                    if pLabel then
                        pLabel:setColor(color_skyBlue);
                    end
                    local pLabel1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-4"));
                    local pLabel2 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-7"));
                    if pLabel1 and pLabel2 then
                        pLabel1:setColor(color_yellow);
                        pLabel2:setColor(color_yellow);
                    end
                    pLabel1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-5"));
                    pLabel2 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-8"));
                    if pLabel1 and pLabel2 then
                        pLabel1:setColor(color_red);
                        pLabel2:setColor(color_red);
                    end
                    pLabel1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-6"));
                    pLabel2 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-9"));
                    if pLabel1 and pLabel2 then
                        pLabel1:setColor(color_red);
                        pLabel2:setColor(color_red);
                    end
                end
            end
            return pNode;
        end
    end
    return nil;
end

local function recPreparationTime(dt)
    if dt then
        local nTime = dt:readInt();
        if nTime > 0 then
            local pNode = getSocietyBattleNode();
            if pNode then                
                pNode:removeChildByTag(70141, true);
                local pCountDownNode = CountDownNode:newCountDownNode();
                if pCountDownNode then
                    pCountDownNode:setTime(nTime);
                    pNode:addChild(pCountDownNode);
                    pCountDownNode:setTag(70141);
                    pCountDownNode:setPosition(CCPointMake(160 * gUIScale().x, 68 * gUIScale().y));
                end
            end
        end
    end
end

local function showSocietyBattleMainWnd(tmp)
        local pNode = getSocietyBattleNode();
        if pNode then
            local pImage = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("7014-3"));
            if pImage then
                local imgPath = nil;
                if 1 == tmp.ucWarNum then
                    imgPath = getRealUIResourcePath("img/titile71.png");
                elseif 2 == tmp.ucWarNum then
                    imgPath = getRealUIResourcePath("img/titile70.png");
                elseif 4 == tmp.ucWarNum then
                    imgPath = getRealUIResourcePath("img/titile72.png");
                elseif 8 == tmp.ucWarNum then
                    imgPath = getRealUIResourcePath("img/titile68.png");
                end
                if imgPath then
                    pImage:setImage(imgPath:getData());
                end
            end
            local pLabel1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-4"));
            local pLabel2 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-7"));
            if pLabel1 and pLabel2 then
                pLabel1:setText(tmp.szTribe1);
                pLabel2:setText(tmp.szTribe2);
            end
            pLabel1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-5"));
            pLabel2 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-8"));
            if pLabel1 and pLabel2 then
                pLabel1:setText(_LTParser("str6092") .. " " .. tmp.ucTribeLev1);
                pLabel2:setText(_LTParser("str6092") .. " " .. tmp.ucTribeLev2);
            end
            pLabel1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-6"));
            pLabel2 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-9"));
            if pLabel1 and pLabel2 then
                pLabel1:setText(_LTParser("str6093") .. " " .. tmp.usLeaveNum1);
                pLabel2:setText(_LTParser("str6093") .. " " .. tmp.usLeaveNum1);
            end
        end
end

local function recSocietyBattleNumber(dt)
    if dt then
        local usLeaveNum1 = dt:readShort();
        local usLeaveNum2 = dt:readShort();
        local pNode = getSocietyBattleNode();
        if pNode then
            local pLabel1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-6"));
            local pLabel2 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7014-9"));
            if pLabel1 and pLabel2 then
                pLabel1:setText(_LTParser("str6093") .. " " .. usLeaveNum1);
                pLabel2:setText(_LTParser("str6093") .. " " .. usLeaveNum2);
            end
        end
    end
end

function setSocietyBattleInfo(action, dt)
    SCActivityIndicator:getSingleton():close();
    if action == MSG_TRIBE_WAR_TIME_LEAVE then
        recPreparationTime(dt);
    elseif action == MSG_TRIBE_WAR_FIGHT_INFO then    
        showSocietyBattleMainWnd(struTribeWarInfo.initWithStream(dt));
    elseif action == MSG_TRIBE_WAR_UPDATE_USERNUM then
        recSocietyBattleNumber(dt);
    end
end

local function TrophieWndClose()
    TrophieInfo = {__mode = "kv"};
    JoinPlayerInfo = {__mode = "kv"};
end

local m_ucAmount = nil;
local m_issueTable = {__mode = "kv"};

local function onClickedDelete(tag)
    if tag == 1 then        
        local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
        if nil == dt then
            return;
        end
        dt:writeShort(ARENASCRIPT_TRIBEWAR_GIFT_MEMBER_OK);
        dt:writeByte(m_ucAmount);
        for i = 1, m_ucAmount do
            dt:writeInt(m_issueTable[i]);
        end
        SCDataTransThread:getSingleton():transData(dt);
        local naviCtrl =  getCurentSceneNavigationController();
        if naviCtrl then
            naviCtrl:removeWindowControllerByTag(7016);
        end
    end
    m_ucAmount = nil;
    m_issueTable = {__mode = "kv"};
end

local function OnClickTrophie(tag)
    local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
    if nil == dt then
        return;
    end
    dt:writeShort(ARENASCRIPT_TRIBEWAR_GIFT_MEMBER_OK);
    m_ucAmount = 0;
    local tmp = {__mode = "kv"};
    for i = 1, 3 do
        local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7016-1-" .. (i + 2) .. "-" .. (i + 8) .. "-" .. (i + 17)));
        if pLabel then
            local str = pLabel:getText();
            for j = 1, JoinPlayerInfo.ucAmount do
                if str == JoinPlayerInfo.stfill[j].szName then
                    m_ucAmount = m_ucAmount + 1;
                    table.insert(tmp, JoinPlayerInfo.stfill[j].idMember)
                end
            end
        end
    end
    if m_ucAmount < 3 then
        m_issueTable = tmp;
        luashowConfirmationWindow(_LTParser("str6117") .. (3 - m_ucAmount) .. _LTParser("str6118"), WIN_YES_NO, onClickedDelete);
        tmp = {__mode = "kv"};
        return;
    end
    dt:writeByte(m_ucAmount);
    for i = 1, m_ucAmount do
        dt:writeInt(tmp[i]);
    end
    SCDataTransThread:getSingleton():transData(dt);
    tmp = {__mode = "kv"};
    m_ucAmount = nil;
    local naviCtrl =  getCurentSceneNavigationController();
    if naviCtrl then
        naviCtrl:removeWindowControllerByTag(7016);
    end
end

local ChooseMark = nil;

local function joinInTeam(tag, itemTag, itemIndex)
    local node = tolua.cast(SCFunction:getUiNodeByIdlist("7016-70161-1-"..itemTag), "SCDragNode");
    if node then
        node:setFrameType(EnumFrameTypeListSelect)
        node:setFrameVisibled(true)
        local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7016-1-" .. (ChooseMark + 3) .. "-" .. (ChooseMark + 9) .. "-" .. (ChooseMark + 18)));
        if pLabel then
            pLabel:setText(JoinPlayerInfo.stfill[itemIndex + 1].szName);
        end        
        local m_wnd = getCurentSceneWindow(7016);
        if m_wnd then
            m_wnd:removeChildByTag(70161, true);
            ChooseMark = nil;
        end
    end
end

local function onClickChoose(tag)
    ChooseMark = tag - 21;
    local m_wnd = getCurentSceneWindow(7016);
    if nil == m_wnd then
        return;
    end
    local pListBox = SCListBox:boxWithWidthHeight(100 * gUIScale().x, 200 * gUIScale().y);
    if nil == pListBox then
        return;
    end
    pListBox:luaSetSelectorOnItemSelected(joinInTeam)
    pListBox:luaSetSelectorOnItemUnSelected(unSelset) 
    pListBox:setTag(1);
    for i = 1, JoinPlayerInfo.ucAmount do
        local pDragNode = SCDragNode:node();
        if pDragNode then
            pDragNode:setFrameVisibled(true);
            pDragNode:setFrameType(EnumFrameTypeListNormal);
            pDragNode:setContentSize(CCSizeMake(100 * gUIScale().x, 20 * gUIScale().y));
            local pLabel = SCLabel:labelWithStringFont(JoinPlayerInfo.stfill[i].szName, getDefaultFontName(), getFontSize(12));
            if pLabel then
                pLabel:setPosition(CCPointMake(5 * gUIScale().x, 4 * gUIScale().y));
                pDragNode:addChild(pLabel);
            end
            pListBox:addItem(pDragNode);
        end
    end
    local pFrameWindow = FrameWindow:frameWnd();
    if pFrameWindow then
        pFrameWindow:setContentSize(CCSizeMake(120 * gUIScale().x, 220 * gUIScale().y));
        pFrameWindow:setCloseBtnVisible(false);
        pListBox:setAnchorPoint(CCPointMake(0.5, 0.5));
        pListBox:setPosition(CCPointMake(pFrameWindow:getContentSize().width / 2, pFrameWindow:getContentSize().height / 2));
        pFrameWindow:addChild(pListBox);
        if getRunningScene() and getRunningScene():getUINode() then
            pFrameWindow:setPosition(CCPointMake(m_wnd:getContentSize().width / 2, m_wnd:getContentSize().height / 2));
            m_wnd:addChild(pFrameWindow);
            pFrameWindow:setTag(70161);
        end
    end
end

local function createTrophieWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7016));
    if wnd == nil then
        return nil 
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/titile66.png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    wnd:luaSetSelectorOnClose(TrophieWndClose);
    -- create a test window controller
    local Btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2", tolua.cast(wnd, "SCNode")));
    if Btn then
        Btn:luaSetSelectorOnClicked(OnClickTrophie);
    end
    local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    if pDragNode then
        pDragNode:setFrameVisibled(true);
        pDragNode:setFrameType(EnumFrameTypeRound);
    end
    for i = 3, 5 do
        pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-" .. i, tolua.cast(wnd, "SCNode")));
        if pDragNode then
            pDragNode:setFrameVisibled(true);
            pDragNode:setFrameType(EnumFrameTypeListNormal);
        end
        pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-" .. i .. "-" .. (i + 6), tolua.cast(wnd, "SCNode")));
        if pDragNode then
            pDragNode:setFrameVisibled(true);
            pDragNode:setFrameType(EnumFrameTypeRound);
        end
        local Btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-" .. i .. "-" .. (i + 18), tolua.cast(wnd, "SCNode")));
        if Btn then
            Btn:luaSetSelectorOnClicked(onClickChoose);
        end
    end
    for i = 9, 11 do
        pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-" .. i, tolua.cast(wnd, "SCNode")));
        if pDragNode then
            pDragNode:setFrameVisibled(true);
            pDragNode:setFrameType(EnumFrameTypeLine);
        end
    end
    for i = 1, 3 do
        local pImage = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-" .. (2 + i) .. "-" .. (5 + i), tolua.cast(wnd, "SCNode")));
        if pImage then
            local imgPath = getRealUIResourcePath("MainInterfaceImg/50270.png");
            if imgPath then
                local imgNode = SCImage:imageWithFile(imgPath:getData());
                if imgNode then
                    imgNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                    imgNode:setPosition(CCPointMake(pImage:getContentSize().width / 2, pImage:getContentSize().height / 2));
                    pImage:addChild(imgNode);
                end
            end
        end
    end
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    return wndCtrl;
end

local function setTrophieWndData()
    for i = 1, TrophieInfo.ucAmount do
        local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7016-1-" .. (2 + i) .. "-" .. (11 + i)));
        if pLabel then
            pLabel:setText(TrophieInfo.stfill[i].szItemName);
        end
    end
end

local function setWindowTrophieAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        setTrophieWndData();
    end
end

local function showTrophieWnd(tmp)
    local wndCtrl = createTrophieWnd();
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl, NavigateStyleBottomToTop);
        wndCtrl:luaSetSelectorOnEvent(setWindowTrophieAttribute);
    end
end

function setTrophieInfo(action, dt)
    if action == ARENASCRIPT_TRIBEWAR_GIFT_LIST then
        showTrophieWnd(tMsg_Info10.initWithStream(dt));
    elseif action == ARENASCRIPT_TRIBEWAR_GIFT_MEMBER then
        tMsg_Info8.initWithStream(dt);
    end
end

function closeSocietyBattleNode()
    local scene = getRunningScene();
    if scene~= nil then
        scene:getUINode():removeChildByTag(7014, true);
    end
end

--LuaData:getSingleton():luaSetSelectorOnRecvData(recSocietyBattleApply, LuaData_MSG_SOCIATY_SIGN_GAME_INFO);
--LuaData:getSingleton():luaSetSelectorOnRecvData(recSocietyBattleView, LuaData_MSG_SOCIATY_SIGN_GAME_LIST);
--SCMessageCenter:getSingleton():luaRegistCommand(recSocietyBattleInfo, _MSG_SYNWAR, 0, nil);