--[[
快速查询
typedef struct
{
	OBJID			idQuest;						//任务id
	USHORT			usLevel;
	UCHAR			ucQuestStatus;					//任务状态 可交>可接>正在执行 3 2 1
	UCHAR           ucQuestType;                    // 1主线 0支线               
	UCHAR           ucType;  // 
	char			szQuestName[MAX_QUEST_NAME_SIZE];		//任务名称
	UCHAR           ucCurCondition;  //当前条件 
	UCHAR           ucCondition; //要达成的条件 
	OBJID			idMap;  // 交接任务发送地图id和坐标 
	USHORT			usPosX;
	USHORT			usPosY;
	OBJID           idCopy; // 执行任务发送副本id
}stCurQuestQuickList;
]]

--人物action
	ACTQUEST_DEL						 = 7--	/*已接任务列表放弃任务 to sever to del quest*/
	ACTQUEST_ABLERECQUEST_QUERY_BYLABEL  = 22--	/*可接任务列表查询*/
	ACTQUEST_ABLERECQUEST_QUERY_BYLABELEND	= 35--		//可接任务列表查询(最后一个包)
	ACTQUEST_CURRENDTQUEST_QUERY_BYLABEL = 23--	/*已接任务列表查询*/
	ACTQUEST_CURRENDTQUEST_QUERY_BYLABELEND	= 36--		//已接任务列表查询(最后一个包)
	ACTQUEST_CUR_QUEST_GUIDE_ADD		 = 27--	/*当前任务或可接任务提示(新加或更新)*/
	ACTQUEST_CUR_QUEST_GUIDE_DEL		 = 28--	/*删除当前任务提示*/
	ACTQUEST_ADD_ABLELIST_2				 = 29--	/*接受任务(可接任务列表中)(ios,web): 接受任务进入领取任务对话界面确定接受*/
	ACTQUEST_QUEST_RETROCEDE_2			 = 30--	/*完成任务(已接任务列表中)(ios,web): 点击进入完成任务的确认对话*/
	ACTQUEST_ABLE_RECEVIE_DEL			 = 31--	/*从可接任务列表中删除任务*/
	ACTQUEST_QUEST_ACTION_RECEIVE			= 33--		//接受任务动画
	ACTQUEST_QUEST_ACTION_RETROCEDE			= 34--		//完成任务动画
	ACTQUEST_OVER_QUEST_TIP					= 37--		//完成任务提示(客户端放到战斗完成后显示)
	ACTQUEST_CUR_MAIN_QUEST_GUIDE			= 38--		//当前主线任务引导提示(新加或更新)
	ACTQUEST_ABLERECQUEST_QUERY_NEXTLEV		= 40--		//下一级可接任务列表查询
	ACTQUEST_ABLERECQUEST_QUERY_NEXTLEVEND  = 41--       //下一级可接任务列表查询(最后一个包)
	ACTQUEST_QUICK_QUEST_BYLABEL            = 42--       //快速交接任务列表 
    ACTQUEST_QUICK_QUEST_BYLABEL_END        = 43--       //快速交接任务列表结束
	ACTQUEST_QUICK_QUEST_UPDATA        		= 44--       //快速交接任务列表通知客户端要开始更新
	ACTQUEST_SEND_EVERYDAY_QUEST_INFO       = 45--       //发送日常任务信息
	ACTQUEST_SEND_EVERYDAY_FINISH       	= 46--       //日常活动完成
	ACTQUEST_SEND_REFRSH_EVETYDAY        	= 47--       //点卷刷新日常任务 
	ACTQUEST_SEND_EVERYDAY_ACCEPT       	= 48--       //接日常任务
	ACTQUEST_SEND_EVERYDAY_GAVE_UP       	= 49--       //放弃日常任务 
	
	ACTQUEST_QUEST_OVERFLAG_INIT            = 51--         //已交还的普通任务和主线任务初始化
	ACTQUEST_QUEST_STATUS_SHOW	            = 52--         //已接任务状态刷新
	ACTQUEST_QUEST_OVERFLAG_SHOW            = 53--         //已交还的普通任务和主线任务刷新


--任务标记
	QUEST_STATUS_NOT_ACCEPT = 1--		/*未接*/
	QUEST_STATUS_ACCEPT_NOT_FINISH = 2--	/*已接未完成*/
	QUEST_STATUS_CAN_RETURN	= 3--		/*可交还*/
	QUEST_STATUS_FINISH = 5--			/*已完成*/	
	QUEST_STATUS_UNABLE	= 0 --不可接
--任务类型
	QUEST_TYPE_NORMAL					= 100--//普通任务
	QUEST_TYPE_MAIN						= 110--//主线任务
	QUEST_TYPE_REPEATED					= 130--//重复任务
	QUEST_TYPE_DAILY					= 140--//每日任务
	QUEST_TYPE_WEEK						= 150--//每周任务
	ACTQUEST_QUEST_NEXT_LEV             = 50 --//下一级可接的主线

--任务类型
    INSTANCE_TYPE_TEAM                  = 100--//普通任务
    INSTANCE_TYPE_S_NORMAL              = 101
    INSTANCE_TYPE_S_SMART               = 102--//精英任务
    INSTANCE_TYPE_S_CHALLENGER          = 103--//魔王任务
	INSTANCE_TYPE_TRIBE                 = 105--//下级可接
	
	
local sumLabelHigh = 25
local specialHigh = 12
local m_nCopySweepTimes = nil;
--数据
local m_TaskCanAcceptPage = {}
local m_TaskAlreadyAcceptPage = {}
local m_TaskCurQuestQuickList = {}	--主界面快速登入列表
local m_TaskFindRoadIndex = 0		--自动寻路索引
local m_curPage = 1
local m_pageLen = 5
local m_taskNum = 0
local m_taskJudge = true
local stNextQuest = {};
local m_nTempQuest = nil;

--清除数据
local function clearData()
	m_TaskCanAcceptPage = {}
	m_TaskAlreadyAcceptPage = {}
	m_curPage = 1
	m_pageLen = 5
	m_taskNum = 0
	m_taskJudge = true
	m_nCopySweepTimes = nil;
end

--放弃任务
local function sendGiveUpTaskInfo(idQuest)
	SCActivityIndicator:getSingleton():show()
	local dt = SCDataTransStream:streamWithCommand(_MSG_ACTQUEST)
	dt:writeShort(ACTQUEST_DEL)
	dt:writeByte(0)
	dt:writeInt(idQuest)
	SCDataTransThread:getSingleton():transData(dt)
end

local function sendTaskInfo(idQuest, type)
	SCActivityIndicator:getSingleton():show()
	local dt = SCDataTransStream:streamWithCommand(_MSG_ACTQUEST)
	dt:writeShort(type)
	dt:writeInt(idQuest)
	SCDataTransThread:getSingleton():transData(dt)
end

local function sentAutoFindTaskRoad( id )
	SCActivityIndicator:getSingleton():show()
	local ACTQUEST_AUTO_FIND_ROAD = 32
	local dt = SCDataTransStream:streamWithCommand(_MSG_ACTQUEST)
	dt:writeShort(ACTQUEST_AUTO_FIND_ROAD)
	dt:writeInt(id)
	SCDataTransThread:getSingleton():transData(dt)
end

--请求任务列表数据
local function requestTaskList( type, curPage, pageLen )
	--clearData()
	SCActivityIndicator:getSingleton():show()
	local dt = SCDataTransStream:streamWithCommand(_MSG_ACTQUEST)
	dt:writeShort(type)
	dt:writeByte(1)
	dt:writeByte(255)
	SCDataTransThread:getSingleton():transData(dt)
end

--关闭任务窗口
local function onCloseTaskWnd()
	local naviCtrl =  getCurentSceneNavigationController()
	if not naviCtrl then
		return
	end
	naviCtrl:removeWindowControllerByTag(1000)
    clearData();
end

--快速交接任务消息接收
local function onMsgQuestQuickList(dt)
	local ucAmount = dt:readByte();
	
	for i=1, ucAmount do
		local tmp = {};
		tmp.idQuest = dt:readInt();
		tmp.usLevel	= dt:readShort();
		tmp.ucQuestStatus = dt:readByte();
		tmp.ucQuestType = dt:readByte();
		tmp.ucType = dt:readByte();
		tmp.ucCurCondition = dt:readByte();
		tmp.ucCondition = dt:readByte();
		tmp.idMap = dt:readInt();
		tmp.usPosX = dt:readShort();
		tmp.usPosY = dt:readShort();
		tmp.idCopy = dt:readInt();	
		tmp.idNpc = dt:readInt();	
		local str = dt:readString();
		if str then
			tmp.szQuestName = str:getData();
		else
			tmp.szQuestName = "";
		end
		tmp.idPhoto = dt:readInt();
		str = dt:readString()
		if str then
		    tmp.szMessage = str:getData()
		else
		    tmp.szMessage = ""
		end
		table.insert(m_TaskCurQuestQuickList, tmp);
		
		if m_nTempQuest~=nil and m_nTempQuest==tmp.idQuest then
            local nCurAmount = tmp.ucCurCondition;
            local nNeedAmount = tmp.ucCondition;
            if nCurAmount<nNeedAmount then
                CopyQuest_setNeedCopySweepInfo(nNeedAmount-nCurAmount);
            else
                CopyQuest_setNeedCopySweepInfo(0);
            end
		    m_nTempQuest = nil;
		end
	end
end

function onMsgQuestOverInit(dt)
	local ucAmount = dt:readByte();
	for i=1, ucAmount do
		local dwType = dt:readInt();
		local dwGroup = dt:readInt();
		for j=1,10 do
		    local dwParam = dt:readInt();
		    CActQuestMgr:getSingleton():AddQverFlag(dwType, dwGroup, j, dwParam, true);
		end
	end
end

function onMsgQuestStatusUpdate(dt)
    local ucAmount = dt:readByte();
	for i=1, ucAmount do
		local idQuest = dt:readInt();
		local ucStatus = dt:readByte();
		CActQuestMgr:getSingleton():AddQuestStatus(idQuest, ucStatus);
		m_nTempQuest = idQuest;
	end
end

function onMsgQuestOverUpdate(dt)
	local ucAmount = dt:readByte();
	for i=1, ucAmount do
		local dwType = dt:readInt();
		local dwGroup = dt:readInt();
		for j=1,10 do
		    local dwParam = dt:readInt();
		    CActQuestMgr:getSingleton():AddQverFlag(dwType, dwGroup, j, dwParam, false);
		end
	end
end


--显示主界面快速任务列表
function showMainInterfaceTaskList()
	local tmpCount = 0;
	local tmpStr = "";
	
	local SEND_QUEST_STATUS_NOT_ACCEPT	= 1;--可接
	local SEND_QUEST_STATUS_ACCEPT_NOT_FINISH	= 2;--执行中
	local SEND_QUEST_STATUS_CAN_RETURN	= 3;--可交
	local SEND_QUEST_STATUS_FINISH		= 5
	local SEND_QUEST_STATUS_UNABLE	= 0 --不可接
	--local isSet = 0;
	local strType = "";
	local mark = 3;
	for i=1, #m_TaskCurQuestQuickList do
		if i > mark then
			break;
		end
		if m_TaskCurQuestQuickList[i] then
            if m_TaskCurQuestQuickList[i].ucQuestType == 1 then
                --strType = L("str9169");
            else 
                --strType = L("str9170");
            end
            
            if m_TaskCurQuestQuickList[i].ucType == 2 then
                --strType = L("str9171");
            elseif m_TaskCurQuestQuickList[i].ucType == 3 then
                --strType = L("str9172");
            end
            
            tmpStr = m_TaskCurQuestQuickList[i].szQuestName;
            if tmpStr then
                tmpStr = strType..tmpStr
            else
                tmpStr = strType
            end
			if m_TaskCurQuestQuickList[i].ucQuestStatus == SEND_QUEST_STATUS_ACCEPT_NOT_FINISH  then 
				if m_TaskCurQuestQuickList[i].ucQuestStatus == SEND_QUEST_STATUS_CAN_RETURN then
					tmpStr = tmpStr.."("..L("str9138")..")";
				elseif m_TaskCurQuestQuickList[i].ucQuestStatus == SEND_QUEST_STATUS_NOT_ACCEPT then
					tmpStr = tmpStr.."("..L("str9139")..")";
				elseif m_TaskCurQuestQuickList[i].ucQuestStatus == SEND_QUEST_STATUS_UNABLE then
					tmpStr = tmpStr.."("..L("str6237")..")";
				elseif m_TaskCurQuestQuickList[i].ucQuestStatus == SEND_QUEST_STATUS_ACCEPT_NOT_FINISH then
					if m_TaskCurQuestQuickList[i].ucCurCondition and m_TaskCurQuestQuickList[i].ucCondition then
						tmpStr = tmpStr.."("..m_TaskCurQuestQuickList[i].ucCurCondition.."/"..m_TaskCurQuestQuickList[i].ucCondition..")";
					end
				end
			end
            local pTmp = 0
            if m_TaskAlreadyAcceptPage[i] then
                pTmp = m_TaskAlreadyAcceptPage[i].usQuestType
            end
            
            if i == 1 then
                if m_TaskCurQuestQuickList[i].ucQuestStatus == SEND_QUEST_STATUS_UNABLE then
                    MainInterface_seTaskBtn(tmpStr, m_TaskCurQuestQuickList[i].idPhoto, color_red);
                else
                    MainInterface_seTaskBtn(tmpStr, m_TaskCurQuestQuickList[i].idPhoto);
                end
                mark = 4;
            elseif mark == 4 then
                if m_TaskCurQuestQuickList[i].ucQuestStatus == SEND_QUEST_STATUS_UNABLE then
                    MainInterface_setQuickTaskBtn(i - 1, tmpStr, color_red);
                else
                    MainInterface_setQuickTaskBtn(i - 1, tmpStr);
                end
                tmpCount = tmpCount + 1;
            else
                if m_TaskCurQuestQuickList[i].ucQuestStatus == SEND_QUEST_STATUS_UNABLE then
                    MainInterface_setQuickTaskBtn(i, tmpStr, color_red);
                else
                    MainInterface_setQuickTaskBtn(i, tmpStr);
                end
                tmpCount = tmpCount + 1;
            end
        end
		
		--[[if isSet == 0 then
		    MainInterface_setBtnTaskImg(m_TaskCurQuestQuickList[i].idPhoto)
		    isSet = 1;
		end]]
	end
	
	if tmpCount == 0 then
		MainInterface_setQuickTaskBtn(1, nil);
		MainInterface_setQuickTaskBtn(2, nil);
		MainInterface_setQuickTaskBtn(3, nil);
	elseif tmpCount == 1 then
		MainInterface_setQuickTaskBtn(2, nil);
		MainInterface_setQuickTaskBtn(3, nil);
	elseif tmpCount == 2 then
		MainInterface_setQuickTaskBtn(3, nil);
	end
end

--已接受任务列表
local function onMsgAlreadyAcceptTaskList(dt)
	local ucCurPage = dt:readByte()
	local ucPage = dt:readByte()
	local ucAmount = dt:readByte()
	m_taskNum = ucAmount
	for i=1, ucAmount do
		local tmp = {}
		tmp.idQuest = dt:readInt()
		local str = dt:readString()
		if str then
			tmp.szQuestName = str:getData()
		else
			tmp.szQuestName = " "
		end
		tmp.usQuestType = dt:readShort()
		tmp.ucQuestStatus = dt:readByte()
		local str = dt:readString()
		if str then
			tmp.szAwardString = str:getData()
		else
			tmp.szAwardString = " "
		end
		tmp.ucAmountBrief = dt:readByte()
		tmp.Briefs = {}
		for j=1, tmp.ucAmountBrief do
			local tmp2 = {};
			tmp2.strBrief = ""
			local str = dt:readString()
			if str then
				tmp2.strBrief = str:getData()
			end
			
			tmp2.idMap = dt:readInt();
			tmp2.usPosX = dt:readShort();
			tmp2.usPosY = dt:readShort();
			tmp2.ucCurCondition = dt:readByte();
			tmp2.ucCondition = dt:readByte(); 
			tmp2.idCopy = dt:readInt();
			tmp2.idNpc = dt:readInt();
			tmp2.ucCopyType = dt:readByte();
			table.insert(tmp.Briefs, tmp2)
		end
		local count = 0
		for k=1, #m_TaskAlreadyAcceptPage do
			if m_TaskAlreadyAcceptPage[k].idQuest == tmp.idQuest then
				table.remove(m_TaskAlreadyAcceptPage, k)
				table.insert(m_TaskAlreadyAcceptPage, k, tmp)
				break
			end
			count = count + 1
		end
		if count == #m_TaskAlreadyAcceptPage then
			table.insert(m_TaskAlreadyAcceptPage, tmp)
		end
	end
end

--删除已接受任务项
local function delAlreadyTask(idQuest)
	local alreadAcpList = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("1000-1-101"))
	if not alreadAcpList then
		return
	end
	local delItem = SCFunction:getUiNodeByIdlist("1000-1-101-"..idQuest)
	if not delItem then
		return
	end
	alreadAcpList:removeItem(delItem)
end

--删除已接受任务数据
local function onMsgUpdataAlreadyTaskList(dt)
	local idQuest = dt:readInt()
	for i=1, #m_TaskAlreadyAcceptPage do
		if m_TaskAlreadyAcceptPage[i].idQuest == idQuest then
			table.remove(m_TaskAlreadyAcceptPage, i)
			delAlreadyTask(i-1)
			break
		end
	end
end

--可接受任务数据
local function onMsgCanAcceptTaskList(dt)
	local ucCurPage = dt:readByte()
	local ucPage = dt:readByte()
	local ucAmount = dt:readByte()
	for i=1, ucAmount do
		local tmp = {}
		tmp.idQuest = dt:readInt()
		local str = dt:readString()
		if str then
			tmp.szQuestName = str:getData()
		else
			tmp.szQuestName = " "
		end
		tmp.usQuestType = dt:readShort()
		tmp.ucQuestStatus = dt:readByte()
		local str = dt:readString()
		if str then
			tmp.szAwardString = str:getData()
		else
			tmp.szAwardString = " "
		end
		tmp.ucAmountBrief = dt:readByte()
		tmp.Briefs = {}
		for j=1, tmp.ucAmountBrief do
			local tmp2 = {};
			tmp2.strBrief = ""
			local str = dt:readString()
			if str then
				tmp2.strBrief = str:getData()
			end
			
			tmp2.idMap = dt:readInt();
			tmp2.usPosX = dt:readShort();
			tmp2.usPosY = dt:readShort();
			tmp2.ucCurCondition = dt:readByte();
			tmp2.ucCondition = dt:readByte(); 
			tmp2.idCopy = dt:readInt();
			tmp2.idNpc = dt:readInt();
			tmp2.ucCopyType = dt:readByte();
			table.insert(tmp.Briefs, tmp2)
		end
		local count = 0
		for k=1, #m_TaskCanAcceptPage do
			if m_TaskCanAcceptPage[k].idQuest == tmp.idQuest then
				table.remove(m_TaskCanAcceptPage, k)
				table.insert(m_TaskCanAcceptPage, k, tmp)
				break
			end
			count = count + 1
		end
		if count == #m_TaskCanAcceptPage then
			table.insert(m_TaskCanAcceptPage, tmp)
		end
	end
end

local function delAbleTaskTask(idQuest)
	local canAcpList = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("1000-1-103"))
	if not canAcpList then
		return
	end
	local delItem = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("1000-1-103-"..idQuest))
	if not delItem then
		return
	end
	canAcpList:removeItem(delItem)
end

--删除可接受任务数据
local function onMsgUpdataAbleTaskList(dt)
	local idQuest = dt:readInt()
	for i=1, #m_TaskCanAcceptPage do
		if m_TaskCanAcceptPage[i].idQuest == idQuest then
			table.remove(m_TaskCanAcceptPage, i)
			delAbleTaskTask(i-1)
			break
		end
	end
end

--接受任务，完成任务光效
local function onMsgQuestAni(action)
	if action == ACTQUEST_QUEST_ACTION_RECEIVE then
		triggerEffect:createShowedEffect(1007, 1007, CCPointMake(getScreenWidth()/2, getScreenHeight()/2+90*gUIScale().y))
	elseif action == ACTQUEST_QUEST_ACTION_RETROCEDE then
		triggerEffect:createShowedEffect(1008, 1008, CCPointMake(getScreenWidth()/2, getScreenHeight()/2+90*gUIScale().y))
		--showNewFunOpenAnimation();
	end
end

--放弃任务
local function onGiveUpBtnClicked(tag)
	sendGiveUpTaskInfo(tag)
end

--任务界面点击自动寻路按钮
local function onFindRoadBtnClicked(tag)
	local i = math.floor(tag/10000);
	local j = math.mod(tag, 10000);
	if j == 0 then
		return;
	end
	
	local idMap = math.floor(GameCommonMsgRecive:getSingleton():getMapID() / 100) * 100;
	local idNpc = 1;
    if m_TaskAlreadyAcceptPage[i].ucQuestStatus ~= QUEST_STATUS_ACCEPT_NOT_FINISH then
        idNpc = m_TaskAlreadyAcceptPage[i].Briefs[j].idNpc;
    end
	if idNpc == 1 and (m_TaskAlreadyAcceptPage[i].Briefs[j].ucCopyType == 2 or m_TaskAlreadyAcceptPage[i].Briefs[j].ucCopyType == 3) then
        GameCopyController_showGameCopyWnd(m_TaskAlreadyAcceptPage[i].Briefs[j].idMap, m_TaskAlreadyAcceptPage[i].Briefs[j].ucCopyType, m_TaskAlreadyAcceptPage[i].Briefs[j].idCopy)
		onCloseTaskWnd();
        return;
    end
	if idMap == m_TaskAlreadyAcceptPage[i].Briefs[j].idMap then
	    Hero:getSingleton():setAutoFindRoad(m_TaskAlreadyAcceptPage[i].Briefs[j].idMap, m_TaskAlreadyAcceptPage[i].Briefs[j].usPosX, m_TaskAlreadyAcceptPage[i].Briefs[j].usPosY, 0, idNpc, m_TaskAlreadyAcceptPage[i].Briefs[j].idCopy);
		Hero:getSingleton():doNextFindRoad();
	else
	    Hero:getSingleton():setAutoFindRoad(m_TaskAlreadyAcceptPage[i].Briefs[j].idMap, m_TaskAlreadyAcceptPage[i].Briefs[j].usPosX, m_TaskAlreadyAcceptPage[i].Briefs[j].usPosY, 0, idNpc,m_TaskAlreadyAcceptPage[i].Briefs[j].idCopy);
		WorldMapController_pathfinding(m_TaskAlreadyAcceptPage[i].Briefs[j].idMap);
	end	
	onCloseTaskWnd();
end

--结束任务
local function onFinishTaskBtnClicked(tag)
	--sendTaskInfo(tag,ACTQUEST_QUEST_RETROCEDE_2)
	local i = math.floor(tag/10000);
	local j = math.mod(tag, 10000);
	if j == 0 then
		return;
	end

	local idMap = math.floor(GameCommonMsgRecive:getSingleton():getMapID() / 100) * 100;
	if idMap == m_TaskAlreadyAcceptPage[i].Briefs[j].idMap then
	    Hero:getSingleton():setAutoFindRoad(m_TaskAlreadyAcceptPage[i].Briefs[j].idMap, m_TaskAlreadyAcceptPage[i].Briefs[j].usPosX, m_TaskAlreadyAcceptPage[i].Briefs[j].usPosY, 0, m_TaskAlreadyAcceptPage[i].Briefs[j].idNpc, 0);
		Hero:getSingleton():doNextFindRoad();
	else
	    Hero:getSingleton():setAutoFindRoad(m_TaskAlreadyAcceptPage[i].Briefs[j].idMap, m_TaskAlreadyAcceptPage[i].Briefs[j].usPosX, m_TaskAlreadyAcceptPage[i].Briefs[j].usPosY, 0, m_TaskAlreadyAcceptPage[i].Briefs[j].idNpc, 0);
		WorldMapController_pathfinding(m_TaskAlreadyAcceptPage[i].Briefs[j].idMap);
	end	
	onCloseTaskWnd();
end

--填入已接受任务列表
local function fillAlreadyAcceptTaskWnd(curPage, pageLen)
	local wnd = getCurentSceneWindow(1000)
	local alreadAcpList = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("1000-1-101"))
	if not alreadAcpList or not wnd then
		return
	end
	local max = curPage*pageLen
	if max > #m_TaskAlreadyAcceptPage then
		max = #m_TaskAlreadyAcceptPage
	end
	for i=(curPage-1)*pageLen+1, max do
		if alreadAcpList:getChildByTag(i-1) then
			alreadAcpList:removeItemAtIndex(i-1)
		end
		--if not alreadAcpList:getChildByTag(m_TaskAlreadyAcceptPage[i].idQuest) then
		local size = m_TaskAlreadyAcceptPage[i].ucAmountBrief
		local addHigh = 0
		if size > 1 and size < 6 then
			addHigh = (size-1)*specialHigh
		end
		local pNode = SCNode:node()
		setNodeContentSize(pNode, CCSizeMake(getNodeContentSize(wnd).width-30, 3*sumLabelHigh + addHigh + 20));
		alreadAcpList:insertItemAtIndex(pNode, i-1)
		--pNode:setTag(m_TaskAlreadyAcceptPage[i].idQuest)
		local pDragNode = SCDragNode:node()
		setNodeContentSize(pDragNode, CCSizeMake(getNodeContentSize(wnd).width-30, 3*sumLabelHigh + addHigh + 10));
		pDragNode:setAnchorPoint(CCPointMake(0,0))
		setNodePostion(pDragNode, CCPointMake(0,5))
		pDragNode:setFrameType(EnumFrameTypeRound)
		pDragNode:setFrameVisibled(true)
		pNode:addChild(pDragNode)

		local strName = "["
		if m_TaskAlreadyAcceptPage[i].usQuestType ==  QUEST_TYPE_NORMAL or m_TaskAlreadyAcceptPage[i].usQuestType == INSTANCE_TYPE_S_NORMAL then
			strName = strName.._LTParser("str0274")
		elseif m_TaskAlreadyAcceptPage[i].usQuestType == QUEST_TYPE_MAIN then
			strName = strName.._LTParser("str0275")
	    elseif INSTANCE_TYPE_S_SMART == m_TaskAlreadyAcceptPage[i].usQuestType then      --精英
	        strName = strName.._LTParser("str5107")
	    elseif INSTANCE_TYPE_S_CHALLENGER == m_TaskAlreadyAcceptPage[i].usQuestType then --魔王
	        strName = strName.._LTParser("str3025")
		end
		strName = strName.."]"
		strName = strName..m_TaskAlreadyAcceptPage[i].szQuestName
		local pQuestName = SCLabel:labelWithStringFont(strName, getDefaultFontName(), getFontSize(14))
		setNodeContentSize(pQuestName, CCSizeMake(getNodeContentSize(wnd).width/3, 20))
		pQuestName:setAnchorPoint(CCPointMake(0,0))
		setNodePostion(pQuestName, CCPointMake(10, getNodeContentSize(pDragNode).height - sumLabelHigh));
		pQuestName:setColor(color_green)
		pDragNode:addChild(pQuestName)

		local strBrief = _LTParser("str0276")
		local strNull = "_          "
		local pBrief = SCNode:node()
		local curBriefIndex = 0;--用于处理自动寻路
		for j=1, #m_TaskAlreadyAcceptPage[i].Briefs do
			if j == 1 then
				strBrief = strBrief..m_TaskAlreadyAcceptPage[i].Briefs[j].strBrief
			else
				strBrief = strBrief..strNull
				strBrief = strBrief..m_TaskAlreadyAcceptPage[i].Briefs[j].strBrief
			end
			
			if m_TaskAlreadyAcceptPage[i].Briefs[j].ucCurCondition < m_TaskAlreadyAcceptPage[i].Briefs[j].ucCondition and m_TaskAlreadyAcceptPage[i].Briefs[j].ucCondition ~= 0 then
				curBriefIndex = j;
			end 
			
			if m_TaskAlreadyAcceptPage[i].Briefs[j].ucCondition == 0 then
			    curBriefIndex = j;
			end
		end

		local pParsedNode = getItemTextNode(strBrief)
		if pParsedNode then
			setNodePostion(pParsedNode, CCPointMake(0, 0))
			pParsedNode:setAnchorPoint(CCPointMake(0, 0))
			setNodeContentSize(pBrief, CCSizeMake(getNodeContentSize(wnd).width/3, getNodeContentSize(pParsedNode).height))
			pBrief:setAnchorPoint(CCPointMake(0,0));
			setNodePostion(pBrief, CCPointMake(10, (getNodeContentSize(pDragNode).height - getNodeContentSize(pBrief).height) / 2))
			pBrief:addChild(pParsedNode)
			pDragNode:addChild(pBrief)
		end

		local strPaward = _LTParser("str0277")
		strPaward = strPaward..m_TaskAlreadyAcceptPage[i].szAwardString
		local pAward = SCNode:node()
		setNodeContentSize(pAward, CCSizeMake(getNodeContentSize(wnd).width/3, 20))
		pAward:setAnchorPoint(CCPointMake(0,0))
		setNodePostion(pAward, CCPointMake(10,10))
		local pParsedAward = getItemTextNode(strPaward)
		if pParsedAward then
			pAward:addChild(pParsedAward)
			pDragNode:addChild(pAward)
		end

		local pAcceptBtn = SCButton:button(EnumBtnType9Atlas)
		setNodeContentSize(pAcceptBtn, CCSizeMake(70, 26))
		pAcceptBtn:setAnchorPoint(CCPointMake(0.5,0.5))
		setNodePostion(pAcceptBtn, CCPointMake(getNodeContentSize(pDragNode).width - 1.5*getNodeContentSize(pAcceptBtn).width - 20, getNodeContentSize(pDragNode).height/2))
		pAcceptBtn:setTitle(_LTParser("str0279"), getDefaultFontName(), getFontSize(12), color_yellow)
		pAcceptBtn:setTag(m_TaskAlreadyAcceptPage[i].idQuest)
		pAcceptBtn:luaSetSelectorOnClicked(onGiveUpBtnClicked)
		pDragNode:addChild(pAcceptBtn)

		local pBtn = SCButton:button(EnumBtnType9Atlas)
		setNodeContentSize(pBtn, CCSizeMake(70, 26))
		pBtn:setAnchorPoint(CCPointMake(0.5,0.5))
		setNodePostion(pBtn, CCPointMake(getNodeContentSize(pDragNode).width - getNodeContentSize(pAcceptBtn).width/2 - 10, getNodeContentSize(pDragNode).height/2))
		local tag = i * 10000 + curBriefIndex;
		pBtn:setTag(tag);
		if m_TaskAlreadyAcceptPage[i].ucQuestStatus == QUEST_STATUS_CAN_RETURN then
			pBtn:setTitle(_LTParser("str0280"), getDefaultFontName(), getFontSize(12), color_yellow)
			pBtn:luaSetSelectorOnClicked(onFinishTaskBtnClicked)
		elseif m_TaskAlreadyAcceptPage[i].ucQuestStatus == QUEST_STATUS_ACCEPT_NOT_FINISH then
			pBtn:setTitle(_LTParser("str0281"), getDefaultFontName(), getFontSize(12), color_yellow);
			pBtn:luaSetSelectorOnClicked(onFindRoadBtnClicked)
		end
		pDragNode:addChild(pBtn);
		--end
	end
	if max == 0 then 
		local str = _LTParser("str3039")
		local labelMsg = SCLabel:labelWithStringFont(str, getDefaultFontName(), getFontSize(15))
		if labelMsg then
			labelMsg:setAnchorPoint(CCPointMake(0.5, 0.5))
		    labelMsg:setPosition(SX(240),SY(180))
		    alreadAcpList:addChild(labelMsg)
		    labelMsg:setColor(colorYellow())
		end
	end
end

--刷新已接受任务列表
local function refreshAlreadyAcceptList(curPage, pageLen)
	local alreadAcpList = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("1000-1-101"))
	if not alreadAcpList then
		return
	end
	--alreadAcpList:removeAllItems()
	fillAlreadyAcceptTaskWnd(curPage, pageLen)
end

local function onAcceptBtnClicked(tag)
	--sendTaskInfo(tag, ACTQUEST_ADD_ABLELIST_2)
	local i = math.floor(tag/10000);
	local j = math.mod(tag, 10000);
	if j == 0 then
		return;
	end

	local idMap = math.floor(GameCommonMsgRecive:getSingleton():getMapID() / 100) * 100;
	if idMap == m_TaskCanAcceptPage[i].Briefs[j].idMap then
	    Hero:getSingleton():setAutoFindRoad(m_TaskCanAcceptPage[i].Briefs[j].idMap, m_TaskCanAcceptPage[i].Briefs[j].usPosX, m_TaskCanAcceptPage[i].Briefs[j].usPosY, 0, m_TaskCanAcceptPage[i].Briefs[j].idNpc, 0);
		Hero:getSingleton():doNextFindRoad();
	else
	    Hero:getSingleton():setAutoFindRoad(m_TaskCanAcceptPage[i].Briefs[j].idMap, m_TaskCanAcceptPage[i].Briefs[j].usPosX, m_TaskCanAcceptPage[i].Briefs[j].usPosY, 0, m_TaskCanAcceptPage[i].Briefs[j].idNpc, 0);
		WorldMapController_pathfinding(m_TaskCanAcceptPage[i].Briefs[j].idMap);
	end	
	onCloseTaskWnd();
end

--刷新可接任务
local function fillCanAcceptTaskWnd(curPage, pageLen)
	local wnd = getCurentSceneWindow(1000)
	local canAcpList = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("1000-1-103"))
	if not canAcpList or not wnd then
		return
	end
	local max = curPage*pageLen
	if max > #m_TaskCanAcceptPage then
		max = #m_TaskCanAcceptPage
	end
	for i=(curPage-1)*pageLen+1, max do
		if canAcpList:getChildByTag(i-1) then
			canAcpList:removeItemAtIndex(i-1)
		end
		--if not canAcpList:getChildByTag(m_TaskCanAcceptPage[i].idQuest) then
		local size = m_TaskCanAcceptPage[i].ucAmountBrief
		local addHigh = 0
		if size > 1 and size < 6 then
			addHigh = (size-1)*specialHigh
		end
		local pNode = SCNode:node()
		setNodeContentSize(pNode, CCSizeMake(getNodeContentSize(wnd).width-30, 3*sumLabelHigh + addHigh + 20));
		canAcpList:insertItemAtIndex(pNode, i-1)
		--pNode:setTag(m_TaskCanAcceptPage[i].idQuest)
		local pDragNode = SCDragNode:node()
		setNodeContentSize(pDragNode, CCSizeMake(getNodeContentSize(wnd).width-30, 3*sumLabelHigh + addHigh + 10));
		pDragNode:setAnchorPoint(CCPointMake(0,0))
		setNodePostion(pDragNode, CCPointMake(0,5))
		pDragNode:setFrameType(EnumFrameTypeRound)
		pDragNode:setFrameVisibled(true)
		pNode:addChild(pDragNode)

		local strName = "["
		if m_TaskCanAcceptPage[i].usQuestType ==  QUEST_TYPE_NORMAL or m_TaskCanAcceptPage[i].usQuestType == INSTANCE_TYPE_S_NORMAL then
			strName = strName.._LTParser("str0274")
		elseif m_TaskCanAcceptPage[i].usQuestType == QUEST_TYPE_MAIN then
			strName = strName.._LTParser("str0275")
	    elseif #m_TaskAlreadyAcceptPage > 0 and m_TaskAlreadyAcceptPage[i] ~= nil and INSTANCE_TYPE_S_SMART == m_TaskCanAcceptPage[i].usQuestType then   --精英
	        strName = strName.._LTParser("str5107")
	    elseif #m_TaskAlreadyAcceptPage > 0 and m_TaskAlreadyAcceptPage[i] ~= nil and INSTANCE_TYPE_S_CHALLENGER == m_TaskCanAcceptPage[i].usQuestType then   --魔王
	        strName = strName.._LTParser("str3025")
		end
		strName = strName.."]"
		strName = strName..m_TaskCanAcceptPage[i].szQuestName
		local pQuestName = SCLabel:labelWithStringFont(strName, getDefaultFontName(), getFontSize(14))
		setNodeContentSize(pQuestName, CCSizeMake(getNodeContentSize(wnd).width/3, 20))
		pQuestName:setAnchorPoint(CCPointMake(0,0))
		setNodePostion(pQuestName, CCPointMake(10, getNodeContentSize(pDragNode).height - sumLabelHigh));
		pQuestName:setColor(color_green)
		pDragNode:addChild(pQuestName)

		local strBrief = _LTParser("str0276")
		local strNull = "_          "
		local pBrief = SCNode:node()
		local curBriefIndex = 0;--用于处理自动寻路
		for j=1, #m_TaskCanAcceptPage[i].Briefs do
			if j == 1 then
				strBrief = strBrief..m_TaskCanAcceptPage[i].Briefs[j].strBrief
			else
				strBrief = strBrief..strNull
				strBrief = strBrief..m_TaskCanAcceptPage[i].Briefs[j].strBrief
			end
			
			if m_TaskCanAcceptPage[i].Briefs[j].ucCurCondition < m_TaskCanAcceptPage[i].Briefs[j].ucCondition and m_TaskCanAcceptPage[i].Briefs[j].ucCondition ~= 0 then
				curBriefIndex = j;
			end 
			
			if m_TaskCanAcceptPage[i].Briefs[j].ucCondition == 0 then
			    curBriefIndex = j;
			end
		end

		local pParsedNode = getItemTextNode(strBrief)
		if pParsedNode then
			setNodePostion(pParsedNode, CCPointMake(0, 0))
			pParsedNode:setAnchorPoint(CCPointMake(0, 0))
			setNodeContentSize(pBrief, CCSizeMake(getNodeContentSize(wnd).width/3, getNodeContentSize(pParsedNode).height))
			pBrief:setAnchorPoint(CCPointMake(0,0));
			setNodePostion(pBrief, CCPointMake(10, (getNodeContentSize(pDragNode).height - getNodeContentSize(pBrief).height) / 2))
			pBrief:addChild(pParsedNode)
			pDragNode:addChild(pBrief)
		end

		local strPaward = _LTParser("str0277")
		strPaward = strPaward..m_TaskCanAcceptPage[i].szAwardString
		local pAward = SCNode:node()
		setNodeContentSize(pAward, CCSizeMake(getNodeContentSize(wnd).width/3, 20))
		pAward:setAnchorPoint(CCPointMake(0,0))
		setNodePostion(pAward, CCPointMake(10,10))
		local pParsedAward = getItemTextNode(strPaward)
		if pParsedAward then
			pAward:addChild(pParsedAward)
			pDragNode:addChild(pAward)
		end

		local pAcceptBtn = SCButton:button(EnumBtnType9Atlas)
		setNodeContentSize(pAcceptBtn, CCSizeMake(70, 26))
		pAcceptBtn:setAnchorPoint(CCPointMake(0.5,0.5))
		setNodePostion(pAcceptBtn, CCPointMake(getNodeContentSize(pDragNode).width - getNodeContentSize(pAcceptBtn).width, getNodeContentSize(pDragNode).height/2));
		pAcceptBtn:setTitle(_LTParser("str0278"), getDefaultFontName(), getFontSize(12), color_yellow)
		local tag = i * 10000 + curBriefIndex;
		pAcceptBtn:setTag(tag);
		pAcceptBtn:luaSetSelectorOnClicked(onAcceptBtnClicked)
		pDragNode:addChild(pAcceptBtn)
		--end
	end
	if max == 0 then 
		local str = _LTParser("str9140")
		local labelMsg = SCLabel:labelWithStringFont(str, getDefaultFontName(), getFontSize(15))
		if labelMsg then
			labelMsg:setAnchorPoint(CCPointMake(0.5, 0.5))
		    labelMsg:setPosition(SX(240),SY(180))
		    canAcpList:addChild(labelMsg)
		    labelMsg:setColor(colorYellow())
		end
	end
end

--刷新下一级可接任务
local function fillNextCanAcceptTaskWnd(curPage, pageLen)
	local wnd = getCurentSceneWindow(1000)
	local canAcpList = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("1000-1-103"))
	if not canAcpList or not wnd then
		return
	end
	local max = curPage*pageLen
	if max > #m_TaskCanAcceptPage then
		max = #m_TaskCanAcceptPage
	end
	for i=(curPage-1)*pageLen+1, max do
		if canAcpList:getChildByTag(i-1) then
			canAcpList:removeItemAtIndex(i-1)
		end
		--if not canAcpList:getChildByTag(m_TaskCanAcceptPage[i].idQuest) then
		local size = m_TaskCanAcceptPage[i].ucAmountBrief
		local addHigh = 0
		if size > 1 and size < 6 then
			addHigh = (size-1)*specialHigh
		end
		local pNode = SCNode:node()
		setNodeContentSize(pNode, CCSizeMake(getNodeContentSize(wnd).width-30, 3*sumLabelHigh + addHigh + 20));
		canAcpList:insertItemAtIndex(pNode, i-1)
		--pNode:setTag(m_TaskCanAcceptPage[i].idQuest)
		local pDragNode = SCDragNode:node()
		setNodeContentSize(pDragNode, CCSizeMake(getNodeContentSize(wnd).width-30, 3*sumLabelHigh + addHigh + 10));
		pDragNode:setAnchorPoint(CCPointMake(0,0))
		setNodePostion(pDragNode, CCPointMake(0,5))
		pDragNode:setFrameType(EnumFrameTypeRound)
		pDragNode:setFrameVisibled(true)
		pNode:addChild(pDragNode)

		local strName = "["
		if m_TaskCanAcceptPage[i].usQuestType ==  QUEST_TYPE_NORMAL or m_TaskCanAcceptPage[i].usQuestType == INSTANCE_TYPE_S_NORMAL then
			strName = strName.._LTParser("str0274")
		elseif m_TaskCanAcceptPage[i].usQuestType == QUEST_TYPE_MAIN then
			strName = strName.._LTParser("str0275")
		elseif INSTANCE_TYPE_S_SMART == m_TaskAlreadyAcceptPage[i].usQuestType then  --精英
	        strName = strName.._LTParser("str5107")
	    elseif INSTANCE_TYPE_S_CHALLENGER == m_TaskAlreadyAcceptPage[i].usQuestType then  --魔王
	        strName = strName.._LTParser("str3025")
	    elseif INSTANCE_TYPE_TRIBE == m_TaskAlreadyAcceptPage[i].usQuestType then
	        strName = strName.._LTParser("str0275")
		end
		strName = strName.."]"
		strName = strName..m_TaskCanAcceptPage[i].szQuestName
		local pQuestName = SCLabel:labelWithStringFont(strName, getDefaultFontName(), getFontSize(14))
		setNodeContentSize(pQuestName, CCSizeMake(getNodeContentSize(wnd).width/3, 20))
		pQuestName:setAnchorPoint(CCPointMake(0,0))
		setNodePostion(pQuestName, CCPointMake(10, getNodeContentSize(pDragNode).height - sumLabelHigh));
		pQuestName:setColor(color_green)
		pDragNode:addChild(pQuestName)

		local strBrief = _LTParser("str0276")
		local strNull = "_          "
		local pBrief = SCNode:node()
		for j=1, #m_TaskCanAcceptPage[i].Briefs do
			if j == 1 then
				strBrief = strBrief..m_TaskCanAcceptPage[i].Briefs[j]
			else
				strBrief = strBrief..strNull
				strBrief = strBrief..m_TaskCanAcceptPage[i].Briefs[j]
			end
		end

		local pParsedNode = getItemTextNode(strBrief)
		if pParsedNode then
			setNodePostion(pParsedNode, CCPointMake(0, 0))
			pParsedNode:setAnchorPoint(CCPointMake(0, 0))
			setNodeContentSize(pBrief, CCSizeMake(getNodeContentSize(wnd).width/3, getNodeContentSize(pParsedNode).height))
			pBrief:setAnchorPoint(CCPointMake(0,0));
			setNodePostion(pBrief, CCPointMake(10, (getNodeContentSize(pDragNode).height - getNodeContentSize(pBrief).height) / 2))
			pBrief:addChild(pParsedNode)
			pDragNode:addChild(pBrief)
		end

		local strPaward = _LTParser("str0277")
		strPaward = strPaward..m_TaskCanAcceptPage[i].szAwardString
		local pAward = SCNode:node()
		setNodeContentSize(pAward, CCSizeMake(getNodeContentSize(wnd).width/3, 20))
		pAward:setAnchorPoint(CCPointMake(0,0))
		setNodePostion(pAward, CCPointMake(10,10))
		local pParsedAward = getItemTextNode(strPaward)
		if pParsedAward then
			pAward:addChild(pParsedAward)
			pDragNode:addChild(pAward)
		end
		local nextLeval = Hero:getSingleton():getLeval() + 1
		local str = nextLeval.._LTParser("str8122")
		local labelMsg = SCLabel:labelWithStringFont(str, getDefaultFontName(), getFontSize(12))
		if labelMsg then
			labelMsg:setAnchorPoint(CCPointMake(0.5, 0.5))
		    --labelMsg:setPosition(SX(240),SY(190))
		    setNodePostion(labelMsg, CCPointMake(getNodeContentSize(pDragNode).width - getNodeContentSize(labelMsg).width, getNodeContentSize(pDragNode).height/2))
		    pDragNode:addChild(labelMsg)
		    labelMsg:setColor(colorRed())
		end
	end
	if max == 0 then 
		local str = _LTParser("str9140")
		local labelMsg = SCLabel:labelWithStringFont(str, getDefaultFontName(), getFontSize(15))
		if labelMsg then
			labelMsg:setAnchorPoint(CCPointMake(0.5, 0.5))
		    labelMsg:setPosition(SX(240),SY(180))
		    canAcpList:addChild(labelMsg)
		    labelMsg:setColor(colorYellow())
		end
	end
end
--刷新未接受任务列表
local function refreshCanAcceptList(curPage, pageLen)
	local canAcpList = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("1000-1-103"))
	if not canAcpList then
		return
	end
	--canAcpList:removeAllItems()
	fillCanAcceptTaskWnd(curPage, pageLen)
end

--刷新下一级可接受任务列表
local function refreshNextCanAcceptList(curPage, pageLen)
	local canAcpList = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("1000-1-103"))
	if not canAcpList then
		return
	end
	--canAcpList:removeAllItems()
	fillNextCanAcceptTaskWnd(curPage, pageLen)
end

--任务接收数据
local function recvTaskData()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    if dt == nil then
        return;
    end
    local action = dt:readShort()
    if action == ACTQUEST_ABLERECQUEST_QUERY_BYLABEL then
		onMsgCanAcceptTaskList(dt)
    elseif action == ACTQUEST_ABLERECQUEST_QUERY_BYLABELEND then
		onMsgCanAcceptTaskList(dt)
		m_curPage = 1
		local canAcpList = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("1000-1-103"))
		if not canAcpList then
			return
		end
		

		canAcpList:removeAllItems()
		refreshCanAcceptList(m_curPage, m_pageLen)
		

    elseif action == ACTQUEST_CURRENDTQUEST_QUERY_BYLABEL then
		onMsgAlreadyAcceptTaskList(dt)
    elseif action == ACTQUEST_CURRENDTQUEST_QUERY_BYLABELEND then
		onMsgAlreadyAcceptTaskList(dt)
		m_curPage = 1
		local alreadAcpList = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("1000-1-101"))
		if not alreadAcpList then
			return
		end
		if m_taskNum == 0 then
			if m_taskJudge then
				local multiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("1000-1"))
				multiPage:selectPageWithIndex(1)
				m_taskJudge = false
			end
		end
		alreadAcpList:removeAllItems()
		refreshAlreadyAcceptList(m_curPage, m_pageLen)


    elseif action == ACTQUEST_DEL then
		onMsgUpdataAlreadyTaskList(dt)
		refreshAlreadyAcceptList(m_curPage, m_pageLen)
    elseif action == ACTQUEST_CUR_QUEST_GUIDE_ADD then
	
    elseif action == ACTQUEST_ADD_ABLELIST_2 then
    
    elseif action == ACTQUEST_QUEST_RETROCEDE_2 then
    
    elseif action == ACTQUEST_ABLE_RECEVIE_DEL then
		onMsgUpdataAbleTaskList(dt)
		refreshCanAcceptList(m_curPage, m_pageLen)
    elseif action == ACTQUEST_QUEST_ACTION_RECEIVE then
		onMsgQuestAni(action)
    elseif action == ACTQUEST_QUEST_ACTION_RETROCEDE then
		onMsgQuestAni(action)
    elseif action == ACTQUEST_OVER_QUEST_TIP then
		--onMsgQuestTip(dt)
    elseif action == ACTQUEST_CUR_MAIN_QUEST_GUIDE then
		LuaData:getSingleton():setDataTransStream(LuaData_ACTQUEST_CUR_MAIN_QUEST_GUIDE, dt)
	elseif action == ACTQUEST_ABLERECQUEST_QUERY_NEXTLEV then
		onMsgCanAcceptTaskList(dt)
	elseif action == ACTQUEST_ABLERECQUEST_QUERY_NEXTLEVEND then
		onMsgCanAcceptTaskList(dt)
		m_curPage = 1
		local canAcpList = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("1000-1-103"))
		if not canAcpList then
			return
		end
		canAcpList:removeAllItems()
		refreshNextCanAcceptList(m_curPage, m_pageLen)
	elseif action == ACTQUEST_QUICK_QUEST_UPDATA then
		m_TaskCurQuestQuickList = {}
	elseif action == ACTQUEST_QUICK_QUEST_BYLABEL then
	    onMsgQuestQuickList(dt);
	elseif action == ACTQUEST_QUICK_QUEST_BYLABEL_END then
	    onMsgQuestQuickList(dt);
	    showMainInterfaceTaskList();
	elseif action == ACTQUEST_SEND_EVERYDAY_QUEST_INFO then
		TaskForDay_recvEverydayTaskInfo(dt);
	elseif action == ACTQUEST_SEND_EVERYDAY_FINISH then
		TaskForDay_recvEverydayTaskFinish(dt);
    elseif ACTQUEST_QUEST_NEXT_LEV == action then
        local str = dt:readString();
        if str then
            stNextQuest.szQuestName = str:getData();		--//任务名称
        else
            stNextQuest.szQuestName = "";		--//任务名称
        end
        stNextQuest.nLev = dt:readInt();                                   --//可接等级 
        stNextQuest.idPhoto = dt:readInt();
        MainInterface_seTaskBtn(--[[L("str9169") .. ]]stNextQuest.szQuestName .. L("str6196"), stNextQuest.idPhoto, color_red);
    elseif ACTQUEST_QUEST_OVERFLAG_INIT==action then
        onMsgQuestOverInit(dt);
    elseif ACTQUEST_QUEST_STATUS_SHOW==action then
        onMsgQuestStatusUpdate(dt);
    elseif ACTQUEST_QUEST_OVERFLAG_SHOW==action then
        onMsgQuestOverUpdate(dt);
    end
end

SCMessageCenter:getSingleton():luaRegistCommand(recvTaskData, _MSG_ACTQUEST, 0, nil)

--关闭窗口回调
local function taskWndClose()
	clearData()
end

--选择事件回调
local function onSelect(tag, pageIndex)
	m_curPage = 1
	if 0 == pageIndex then
		--requestTaskList(ACTQUEST_CURRENDTQUEST_QUERY_BYLABEL, m_curPage, m_pageLen)
		requestTaskList(ACTQUEST_CURRENDTQUEST_QUERY_BYLABEL, m_curPage, m_pageLen)
		--refreshAlreadyAcceptList(m_curPage, m_pageLen)
	elseif 1 == pageIndex then
		--requestTaskList(ACTQUEST_ABLERECQUEST_QUERY_BYLABEL, m_curPage, m_pageLen)
		requestTaskList(ACTQUEST_ABLERECQUEST_QUERY_BYLABEL, m_curPage, m_pageLen)
		--refreshCanAcceptList(m_curPage, m_pageLen)
	end
end

local function alreadyScrollEnd(tag)
	m_curPage = m_curPage + 1
	--requestTaskList(ACTQUEST_CURRENDTQUEST_QUERY_BYLABEL, m_curPage, m_pageLen)
	refreshAlreadyAcceptList(m_curPage, m_pageLen)
end

local function canacceptScrollEnd(tag)
	m_curPage = m_curPage + 1
	--requestTaskList(ACTQUEST_ABLERECQUEST_QUERY_BYLABEL, m_curPage, m_pageLen)
	refreshCanAcceptList(m_curPage, m_pageLen)
end

local function ctrlEvent(tag, eventType)
	if eventType == LuaControllerEventPushEnded then
		requestTaskList(ACTQUEST_CURRENDTQUEST_QUERY_BYLABEL, m_curPage, m_pageLen)
		--requestTaskList(ACTQUEST_ABLERECQUEST_QUERY_BYLABEL, m_curPage, m_pageLen)
	end
end

--创建任务窗口
function createTaskWnd()
	if isWindControllerExistence(1000) then
		return
	end
	local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(1000))
	if not wnd then
		return
	end
	wnd:setBackgroundColor(color_window_red_bg)
	wnd:luaSetSelectorOnClose(taskWndClose)
	local pImgTitle = getRealUIResourcePath("img/new00057.png")
	local pImgCanAcceptTask = getRealUIResourcePath("img/new00062.png")
	local pImgAlreadyAcceptTask = getRealUIResourcePath("img/new00061.png")
	if not pImgAlreadyAcceptTask or not pImgTitle or not pImgCanAcceptTask then
		return
	end
	wnd:setTitleWithImage(pImgTitle:getData())
	local multiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlistAndParent("1", wnd))
	if multiPage then
		multiPage:luaSetSelectorOnPageSelected(onSelect)
		multiPage:setTitleAtPage(pImgCanAcceptTask:getData(), 0)
		multiPage:setTitleAtPage(pImgAlreadyAcceptTask:getData(), 1)
	end
	local pNode = SCTypeCast:castNodeToListBox(multiPage:getPageWithIndex(0))
	if pNode then
		pNode:luaSetSelectorOnScrollToEnd(alreadyScrollEnd)
		pNode:setAnchorPoint(CCPointMake(0, 0))
		setNodePostion(pNode, CCPointMake((getNodeContentSize(wnd).width-getNodeContentSize(pNode).width)/2,10))
	end
	local pNode = SCTypeCast:castNodeToListBox(multiPage:getPageWithIndex(1))
	if pNode then
		pNode:luaSetSelectorOnScrollToEnd(canacceptScrollEnd)
		pNode:setAnchorPoint(CCPointMake(0, 0))
		setNodePostion(pNode, CCPointMake((getNodeContentSize(wnd).width-getNodeContentSize(pNode).width)/2,10))
	end
	
	local wndCtrl = SCWindowController:controllerWithWindow(wnd)
	wndCtrl:luaSetSelectorOnEvent(ctrlEvent)
	if not wndCtrl then
		return
	end
	local naviCtrl =  getCurentSceneNavigationController()
	if not naviCtrl then
		return
	end
	naviCtrl:pushWindowController(wndCtrl)
end

function CopyQuest_getNeedCopySweepInfo()
    return m_nCopySweepTimes;
end

function CopyQuest_setNeedCopySweepInfo(nTimes)
    m_nCopySweepTimes = nTimes;
end

--主界面任务按钮响应
function Task_onMainInterfaceBtnClick(tag)
    if tag == 1007 then
		if #m_TaskCurQuestQuickList < 1 then
			return;
		end
		--[[local pNode = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-1007-2-1"), "SCNode") --自动寻路隐藏引导框
		if pNode then
		    pNode:setVisible(false);
		end--]]
		m_TaskFindRoadIndex = 1;
	elseif tag == 1005 then
		if #m_TaskCurQuestQuickList < 2 then
			return;
		end
		m_TaskFindRoadIndex = 2;
	elseif tag == 1006 then
		if #m_TaskCurQuestQuickList < 3 then
			return;
		end
		m_TaskFindRoadIndex = 3;
	elseif tag == 1008 then
		if #m_TaskCurQuestQuickList < 4 then
			return;
		end	
		m_TaskFindRoadIndex = 4;
	end
    if m_TaskCurQuestQuickList[m_TaskFindRoadIndex].ucQuestStatus == QUEST_STATUS_UNABLE then
        showMessage(m_TaskCurQuestQuickList[m_TaskFindRoadIndex].szMessage);
        return
    end
    local roleLevel = Hero:getSingleton():getLeval();
    if stNextQuest.nLev and roleLevel < stNextQuest.nLev then
        if m_TaskFindRoadIndex == 1 then
            showMessage(L("str6197") .. stNextQuest.nLev .. L("str6198"));
            return;
        else
            m_TaskFindRoadIndex = m_TaskFindRoadIndex - 1;
        end
    end
   
	local idMap = math.floor(GameCommonMsgRecive:getSingleton():getMapID() / 100) * 100;
    local idNpc = 1;
    if m_TaskCurQuestQuickList[m_TaskFindRoadIndex].ucQuestStatus ~= QUEST_STATUS_ACCEPT_NOT_FINISH then
        idNpc = m_TaskCurQuestQuickList[m_TaskFindRoadIndex].idNpc;
    end

    local nCurAmount = m_TaskCurQuestQuickList[m_TaskFindRoadIndex].ucCurCondition;
    local nNeedAmount = m_TaskCurQuestQuickList[m_TaskFindRoadIndex].ucCondition;
    if nCurAmount<nNeedAmount then
        CopyQuest_setNeedCopySweepInfo(nNeedAmount-nCurAmount);
    else
        CopyQuest_setNeedCopySweepInfo(0);
    end
    
    if idNpc == 1 and (m_TaskCurQuestQuickList[m_TaskFindRoadIndex].ucType == 2 or m_TaskCurQuestQuickList[m_TaskFindRoadIndex].ucType == 3) then
        GameCopyController_showGameCopyWnd(m_TaskCurQuestQuickList[m_TaskFindRoadIndex].idMap, m_TaskCurQuestQuickList[m_TaskFindRoadIndex].ucType, m_TaskCurQuestQuickList[m_TaskFindRoadIndex].idCopy)
        return;
    end
	if idMap == m_TaskCurQuestQuickList[m_TaskFindRoadIndex].idMap then
		Hero:getSingleton():setAutoFindRoad(m_TaskCurQuestQuickList[m_TaskFindRoadIndex].idMap, m_TaskCurQuestQuickList[m_TaskFindRoadIndex].usPosX, m_TaskCurQuestQuickList[m_TaskFindRoadIndex].usPosY, 0, idNpc, m_TaskCurQuestQuickList[m_TaskFindRoadIndex].idCopy);
		Hero:getSingleton():doNextFindRoad();
	else
	    Hero:getSingleton():setAutoFindRoad(m_TaskCurQuestQuickList[m_TaskFindRoadIndex].idMap, m_TaskCurQuestQuickList[m_TaskFindRoadIndex].usPosX, m_TaskCurQuestQuickList[m_TaskFindRoadIndex].usPosY, 0, idNpc, m_TaskCurQuestQuickList[m_TaskFindRoadIndex].idCopy);
		WorldMapController_pathfinding(m_TaskCurQuestQuickList[m_TaskFindRoadIndex].idMap);
	end
end

--继续任务自动寻路
function Task_autoFindRoad()
	if m_TaskFindRoadIndex == 0 then
		return;
	end
	
	local idMap = math.floor(GameCommonMsgRecive:getSingleton():getMapID() / 100) * 100;
	local idNpc = 1;
    if m_TaskCurQuestQuickList[i].Briefs[j].ucQuestStatus ~= QUEST_STATUS_ACCEPT_NOT_FINISH then
        idNpc = m_TaskCurQuestQuickList[i].Briefs[j].idNpc;
    end
	if idMap == m_TaskCurQuestQuickList[m_TaskFindRoadIndex].idMap then
		Hero:getSingleton():setAutoFindRoad(m_TaskCurQuestQuickList[i].Briefs[j].idMap, m_TaskCurQuestQuickList[i].Briefs[j].usPosX, m_TaskCurQuestQuickList[i].Briefs[j].usPosY, 0, idNpc, m_TaskCurQuestQuickList[i].Briefs[j].idCopy);
		Hero:getSingleton():doNextFindRoad();
	else
	    Hero:getSingleton():setAutoFindRoad(m_TaskCurQuestQuickList[i].Briefs[j].idMap, m_TaskCurQuestQuickList[i].Briefs[j].usPosX, m_TaskCurQuestQuickList[i].Briefs[j].usPosY, 0, idNpc, m_TaskCurQuestQuickList[i].Briefs[j].idCopy);
		WorldMapController_pathfinding(m_TaskCurQuestQuickList[m_TaskFindRoadIndex].idMap);
	end	
end

--清除自动寻路状态
function Task_clearAutoFindRoadIndex()
	m_TaskFindRoadIndex = 0;
	Hero:getSingleton():setAutoWork(false);
end