--定义一个与文件名相同的table
Through = {}

g_Through_bBuyTimes = false;
g_Through_bisOpen = false;

local m_bChangeDir = false;
------------------消息--------------------

----------------结构定义区----------------

local stThroughInfo = {
	initWithStream  = function(dt)
		if dt == nil then
			return;
		end
		
		local tmp = {
            __mode = "kv",
        }
		
		tmp.dwPreThroughIndex = dt:readInt()    --//上一次关卡编号
		tmp.dwThroughIndex = dt:readInt()		--//当前关卡(波)编号
		tmp.usLeaveEnterTimes = dt:readShort()	--//剩余进入次数
		tmp.usCostTiredness = dt:readShort()	--//消耗体力
		tmp.szNeedPrestige = "";
		local tmpNeedPrestige = dt:readString();
		if tmpNeedPrestige then
		    tmp.szNeedPrestige = tmpNeedPrestige:getData();
		end
		
		tmp.szName = "";						--//关卡(波)名称
		tmp.szBoss = "";						--//守关boss名称
		tmp.szAward = "";						--//关卡(波)奖励
		local tmpName = dt:readString();
		if tmpName then
			tmp.szName = tmpName:getData();
		end
		
		local tmpBoss = dt:readString();
		if tmpBoss then
			tmp.szBoss = tmpBoss:getData();
		end
		
		local tmpAward = dt:readString();
		if tmpAward then
			tmp.szAward = tmpAward:getData();
		end
		
		return tmp
	end
}

local stGroupInfo = {
	initWithStream = function(dt)
		if dt == nil then
			return;
		end
	
		local tmp = {
            __mode = "kv",
        }
		
		tmp.dwGroup = dt:readInt();
		tmp.dwPhoto = dt:readInt();
		tmp.szName = "";
		
		local tmpName = dt:readString();
		if tmpName then
			tmp.szName = tmpName:getData();
		end
		
		return tmp;
	end
}

local stAwardInfo = {
	initWithStream = function(dt)
		if dt == nil then
			return;
		end
		
		local tmp = {
            __mode = "kv",
        }
		
		tmp.dwGroup = dt:readInt();
		tmp.dwPrestigeMin = dt:readInt();
		tmp.dwPrestigeMax = dt:readInt();
		tmp.usLevelMin = dt:readShort();
		tmp.usLevelMax = dt:readShort();
		tmp.ucCostTimes = dt:readByte();
		tmp.szAward = {}
		for i=1, 5 do
			tmp.szAward[i] = "";
			local tmpAward = dt:readString();
			if tmpAward then
				tmp.szAward[i] = tmpAward:getData();
			end
		end
		
		return tmp;
	end
}

local stChangMapDoor = {
	initWithStream = function(dt)
	    if dt == nil then
	        return;
	    end
	    
		local tmp = {
            __mode = "kv",
        }
        
        tmp.idMap = dt:readInt();
        tmp.usPosX = dt:readShort();
        tmp.usPosY = dt:readShort();
        
        return tmp;
	end
}

----------------常量定义区----------------

local ACT_THROUGH_OPEN			= 0		--//闯关界面打开
local ACT_THROUGH_LAYER 		= 1		--//层信息
local ACT_THROUGH_ENTER 		= 2		--//闯关
local ACT_THROUGH_AWARDVIEW 	= 3		--//查看奖励
local ACT_THROUGH_RESET 		= 4		--//重置
local ACT_THROUGH_SWEEP 		= 5		--//扫荡
local ACT_THROUGH_TOLLGATESHOW  = 6		--//当前闯关数刷新
local ACT_THROUGH_BATTLEAWARD   = 7     --//闯关结算 
local ACT_THROUGH_CHANGEMAP     = 8     --//过关传送 

local MSG_BUY_INSTANCE_TIME     = 2
local BUY_THROUGH_TIMES         = 4     --//购买次数
local BUY_THROUGHRESET_TIMES    = 5     --//重置次数

----------------变量定义区----------------

local m_stLayerInfo = {}
local m_curLayer = nil;
local m_curIndex = nil
local m_curThroughIndex = nil;
local m_barWidth = nil;
local m_changeMapDoor = {}

--变量的定义
----------------UI控制器区----------------
function Through.initControl()
	local pWindow6030 = SCWindow:window()
	if pWindow6030 then
		pWindow6030:setTag(6030)
		pWindow6030:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow6030:setPosition(AUTO_POS(0.00, 0.00))pWindow6030:setContentSize(AUTO_SIZE(480, 320))
		pWindow6030:luaSetSelectorOnClose(Through.releaseControl)
	end

	local pMultiPage2 = SCMultiPage:pageWithType(EnumMultiPageTypeLarge)
	if pMultiPage2 then
		pMultiPage2:setTag(2)
		pMultiPage2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pMultiPage2:setPosition(AUTO_POS(0.00, 0.00))
		pMultiPage2:setContentSize(AUTO_SIZE(480, 320))
		local pageImg = {"new00764.png", "new00759.png", "new00763.png"}
		for i = 1, 3 do
			local pNode = SCNode:node()
			if pNode then
				pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)				   
				pNode:setPosition(ANCHOR_LEFT_BOTTOM)
				pMultiPage2:addPage(pNode)
				local imgPath = getRealUIResourcePath("guoguan/" .. pageImg[i])				   
				if imgPath then
					pMultiPage2:setTitleAtPage(imgPath:getData(), i - 1)
				end
			end
		end
	end

	if pMultiPage2 and pWindow6030 then
		pWindow6030:addChild(tolua.cast(pMultiPage2, "SCNode"))
	end
	return pWindow6030
end
function Through.releaseControl()
	if Through.wndClose then
		Through.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
--重置副本
local function sendResetInfo()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_THROUGH);
	if dataStream then
		dataStream:writeShort(ACT_THROUGH_RESET)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end
end

--购买重置次数
local function sendBuyResetTimes()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE_MENU);
	if dataStream then
		dataStream:writeShort(MSG_BUY_INSTANCE_TIME)
		dataStream:writeByte(BUY_THROUGHRESET_TIMES)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end
end

--购买闯关次数
local function sendBuyEnterTimes()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE_MENU);
	if dataStream then
		dataStream:writeShort(MSG_BUY_INSTANCE_TIME)
		dataStream:writeByte(BUY_THROUGH_TIMES)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end
	g_Through_bBuyTimes = true
end

--开始扫荡
local function sendSweepInfo()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_THROUGH);
	if dataStream then
		dataStream:writeShort(ACT_THROUGH_SWEEP)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end
end

--开始闯关
local function sendEnterInfo(dwIndex)
	if dwIndex == nil then
		return
	end
	
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_THROUGH);
	if dataStream then
		dataStream:writeShort(ACT_THROUGH_ENTER)
		dataStream:writeInt(dwIndex);
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end
	
	if CLIENT_VERSION > 328 then
		--NewBattleMessage:getSingleton():checkIsSmallMemory(60);
	end
end

--查看奖励
local function sendAwardView(dwGroup)
	if dwGroup == nil then
		return;
	end
	
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_THROUGH);
	if dataStream then
		dataStream:writeShort(ACT_THROUGH_AWARDVIEW)
		dataStream:writeInt(dwGroup);
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end	
end

--闯关结算
local function sendBattleAward(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_THROUGH);
	if dataStream then
		dataStream:writeShort(ACT_THROUGH_BATTLEAWARD)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end	
end

--过关传送
function Through_sendChangeMap()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_THROUGH);
	if dataStream then
		dataStream:writeShort(ACT_THROUGH_CHANGEMAP)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end	
end

--打开闯关界面
function Through_sendOpenWndInfo(curLayer)
    if curLayer == nil or curLayer < 0 or curLayer > 6 then
        curLayer = 0
    end
    
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_THROUGH);
	if dataStream then
		dataStream:writeShort(ACT_THROUGH_OPEN)
		dataStream:writeByte(curLayer);
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end
	g_Through_bisOpen = true;
end

--点击预留魂玉背包按钮事件
local function onHunyuBagBtnClick(tag)
    --showMessage(L("str9206"));
    SoulJade_ShowWndSoulJade()
    removeWindowCtrlByTag(6030);
end

--点击增加挑战次数
local function onAddTimesBtnClick(tag)
    sendBuyEnterTimes();
end

--点击刷新按钮
local function onResetBtnClick(tag)
    sendResetInfo()
end

--点击开始挑战
local function onSureEnterThrough(tag)
    if 1 == tag then
        --解散队伍
        local MSG_TEAM_LEAVE				    = 1;	--// 成员离队(包括队长)
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
        dataStream:writeShort(MSG_TEAM_LEAVE);
        SCDataTransThread:getSingleton():transData(dataStream);
        --进入关卡
        sendEnterInfo(m_curThroughIndex)
    end
end
local function onEnterBtnClick(tag)
    if nil == m_curThroughIndex then
        return
    end
    if Hero:getSingleton():iSATeamLeader() or Hero:getSingleton():isATeamMember() then
        luashowConfirmationWindow(L("str6310"), WIN_YES_NO, onSureEnterThrough)
        return
    end
    sendEnterInfo(m_curThroughIndex)
end

--点击开始扫荡
local function onBeginSweepBtnClick(tag)
    sendSweepInfo();
end

--点击层信息
local function onLayerBtnClick(tag)
    local index = tag - 6;
    if index < 0 or index > 5 then
        return;
    end
    
    if m_stLayerInfo[index] ~= nil then
        if m_stLayerInfo[index].dwGroup ~= nil then
            sendAwardView(m_stLayerInfo[index].dwGroup);
        end
    end
end

--显示说明
local function onExplainBtnClick(tag)
    Through2_showThroughTip(L("str9214"));
end

local function creatSingleNode(imgPath)
    local relPath = RES(imgPath)
    if relPath == nil then
        return nil;
    end
    
    local BgPath = RES("img/new00002.png");
    if BgPath == nil then
        return nil
    end
    
    local BgImage = SCImage:imageWithFile(BgPath);
    if BgImage == nil then
        return nil;
    end
    
    local childImage = SCImage:imageWithFile(relPath);
    if childImage == nil then
        return nil;
    end
    
    childImage:setAnchorPoint(CCPointMake(0.5, 0.5));
    childImage:setPosition(CCPointMake(BgImage:getContentSize().width/2, BgImage:getContentSize().height/2));
    BgImage:setAnchorPoint(CCPointMake(0.5, 0.5));
    BgImage:addChild(childImage);
    BgImage:setScale(0.5);
    
    return BgImage;
end

local function creatCurLayerInfo(node)
    if node == nil then
        return
    end
    
    local BgNode = SCFunction:getUiNodeByIdlistAndParent("2-25", tolua.cast(node, "SCNode"))
    if BgNode == nil then
        return
    end
    
    local height = BgNode:getContentSize().height / 2;
    m_barWidth = BgNode:getContentSize().width;
    local imagePath = nil;
    for i=1, 6 do
        if i == 1 then
            imagePath = "item/2000115.jpg";
        elseif i == 2 then
            imagePath = "item/2000116.jpg";
        elseif i == 3 then
            imagePath = "item/2000117.jpg";
        elseif i == 4 then
            imagePath = "item/2000118.jpg";
        elseif i == 5 then
            imagePath = "item/2000119.jpg";
        elseif i == 6 then
            imagePath = "item/2000120.jpg";
        end
        
        local child = BgNode:getChildByTag(i);
        if child == nil then
            child = creatSingleNode(imagePath);
            if child then
                child:setTag(i)
                child:setPosition(CCPointMake(m_barWidth * (i - 1) / 5, height));
                BgNode:addChild(child);
            end
        end
    end
end

local function onActionMoveEnd()
    local multpage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("6030-2"));
    if multpage == nil then 
        return;
    end
    
    local multpageNode = multpage:getPageWithIndex(0);
    if multpageNode == nil then 
        return;
    end
    
    local pageNode1 =  multpageNode:getChildByTag(3);
    if pageNode1 == nil then
        return
    end
    
    local pAniRun = SCLookfaceParser:getSingleton():getAnimationByLookfaceAndIndex(Hero:getSingleton():getLookFace(), dirAction_Stand);
    if pAniRun then
        local actionNode = SCTypeCast:castNodeToAnimationNode(SCFunction:getUiNodeByIdlistAndParent("2-1008-1", pageNode1));
        if actionNode then
            if m_bChangeDir ~= nil and m_bChangeDir == false then
                pAniRun:setTransMirror(true);
            end
            actionNode:setAnimation(pAniRun);
        end
    end
end

local function onLeftBtnClick(tag)
    if m_curLayer == nil then
        return
    end
    
    local index = m_curLayer -1;
    if index > 0 then
        Through_sendOpenWndInfo(index);
    end
end

local function onRightBtnClick(tag)
   local index = m_curLayer + 1;
    if index > 0 and index <= 6 then
        if index > 0 and index <= 3 then
            Through_sendOpenWndInfo(index);
        else
            showMessage(L("str9235"));
        end
    end
end

local function  createEnterBgNdoe(layer)
    if layer == nil then
        return
    end
    
    local multpage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("6030-2"));
    if multpage == nil then 
        return;
    end
    
    local multpageNode = multpage:getPageWithIndex(0);
    if multpageNode == nil then 
        return;
    end
 
    local pageNode1 = multpageNode:getChildByTag(3);
    if pageNode1 == nil then
        return
     end
     
    local BgNode = SCFunction:getUiNodeByIdlistAndParent("2-25", tolua.cast(pageNode1, "SCNode"))
    if BgNode == nil then
        return
    end
    
    local child = nil;
    local dragNode = nil;
    for i=1, 6 do
        child = BgNode:getChildByTag(i);
        if child then
            dragNode = child:getChildByTag(1000 + i);
            if dragNode == nil then
                dragNode = SCDragNode:node();
                if dragNode then
                    dragNode:setTag(1000 + i);
                    dragNode:setContentSize(child:getContentSize());
                    dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                    dragNode:setPosition(CCPointMake(child:getContentSize().width/2, child:getContentSize().height/2));
                    dragNode:setBackgroundColor(getColorBlackTransparent());
                    child:addChild(dragNode);
                end
            end
        end
        
        if dragNode ~= nil and i <= layer then
            dragNode:setVisible(false);
        end
    end
end

local function refreshThroughWnd(info)
    if info == nil then
        return
    end
    
    m_curThroughIndex = info.dwThroughIndex;
    
    local window = nil;
    local wndCtrl = getCurentSceneWindowController(6030);
	if wndCtrl then
	    window = wndCtrl:getWindow();
	end
	
	if window == nil then
	    return
	end
    
    local multpage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("6030-2"));
    if multpage == nil then 
        return;
    end
    
    local multpageNode = multpage:getPageWithIndex(0);
    if multpageNode == nil then 
        return;
    end
    
    local pageNode1 = multpageNode:getChildByTag(3);
    if pageNode1 == nil then
        pageNode1 = Through1.initControl();
        if pageNode1 then
            pageNode1:setTag(3);
            pageNode1:setAnchorPoint(CCPointMake(0.5, 0));
            pageNode1:setPosition(CCPointMake(window:getContentSize().width / 2, SY(5)));
            multpageNode:addChild(pageNode1);
            creatCurLayerInfo(pageNode1);
        end
    end
    
    if pageNode1 == nil then
        return;
    end
    
    local leftBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-3-66", pageNode1));
    local rightBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-3-67", pageNode1));
    if leftBtn and rightBtn then
        leftBtn:luaSetSelectorOnClicked(onLeftBtnClick);
        rightBtn:luaSetSelectorOnClicked(onRightBtnClick);
    end
    
    local nameBg = SCFunction:getUiNodeByIdlistAndParent("5-12", pageNode1);
    if nameBg then        
        local nameLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("5-12-21", pageNode1));
        if nameLabel then
            nameLabel:setText(info.szName);
            nameLabel:setColor(colorGreen());
        end 
    end
    
    local bossBg = SCFunction:getUiNodeByIdlistAndParent("5-13", pageNode1);
    if bossBg then
        local bossLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("5-13-22", pageNode1));
        if bossLabel then
            bossLabel:setText(L("str9233")..info.szBoss);
            bossLabel:setColor(colorGreen());  
        end
     end
    
    local awardBg = SCFunction:getUiNodeByIdlistAndParent("5-14", pageNode1);
    if awardBg then
        local awardStr = L("str9228")..info.usCostTiredness..L("_");
        awardStr = awardStr..L("str9229")..info.szNeedPrestige..L("_");
        awardStr = awardStr..L("str9207")..info.szAward
        local awardText = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlistAndParent("5-14-20", pageNode1));
        if awardText then
            awardText:setText(awardStr)
        end
    end
    
    local leftBg = SCFunction:getUiNodeByIdlistAndParent("5-19", pageNode1);
    if leftBg then
        local leftLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("5-19-24", pageNode1));
        if leftLabel then
            leftLabel:setText(""..info.usLeaveEnterTimes);
        end
    end
    
    local addTimesBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("5-18", pageNode1));
    if addTimesBtn then
        addTimesBtn:luaSetSelectorOnClicked(onAddTimesBtnClick);
    end
    
    local hunyuBagBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("5-16", pageNode1));
    if hunyuBagBtn then
        hunyuBagBtn:luaSetSelectorOnClicked(onHunyuBagBtnClick);
    end
    
    local enterBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("5-17", pageNode1));
    if enterBtn then
        enterBtn:luaSetSelectorOnClicked(onEnterBtnClick);
    end
    
    local explainBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-4", pageNode1));
    if explainBtn then
        explainBtn:luaSetSelectorOnClicked(onExplainBtnClick);
    end
    
    local proBar = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("2-25-26", pageNode1));
    local imagePath = RES("img/new00646.png");
    if proBar and imagePath and m_barWidth and m_curLayer then
        local width = m_barWidth * (m_curLayer - 1) / 5;
        if m_curLayer <= 1 then
            width = 1;
        elseif m_curLayer > 5 then
            width = m_barWidth - SX(3);
        end
        local partentNode = SCFunction:getUiNodeByIdlistAndParent("2-25", pageNode1)
        if partentNode then
			proBar:setAnchorPoint(CCPointMake(0, 0.5));
			proBar:setPosition(CCPointMake(proBar:getPosition().x, partentNode:getContentSize().height/2))
			proBar:setImage(imagePath, CCRectMake(0, 0, width, partentNode:getContentSize().height));
        end
    end
    
    local contentSize = nil;
    --layerIndex = math.floor(info.dwPreThroughIndex / 10);
    local layerIndex = math.mod(info.dwPreThroughIndex, 10);
    if layerIndex <= 0 or layerIndex > 5 then
        return
    end
    local layerBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-"..(6 + layerIndex), pageNode1));
    if layerBtn == nil then
        return
    end
    
    contentSize = layerBtn:getContentSize();
    local roleBg = SCFunction:getUiNodeByIdlistAndParent("2", pageNode1);
    if roleBg == nil then
        return
    end
    
    if layerIndex == 1 or layerIndex == 3 or layerIndex == 5 then
        isRightX = layerBtn:getPosition().x + 0.5 * contentSize.width;
        m_bChangeDir = true;
    else
        isRightX = layerBtn:getPosition().x - contentSize.width / 2;
        m_bChangeDir = false;
    end
    
    local actionNode = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("2-1008", pageNode1) , "ActionNode");
    if actionNode == nil then
        local actionNode = ActionNode:newActionNode();
        if actionNode and contentSize then 
            local ani = SCLookfaceParser:getSingleton():getAnimationByLookfaceAndIndex(Hero:getSingleton():getLookFace(), dirAction_Stand);
            if ani then
                local roleNode = SCAnimationNode:nodeWithAnimation(ani);
                if roleNode then
                    roleNode:setTag(1)
                    roleNode:setScale(0.5)
                    actionNode:addChild(roleNode)
                    actionNode:setTag(1008);
                    actionNode:setContentSize(contentSize)
                    actionNode:setPosition(CCPointMake(isRightX, layerBtn:getPosition().y));
                    actionNode:luaSetSelectorOnMoveEnd(onActionMoveEnd);
                    roleBg:addChild(actionNode);
                end
            end
        end
    else
        if layerBtn:getPosition().y ~= actionNode:getPosition().y then
            local aniNode = SCTypeCast:castNodeToAnimationNode(actionNode:getChildByTag(1));
            if aniNode then
                local pAniRun = SCLookfaceParser:getSingleton():getAnimationByLookfaceAndIndex(Hero:getSingleton():getLookFace(), dirAction_Move);
                if pAniRun then
                    if m_bChangeDir == true then
                        pAniRun:setTransMirror(true);
                    end
                    aniNode:setAnimation(pAniRun);
                    actionNode:moveTo(CCPointMake(isRightX, layerBtn:getPosition().y), 0.5);
                end
            end
        end
    end
end

local function onPageSelected(tag, index)
    local multpage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("6030-2"));
    if multpage == nil then 
        return;
    end
    
    if index == 1 or index == 2 then
        showMessage(L("str9206"));
        multpage:selectPageWithIndex(0);
    end
end

local function showThroughWnd(info)
    if g_Through_bisOpen == false then
        return;
    end
	local wndCtrl = getCurentSceneWindowController(6030);
	if wndCtrl then
	    refreshThroughWnd(info);
		return;
	end
	
	local wnd = Through.initControl();
	if wnd then
		wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl = getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            local multpage = SCTypeCast:castNodeToMultiPage(wnd:getChildByTag(2));
            if multpage then
                multpage:luaSetSelectorOnPageSelected(onPageSelected);
            end
            
            naviCtrl:pushWindowController(wndCtrl);
            refreshThroughWnd(info);
        end
	end
end

local function recvLayerInfo(dt)
    if dt == nil then
        return
    end
    m_curIndex =  dt:readInt();			--//当前挑战到的最高关卡
    --dt:readByte()
    --dt:readByte()
    m_curLayer = dt:readByte();
    local count = dt:readByte();
    for i=1, count do
        table.insert(m_stLayerInfo, i, stGroupInfo.initWithStream(dt));
    end
    
    local multpage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("6030-2"));
    if multpage == nil then 
        return;
    end
    
    local multpageNode = multpage:getPageWithIndex(0);
    if multpageNode == nil then 
        return;
    end
    
    local pageNode1 =  multpageNode:getChildByTag(3);
    if pageNode1 == nil then
        pageNode1 = Through1.initControl();
        if pageNode1 then
            pageNode1:setTag(3);
            pageNode1:setAnchorPoint(CCPointMake(0.5, 0));
            pageNode1:setPosition(CCPointMake(multpageNode:getContentSize().width / 2, SY(5)));
            multpageNode:addChild(pageNode1);
            creatCurLayerInfo(pageNode1);
        end
    end
    
    if pageNode1 == nil then
        return;
    end
    
    createEnterBgNdoe(m_curLayer);
    
    local proBar = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("2-25-26", pageNode1));
    local imagePath = RES("img/new00646.png");
    if proBar and imagePath and m_barWidth and m_curLayer then
        local width = m_barWidth * (m_curLayer - 1) / 5;
        if m_curLayer <= 1 then
            width = 1;
        elseif m_curLayer > 5 then
            width = m_barWidth - SX(3);
        end
        local partentNode = SCFunction:getUiNodeByIdlistAndParent("2-25", pageNode1)
        if partentNode then
			proBar:setAnchorPoint(CCPointMake(0, 0.5));
			proBar:setPosition(CCPointMake(proBar:getPosition().x, partentNode:getContentSize().height/2))
			proBar:setImage(imagePath, CCRectMake(0, 0, width, partentNode:getContentSize().height));
        end
    end
    local maxLayer = math.modf(m_curIndex/10)
    for i=1, 5 do
        local layerBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-"..(i+6), pageNode1));
        if layerBtn then
            layerBtn:luaSetSelectorOnClicked(onLayerBtnClick);
            if m_stLayerInfo[i] ~= nil then
                if m_stLayerInfo[i].dwPhoto ~= nil and m_stLayerInfo[i].dwPhoto ~= 0 then
                    local path = RES("guoguan/"..m_stLayerInfo[i].dwPhoto..".pn")
                    if path then
                        layerBtn:setBackgroundImage(path:getData());
                    end
                end
            end
            local img = tolua.cast(layerBtn:getChildByTag(12000), "SCImage")
            if img then
                local index = i + 5 * (m_curLayer - 1);
                local maxIndex = (math.floor(m_curIndex/10) - 1) * 5 + m_curIndex%10 + 1;
                if m_curIndex == 0 then
                    maxIndex = 1;
                end
                if index <= maxIndex or maxLayer > m_curLayer then
                    img:setVisible(false)
                else
                    img:setVisible(true)
                end
            end
        end
    end
end

local function createChangeMapDoor()
    if #m_changeMapDoor == 0 then
        return
    end
    
    local ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1051, 1051);
    local layer = getMapLayer();
    if ani and layer then
        layer:addElement(ani);
        local pos = CCPointMake(getCellSize().width * m_changeMapDoor[1].usPosX, getCellSize().height * m_changeMapDoor[1].usPosY)
        ani:setPosition(pos)
        local manager = layer:getNewBattleManager();
        if manager then
            manager:setChangeMapDoorPos(pos)
        end
    end
end

local function recvAwardViewInfo(dt)
    local tmpAward = stAwardInfo.initWithStream(dt);
    local strTmp = "*3"..L("str9210")..tmpAward.ucCostTimes..L("str0015")
    for i=1, 5 do
        if tmpAward.szAward[i] ~= nil then
            strTmp = strTmp.."_"..string.format(L("str9211"),i).."_"..tmpAward.szAward[i];
        end
    end
    
    strTmp = strTmp.."_*3"..L("str9212")..tmpAward.dwPrestigeMin;
    strTmp = strTmp.."_*3"..L("str9213")..tmpAward.usLevelMin;
    
    Through2_showThroughTip(strTmp);
end

local function recvThroughInfo()
	SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if dt == nil then
        return;
    end
	
	local action = dt:readShort();
    if action == ACT_THROUGH_OPEN or action == ACT_THROUGH_AWARDVIEW then
        local trough = stThroughInfo.initWithStream(dt);
        if trough then
            showThroughWnd(trough);
        end
    elseif action == ACT_THROUGH_LAYER then
        recvLayerInfo(dt);
    elseif action == ACT_THROUGH_TOLLGATESHOW then
        local dwTollGate = dt:readInt();
        SoulJade_setSoulJadeLevel(dwTollGate);
    elseif action == ACT_THROUGH_BATTLEAWARD then
        local ucWin = dt:readByte();
        local szAwardBuf = dt:readString();
        if szAwardBuf then
            luaShowBattleMessage(szAwardBuf:getData(), WIN_YES, sendBattleAward);
        end
    elseif action == ACT_THROUGH_CHANGEMAP then
        table.insert(m_changeMapDoor, stChangMapDoor.initWithStream(dt));
        createChangeMapDoor();
    end
end

function Through.wndClose()
    m_stLayerInfo = {}
    m_curLayer = nil;
    m_curIndex = nil
    m_curThroughIndex = nil;
    m_barWidth = nil;
    g_Through_bBuyTimes = false
    g_Through_bisOpen = false
    m_bChangeDir = nil;
    if Through1.releaseControl then
        Through1.releaseControl();
    end
end

----------------消息处理区----------------

----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(recvThroughInfo, _MSG_THROUGH, 0, nil)
----------------全局函数区----------------



--函数调用