--定义一个与文件名相同的table
TreasureHunt3 = {}
------------------消息--------------------
local ITEMACT_CHIBI_TIDYUP_SUCCESS = 198		--赤壁寻宝物品整理完成
local ITEMACT_CHIBI_GET_ITEM = 199				--赤壁寻宝提取物品
local ITEMACT_CHIBI_ONEKEY_GET_ITEM = 200	 	--赤壁寻宝一键提取物品

local ITEMSHOW_ADDITEM = 1						--添加物品
local ITEMSHOW_CHIBI_DROP = 19					--丢弃物品
local ITEMSHOW_CHIBI_TIDY = 20 					--物品整理
local ITEMSHOW_CLEAR_CHIBI = 21					--清空寻宝仓库

local BAG_SIZE = 32								--背包大小
local HUNT_BAG_PLACE_BEGIN = 700				--背包起始位
local HUNT_BAG_PLACE_END = 731					--背包结束位
local HUNT_INDEX_CHG = 699						--place转node索引差值

--------------------变量定义--------------
local m_curClick = nil
local m_treasureHuntBagInfo = {}

----------------结构定义区----------------
local stItemInfo = {								--物品信息
    initWithStream = function (dt)
        if not dt then return nil end
        local tmp = {
            __mode = "kv" 
        }
        
		tmp.id = dt:readInt()						--物品ID
		if tmp.id == 0 then return nil end
		
		tmp.idType = dt:readInt()					--物品类型id
		tmp.idKeeper = dt:readInt()    				--所有者
		tmp.usAmount = dt:readShort()				--个数
		tmp.ucPosition = dt:readByte()				--对应字段是 ITEM_POS
		tmp.usPlace = dt:readShort()				--物品在存储处的位置id
		tmp.nBinding = dt:readInt()					--绑定
		tmp.usUpLev = dt:readShort()				--强化等级
		
		tmp.ucGemAmount = dt:readByte()				--宝石个数
		tmp.stGemInfo = {}
		for i = 1, tmp.ucGemAmount do
			local tmpdate = {}
			tmpdate.ucPos = dt:readByte()			--宝石位置
			tmpdate.idType = dt:readInt()			--宝石类型
			table.insert(tmp.stGemInfo, tmpdate)
		end
		
		tmp.dwMarkGroup = dt:readInt()				--刻印等级
		tmp.dwMarkExp = dt:readInt()				--刻印经验
		tmp.dwData1 = dt:readInt()					--武魂当前经验
		tmp.dwData2 = dt:readInt()					--武魂当前等级	
		
		tmp.ucAttrAmount = dt:readByte()			--附加属性个数
		tmp.stAttrInfo = {}
		for i = 1, tmp.ucAttrAmount do
			local tmpdate = {}
			tmpdate.nAttrType = dt:readInt()		--属性类型
			tmpdate.nAttrData = dt:readInt()		--属性值
			table.insert(tmp.stAttrInfo, tmpdate)
		end

        return tmp
    end
}


----------------常量定义区----------------
local HUNT_GRID_BEGINPLACE		= 700		--寻宝背包起始位
local HUNT_GRID_ENDPLACE		= 732		--寻宝背包结束位	

----------------函数回调------------------
---点击提取按钮---
function TreasureHunt3.onClickGetItemBtn()
	if not m_curClick then return end
	local id = m_curClick					--超级武魂、真武魂礼包特殊处理
	if id and (id == 3461000261 or id == 3461000262) and not luaIsUnlock(UNLOCK_TYPE_TYPE4) then
		showMessage(L("str30143"))
		return
	end

	local dt = SCDataTransStream:streamWithCommand(_MSG_ITEM)
    dt:writeShort(ITEMACT_CHIBI_GET_ITEM)
    dt:writeInt(m_curClick)
    
    SCDataTransThread:getSingleton():transData(dt)
    SCActivityIndicator:getSingleton():show()
    
    m_curClick = nil
end

---点击武魂背包节点---
function TreasureHunt3.onClikcHuntBagNode(tag)
	local itemtypeInfo = nil
	for i = 1, #m_treasureHuntBagInfo do
		if m_treasureHuntBagInfo[i] and m_treasureHuntBagInfo[i].itemInfo and 
			m_treasureHuntBagInfo[i].itemInfo.usPlace - HUNT_INDEX_CHG == tag then
			m_curClick = m_treasureHuntBagInfo[i].itemInfo.id
			itemtypeInfo = m_treasureHuntBagInfo[i].itemtypeInfo
		end
	end
	
	if not itemtypeInfo then return end
	
	local str = ""
	if itemtypeInfo.effect_type_1 ~= 0 then
		str = str.."*5"..TreasureHunt3.getAttrNameByIndex(math.modf(itemtypeInfo.effect_type_1 / 10)).." +"..itemtypeInfo.effect_param_1
	end
	if itemtypeInfo.effect_type_2 ~= 0 then
		str = str.."*5"..TreasureHunt3.getAttrNameByIndex(math.modf(itemtypeInfo.effect_type_2 / 10)).." +"..itemtypeInfo.effect_param_2
	end
	if itemtypeInfo.effect_type_3 ~= 0 then
		str = str.."*5"..TreasureHunt3.getAttrNameByIndex(math.modf(itemtypeInfo.effect_type_3 / 10)).." +"..itemtypeInfo.effect_param_3
	end
	
	str = str.."_*0"..itemtypeInfo.description:getData()
	str = str.."_ _"..L("str8121")..math.modf(itemtypeInfo.price/4)
	
	local title = getColorString(itemtypeInfo.id)
	if title == "*0" then
	    title = "*4"
	end
	title = title..itemtypeInfo.name:getData()
	
	local file = getRealUIResourcePath("item/"..itemtypeInfo.icon..".jpg")

	local pWnd = showTipEx(L("str30139"), str, title, itemtypeInfo.icon, itemInfo.id)            
    if pWnd then
        local pWnd = tolua.cast(pWnd, "TipWindow")
        pWnd:luaSetReturnSelector(TreasureHunt3.onClickGetItemBtn)
    end
end

---点击全部提取按钮---
function TreasureHunt3.onClikcGetAllItem(tag)
	local dt = SCDataTransStream:streamWithCommand(_MSG_ITEM)
    dt:writeShort(ITEMACT_CHIBI_ONEKEY_GET_ITEM)
    
    SCDataTransThread:getSingleton():transData(dt)
    SCActivityIndicator:getSingleton():show()
end

---点击整理背包---
function TreasureHunt3.onClikcCleanUp(tag)
	local dt = SCDataTransStream:streamWithCommand(_MSG_ITEM)
    dt:writeShort(ITEMACT_CHIBI_TIDYUP_SUCCESS)
    
    SCDataTransThread:getSingleton():transData(dt)
    SCActivityIndicator:getSingleton():show()
end

----------------UI控制器区----------------
function TreasureHunt3.initControl()
	local pWindow1 = SCWindow:window()
	if pWindow1 then
		pWindow1:setTag(11005)
		pWindow1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow1:setPosition(AUTO_POS(0.00, 0.00))
		pWindow1:setContentSize(AUTO_SIZE(480, 290))
		pWindow1:luaSetSelectorOnClose(TreasureHunt3.releaseControl)
	end

	local pDragNode2 = SCDragNode:node()
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode2:setPosition(AUTO_POS(0.00, 0.00))
		pDragNode2:setContentSize(AUTO_SIZE(480, 290))
		pDragNode2:setFrameVisibled(true)
		pDragNode2:setDragEnabled(false)
		pDragNode2:setFrameType(EnumFrameTyperedwindowstip)
	end

	local pDragNode3 = SCDragNode:node()
	if pDragNode3 then
		pDragNode3:setTag(3)
		pDragNode3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode3:setPosition(AUTO_POS(5.00, 36.00))
		pDragNode3:setContentSize(AUTO_SIZE(466, 217))
		pDragNode3:setFrameVisibled(true)
		pDragNode3:setDragEnabled(false)
		pDragNode3:setFrameType(EnumFrameTypeLine)
	end
	
	--循环创建背包节点
	local posY = 200
	for i = 1, 32 do
		if i % 8 == 1 then
			posY = posY - 46
		end
		
		local pButton = SCButton:button(EnumBtnTypeNormalImg)
		if pButton then
			pButton:setTag(i)
			pButton:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pButton:setPosition(AUTO_POS(28 + ((i - 1) % 8) * 51, posY))
			pButton:setContentSize(AUTO_SIZE(46, 46))
			local pBackimg = getRealUIResourcePath("img/new00002.png")
			if pBackimg then
				pButton:setBackgroundImage(pBackimg:getData())
			end
			
			if pDragNode3 then
				pDragNode3:addChild(tolua.cast(pButton, "SCNode"))
			end
		end
	end
	
	--全部提取
	local pButton15 = SCButton:button(EnumBtnType9Atlas)
	if pButton15 then
		pButton15:setTag(15)
		pButton15:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton15:setPosition(AUTO_POS(70.00, 5.00))
		pButton15:setContentSize(AUTO_SIZE(77, 34))
		pButton15:setTitle(L("str30131"), DEFAULT_FONT_NAME, F(15))
	end
	
	--整理仓库
	local pButton16 = SCButton:button(EnumBtnType9Atlas)
	if pButton16 then
		pButton16:setTag(16)
		pButton16:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton16:setPosition(AUTO_POS(299.00, 6.00))
		pButton16:setContentSize(AUTO_SIZE(77, 34))
		pButton16:setTitle(L("str30132"), DEFAULT_FONT_NAME, F(15))
	end
	
	--背包道具数量
	local pLabe17 = SCLabel:labelWithStringFont(L("str30141").." 0 / 0", DEFAULT_FONT_NAME, F(14))		--道具数量
	if pLabe17 then
		pLabe17:setTag(17)
		pLabe17:setAnchorPoint(CCPointMake(0, 0.0))
		pLabe17:setPosition(AUTO_POS(315.00, 251.00))
		pLabe17:setColor(ccc4(255,255,255,255))
	end

	if pDragNode2 and pWindow1 then
		pWindow1:addChild(tolua.cast(pDragNode2, "SCNode"))
	end
	if pDragNode3 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pDragNode3, "SCNode"))
	end
	if pButton15 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton15, "SCNode"))
	end
	if pButton16 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton16, "SCNode"))
	end
	if pLabe17 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLabe17, "SCNode"))
	end
	
	return pWindow1
end

function TreasureHunt3.init()
	local pWnd = getCurentSceneWindow(11005)
	if not pWnd then return end
	
	for i = 1, 32 do
		pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-3-"..i, pWnd))
		if pBtn then 
			pBtn:luaSetSelectorOnClicked(TreasureHunt3.onClikcHuntBagNode)
		end
	end
	
	pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-15", pWnd))
	if pBtn then
		pBtn:luaSetSelectorOnClicked(TreasureHunt3.onClikcGetAllItem)
	end
	
	pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-16", pWnd))
	if pBtn then
		pBtn:luaSetSelectorOnClicked(TreasureHunt3.onClikcCleanUp)
	end
	
	TreasureHunt3.showBag()
	TreasureHunt3.setBagItemNum()
end

---设置背包道具数量---
function TreasureHunt3.setBagItemNum()
	local pWnd = getCurentSceneWindow(11005)
	if not pWnd then return end
	
	pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-17", pWnd))
	if pLabel then
		pLabel:setText(L("str30141").." "..TreasureHunt3.getBagItemNum().." / 32")
		pLabel:setColor(color_orange)
	end
end

---窗口释放---
function TreasureHunt3.releaseControl()
	m_curClick = nil
end

---显示背包内容---
function TreasureHunt3.showBag()
	local pWnd = getCurentSceneWindow(11005)
	if not pWnd then return end
	
	--清理背包
	TreasureHunt3.clearBag()
	
	--显示背包
	for i = 1, #m_treasureHuntBagInfo do
		if m_treasureHuntBagInfo[i] and m_treasureHuntBagInfo[i].itemInfo and m_treasureHuntBagInfo[i].itemtypeInfo then
			local index = m_treasureHuntBagInfo[i].itemInfo.usPlace - HUNT_INDEX_CHG
			
			--根据place获取格子
			local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-3-"..index, pWnd))			
			if pBtn then
				pBtn:removeAllChildrenWithCleanup(true)
				--道具图片
				local img = getRealUIResourcePath("item/"..m_treasureHuntBagInfo[i].itemtypeInfo.icon..".jpg")				
				if img then
					pBtn:setTitle(img:getData())
				end
				
				--道具数量
				local pLable1 = SCLabel:labelWithStringFont(m_treasureHuntBagInfo[i].itemInfo.usAmount, DEFAULT_FONT_NAME, F(12)) 	
				if pLable1 then
					pLable1:setAnchorPoint(ANCHOR_RIGHT_BOTTOM)
					pLable1:setPosition(AUTO_POS(40.00, 4.00))
					pBtn:addChild(pLable1)
				end
			end
		end
	end
end

---清空背包---
function TreasureHunt3.clearBag()
	local pWnd = getCurentSceneWindow(11005)
	if not pWnd then return end			
			
	for i = 1, BAG_SIZE do
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-3-"..i, pWnd))
		if pBtn then
			pBtn:removeAllChildrenWithCleanup(true)
			local img = getRealUIResourcePath("img/new00002.png")
			if img then
				pBtn:setTitle(img:getData())
			end
		end
	end
end

----------------逻辑处理区----------------
---获取属性名---
function TreasureHunt3.getAttrNameByIndex(index)
	local strName = "";
	if index == 201 then --力量
		strName = L("str8127")
	elseif index == 202 then --灵力
		strName = L("str8128")
	elseif index == 411 then --物理攻击
		strName = L("str5074")
	elseif index == 421 then --物理防御
		strName = L("str5075")
	elseif index == 455 then --HP上限
		strName = L("str8129")
	elseif index == 456 then --MP上限
		strName = L("str8130")
	elseif index == 457 then --特技攻击
		strName = L("str9175")
	elseif index == 457 then --特技防御
		strName = L("str9178")
	elseif index == 492 then --暴击率
		strName = L("str8131")
	elseif index == 496 then --免暴率
		strName = L("str0405")
	elseif index == 497 then --必杀率
		strName = L("str0406")
	elseif index == 481 then 
		strName = L("str0403") --格挡率
	elseif index == 498 then 
		strName = L("str0402") --破击
	end

	return strName;
end

---添加物品---
function TreasureHunt3.addItem(itemInfo, itemtypeInfo)
	--不重复添加道具
	local isFind = false							
	for i = 1, #m_treasureHuntBagInfo do			
		if m_treasureHuntBagInfo[i] and m_treasureHuntBagInfo[i].itemInfo then
			if m_treasureHuntBagInfo[i].itemInfo.id == itemInfo.id then
				m_treasureHuntBagInfo[i].itemInfo.usAmount = itemInfo.usAmount
				isFind = true
				break
			end
		end
	end
	
	if not isFind then
		table.insert(m_treasureHuntBagInfo, {["itemInfo"] = itemInfo, ["itemtypeInfo"] = itemtypeInfo})
	end
end

---删除物品---
function TreasureHunt3.delItem(nId)
	for i = 1, #m_treasureHuntBagInfo do			
		if m_treasureHuntBagInfo[i] and m_treasureHuntBagInfo[i].itemInfo then
			if m_treasureHuntBagInfo[i].itemInfo.id == nId then
				table.remove(m_treasureHuntBagInfo, i)
				break
			end
		end
	end
end

---整理物品---
function TreasureHunt3.tidyItem(nIDItem, usPlace)
	local isFind = false							--是否物品记录在背包中
	local pos = nil
	for i = 1, #m_treasureHuntBagInfo do			
		if m_treasureHuntBagInfo[i] and m_treasureHuntBagInfo[i].itemInfo then
			if m_treasureHuntBagInfo[i].itemInfo.id == nIDItem then
				if m_treasureHuntBagInfo[i].itemInfo.usPlace == usPlace then return end
				isFind = true
				pos = i
				break
			end
		end
	end
	
	if not isFind then return end
	m_treasureHuntBagInfo[pos].itemInfo.usPlace = usPlace
end

----------------消息处理区----------------
---赤壁仓库数据接收---
function TreasureHunt3.recvHuntBagInfo()
	SCActivityIndicator:getSingleton():close()
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if not dt then return end
    local action = dt:readShort()
    if action == ITEMSHOW_ADDITEM then						--添加物品
		local ucAmount = dt:readByte()
		for i = 1, ucAmount do
			local itemInfo = stItemInfo.initWithStream(dt)	--获取物品
			if itemInfo then
				itemtypeInfo = TableParser:getSingleton():getItemInfoByKey(itemInfo.idType)
				TreasureHunt3.addItem(itemInfo, itemtypeInfo)	
			end
		end
	elseif action == ITEMSHOW_CHIBI_DROP then				--删除物品
		local nId = dt:readInt()
		TreasureHunt3.delItem(nId)
	elseif action == ITEMSHOW_CHIBI_TIDY then				--整理物品
		local nIDItem = dt:readInt()
		local usPlace = dt:readShort()
		TreasureHunt3.tidyItem(nIDItem, usPlace)
	elseif action == ITEMACT_CHIBI_TIDYUP_SUCCESS then		--背包整理成功
		TreasureHunt3.setBagItemNum()
		TreasureHunt3.showBag()
	elseif action == ITEMSHOW_CLEAR_CHIBI then				--清空背包信息
		m_treasureHuntBagInfo = {}
	elseif action == ITEMACT_CHIBI_GET_ITEM then			--提取完成
		
    end
end

----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(TreasureHunt3.recvHuntBagInfo, _MSG_CHIBI_ITEMINFO, 0, nil)

----------------全局函数区----------------
function TreasureHunt3.showTreasureHuntWnd()
    local wnd =  TreasureHunt3.initControl()
    if wnd then
        local wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
            TreasureHunt3.init()
            return
        end
    end
end

---获取背包道具数量---
function TreasureHunt3.getBagItemNum()
	return #m_treasureHuntBagInfo
end

---背包整理完成---
function TreasureHunt3BagCleanUpCom()
	TreasureHunt3.setBagItemNum()
	TreasureHunt3.showBag()
end

---背包提取完成---
function TreasureHunt3ItemGetCom()
	TreasureHunt3.setBagItemNum()
	TreasureHunt3.showBag()
	TreasureHunt1.setRechargeInfo()
	TreasureHunt2.seExchangeShopRoleInfo()
end

---清除数据---
function TreasureHunt3.clearDate()
	--m_treasureHuntBagInfo = {}
end
