
local VanFood = {}   --押送军粮　主界面
local Escort  = {}   --选择护送军粮类型UI
local RobFood = {}  --拦截单人小UI
local RobList = {}  --拦截列表
-----------------------结构定义区------------------------
local struEnemyUserInfo = {}
struEnemyUserInfo.initStream = function(dt)
    local tmp = {}
    if not dt then return tmp end 
    
    tmp.idPlayer = dt:readInt()
    tmp.szName = dt:readString()
    if not tmp.szName then
        tmp.szName = ""
    else
        tmp.szName = tmp.szName:getData()
    end
    tmp.nPlayerLev = dt:readInt()
    tmp.szTribe = dt:readString()
    if tmp.szTribe then
        tmp.szTribe = tmp.szTribe:getData()
    else
        tmp.szTribe = ""
    end
    tmp.nEnemyMoney = dt:readInt()--改为战功
    tmp.nEnemyReputation = dt:readInt()
    tmp.nEnemyTime = dt:readInt()
    tmp.ucClan = dt:readByte()
    return tmp
end

local EscortUserInfo = {
    initStream = function(dt)
        local tmp = {}
        if not tmp then return tmp end 
        
        tmp.idPlayer = dt:readInt()
        tmp.szName = dt:readString()
        if tmp.szName then
            tmp.szName = tmp.szName:getData()
        else
            tmp.szName = ""
        end
        tmp.nUserLev = dt:readInt()
        tmp.usEscortType = dt:readShort()        
        tmp.nSupLootTimes = dt:readInt()
        tmp.nSupTime = dt:readInt()
        tmp.nEnemyMoney = dt:readInt()--改为战功
        tmp.nEnemyReputation = dt:readInt()
        return tmp
    end    
}

local stEscortEnvoyInfo = {
    initStream = function(dt)
        local tmp = {}
        if not dt then return tmp end 
        
        tmp.usEscortType = dt:readShort()
        tmp.nNeedTimes = dt:readInt()
        tmp.nAwardReputation = dt:readInt()
        --tmp.nCurrency1 = dt:readInt()--
        tmp.nMoneyBase = dt:readInt()
        tmp.nCoefficient = dt:readInt()
        tmp.idAwardItemtype = dt:readInt()
        return tmp
    end
}
-----------------------常量定义区------------------------
local ESCORT_ESCORT_INFO			= 1--,	//押镖信息 
local ESCORT_ESCORT_USERCUR_INFO    = 2--,    //玩家当前的押镖信息 
local ESCORT_ESCORT_OPENINFO      = 3--,    //打开护送界面 
local ESCORT_ESCORT_INFO_ALL      = 4--,    //全部 
local ESCORT_ESCORT_INFO_ALL_END  = 5--,    //下发结束
local ESCORT_ESCORT_INFO_ADD      = 6 --,    //添加 
local ESCORT_ESCORT_INFO_DEL      = 7--,    //删除
local ESCORT_ESCORT_INFO_UPDATE   = 8--,    //更新 
local ESCORT_ESCORT_INFO_CLEAR    = 9--,    //活动结束清除所有数据
local ESCORT_ESCORT_INFO_REFRESH    = 10--,   //刷新押镖信息 
local ESCORT_ESCORT_REFRESH_MAX     = 11--,   //刷新最后一个押镖信息
local ESCORT_ESCORT_START         = 12 --,   //开始押送
local ESCORT_ESCORT_SPEED_UP      = 13--,   //加速 
local ESCORT_ESCORT_LOOT          = 14--,   //抢夺 
local ESCORT_ESCORT_RETACK        = 15--,   //夺回
local ESCORT_ESCORT_LOOT_SPEED_UP = 16--,   //抢夺CD清除
local ESCORT_ESCORT_CLOSE         = 17--,   //关闭窗口
local ESCORT_ESCORT_LOOTED_MESG   = 18--,   //被抢夺提示 
-----------------------变量定义区------------------------
local m_nCurEnemyIndex
local m_bRobTime
local m_bVanTime    
local m_bHideFood
local m_initOpened
local m_nLootCD
local m_idTimerPlayer
local m_idTimerEnemy
local m_nTimeCount
local m_nTimeEnemy
local m_nReturnType
local m_bFirstOpenMainWnd
local m_bRobTimeUpdate
local m_bOpenWithMail

local m_nSupEscortTimes
local m_nSupLootTimes
local m_stEnemyList = {}    --仇人
local m_stPlayerList = {}   --玩家
local m_stEscortList = {}   --押镖
local m_ptPlayerPos = {}

local m_bStreamEnd
local m_ptPos = {--60 130 78 140
    ll = CCPointMake(SX(70), SY(30)), lt = CCPointMake(SX(130) + SX(19), SY(30)), lb = CCPointMake(SX(200) + SX(10), SY(30)), 
    rl = CCPointMake(SX(240), SY(30)), rt = CCPointMake(SX(290) + SX(38), SY(30)), rb = CCPointMake(SX(360) + SX(30), SY(30)),
    c = CCPointMake(SX(240), SY(30)),
    a = CCPointMake(SX(420), SY(30))
}
-----------------------函数声明区------------------------

-----------------------逻辑功能区------------------------

local function VanFood_GetIsEnemy(idPlayer)    
    for i = 1, #m_stEnemyList do
        if m_stEnemyList[i].idPlayer == idPlayer then
            return true
        end
    end
    return false
end

local function VanFood_GetRandomEnemyList()
    local st = {}
    
    local idPlayer = Hero:getSingleton():getID()
    for i = 1, #m_stPlayerList do
        if m_stPlayerList[i].idPlayer ~= idPlayer and m_stPlayerList[i].nSupLootTimes < 2 then
            table.insert(st, i)
        end
    end

    local tmp = {}
    local n = #st
    if n > 15 then
        n = 15 
    end 
    for i = 1, n do
        local num = math.random(1, #st)
        if VanFood_GetIsEnemy(m_stPlayerList[st[num]].idPlayer) then
            table.insert(tmp, 1, m_stPlayerList[st[num]])
        else
            table.insert(tmp, m_stPlayerList[st[num]])
        end
        
        table.remove(st, num)
    end
    return tmp
end

local function OpenUnClickLayer()
    local wndCtrl = getCurentSceneWindowController(9114)
    if not wndCtrl then
        local wnd = SCWindow:window()
        if wnd then
            wnd:setTag(9114)
            wndCtrl = SCWindowController:controllerWithWindow(wnd)
            if wndCtrl then
                PUSH_CTRL(wndCtrl)
                
                wnd:setBackButtonVisibled(false)
                wnd:setCloseButtonVisibled(false)
                wnd:setFrameVisibled(false)
            end
        end
    end
end

local function CloseUnClickLayer()
    if getCurentSceneWindowController(9114) then
        REMOVE_CTRL_BY_TAG(9114)
    end
end

local function onOpenWnd(tag)
    m_bOpenWithMail = true
    VanFood_OpenVanFoodWnd()
    ShowFastLittleVip5TipCancel()
end
local function onMailTipClick(tag)    
    GuidePoint_LuaAddCount(20, 0)
    local btn = SCFunction:getUiNodeByIdlist("9115")
    if btn then
        btn:removeFromParentAndCleanup(true)
    end
    luashowConfirmationWindowPoint(L("str20151"), nil, L("str20152"), WIN_NULL, onOpenWnd, ShowFastLittleVip5TipCancel, 1) 
    --[[
    local stTitle = {"*0"..L("str20118"), "*3"..L("str20119"), "*8"..L("str20120"), "*7"..L("str20121"), "*6"..L("str20122")}
    local szName = m_stEnemyList[n].szName
    local str = string.format(L("str20157"), stTitle[m_stEnemyList[n].usEscortType].."*0", "*3"..szName.."*0")
    luashowConfirmationWindowPoint(str, nil, L("str20158"), WIN_NULL, onOpenWnd, ShowFastLittleVip5TipCancel, 1)    
    --]]
end
local function OpenMailTip()
    local wndMain = SCFunction:getUiNodeByIdlist("9110")
    if wndMain then
        while true do
            local wndTopCtrl = getCurentSceneNavigationController():topWindowController()
            if wndTopCtrl and wndTopCtrl:getTag() ~= 9110 then
                REMOVE_TOP_CTRL()
            else
                break
            end
        end
        --onMailTipClick()
        return
    end
    
    local wnd = getRunningScene():getUINode()
    if not wnd then return end 
    --[[
    if SCFunction:getUiNodeByIdlist("9110") then
        onMailTipClick()
        return
    end--]]
    local path = RES("img/new00641.pn")
    local btn = --[[BtnMainInterface:getMainInterfaceButton(path)--]]SCButton:button()    
    if btn and path then
        btn:setTag(9115)
        btn:setTitle(path)
        --btn:setApertureVisible(true)
        btn:setAnchorPoint(ANCHOR_CENTER)
        btn:setPosition(AUTO_POS(240, 110))
        btn:luaSetSelectorOnClicked(onMailTipClick)
        if Hero:getSingleton():getBatter() then
            wnd:addChild(btn, -1)
        else
            wnd:addChild(btn)
        end
        --[[
        local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1018, 1018);--光圈
        if pAi then
            local pAnimationNode =  SCAnimationNode:nodeWithAnimation(pAi);
            if pAnimationNode then
                pAnimationNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                local size = btn:getContentSize();
                pAnimationNode:setPosition(CCPointMake(size.width / 2, size.height / 2));
                btn:addChild(pAnimationNode);
            end
        end
        --]]
    end
end
local function VanFood_EnemyBtnClick(id)
    ViewPlayInfo_sendData(id, 0, "")
end
local function VanFood_OpenEnemyInfoWnd(stPlayer, type)--[[type = 1-- hero, 2--escort  --]]
    if not stPlayer then return end 
    
    local wndCtrl = getCurentSceneWindowController(9116)
    if not wndCtrl then
        local wnd = SCWindow:window()
        if wnd then
            local szWnd = AUTO_SIZE(280, 180)
            if type == 2 then
                szWnd = AUTO_SIZE(280, 165)
            end
            wnd:setContentSize(szWnd)
            wnd:setTag(9116)
            
            local nodeBg = SCDragNode:node()
            if nodeBg then
                nodeBg:setContentSize(szWnd)
                nodeBg:setFrameVisibled(true)
                nodeBg:setFrameType(1)
                wnd:addChild(nodeBg)                
            end
            
            local path = RES("kernal/redtop.pn")
            if path then
                local img = SCImage:imageWithFile(path)
                if img then
                    img:setAnchorPoint(CCPointMake(0.5, 1))
                    img:setPosition(szWnd.width / 2, szWnd.height)
                    wnd:addChild(img)
                    
                    local str = ""
                    if type == 2 then
                        str = L("str20163")--L("str201"..m_stPlayerSel.usEscortType + 17)
                    elseif type == 1 then
                        str = stPlayer.szName
                    end
                    local label = SCLabel:labelWithStringFont(str, getDefaultFontName(), F(15))
                    if label then
                        label:setAnchorPoint(CCPointMake(0.5, 0.5))
                        label:setPosition(img:getContentSize().width / 2, img:getContentSize().height / 2)
                        label:setColor(color_orange)
                        img:addChild(label)
                    end
                end
            end
            local path = RES("img/new00305.pn")
            if path then
                local node = SCImage:imageWithFile(path)
                if node then            
                    node:setAnchorPoint(CCPointMake(0, 0))
                    node:setPosition(SX(30), szWnd.height - SY(130))
                    wnd:addChild(node)
                    local stPath = {"escort/new00838.pn", "escort/new00837.pn", "escort/new00836.pn", "escort/new00835.pn", "escort/new00840.pn"}
                    local path = RES(stPath[5])
                    if stPlayer then
                        if type == 2 then
                            path = RES(stPath[stPlayer.usEscortType])
                            if path then
                                local img = SCImage:imageWithFile(path)
                                if img then
                                    img:setAnchorPoint(CCPointMake(0.5, 0))
                                    img:setPosition(node:getContentSize().width / 2, 0)
                                    node:addChild(img)
                                end   
                            end             
                        else
                            --龙将、剑舞、箭神、军师
                            local stPhoto = {111010, 141010, 121010, 131010}
                            local nPhoto = 0
                            if stPlayer.ucClan then
                                nPhoto = stPhoto[stPlayer.ucClan]                    
                            end
                            local ani = SCLookfaceParser:getSingleton():getAnimationByLookfaceAndIndex(nPhoto, dirAction_Stand)
                            if ani then
                                ani:setFrameAnchor(EnumFrameAnchorFoot);
                                local pLookNode = SCAnimationNode:nodeWithAnimation(ani);
                                if pLookNode then
                                    pLookNode:setAnchorPoint(CCPointMake(0.5, 0));
                                    pLookNode:setPosition(node:getContentSize().width / 2, 0 + node:getContentSize().height / 2 - SY(5))                        
                                    node:addChild(pLookNode);
                                end
                            end
                        end
                    end
                end
            end
            local str = ""
            if type == 1 then
                str = "*5"..L("str20155")..":%s_*5"..L("str0013")..":%s_*5"..L("str20146")..":%s_*5"..L("str20162")..":"..L("str5001")
                str = string.format(str, stPlayer.szName, stPlayer.nPlayerLev.."", stPlayer.szTribe)
                local nodeInfo = getItemTextNode(str, 0, 13)
                if nodeInfo then
                    nodeInfo:setPosition(SX(120), szWnd.height - SY(40))
                    nodeInfo:setAnchorPoint(CCPointMake(0, 1))
                    nodeInfo:setPerWidthAndHeight(13, 20)
                    wnd:addChild(nodeInfo)
                end
                local btnInfo = SCButton:button(1)
                if btnInfo then
                    btnInfo:setTag(stPlayer.idPlayer)
                    btnInfo:setAnchorPoint(CCPointMake(0.5, 0))
                    btnInfo:setPosition(szWnd.width / 2, SY(15))                    
                    btnInfo:setContentSize(AUTO_SIZE(80, 30))
                    btnInfo:setTitle(L("str20140")..L("str0129"), getDefaultFontName(), F(15))
                    btnInfo:luaSetSelectorOnClicked(VanFood_EnemyBtnClick)
                    wnd:addChild(btnInfo)
                end
            elseif type == 2 then
                local stTitle = {L("str20118"), L("str20119"), L("str20120"), L("str20121"), L("str20122")}
                str = "*5"..L("str20165")..":%s_*5"..L("str20129")..":_*5"..L("str20166")..":%d/2_*5"..L("str20167")..":"
                str = string.format(str, stTitle[stPlayer.usEscortType], stPlayer.nSupLootTimes)
                
                local label = getItemTextNode(str, 0, 13)
                if label then
                    label:setAnchorPoint(CCPointMake(0, 1))
                    label:setPosition(SX(120), szWnd.height - SY(30))
                    label:setPerWidthAndHeight(13, 20)
                    wnd:addChild(label)
                end
                --时间
                local label = CountDownNode:newCountDownNode(DisplayTimeType_Minute_Second, 13)
                if label then
                    label:setAnchorPoint(CCPointMake(0, 0.5))
                    label:setPosition(SX(188), szWnd.height - SY(57))
                    local nSubTime = 0
                    local node = SCTypeCast:castNodeToCountDownNode(SCFunction:getUiNodeByIdlist("9110-1-"..stPlayer.idPlayer.."-1"))                    
                    if node then
                        nSubTime = node:getCurTime()
                    end
                    label:setTime(nSubTime)
                    label:setColor(color_orange)                    
                    wnd:addChild(label)
                end
                --奖励
                local bNewLine
                local extra = ""
                if stPlayer.nEnemyMoney > 0 then
                    local nMoney = stPlayer.nEnemyMoney
                    local sub = 0
                    if stPlayer.nSupLootTimes then
                        sub = stPlayer.nSupLootTimes
                    end
                    nMoney = nMoney - math.floor(nMoney / 10) * sub
                    extra = "*5"..nMoney..L("str5171")
                    bNewLine = true
                end
                if stPlayer.nEnemyReputation > 0 then
                    local nEnemyReputation = stPlayer.nEnemyReputation
                    if bNewLine then
                        extra = extra.."_*5"
                    end
                    if stPlayer.nSupLootTimes then
                        nEnemyReputation = nEnemyReputation - math.floor(nEnemyReputation / 10) * stPlayer.nSupLootTimes
                    end
                    extra = extra..nEnemyReputation..L("str0193")
                end
                local itemID = 0
                if m_stEscortList[stPlayer.usEscortType] and m_stEscortList[stPlayer.usEscortType].idAwardItemtype > 0 then
                    itemID = m_stEscortList[stPlayer.usEscortType].idAwardItemtype
                else
                    local stName = {0, 0, 3461000306, 3461000307, 3461000308}
                    itemID = stName[stPlayer.usEscortType]
                end
                if itemID > 0 then
                    local item = TableParser:getSingleton():getItemInfoByKey(itemID)                    
                    if item then 
                        extra = extra.."_*5"..item.name:getData()
                    end
                end
                local nodeInfo = getItemTextNode(extra, 0, 13)
                if nodeInfo then
                    nodeInfo:setPosition(SX(179), szWnd.height - SY(90))
                    nodeInfo:setAnchorPoint(CCPointMake(0, 1))
                    nodeInfo:setPerWidthAndHeight(13, 20)
                    wnd:addChild(nodeInfo)
                end
            end            
            
            wndCtrl = SCWindowController:controllerWithWindow(wnd)
            if wndCtrl then
                PUSH_CTRL(wndCtrl)
                wnd:setBackButtonVisibled(false)
                wnd:setFrameVisibled(false)
                --wnd:setAutoCloseOnTouchSpace(true)
            end
        end
    end
end
------------------
function VanFood.OpenMainWnd()
    local wndCtrl = getCurentSceneWindowController(9110)
    if not wndCtrl then
        local wnd = VanFood.CreateWnd()
        if wnd then
            wndCtrl = SCWindowController:controllerWithWindow(wnd)
            if wndCtrl then
                PUSH_CTRL(wndCtrl)                
                
                local btnClose = SCTypeCast:castNodeToButton(wnd:getChildByTag(101))
                if btnClose then
                    btnClose:setMusicPath("closeWindow.mp3");                    
                end
                
                VanFood.UpdateWindow()                
            end
        end
    else
        VanFood.UpdateWindow()
    end
end
function VanFood.OpenEscortWndEnable()
    if not m_bFirstOpenMainWnd then return end 
    if m_bOpenWithMail then
        m_bOpenWithMail = nil
        return 
    end
    local idPlayer = Hero:getSingleton():getID()
    local node = SCFunction:getUiNodeByIdlist("9110-1-"..idPlayer)
    if not node and m_nSupEscortTimes > 0 then
        Escort.SendOpenWnd()
    end
    --[[
    if m_nSupEscortTimes and m_nSupEscortTimes > 0 then
        for i = 1, #m_stPlayerList do
            if idPlayer == m_stPlayerList[i].idPlayer then
                return 
            end        
        end
        Escort.SendOpenWnd()
    end    
    --]]
end
function VanFood.onCloseWnd()
    m_nCurEnemyIndex = nil
    m_bRobTime = nil
    m_bVanTime  = nil
    m_bHideFood = nil
    m_nLootCD = nil
    m_nTimeCount = nil--
    m_nReturnType = nil    
    m_nTimeCount = nil
    m_nTimeEnemy = nil
    m_bFirstOpenMainWnd = nil
    m_nSupEscortTimes = nil
    m_nSupLootTimes = nil
    m_bRobTimeUpdate = nil
    
    m_stEnemyList = {}    --仇人
    m_stPlayerList = {}   --玩家
    m_stEscortList = {}   --押镖

    if m_idTimerPlayer then--test
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_idTimerPlayer)
        m_idTimerPlayer = nil
    end
    if m_idTimerEnemy then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_idTimerEnemy)
    end    
    
    VanFood.SendCloseWnd()
end

function VanFood.onBtnClick(tag)
    if tag == 101 then--hide
        local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("9110-101"))
        if btn then
            local str = ""
            if m_bHideFood then
                str = L("str20124")
                m_bHideFood = false
            else
                str = L("str20135")
                m_bHideFood = true
            end
            btn:setTitle(str, getDefaultFontName(), F(15))
        end
        local nodeMain = SCFunction:getUiNodeByIdlist("9110-1")
        if nodeMain then
            local idHero = Hero:getSingleton():getID()            
            for i = 1, #m_stPlayerList do
                if m_stPlayerList[i].usEscortType == 1 and m_stPlayerList[i].idPlayer ~= idHero then
                    local node = nodeMain:getChildByTag(m_stPlayerList[i].idPlayer)
                    if node then
                        node:setVisible(not m_bHideFood)
                    end
                end
            end
        end
    elseif tag == 102 then--rob list
        if m_nSupLootTimes <= 0 then
            showMessage(L("str20160"))
        else
            RobList.OpenMainWnd()
        end
    elseif tag == 103 then--info
        local id = Hero:getSingleton():getID()
        for i = 1, #m_stPlayerList do
            if m_stPlayerList[i].idPlayer == id then
                VanFood_OpenEnemyInfoWnd(m_stPlayerList[i], 2)
                return
            end
        end
        showMessage(L("str20168"))
    elseif tag == 104 then --desctibe
        local wnd = SCFunction:getUiNodeByIdlist("9110")
        local tipWnd = VanFood.CreateTipWnd()
        if wnd and tipWnd then
            tipWnd:setAnchorPoint(CCPointMake(0.5, 0.5))
            tipWnd:setPosition(wnd:getContentSize().width / 2, wnd:getContentSize().height / 2)
            wnd:addChild(tipWnd, 1112)
        end
    elseif tag == 111 then --add escortTimes
        
    elseif tag == 112 then--add robTimes
    
    elseif tag == 121 then --start
        Escort.SendOpenWnd()
    elseif tag == 25 then--robtime
        VanFood.SendLootUpSpeed(0)
        --[[m_nReturnType = 11
        local nodeRob = SCTypeCast:castNodeToCountDownNode(SCFunction:getUiNodeByIdlist("9110-22"))
        if nodeRob then
            local time = math.ceil(nodeRob:getCurTime() / 30) * 5
            luashowConfirmationWindow(string.format(L("str20144"), time, L("str20111")), WIN_YES_NO, VanFood.returnRefreshEscort)
        end--]]
    elseif tag == 26 then--escorttime
        VanFood.SendUpSpeed(0)
        --[[m_nReturnType = 12
        local nodeVan = SCTypeCast:castNodeToCountDownNode(SCFunction:getUiNodeByIdlist("9110-24"))
        if nodeVan then
            local time = math.ceil(nodeVan:getCurTime() / 30) * 5
            luashowConfirmationWindow(string.format(L("str20144"), time, L("str20112")), WIN_YES_NO, VanFood.returnRefreshEscort)
        end--]]
    elseif tag == 27 then--rob escort
        m_nReturnType = 13
        local nodeRob = SCTypeCast:castNodeToCountDownNode(SCFunction:getUiNodeByIdlist("9110-22"))
        local nodeVan = SCTypeCast:castNodeToCountDownNode(SCFunction:getUiNodeByIdlist("9110-24"))
        if nodeRob then
            local time = math.ceil(nodeRob:getCurTime() / 30) * 5 + math.ceil(nodeVan:getCurTime() / 30) * 5
            luashowConfirmationWindow(string.format(L("str20144"), time, L("str20111").."、"..L("str20112")), WIN_YES_NO, VanFood.returnRefreshEscort)
        end
    end
end

function VanFood.onBtnEnemy(tag)
    for i = 1, #m_stEnemyList do
        if m_stEnemyList[i].idPlayer == tag then
            GuidePoint_LuaAddCount(20, 2)
            local nodeBack = SCFunction:getUiNodeByIdlist("9110-51-"..m_stEnemyList[i].idPlayer.."-1")
            local nodeRob = SCFunction:getUiNodeByIdlist("9110-1-"..m_stEnemyList[i].idPlayer)
            if nodeBack then
                if nodeBack:isVisible() or nodeBack:getCurTime() == 0 then
                    RobFood.OpenMainWnd(m_stEnemyList[i], true, true)                     
                end
            elseif nodeRob then
                VanFood.onMainEscortClick(m_stEnemyList[i].idPlayer)
            else
                VanFood_OpenEnemyInfoWnd(m_stEnemyList[i], 1)
            end
            break
        end
    end
end
function VanFood.onMainEscortClick(tag)
    for i = 1, #m_stPlayerList do
        if m_stPlayerList[i].idPlayer == tag then            
            RobFood.OpenMainWnd(m_stPlayerList[i], false)
            break;
        end
    end
end
--刷新二次确认
function VanFood.returnRefreshEscort(tag)
    if tag == 1 then
        if m_nReturnType == 1 then
            Escort.SendRefresh()
        elseif m_nReturnType == 2 then
            local tipNode = SCFunction:getUiNodeByIdlist("9111-4-102-1000")
            if tipNode then
                tipNode:removeFromParentAndCleanup(true)
            end
            Escort.SendRefreshMax()
        elseif m_nReturnType == 11 then
            --VanFood.SendLootUpSpeed(0)
        elseif m_nReturnType == 12 then
            --VanFood.SendUpSpeed(0)
        elseif m_nReturnType == 13 then
            VanFood.SendLootUpSpeed(0)
            VanFood.SendUpSpeed(0)
        end
    end
    m_nReturnType = nil
end
function VanFood.ActionMoveEnd()
    VanFood.AddTimeExtra()     
end
function VanFood.robTimeEnd()
    local nodeRob = SCTypeCast:castNodeToCountDownNode(SCFunction:getUiNodeByIdlist("9110-22"))
    if nodeRob then
        m_nLootCD = 0
        VanFood.UpdateBottomTime()
    end
end
function VanFood.EscortTimeEnd()
    local nodeEscort = SCTypeCast:castNodeToCountDownNode(SCFunction:getUiNodeByIdlist("9110-24"))
    if nodeEscort then
        VanFood.UpdateBottomTime()
    end
end
function VanFood.UpdateWindow()  
    local scrollBox = tolua.cast(SCFunction:getUiNodeByIdlist("9110-51"), "SCScrollBox")
    if scrollBox then
        scrollBox:removeAllChildrenWithCleanup(true)        
        for i = 1, #m_stEnemyList do            
            local btn = VanFood.CreatePhotoBtn(i)
            if btn then                
                btn:setAnchorPoint(CCPointMake(0, 1))
                btn:setPosition(SX(50) * (i - 1) , scrollBox:getHeight() - SY(15))
                btn:luaSetSelectorOnClicked(VanFood.onBtnEnemy)                
                scrollBox:addChild(btn)
            end
        end
    end
    
    local labelEscort = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("9110-11"))
    if labelEscort then
        if not m_nSupEscortTimes then 
            m_nSupEscortTimes = 0
        end
        labelEscort:setText(string.format(L("str20109"), m_nSupEscortTimes))
    end
    local labelRob = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("9110-12"))
    if labelRob then
        if not m_nSupLootTimes then 
            m_nSupLootTimes = 0
        end
        labelRob:setText(string.format(L("str20110"), m_nSupLootTimes))
    end
    
    VanFood.UpdateBottomTime()
end

function VanFood.UpdateBottomTime()
    local wnd = SCFunction:getUiNodeByIdlist("9110")
    if not wnd then return end 
    
    m_bRobTime = nil
    m_bVanTime = nil
    if m_nSupLootTimes then
        if m_nLootCD and m_nLootCD > 0 then
            m_bRobTime = true
        end
    end

    local idPlayer = Hero:getSingleton():getID()    
    local node = SCTypeCast:castNodeToCountDownNode(SCFunction:getUiNodeByIdlist("9110-1-".. idPlayer.."-1"))
    if node and node:getCurTime() > 0 then
        m_bVanTime = true;
    end
    
    local labelRob = SCTypeCast:castNodeToLabel(wnd:getChildByTag(21))
    local nodeRob = SCTypeCast:castNodeToCountDownNode(wnd:getChildByTag(22))
    local btnRob = SCTypeCast:castNodeToButton(wnd:getChildByTag(25))
    local labelVan = SCTypeCast:castNodeToLabel(wnd:getChildByTag(23))
    local nodeVan = SCTypeCast:castNodeToCountDownNode(wnd:getChildByTag(24))
    local btnVan = SCTypeCast:castNodeToButton(wnd:getChildByTag(26))
    local btnAll = SCTypeCast:castNodeToButton(wnd:getChildByTag(27))
    local btnStart = SCTypeCast:castNodeToButton(wnd:getChildByTag(121))
    if not labelRob or not nodeRob or not btnRob or not labelVan or not nodeVan or not btnVan or not btnStart then
        return 
    end 
    if m_bRobTime then        
        labelRob:setVisible(true)
        nodeRob:setVisible(true)
        btnRob:setVisible(true)
        if m_bRobTimeUpdate then
            nodeRob:setTime(m_nLootCD)
            m_bRobTimeUpdate = nil
        end
    else
        labelRob:setVisible(false)
        nodeRob:setVisible(false)
        btnRob:setVisible(false)
    end
    if m_bVanTime then        
        local idPlayer = Hero:getSingleton():getID()
        if node then            
            nodeVan:setTime(node:getCurTime())            
        end
       
        labelVan:setVisible(true)
        nodeVan:setVisible(true)
        btnVan:setVisible(true)
        btnStart:setVisible(false)        
    else
        labelVan:setVisible(false)
        nodeVan:setVisible(false)
        btnVan:setVisible(false)
        if m_nSupEscortTimes > 0 then
            btnStart:setVisible(true)
        else
            btnStart:setVisible(false)
        end
    end
    
    if m_bRobTime and m_bVanTime then 
        --btnAll:setVisible(true)        
        labelRob:setPosition(m_ptPos.ll)
        nodeRob:setPosition(m_ptPos.lt)
        btnRob:setPosition(m_ptPos.lb)
        labelVan:setPosition(m_ptPos.rl)
        nodeVan:setPosition(m_ptPos.rt)
        btnVan:setPosition(m_ptPos.rb)
        --btnAll:setPosition(m_ptPos.a)
    elseif m_bRobTime and not m_bVanTime then
        btnAll:setVisible(false)      
        labelRob:setPosition(m_ptPos.ll)
        nodeRob:setPosition(m_ptPos.lt)
        btnRob:setPosition(m_ptPos.lb)
        btnStart:setPosition(m_ptPos.rt)
    elseif not m_bRobTime and m_bVanTime then
        btnAll:setVisible(false)
        local pt = CCPointMake(SX(160), m_ptPos.rl.y)
        labelVan:setPosition(pt)
        nodeVan:setPosition(pt.x + SX(98), pt.y)
        btnVan:setPosition(pt.x + SX(170), pt.y)
    else
        btnAll:setVisible(false)
        btnStart:setPosition(m_ptPos.c)
    end
end

function VanFood.UpdateEscortAction()
    local idHero = Hero:getSingleton():getID()
    for i = 1, #m_stPlayerList do
        if m_stPlayerList[i] then            
            VanFood.AddItemAction(m_stPlayerList[i])            
        end
    end
    VanFood.UpdateBottomTime()
end

function VanFood.AddItemAction(tmp)
    if not tmp then return end 
    
    local nodeMain = SCFunction:getUiNodeByIdlist("9110-1")
    if not nodeMain then return end 
    
    local node = nodeMain:getChildByTag(tmp.idPlayer)
    if node then
        return
    end
    --[[if tmp.nSupTime <= 0 then
        return 
    end--]]
    local szMain = nodeMain:getContentSize()
    local stPath = {"escort/new00838.pn", "escort/new00837.pn", "escort/new00836.pn", "escort/new00835.pn", "escort/new00840.pn"} 
    local actionNode = ActionNode:newActionNode()
    local btn = SCButton:button()
    if btn and actionNode then            
        btn:setTag(tmp.idPlayer)
        btn:luaSetSelectorOnClicked(VanFood.onMainEscortClick)            
        btn:setTouchRectScale(1, 1)
        btn:setIsTouchMoveClose(true)--test
        local path = RES(stPath[tmp.usEscortType])
        if path then
            btn:setTitle(path)
            btn:setScale(0.8)
        end
                
        local nNeedTime = 300--m_stEscortList[tmp.usEscortType].nNeedTimes * 60--test
        local max = szMain.width - SX(90)
        local x = (nNeedTime - tmp.nSupTime) / nNeedTime * max
        local y = 0
        local z = 0
        if m_ptPlayerPos[tmp.idPlayer] then
            y = m_ptPlayerPos[tmp.idPlayer].y
            z = m_ptPlayerPos[tmp.idPlayer].z
        else            
            y = math.random(0, szMain.height - SY(50))            
            z = math.floor(szMain.height - y)
        end
        
        if tmp.idPlayer == Hero:getSingleton():getID() then            
            local offset = SX(0)
            if tmp.usEscortType == 1 then
                offset = -SX(10)
            elseif tmp.usEscortType == 2 then
                offset = -SX(15)
            elseif tmp.usEscortType == 3 then
                offset = -SX(8)
            elseif tmp.usEscortType == 4 then
                offset = -SX(15)
            elseif tmp.usEscortType == 5 then
                offset = -SX(5)
            end
            
            local nodeDown = ActionNode:newActionNode()
            if nodeDown then
                nodeDown:setTag(8889)
                nodeDown:setContentSize(btn:getContentSize())
                nodeDown:setAnchorPoint(CCPointMake(0.5, 0))                
                nodeDown:setAutoRemove(true)
                nodeMain:addChild(nodeDown, 8889)
                local nEx = nodeDown:getContentSize().width / 2 + offset
                nodeDown:setPosition(CCPointMake(x + nEx, y - SY(25)))
                nodeDown:moveTo(CCPointMake(max + nEx, y - SY(25)), tmp.nSupTime, true)
                GuidePoint_createSetDownGuideNode(nodeDown)
            end
            local node = ActionNode:newActionNode()
            if node and btn then
                nodeMain:addChild(node, -1)
                node:setContentSize(btn:getContentSize())
                node:setAnchorPoint(CCPointMake(0.5, 0))                
                node:setAutoRemove(true)                
                
                local nEx = node:getContentSize().width / 2 + offset
                node:setPosition(CCPointMake(x + nEx, y))
                node:moveTo(CCPointMake(max + nEx, y), tmp.nSupTime, true)--
                node:setTag(8888)                                 
                local path = RES("img/new00305.pn")            
                if path then
                    local img = SCImage:imageWithFile(path)
                    if img then
                        img:setAnchorPoint(CCPointMake(0.5, 0))                        
                        img:setPosition(node:getContentSize().width / 2, 0)                        
                        node:addChild(img)
                    end
                end
            end
        end
        
        actionNode:setPosition(CCPointMake(x, y))
        actionNode:setAutoRemove(true)
        actionNode:moveTo(CCPointMake(max, y), tmp.nSupTime, true)--
        actionNode:setTag(tmp.idPlayer)        
        actionNode:luaSetSelectorOnMoveEnd(VanFood.ActionMoveEnd)
        actionNode:addChild(btn)
        actionNode:setContentSize(btn:getContentSize())
        nodeMain:addChild(actionNode,z)
        VanFood.AddToTable(tmp.idPlayer, x, y)
        m_ptPlayerPos[tmp.idPlayer].z = z
        
        local nodeTime = CountDownNode:newCountDownNode(DisplayTimeType_Hour_Minute_Second, 10)
        if nodeTime then
            nodeTime:setTag(1)           
            nodeTime:setTime(tmp.nSupTime)
            nodeTime:setVisible(false)
            actionNode:addChild(nodeTime)
            actionNode:getTag()
        end        
        --[[
        local labelName = SCLabel:labelWithStringFont(tmp.szName, getDefaultFontName(), F(10))
        if labelName then
            labelName:setAnchorPoint(CCPointMake(0.5, 1))
            labelName:setPosition(btn:getContentSize().width / 2, btn:getContentSize().height - SY(10))
            actionNode:addChild(labelName)
        end--]]
    end    
end
function VanFood.AddToTable(idPlayer, x, y)
    if not idPlayer then return end 
    
    local pt = CCPointMake(x, y)    
    m_ptPlayerPos[idPlayer] = pt
    m_ptPlayerPos[idPlayer].x = x
    m_ptPlayerPos[idPlayer].y = y
end
function VanFood.AddTimeExtra()
    local nodeMain = SCFunction:getUiNodeByIdlist("9110-1")
    local tmp = {}
    if nodeMain then
        for i = 1, #m_stPlayerList do
            local node = SCTypeCast:castNodeToCountDownNode(SCFunction:getUiNodeByIdlistAndParent(m_stPlayerList[i].idPlayer.."-1", nodeMain))
            if node then
                m_stPlayerList[i].nSupTime = node:getCurTime()
                if m_stPlayerList[i].nSupTime == 0 then
                    local parent = node:getParent()
                    if parent then                        
                        table.insert(tmp, m_stPlayerList[i].idPlayer)
                    end
                end
            else
                table.insert(tmp, m_stPlayerList[i].idPlayer)
            end
        end
    end
    local nodeEnemy = SCFunction:getUiNodeByIdlist("9110-51")
    if nodeEnemy then
        for i = 1, #m_stEnemyList do
            local node = SCTypeCast:castNodeToCountDownNode(SCFunction:getUiNodeByIdlistAndParent(m_stEnemyList[i].idPlayer.."-1", nodeEnemy))
            if node then
                m_stEnemyList[i].nEnemyTime = node:getCurTime()
            end
        end
    end
    local n = #tmp
    for i = 1, n do
        for j = 1, #m_stPlayerList do
            if m_stPlayerList[j].idPlayer == tmp[i] then
                table.remove(m_stPlayerList, j)
                break
            end
        end
    end
    tmp = nil
    --VanFood.UpdateBottomTime()    
end
function VanFood.timeCount()
    if not m_nTimeCount then
        m_nTimeCount = 0
    end
    m_nTimeCount = m_nTimeCount + 1
end
function VanFood.timeEnemyCount()
    if not m_nTimeEnemy then
        m_nTimeEnemy = 0
    end
    m_nTimeEnemy = m_nTimeEnemy + 1
end
-----------------------UI控制器区------------------------
function VanFood.CreateWnd()
    local wnd = SCWindow:window()
    if not wnd then return end 
    
    local szWnd = AUTO_SIZE(480, 320)
    wnd:setTag(9110)
    wnd:setContentSize(szWnd)
    wnd:luaSetSelectorOnClose(VanFood.onCloseWnd)    
    
    local path = RES("escort/new00841.pn")
    if path then
        local nodeBg = SCImage:imageWithFile(path)
        if nodeBg then            
            wnd:addChild(nodeBg)
            nodeBg:setScaleX(SX(480) / nodeBg:getContentSize().width)
            nodeBg:setScaleY(SY(320) / nodeBg:getContentSize().height)
            nodeBg:setAnchorPoint(CCPointMake(0.5, 0.5))
            nodeBg:setPosition(AUTO_POS(240, 160))
        end
    end
    
    local pathTitle = RES("escort/new00834.pn")
    if pathTitle then
        local img = SCImage:imageWithFile(pathTitle)
        if img then
            img:setAnchorPoint(CCPointMake(0, 1))
            img:setPosition(SX(20), szWnd.height - SY(10))
            wnd:addChild(img)
            --wnd:setTitleWithImage(pathTitle)
        end
    end
    
    local szBtnTop = AUTO_SIZE(80, 30)    
    for i = 1, 4 do
        local btnList = SCButton:button(1)
        if btnList then
            btnList:setAnchorPoint(CCPointMake(1, 1))
            btnList:setPosition(szWnd.width - SX(40) - (szBtnTop.width + SX(1)) * (i - 1), szWnd.height - SY(7))
            btnList:setContentSize(szBtnTop)
            btnList:setTag(100 + i)
            if i == 1 or i == 2 then
                btnList:setTitle(L("str2012".. 5 - i), getDefaultFontName(), F(15))
            elseif i == 3 then
                btnList:setTitle(L("str20164"), getDefaultFontName(), F(15))
            else
                btnList:setTitle(L("str0517"), getDefaultFontName(), F(15))
            end
            btnList:luaSetSelectorOnClicked(VanFood.onBtnClick)
            wnd:addChild(btnList)
        end
    end
    
    local labelProtect = SCLabel:labelWithStringFont(string.format(L("str20109"), 0), getDefaultFontName(), F(12))
    if labelProtect then
        labelProtect:setTag(11)
        labelProtect:setAnchorPoint(CCPointMake(0, 0.5))
        labelProtect:setPosition(SX(5), SY(275))
        wnd:addChild(labelProtect, 1111)
    end
    local labelRob = SCLabel:labelWithStringFont(string.format(L("str20110"), 0), getDefaultFontName(), F(12))
    if labelRob then
        labelRob:setTag(12)
        labelRob:setAnchorPoint(CCPointMake(0, 0.5))
        labelRob:setPosition(SX(5), SY(250))
        wnd:addChild(labelRob, 1111)
    end
    --[[
    local pathNormal = RES("img/new00306.pn")
    local pathSelect = RES("img/new00307.pn")
    if pathNormal and pathSelect then
        for i = 1, 2 do
            local btnAdd = SCButton:button()
            if btnAdd then
                btnAdd:setTag(110 + i)
                btnAdd:setPosition(AUTO_POS(110, 275 - (i - 1) * 25))
                btnAdd:setAnchorPoint(CCPointMake(0.5, 0.5))
                btnAdd:setBackgroundImage(pathNormal)
                btnAdd:setSelectedImage(pathSelect)
                btnAdd:luaSetSelectorOnClicked(VanFood.onBtnClick)
                wnd:addChild(btnAdd)
                local path = RES("img/new00308.pn")
                if path then
                    btnAdd:setTitle(path)
                end
            end
        end        
    end
    --]]
    local scrollBox = SCScrollBox:boxWithWidthHeight(SX(320), SY(80))
    if scrollBox then
        scrollBox:setTag(51)
        scrollBox:setScrollHorizontal(false)
        scrollBox:setScrollVertical(false)
        scrollBox:setAnchorPoint(CCPointMake(0, 1))
        scrollBox:setPosition(AUTO_POS(140, 300))
        --scrollBox:setBackgroundColor(color_blue)
        wnd:addChild(scrollBox, 1111)
    end
    
    local nodeMain = SCNode:node()
    if nodeMain then
        nodeMain:setTag(1)
        nodeMain:setContentSize(CCSizeMake(szWnd.width, SY(175)))
        nodeMain:setAnchorPoint(CCPointMake(0.5, 0))
        nodeMain:setPosition(szWnd.width / 2, SY(50))
        --nodeMain:setBackgroundColor(color_gray)
        wnd:addChild(nodeMain)
    end
    
    local ptY = SY(30)
    local btnStart = SCButton:button(1)
    if btnStart then
        btnStart:setTag(121)
        btnStart:setContentSize(AUTO_SIZE(80, 30))
        btnStart:setAnchorPoint(CCPointMake(0.5, 0.5))
        btnStart:setPosition(szWnd.width / 2, ptY)
        btnStart:setTitle(L("str20125"), getDefaultFontName(), F(15))
        btnStart:luaSetSelectorOnClicked(VanFood.onBtnClick)
        btnStart:setVisible(false)
        wnd:addChild(btnStart)
    end
    
    local labelLose = SCLabel:labelWithStringFont(L("str20111"), getDefaultFontName(), F(13))
    if labelLose then
        labelLose:setTag(21)
        labelLose:setAnchorPoint(CCPointMake(0, 0.5))
        labelLose:setPosition(m_ptPos.ll)        
        wnd:addChild(labelLose)
    end
    
    local nodeTime = CountDownNode:newCountDownNode(DisplayTimeType_Minute_Second, 13)
    if nodeTime then
        nodeTime:setTag(22)
        nodeTime:setAnchorPoint(CCPointMake(0, 0.5))
        nodeTime:setPosition(m_ptPos.lt)
        nodeTime:setTime(0)
        nodeTime:luasetSelectorOnClose(VanFood.robTimeEnd)
        wnd:addChild(nodeTime)
    end
    
    local labelLeft = SCLabel:labelWithStringFont(L("str20112"), getDefaultFontName(), F(13))
    if labelLeft then
        labelLeft:setTag(23)
        labelLeft:setAnchorPoint(CCPointMake(0, 0.5))
        labelLeft:setPosition(m_ptPos.rl)         
        wnd:addChild(labelLeft)
    end
    
    local nodeTime = CountDownNode:newCountDownNode(DisplayTimeType_Minute_Second, 13)
    if nodeTime then
        nodeTime:setTag(24)
        nodeTime:setAnchorPoint(CCPointMake(0, 0.5))
        nodeTime:setPosition(m_ptPos.rt)
        nodeTime:setTime(0)
        nodeTime:luasetSelectorOnClose(VanFood.EscortTimeEnd)
        wnd:addChild(nodeTime)
    end
    
    local btnLose = SCButton:button(1)    
    if btnLose then
        btnLose:setTag(25)
        btnLose:setContentSize(AUTO_SIZE(50, 26))
        btnLose:setAnchorPoint(CCPointMake(0.5, 0.5))
        btnLose:setPosition(m_ptPos.lb)
        btnLose:setTitle(L("str20172"), getDefaultFontName(), F(13))
        btnLose:luaSetSelectorOnClicked(VanFood.onBtnClick)
        wnd:addChild(btnLose)
    end
    
    local btnLeft = SCButton:button(1)
    if btnLeft then
        btnLeft:setTag(26)
        btnLeft:setContentSize(AUTO_SIZE(50, 26))
        btnLeft:setAnchorPoint(CCPointMake(0.5, 0.5))
        btnLeft:setPosition(m_ptPos.rb)
        btnLeft:setTitle(L("str20172"), getDefaultFontName(), F(13))
        btnLeft:luaSetSelectorOnClicked(VanFood.onBtnClick)
        wnd:addChild(btnLeft)
    end
    
    local btnFast = SCButton:button(1)
    if btnFast then
        btnFast:setTag(27)
        btnFast:setContentSize(AUTO_SIZE(40, 26))
        btnFast:setAnchorPoint(CCPointMake(0.5, 0.5))
        btnFast:setPosition(m_ptPos.a)
        btnFast:setTitle(">>>", getDefaultFontName(), F(13))
        btnFast:luaSetSelectorOnClicked(VanFood.onBtnClick)
        btnFast:setVisible(false)
        wnd:addChild(btnFast)
    end
    return wnd
end

function VanFood.CreatePhotoBtn(id)
    st = {"img/new00627.pn", "img/new00630.pn", "img/new00629.pn", "img/new00628.pn"}--龙将、剑舞、箭神、军师
    if not m_stEnemyList[id] then return end 
    
    local path = st[1]
    if m_stEnemyList[id].ucClan > 4 or m_stEnemyList[id].ucClan <= 0 then
        path = st[1]
    elseif m_stEnemyList[id].ucClan then
        path = st[m_stEnemyList[id].ucClan]
    end
    if path then
        path = RES(path)
    end
    local btn = SCButton:button()    
    if btn then
        btn:setTag(m_stEnemyList[id].idPlayer)
        local pathNormal = RES("img/new00002.pn")
        local pathSelect = RES("img/new00003.pn")
        if pathNormal and pathSelect then            
            btn:setBackgroundImage(pathNormal)
            btn:setSelectedImage(pathSelect)
        end
        
        if path then 
            local img = SCImage:imageWithFile(path)
            if img then
                img:setAnchorPoint(CCPointMake(0.5, 0))
                img:setPosition(btn:getContentSize().width / 2, SY(5))
                btn:addChild(img)
            end
        end
        --[[
        local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1018, 1018);--光圈
        local pAnimationNode
        if pAi then
            pAnimationNode =  SCAnimationNode:nodeWithAnimation(pAi);
            if pAnimationNode then
                pAnimationNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                local size = btn:getContentSize();
                pAnimationNode:setPosition(CCPointMake(size.width / 2, size.height / 2));
                btn:addChild(pAnimationNode);
            end
        end
        --]]
        local num = 0
        local bShow = true
        if m_stEnemyList[id].nEnemyTime <= 0 then
            bShow = false            
        end
        if bShow then            
            local nodeTime = CountDownNode:newCountDownNode(DisplayTimeType_Minute_Second, 9)
            if nodeTime then
                nodeTime:setAnchorPoint(CCPointMake(0.5, 0))
                nodeTime:setPosition(btn:getContentSize().width / 2, SY(-18))
                nodeTime:setTag(1)           
                nodeTime:setTime(m_stEnemyList[id].nEnemyTime)            
                nodeTime:luasetSelectorOnClose(VanFood.EnemyTimeEnd)
                btn:addChild(nodeTime)
                nodeTime:setVisible(bShow)            
                nodeTime:setBackgroundColor(ccc4(0, 0, 0, 160))
            end
        end
        local nodePlayer = SCFunction:getUiNodeByIdlist("9110-1-"..m_stEnemyList[id].idPlayer)
        local str = L("str20169")
        if nodePlayer then
            str = L("str20159")..L("str20139")
            num = 1
        end
        if bShow then
            str = L("str20170")
            num = 1
        end
        local labelState = SCLabel:labelWithStringFont(str, getDefaultFontName(), F(9))
        if labelState then
            labelState:setAnchorPoint(CCPointMake(0.5, 0))
            labelState:setPosition(btn:getContentSize().width / 2, SY(-8))
            labelState:setTag(11)
            btn:addChild(labelState)                
            labelState:setVisible(true)
            labelState:setBackgroundColor(ccc4(0, 0, 0, 160))
            if pAnimationNode then 
                pAnimationNode:setVisible(false)
            end
        end
        
        if num > 0 then
            local imgPath = getRealUIResourcePath("img/new00544.png")
            local pImage = nil
            if imgPath and pBtn then
                pImage = SCImage:imageWithFile(imgPath:getData())
                if pImage then
                    pImage:setTag(3300);
                    pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pImage:setPosition(AUTO_POS(-3.00, 30.00))
                    pImage:setContentSize(AUTO_SIZE(14.00, 14.00))
                    btn:addChild(pImage);
                end
            end
            local pLabel = SCLabel:labelWithStringFont(num.."", DEFAULT_FONT_NAME, F(10))
            if pLabel and pImage then
                pLabel:setAnchorPoint(CCPointMake(0.5, 0))
                pLabel:setPosition(CCPointMake(pImage:getContentSize().width/2 + SX(1), SY(7)))
                pImage:addChild(pLabel);
            end
        end
    end
    
    return btn
end
--玩法说明提示窗口
function VanFood.CreateTipWnd()
    local pframeWnd = FrameWindow:frameWnd();
    if pframeWnd then
        local szWnd = CCSizeMake(SX(300), SY(200))
        pframeWnd:setTag(1000)
        pframeWnd:setContentSize(szWnd);
        pframeWnd:setAnchorPoint(CCPointMake(0.5, 0.5));
        pframeWnd:setOutSpaceClickClose(true)

        local pTextBox = SCTextBox:boxWithWidthHeightFont(szWnd.width - SX(40), SY(160), DEFAULT_FONT_NAME, F(15))
        if pTextBox then            
            pTextBox:setPosition(szWnd.width / 2, szWnd.height / 2)
            pTextBox:setAnchorPoint(CCPointMake(0.5, 0.5))
            pTextBox:setParserDelegate(TextParser:getSingleton())
            pTextBox:setText(L("str20173"))
            pframeWnd:addChild(pTextBox)
        end
        pframeWnd:setCloseBtnVisible(false);
    end
    
    return pframeWnd
end
function VanFood.EnemyTimeEnd()    
    local parent = SCFunction:getUiNodeByIdlist("9110-51")
    if parent then
        for i = 1, #m_stEnemyList do
            local node = SCTypeCast:castNodeToCountDownNode(SCFunction:getUiNodeByIdlistAndParent(m_stEnemyList[i].idPlayer.."-1", parent))
            if node then
                if node:getCurTime() == 0 then
                    node:setVisible(false)                    
                    if m_stEnemyList[i].nEnemyTime == 0 then
                        
                    else
                        m_stEnemyList[i].nEnemyTime = 0                        
                    end                    
                    --table.remove(m_stEnemyList, i)                    
                end
            end
        end
    end
    VanFood.UpdateWindow()
end
---------------------选择护送详情界面-----------------------------------------------------------
local m_nCurFoodIndex
local m_idTimer
local m_ucRefreshType
local m_idFoodSel
local m_nSelFoodIndex
local m_nCurTurn
local m_fSpeed

function Escort.OpenEscortInfoWnd()
    local wndCtrl = getCurentSceneWindowController(9111)
    if not wndCtrl then
        local wnd = Escort.CreateEscortWnd()
        if wnd then
            wndCtrl = SCWindowController:controllerWithWindow(wnd)
            if wndCtrl then
                PUSH_CTRL(wndCtrl)                
                
                Escort.SetFoodNode()
                Escort.UpdateWindow()
            end
        end
    end
end

function Escort.onCloseWnd()
    m_nCurFoodIndex = nil
    m_ucRefreshType = nil
    m_idFoodSel = nil
    m_nSelFoodIndex = nil
    m_nCurTurn = nil
    m_fSpeed = nil
    if m_idTimer then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_idTimer)
        m_idTimer = nil
    end
end

function Escort.onBtnClick(tag)
    if tag == 102 then --refresh
        if m_nSelFoodIndex == 5 then
            showMessage("*6"..L("str20136"))
            return
        end
        
        local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("9111-4-102"))
        local btnStart = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("9111-4-103"))
        if btn and btnStart then
            if m_ucRefreshType == 1 then
                btn:setTitle(L("str20150"), getDefaultFontName(), F(15))
                btn:setButtonType(3)
                btnStart:setButtonType(3)
            else
                btn:setTitle(L("str0138")..L("str0168"), getDefaultFontName(), F(15))
                btn:setButtonType(1)
            end
        end
        
        if m_ucRefreshType == 1 then
            local tipNode = SCFunction:getUiNodeByIdlist("9111-4-102-1000")
            if tipNode then
                tipNode:removeFromParentAndCleanup(true)
            end
            m_fSpeed = 0.05
            m_idTimer = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(Escort.SelectFoodType, m_fSpeed, false)
            Escort.SendRefresh()
            OpenUnClickLayer()
        else
            --luashowConfirmationWindow(L("str20141"), WIN_YES_NO, VanFood.returnRefreshEscort)
            --m_nReturnType = 1
            if Hero:getSingleton():getEmoney() >= 10 then
                Escort.SendRefresh()
            else
                luashowConfirmationWindowPoint(L("str0439"), nil, L("str20030"), WIN_NULL, ShowFastLittleVip5TipOK, ShowFastLittleVip5TipCancel, 1)
            end
        end        
    elseif tag == 103 then --start
       if m_nSelFoodIndex > 5 or m_nSelFoodIndex < 1 then
            showMessage(L("str20128"))
            return
        end
        POP_TOP_CTRL()
        Escort.SendStartEscort()
        VanFood.UpdateBottomTime()
    elseif tag == 205 then --summon
        if m_nSelFoodIndex == 5 then
            showMessage("*6"..L("str20136"))
            return
        end
        
        if Hero:getSingleton():getEmoney() < 100 then
            luashowConfirmationWindowPoint(L("str0439"), nil, L("str20030"), WIN_NULL, ShowFastLittleVip5TipOK, ShowFastLittleVip5TipCancel, 1)
        else
            luashowConfirmationWindow(L("str20142"), WIN_YES_NO, VanFood.returnRefreshEscort)
            m_nReturnType = 2
        end
        --Escort.SendRefreshMax()
    end    
end

function Escort.onBtnFood(tag)
    local parent = SCFunction:getUiNodeByIdlist("9111")
    if not parent then return end 
    
    local st = m_stEscortList[tag]
    if st then
        local wnd = FrameWindow:frameWnd()
        if wnd then
            local szWnd = AUTO_SIZE(280, 130)
            wnd:setOutSpaceClickClose(true)
            wnd:setCloseBtnVisible(false)
            wnd:setContentSize(szWnd)
            wnd:setAnchorPoint(ANCHOR_CENTER)
            wnd:setPosition(parent:getContentSize().width / 2, parent:getContentSize().height / 2)
            parent:addChild(wnd)
            
            local stTitle = {"*0"..L("str20118"), "*3"..L("str20119"), "*8"..L("str20120"), "*7"..L("str20121"), "*6"..L("str20122")}
            local stPath = {"escort/new00838.pn", "escort/new00837.pn", "escort/new00836.pn", "escort/new00835.pn", "escort/new00840.pn"}
            local path = RES(stPath[st.usEscortType])
            if path then
                local img = SCImage:imageWithFile(path)
                if img then
                    img:setAnchorPoint(CCPointMake(0, 0.5))
                    img:setPosition(SX(5), szWnd.height / 2)
                    wnd:addChild(img)
                end
            end
            
            local str = "*5"..L("str20129")..":_*5"..L("str20130")..":_ _*5"
            if st.idAwardItemtype > 0 then
                str = str..L("str20114")..":"
            end
            local parseNode = getItemTextNode(str, 0, 13)
            if parseNode then
                parseNode:setPosition(SX(115), szWnd.height - SY(30))
                parseNode:setAnchorPoint(CCPointMake(0, 1))
                parseNode:setPerWidthAndHeight(13, 18)
                wnd:addChild(parseNode)
            end
            local str = "*5"..st.nNeedTimes..L("str20137")
            if st.nMoneyBase > 0 then
                str = str .."_*5"
                local lev = Hero:getSingleton():getLeval()
                str = str..st.nMoneyBase + lev * math.floor(st.nCoefficient / 1000) ..L("str5171")--[[L("str0139")--]]
            end            
            if st.nAwardReputation > 0 then
                str = str.."_*5"
                str = str..st.nAwardReputation..L("str0193")
                bNewLine = true
            end            
            if st.nCurrency1 and st.nCurrency1 > 0 then
                str = str.."_*5"
                str = str..st.nCurrency1..L("str5171")            
            end            
            if st.idAwardItemtype > 0 then
                str = str.."_*5"
                local item = TableParser:getSingleton():getItemInfoByKey(st.idAwardItemtype)
                if item then
                    str = str..item.name:getData()
                end
            end
            local parseNode = getItemTextNode(str, 0, 13)
            if parseNode then
                parseNode:setPosition(SX(182), szWnd.height - SY(30))
                parseNode:setAnchorPoint(CCPointMake(0, 1))
                parseNode:setPerWidthAndHeight(13, 18)
                wnd:addChild(parseNode)
            end
        end
    end
end

function Escort.SelectFoodType()
    local nodeUp = SCFunction:getUiNodeByIdlist("9111-1")
    if not nodeUp then return end 
    
    if not m_nCurFoodIndex then
        m_nCurFoodIndex = 0
    end
    if not m_nCurTurn then
        m_nCurTurn = 1
    end
    local cur = m_nCurFoodIndex
    local count = m_nCurTurn
    m_nCurFoodIndex = m_nCurFoodIndex + 1
    if m_nCurFoodIndex > 5 then
        m_nCurFoodIndex = 1
        count = count + 1
    end
    local next = m_nCurFoodIndex    
    
    local stPathSel = {"escort/new00838.pn", "escort/new00837.pn", "escort/new00836.pn", "escort/new00835.pn", "escort/new00840.pn"}
    local stPathNor = {"escort/new00848.pn", "escort/new00847.pn", "escort/new00846.pn", "escort/new00845.pn", "escort/new00849.pn"}
    local nodeCur = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(cur.."-"..cur, nodeUp))
    local nodeNext = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(next.."-"..next, nodeUp))
    local pathNormal = RES(stPathNor[cur])--RES("img/new00305.pn")
    local pathSelect = RES(stPathSel[next])--RES("img/new00081.pn")
    if nodeCur then
        nodeCur:setTitle(pathNormal)        
    end
    if nodeNext then
        nodeNext:setTitle(pathSelect)
    end
    
    m_nCurTurn = count
    local bClose
    if count and count >= 3 then
        if m_idTimer then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_idTimer)                
        end
        
        if m_fSpeed < 0.5 then
            m_fSpeed = m_fSpeed + 0.1
        end
        m_idTimer = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(Escort.SelectFoodType, m_fSpeed, false)
        if m_nCurFoodIndex == m_nSelFoodIndex then-----------            
            if m_fSpeed >= 0.5 then
                if m_nCurFoodIndex == m_nSelFoodIndex then 
                    bClose = true
                    local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("9111-4-102"))
                    if btn then
                        btn:setTitle(L("str0138")..L("str0168"), getDefaultFontName(), F(15))
                        btn:setButtonType(1)
                    end
                    local btnStart = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("9111-4-103"))
                    if btnStart then
                        btnStart:setButtonType(1)
                    end
                    Escort.ShowFoodEffect(0, m_nSelFoodIndex)
                    --local stTitle = {"*0"..L("str20118"), "*3"..L("str20119"), "*8"..L("str20120"), "*7"..L("str20121"), "*6"..L("str20122")}
                    --showMessage("*3"..string.format(L("str20149"), stTitle[m_nSelFoodIndex]))
                end
            end            
        else
            if count > 6 then
                bClose = true
                local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("9111-4-102"))
                if btn then
                    btn:setTitle(L("str0138")..L("str0168"), getDefaultFontName(), F(15))
                    btn:setButtonType(1)
                end
                local btnStart = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("9111-4-103"))
                if btnStart then
                    btnStart:setButtonType(1)
                end
            end
        end
    end    
    if bClose then
        if m_idTimer then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_idTimer)                
        end
        local node = SCFunction:getUiNodeByIdlist("9111-9111")
        if node then
            node:removeFromParentAndCleanup(true)
        end
        Escort.SetBottomContent(m_nSelFoodIndex)
        local img = SCFunction:getUiNodeByIdlist("9111-4-102-1")
        if img then
            img:setVisible(true)
        end
        local label = SCFunction:getUiNodeByIdlist("9111-4-102-2")
        if label then
            label:setVisible(true)
        end
        
        m_idTimer = nil
        m_nCurTurn = nil
        CloseUnClickLayer()
    end
end

function Escort.UpdateWindow()
    local nodeUp = SCFunction:getUiNodeByIdlist("9111-1")
    if not nodeUp then return end 
    
    local stPathSel = {"escort/new00838.pn", "escort/new00837.pn", "escort/new00836.pn", "escort/new00835.pn", "escort/new00840.pn"}
    local stPathNor = {"escort/new00848.pn", "escort/new00847.pn", "escort/new00846.pn", "escort/new00845.pn", "escort/new00849.pn"}
    for i = 1, 5 do
        local nodeCur = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("9111-1-"..i.."-"..i))
        if nodeCur then
            local pathNormal = RES(stPathNor[i])
            local pathSelect = RES(stPathSel[i])
            
            if m_nSelFoodIndex == i and pathSelect then
                nodeCur:setTitle(pathSelect)
            elseif pathNormal then
                nodeCur:setTitle(pathNormal)
            end
        end
    end
    local labelYB = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("9111-71"))
    if labelYB then
        local yb = Hero:getSingleton():getEmoney()
        labelYB:setText(yb.."")
    end
    Escort.SetButtonType()
    Escort.SetBottomContent(m_nSelFoodIndex)
end
function Escort.SetButtonType(type)
    local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("9111-4-102"))
    if btn then
        local str = L("str0138")
        if m_nSelFoodIndex > 5 or m_nSelFoodIndex < 1 then
            GuidePoint_createRightGuideNode(btn)
        end
        if m_ucRefreshType == 1 then            
            local img = btn:getChildByTag(1)
            if img then
                img:setVisible(false)
            end
            local img = btn:getChildByTag(2)
            if img then
                img:setVisible(false)
            end
            str = L("str20127")
            if node then
                node:setVisible(false)
            end
        else
            if type ~= 1 then
                btn:setTitle(str..L("str0168"), getDefaultFontName(), F(15))
                local img = btn:getChildByTag(2)
                if img then
                    img:setVisible(true)
                end
                local img = btn:getChildByTag(1)
                if img then
                    img:setVisible(true)
                end
            end
        end                     
    end
    local btnEscort = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("9111-4-103"))
    if btnEscort then        
        if type ~= 1 then
            if m_nSelFoodIndex > 5 or m_nSelFoodIndex < 1 then
                btnEscort:setButtonType(3)
            else
                btnEscort:setButtonType(1)
            end
        end
    end
end
function Escort.onItemTip(tag)
    if m_nSelFoodIndex and m_stEscortList[m_nSelFoodIndex] then
        if m_stEscortList[m_nSelFoodIndex].idAwardItemtype > 0 then
            showTip(m_stEscortList[m_nSelFoodIndex].idAwardItemtype)
        end
    end
end

function Escort.SetBottomContent(index)
    if not index then return end 
    
    local labelTime = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("9111-3-11"))
    local labelReward = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("9111-3-12"))
    local labelExtra = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("9111-3-13"))
    local labelBox = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("9111-3-52"))
    if labelTime and labelReward and labelExtra and labelBox then  
        if index > 0 and index <= 5 then
            local st = m_stEscortList[index]
            if not st then return end 
            
            labelTime:setText(st.nNeedTimes..L("str20137"))
            local bNewLine = false
            if st.nMoneyBase > 0 then
                local lev = Hero:getSingleton():getLeval()
                local str = st.nMoneyBase + lev * math.floor(st.nCoefficient / 1000) ..L("str5171")--[[L("str0139")--]]
                labelReward:setText(str)
                labelExtra:setText("")
                bNewLine = true
            end
            --[[if st.nCurrency1 and st.nCurrency1 > 0 then
                if bNewLine then
                    labelExtra:setText(st.nCurrency1..L("str5171"))
                else
                    labelReward:setText(st.nCurrency1..L("str5171"))
                end                
            end--]]
            
            if st.nAwardReputation > 0 then
                if bNewLine then
                    labelExtra:setText(st.nAwardReputation..L("str0193"))
                else
                    bNewLine = true
                    labelReward:setText(st.nAwardReputation..L("str0193"))
                end
            end            
            
            local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("9111-3-51"))
            if btn then
                if st.idAwardItemtype > 0 then
                    local item = TableParser:getSingleton():getItemInfoByKey(st.idAwardItemtype)                    
                    if item then 
                        local path
                        if item.icon ~= 0 then
                            path = RES("item/"..item.icon..".jp")
                        else
                            path = RES("img/ItemTemp.pn")
                        end 
                        if path then
                            btn:setTitle(path)                            
                            btn:luaSetSelectorOnClicked(Escort.onItemTip)
                        end
                        labelBox:setText(item.name:getData())
                    end
                else
                    local path = RES("img/new00259.pn")
                    if path then
                        btn:setTitle(path)
                    end 
                    labelBox:setText(L("str20131"))                    
                end
            end            
        else
            labelTime:setText(L("str20128"))
            labelReward:setText(L("str20128"))
        end
    end
end
----
function Escort.CreateEscortWnd()
    local wnd = SCWindow:window()
    if not wnd then return end 
    
    local szWnd = AUTO_SIZE(480, 320)
    wnd:setTag(9111)
    wnd:setContentSize(szWnd)
    wnd:luaSetSelectorOnClose(Escort.onCloseWnd)
    
    local path = RES("escort/new00841.pn")
    if path then
        local nodeBg = SCImage:imageWithFile(path)
        if nodeBg then            
            wnd:addChild(nodeBg)
        end
    end
    
    local pathTitle = RES("escort/new00834.pn")
    if pathTitle then
        local img = SCImage:imageWithFile(pathTitle)
        if img then
            img:setAnchorPoint(CCPointMake(0, 1))
            img:setPosition(SX(20), szWnd.height - SY(10))
            wnd:addChild(img)
            --wnd:setTitleWithImage(pathTitle)
        end
    end
    
    local w = SX(5)
    local szUp = CCSizeMake(szWnd.width - w * 2, SY(160))
    local szLR = CCSizeMake(SX(140), SY(128))
    local szCenter = CCSizeMake(szUp.width - (szLR.width * 2 + w), szLR.height)
    local top = SY(30)
    local ptY = szWnd.height - top - szUp.height    
     
    local nodeUp = SCDragNode:node()
    if nodeUp then
        nodeUp:setTag(1)
        nodeUp:setFrameVisibled(true)
        nodeUp:setFrameType(1)
        nodeUp:setContentSize(szUp)
        nodeUp:setPosition(w, ptY)
        wnd:addChild(nodeUp)
        
        local label = SCLabel:labelWithStringFont(L("str20126"), getDefaultFontName(), F(10))
        if label then
            label:setAnchorPoint(CCPointMake(0.5, 0))
            label:setPosition(szUp.width/ 2, SY(15))
            label:setColor(color_green)
            nodeUp:addChild(label)
        end
    end
        
    local nodeBottom = SCDragNode:node()
    if nodeBottom then
        nodeBottom:setFrameType(1)
        nodeBottom:setFrameVisibled(true)
        nodeBottom:setPosition(w, SY(5))
        nodeBottom:setContentSize(CCSizeMake(szUp.width, szLR.height))
        wnd:addChild(nodeBottom)
    end
    
    ptY = SY(5)
    local nodeLeft = SCDragNode:node()
    if nodeLeft then
        nodeLeft:setTag(2)
        --nodeLeft:setFrameVisibled(true)
        --nodeLeft:setFrameType(0)
        nodeLeft:setContentSize(szLR)
        nodeLeft:setPosition(w, ptY)
        wnd:addChild(nodeLeft)
        
        local label = SCLabel:labelWithStringFont(L("str20113"), getDefaultFontName(), F(10))
        if label then
            label:setAnchorPoint(CCPointMake(0.5, 0.5))
            label:setPosition(szLR.width / 2, szLR.height / 2)
            label:setColor(color_orange)
            nodeLeft:addChild(label)
        end
    end
    
    local nodeCenter = SCDragNode:node()
    if nodeCenter then
        nodeCenter:setTag(3)
        --nodeCenter:setFrameVisibled(true)
        --nodeCenter:setFrameType(0)
        nodeCenter:setContentSize(szCenter)
        nodeCenter:setAnchorPoint(CCPointMake(0.5, 0))
        nodeCenter:setPosition(szWnd.width / 2, ptY)
        wnd:addChild(nodeCenter)
        
        local space = SX(15)
        local labelTime = SCLabel:labelWithStringFont(L("str20129")..":", getDefaultFontName(), F(13))
        if labelTime then
            labelTime:setColor(color_lightYellow)
            labelTime:setPosition(space, szLR.height - SY(30))
            nodeCenter:addChild(labelTime)
        end
        
        local labelAward = SCLabel:labelWithStringFont(L("str20130")..":", getDefaultFontName(), F(13))
        if labelAward then
            labelAward:setColor(color_lightYellow)
            labelAward:setPosition(space, szLR.height - SY(45))
            nodeCenter:addChild(labelAward)
        end
        
        local label = SCLabel:labelWithStringFont(L("str20128"), getDefaultFontName(), F(13))
        if label then
            label:setTag(11)
            label:setPosition(space + SX(60), szLR.height - SY(30))
            nodeCenter:addChild(label)
        end
        local label = SCLabel:labelWithStringFont(L("str20128"), getDefaultFontName(), F(13))
        if label then
            label:setTag(12)
            label:setPosition(space + SX(70), szLR.height - SY(45))
            nodeCenter:addChild(label)
        end
        local label = SCLabel:labelWithStringFont(L(" "), getDefaultFontName(), F(13))
        if label then
            label:setTag(13)
            label:setPosition(space + SX(70), szLR.height - SY(60))
            nodeCenter:addChild(label)
        end
        local pathNormal = RES("img/new00002.pn")
        local pathSelect = RES("img/new00003.pn")
        local btnY = SY(50)
        local btn = SCButton:button()
        if pathNormal and pathSelect and btn then
            btn:setTag(51)
            btn:setBackgroundImage(pathNormal)
            btn:setSelectedImage(pathSelect)
            btn:setAnchorPoint(CCPointMake(0, 0.5))
            btn:setPosition(space, btnY)
            nodeCenter:addChild(btn)
            
            local path = RES("img/new00259.pn")
            if path then
                btn:setTitle(path)
            end
        end
        
        local text = SCText:textWithWidthFont(szCenter.width - SX(80), getDefaultFontName(), F(13))
        if text then
            text:setTag(21)
            text:addNormalText(L("str20117"), color_orange)            
            text:setPosition(CCPointMake(SX(70), btnY + SY(15)))
            nodeCenter:addChild(text)
        end
        
        local label = SCLabel:labelWithStringFont(L("str20131"), getDefaultFontName(), F(10))
        if label then
            label:setTag(52)
            label:setColor(color_orange)
            label:setAnchorPoint(CCPointMake(0.5, 0))
            if btn then
                label:setPosition(CCPointMake(space + btn:getContentSize().width / 2, SY(13)))
            end
            nodeCenter:addChild(label)
        end
    end
    local path = RES("img/new00218.pn")
    if path then
        for i = 1, 2 do 
            local img = SCImage:imageWithFile(path)
            if img then
                img:setRotation(90)
                img:setScaleX(0.3)
                img:setAnchorPoint(CCPointMake(0.5, 0.5))
                img:setPosition(szWnd.width / 2 - (1.5 - i) * (szCenter.width + SY(10)), ptY + szLR.height / 2)
                wnd:addChild(img)
            end
        end
    end
    
    local nodeRight = SCDragNode:node()
    if nodeRight then
        nodeRight:setTag(4)
        --nodeRight:setFrameVisibled(true)
        --nodeRight:setFrameType(0)
        nodeRight:setContentSize(szLR)
        nodeRight:setPosition(szWnd.width - w - szLR.width, ptY)
        wnd:addChild(nodeRight)
        
        local btn = SCButton:button(1)
        if btn then
            btn:setContentSize(AUTO_SIZE(80, 30))
            btn:setAnchorPoint(CCPointMake(0.5, 0.5))
            btn:setPosition(szLR.width / 2, szLR.height / 2 + SY(20))
            btn:luaSetSelectorOnClicked(Escort.onBtnClick)
            btn:setTag(102)
            btn:setTitle(L("str20127")..L("str0168"), getDefaultFontName(), F(15))
            nodeRight:addChild(btn)
            
            local path = RES("img/new00544.pn")
            if path then
                local img = SCImage:imageWithFile(path)
                if img then
                    btn:addChild(img)
                    img:setTag(1)
                    img:setAnchorPoint(CCPointMake(0.5, 0))
                    img:setPosition(btn:getContentSize().width - SX(20), btn:getContentSize().height - SY(8))
                    img:setVisible(false)
                    img:setScaleX(2)                    
                end
            end
            local label = SCLabel:labelWithStringFont("10"..L("str0138"), getDefaultFontName(), F(9))
            if label then
                btn:addChild(label)                    
                label:setAnchorPoint(CCPointMake(0.5, 0))
                label:setPosition(btn:getContentSize().width - SX(21), btn:getContentSize().height - SY(1))
                label:setTag(2)
            end
        end        
        
        local btnStart = SCButton:button(1)
        if btnStart then
            btnStart:setContentSize(AUTO_SIZE(80, 40))
            btnStart:setAnchorPoint(CCPointMake(0.5, 0.5))
            btnStart:setPosition(szLR.width / 2, szLR.height / 2 - SY(20))
            btnStart:luaSetSelectorOnClicked(Escort.onBtnClick)
            btnStart:setTag(103)
            btnStart:setTitle(L("str20125"), getDefaultFontName(), F(15))
            nodeRight:addChild(btnStart)
        end
    end   
    
    local path = RES("img/2001008.pn")
    if path then
        img = SCImage:imageWithFile(path)
        if img then
            img:setAnchorPoint(CCPointMake(0.5, 0.5))
            img:setPosition(AUTO_POS(350, 300))
            img:setScale(0.7)
            wnd:addChild(img)
        end
    end
    local path = RES("img/new00001.pn")
    if path then
        img = SCImage:imageWithFile(path)
        if img then
            img:setAnchorPoint(CCPointMake(0, 0.5))
            img:setPosition(AUTO_POS(370, 300))
            img:setScaleX(0.7)
            wnd:addChild(img)
        end
    end
    local yb = Hero:getSingleton():getEmoney()
    local label = SCLabel:labelWithStringFont(yb.."", getDefaultFontName(), F(15))
    if label then
        label:setTag(71)
        label:setAnchorPoint(CCPointMake(0, 0.5))
        label:setPosition(AUTO_POS(375, 300))
        wnd:addChild(label)
    end
    return wnd
end

function Escort.ShowFoodEffect(index, CurSel)
    local wnd = SCFunction:getUiNodeByIdlist("9111")
    if not wnd then return end 
    
    if not index then
        index = 0
    end
    if not CurSel then
        CurSel = 0
    end
    local node = ActionNode:newActionNode()
    if node then
        wnd:addChild(node)
        node:setAnchorPoint(ANCHOR_CENTER)        
        node:setContentSize(AUTO_SIZE(100, 30))
        node:setAutoRemove(true)
        node:setPosition(AUTO_POS(240, 160))
        node:moveTo(AUTO_POS(240, 310), 2, true)
        local stTitle = {"*0"..L("str20118"), "*3"..L("str20119"), "*8"..L("str20120"), "*7"..L("str20121"), "*6"..L("str20122")}
        local str = ""
        if index >= CurSel then
            str = L("str20148")
        else
            str = "*3"..string.format(L("str20149"), stTitle[CurSel])
        end
        local dragNode = SCDragNode:node()
        if dragNode then            
            node:addChild(dragNode)
        
            local parseNode = getItemTextNode(str)
            if parseNode then
                local sz = parseNode:getContentSize()
                dragNode:setFrameType(EnumFrameTypeLine)
                dragNode:setFrameVisibled(true)
                dragNode:setDragEnabled(false)
                dragNode:setContentSize(CCSizeMake(sz.width + SX(12), sz.height + SY(20)))                
                dragNode:addChild(parseNode)
                
                parseNode:setAnchorPoint(ANCHOR_CENTER)
                parseNode:setPosition(dragNode:getContentSize().width / 2, dragNode:getContentSize().height / 2)
                node:setContentSize(dragNode:getContentSize())
            end
        end
    end
end

function Escort.SetFoodNode()
    local nodeUp = SCFunction:getUiNodeByIdlist("9111-1")
    if not nodeUp then return end 
    
    local space = SX(20)
    local szUp = nodeUp:getContentSize()
    local szCell = CCSizeMake((szUp.width - space * 2) / 5, szUp.height)
    local stTitle = {"*0"..L("str20118"), "*3"..L("str20119"), "*8"..L("str20120"), "*7"..L("str20121"), "*6"..L("str20122")}
    --local stPath = {"escort/new00838.pn", "escort/new00837.pn", "escort/new00836.pn", "escort/new00835.pn", "escort/new00840.pn"}
    local stPath = {"escort/new00848.pn", "escort/new00847.pn", "escort/new00846.pn", "escort/new00845.pn", "escort/new00849.pn"}
    for i = 1, 5 do 
        local pa = RES("img/new00305.pn")
        if pa then
            local img = SCImage:imageWithFile(pa)
            if img then
                img:setTag(10 + i)
                img:setAnchorPoint(CCPointMake(0.5, 0))
                local offset = SX(0)
                if i == 2 then
                    offset = -SX(5)
                elseif i == 3 then
                    offset = -SX(5)
                elseif i == 4 then
                    offset = -SX(5)
                end
                img:setPosition(space + szCell.width * (i - 0.5) + offset, SY(40))
                img:setScale(0.8)
                nodeUp:addChild(img)
            end
        end
        
        local node = SCNode:node()
        if node then
            node:setContentSize(szCell)
            node:setTag(i)
            node:setAnchorPoint(CCPointMake(0.5, 0))            
            if i == 3 then
                node:setPosition(space + szCell.width * (i - 0.5) - SX(15), 0)
            else
                node:setPosition(space + szCell.width * (i - 0.5), 0)
            end
            
            nodeUp:addChild(node)                    
            local label = getItemTextNode(stTitle[i], 0, 12)
            if label then
                label:setAnchorPoint(CCPointMake(0.5, 0.5))                
                if i == 3 then
                    label:setPosition(szCell.width / 2 + SX(10), szCell.height - SY(20))
                else
                    label:setPosition(szCell.width / 2, szCell.height - SY(20))
                end
                node:addChild(label)
            end
            
            local path = RES(stPath[i])
            if path then                
                local btn = SCButton:button()                
                if btn then
                    btn:setTag(i)
                    btn:setAnchorPoint(CCPointMake(0.5, 0))
                    btn:setPosition(szCell.width / 2, SY(40))
                    btn:luaSetSelectorOnClicked(Escort.onBtnFood)
                    btn:setTitle(path)
                    btn:setScale(0.8)
                    node:addChild(btn)
                end
            end
        end
    end
    
    local path = RES("escort/new00843.pn")
    local btn = SCButton:button()
    if btn and path then
        btn:setAnchorPoint(ANCHOR_CENTER)
        btn:setTag(205)
        btn:luaSetSelectorOnClicked(Escort.onBtnClick)
        btn:setPosition(space + szCell.width * 4.5, SY(35))
        btn:setTitle(path)
        nodeUp:addChild(btn)
    end
end
--------------------------------拦截UI--------------------------------------------------------------------------
local m_stPlayerSel
local m_bRobBack
local m_bEnemySel
function RobFood.OpenMainWnd(stPlayer, bReback, bEnemy)
    --[[if m_stPlayerSel.nSupTime - m_nTimeCount < 0 then--test
        m_stPlayerSel = nil
        return 
    end]]    
    local wndCtrl = getCurentSceneWindowController(9112)
    if not wndCtrl then
        m_stPlayerSel = stPlayer    
        m_bRobBack = bReback
        m_bEnemySel = bEnemy
        if not m_stPlayerSel then
            m_stPlayerSel = nil
            m_bRobBack = nil
            m_bEnemySel = nil
            return
        end
        local wnd = RobFood.CreateRobWnd()
        if wnd then
            wndCtrl = SCWindowController:controllerWithWindow(wnd)
            if wndCtrl then
                PUSH_CTRL(wndCtrl)
                wnd:setBackButtonVisibled(false)
                wnd:setFrameVisibled(false)
                wnd:setCloseButtonVisibled(false)
                --wnd:setAutoCloseOnTouchSpace(true)
                RobFood.SetBtnList()
            end
        end
    else
        RobFood.UpdateWindow()
    end
end

function RobFood.onCloseWnd()
    POP_TOP_CTRL()
    m_stPlayerSel = nil
    m_bRobBack = nil
    m_bEnemySel = nil
end

function RobFood.onBtnClick(tag)
    if tag == 102 then --info
        if m_stPlayerSel then
            ViewPlayInfo_sendData(m_stPlayerSel.idPlayer, 0, "")
        end
    elseif tag == 101 then --rob
        if m_stPlayerSel then
            if m_bRobBack then
                GuidePoint_LuaAddCount(20, 3)
                VanFood.SendRobBack(m_stPlayerSel.idPlayer)
            else
                RobList:SendRobFood(m_stPlayerSel.idPlayer)
            end
        end
    end
    RobFood.onCloseWnd()
end

function RobFood.onBtnSpeedUp(tag)
    --showMessage(L("str20171"))    
    
    if m_nLootCD and m_nLootCD > 0 then
        VanFood.SendLootUpSpeed(0)
    elseif m_stPlayerSel.nSupLootTimes == 2 then
        showMessage(L("str20171"))
    elseif m_nSupLootTimes <= 0 then
        showMessage(L("str20160"))
    end
end

function RobFood.SetBtnList()
    local wnd = SCFunction:getUiNodeByIdlist("9112")
    if not wnd then return end 
    
    local szWnd = wnd:getContentSize()
    local bRobEnable = true
    if not m_bRobBack then
        if m_nLootCD and m_nLootCD > 0 or m_stPlayerSel.nSupLootTimes == 2 or m_nSupLootTimes <= 0 then
            bRobEnable = nil
        end    
    end
    if m_stPlayerSel.idPlayer == Hero:getSingleton():getID() then
        return
    end
    
    local btnRob = SCButton:button(1)
    if btnRob then
        btnRob:setTag(101)
        btnRob:setAnchorPoint(CCPointMake(0.5, 0))
        if m_bRobBack then
            --btnRob:setPosition(szWnd.width / 2 + SX(50), SY(15))
            btnRob:setTitle(L("str20145"), getDefaultFontName(), F(15))
        else
            --btnRob:setPosition(szWnd.width / 2, SY(15))
            btnRob:setTitle(L("str20139"), getDefaultFontName(), F(15))
        end
        if bRobEnable then
            btnRob:luaSetSelectorOnClicked(RobFood.onBtnClick)            
        else
            btnRob:luaSetSelectorOnClicked(RobFood.onBtnSpeedUp)
            btnRob:setButtonType(3)
        end
        btnRob:setPosition(szWnd.width / 2 + SX(60), SY(15))
        btnRob:setContentSize(AUTO_SIZE(70, 30))        
        wnd:addChild(btnRob)
    end
        
    local btnInfo = SCButton:button(1)
    if btnInfo then
        btnInfo:setTag(102)
        btnInfo:setAnchorPoint(CCPointMake(0.5, 0))
        btnInfo:setPosition(szWnd.width / 2 - SX(50), SY(15))
        --[[if bRobEnable then
            btnInfo:setPosition(szWnd.width / 2 - SX(50), SY(15))
        else
            btnInfo:setPosition(szWnd.width / 2, SY(15))
        end--]]
        btnInfo:setContentSize(AUTO_SIZE(130, 30))
        btnInfo:setTitle(L("str20140")..L("str0129"), getDefaultFontName(), F(15))
        btnInfo:luaSetSelectorOnClicked(RobFood.onBtnClick)
        wnd:addChild(btnInfo)
    end
end
function RobFood.UpdateWindow()
    local bRobEnable = true
    local nTipType = 0
    if not m_bRobBack then
        if m_nLootCD and m_nLootCD > 0 or m_stPlayerSel.nSupLootTimes == 2 or m_nSupLootTimes <= 0 then
            bRobEnable = nil            
        end    
    end
    local btnRob = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("9112-101"))
    if btnRob then
        if m_bRobBack then            
            btnRob:setTitle(L("str20145"), getDefaultFontName(), F(15))
        else            
            btnRob:setTitle(L("str20139"), getDefaultFontName(), F(15))
        end
        if bRobEnable then
            btnRob:luaSetSelectorOnClicked(RobFood.onBtnClick)
            btnRob:setButtonType(1)
        else
            btnRob:luaSetSelectorOnClicked(RobFood.onBtnSpeedUp)
            btnRob:setButtonType(3)
        end
    end
end

function RobFood.CreateRobWnd()
    local wnd = SCWindow:window()
    if not wnd then return end 
    
    local szWnd = AUTO_SIZE(280, 200)
    if m_stPlayerSel.idPlayer == Hero:getSingleton():getID() then
        szWnd = AUTO_SIZE(280, 170)        
    end
    wnd:setTag(9112)    
    wnd:setContentSize(szWnd)
            
    local nodeBg = SCDragNode:node()
    if nodeBg then
        nodeBg:setContentSize(szWnd)
        nodeBg:setFrameVisibled(true)
        nodeBg:setFrameType(1)
        wnd:addChild(nodeBg)
        
        local pathCloseNormal = RES("kernal/close-normal.pn")
        local pathCloseSelect = RES("kernal/close-selected.pn")
        if pathCloseNormal and pathCloseSelect then
            local btnClose = SCButton:button()
            if btnClose then
                btnClose:setBackgroundImage(pathCloseNormal)
                btnClose:setSelectedImage(pathCloseSelect)
                btnClose:luaSetSelectorOnClicked(RobFood.onCloseWnd)
                btnClose:setAnchorPoint(CCPointMake(1, 1))
                btnClose:setPosition(szWnd.width - SX(7), szWnd.height - SY(7))
                btnClose:setMusicPath("closeWindow.mp3");
                --btnClose:setTouchRectScale(4, 4)
                nodeBg:addChild(btnClose, 1)
            end
        end
    end
    
    local path = RES("kernal/redtop.pn")
    if path then
        local img = SCImage:imageWithFile(path)
        if img then
            img:setAnchorPoint(CCPointMake(0.5, 1))
            img:setPosition(szWnd.width / 2, szWnd.height)
            wnd:addChild(img)
            
            local str = L("str20118")
            if m_stPlayerSel.usEscortType then
                str = L("str201"..m_stPlayerSel.usEscortType + 17)
            end
            if m_bRobBack and m_stPlayerSel.szName then
                str = m_stPlayerSel.szName
            end
            local label = SCLabel:labelWithStringFont(str, getDefaultFontName(), F(15))
            if label then
                label:setAnchorPoint(CCPointMake(0.5, 0.5))
                label:setPosition(img:getContentSize().width / 2, img:getContentSize().height / 2)
                label:setColor(color_orange)
                img:addChild(label)
            end
        end
    end
    local path = RES("img/new00305.pn")
    if path then
        local node = SCImage:imageWithFile(path)
        if node then            
            node:setAnchorPoint(CCPointMake(0, 0))
            node:setPosition(SX(30), szWnd.height - SY(130))
            wnd:addChild(node)
            
            local stPath = {"escort/new00838.pn", "escort/new00837.pn", "escort/new00836.pn", "escort/new00835.pn", "escort/new00840.pn"}
            local path = RES(stPath[5])
            if m_stPlayerSel then
                if m_stPlayerSel.usEscortType then
                    path = RES(stPath[m_stPlayerSel.usEscortType])
                    if path then
                        local img = SCImage:imageWithFile(path)
                        if img then
                            img:setAnchorPoint(CCPointMake(0.5, 0))
                            img:setPosition(node:getContentSize().width / 2, 0)
                            node:addChild(img)
                        end   
                    end             
                else
                    --龙将、剑舞、箭神、军师
                    local stPhoto = {111010, 141010, 121010, 131010}
                    local nPhoto = 0
                    if m_stPlayerSel.ucClan then
                        nPhoto = stPhoto[m_stPlayerSel.ucClan]                    
                    end
                    local ani = SCLookfaceParser:getSingleton():getAnimationByLookfaceAndIndex(nPhoto, dirAction_Stand)
                    if ani then
                        ani:setFrameAnchor(EnumFrameAnchorFoot);
                        local pLookNode = SCAnimationNode:nodeWithAnimation(ani);
                        if pLookNode then
                            pLookNode:setAnchorPoint(CCPointMake(0.5, 0));
                            pLookNode:setPosition(node:getContentSize().width / 2, 0 + node:getContentSize().height / 2 - SY(5))                        
                            node:addChild(pLookNode);
                        end
                    end
                end
            end            
        end
    end    
    
    local strName = L("str20115")    
    local str = L("str20116")
    local strEx = L("str20133")
    if m_bRobBack then
        strName = L("str20155")
        str = L("str20146")
        strEx = L("str20154")
    end    
    if m_stPlayerSel.idPlayer == Hero:getSingleton():getID() then
        strEx = L("str20153")
    end

    stName = {strName, L("str0306"), str, L("str8020"), strEx}
    local nodeInfo = SCNode:node()
    if nodeInfo then
        nodeInfo:setTag(1)
        nodeInfo:setPosition(SX(120), szWnd.height - SY(30))
        nodeInfo:setAnchorPoint(CCPointMake(0, 1))
        wnd:addChild(nodeInfo)
        local szNode = AUTO_SIZE(120, 90)
        nodeInfo:setContentSize(szNode)
        for i = 1, #stName do
            local labelName = SCLabel:labelWithStringFont(stName[i]..":", getDefaultFontName(), F(13))
            if labelName then
                nodeInfo:addChild(labelName)
                labelName:setColor(color_orange)
                labelName:setPosition(0, szNode.height - SY(20) * (i - 1))
                labelName:setAnchorPoint(CCPointMake(0, 1))
            end
            
            if i == 1 then
                local label = SCLabel:labelWithStringFont(m_stPlayerSel.szName, getDefaultFontName(), F(13))
                if label then
                    label:setAnchorPoint(CCPointMake(0, 1))
                    label:setPosition(SX(75), szNode.height - SY(20) * (i - 1))
                    label:setColor(color_orange)
                    nodeInfo:addChild(label)
                end
            elseif i == 2 then
                local lev = 1
                if m_stPlayerSel.nUserLev then
                    lev = m_stPlayerSel.nUserLev
                elseif m_stPlayerSel.nPlayerLev then
                    lev = m_stPlayerSel.nPlayerLev
                end
                local label = SCLabel:labelWithStringFont(lev.."", getDefaultFontName(), F(13))
                if label then
                    label:setAnchorPoint(CCPointMake(0, 1))
                    label:setPosition(SX(75), szNode.height - SY(20) * (i - 1))
                    label:setColor(color_orange)
                    nodeInfo:addChild(label)
                end
            elseif i == 3 then
                --test
                local str = ""
                if m_bRobBack then
                    str = m_stPlayerSel.szTribe
                else
                    str = m_stPlayerSel.nSupLootTimes
                    if str < 0 then
                        str = 0
                    end
                    str = str .. "/2"
                end
                local label = SCLabel:labelWithStringFont(str, getDefaultFontName(), F(13))                
                if label then
                    label:setAnchorPoint(CCPointMake(0, 1))
                    label:setPosition(SX(75), szNode.height - SY(20) * (i - 1))
                    label:setColor(color_orange)
                    nodeInfo:addChild(label)
                end
            elseif i == 4 then
                local label = CountDownNode:newCountDownNode(DisplayTimeType_Minute_Second, 13)
                if label then
                    label:setAnchorPoint(CCPointMake(0, 1))
                    label:setPosition(SX(75), szNode.height - SY(20) * (i - 1))
                    local nSubTime = 0
                    local node
                    if m_bRobBack then
                        node = SCTypeCast:castNodeToCountDownNode(SCFunction:getUiNodeByIdlist("9110-51-"..m_stPlayerSel.idPlayer.."-1"))
                    else
                        node = SCTypeCast:castNodeToCountDownNode(SCFunction:getUiNodeByIdlist("9110-1-"..m_stPlayerSel.idPlayer.."-1"))
                    end
                    if node then
                        nSubTime = node:getCurTime()
                    end
                    label:setTime(nSubTime)
                    label:setColor(color_orange)
                    label:luasetSelectorOnClose(RobFood.onCloseWnd)
                    nodeInfo:addChild(label)
                end
            elseif i == 5 then                
                local str = "*5"
                local bNewLine                
                if m_stPlayerSel.nEnemyMoney > 0 then
                    local nMoney = m_stPlayerSel.nEnemyMoney
                    if m_stPlayerSel.idPlayer ~= Hero:getSingleton():getID() then
                        if not m_bEnemySel then
                            nMoney = math.floor(nMoney / 10)                        
                        end
                    else
                        local sub = 0
                        if m_stPlayerSel.nSupLootTimes then
                            sub = m_stPlayerSel.nSupLootTimes
                        end
                        nMoney = nMoney - math.floor(nMoney / 10) * sub
                    end                    
                    str = str..nMoney..L("str5171")--L("str0139")
                    bNewLine = true
                end
                if m_stPlayerSel.nEnemyReputation > 0 then
                    if bNewLine then
                        str = str.."_*5"
                    end
                    local nEnemyReputation = m_stPlayerSel.nEnemyReputation
                    if m_stPlayerSel.idPlayer ~= Hero:getSingleton():getID() then                        
                        if not m_bEnemySel then
                            nEnemyReputation = math.floor(nEnemyReputation / 10)                        
                        end                        
                    else
                        if m_stPlayerSel.nSupLootTimes then
                            nEnemyReputation = nEnemyReputation - math.floor(nEnemyReputation / 10) * m_stPlayerSel.nSupLootTimes
                        end
                    end
                    str = str..nEnemyReputation..L("str0193")
                end                
                local label = getItemTextNode(str, 0, 13)
                if label then
                    label:setAnchorPoint(CCPointMake(0, 1))
                    label:setPosition(SX(65), szNode.height - SY(20) * (i - 1) + SY(2))
                    nodeInfo:addChild(label)
                end
            end
        end
    end
    
    return wnd
end
-----------------------------------栏截列表UI-------------------------------------------------------------------------------------
local m_stRanRobList = nil
function RobList.OpenMainWnd()
    m_stRanRobList = VanFood_GetRandomEnemyList()
    local wndCtrl = getCurentSceneWindowController(9113)
    if not wndCtrl then
        local wnd = RobList.CreateListWnd()
        if wnd then
            wndCtrl = SCWindowController:controllerWithWindow(wnd)
            if wndCtrl then
                PUSH_CTRL(wndCtrl)
                wnd:setFrameVisibled(false)
                wnd:setBackButtonVisibled(false)
                wnd:setCloseButtonVisibled(false)
                
                RobList.UpdateWindow()
            end
        end 
    else
        RobList.UpdateWindow()
    end
end

function RobList.onCloseWnd()
    POP_TOP_CTRL()
    m_stRanRobList = nil
end

function RobList.UpdateWindow()
    local pageBox = SCFunction:getUiNodeByIdlist("9113-1")
    if pageBox then
        pageBox:removeAllChildrenWithCleanup(true)
        local pageNum = 0
        for i = 1, #m_stRanRobList do
            pageNum = math.floor((i + 4) / 5)
            local page = pageBox:getChildByTag(pageNum)
            if not page then               
                page = SCNode:node()
                if page then
                    page:setTag(pageNum)
                    pageBox:addChild(page)
                    page:setPosition(pageBox:getWidth() * (pageNum - 1) - SX(5), 0)
                end                
            end
            local node = RobList.CreateItemNode(i)
            if node and page then
                node:setPosition(SX(95) * math.floor((i + 4) % 5), 0)                
                page:addChild(node)
            end
        end
        if pageNum > 0 then
            pageBox:setContentSize(CCSizeMake(pageNum * pageBox:getWidth(), pageBox:getHeight()))
        end
    end
end

function RobList.onBtnClick(tag)
    if m_stRanRobList[tag] then
        RobList:SendRobFood(m_stRanRobList[tag].idPlayer)
    end
    POP_TOP_CTRL()
end

function RobList.CreateListWnd()
    local wnd = SCWindow:window()
    if not wnd then return end 
    
    local szWnd = AUTO_SIZE(480, 320)
    wnd:setTag(9113)
    wnd:setContentSize(szWnd)
    
    local nodeBg = SCDragNode:node()
    if nodeBg then
        nodeBg:setContentSize(szWnd)
        nodeBg:setFrameVisibled(true)
        nodeBg:setFrameType(EnumFrameTyperedwindowstip)
        wnd:addChild(nodeBg)
    end
    
    local pathCloseNormal = RES("kernal/close-normal.pn")
    local pathCloseSelect = RES("kernal/close-selected.pn")
    if pathCloseNormal and pathCloseSelect then
        local btnClose = SCButton:button()
        if btnClose then
            btnClose:setBackgroundImage(pathCloseNormal)
            btnClose:setSelectedImage(pathCloseSelect)
            btnClose:luaSetSelectorOnClicked(RobList.onCloseWnd)
            btnClose:setAnchorPoint(CCPointMake(1, 1))
            btnClose:setPosition(szWnd.width, szWnd.height)
            btnClose:setMusicPath("closeWindow.mp3");
            btnClose:setTouchRectScale(4.0,4.0)
            btnClose:setScale(0.7)
            wnd:addChild(btnClose, 1)
        end
    end
    
    local path = RES("kernal/redtop.pn")
    if path then
        local bgTitle = SCImage:imageWithFile(path)
        if bgTitle then
            bgTitle:setAnchorPoint(CCPointMake(0.5, 1))
            bgTitle:setPosition(szWnd.width / 2, szWnd.height)
            wnd:addChild(bgTitle)
        end
        
        local path = RES("escort/new00839.pn")
        if path then
            local img = SCImage:imageWithFile(path)
            if img then
                img:setAnchorPoint(CCPointMake(0.5, 0.5))
                img:setPosition(bgTitle:getContentSize().width / 2, bgTitle:getContentSize().height / 2)
                bgTitle:addChild(img)
            end
        end
    end
    
    local pageBox = SCPageScrollBox:boxWithWidthHeight(SX(470), SY(250))
    if pageBox then
        pageBox:setTag(1)
        pageBox:setPosition(SX(5), SY(45))
        pageBox:setScrollVertical(false)
        pageBox:setScrollHorizontal(true)
        pageBox:setPageSize(CCSizeMake(SX(470), SY(250)));
        wnd:addChild(pageBox)
        
        local pageHint = SCPageHint:hintWithType(EnumPgaeHintTypeHorizontal)
        if pageHint then
            pageHint:setBoundPageScrollBox(pageBox)
            pageHint:setAnchorPoint(CCPointMake(0.5, 0.5))
            pageHint:setPosition(szWnd.width / 2, SY(35))
            wnd:addChild(pageHint)
        end        
    end
    
    local labelTip = SCLabel:labelWithStringFont(L("str20134"), getDefaultFontName(), F(12))
    if labelTip then
        labelTip:setColor(color_green)
        labelTip:setAnchorPoint(ANCHOR_CENTER)
        labelTip:setPosition(szWnd.width / 2, SY(15))
        wnd:addChild(labelTip)
    end
    
    return wnd 
end

function RobList.CreateItemNode(tag)
    if not tag then return end 
    
    local node = SCDragNode:node()
    if not node then return end 
    
    local szCell = AUTO_SIZE(99, 248)
    node:setContentSize(szCell)
    node:setFrameVisibled(true)
    node:setFrameType(1)
    node:setTag(tag)
    
    local st = m_stRanRobList[tag]
    local labelName = SCLabel:labelWithStringFont(st.szName, getDefaultFontName(), F(12))
    if labelName then
        node:addChild(labelName)
        
        if VanFood_GetIsEnemy(st.idPlayer) then
            labelName:setColor(color_red)
        else
            labelName:setColor(color_orange)
        end
        labelName:setAnchorPoint(CCPointMake(0.5, 0))
        labelName:setPosition(szCell.width / 2, SY(218))        
    end 
    
    local lev = 1
    if st.nUserLev then
        lev = st.nUserLev
    end
    local labelLev = SCLabel:labelWithStringFont(lev .. L("str0266"), getDefaultFontName(), F(12))
    if labelLev then
        if VanFood_GetIsEnemy(st.idPlayer) then
            labelLev:setColor(color_red)
        else
            labelLev:setColor(color_orange)
        end
        labelLev:setAnchorPoint(CCPointMake(0.5, 0))
        labelLev:setPosition(szCell.width / 2, SY(203))
        node:addChild(labelLev)
    end
    
    local stPath = {"escort/new00838.pn", "escort/new00837.pn", "escort/new00836.pn", "escort/new00835.pn", "escort/new00840.pn"}
    local bgPath = RES("img/new00305.pn")
    if bgPath then
        local img = SCImage:imageWithFile(bgPath)
        if img then
            img:setAnchorPoint(CCPointMake(0.5, 0))
            img:setPosition(szCell.width / 2, SY(120))
            node:addChild(img)
        end
    end
    local path = RES(stPath[st.usEscortType])
    if path then
        local img = SCImage:imageWithFile(path)
        if img then
            img:setAnchorPoint(CCPointMake(0.5, 0))
            img:setPosition(szCell.width / 2, SY(120))
            node:addChild(img)
        end
    end
    
    local y = SY(100)
    local h = SY(18)
    local nRobTime = 0
    if st.nSupLootTimes then
        nRobTime = st.nSupLootTimes
    end
    local labelRob = SCLabel:labelWithStringFont(string.format(L("str20132"), nRobTime, 2), getDefaultFontName(), F(12))
    if labelRob then
        labelRob:setAnchorPoint(CCPointMake(0.5, 0))
        labelRob:setPosition(szCell.width / 2, y)        
        node:addChild(labelRob)
    end
    
    local labelInfo = SCLabel:labelWithStringFont(L("str20133"), getDefaultFontName(), F(12))
    if labelInfo then
        labelInfo:setAnchorPoint(CCPointMake(0.5, 0))
        labelInfo:setPosition(szCell.width / 2, y - h)
        labelInfo:setColor(color_green)
        node:addChild(labelInfo)
    end
    
    local labelMoney = SCLabel:labelWithStringFont(math.floor(st.nEnemyMoney / 10) .. L("str5171")--[[L("str0139")--]], getDefaultFontName(), F(12))
    if labelMoney then
        labelMoney:setAnchorPoint(CCPointMake(0.5, 0))
        labelMoney:setPosition(szCell.width / 2, y - 2 * h)
        labelMoney:setColor(color_green)
        node:addChild(labelMoney)
    end
    
    local labelExtra = SCLabel:labelWithStringFont(math.floor(st.nEnemyReputation / 10)..L("str0193"), getDefaultFontName(), F(12))
    if labelExtra then
        labelExtra:setAnchorPoint(CCPointMake(0.5, 0))
        labelExtra:setPosition(szCell.width / 2, y - 3 * h)
        labelExtra:setColor(color_green)
        node:addChild(labelExtra)
    end
    
    local btn = SCButton:button(1)
    if btn then
        btn:setContentSize(AUTO_SIZE(60, 26))
        btn:setTag(tag)
        btn:setTitle(L("str20139"), getDefaultFontName(), F(12))
        btn:setAnchorPoint(CCPointMake(0.5, 0))
        btn:setPosition(szCell.width / 2, SY(10))
        btn:luaSetSelectorOnClicked(RobList.onBtnClick)
        node:addChild(btn)
    end
    
    return node
end
-----------------------消息处理区------------------------
function VanFood.SendOpenMainWnd()
    GuidePoint_LuaAddCount(20, 1)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ESCORTTYPE);
    dataStream:writeShort(ESCORT_ESCORT_OPENINFO);    
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();    
end
--加速　护送
function VanFood.SendUpSpeed(type)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ESCORTTYPE);
    dataStream:writeShort(ESCORT_ESCORT_SPEED_UP);    
    dataStream:writeByte(type)
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end
--清除抢夺失败CD
function VanFood.SendLootUpSpeed(type)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ESCORTTYPE);
    dataStream:writeShort(ESCORT_ESCORT_LOOT_SPEED_UP);    
    dataStream:writeByte(type)
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end

function VanFood.SendInitData()
    if m_initOpened then return end 
    
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ESCORTTYPE);
    dataStream:writeShort(ESCORT_ESCORT_INFO_ALL);     
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end
--夺回
function VanFood.SendRobBack(id)
    if not id then return end 
    
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ESCORTTYPE);
    dataStream:writeShort(ESCORT_ESCORT_RETACK);
    dataStream:writeInt(id)
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end
function VanFood.SendCloseWnd()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ESCORTTYPE);
    dataStream:writeShort(ESCORT_ESCORT_CLOSE);
    SCDataTransThread:getSingleton():transData(dataStream);
end
--仇人信息
function VanFood.RecvEnemyUserInfo(dt)
    m_nSupEscortTimes = dt:readInt()
    m_nSupLootTimes = dt:readInt()
    m_nLootCD = dt:readInt()--test
    m_bRobTimeUpdate = true
    local amount = dt:readByte()
    m_stEnemyList = {}
    for i = 1, amount do
        table.insert(m_stEnemyList, struEnemyUserInfo.initStream(dt))
    end
    
    if getCurentSceneWindowController(9112) then
        RobFood.UpdateWindow()
    end
end
--全部玩家信息
function VanFood.RecvPlayerInfo(dt)
    if m_bStreamEnd then
        m_stPlayerList = {}
        m_bStreamEnd = nil
    end
    local ucAmount = dt:readByte()
    for i = 1, ucAmount do
        table.insert(m_stPlayerList, EscortUserInfo.initStream(dt))
    end   
end
--更新
function VanFood.RecvUpdateData(dt, action) 
    VanFood.AddTimeExtra()
    if action == ESCORT_ESCORT_INFO_ADD then
        local stPath = {"escort/new00838.pn", "escort/new00837.pn", "escort/new00836.pn", "escort/new00835.pn", "escort/new00840.pn"}
        local ucAmount = dt:readByte()
        for i = 1, ucAmount do
            local tmp = EscortUserInfo.initStream(dt)
            table.insert(m_stPlayerList, tmp)            
            VanFood.AddItemAction(tmp)
        end       
    elseif action == ESCORT_ESCORT_INFO_UPDATE then
        local idPlayer = dt:readInt()    
        local nSupLootTimes = dt:readInt()
        for i = 1, #m_stPlayerList do
            if m_stPlayerList[i].idPlayer == idPlayer then
                m_stPlayerList[i].nSupLootTimes = 2 - nSupLootTimes
                break
            end
        end
    elseif action == ESCORT_ESCORT_INFO_DEL then
        local idPlayer = dt:readInt()        
        for i = 1, #m_stPlayerList do
            if m_stPlayerList[i].idPlayer == idPlayer then
                table.remove(m_stPlayerList, i)
                if m_ptPlayerPos[idPlayer] then
                    m_ptPlayerPos[idPlayer] = nil
                end
                break
            end
        end
        local node = SCFunction:getUiNodeByIdlist("9110-1-"..idPlayer)
        if node then
            node:removeFromParentAndCleanup(true)
        end
        --[[local wndList = SCFunction:getUiNodeByIdlist("9113")
        if wndList then
            RobList.OpenMainWnd()
        end]]
        if idPlayer == Hero:getSingleton():getID() then
            local nodeBg = SCFunction:getUiNodeByIdlist("9110-1-8888")
            if nodeBg then
                nodeBg:removeFromParentAndCleanup(true)
            end
            local nodeDown = SCFunction:getUiNodeByIdlist("9110-1-8889")
            if nodeDown then
                nodeDown:removeFromParentAndCleanup(true)
            end
        end
    end    
    VanFood.AddTimeExtra()
    VanFood.UpdateWindow()
end
-----------------------escort-----------
---刷新押镖--------
function Escort.SendRefresh()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ESCORTTYPE);
    dataStream:writeShort(ESCORT_ESCORT_INFO_REFRESH);    
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end
--召唤
function Escort.SendRefreshMax()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ESCORTTYPE);
    dataStream:writeShort(ESCORT_ESCORT_REFRESH_MAX);    
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end
--开始押镖
function Escort.SendStartEscort()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ESCORTTYPE);
    dataStream:writeShort(ESCORT_ESCORT_START);    
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end
function Escort.SendOpenWnd()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ESCORTTYPE);
    dataStream:writeShort(ESCORT_ESCORT_INFO);    
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end
--押镖信息
function Escort.RecvEnvoyInfo(dt)
    m_ucRefreshType = dt:readByte()
    m_nSelFoodIndex = dt:readShort()
    local ucAmount = dt:readByte()
    m_stEscortList = {}
    for i = 1, ucAmount do
        table.insert(m_stEscortList, stEscortEnvoyInfo.initStream(dt))
    end
    m_nCurFoodIndex = m_nSelFoodIndex
end

----------------robList--------------------------
--抢夺
function RobList:SendRobFood(idPlayer)
    if m_nSupLootTimes and m_nSupLootTimes <= 0 then
        showMessage(L("str20160"))
        return;
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ESCORTTYPE);
    dataStream:writeShort(ESCORT_ESCORT_LOOT);    
    dataStream:writeInt(idPlayer)
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end
------------------------------------------------
function VanFood.ClearData()
    m_stEnemyList = {}    --仇人
    m_stPlayerList = {}   --玩家
    m_stEscortList = {}   --押镖
    m_ptPlayerPos = {}
    if m_idTimerPlayer then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_idTimerPlayer)
        m_idTimerPlayer = nil
    end
    while getCurentSceneWindowController(9110) do
        POP_TOP_CTRL()
    end
end
function VanFood.ReadData()    
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if not dt then return end 
    
    local action = dt:readShort()
    if action == ESCORT_ESCORT_INFO then --押镖信息
        Escort.RecvEnvoyInfo(dt)
        Escort.OpenEscortInfoWnd()        
    elseif action == ESCORT_ESCORT_USERCUR_INFO then --玩家当前的押镖信息 
        local type = m_ucRefreshType
        local index = m_nSelFoodIndex
        m_ucRefreshType = dt:readByte()
        m_nSelFoodIndex = dt:readShort()
        if type == 0 or (type > 0 and m_nSelFoodIndex == 5) then
            Escort.UpdateWindow()
        elseif type > 0 and type <= 5 then
            Escort.SetButtonType(type)
            return
        end
        Escort.ShowFoodEffect(index, m_nSelFoodIndex)
    elseif action == ESCORT_ESCORT_INFO_ADD then    --添加
        VanFood.RecvUpdateData(dt, action)
    elseif action == ESCORT_ESCORT_INFO_DEL then --del
        VanFood.RecvUpdateData(dt, action)
    elseif action == ESCORT_ESCORT_INFO_UPDATE then--update
        VanFood.RecvUpdateData(dt, action)
    elseif action == ESCORT_ESCORT_OPENINFO then   --打开护送界面
        if not getCurentSceneWindowController(9110) then
            m_bFirstOpenMainWnd = true
        end
        VanFood.RecvEnemyUserInfo(dt)
        VanFood.AddTimeExtra()
        VanFood.OpenMainWnd()
        VanFood.UpdateEscortAction()
    elseif action == ESCORT_ESCORT_INFO_ALL or action == ESCORT_ESCORT_INFO_ALL_END then--
        --m_initOpened = true
        VanFood.RecvPlayerInfo(dt)
        VanFood.UpdateEscortAction()
        if action == ESCORT_ESCORT_INFO_ALL_END then
            m_bStreamEnd = true
            VanFood.AddTimeExtra()
            VanFood.UpdateBottomTime()
            VanFood.OpenEscortWndEnable()
            VanFood.UpdateWindow()
        end
    elseif action == ESCORT_ESCORT_INFO_CLEAR then
        VanFood.ClearData()
    elseif action == ESCORT_ESCORT_LOOTED_MESG then        
        OpenMailTip()        
    end
    SCActivityIndicator:getSingleton():close();
end
-----------------------消息注册区------------------------
SCMessageCenter:getSingleton():luaRegistCommand(VanFood.ReadData, _MSG_ESCORTTYPE, 0, nil)
-----------------------全局函数区------------------------
function VanFood_OpenVanFoodWnd()    
    --VanFood.OpenMainWnd()
    VanFood.SendOpenMainWnd()
    VanFood.SendInitData()    
end
--引导使用
function VanFood_GetEnemyIdWithPos(pos)
    if m_stEnemyList[pos] then
        return m_stEnemyList[pos].idPlayer
    end
end
--活动结束，押送军粮界面关闭
function VanFood_CloseEscortWnd()
    VanFood.ClearData()
end