--定义一个与文件名相同的table
WingsShop = {}
------------------消息--------------------
_MSG_EXCHANGESHOP		=   _MSG_GENERAL + 615		---兑换商店
EXCHANGESHOPACT_ADD     =   2
EXCHANGESHOPACT_BUY     =   3
EXCHANGESHOPACT_END     =   4
EXCHANGESHOPACT_BUY_EMONEY_GOOD = 5
SHOP_ARTIFACT           =   6  						--神器
EXCHANGESHOPACT_BUY_EMONEY_GOOD_SUCCESS = 6   		--商店购买成功
EXCHANGESHOPACT_BUY_HERO = 7 						--兑换武将

----------------结构定义区----------------
local stExchangeGood = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idGoodType = dt:readInt();      --//idItemType
        tmp.dwCost = dt:readInt();          --//消耗物品id
        tmp.usPosition = dt:readShort();    --//位置
        tmp.usCostNum = dt:readShort();     --//消耗物品数量
        return tmp
    end
}

local MSG_Info1 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nType = dt:readInt();       --//商店类型
        local str = dt:readString();    --//商店名称
        if str then
            tmp.szShop = str:getData();
        else
            tmp.szShop = "";
        end
        tmp.ucAmount = dt:readByte();   --//数量
        tmp.setExchangeGood = {__mode = "kv"};
        for i = 1, tmp.ucAmount do
            table.insert(tmp.setExchangeGood, stExchangeGood.initWithStream(dt));
        end
        return tmp;
    end
}

----------------变量定义------------------
local m_goodsInfo = {__mode = "kv"};
local m_selectGoodPos = nil
local m_nSelectBuyPos = nil

----------------常量定义区----------------


----------------函数回调------------------
---窗口释放---
function WingsShop.releaseControl()
	m_goodsInfo = {__mode = "kv"};
	m_selectGoodPos = nil
	m_nSelectBuyPos = nil
	WingsShop1.releaseControl()
	WingsShop2.releaseControl()
	local wnd = SCFunction:getUiNodeByIdlist("7034");
    if wnd then
		wings_refreshWnd()
    end
end

---页面选择---
function WingsShop.onClickedMultiPage()
end

----------------UI控制器区----------------
function WingsShop.initControl()
	local pWindow11004 = SCWindow:window()
	if pWindow11004 then
		pWindow11004:setTag(11004)
		pWindow11004:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow11004:setPosition(AUTO_POS(0.00, 0.00))
		local pImgPath = getRealUIResourcePath("1.6/wenzi/new00891.png")
		if pImgPath then
			pWindow11004:setTitleWithImage(pImgPath:getData())
		end
		pWindow11004:setContentSize(AUTO_SIZE(480, 320))
		pWindow11004:luaSetSelectorOnClose(WingsShop.releaseControl)
	end

	local pMultiPage1 = SCMultiPage:pageWithType(EnumMultiPageTypeLarge)
	if pMultiPage1 then
		pMultiPage1:setTag(1)
		pMultiPage1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pMultiPage1:setPosition(AUTO_POS(0.00, 0.00))
		pMultiPage1:setContentSize(AUTO_SIZE(480, 320))
		local pageImg = {"1.6/wenzi/new00892.png", "1.6/wenzi/new00893.png"}
		for i = 1, 2 do
			local pNode = SCNode:node()
			if pNode then
				pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)				   
				pNode:setPosition(ANCHOR_LEFT_BOTTOM)
				pMultiPage1:addPage(pNode)
				local imgPath = getRealUIResourcePath(pageImg[i])				   
				if imgPath then
					pMultiPage1:setTitleAtPage(imgPath:getData(), i - 1)
				end
			end
		end
	end

	if pMultiPage1 and pWindow11004 then
		pWindow11004:addChild(tolua.cast(pMultiPage1, "SCNode"))
	end
	
	return pWindow11004
end

function WingsShop.init()
	local pWnd = getCurentSceneWindow(11004)
	if not pWnd then return end
	
	local isSendReqMsg = false
	
    local pMultiPage = SCTypeCast:castNodeToMultiPage(pWnd:getChildByTag(1))
    if pMultiPage then
        pMultiPage:luaSetSelectorOnPageSelected(WingsShop.onClickedMultiPage)
        local pNode = pMultiPage:getPageWithIndex(0)
        if pNode then
			--窗口不存在，发请求消息
			local pChildNode = pNode:getChildByTag(1)
			if not pChildNode then
				isSendReqMsg = true
			end
			
			pChildNode = WingsShop1.initControl()
            if pChildNode then
                pChildNode:setPosition(CCPointMake(SX(0), SY(0)))
                pNode:addChild(pChildNode)
            end
        end
        
        local pNode = pMultiPage:getPageWithIndex(1)
        if pNode then
            local pChildNode = WingsShop2.initControl()
            if pChildNode then
                pChildNode:setPosition(CCPointMake(SX(0), SY(0)))
                pNode:addChild(pChildNode)
            end
        end
    end
    
    --获取商店消息
    if isSendReqMsg then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_EXCHANGESHOP)
		dataStream:writeByte(EXCHANGESHOPACT_ADD)
		dataStream:writeInt(SHOP_ARTIFACT)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show()
	end
end
----------------消息处理区----------------
---商店消息接收---
function WingsShop.recvMsg()
	SCActivityIndicator:getSingleton():close()
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if not dt then return end
    
    local action = dt:readByte()
    if action == EXCHANGESHOPACT_ADD then
        WingsShop.addGoodsInfo(MSG_Info1.initWithStream(dt))
    elseif EXCHANGESHOPACT_END == action then
        WingsShop.addGoodsInfo(MSG_Info1.initWithStream(dt))
        if m_goodsInfo.nType == 9 then		--寻宝商店类型
			TreasureHunt2.recvMsg(m_goodsInfo)
			return
        end
        
        WingsShop1.seExchangeShopInfo()
		WingsShop2.seExchangeShopInfo()
    elseif   EXCHANGESHOPACT_BUY_EMONEY_GOOD_SUCCESS == action then   
        --wings1_emoney_buy_success()
        TreasureHunt2.refreshShopInfo()
        TreasureHunt1.setRechargeInfo()
    end
end

----------------逻辑功能区----------------
---增加物品---
function WingsShop.addGoodsInfo(tmp)
	m_goodsInfo.nType = tmp.nType
    m_goodsInfo.szShop = tmp.szShop
    if m_goodsInfo.ucAmount == nil then 
        m_goodsInfo.ucAmount = tmp.ucAmount
    else
        m_goodsInfo.ucAmount = m_goodsInfo.ucAmount + tmp.ucAmount
    end
    if m_goodsInfo.setExchangeGood == nil then
        m_goodsInfo.setExchangeGood = tmp.setExchangeGood
        return;
    end
    for i = 1, tmp.ucAmount do
		table.insert(m_goodsInfo.setExchangeGood, tmp.setExchangeGood[i])
    end
end

---返回商店信息---
function WingsShop.getInfo()
	return m_goodsInfo
end

----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(WingsShop.recvMsg, _MSG_EXCHANGESHOP, 0, nil)

----------------全局函数区----------------
function WingsShop.showTreasureHuntWnd()
	--删除活动框
	local node = SCFunction:getUiNodeByIdlist("5918-5932-10111-5999")
    if node then
        node:removeFromParentAndCleanup(true)
    end
    
    local wnd = WingsShop.initControl()
    if wnd then
        local wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
            WingsShop.init()
            return
        end
    end
end

function wingsShop_onClickShowWingsShop()
	WingsShop.showTreasureHuntWnd()
end