local MSG_MAPWORLD_AREA_INFO    = 4;            --/*世界地图区域信息*/
local MSG_MAPWORLD_AREA_DETAIL_INFO    = 5;    --/*各区域详细信息*/

local m_wnd = nil;
local m_WorldMapInfo = {__mode = "kv"};
local m_AreaMapInfo = {__mode = "kv"};
local m_pHeroNode = nil;
local m_pHero = nil;
local m_ActionNode = nil;
local m_lastClickTag = nil;
local m_pBtnUp = nil;
local m_pBtnDown = nil;
local isDirection = nil;
local m_wordInfo = {__mode = "kv"};
local m_pathfinding = nil;
local m_NewOpenAreaInfo = {
        __mode = "kv",
        idGroup;                --/*副本id*/
        nPhoto;                 --/*图标*/
        strName;                --/*名称*/
        usItemX;                --/*x*/
        usItemY;                --/*y*/
        ucFirstOpenFlag;
        usLightX;               --/*光效x*/
        usLightY;               --/*光效y*/
    }
local m_id = nil;
local m_photo = nil;
local m_nType = nil; --/*  0主动请求， 1 服务端主动下发*/

local stMapInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            idGroup,                --/*副本id*/
            nPhoto,                    --/*图标*/
            strName,                --/*名称*/
            usItemX,                --/*x*/
            usItemY,                --/*y*/
        }
        tmp.idGroup = dt:readInt();
        tmp.nPhoto = dt:readInt();
        local scStr = dt:readString()
        if scStr == nil then
            tmp.strName = ""
        else
            tmp.strName = scStr:getData()
        end
        tmp.usItemX = dt:readShort();   
        tmp.usItemY = dt:readShort();           
        return tmp
    end
}

local tMsg_SendWorldMap = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
		tmp.ucAmount = dt:readByte();
		tmp.stWorldMap = {__mode = "kv"};
		for i = 1, tmp.ucAmount do
		    table.insert(tmp.stWorldMap, stMapInfo.initWithStream(dt));
		end
        return tmp
    end
}

local stWorldAreaInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            idGroup;                --/*副本id*/
            nPhoto;                    --/*图标*/
            strName;                --/*名称*/
            usItemX;                --/*x*/
            usItemY;                --/*y*/
            ucFirstOpenFlag;
            usLightX;                --/*光效x*/
            usLightY;                --/*光效y*/
        }
        tmp.idGroup = dt:readInt();
        tmp.nPhoto = dt:readInt();
        local scStr = dt:readString()
        if scStr == nil then
            tmp.strName = ""
        else
            tmp.strName = scStr:getData()
        end
        tmp.usItemX = dt:readShort();   
        tmp.usItemY = dt:readShort();   
        tmp.ucFirstOpenFlag = dt:readByte();
        tmp.usLightX = dt:readShort();   
        tmp.usLightY = dt:readShort();  
        return tmp
    end
}

local function WorldMapWndClose(tag)
    m_pHeroNode = nil;
    m_pHero = nil;
    m_ActionNode = nil;
    m_lastClickTag = nil;
    m_pBtnUp = nil;
    m_pBtnDown = nil;
    m_NewOpenAreaInfo = {__mode = "kv"};
    if 1 == m_nType then
        m_WorldMapInfo = {__mode = "kv"};
        m_AreaMapInfo = {__mode = "kv"};
        m_wnd = nil;
    end
    m_id = nil;
    m_photo = nil;
    m_nType = nil;
    isDirection = nil;
end

local function onClickClose(tag)
    local naviCtrl = getCurentSceneNavigationController();
    if naviCtrl then
        naviCtrl:popWindowController();
    end
	Hero:getSingleton():cancelAutoFindRoad();
end

local function getMapUpID(id)
    for i = 1, #m_WorldMapInfo - 1 do
        if id == m_WorldMapInfo[i + 1].idGroup then
            return m_WorldMapInfo[i].idGroup;
        end
    end
    return 0;
end

local function getMapDownID(id)
    for i = 1, #m_WorldMapInfo - 1 do
        if id == m_WorldMapInfo[i].idGroup then
            return m_WorldMapInfo[i + 1].idGroup;
        end
    end
    return 0;
end

local function sendQueryAreaMap(id)
    m_AreaMapInfo = {__mode = "kv"};
    local dt = SCDataTransStream:streamWithCommand(_MSG_MAPWORLD_INFO);
    if dt then        
        dt:writeShort(MSG_MAPWORLD_AREA_DETAIL_INFO);
        dt:writeInt(id);
        SCDataTransThread:getSingleton():transData(dt);
        if GameCommonMsgRecive:getSingleton():getMapID() ~= id then
            SCActivityIndicator:getSingleton():show();
        end
    end
    MainInterface_hideBtn(true);
end

local function onClickUp(tag)
    local id = getMapUpID(m_wnd:getTag());
    if id == 0 then
        return ;
    end
    sendQueryAreaMap(id);
end

local function onClickDown(tag)
    local id = getMapDownID(m_wnd:getTag());
    if id == 0 then
        return ;
    end
    sendQueryAreaMap(id);
end

local function onMoveEnd()
    local pAniRun = SCLookfaceParser:getSingleton():getAnimationByLookfaceAndIndex(Hero:getSingleton():getLookFace(), dirAction_Stand);
    if pAniRun and m_pHero then
        if isDirection == true then
            pAniRun:setTransMirror(false);
        else
            pAniRun:setTransMirror(true);
        end
        m_pHero:setAnimation(pAniRun);
        isDirection = nil;
    end
    m_pathfinding = nil;
    if 1 == m_pathfinding then
        m_pathfinding = nil;
    end
end

local function onWindowTouched(tag, pointX, pointY)
    local wnd = SCFunction:getUiNodeByIdlist("2020");
    if wnd == nil then
        return;
    end
    local wndSize = wnd:getContentSize();
    local nWidth = (getScreenWidth() - wndSize.width) / 2;
    local nHeight = (getScreenHeight() - wndSize.height) / 2;
    if pointX > wndSize.width - SX(120) and pointY > wndSize.height - SY(85) then
        pointX = wndSize.width - SX(120);
        pointY = wndSize.height - SY(85);
    else
        if pointX < SX(130) - nWidth then
            pointX = SX(130) - nWidth;
        end
        if pointX > wndSize.width - SX(45) then
            pointX = wndSize.width - SX(45);
        end
        if pointY < SY(30) - nHeight then
            pointY = SY(30) - nHeight;
        end
        if pointY > wndSize.height - SY(30) then
            pointY = wndSize.height - SY(30);
        end
    end
    local pAniRun = SCLookfaceParser:getSingleton():getAnimationByLookfaceAndIndex(Hero:getSingleton():getLookFace(), dirAction_Move);
    if m_ActionNode and m_pHero and pAniRun then
        local pt = m_ActionNode:getPosition();
        local s = math.sqrt((pt.x - pointX) * (pt.x - pointX) + (pt.y - pointY) * (pt.y - pointY));
        local time = s / 120;        
	    m_ActionNode:stopAllActions();
        m_ActionNode:moveTo(CCPointMake(pointX, pointY), time);
        if pointX > pt.x then
            isDirection = true;
            pAniRun:setTransMirror(false);
        else
            isDirection = false;
            pAniRun:setTransMirror(true);
        end
        m_pHero:setAnimation(pAniRun);
        m_ActionNode:luaSetSelectorOnMoveEnd(onMoveEnd);
    end
end

local function createWnd(id, photo)
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(2020));
    if wnd == nil then
        return nil;
    end
    local pPointNode = SCWindowPoint:newSCWindowPoint();
    if pPointNode then
        pPointNode:setContentSize(WIN_SIZE);
        pPointNode:setTouchEnabled(true);
        pPointNode:luaSetSelectorOnTouched(onWindowTouched);
        wnd:addChild(pPointNode);
        wnd:reorderChild(pPointNode, -2);
    end
    wnd:setFrameVisibled(false);
    wnd:luaSetSelectorOnClose(WorldMapWndClose);
    wnd:setBackgroundColor(colorWindowRedBG());
    local flie = nil;
    if id == 0 then
        wnd:setTag(2020);    
        flie = getRealUIResourcePath("worldMap/WorldMap.png");
        m_WorldMapInfo = {__mode = "kv"};
        m_AreaMapInfo = {__mode = "kv"};
    else
        wnd:setTag(id);
        local strPath = "worldMap/";
        strPath = strPath .. (photo + 2);
        strPath = strPath .. ".png";
        flie = getRealUIResourcePath(strPath);
    end    
    local pImg = SCTypeCast:castNodeToImage(wnd:getChildByTag(1));
    if pImg then    
        if flie then
            pImg:setImage(flie:getData());
        end
    end
    local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(wnd, "SCNode")));
    local pImgPath = getRealUIResourcePath("worldMap/902000.png");
    if pBtn and pImgPath then
        pBtn:luaSetSelectorOnClicked(onClickClose);
        pBtn:setTouchRectScale(2.0, 2.0);
        pBtn:setTitle(pImgPath:getData());
    end
    if id == 0 then
        m_ActionNode = ActionNode:newActionNode();
        m_pHeroNode = SCRoleNode:node();
        local pAni = SCLookfaceParser:getSingleton():getAnimationByLookfaceAndIndex(Hero:getSingleton():getLookFace(), dirAction_Move);       
        if m_ActionNode and m_pHeroNode and pAni then
            setNodePostion(m_ActionNode, CCPointMake(20, 20));
            pAni:setTransMirror(true);
            m_pHero = SCRole:roleWithAnimation(pAni);
            m_pHeroNode:setRole(m_pHero);
            m_ActionNode:addChild(m_pHeroNode);
            wnd:addChild(m_ActionNode, 100);
        end    
    end

    local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2", tolua.cast(wnd, "SCNode")));
    if btn then
        btn:luaSetSelectorOnClicked(onClickUp);
        if id == 0 then
            btn:setVisible(false);
        end
        m_pBtnUp = btn;
    end
    btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
    if btn then
        btn:luaSetSelectorOnClicked(onClickDown);
        if id == 0 then
            btn:setVisible(false);
        end
        m_pBtnDown = btn;
    end    
    m_wnd = wnd;
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    return wndCtrl;
end

local function moveEndCallback()
    local pAniRun = SCLookfaceParser:getSingleton():getAnimationByLookfaceAndIndex(Hero:getSingleton():getLookFace(), dirAction_Stand);
    if pAniRun and m_pHero then
        pAniRun:setTransMirror(true);
        m_pHero:setAnimation(pAniRun);
    end
    sendQueryAreaMap(m_lastClickTag);
    local naviCtrl = getCurentSceneNavigationController();
    if naviCtrl then
        naviCtrl:removeWindowControllerByTag(2020);
    end
    if m_lastClickTag == 901000 then
        return ;
    end
end

local function onClickMap(tag)
    m_lastClickTag = tag;
    local pBtn = SCTypeCast:castNodeToButton(m_wnd:getChildByTag(tag));
    if pBtn == nil then
        return;
    end
    onWindowTouched(0, pBtn:getPosition().x + pBtn:getContentSize().width / 2, pBtn:getPosition().y + pBtn:getContentSize().height / 2);
    m_ActionNode:luaSetSelectorOnMoveEnd(moveEndCallback);
    --[[if m_pHero and m_ActionNode then        
        local pAniRun = LookfaceParser:getSingleton():getAnimationByLookFaceAndIndex(Hero:getSingleton():getLookFace(), 1);
        if pAniRun then
            pAniRun:setTransMirror(true);
            m_pHero:setAnimation(pAniRun);
            if m_wnd then
                m_ActionNode:moveTo(setPoint(getNodePostion(m_wnd:getChildByTag(tag))), 0.8);
                m_ActionNode:luaSetSelectorOnMoveEnd(moveEndCallback);
            end
        end    
    end]]
end

function getCopyDownID(id)
    local num = #m_AreaMapInfo;
    for i = 1, num - 1 do
        if id == m_AreaMapInfo[num - (i - 1)].idGroup then
            return m_AreaMapInfo[num - i].idGroup;
        end
    end
    return 0;
end

local function showWorldMap(data)
    local pBtn = SCButton:button();
    local rect = nil;
    local strPath = "worldMap/";
    strPath = strPath .. data.idGroup;
    strPath = strPath .. ".png";
    local file = getRealUIResourcePath(strPath);
    if nil == file then
        return ;
    end
    pBtn:setBackgroundImage(file:getData());
    strPath = "worldMap/";
    strPath = strPath .. (data.idGroup + 1);
    strPath = strPath .. ".png";
    file = getRealUIResourcePath(strPath);
    if nil == file then
        return ;
    end
    pBtn:setSelectedImage(file:getData());
    pBtn:setTag(data.idGroup);
    pBtn:setAnchorPoint(CCPointMake(0, 0));
    setNodePostion(pBtn, CCPointMake(data.usItemX, data.usItemY));
    pBtn:setTouchRectScale(0.5, 0.5);
    pBtn:luaSetSelectorOnClicked(onClickMap);



    if m_pBtnUp and getMapUpID(data.idGroup) == 0 then
        m_pBtnUp:setVisible(false);
    elseif m_pBtnUp then
        m_pBtnUp:setVisible(true);
    end

    if m_pBtnDown and getCopyDownID(data.idGroup) == 0 then
        m_pBtnDown:setVisible(false);
    elseif m_pBtnDown then
        m_pBtnDown:setVisible(true);
    end
    if m_wnd then
        m_wnd:addChild(pBtn);
    end
end

local showAreaMap;

local function NewOpenAreaAnimationEnd()
    if nil == m_wnd then
        return;
    end
    m_wnd:removeChildByTag(5000, true);
    m_NewOpenAreaInfo.ucFirstOpenFlag = 0;
    showAreaMap(m_NewOpenAreaInfo);
    show_NewMapOpenTip();
end

local function onClickArea(tag)
    sendQueryCopyList(2, tag);
    setIsFirstRemoveTrue();
end

function showAreaMap(data)
    if data.ucFirstOpenFlag == 1 then
        m_NewOpenAreaInfo = data;
        local pAni = LookfaceParser:getSingleton():getAnimationByIndex(1110, 1150);
        if pAni then
            pAni:setAutoremoveOnComplete(true);
            pAni:luaSetSelectorOnComplete(NewOpenAreaAnimationEnd);
            local pAniNode = SCAnimationNode:nodeWithAnimation(pAni);
            if pAniNode then
                pAniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                pAniNode:setTag(5000);
                setNodePostion(pAniNode, CCPointMake(data.usLightX, data.usLightY));
                if m_wnd then
                    m_wnd:addChild(pAniNode);
                end
            end
        end
    else
        local pBtn = SCButton:button();
        local strPath = "worldMap/";
        strPath = strPath .. data.nPhoto;
        strPath = strPath .. ".png";
        local file = getRealUIResourcePath(strPath);
        if nil == file then
            return ;
        end
        
        pBtn:setTitle(file:getData());
        pBtn:setTag(data.idGroup);

        setNodePostion(pBtn, CCPointMake(data.usItemX, data.usItemY));
        pBtn:luaSetSelectorOnClicked(onClickArea);
    
        if m_wnd then
            m_wnd:addChild(pBtn);
        end
    end
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        if m_wnd then
            m_wnd:setCloseButtonVisibled(false);
            local naviCtrl = getCurentSceneNavigationController();
            if naviCtrl then
                if tag ~= 2020 and isWindControllerExistence(2020) then
                    naviCtrl:removeWindowControllerByTag(2020);
                end
                local id = getMapDownID(tag);
                if isWindControllerExistence(id) then
                    naviCtrl:removeWindowControllerByTag(id);
                end

                id = getMapUpID(tag);
                if isWindControllerExistence(id) then
                    naviCtrl:removeWindowControllerByTag(id);
                end
                for i = 1, #m_AreaMapInfo do
                    showAreaMap(m_AreaMapInfo[i]);
                end
            end
        end
    elseif LuaControllerEventPopBegan == type then
        if getRestartGuideFlag(GUIDE_TYPE_INST) then
            setRestartGuideFlag(GUIDE_TYPE_INST, false);
            restartGuideStep(GUIDE_TYPE_INST);
        else
            showGuideStep(GUIDE_TYPE_INST, -1);
        end
    end
end

local function getMapCtrl(id , photo)
    local nTag = 2020;
    if 0 ~= id then
        nTag = id;
    end
    local pCtrl =  getCurentSceneWindowController(nTag);
    if nil == pCtrl then
        pCtrl = createWnd(id, photo);
        local naviCtrl = getCurentSceneNavigationController();
        if  naviCtrl and pCtrl then
            pCtrl:luaSetSelectorOnEvent(setWindowAttribute);
            naviCtrl:pushWindowController(pCtrl);
        end
    end
    return pCtrl;
end

function sendQueryWolrdMap()    
    m_WorldMapInfo = {__mode = "kv"};
    m_AreaMapInfo = {__mode = "kv"};
    local dt = SCDataTransStream:streamWithCommand(_MSG_MAPWORLD_INFO);
    if dt then        
        dt:writeShort(MSG_MAPWORLD_AREA_INFO);
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show();
    end
end

local function recvWorldMapInfo()    
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if dt == nil then
        return;
    end
    local action = dt:readShort()
    if action == MSG_MAPWORLD_AREA_INFO then
        m_wordInfo = tMsg_SendWorldMap.initWithStream(dt);
        if 1 == 1 then
            return;
        end
        m_lastClickTag = 901000;
        local pCtrl = getMapCtrl(0, 0);
        local ucAmount = dt:readByte();
        for i = 1, ucAmount do
            local data = stMapInfo.initWithStream(dt);
            if data then
                if pCtrl then
                    showWorldMap(data);
                end
                table.insert(m_WorldMapInfo, data);
            end
        end
        setRestartGuideFlag(GUIDE_TYPE_INST, true);
        showGuideStep(GUIDE_TYPE_INST, 3, 2);
    elseif action == MSG_MAPWORLD_AREA_DETAIL_INFO then
        m_id = dt:readInt();
        m_photo = dt:readInt();
        m_nType = dt:readByte();
        local pCtrl  = nil;
        if 0 == m_nType then
            pCtrl = getMapCtrl(m_id ,m_photo);
        else
            m_WorldMapInfo = {__mode = "kv"};
            m_AreaMapInfo = {__mode = "kv"};
        end
        local ucAmount = dt:readByte();
        for i = 1, ucAmount do
            local data = stWorldAreaInfo.initWithStream(dt);
            if data then
                table.insert(m_AreaMapInfo, 1, data);
            end
        end
        setRestartGuideFlag(GUIDE_TYPE_INST, true);
        showGuideStep(GUIDE_TYPE_INST, 4, 3);
    end
end

function getCopyUpID(id)
    for i = 1, #m_AreaMapInfo - 1 do
		if id == m_AreaMapInfo[i].idGroup then
			return m_AreaMapInfo[i + 1].idGroup;
		end
	end
	return 0;
end

function getCopyName(nGroup)
    for i = 1, #m_AreaMapInfo do
		if nGroup == m_AreaMapInfo[i].idGroup then
			return m_AreaMapInfo[i].strName;
		end
    end
	return nil;
end

function reshowAreaMap()
    local pCtrl  = nil;
    if 1 == m_nType then
        pCtrl = getMapCtrl(m_id ,m_photo);
    else
        return ;
    end
    for i = 1, #m_AreaMapInfo do
        showAreaMap(m_AreaMapInfo[i]);
    end
end

function callShowAreaMap()
    local pCtrl = nil;
	if 1 == m_nType then
		pCtrl = getMapCtrl(m_id ,m_photo);
	else
		return ;
	end
	if pCtrl then
        for i = 1, #m_AreaMapInfo do
            showAreaMap(m_AreaMapInfo[i]);
        end
	end
end

local function createWorldMap()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(2020));
    if wnd == nil then
        return nil;
    end
    local pPointNode = SCWindowPoint:newSCWindowPoint();
    if pPointNode then
        pPointNode:setContentSize(WIN_SIZE);
        pPointNode:setTouchEnabled(true);
        pPointNode:luaSetSelectorOnTouched(onWindowTouched);
        wnd:addChild(pPointNode);
        wnd:reorderChild(pPointNode, -2);
    end
    wnd:setFrameVisibled(false);
    wnd:luaSetSelectorOnClose(WorldMapWndClose);
    wnd:setBackgroundColor(colorWindowRedBG());
    local flie = getRealUIResourcePath("worldMap/WorldMap.png");
    local pImg = SCTypeCast:castNodeToImage(wnd:getChildByTag(1));
    if pImg then    
        if flie then
            pImg:setImage(flie:getData());
            --[[local size = SCREEN_SIZE;
            local pSize = pImg:getContentSize();
            local pSize = pImg:getContentSize();
            pImg:setScaleX(size.width / pSize.width);
            pImg:setScaleY(size.height / pSize.height);]]
        end
    end
    local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(wnd, "SCNode")));
    local pImgPath = getRealUIResourcePath("worldMap/902000.png");
    if pBtn and pImgPath then
        pBtn:luaSetSelectorOnClicked(onClickClose);
        pBtn:setTouchRectScale(2.0, 2.0);
        pBtn:setTitle(pImgPath:getData());
    end
    m_ActionNode = ActionNode:newActionNode();
    m_pHeroNode = SCRoleNode:node();
    local pAni = SCLookfaceParser:getSingleton():getAnimationByLookfaceAndIndex(Hero:getSingleton():getLookFace(), dirAction_Stand);      
    if m_ActionNode and m_pHeroNode and pAni then
        m_ActionNode:setAnchorPoint(CCPointMake(0.5, 0))
        local flg = 0
        for i = 1, #m_wordInfo.stWorldMap do
            
            if m_wordInfo.stWorldMap[i].idGroup == GameCommonMsgRecive:getSingleton():getMapID() then
                setNodePostion(m_ActionNode, CCPointMake(m_wordInfo.stWorldMap[i].usItemX, m_wordInfo.stWorldMap[i].usItemY));
                flg = 1
                break;
            end
            
        end
        if flg == 0 then
            m_ActionNode:setPosition(CCPointMake(wnd:getContentSize().width/3, wnd:getContentSize().height/2));
        end
        pAni:setTransMirror(true);
        m_pHero = SCRole:roleWithAnimation(pAni);
        m_pHeroNode:setRole(m_pHero);
        m_ActionNode:addChild(m_pHeroNode);
        m_ActionNode:setContentSize(m_pHeroNode:getContentSize());
        wnd:addChild(m_ActionNode, 100);
    end
    m_wnd = wnd;
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    return wndCtrl;
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        if m_wnd then
            for i = 1, m_wordInfo.ucAmount do
                local pBtn = SCButton:button();
                local strPath = "worldMap/";
                strPath = strPath .. m_wordInfo.stWorldMap[i].nPhoto;
                strPath = strPath .. ".png";
                local file = getRealUIResourcePath(strPath);
                if nil == file then
                    return ;
                end
                pBtn:setBackgroundImage(file:getData());
                strPath = "worldMap/";
                strPath = strPath .. (m_wordInfo.stWorldMap[i].nPhoto + 1);
                strPath = strPath .. ".png";
                file = getRealUIResourcePath(strPath);
                if nil == file then
                    return ;
                end
                pBtn:setSelectedImage(file:getData());
                pBtn:setTag(m_wordInfo.stWorldMap[i].idGroup);
                pBtn:setAnchorPoint(CCPointMake(0, 0));
                setNodePostion(pBtn, CCPointMake(m_wordInfo.stWorldMap[i].usItemX, m_wordInfo.stWorldMap[i].usItemY));
                pBtn:setTouchRectScale(0.5, 0.5);
                pBtn:luaSetSelectorOnClicked(onClickMap);
                m_wnd:addChild(pBtn);   
            end
            if m_pathfinding then             
                onClickMap(m_pathfinding);
                m_pathfinding = nil;
            end
        end
    end
end

function showWorldMapController()
    SCActivityIndicator:getSingleton():showEX(1.0);
    local wndCtrl = createWorldMap()
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl);
        wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);
        m_wnd:setCloseButtonVisibled(false);
    end
end

--寻路
function WorldMapController_pathfinding(id)
    if 0 == id then
        return;
    end
    for i = 1, m_wordInfo.ucAmount do
        if id == m_wordInfo.stWorldMap[i].idGroup then
            m_pathfinding = id;
            showWorldMapController();
            return;
        end
    end
end

function WorldMapController_CutFigure()
    local id = LuaReCall:getSingleton():getuID();
    LuaReCall:getSingleton():setuID(0);
    WorldMapController_pathfinding(id);
end

SCMessageCenter:getSingleton():luaRegistCommand(recvWorldMapInfo, _MSG_MAPWORLD_INFO, 0, nil)