--定义一个与文件名相同的table
armyGroupFight3 = {}
------------------消息--------------------

----------------结构定义区----------------
--对战详情
local stTribePair = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            ucIndex,                --//位置
            idTribe,		    --//军团id
            szTribe,            --//公会名称
            ucWinTimes,            --//胜场
        }
        tmp.ucIndex = dt:readByte()
        tmp.idTribe = dt:readInt();
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTribe = ""
        else
            tmp.szTribe = scStr:getData()
        end
        tmp.ucWinTimes = dt:readByte();
        return tmp
    end;
}
--对战表
local stWarPairInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            ucLastId,
            ucWarFlag,
            ucWarPair,
            dwLeaveTime,
            ucAmount,
        }
        tmp.stPairFill = {};
        tmp.ucLastId = dt:readInt();
        tmp.ucWarFlag = dt:readByte();  --//0:准备 1:(可以进入战场) 2:已开始   3比赛未开始 4比赛已结束
        tmp.ucWarPair = dt:readByte();  --//几强赛0~4
        tmp.dwLeaveTime = dt:readInt();
        tmp.ucAmount = dt:readByte();
        local count = tmp.ucAmount
        if not tmp.ucAmount or 0 == tmp.ucAmount then
            count = 1
        end
        for i = 1, count do
            table.insert(tmp.stPairFill, stTribePair.initWithStream(dt))
        end
        return tmp
    end
}
--投注界面
local stBetInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            dwBetMoney,                --
            ucScale,		    --//
            idTribe1,            --//
            szTribe1,            --//
            ucTribeLev1,
            ucMemberNum1,            --//
            idTribe2,            --//
            szTribe2,            --//
            ucTribeLev2,
            ucMemberNum2,            --//
        }
        tmp.dwBetMoney = dt:readInt()
        tmp.ucScale = dt:readByte()
        tmp.idTribe1 = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTribe1 = ""
        else
            tmp.szTribe1 = scStr:getData()
        end
        tmp.ucTribeLev1 = dt:readByte();
        tmp.ucMemberNum1 = dt:readByte();
        tmp.idTribe2 = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTribe2 = ""
        else
            tmp.szTribe2 = scStr:getData()
        end
        tmp.ucTribeLev2 = dt:readByte();
        tmp.ucMemberNum2 = dt:readByte()
        return tmp
    end;
}
--情报详情
local stWarReport = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            idUser,               
            ucClan,		    
            szName,            
            usKillNum,            
        }
        tmp.idUser = dt:readInt();
        tmp.ucClan = dt:readByte()--//1龙将2剑舞3箭神4军师
        
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szName = ""
        else
            tmp.szName = scStr:getData()
        end
        tmp.usKillNum = dt:readShort();
        return tmp
    end;
}
--情报界面
local stTribeWarInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            ucMySelf,
            szTribeName,
            ucAliveNum,
            ucWinTimes,
            ucMemberNum,
        }
        tmp.stWarFill = {};
        tmp.ucMySelf = dt:readByte();  --//0正在比赛 1胜利 2失败
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTribeName = ""
        else
            tmp.szTribeName = scStr:getData()
        end
        tmp.ucAliveNum = dt:readByte();
        tmp.ucWinTimes = dt:readByte();
        tmp.ucMemberNum = dt:readByte();
        for i = 1, tmp.ucMemberNum do
            table.insert(tmp.stWarFill, stWarReport.initWithStream(dt))
        end
        return tmp
    end
}
----------------常量定义区----------------
local ACTION_TRIBEWAR_PAIR_INFO             = 15;    --//公会配对界面
local ACTION_TRIBEWAR_INVITE			= 10	--//进入军团战邀请
local ACTION_TRIBEWAR_ENTER_MAP		= 11	--//进入军团战地图
local ACTION_TRIBEWAR_WARINFO			= 14	--//军团战战报查看
--local ACTION_TRIBEWAR_PAIRINFO		= 15	--//军团战对战表查看
local ACTION_TRIBEWAR_SIGN			= 16	--//军团战报名
local ACTION_TRIBEWAR_CLOSE_WINDOW	= 17	--//关闭军团战配对界面
local ACTION_TRIBEWAR_BET				= 18	--//打开军团战下注界面
local ACTION_TRIBEWAR_BETOK			= 19	--//军团战下注
local ACTION_TRIBEWAR_WARVIEW			= 20	--//准备地图查看对战情报详情
----------------变量定义区----------------
--变量的定义
local m_fightMapTagTable = nil
local m_allArmyMsg = nil
local m_ucWarPair = nil
local m_firstArmyName = nil
----------------UI控制器区----------------
function armyGroupFight3.initControl()
	local pWindow4223 = SCWindow:window()
	if pWindow4223 then
		pWindow4223:setTag(4223)
		pWindow4223:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow4223:setPosition(AUTO_POS(0.00, 0.00))pWindow4223:setContentSize(AUTO_SIZE(480, 320))
		pWindow4223:luaSetSelectorOnClose(armyGroupFight3.releaseControl)
	end

	local imgPath = getRealUIResourcePath("pk/new00780.jp")
	local pImage1 = nil
	if imgPath then
		pImage1 = SCImage:imageWithFile(imgPath:getData())
		if pImage1 then
			pImage1:setTag(1)
			pImage1:setAnchorPoint(ANCHOR_CENTER)
			pImage1:setPosition(AUTO_POS(240.00, 160.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1001 = nil
	if imgPath then
		pImage1001 = SCImage:imageWithFile(imgPath:getData())
		if pImage1001 then
			pImage1001:setTag(1001)
			pImage1001:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1001:setPosition(AUTO_POS(60.00, 245.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1101 = nil
	if imgPath then
		pImage1101 = SCImage:imageWithFile(imgPath:getData())
		if pImage1101 then
			pImage1101:setTag(1101)
			pImage1101:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1101:setPosition(AUTO_POS(60.00, 230.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1102 = nil
	if imgPath then
		pImage1102 = SCImage:imageWithFile(imgPath:getData())
		if pImage1102 then
			pImage1102:setTag(1102)
			pImage1102:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1102:setPosition(AUTO_POS(60.00, 160.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1002 = nil
	if imgPath then
		pImage1002 = SCImage:imageWithFile(imgPath:getData())
		if pImage1002 then
			pImage1002:setTag(1002)
			pImage1002:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1002:setPosition(AUTO_POS(60.00, 175.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1003 = nil
	if imgPath then
		pImage1003 = SCImage:imageWithFile(imgPath:getData())
		if pImage1003 then
			pImage1003:setTag(1003)
			pImage1003:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1003:setPosition(AUTO_POS(60.00, 105.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1103 = nil
	if imgPath then
		pImage1103 = SCImage:imageWithFile(imgPath:getData())
		if pImage1103 then
			pImage1103:setTag(1103)
			pImage1103:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1103:setPosition(AUTO_POS(60.00, 90.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1004 = nil
	if imgPath then
		pImage1004 = SCImage:imageWithFile(imgPath:getData())
		if pImage1004 then
			pImage1004:setTag(1004)
			pImage1004:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1004:setPosition(AUTO_POS(60.00, 35.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1104 = nil
	if imgPath then
		pImage1104 = SCImage:imageWithFile(imgPath:getData())
		if pImage1104 then
			pImage1104:setTag(1104)
			pImage1104:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1104:setPosition(AUTO_POS(60.00, 20.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00818.pn")
	local pImage1005 = nil
	if imgPath then
		pImage1005 = SCImage:imageWithFile(imgPath:getData())
		if pImage1005 then
			pImage1005:setTag(1005)
			pImage1005:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1005:setPosition(AUTO_POS(100.00, 212.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00818.pn")
	local pImage1105 = nil
	if imgPath then
		pImage1105 = SCImage:imageWithFile(imgPath:getData())
		if pImage1105 then
			pImage1105:setTag(1105)
			pImage1105:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1105:setPosition(AUTO_POS(100.00, 178.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00820.pn")
	local pImage1007 = nil
	if imgPath then
		pImage1007 = SCImage:imageWithFile(imgPath:getData())
		if pImage1007 then
			pImage1007:setTag(1007)
			pImage1007:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1007:setPosition(AUTO_POS(150.00, 144.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00818.pn")
	local pImage1006 = nil
	if imgPath then
		pImage1006 = SCImage:imageWithFile(imgPath:getData())
		if pImage1006 then
			pImage1006:setTag(1006)
			pImage1006:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1006:setPosition(AUTO_POS(100.00, 72.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00818.pn")
	local pImage1106 = nil
	if imgPath then
		pImage1106 = SCImage:imageWithFile(imgPath:getData())
		if pImage1106 then
			pImage1106:setTag(1106)
			pImage1106:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1106:setPosition(AUTO_POS(100.00, 38.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00820.pn")
	local pImage1107 = nil
	if imgPath then
		pImage1107 = SCImage:imageWithFile(imgPath:getData())
		if pImage1107 then
			pImage1107:setTag(1107)
			pImage1107:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1107:setPosition(AUTO_POS(150.00, 74.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00822.pn")
	local pImage15 = nil
	if imgPath then
		pImage15 = SCImage:imageWithFile(imgPath:getData())
		if pImage15 then
			pImage15:setTag(15)
			pImage15:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage15:setPosition(AUTO_POS(176.00, 144.00))
		end
	end

	local pDragNode101 = SCDragNode:node()
	if pDragNode101 then
		pDragNode101:setTag(101)
		pDragNode101:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode101:setPosition(AUTO_POS(5.00, 260.00))
		pDragNode101:setContentSize(AUTO_SIZE(70, 20))
		pDragNode101:setFrameVisibled(true)
		pDragNode101:setDragEnabled(false)
		pDragNode101:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode103 = SCDragNode:node()
	if pDragNode103 then
		pDragNode103:setTag(103)
		pDragNode103:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode103:setPosition(AUTO_POS(5.00, 225.00))
		pDragNode103:setContentSize(AUTO_SIZE(70, 20))
		pDragNode103:setFrameVisibled(true)
		pDragNode103:setDragEnabled(false)
		pDragNode103:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode105 = SCDragNode:node()
	if pDragNode105 then
		pDragNode105:setTag(105)
		pDragNode105:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode105:setPosition(AUTO_POS(5.00, 190.00))
		pDragNode105:setContentSize(AUTO_SIZE(70, 20))
		pDragNode105:setFrameVisibled(true)
		pDragNode105:setDragEnabled(false)
		pDragNode105:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode107 = SCDragNode:node()
	if pDragNode107 then
		pDragNode107:setTag(107)
		pDragNode107:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode107:setPosition(AUTO_POS(5.00, 155.00))
		pDragNode107:setContentSize(AUTO_SIZE(70, 20))
		pDragNode107:setFrameVisibled(true)
		pDragNode107:setDragEnabled(false)
		pDragNode107:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode301 = SCDragNode:node()
	if pDragNode301 then
		pDragNode301:setTag(301)
		pDragNode301:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode301:setPosition(AUTO_POS(85.00, 243.00))
		pDragNode301:setContentSize(AUTO_SIZE(40, 20))
		pDragNode301:setFrameVisibled(true)
		pDragNode301:setDragEnabled(false)
		pDragNode301:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode303 = SCDragNode:node()
	if pDragNode303 then
		pDragNode303:setTag(303)
		pDragNode303:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode303:setPosition(AUTO_POS(85.00, 173.00))
		pDragNode303:setContentSize(AUTO_SIZE(40, 20))
		pDragNode303:setFrameVisibled(true)
		pDragNode303:setDragEnabled(false)
		pDragNode303:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode109 = SCDragNode:node()
	if pDragNode109 then
		pDragNode109:setTag(109)
		pDragNode109:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode109:setPosition(AUTO_POS(5.00, 120.00))
		pDragNode109:setContentSize(AUTO_SIZE(70, 20))
		pDragNode109:setFrameVisibled(true)
		pDragNode109:setDragEnabled(false)
		pDragNode109:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode111 = SCDragNode:node()
	if pDragNode111 then
		pDragNode111:setTag(111)
		pDragNode111:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode111:setPosition(AUTO_POS(5.00, 85.00))
		pDragNode111:setContentSize(AUTO_SIZE(70, 20))
		pDragNode111:setFrameVisibled(true)
		pDragNode111:setDragEnabled(false)
		pDragNode111:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode113 = SCDragNode:node()
	if pDragNode113 then
		pDragNode113:setTag(113)
		pDragNode113:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode113:setPosition(AUTO_POS(5.00, 50.00))
		pDragNode113:setContentSize(AUTO_SIZE(70, 20))
		pDragNode113:setFrameVisibled(true)
		pDragNode113:setDragEnabled(false)
		pDragNode113:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode115 = SCDragNode:node()
	if pDragNode115 then
		pDragNode115:setTag(115)
		pDragNode115:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode115:setPosition(AUTO_POS(5.00, 15.00))
		pDragNode115:setContentSize(AUTO_SIZE(70, 20))
		pDragNode115:setFrameVisibled(true)
		pDragNode115:setDragEnabled(false)
		pDragNode115:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode305 = SCDragNode:node()
	if pDragNode305 then
		pDragNode305:setTag(305)
		pDragNode305:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode305:setPosition(AUTO_POS(85.00, 103.00))
		pDragNode305:setContentSize(AUTO_SIZE(40, 20))
		pDragNode305:setFrameVisibled(true)
		pDragNode305:setDragEnabled(false)
		pDragNode305:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode311 = SCDragNode:node()
	if pDragNode311 then
		pDragNode311:setTag(311)
		pDragNode311:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode311:setPosition(AUTO_POS(130.00, 67.00))
		pDragNode311:setContentSize(AUTO_SIZE(40, 20))
		pDragNode311:setFrameVisibled(true)
		pDragNode311:setDragEnabled(false)
		pDragNode311:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode307 = SCDragNode:node()
	if pDragNode307 then
		pDragNode307:setTag(307)
		pDragNode307:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode307:setPosition(AUTO_POS(85.00, 33.00))
		pDragNode307:setContentSize(AUTO_SIZE(40, 20))
		pDragNode307:setFrameVisibled(true)
		pDragNode307:setDragEnabled(false)
		pDragNode307:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode313 = SCDragNode:node()
	if pDragNode313 then
		pDragNode313:setTag(313)
		pDragNode313:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode313:setPosition(AUTO_POS(166.00, 137.00))
		pDragNode313:setContentSize(AUTO_SIZE(40, 20))
		pDragNode313:setFrameVisibled(true)
		pDragNode313:setDragEnabled(false)
		pDragNode313:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode309 = SCDragNode:node()
	if pDragNode309 then
		pDragNode309:setTag(309)
		pDragNode309:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode309:setPosition(AUTO_POS(130.00, 207.00))
		pDragNode309:setContentSize(AUTO_SIZE(40, 20))
		pDragNode309:setFrameVisibled(true)
		pDragNode309:setDragEnabled(false)
		pDragNode309:setFrameType(EnumFrameTypeListNormal)
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1201 = nil
	if imgPath then
		pImage1201 = SCImage:imageWithFile(imgPath:getData())
		if pImage1201 then
			pImage1201:setTag(1201)
			pImage1201:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1201:setPosition(AUTO_POS(370.00, 245.00))
		end
	end

	local pDragNode102 = SCDragNode:node()
	if pDragNode102 then
		pDragNode102:setTag(102)
		pDragNode102:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode102:setPosition(AUTO_POS(405.00, 260.00))
		pDragNode102:setContentSize(AUTO_SIZE(70, 20))
		pDragNode102:setFrameVisibled(true)
		pDragNode102:setDragEnabled(false)
		pDragNode102:setFrameType(EnumFrameTypeListNormal)
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1301 = nil
	if imgPath then
		pImage1301 = SCImage:imageWithFile(imgPath:getData())
		if pImage1301 then
			pImage1301:setTag(1301)
			pImage1301:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1301:setPosition(AUTO_POS(370.00, 230.00))
		end
	end

	local pDragNode104 = SCDragNode:node()
	if pDragNode104 then
		pDragNode104:setTag(104)
		pDragNode104:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode104:setPosition(AUTO_POS(405.00, 225.00))
		pDragNode104:setContentSize(AUTO_SIZE(70, 20))
		pDragNode104:setFrameVisibled(true)
		pDragNode104:setDragEnabled(false)
		pDragNode104:setFrameType(EnumFrameTypeListNormal)
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1202 = nil
	if imgPath then
		pImage1202 = SCImage:imageWithFile(imgPath:getData())
		if pImage1202 then
			pImage1202:setTag(1202)
			pImage1202:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1202:setPosition(AUTO_POS(370.00, 175.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1302 = nil
	if imgPath then
		pImage1302 = SCImage:imageWithFile(imgPath:getData())
		if pImage1302 then
			pImage1302:setTag(1302)
			pImage1302:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1302:setPosition(AUTO_POS(370.00, 160.00))
		end
	end

	local pDragNode106 = SCDragNode:node()
	if pDragNode106 then
		pDragNode106:setTag(106)
		pDragNode106:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode106:setPosition(AUTO_POS(405.00, 190.00))
		pDragNode106:setContentSize(AUTO_SIZE(70, 20))
		pDragNode106:setFrameVisibled(true)
		pDragNode106:setDragEnabled(false)
		pDragNode106:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode108 = SCDragNode:node()
	if pDragNode108 then
		pDragNode108:setTag(108)
		pDragNode108:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode108:setPosition(AUTO_POS(405.00, 155.00))
		pDragNode108:setContentSize(AUTO_SIZE(70, 20))
		pDragNode108:setFrameVisibled(true)
		pDragNode108:setDragEnabled(false)
		pDragNode108:setFrameType(EnumFrameTypeListNormal)
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1203 = nil
	if imgPath then
		pImage1203 = SCImage:imageWithFile(imgPath:getData())
		if pImage1203 then
			pImage1203:setTag(1203)
			pImage1203:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1203:setPosition(AUTO_POS(370.00, 105.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1303 = nil
	if imgPath then
		pImage1303 = SCImage:imageWithFile(imgPath:getData())
		if pImage1303 then
			pImage1303:setTag(1303)
			pImage1303:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1303:setPosition(AUTO_POS(369.00, 90.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1204 = nil
	if imgPath then
		pImage1204 = SCImage:imageWithFile(imgPath:getData())
		if pImage1204 then
			pImage1204:setTag(1204)
			pImage1204:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1204:setPosition(AUTO_POS(370.00, 35.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00816.pn")
	local pImage1304 = nil
	if imgPath then
		pImage1304 = SCImage:imageWithFile(imgPath:getData())
		if pImage1304 then
			pImage1304:setTag(1304)
			pImage1304:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1304:setPosition(AUTO_POS(370.00, 20.00))
		end
	end

	local pDragNode110 = SCDragNode:node()
	if pDragNode110 then
		pDragNode110:setTag(110)
		pDragNode110:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode110:setPosition(AUTO_POS(405.00, 120.00))
		pDragNode110:setContentSize(AUTO_SIZE(70, 20))
		pDragNode110:setFrameVisibled(true)
		pDragNode110:setDragEnabled(false)
		pDragNode110:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode112 = SCDragNode:node()
	if pDragNode112 then
		pDragNode112:setTag(112)
		pDragNode112:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode112:setPosition(AUTO_POS(405.00, 85.00))
		pDragNode112:setContentSize(AUTO_SIZE(70, 20))
		pDragNode112:setFrameVisibled(true)
		pDragNode112:setDragEnabled(false)
		pDragNode112:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode114 = SCDragNode:node()
	if pDragNode114 then
		pDragNode114:setTag(114)
		pDragNode114:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode114:setPosition(AUTO_POS(405.00, 50.00))
		pDragNode114:setContentSize(AUTO_SIZE(70, 20))
		pDragNode114:setFrameVisibled(true)
		pDragNode114:setDragEnabled(false)
		pDragNode114:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode116 = SCDragNode:node()
	if pDragNode116 then
		pDragNode116:setTag(116)
		pDragNode116:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode116:setPosition(AUTO_POS(405.00, 15.00))
		pDragNode116:setContentSize(AUTO_SIZE(70, 21))
		pDragNode116:setFrameVisibled(true)
		pDragNode116:setDragEnabled(false)
		pDragNode116:setFrameType(EnumFrameTypeListNormal)
	end

	local imgPath = getRealUIResourcePath("tribe/new00818.pn")
	local pImage1205 = nil
	if imgPath then
		pImage1205 = SCImage:imageWithFile(imgPath:getData())
		if pImage1205 then
			pImage1205:setTag(1205)
			pImage1205:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1205:setPosition(AUTO_POS(324.00, 212.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00818.pn")
	local pImage1305 = nil
	if imgPath then
		pImage1305 = SCImage:imageWithFile(imgPath:getData())
		if pImage1305 then
			pImage1305:setTag(1305)
			pImage1305:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1305:setPosition(AUTO_POS(324.00, 178.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00818.pn")
	local pImage1206 = nil
	if imgPath then
		pImage1206 = SCImage:imageWithFile(imgPath:getData())
		if pImage1206 then
			pImage1206:setTag(1206)
			pImage1206:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1206:setPosition(AUTO_POS(324.00, 72.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00818.pn")
	local pImage1306 = nil
	if imgPath then
		pImage1306 = SCImage:imageWithFile(imgPath:getData())
		if pImage1306 then
			pImage1306:setTag(1306)
			pImage1306:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1306:setPosition(AUTO_POS(324.00, 38.00))
		end
	end

	local pDragNode302 = SCDragNode:node()
	if pDragNode302 then
		pDragNode302:setTag(302)
		pDragNode302:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode302:setPosition(AUTO_POS(355.00, 242.00))
		pDragNode302:setContentSize(AUTO_SIZE(40, 20))
		pDragNode302:setFrameVisibled(true)
		pDragNode302:setDragEnabled(false)
		pDragNode302:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode304 = SCDragNode:node()
	if pDragNode304 then
		pDragNode304:setTag(304)
		pDragNode304:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode304:setPosition(AUTO_POS(355.00, 173.00))
		pDragNode304:setContentSize(AUTO_SIZE(40, 20))
		pDragNode304:setFrameVisibled(true)
		pDragNode304:setDragEnabled(false)
		pDragNode304:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode306 = SCDragNode:node()
	if pDragNode306 then
		pDragNode306:setTag(306)
		pDragNode306:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode306:setPosition(AUTO_POS(355.00, 103.00))
		pDragNode306:setContentSize(AUTO_SIZE(40, 20))
		pDragNode306:setFrameVisibled(true)
		pDragNode306:setDragEnabled(false)
		pDragNode306:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode308 = SCDragNode:node()
	if pDragNode308 then
		pDragNode308:setTag(308)
		pDragNode308:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode308:setPosition(AUTO_POS(355.00, 33.00))
		pDragNode308:setContentSize(AUTO_SIZE(40, 20))
		pDragNode308:setFrameVisibled(true)
		pDragNode308:setDragEnabled(false)
		pDragNode308:setFrameType(EnumFrameTypeListNormal)
	end

	local pLable3 = SCLabel:labelWithStringFont(L("  "), DEFAULT_FONT_NAME, F(12))
	if pLable3 then
		pLable3:setTag(3)
		pLable3:setAnchorPoint(ANCHOR_CENTER)
		pLable3:setPosition(AUTO_POS(239.50, 24.50))
		pLable3:setColor(ccc4(255,132,0,123))
	end

	local imgPath = getRealUIResourcePath("tribe/new00820.pn")
	local pImage1207 = nil
	if imgPath then
		pImage1207 = SCImage:imageWithFile(imgPath:getData())
		if pImage1207 then
			pImage1207:setTag(1207)
			pImage1207:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1207:setPosition(AUTO_POS(288.00, 144.00))
		end
	end

	local imgPath = getRealUIResourcePath("tribe/new00820.pn")
	local pImage1307 = nil
	if imgPath then
		pImage1307 = SCImage:imageWithFile(imgPath:getData())
		if pImage1307 then
			pImage1307:setTag(1307)
			pImage1307:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1307:setPosition(AUTO_POS(288.00, 74.00))
		end
	end

	local pDragNode310 = SCDragNode:node()
	if pDragNode310 then
		pDragNode310:setTag(310)
		pDragNode310:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode310:setPosition(AUTO_POS(310.00, 207.00))
		pDragNode310:setContentSize(AUTO_SIZE(40, 20))
		pDragNode310:setFrameVisibled(true)
		pDragNode310:setDragEnabled(false)
		pDragNode310:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode312 = SCDragNode:node()
	if pDragNode312 then
		pDragNode312:setTag(312)
		pDragNode312:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode312:setPosition(AUTO_POS(310.00, 67.00))
		pDragNode312:setContentSize(AUTO_SIZE(40, 20))
		pDragNode312:setFrameVisibled(true)
		pDragNode312:setDragEnabled(false)
		pDragNode312:setFrameType(EnumFrameTypeListNormal)
	end

	local imgPath = getRealUIResourcePath("tribe/new00822.pn")
	local pImage1208 = nil
	if imgPath then
		pImage1208 = SCImage:imageWithFile(imgPath:getData())
		if pImage1208 then
			pImage1208:setTag(1208)
			pImage1208:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1208:setPosition(AUTO_POS(234.00, 144.00))
		end
	end

	local pDragNode314 = SCDragNode:node()
	if pDragNode314 then
		pDragNode314:setTag(314)
		pDragNode314:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode314:setPosition(AUTO_POS(274.00, 137.00))
		pDragNode314:setContentSize(AUTO_SIZE(40, 20))
		pDragNode314:setFrameVisibled(true)
		pDragNode314:setDragEnabled(false)
		pDragNode314:setFrameType(EnumFrameTypeListNormal)
	end

	local pButton2 = SCButton:button(EnumBtnType9Atlas)
	if pButton2 then
		pButton2:setTag(2)
		pButton2:setAnchorPoint(ANCHOR_CENTER)
		pButton2:setPosition(AUTO_POS(240.00, 60.00))
		pButton2:setContentSize(AUTO_SIZE(85, 30))
		pButton2:setTitle(L("str3180"), DEFAULT_FONT_NAME, F(15))
	end

	local imgPath = getRealUIResourcePath("tribe/new00826.pn")
	local pImage4 = nil
	if imgPath then
		pImage4 = SCImage:imageWithFile(imgPath:getData())
		if pImage4 then
			pImage4:setTag(4)
			pImage4:setAnchorPoint(ANCHOR_CENTER)
			pImage4:setPosition(AUTO_POS(240.00, 300.00))
		end
	end

	local pLable6 = SCLabel:labelWithStringFont(L("str3235"), DEFAULT_FONT_NAME, F(12))
	if pLable6 then
		pLable6:setTag(6)
		pLable6:setAnchorPoint(ANCHOR_CENTER)
		pLable6:setPosition(AUTO_POS(239.50, 279.50))
		pLable6:setColor(ccc4(255,132,0,125))
	end

	local pDragNode7 = SCDragNode:node()
	if pDragNode7 then
		pDragNode7:setTag(7)
		pDragNode7:setAnchorPoint(ANCHOR_CENTER)
		pDragNode7:setPosition(AUTO_POS(240.00, 250.00))
		pDragNode7:setContentSize(AUTO_SIZE(100, 40))
		pDragNode7:setFrameVisibled(true)
		pDragNode7:setDragEnabled(false)
		pDragNode7:setFrameType(EnumFrameTypeNone)
	end

	local imgPath = getRealUIResourcePath("tribe/new00825.pn")
	local pImage5 = nil
	if imgPath then
		pImage5 = SCImage:imageWithFile(imgPath:getData())
		if pImage5 then
			pImage5:setTag(5)
			pImage5:setAnchorPoint(ANCHOR_CENTER)
			pImage5:setPosition(AUTO_POS(240.00, 165.00))
		end
	end

	local pLable8 = SCLabel:labelWithStringFont(L("str3183"), DEFAULT_FONT_NAME, F(14))
	if pLable8 then
		pLable8:setTag(8)
		pLable8:setAnchorPoint(ANCHOR_CENTER)
		pLable8:setPosition(AUTO_POS(239.50, 125.00))
		pLable8:setColor(ccc4(255,132,0,125))
	end

	local pLable3010 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3010 then
		pLable3010:setTag(3010)
		pLable3010:setAnchorPoint(ANCHOR_CENTER)
		pLable3010:setPosition(AUTO_POS(19.50, 9.50))
		pLable3010:setColor(ccc4(255,132,0,125))
	end

	local pLable3020 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3020 then
		pLable3020:setTag(3020)
		pLable3020:setAnchorPoint(ANCHOR_CENTER)
		pLable3020:setPosition(AUTO_POS(19.50, 9.50))
		pLable3020:setColor(ccc4(255,132,0,125))
	end

	local pLable3030 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3030 then
		pLable3030:setTag(3030)
		pLable3030:setAnchorPoint(ANCHOR_CENTER)
		pLable3030:setPosition(AUTO_POS(19.50, 9.50))
		pLable3030:setColor(ccc4(255,132,0,125))
	end

	local pLable3040 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3040 then
		pLable3040:setTag(3040)
		pLable3040:setAnchorPoint(ANCHOR_CENTER)
		pLable3040:setPosition(AUTO_POS(19.50, 9.50))
		pLable3040:setColor(ccc4(255,132,0,125))
	end

	local pLable3050 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3050 then
		pLable3050:setTag(3050)
		pLable3050:setAnchorPoint(ANCHOR_CENTER)
		pLable3050:setPosition(AUTO_POS(19.50, 9.50))
		pLable3050:setColor(ccc4(255,132,0,125))
	end

	local pLable3060 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3060 then
		pLable3060:setTag(3060)
		pLable3060:setAnchorPoint(ANCHOR_CENTER)
		pLable3060:setPosition(AUTO_POS(19.50, 9.50))
		pLable3060:setColor(ccc4(255,132,0,125))
	end

	local pLable3070 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3070 then
		pLable3070:setTag(3070)
		pLable3070:setAnchorPoint(ANCHOR_CENTER)
		pLable3070:setPosition(AUTO_POS(19.50, 9.50))
		pLable3070:setColor(ccc4(255,132,0,125))
	end

	local pLable3080 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3080 then
		pLable3080:setTag(3080)
		pLable3080:setAnchorPoint(ANCHOR_CENTER)
		pLable3080:setPosition(AUTO_POS(19.50, 9.50))
		pLable3080:setColor(ccc4(255,132,0,125))
	end

	local pLable3090 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3090 then
		pLable3090:setTag(3090)
		pLable3090:setAnchorPoint(ANCHOR_CENTER)
		pLable3090:setPosition(AUTO_POS(19.50, 9.50))
		pLable3090:setColor(ccc4(255,132,0,125))
	end

	local pLable3100 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3100 then
		pLable3100:setTag(3100)
		pLable3100:setAnchorPoint(ANCHOR_CENTER)
		pLable3100:setPosition(AUTO_POS(19.50, 9.50))
		pLable3100:setColor(ccc4(255,132,0,125))
	end

	local pLable3110 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3110 then
		pLable3110:setTag(3110)
		pLable3110:setAnchorPoint(ANCHOR_CENTER)
		pLable3110:setPosition(AUTO_POS(19.50, 9.50))
		pLable3110:setColor(ccc4(255,132,0,125))
	end

	local pLable3120 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3120 then
		pLable3120:setTag(3120)
		pLable3120:setAnchorPoint(ANCHOR_CENTER)
		pLable3120:setPosition(AUTO_POS(19.50, 9.50))
		pLable3120:setColor(ccc4(255,132,0,125))
	end

	local pLable3130 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3130 then
		pLable3130:setTag(3130)
		pLable3130:setAnchorPoint(ANCHOR_CENTER)
		pLable3130:setPosition(AUTO_POS(19.50, 9.50))
		pLable3130:setColor(ccc4(255,132,0,125))
	end

	local pLable3140 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3140 then
		pLable3140:setTag(3140)
		pLable3140:setAnchorPoint(ANCHOR_CENTER)
		pLable3140:setPosition(AUTO_POS(19.50, 9.50))
		pLable3140:setColor(ccc4(255,132,0,125))
	end

	local pDragNode315 = SCDragNode:node()
	if pDragNode315 then
		pDragNode315:setTag(315)
		pDragNode315:setAnchorPoint(ANCHOR_CENTER)
		pDragNode315:setPosition(AUTO_POS(240.00, 120.00))
		pDragNode315:setContentSize(AUTO_SIZE(70, 30))
		pDragNode315:setFrameVisibled(true)
		pDragNode315:setDragEnabled(false)
		pDragNode315:setFrameType(EnumFrameTypeListNormal)
	end

	local pLable3150 = SCLabel:labelWithStringFont(L("str6094"), DEFAULT_FONT_NAME, F(12))
	if pLable3150 then
		pLable3150:setTag(3150)
		pLable3150:setAnchorPoint(ANCHOR_CENTER)
		pLable3150:setPosition(AUTO_POS(35.00, 15.00))
		pLable3150:setColor(ccc4(255,132,0,125))
	end

	if pImage1 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1, "SCNode"))
	end
	if pImage1001 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1001, "SCNode"))
	end
	if pImage1101 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1101, "SCNode"))
	end
	if pImage1102 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1102, "SCNode"))
	end
	if pImage1002 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1002, "SCNode"))
	end
	if pImage1003 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1003, "SCNode"))
	end
	if pImage1103 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1103, "SCNode"))
	end
	if pImage1004 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1004, "SCNode"))
	end
	if pImage1104 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1104, "SCNode"))
	end
	if pImage1005 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1005, "SCNode"))
	end
	if pImage1105 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1105, "SCNode"))
	end
	if pImage1007 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1007, "SCNode"))
	end
	if pImage1006 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1006, "SCNode"))
	end
	if pImage1106 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1106, "SCNode"))
	end
	if pImage1107 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1107, "SCNode"))
	end
	if pImage15 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage15, "SCNode"))
	end
	if pDragNode101 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode101, "SCNode"))
	end
	if pDragNode103 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode103, "SCNode"))
	end
	if pDragNode105 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode105, "SCNode"))
	end
	if pDragNode107 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode107, "SCNode"))
	end
	if pDragNode301 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode301, "SCNode"))
	end
	if pDragNode303 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode303, "SCNode"))
	end
	if pDragNode109 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode109, "SCNode"))
	end
	if pDragNode111 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode111, "SCNode"))
	end
	if pDragNode113 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode113, "SCNode"))
	end
	if pDragNode115 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode115, "SCNode"))
	end
	if pDragNode305 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode305, "SCNode"))
	end
	if pDragNode311 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode311, "SCNode"))
	end
	if pDragNode307 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode307, "SCNode"))
	end
	if pDragNode313 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode313, "SCNode"))
	end
	if pDragNode309 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode309, "SCNode"))
	end
	if pImage1201 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1201, "SCNode"))
	end
	if pDragNode102 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode102, "SCNode"))
	end
	if pImage1301 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1301, "SCNode"))
	end
	if pDragNode104 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode104, "SCNode"))
	end
	if pImage1202 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1202, "SCNode"))
	end
	if pImage1302 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1302, "SCNode"))
	end
	if pDragNode106 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode106, "SCNode"))
	end
	if pDragNode108 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode108, "SCNode"))
	end
	if pImage1203 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1203, "SCNode"))
	end
	if pImage1303 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1303, "SCNode"))
	end
	if pImage1204 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1204, "SCNode"))
	end
	if pImage1304 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1304, "SCNode"))
	end
	if pDragNode110 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode110, "SCNode"))
	end
	if pDragNode112 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode112, "SCNode"))
	end
	if pDragNode114 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode114, "SCNode"))
	end
	if pDragNode116 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode116, "SCNode"))
	end
	if pImage1205 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1205, "SCNode"))
	end
	if pImage1305 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1305, "SCNode"))
	end
	if pImage1206 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1206, "SCNode"))
	end
	if pImage1306 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1306, "SCNode"))
	end
	if pDragNode302 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode302, "SCNode"))
	end
	if pDragNode304 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode304, "SCNode"))
	end
	if pDragNode306 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode306, "SCNode"))
	end
	if pDragNode308 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode308, "SCNode"))
	end
	if pLable3 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pLable3, "SCNode"))
	end
	if pImage1207 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1207, "SCNode"))
	end
	if pImage1307 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1307, "SCNode"))
	end
	if pDragNode310 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode310, "SCNode"))
	end
	if pDragNode312 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode312, "SCNode"))
	end
	if pImage1208 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage1208, "SCNode"))
	end
	if pDragNode314 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode314, "SCNode"))
	end
	if pButton2 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pButton2, "SCNode"))
	end
	if pImage4 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage4, "SCNode"))
	end
	if pLable6 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pLable6, "SCNode"))
	end
	if pDragNode7 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode7, "SCNode"))
	end
	if pImage5 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pImage5, "SCNode"))
	end
	if pLable8 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pLable8, "SCNode"))
	end
	if pLable3010 and pDragNode301 then
		pDragNode301:addChild(tolua.cast(pLable3010, "SCNode"))
	end
	if pLable3020 and pDragNode302 then
		pDragNode302:addChild(tolua.cast(pLable3020, "SCNode"))
	end
	if pLable3030 and pDragNode303 then
		pDragNode303:addChild(tolua.cast(pLable3030, "SCNode"))
	end
	if pLable3040 and pDragNode304 then
		pDragNode304:addChild(tolua.cast(pLable3040, "SCNode"))
	end
	if pLable3050 and pDragNode305 then
		pDragNode305:addChild(tolua.cast(pLable3050, "SCNode"))
	end
	if pLable3060 and pDragNode306 then
		pDragNode306:addChild(tolua.cast(pLable3060, "SCNode"))
	end
	if pLable3070 and pDragNode307 then
		pDragNode307:addChild(tolua.cast(pLable3070, "SCNode"))
	end
	if pLable3080 and pDragNode308 then
		pDragNode308:addChild(tolua.cast(pLable3080, "SCNode"))
	end
	if pLable3090 and pDragNode309 then
		pDragNode309:addChild(tolua.cast(pLable3090, "SCNode"))
	end
	if pLable3100 and pDragNode310 then
		pDragNode310:addChild(tolua.cast(pLable3100, "SCNode"))
	end
	if pLable3110 and pDragNode311 then
		pDragNode311:addChild(tolua.cast(pLable3110, "SCNode"))
	end
	if pLable3120 and pDragNode312 then
		pDragNode312:addChild(tolua.cast(pLable3120, "SCNode"))
	end
	if pLable3130 and pDragNode313 then
		pDragNode313:addChild(tolua.cast(pLable3130, "SCNode"))
	end
	if pLable3140 and pDragNode314 then
		pDragNode314:addChild(tolua.cast(pLable3140, "SCNode"))
	end
	if pDragNode315 and pWindow4223 then
		pWindow4223:addChild(tolua.cast(pDragNode315, "SCNode"))
	end
	if pLable3150 and pDragNode315 then
		pDragNode315:addChild(tolua.cast(pLable3150, "SCNode"))
	end
	return pWindow4223
end
function armyGroupFight3.releaseControl()
	if armyGroupFight3.wndClose then
		armyGroupFight3.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
local function setTagToTable()
    if not m_fightMapTagTable then
        m_fightMapTagTable = {}
        m_fightMapTagTable[1] = {1001,1005,1007,15}
        m_fightMapTagTable[2] = {1201,1205,1207,1208}
        m_fightMapTagTable[3] = {1101,1005,1007,15}
        m_fightMapTagTable[4] = {1301,1205,1207,1208}
        m_fightMapTagTable[5] = {1002,1105,1007,15}
        m_fightMapTagTable[6] = {1202,1305,1207,1208}
        m_fightMapTagTable[7] = {1102,1105,1007,15}
        m_fightMapTagTable[8] = {1302,1305,1207,1208}
        m_fightMapTagTable[9] = {1003,1006,1107,15}
        m_fightMapTagTable[10] = {1203,1206,1307,1208}
        m_fightMapTagTable[11] = {1103,1006,1107,15}
        m_fightMapTagTable[12] = {1303,1206,1307,1208}
        m_fightMapTagTable[13] = {1004,1106,1107,15}
        m_fightMapTagTable[14] = {1204,1306,1307,1208}
        m_fightMapTagTable[15] = {1104,1106,1107,15}
        m_fightMapTagTable[16] = {1304,1306,1307,1208}
    end
end
local function setFightRelationChart(wnd)
    for i = 1101,1107 do
        local pImg = SCTypeCast:castNodeToImage(wnd:getChildByTag(i));
        if pImg then
            pImg:setFlipY(true)
        end
    end
    for i = 1201,1208 do
        local pImg = SCTypeCast:castNodeToImage(wnd:getChildByTag(i));
        if pImg then
            pImg:setFlipX(true)
        end
    end
    for i = 1301,1307 do
        local pImg = SCTypeCast:castNodeToImage(wnd:getChildByTag(i));
        if pImg then
            pImg:setTransform(SCTRANS_ROT180)
        end
    end
    
    local pImg = SCTypeCast:castNodeToImage(wnd:getChildByTag(5));
    if pImg then
        pImg:setScale(1.5)
    end
end

--进入战斗
local function onEnterToFightBtnClick()
    --armyGroupFight4_showArmyGroupFight4Wnd()
    local dt = SCDataTransStream:streamWithCommand(_MSG_SYNWAR);
    if dt then
        dt:writeShort(ACTION_TRIBEWAR_ENTER_MAP)
        --dt:writeInt(tag)-- //公会ID
        --dt:writeByte(m_ucWarPair)
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
    
end

--查看军团
local function checkArmyDetails(tag)
    if tag then
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_VIEW_SOCIATY_INFO2)--//查看公会信息
        dt:writeInt(tag)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_SOCIATY_MEMBER_LIST2)--//查看公会成员
        dt:writeInt(tag)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    
    end
end
--准备时间
local function readinessTimeClick()
    --showMessage(L("str3241"))
end
--投注申请
local function sentApplyForBetMsg(id)
    local dt = SCDataTransStream:streamWithCommand(_MSG_SYNWAR);
    if dt then
        dt:writeShort(ACTION_TRIBEWAR_BET)--//
        dt:writeInt(id)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

local function sentApplyForBet(tag)
    if tag and m_allArmyMsg then
        local tmpId = nil
        if tag > 20 then
            if 309 == tag then
                if m_allArmyMsg[1] then
                    if not m_allArmyMsg[3] or m_allArmyMsg[1].ucWinTimes > m_allArmyMsg[3].ucWinTimes then
                        tmpId = m_allArmyMsg[1].idTribe
                    else
                        tmpId = m_allArmyMsg[3].idTribe
                    end
                end
            elseif 310 == tag then
                if m_allArmyMsg[2] then
                    if not m_allArmyMsg[4] or m_allArmyMsg[2].ucWinTimes > m_allArmyMsg[4].ucWinTimes then
                        tmpId = m_allArmyMsg[2].idTribe
                    else
                        tmpId = m_allArmyMsg[4].idTribe
                    end
                end
            elseif 311 == tag then
                if m_allArmyMsg[9] then
                    if not m_allArmyMsg[11] or m_allArmyMsg[9].ucWinTimes > m_allArmyMsg[11].ucWinTimes then
                        tmpId = m_allArmyMsg[9].idTribe
                    else
                        tmpId = m_allArmyMsg[11].idTribe
                    end
                end
            elseif 312 == tag then
                if m_allArmyMsg[10] then
                    if not m_allArmyMsg[12] or m_allArmyMsg[10].ucWinTimes > m_allArmyMsg[12].ucWinTimes then
                        tmpId = m_allArmyMsg[10].idTribe
                    else
                        tmpId = m_allArmyMsg[12].idTribe
                    end
                end
            elseif 313 == tag or 314 == tag then
                local tID1 = nil
                local tID2 = nil
                local tID1 = nil
                local tID2 = nil
                for key, value in pairs(m_allArmyMsg) do
                    --if m_allArmyMsg[i] then
                        if value.ucWinTimes > 1 then
                            if 0 == key%2 then
                                tID2 = value.idTribe
                            else
                                tID1 = value.idTribe
                            end
                        end
                    --end
                end
                if 313 == tag then
                    tmpId = tID1
                elseif 314 == tag then
                    tmpId = tID2
                end
                
            elseif 315 == tag then
                 for key, value in pairs(m_allArmyMsg) do
                    if value then
                        if value.ucWinTimes > 2 then
                            tmpId = value.idTribe
                        end
                    end
                end
            end
            if tmpId then
                sentApplyForBetMsg(tmpId)
            else
                showMessage(L("str3237"))
            end
        else
            local tmpId = nil
            if m_allArmyMsg[tag] then
                tmpId = m_allArmyMsg[tag].idTribe
                if tmpId then
                    sentApplyForBetMsg(tmpId)
                    return
                end
            end
            showMessage(L("str3237"))
        end
    else
        showMessage(L("str3237"))
    end
end
--
--查看申请
local function sentCheckFightDetailsMsg(id,session)
    local dt = SCDataTransStream:streamWithCommand(_MSG_SYNWAR);
    if dt then
        dt:writeShort(ACTION_TRIBEWAR_WARINFO)--//
        dt:writeByte(session-1)
        dt:writeInt(id)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

local function sentCheckFightDetails(tag)
    if tag and m_allArmyMsg then
        local tmpId = nil
        local tmpSession = nil
        if tag > 20 then
            if 309 == tag then
                if m_allArmyMsg[1] then
                    if not m_allArmyMsg[3] or m_allArmyMsg[1].ucWinTimes > m_allArmyMsg[3].ucWinTimes then
                        tmpId = m_allArmyMsg[1].idTribe
                    else
                        tmpId = m_allArmyMsg[3].idTribe
                    end
                end
                tmpSession = 2
            elseif 310 == tag then
                if m_allArmyMsg[2] then
                    if not m_allArmyMsg[4] or m_allArmyMsg[2].ucWinTimes > m_allArmyMsg[4].ucWinTimes then
                        tmpId = m_allArmyMsg[2].idTribe
                    else
                        tmpId = m_allArmyMsg[4].idTribe
                    end
                end
                tmpSession = 2
            elseif 311 == tag then
                if m_allArmyMsg[9] then
                    if not m_allArmyMsg[11] or m_allArmyMsg[9].ucWinTimes > m_allArmyMsg[11].ucWinTimes then
                        tmpId = m_allArmyMsg[9].idTribe
                    else
                        tmpId = m_allArmyMsg[11].idTribe
                    end
                end
                tmpSession = 2
            elseif 312 == tag then
                if m_allArmyMsg[10] then
                    if not m_allArmyMsg[12] or m_allArmyMsg[10].ucWinTimes > m_allArmyMsg[12].ucWinTimes then
                        tmpId = m_allArmyMsg[10].idTribe
                    else
                        tmpId = m_allArmyMsg[12].idTribe
                    end
                end
                tmpSession = 2
            elseif 313 == tag or 314 == tag then
                local tID1 = nil
                local tID2 = nil
                for key, value in pairs(m_allArmyMsg) do
                    --if m_allArmyMsg[i] then
                        if value.ucWinTimes > 1 then
                            if 0 == key%2 then
                                tID2 = value.idTribe
                            else
                                tID1 = value.idTribe
                            end
                        end
                    --end
                end
                if 313 == tag then
                    tmpId = tID1
                elseif 314 == tag then
                    tmpId = tID2
                end
                tmpSession = 3
            elseif 315 == tag then
                for key, value in pairs(m_allArmyMsg) do
                    if value then
                        if value.ucWinTimes > 2 then
                            tmpId = value.idTribe
                        end
                    end
                    tmpSession = 4
                end
        end
        if tmpId then
            sentCheckFightDetailsMsg(tmpId,tmpSession)
        else
            showMessage(L("str3238"))
        end
    else
            local tmpId = nil
            if m_allArmyMsg[tag] then
                tmpId = m_allArmyMsg[tag].idTribe
                tmpSession = 1
                if tmpId then
                    sentCheckFightDetailsMsg(tmpId,tmpSession)
                    return
                end
            end

            showMessage(L("str3238"))
        end
    else
        showMessage(L("str3238"))
    end
end
--按钮设置
local function sentBtnState(wnd,tag,str,state,dt)
    if not wnd or not dt then
        return
    end
    local pDragNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(tag))
    if pDragNode then
        local nWidth = pDragNode:getContentSize().width
        local nHeight = pDragNode:getContentSize().height
        local pLabel = SCTypeCast:castNodeToLabel(pDragNode:getChildByTag(tag*10))
        if pLabel then
            pLabel:setText(str)
            pLabel:removeAllChildrenWithCleanup(true)
            local pBtn = SCButton:button();
            if pBtn then
                pBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
                pBtn:setPosition(CCPointMake(nWidth / 2, nHeight / 2));
                pBtn:setContentSize(CCSizeMake(nWidth, nHeight))
				if tag ~= 315 then
					pBtn:setTouchRectScale(1.5, 2)
				end
                if tag < 309 then
                    if 0 == tag%2 then
                        local pTag = tag - 300 + tag - 302
                        pBtn:setTag(pTag)
                    else
                        local pTag = tag - 300 + tag - 301
                        pBtn:setTag(pTag)
                    end
                else
                    pBtn:setTag(tag)
                end
                if 0 == state then
                    pBtn:luaSetSelectorOnClicked(sentApplyForBet);
                elseif 1 == state then
                    pBtn:luaSetSelectorOnClicked(sentCheckFightDetails);
                elseif 2 == state then
                    pBtn:luaSetSelectorOnClicked(readinessTimeClick);
                end
                pLabel:addChild(pBtn);
            end
        end
    end
end
--设置状态
local function sentArmyFightState(ucWarFlag,ucWarPair,wnd,dt)
    local pLabel = SCTypeCast:castNodeToLabel(wnd:getChildByTag(3))
    if not pLabel then
        return
    end
    local pTopLabel = SCTypeCast:castNodeToLabel(wnd:getChildByTag(6))
    if not pTopLabel then
        return
    end
    local pBtn = SCTypeCast:castNodeToButton(wnd:getChildByTag(2))
    if pBtn then
        pBtn:setTouchForce(true)
        pBtn:setButtonType(EnumBtnTypeAsh)
    end
    
    if 0 == ucWarPair then
        for i = 301,308 do
            local tmpStr = L("str3188")
            local state = 0
            sentBtnState(wnd,i,tmpStr,state,dt)
        end
        pLabel:setText(L("str3193"))
        pTopLabel:setText(L("str3273"))
    elseif 1 == ucWarPair then
        for i = 301,308 do
            local state = 1
            local tmpStr = L("str3191")
            sentBtnState(wnd,i,tmpStr,state,dt)
        end
        for i = 309,312 do
            local state = 0
            local tmpStr = L("str3188")
            sentBtnState(wnd,i,tmpStr,state,dt)
        end
        pLabel:setText(L("str3194"))
        pTopLabel:setText(L("str3272"))
    elseif 2 == ucWarPair then
        for i = 301,312 do
            local state = 1
            local tmpStr = L("str3191")
            sentBtnState(wnd,i,tmpStr,state,dt)
        end
        for i = 313,314 do
            local state = 0
            local tmpStr = L("str3188")
            sentBtnState(wnd,i,tmpStr,state,dt)
        end
        pLabel:setText(L("str3195"))
        pTopLabel:setText(L("str3271"))
    elseif 3 == ucWarPair then
        for i = 301,314 do
            local state = 1
            local tmpStr = L("str3191")
            sentBtnState(wnd,i,tmpStr,state,dt)
        end
        local state = 0
        local tmpStr = L("str3188")
        sentBtnState(wnd,315,tmpStr,state,dt)
        pLabel:setText(L("str3196"))
        pTopLabel:setText(L("str3270"))
    elseif 4 == ucWarPair then
        for i = 301,314 do
            local state = 1
            local tmpStr = L("str3191")
            sentBtnState(wnd,i,tmpStr,state,dt)
        end
        
        pLabel:setText(L("str3197"))
        
    end
    if 0 == ucWarFlag then
        for i = 301,314 do
            local state = 2
            local tmpStr = L("str6094")
            sentBtnState(wnd,i,tmpStr,state,dt)
        end
        pLabel:setText(L("str3192"))
		pTopLabel:setText(L("str3236"))
    elseif 1 == ucWarFlag then
        pBtn:setButtonType(EnumBtnType9Atlas)
        pBtn:setTouchForce(false)
        pBtn:luaSetSelectorOnClicked(onEnterToFightBtnClick);
        pLabel:setText(L("str3240"))
		pTopLabel:setText(L("str"..(3283-ucWarPair)))
    elseif 3 == ucWarFlag then
        for i = 301,314 do
            local state = 1
            local tmpStr = L("str3191")
            sentBtnState(wnd,i,tmpStr,state,dt)
        end
        local pLabel6 = SCTypeCast:castNodeToLabel(wnd:getChildByTag(6))
        if pLabel6 then
            pLabel6:setText(L("str3235"))
        end
        local pDragNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(315))
        if pDragNode then
            local tmpStr = m_firstArmyName
            local state = 1
            sentBtnState(wnd,315,tmpStr,state,dt)
            --pDragNode:setVisible(false)
        end
		pLabel:setText(L("str3276"))
        pTopLabel:setText(L("str3276"))
    elseif 4 == ucWarFlag then
        for i = 301,314 do
            local state = 1
            local tmpStr = L("str3191")
            sentBtnState(wnd,i,tmpStr,state,dt)
        end
        local pLabel6 = SCTypeCast:castNodeToLabel(wnd:getChildByTag(6))
        if pLabel6 then
            pLabel6:setText(L("str3235"))
        end
        local pDragNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(315))
        if pDragNode then
            local tmpStr = m_firstArmyName
            local state = 1
            sentBtnState(wnd,315,tmpStr,state,dt)
            --pDragNode:setVisible(false)
        end
		pLabel:setText(L("str3197"))
        pTopLabel:setText(L("str3277"))
    end
end
--显示对战信息
local function showArmyFightReport(dt)
    if not dt then
        return
    end 
    
    local wndCtrl = getCurentSceneWindowController(4223)
    if not wndCtrl then
        return
    end
    local wnd = wndCtrl:getWindow()
    if not wnd then
        return
    end
    local pDragNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(7))
    if pDragNode then
        if dt.dwLeaveTime and 3600 > dt.dwLeaveTime and 0 < dt.dwLeaveTime then
            local imgCountDownNode = pDragNode:getChildByTag(888)
            if imgCountDownNode then
                pDragNode:removeChildByTag(888,true)
            end
            imgCountDownNode = newImgCountDownNodeWithTime(dt.dwLeaveTime)
            if imgCountDownNode then
                imgCountDownNode:setAnchorPoint(CCPointMake(0.5, 0.5))
                imgCountDownNode:setPosition(CCPointMake(pDragNode:getContentSize().width/2, pDragNode:getContentSize().height/2))
                imgCountDownNode:setTag(888)
                pDragNode:addChild(imgCountDownNode)
            end
        end
    end

    for i = 1,dt.ucAmount do
        if dt.stPairFill[i] then
            local pTag = dt.stPairFill[i].ucIndex 
            if not pTag then
                return
            end
            if not m_allArmyMsg then
                m_allArmyMsg = {}
            end
            if not m_allArmyMsg[pTag] then
                m_allArmyMsg[pTag] = {}
            end
            m_allArmyMsg[pTag].idTribe = dt.stPairFill[i].idTribe
            m_allArmyMsg[pTag].ucWinTimes = dt.stPairFill[i].ucWinTimes
            pTag = pTag + 100 
            local pDragNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(pTag))
            if pDragNode then
                local nWidth = pDragNode:getContentSize().width
                local nHeight = pDragNode:getContentSize().height
                if dt.ucLastId == dt.stPairFill[i].idTribe then
                    local imgPath = getRealUIResourcePath("tribe/new00830.png")
                    if imgPath then
                        local pImage = SCImage:imageWithFile(imgPath:getData());
                        if pImage then
                            pImage:setAnchorPoint(CCPointMake(0.5, 0.5));
                            pImage:setPosition(CCPointMake(nWidth / 2, nHeight / 2));
                            pImage:setScaleX(1.1)
                            pDragNode:addChild(pImage);
                        end
                    end
                end
                if dt.stPairFill[i].szTribe then
                    local pLabel = SCLabel:labelWithStringFont(dt.stPairFill[i].szTribe, DEFAULT_FONT_NAME, F(10))
                    if pLabel then
                         pLabel:setAnchorPoint(CCPointMake(0.5, 0.5));
                         pLabel:setPosition(CCPointMake(nWidth / 2, nHeight / 2));
                         pDragNode:addChild(pLabel);
                    end
                    local pBtn = SCButton:button();
                    if pBtn then
                        pBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pBtn:setPosition(CCPointMake(nWidth / 2, nHeight / 2));
                        pBtn:setContentSize(CCSizeMake(nWidth, nHeight))
                        if dt.stPairFill[i].idTribe then
                            local pTag = dt.stPairFill[i].idTribe
                            pBtn:setTag(pTag)
                        end
                        pBtn:luaSetSelectorOnClicked(checkArmyDetails);
                        pDragNode:addChild(pBtn);
                    end
                end
            end
            
            for k = 1,dt.stPairFill[i].ucWinTimes do
                local tmpNum = dt.stPairFill[i].ucIndex
                local tagList = m_fightMapTagTable[tmpNum]
                local file = nil
                if 1 == k then
                    file = getRealUIResourcePath("tribe/new00817.png")
                elseif 2 == k then
                    file = getRealUIResourcePath("tribe/new00819.png")
                elseif 3 == k then
                    file = getRealUIResourcePath("tribe/new00821.png")
                elseif 4 == k then
                    file = getRealUIResourcePath("tribe/new00823.png")
                    --[[
                    local pLabel = SCTypeCast:castNodeToLabel(wnd:getChildByTag(8))
                    if pLabel then
                        if dt.stPairFill[i].szTribe then
                            local str = dt.stPairFill[i].szTribe
                            pLabel:setText(str)
                        end
                        local pBtn = SCButton:button();
                        if pBtn then
                            local nWidth = pLabel:getContentSize().width
                            local nHeight = pLabel:getContentSize().height
                            pBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
                            pBtn:setPosition(CCPointMake(nWidth / 2, nHeight / 2));
                            pBtn:setContentSize(CCSizeMake(nWidth, nHeight))
                            pBtn:luaSetSelectorOnClicked(sentCheckFightDetails);
                            pBtn:setTag(315)
                            pLabel:addChild(pBtn);
                        end
                    end
                    ]]
                    m_firstArmyName = dt.stPairFill[i].szTribe
                    
                end
                
                if tagList and tagList[k] then
                    local pImg = SCTypeCast:castNodeToImage(wnd:getChildByTag(tagList[k]));
                    if file and pImg then
                        pImg:setImage(file:getData())
                        if 1101 <= tagList[k] and 1107 >= tagList[k] then
                            pImg:setFlipY(true)
                        elseif 1201 <= tagList[k] and 1208 >= tagList[k] then
                            pImg:setFlipX(true)
                        elseif 1301 <= tagList[k] and 1307 >= tagList[k] then
                            pImg:setTransform(SCTRANS_ROT180)
                        end
                    end
                end
            end
            
            
        end
    end
    
    m_ucWarPair = dt.ucWarPair
    sentArmyFightState(dt.ucWarFlag,dt.ucWarPair,wnd,dt)
end
----------------消息处理区----------------
--准备地图查看战斗情报
function armyGroupFight3_sendLookReport()
    local dt = SCDataTransStream:streamWithCommand(_MSG_SYNWAR);
    if dt then
        dt:writeShort(ACTION_TRIBEWAR_WARVIEW)
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end
function armyGroupFight3_onCloseBtnClick()
    local dt = SCDataTransStream:streamWithCommand(_MSG_SYNWAR);
    if dt then
        dt:writeShort(ACTION_TRIBEWAR_CLOSE_WINDOW)
        SCDataTransThread:getSingleton():transData(dt);
        --SCActivityIndicator:getSingleton():show()
    end
end
local function recArmyGroupFightInfo(dt)
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    if not dt then
        return;
    end
    local action = dt:readShort();
    if action == ACTION_TRIBEWAR_PAIR_INFO then
        showArmyFightReport(stWarPairInfo.initWithStream(dt));
    elseif ACTION_TRIBEWAR_BET == action then
        armyGroupFight4_showArmyGroupFight4Wnd(stBetInfo.initWithStream(dt))
    elseif ACTION_TRIBEWAR_WARINFO == action then
        armyGroupFight1_showArmyGroupFight1Wnd(stTribeWarInfo.initWithStream(dt))
    end
end
----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(recArmyGroupFightInfo, _MSG_SYNWAR, 0, nil)
----------------全局函数区----------------
function armyGroupFight3_showArmyGroupFight3Wnd()
    local wndCtrl = getCurentSceneWindowController(4223)
    if wndCtrl then
        return
    end
    local wnd = armyGroupFight3.initControl()
    if wnd then
        wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
        end
        local pImg = SCTypeCast:castNodeToImage(wnd:getChildByTag(1));
        if pImg then
            local size = pImg:getContentSize();
            local nWidth = size.width;
            local nHeight = size.height;
            local pDragNode = SCNode:node()            --半透明标志
            if pDragNode then
                pDragNode:setTag(10)
                pDragNode:setAnchorPoint(ANCHOR_CENTER)
                pDragNode:setPosition(AUTO_POS(240.00, 160.00))
                pDragNode:setContentSize(size)
                pDragNode:setBackgroundColor(ccc4(0,0,0,150))
                pImg:addChild(pDragNode)
            end
        end
        
        setFightRelationChart(wnd)
        setTagToTable()
    end
end


function armyGroupFight3.wndClose()
    m_fightMapTagTable = nil
    m_allArmyMsg = nil
    m_ucWarPair = nil
    m_firstArmyName = nil
    armyGroupFight3_onCloseBtnClick()
end

--函数调用