local m_battlePar = {}  --出战伙伴
local m_restPar = {}    --休息伙伴
local m_hitTurn = nil  --攻击顺序

local TalentSkill = {}
local magicInfos = {}
local CurrentSkillsID = nil;
local mark = nil;

--发送换位消息
local function sendChangeFormation(idRole, pos)
    SCActivityIndicator:getSingleton():show()
    local USERINFO_FORMATION = 38  --布阵信息
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_FORMATION)
    dataStream:writeInt(idRole)
    dataStream:writeByte(pos)
    SCDataTransThread:getSingleton():transData(dataStream)
end

--查看前中后军技能信息
local function sendLookFSASkillInfo(type)
    local USERINFO_FIRST_SKILL = 84
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_FIRST_SKILL)
    dataStream:writeByte(type)
    SCDataTransThread:getSingleton():transData(dataStream)
end

--主角技能列表请求
local function sendLookSkillList()
    local USERINFO_CHICK_SKILL  = 85
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_CHICK_SKILL)
    SCDataTransThread:getSingleton():transData(dataStream)
end

--选择主角技能
local function sendChangeSkill(skillId)
    local USERINFO_REPLACE_SKILL  = 83
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_REPLACE_SKILL)
    if mark then
        dataStream:writeInt(magicInfos[mark].idMagic)
    else        
        dataStream:writeInt(magicInfos[1].idMagic)
    end
    SCDataTransThread:getSingleton():transData(dataStream)    
    getCurentSceneNavigationController():removeWindowControllerByTag(7006);
end

--获取布阵数据
local function getFormationInfo()
    local mapLayer = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer")
    if mapLayer then
        return mapLayer:getFormationInfo()
    end
    return nil
end

--计算攻击顺序
local function orderHitTurn(formationInfo)
    m_hitTurn = {}
    for i=1, 9 do
        if formationInfo.posInfo[i-1].nSpeed > 0 then
            m_hitTurn[i] = formationInfo.posInfo[i-1].nSpeed
        elseif formationInfo.posInfo[i-1].idRole > 1 then
            m_hitTurn[i] = 1
        else
            m_hitTurn[i] = 0
        end
    end
    local minInt = -2147483648
    local turn = -1
    for i=1, 9 do
        local max = minInt
        local maxPos = -1
        for j=1, 9 do
            if m_hitTurn[j]>0 and m_hitTurn[j]>max then
                max = m_hitTurn[j]
                maxPos = j
            end
        end
        if max ~= minInt then
            m_hitTurn[maxPos] = turn
            turn = turn - 1
        else
            break
        end
    end
end

--信息分类
local function sortRestPar(restPar)
	for i=1, #restPar do
		for j=i+1, #restPar do
			if restPar[i].usLevel < restPar[j].usLevel then
				local tmp = restPar[i]
				restPar[i] = restPar[j]
				restPar[j] = tmp
			end
		end
	end
end

local function classifyInfo()
    m_battlePar = {}
    m_restPar = {}
    local formationInfo = getFormationInfo()
    if not formationInfo then
        return false
    end
    local userInfo = Hero:getSingleton():getHeroInfo()
    if not userInfo then
        return false
    end
    local userIDFace = {}
    userIDFace.uID = userInfo.nID
    userIDFace.lookFace = userInfo.dwLookFace
    userIDFace.strName = userInfo.strName
    userIDFace.usLevel = userInfo.ucLevel
    userIDFace.nCanPushFlag = 2 --能摆放位置标记
    userIDFace.nFacePhoto = userInfo.nHeadImg
    table.insert(m_battlePar, userIDFace)
    
    local size = Hero:getSingleton():partnerSize()
    for i=1, size do
        local parInfo = Hero:getSingleton():getPartnerWithPos(i - 1)
        if parInfo then
            local tmp = {}
            tmp.uID = parInfo.nID
            tmp.lookFace = parInfo.dwLookFace
            tmp.strName = parInfo.strName:getData()
            tmp.usLevel = parInfo.usLevel
            tmp.nCanPushFlag = parInfo.ucAgrle
            tmp.nFacePhoto = parInfo.nFacePhoto
            local count = 0
            for j=1, 9 do
                if formationInfo.posInfo[j-1].idRole == parInfo.nID then
                    table.insert(m_battlePar, tmp)
                    break
                end
                count = count + 1
            end
            if count == 9 then
                table.insert(m_restPar, tmp)
            end
        end
    end
    orderHitTurn(formationInfo)
    sortRestPar(m_restPar)
    return true
end

--判断能否摆放
local function isCanPush(canPushFlag, FSAFlag)
    --前中后军可摆放标记
    local enableFlag = {false, false, false}
    --设置标记
    for i=1, 3 do
        if canPushFlag%10 ~= 0 then
            enableFlag[canPushFlag%10] = true
        end
        canPushFlag = getIntPart(canPushFlag/10)
    end
    
    return enableFlag[FSAFlag]
end

--显示可摆放位置
local function showCanPushPos(canPushFlag)
    local wnd = getCurentSceneWindow(5601)
    if not wnd then
        return
    end
    --前中后军可摆放标记
    local enableFlag = {false, false, false}
    --设置标记
    for i=1, 3 do
        if canPushFlag%10 ~= 0 then
            enableFlag[canPushFlag%10] = true
        end
        canPushFlag = getIntPart(canPushFlag/10)
    end
    for i=1, 3 do
        local imgNode = tolua.cast(wnd:getChildByTag(100+i*10), "SCImage")
        if imgNode then
			if not enableFlag[i] then
				local file = getRealUIResourcePath("img/img8021.png")
				if file then
					imgNode:setImage(file:getData())
				end
			else
				if i == 1 then
					local file = getRealUIResourcePath("img/img8024.png")
					if file then
						imgNode:setImage(file:getData())
					end
				elseif i == 2 then
					local file = getRealUIResourcePath("img/img8023.png")
					if file then
						imgNode:setImage(file:getData())
					end
				elseif i == 3 then
					local file = getRealUIResourcePath("img/img8022.png")
					if file then
						imgNode:setImage(file:getData())
					end
				end
			end
        end
    end
end

--获取空dragButton
--type = 1 左侧休息中的伙伴， = 2 右侧出战的伙伴
local function getNullDragBtn(type)
    local pBtn = DragButton:newDragButton()
    pBtn:setAnchorPoint(CCPointMake(0.5, 0.5))
    pBtn:setDragNodeIsVisible(false)

    if type == 1 then
        local file = getRealUIResourcePath("img/new00002.png")
        if  not file then
            return nil
        end
        pBtn:hsetBackgroundImage(file:getData())

        file = getRealUIResourcePath("img/new00003.png")
        if  not file then
            return nil
        end
        pBtn:hsetSelectedImage(file:getData())
    elseif type == 2 then
        --local file = getRealUIResourcePath("img/img8024.png")
        --if not file then
        --    return nil
        --end
        --pBtn:hsetTitle(file:getData())
        pBtn:setContentSize(CCSizeMake(SX(76), SY(44)))
    end
    return pBtn
end

---------------------
local showBattlePar        --声明显示出战伙伴函数
---------------------
--休息中的伙伴拖动回调
local function dragBeginLeft(tag)
    local wnd = getCurentSceneWindow(5601)
    if not wnd then
        return
    end
    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("4-"..(tag-1), wnd))
    if not dragNode then
        return
    end
    local pDragBtn = tolua.cast(dragNode:getChildByTag(tag), "DragButton")
    if not pDragBtn then
        return
    end

    --pDragBtn:setDragImg(nil)
    pDragBtn:setDragImgIsVisible(false)
    local pAni = LookfaceParser:getSingleton():getAnimationByLookFaceAndIndex(m_restPar[tag].lookFace)
    if pAni then
		pAni:setFrameAnchor(EnumFrameAnchorCenter)
        pAni:setTransMirror(true)
        local shadowFile = getRealUIResourcePath("img/img2547.png")
        local pAniNode = SCAnimationNode:nodeWithAnimation(pAni)
        if shadowFile then
			local shadowImg = SCImage:imageWithFile(shadowFile:getData())
			shadowImg:setAnchorPoint(CCPointMake(0.5, 0.5))
			setNodePostion(shadowImg, CCPointMake(getNodeContentSize(pAniNode).width/2, getNodeContentSize(shadowImg).height/2+50))
			pAniNode:addChild(shadowImg)
		end
        pDragBtn:setDragNode(pAniNode)
        pAniNode:setAnchorPoint(CCPointMake(0.5, 0.5))
        setNodePostion(pAniNode, CCPointMake(getNodeContentSize(dragNode).width/2, getNodeContentSize(dragNode).height/2+getNodeContentSize(pAniNode).height/2-60))
    end
    
    showCanPushPos(m_restPar[tag].nCanPushFlag)
end

local function dragEndLeft(tag, x, y)
    local wnd = getCurentSceneWindow(5601)
    if not wnd then
		pDragBtn:setDragImgIsVisible(true)
		pDragNode:removeChildByTag(-4, true)
		local file = getFaceImagePath(m_restPar[tag].nFacePhoto)
		if file then
			pDragBtn:setDragImg(file:getData())
		end
        return
    end
    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("4-"..(tag-1), wnd))
    if not dragNode then
		pDragBtn:setDragImgIsVisible(true)
		pDragNode:removeChildByTag(-4, true)
		local file = getFaceImagePath(m_restPar[tag].nFacePhoto)
		if file then
			pDragBtn:setDragImg(file:getData())
		end
        return
    end
    local pDragBtn = tolua.cast(dragNode:getChildByTag(tag), "DragButton")
    if not pDragBtn then
		pDragBtn:setDragImgIsVisible(true)
		pDragNode:removeChildByTag(-4, true)
		local file = getFaceImagePath(m_restPar[tag].nFacePhoto)
		if file then
			pDragBtn:setDragImg(file:getData())
		end
        return
    end
    local pDragNode = tolua.cast(pDragBtn:getChildByTag(tag), "SCDragNode")
    if not pDragNode then
		pDragBtn:setDragImgIsVisible(true)
		pDragNode:removeChildByTag(-4, true)
		local file = getFaceImagePath(m_restPar[tag].nFacePhoto)
		if file then
			pDragBtn:setDragImg(file:getData())
		end
        return
    end
    
    local formationInfo = getFormationInfo()
    if not formationInfo then
		pDragBtn:setDragImgIsVisible(true)
		pDragNode:removeChildByTag(-4, true)
		local file = getFaceImagePath(m_restPar[tag].nFacePhoto)
		if file then
			pDragBtn:setDragImg(file:getData())
		end
        return false
    end
    
    for i=1, 3 do
        local imgNode = tolua.cast(wnd:getChildByTag(100+i*10), "SCImage")
        if imgNode then
            for j=1, 3 do
                local node = tolua.cast(wnd:getChildByTag(100+i*10+j), "SCDragNode")
                local tpt = node:convertToNodeSpace(CCPointMake(x, y))
                if CCRect:CCRectContainsPoint(CCRectMake(0,0,node:getContentSize().width,node:getContentSize().height), tpt) then
                    if formationInfo.posInfo[(i-1)*3+j-1].idRole>=1 then
                        if isCanPush(m_restPar[tag].nCanPushFlag, i) then
                            if (i==1 and j==2) or i~=1 then
                                if formationInfo.nPlayer_num==0 and formationInfo.posInfo[(i-1)*3+j-1].idRole==1 then
                                    showMessage(_LTParser("str5097"), 3)
                                else
                                    sendChangeFormation(m_restPar[tag].uID, (i-1)*3+j)
									setRestartGuideFlag(GUIDE_TYPE_FORMAT_2, false)
									showGuideStep(GUIDE_TYPE_FORMAT_2, 4, 3)
                                end
                            end
                        end
                        pDragBtn:setDragImgIsVisible(true)
                        pDragNode:removeChildByTag(-4, true)
                        local file = getFaceImagePath(m_restPar[tag].nFacePhoto)
                        if file then
                            pDragBtn:setDragImg(file:getData())
                        end
                        showBattlePar(wnd, m_battlePar)
                        return
                    end
                end
            end
        end
    end
    pDragBtn:setDragImgIsVisible(true)
    pDragNode:removeChildByTag(-4, true)
    local file = getFaceImagePath(m_restPar[tag].nFacePhoto)
    if file then
        pDragBtn:setDragImg(file:getData())
    end
    showBattlePar(wnd, m_battlePar)
end

--显示左侧休息中的伙伴
local function showRestPar(wnd, restPars)
    --创建左侧按钮 并填充
    local listBox = SCTypeCast:castNodeToListBox(wnd:getChildByTag(4))
    if listBox then
		listBox:removeAllItems()
		for i=1, 8 do
			local dragNode = SCDragNode:node()
			dragNode:setContentSize(CCSizeMake(SX(42), SY(47)))
			local pDragBtn = getNullDragBtn(1)
			pDragBtn:setTag(i)
			pDragBtn:setPosition(CCPointMake(pDragBtn:getContentSize().width/2, pDragBtn:getContentSize().height/2+SY(5)))
			pDragBtn:luaSetSelectorOnDragBegin(dragBeginLeft)
			pDragBtn:luaSetSelectorOnDragEnd(dragEndLeft)
			pDragBtn:setDragNodeIsVisible(false)
            if restPars[i] then
                pDragBtn:setDragNodeIsVisible(true)
                local file = getFaceImagePath(restPars[i].nFacePhoto)
                if file then
                    pDragBtn:setDragImg(file:getData())
                end
            end
            dragNode:addChild(pDragBtn)
            listBox:addItem(dragNode)
		end
    end
end

--出战中的伙伴拖动回调
local function dragBeginRight(tag)
    local formationInfo = getFormationInfo()
    if not formationInfo then
        return false
    end
    local dragNode = tolua.cast(SCFunction:getUiNodeByIdlist("5601-"..tag), "DragButton")
    if dragNode then
		local file = getRealUIResourcePath("img/img8026.png")
		if file then
			local img = SCImage:imageWithFile(file:getData())
			img:setTag(10001)
			dragNode:addChild(img)
		end
    end
    local ps = (tag-100)%10+(getIntPart((tag-100)/10)-1)*3
    for k=1, #m_battlePar do
        if formationInfo.posInfo[ps-1].idRole == m_battlePar[k].uID then
            showCanPushPos(m_battlePar[k].nCanPushFlag)
        end
    end
end

local function dragEndRight(tag, x, y)
    local wnd = getCurentSceneWindow(5601)
    if not wnd then
        return
    end
    local imgNode = tolua.cast(wnd:getChildByTag(getIntPart(tag/10)*10), "SCImage")
    if not imgNode then
        return
    end
    local dragNode = tolua.cast(wnd:getChildByTag(tag), "SCDragNode")
    if not dragNode then
        return
    end
    local pDragBtn = tolua.cast(dragNode:getChildByTag(tag), "DragButton")
    if not pDragBtn then
        return
    end
    local formationInfo = getFormationInfo()
    if not formationInfo then
        return false
    end
    
    local pos = 0
    local ps = (tag-100)%10+(getIntPart((tag-100)/10)-1)*3
    for k=1, #m_battlePar do
        if formationInfo.posInfo[ps-1].idRole == m_battlePar[k].uID then
            pos = k
            break
        end
    end
    
    for i=1, 3 do
        local imgNode = tolua.cast(wnd:getChildByTag(100+i*10), "SCImage")
        if imgNode then
            for j=1, 3 do
                local node = tolua.cast(wnd:getChildByTag(100+i*10+j), "SCDragNode")
                local tpt = node:convertToNodeSpace(CCPointMake(x, y))
                if CCRect:CCRectContainsPoint(CCRectMake(0,0,node:getContentSize().width,node:getContentSize().height), tpt) then
                    if 100+i*10+j==tag then
                        showBattlePar(wnd, m_battlePar)
                        return
					elseif formationInfo.posInfo[(i-1)*3+j-1].idRole>=1 then
                        if isCanPush(m_battlePar[pos].nCanPushFlag, i) then
                            if (i==1 and j==2) or i~=1 then
                                sendChangeFormation(m_battlePar[pos].uID, (i-1)*3+j)
                            else
                                sendChangeFormation(m_battlePar[pos].uID, 0)
                            end
                        else
                            sendChangeFormation(m_battlePar[pos].uID, 0)
                        end
                        showBattlePar(wnd, m_battlePar)
                        return
                    end
                end
            end
        end
    end
    sendChangeFormation(m_battlePar[pos].uID, 0)
    showBattlePar(wnd, m_battlePar)
end

--显示右侧出战的伙伴
function showBattlePar(wnd, battlePars)
    local formationInfo = getFormationInfo()
    if not formationInfo then
        return false
    end
    --创建右侧按钮 并填充
    for i=1, 3 do
        local img = tolua.cast(wnd:getChildByTag(100+i*10), "SCImage")
        if img then
			local file = getRealUIResourcePath("img/img"..(8025-i)..".png")
			if file then
				img:setImage(file:getData())
			end
            --wnd:reorderChild(img, i)
            for j=1, 3 do
                local dragNode = tolua.cast(wnd:getChildByTag(100+i*10+j), "SCDragNode")
                if dragNode then
					wnd:reorderChild(dragNode, 100-i*10+j)
                    local pDragBtn = tolua.cast(dragNode:getChildByTag(100+i*10+j), "DragButton")
                    if not pDragBtn then
                        pDragBtn = getNullDragBtn(2)
                        pDragBtn:setTag(100+i*10+j)
                        --pDragBtn:setChildDragNodeTag((i-1)*3+j)
                        pDragBtn:luaSetSelectorOnDragBegin(dragBeginRight)
                        pDragBtn:luaSetSelectorOnDragEnd(dragEndRight)
                        setNodePostion(pDragBtn, CCPointMake(getNodeContentSize(dragNode).width/2, getNodeContentSize(dragNode).height/2))
                        dragNode:addChild(pDragBtn)
					else
						dragNode:removeChildByTag(10001, true)
                    end
                    pDragBtn:setDragNodeIsVisible(false)
                    if formationInfo.posInfo[(i-1)*3+j-1].idRole>1 then
                        local lookFace = nil
                        for k=1, #battlePars do
                            if battlePars[k].uID == formationInfo.posInfo[(i-1)*3+j-1].idRole then
                                lookFace = battlePars[k].lookFace
                                break
                            end
                        end
                        if lookFace then
                            pDragBtn:setDragNodeIsVisible(true)
                            local pAni = LookfaceParser:getSingleton():getAnimationByLookFaceAndIndex(lookFace)
                            if pAni then
								pAni:setFrameAnchor(EnumFrameAnchorCenter)
                                pAni:setTransMirror(true)
                                local pAniNode = SCAnimationNode:nodeWithAnimation(pAni)
                                local file = getRealUIResourcePath("img/img"..(5138+math.abs(m_hitTurn[(i-1)*3+j]))..".png")
                                local shadowFile = getRealUIResourcePath("img/img2547.png")
                                if file and shadowFile then
                                    local img = SCImage:imageWithFile(file:getData())
                                    img:setAnchorPoint(CCPointMake(0.5, 0.5))
                                    setNodePostion(img, CCPointMake(getNodeContentSize(pAniNode).width/2+20, getNodeContentSize(pAniNode).height-70))
                                    pAniNode:addChild(img)
                                    local shadowImg = SCImage:imageWithFile(shadowFile:getData())
                                    shadowImg:setAnchorPoint(CCPointMake(0.5, 0.5))
                                    setNodePostion(shadowImg, CCPointMake(getNodeContentSize(pAniNode).width/2, getNodeContentSize(shadowImg).height/2+50))
                                    pAniNode:addChild(shadowImg)
                                end
                                pDragBtn:setDragNode(pAniNode)
                                pAniNode:setAnchorPoint(CCPointMake(0.5, 0.5))
								setNodePostion(pAniNode, CCPointMake(getNodeContentSize(dragNode).width/2, getNodeContentSize(dragNode).height/2+getNodeContentSize(pAniNode).height/2-60))
                            end
                        end
                    end
                end
            end
        end
    end
end

--技能按钮点击
local function onSkillClicked(tag)
    if tag == 24 then
        sendLookSkillList()
        return
    end
    if tag == 21 then        
        luaShowTip(TalentSkill.szThird)
    end
    if tag == 22 then
        luaShowTip(TalentSkill.szSecond)
    end
    if tag == 23 then
        luaShowTip(TalentSkill.szFirst)
    end
    --sendLookFSASkillInfo(tag-20)
end

--关闭布阵界面
local function formationWndClose()
	m_battlePar = {}  --出战伙伴
	m_restPar = {}    --休息伙伴
	m_hitTurn = nil  --攻击顺序
	magicInfos = {}
end

--ctrl回调
local function ctrlEvent(tag, eventType)
    if eventType == LuaControllerEventPushEnded then
		if isGuideCanStart(GUIDE_TYPE_FORMAT_2) then
			setRestartGuideFlag(GUIDE_TYPE_FORMAT_2, true)
			showGuideStep(GUIDE_TYPE_FORMAT_2, 3, 2)
		elseif isGuideCanStart(GUIDE_TYPE_FORMAT_3) then
			setRestartGuideFlag(GUIDE_TYPE_FORMAT_3, true)
			showGuideStep(GUIDE_TYPE_FORMAT_3, 3, 2)
		end
    elseif eventType == LuaControllerEventPopBegan or eventType == LuaControllerEventRemoveBegan then
		if isGuideCanStart(GUIDE_TYPE_FORMAT_2) then
			if getRestartGuideFlag(GUIDE_TYPE_FORMAT_2) then
				restartBeginnerGuide(GUIDE_TYPE_FORMAT_2)
			else
				showGuideStep(GUIDE_TYPE_FORMAT_2, -1)
			end
		elseif isGuideCanStart(GUIDE_TYPE_FORMAT_3) then
			if getRestartGuideFlag(GUIDE_TYPE_FORMAT_3) then
				restartBeginnerGuide(GUIDE_TYPE_FORMAT_3)
			else
				showGuideStep(GUIDE_TYPE_FORMAT_3, -1)
			end
		end
    end
end

local function upDownClick(tag)
	local listBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("5601-4"))
	if not listBox then
		return
	end
	if tag == 5 then
		listBox:setOffset(CCPointMake(0, 0))
	elseif tag == 6 then
		listBox:setOffset(CCPointMake(0, listBox:getContentSize().height))
	end
end

--显示布阵界面
function showFormationWnd()
    if not classifyInfo() then
        return
    end
    local naviCtrl = getCurentSceneNavigationController()
    if not naviCtrl then
        return
    end
    local wnd = nil
    local wndCtrl = naviCtrl:getWindowControllerByTag(5601)
    if not wndCtrl then
        wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5601))
        local titlefile = getRealUIResourcePath("img/titile05.png")
        if titlefile then
            wnd:setTitleWithImage(titlefile:getData())
        end
        wnd:luaSetSelectorOnClose(formationWndClose);
		local listBox = SCTypeCast:castNodeToListBox(wnd:getChildByTag(4))
		if listBox then
			listBox:setScrollVertical(false)
		end
		local pBtn = SCTypeCast:castNodeToButton(wnd:getChildByTag(5))
		if pBtn then
			pBtn:luaSetSelectorOnClicked(upDownClick)
			pBtn:setTouchRectScale(1.1, 1.1)
		end
		local pBtn = SCTypeCast:castNodeToButton(wnd:getChildByTag(6))
		if pBtn then
			pBtn:luaSetSelectorOnClicked(upDownClick)
			pBtn:setTouchRectScale(1.1, 1.1)
		end
        wndCtrl = SCWindowController:controllerWithWindow(wnd)
        wndCtrl:luaSetSelectorOnEvent(ctrlEvent)
        naviCtrl:pushWindowController(wndCtrl)
        local dragNode = tolua.cast(wnd:getChildByTag(1), "SCDragNode")
        if dragNode then
            dragNode:setFrameType(EnumFrameTypeRound)
            dragNode:setFrameVisibled(true)
        end
        local dragNode = tolua.cast(wnd:getChildByTag(2), "SCDragNode")
        if dragNode then
            --dragNode:setFrameType(EnumFrameTypeRound)
            --dragNode:setFrameVisibled(true)
        end
        for i=21, 24 do
            local btn = tolua.cast(wnd:getChildByTag(i), "SCButton")
            if btn then
                btn:luaSetSelectorOnClicked(onSkillClicked)
            end
        end
    else
        wnd = wndCtrl:getWindow()
    end
    showRestPar(wnd, m_restPar)
    showBattlePar(wnd, m_battlePar)
end

--前中后军技能信息
local function recvFSASkill()
    local dt = LuaData:getSingleton():getDataTransStream()
    if not dt then
        return
    end
    local str = dt:readString()
    if str then
        TalentSkill.szFirst = str:getData()
    else
        TalentSkill.szFirst = ""
    end
    str = dt:readString()
    if str then
        TalentSkill.szSecond = str:getData()
    else
        TalentSkill.szSecond = ""
    end
    str = dt:readString()
    if str then
        TalentSkill.szThird = str:getData()
    else
        TalentSkill.szThird = ""
    end
    --luaShowTip(str:getData())
end

--listbox回调
local function joinInTeam(tag, itemTag, index)
    local node = tolua.cast(SCFunction:getUiNodeByIdlist("7006-2-8-"..itemTag), "SCDragNode");
    if node then
        node:setFrameType(EnumFrameTypeListSelect)
        node:setFrameVisibled(true)
        CurrentSkillsID = itemTag
        local text = tolua.cast(SCFunction:getUiNodeByIdlist("7006-2-1"), "SCTextBox");
        if text then
            for i = 1, #magicInfos do
                if magicInfos[i].idMagic == itemTag then
                    text:setText(magicInfos[i].szDescribe);
                    break;
                end
            end
        end
        if index == 0 then
            setRestartGuideFlag(GUIDE_TYPE_FORMAT_3, false)
			showGuideStep(GUIDE_TYPE_FORMAT_3, 5, 4)
        end
    end
end

local function unSelset(tag, itemTag, index)
    local node = tolua.cast(SCFunction:getUiNodeByIdlist("7006-2-8-"..itemTag), "SCDragNode");   
    if node then
        node:setFrameType(EnumFrameTypeListNormal)
        node:setFrameVisibled(true)
    end
end

--ctrl回调
local function ctrlEvent1(tag, eventType)
    if eventType == LuaControllerEventPushEnded then
		setRestartGuideFlag(GUIDE_TYPE_FORMAT_3, true)
		showGuideStep(GUIDE_TYPE_FORMAT_3, 4, 3)
    elseif eventType == LuaControllerEventPopBegan or eventType == LuaControllerEventRemoveBegan then
		if getRestartGuideFlag(GUIDE_TYPE_FORMAT_3) then
			setRestartGuideFlag(GUIDE_TYPE_FORMAT_3, true)
			showGuideStep(GUIDE_TYPE_FORMAT_3, 3, 2)
		else
			setRestartGuideFlag(GUIDE_TYPE_FORMAT_3, false)
			showGuideStep(GUIDE_TYPE_FORMAT_3, 6, 5)
		end
    end
end

local function onTitleId(tag)
    if mark == tag then 
        return;
    end
            local pPageScrollBox = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlist("7006-100-3"));
            if pPageScrollBox then
                if nil ~= mark then
                    local index = getIntPart(mark / 3) + 1;
                    if mark % 3 == 0 then
                        index = index - 1;
                    end
                    local pNode = pPageScrollBox:getChildByTag(index);
                    if pNode then
                        local dragnode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(mark));
                        if dragnode then
                            dragnode:setFrameType(EnumFrameTypeListNormal);
                        end
                    end
                end
                local index = getIntPart(tag / 3) + 1;
                if tag % 3 == 0 then
                    index = index - 1;
                end
                local pNode = pPageScrollBox:getChildByTag(index);
                if pNode then
                    local dragnode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(tag));
                    if dragnode then
                        dragnode:setFrameType(EnumFrameTypeListSelect);
                    end
                    mark = tag;
                end
            end
		setRestartGuideFlag(GUIDE_TYPE_FORMAT_3, false)
		showGuideStep(GUIDE_TYPE_FORMAT_3, 5, 4)
end

--主角技能选择窗口
local function showChooseSkillWnd(magicInfos)
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7006));
    if wnd == nil then
        return nil 
    end
    local imgPath = getRealUIResourcePath("img/titile62.png")
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    --wnd:luaSetSelectorOnClose();
    -- create a test window controller
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wndCtrl:luaSetSelectorOnEvent(ctrlEvent1)
    wnd:setBackgroundColor(colorWindowRedBG());
    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("100", tolua.cast(wnd, "SCNode")));
    if dragNode then
        dragNode:setFrameType(EnumFrameTypeRound)
        dragNode:setFrameVisibled(true)
    end
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl);          
    end     
    local btn = SCTypeCast:castNodeToButton(dragNode:getChildByTag(1));
    if btn then
        btn:luaSetSelectorOnClicked(sendChangeSkill);
    end
    local pPageScrollBox = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("100-3", tolua.cast(wnd, "SCNode")));
    if pPageScrollBox then
                pPageScrollBox:removeAllChildrenWithCleanup(true);
                pPageScrollBox:setPageSize(CCSizeMake(290 * gUIScale().x, 145 * gUIScale().y));
                local count = getIntPart(#magicInfos / 3) + 1;
                local remainder = #magicInfos % 3;
                if remainder == 0 then
                    count = count - 1;
                end
                for i = 1, count do
                    local pDrag = SCDragNode:node();
                    if pDrag then
                        local pNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(7006, 104));
                        if pNode then
                            pNode:setFrameType(EnumFrameTypeListNormal);
                            pNode:setFrameVisibled(true);
                            pNode:setPosition(CCPointMake(3, 0));
                            local pImg = SCTypeCast:castNodeToImage(pNode:getChildByTag(1));
                            if pImg then
                                local imgPath = getRealUIResourcePath("Skill/" .. magicInfos[(i - 1) * 3 + 1].dwPhoto .. ".png");
                                if imgPath then
                                    local imgNode = SCImage:imageWithFile(imgPath:getData());
                                    if imgNode then
                                        imgNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                        imgNode:setPosition(CCPointMake(pImg:getContentSize().width / 2, pImg:getContentSize().height / 2));
                                        pImg:addChild(imgNode);
                                    end
                                end
                            end
                            local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
                            if pLabel then
                                pLabel:setText("- " .. magicInfos[(i - 1) * 3 + 1].szName .. " -");           
                                pLabel:setColor(colorYellow());
                            end
                            local btn = SCButton:button();
                            if btn then
                                btn:setTag((i - 1) * 3 + 1);
                                btn:luaSetSelectorOnClicked(onTitleId);
                                btn:setContentSize(pNode:getContentSize());
                                pNode:addChild(btn);
                            end
                            local strbuf = getNewLinStr(magicInfos[(i - 1) * 3 + 1].szDescribe, 8);
                            local pParsedNode = getItemTextNode(strbuf, 0, 10);
                            if pParsedNode then
                                pParsedNode:setAnchorPoint(CCPointMake(0.5, 1));
                                pParsedNode:setPosition(CCPointMake(pNode:getContentSize().width / 2, 60 * gUIScale().y));
                                pNode:addChild(pParsedNode);
                            end
                            pNode:setTag((i - 1) * 3 + 1);
                            pDrag:addChild(pNode);
                        end
                        if remainder > 1 or count ~= i or remainder == 0 then
                            pNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(7006, 104));
                            if pNode then
                                pNode:setFrameType(EnumFrameTypeListNormal);
                                pNode:setFrameVisibled(true);
                                pNode:setPosition(CCPointMake(100 * gUIScale().x, 0));
                                local pImg = SCTypeCast:castNodeToImage(pNode:getChildByTag(1));
                                if pImg then
                                    local imgPath = getRealUIResourcePath("Skill/" .. magicInfos[(i - 1) * 3 + 2].dwPhoto .. ".png");
                                    if imgPath then
                                        local imgNode = SCImage:imageWithFile(imgPath:getData());
                                        if imgNode then
                                            imgNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                            imgNode:setPosition(CCPointMake(pImg:getContentSize().width / 2, pImg:getContentSize().height / 2));
                                            pImg:addChild(imgNode);
                                        end
                                    end
                                end
                                local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
                                if pLabel then
                                    pLabel:setText("- " .. magicInfos[(i - 1) * 3 + 2].szName .. " -");                                               
                                    pLabel:setColor(colorYellow());
                                end
                                local btn = SCButton:button();
                                if btn then
                                    btn:setTag((i - 1) * 3 + 2);
                                    btn:luaSetSelectorOnClicked(onTitleId);
                                    btn:setContentSize(pNode:getContentSize());
                                    pNode:addChild(btn);
                                end
                                local strbuf = getNewLinStr(magicInfos[(i - 1) * 3 + 2].szDescribe, 8);
                                local pParsedNode = getItemTextNode(strbuf, 0, 10);
                                if pParsedNode then
                                    pParsedNode:setAnchorPoint(CCPointMake(0.5, 1));
                                    pParsedNode:setPosition(CCPointMake(pNode:getContentSize().width / 2, 60 * gUIScale().y));
                                    pNode:addChild(pParsedNode);
                                end
                                pNode:setTag((i - 1) * 3 + 2);
                                pDrag:addChild(pNode);
                            end
                        end
                        
                        if remainder > 2 or count ~= i or remainder == 0 then
                            pNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(7006, 104));
                            if pNode then
                                pNode:setFrameType(EnumFrameTypeListNormal);
                                pNode:setFrameVisibled(true);
                                pNode:setPosition(CCPointMake(197 * gUIScale().x, 0));
                                local pImg = SCTypeCast:castNodeToImage(pNode:getChildByTag(1));
                                if pImg then
                                    local imgPath = getRealUIResourcePath("Skill/" .. magicInfos[(i - 1) * 3 + 3].dwPhoto .. ".png");
                                    if imgPath then
                                        local imgNode = SCImage:imageWithFile(imgPath:getData());
                                        if imgNode then
                                            imgNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                            imgNode:setPosition(CCPointMake(pImg:getContentSize().width / 2, pImg:getContentSize().height / 2));
                                            pImg:addChild(imgNode);
                                        end
                                    end
                                end
                                local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
                                if pLabel then
                                    pLabel:setText("- " .. magicInfos[(i - 1) * 3 + 3].szName .. " -");           
                                    pLabel:setColor(colorYellow());
                                end
                                local btn = SCButton:button();
                                if btn then
                                    btn:setTag((i - 1) * 3 + 3);
                                    btn:luaSetSelectorOnClicked(onTitleId);
                                    btn:setContentSize(pNode:getContentSize());
                                    pNode:addChild(btn);
                                end
                                local strbuf = getNewLinStr(magicInfos[(i - 1) * 3 + 3].szDescribe, 8);
                                local pParsedNode = getItemTextNode(strbuf, 0, 10);
                                if pParsedNode then
                                    pParsedNode:setAnchorPoint(CCPointMake(0.5, 1));
                                    pParsedNode:setPosition(CCPointMake(pNode:getContentSize().width / 2, 60 * gUIScale().y));
                                    pNode:addChild(pParsedNode);
                                end
                                pNode:setTag((i - 1) * 3 + 3);
                                pDrag:addChild(pNode);
                            end
                        end
                        pDrag:setTag(i);
                        pDrag:setPosition(CCPointMake(290 * (i - 1) * gUIScale().x, 0));
                        pPageScrollBox:addChild(pDrag);
                    end
                end
                pPageScrollBox:setContentSize(CCSizeMake(290 * count * gUIScale().x, 145 * gUIScale().y));
            end
            for i = 1, #magicInfos do
                if magicInfos[i].idMagic == CurrentSkillsID then
                    mark = nil;
                    onTitleId(i);
                end
            end
end

--主角技能切换
local function recvALLSkill()
    local dt = LuaData:getSingleton():getDataTransStream()
    if not dt then
        return
    end
    local amount = dt:readByte()
    magicInfos = {}
    for i=1, amount do
        local tmp = {}
        tmp.idMagic = dt:readInt()
        tmp.dwPhoto = dt:readInt()
        local str = dt:readString()
        if str then
            tmp.szName = str:getData()
        else
            tmp.szName = ""
        end
        str = dt:readString()
        if str then
            tmp.szDescribe = str:getData()
        else
            tmp.szDescribe = ""
        end
        table.insert(magicInfos, tmp)
    end
    showChooseSkillWnd(magicInfos)
end

local function recvReplaceSkill()
    local dt = LuaData:getSingleton():getDataTransStream()
    if not dt then
        return
    end
    local tmp = {};
    tmp.idMagicType = dt:readInt();
    tmp.dwPhoto = dt:readInt();
    CurrentSkillsID = tmp.idMagicType;
    local str = dt:readString();
    if str then
        tmp.szName = str:getData();
    else
        tmp.szName = "";
    end
    str = dt:readString();
    if str then
        tmp.szDescribe = str:getData();
    else
        tmp.szDescribe = "";
    end
end

LuaData:getSingleton():luaSetSelectorOnRecvData(recvALLSkill, LuaData_USERINFO_ALL_SKILL)
LuaData:getSingleton():luaSetSelectorOnRecvData(recvReplaceSkill, LuaData_USERINFO_FIRST_SKILL)
LuaData:getSingleton():luaSetSelectorOnRecvData(recvFSASkill, LuaData_USERINFO_REPLACE_SKILL)