

local function onDragNodeEndDrag(tag, x, y)
   CCMessageBox('hello drag')
end

local function onDragNodeBeginDrag(tag)
    CCLuaLog('onDragNodeBeginDrag')
end


local function createImage()
    local imgPath = getRealUIResourcePath('img/BtnFriendViewNormal.png')
    local image = SCImage:imageWithFile(imgPath:getData())
    return image
end

local function addDragNode(wnd)
    local node = SCDragNode:node()
    node:setContentSize(CCSizeMake(20, 20))
    node:setPosition(CCPointMake(100, 100))
    node:setDragEnabled(true)
    wnd:addChild(node)
    
    node:luaSetSelectorOnDragBegin(onDragNodeBeginDrag)
    node:luaSetSelectorOnDragEnd(onDragNodeEndDrag) 
    
    local image = createImage()
    image:setAnchorPoint(CCPointMake(0.5, 0.5))
    image:setPosition(CCPointMake(10, 10))
    node:addChild(image)
end

local function onControllerEvent(tag, event)
    if event == LuaControllerEventPushEnded then 
        CCLuaLog('onControllerEvent:LuaControllerEventPushEnded')
    end        
end

local function onMessageBoxClose()
    CCMessageBox('hello messagebox')
end

function testWndCtrl()
    -- create a test window controller
	local wnd = SCWindow:window()
	local wndCtrl = SCWindowController:controllerWithWindow(wnd)
	wndCtrl:setTag(1000);
	wndCtrl:luaSetSelectorOnEvent(onControllerEvent);
	wnd:setContentSize(CCSizeMake(200, 200));
	
	local messageBox = SCMessageBox:boxWithContent("hello drag");
	messageBox:luasetSelectorOnClose(onMessageBoxClose);
	
	--get running scene
	local scene = SCBaseScene:getRunningScene()
	local naviCtrl =  scene:getNavigationController()
	scene:getUINode():addChild(tolua.cast(messageBox, "SCNode"), 1000)
	--push the controller
	naviCtrl:pushWindowController(wndCtrl)
	
	--add controls
	--addDragNode(wnd)
end



    











